"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/utils.js
var require_utils = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/utils.js"(exports2) {
    "use strict";
    exports2.removeLeadingAndTrailingHTTPWhitespace = (string3) => {
      return string3.replace(/^[ \t\n\r]+/u, "").replace(/[ \t\n\r]+$/u, "");
    };
    exports2.removeTrailingHTTPWhitespace = (string3) => {
      return string3.replace(/[ \t\n\r]+$/u, "");
    };
    exports2.isHTTPWhitespaceChar = (char) => {
      return char === " " || char === "	" || char === "\n" || char === "\r";
    };
    exports2.solelyContainsHTTPTokenCodePoints = (string3) => {
      return /^[-!#$%&'*+.^_`|~A-Za-z0-9]*$/u.test(string3);
    };
    exports2.soleyContainsHTTPQuotedStringTokenCodePoints = (string3) => {
      return /^[\t\u0020-\u007E\u0080-\u00FF]*$/u.test(string3);
    };
    exports2.asciiLowercase = (string3) => {
      return string3.replace(/[A-Z]/ug, (l) => l.toLowerCase());
    };
    exports2.collectAnHTTPQuotedString = (input, position) => {
      let value = "";
      position++;
      while (true) {
        while (position < input.length && input[position] !== '"' && input[position] !== "\\") {
          value += input[position];
          ++position;
        }
        if (position >= input.length) {
          break;
        }
        const quoteOrBackslash = input[position];
        ++position;
        if (quoteOrBackslash === "\\") {
          if (position >= input.length) {
            value += "\\";
            break;
          }
          value += input[position];
          ++position;
        } else {
          break;
        }
      }
      return [value, position];
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type-parameters.js
var require_mime_type_parameters = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type-parameters.js"(exports2, module2) {
    "use strict";
    var {
      asciiLowercase,
      solelyContainsHTTPTokenCodePoints,
      soleyContainsHTTPQuotedStringTokenCodePoints
    } = require_utils();
    module2.exports = class MIMETypeParameters {
      constructor(map2) {
        this._map = map2;
      }
      get size() {
        return this._map.size;
      }
      get(name) {
        name = asciiLowercase(String(name));
        return this._map.get(name);
      }
      has(name) {
        name = asciiLowercase(String(name));
        return this._map.has(name);
      }
      set(name, value) {
        name = asciiLowercase(String(name));
        value = String(value);
        if (!solelyContainsHTTPTokenCodePoints(name)) {
          throw new Error(`Invalid MIME type parameter name "${name}": only HTTP token code points are valid.`);
        }
        if (!soleyContainsHTTPQuotedStringTokenCodePoints(value)) {
          throw new Error(`Invalid MIME type parameter value "${value}": only HTTP quoted-string token code points are valid.`);
        }
        return this._map.set(name, value);
      }
      clear() {
        this._map.clear();
      }
      delete(name) {
        name = asciiLowercase(String(name));
        return this._map.delete(name);
      }
      forEach(callbackFn, thisArg) {
        this._map.forEach(callbackFn, thisArg);
      }
      keys() {
        return this._map.keys();
      }
      values() {
        return this._map.values();
      }
      entries() {
        return this._map.entries();
      }
      [Symbol.iterator]() {
        return this._map[Symbol.iterator]();
      }
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/parser.js
var require_parser = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/parser.js"(exports2, module2) {
    "use strict";
    var {
      removeLeadingAndTrailingHTTPWhitespace,
      removeTrailingHTTPWhitespace,
      isHTTPWhitespaceChar,
      solelyContainsHTTPTokenCodePoints,
      soleyContainsHTTPQuotedStringTokenCodePoints,
      asciiLowercase,
      collectAnHTTPQuotedString
    } = require_utils();
    module2.exports = (input) => {
      input = removeLeadingAndTrailingHTTPWhitespace(input);
      let position = 0;
      let type2 = "";
      while (position < input.length && input[position] !== "/") {
        type2 += input[position];
        ++position;
      }
      if (type2.length === 0 || !solelyContainsHTTPTokenCodePoints(type2)) {
        return null;
      }
      if (position >= input.length) {
        return null;
      }
      ++position;
      let subtype = "";
      while (position < input.length && input[position] !== ";") {
        subtype += input[position];
        ++position;
      }
      subtype = removeTrailingHTTPWhitespace(subtype);
      if (subtype.length === 0 || !solelyContainsHTTPTokenCodePoints(subtype)) {
        return null;
      }
      const mimeType = {
        type: asciiLowercase(type2),
        subtype: asciiLowercase(subtype),
        parameters: /* @__PURE__ */ new Map()
      };
      while (position < input.length) {
        ++position;
        while (isHTTPWhitespaceChar(input[position])) {
          ++position;
        }
        let parameterName = "";
        while (position < input.length && input[position] !== ";" && input[position] !== "=") {
          parameterName += input[position];
          ++position;
        }
        parameterName = asciiLowercase(parameterName);
        if (position < input.length) {
          if (input[position] === ";") {
            continue;
          }
          ++position;
        }
        let parameterValue = null;
        if (input[position] === '"') {
          [parameterValue, position] = collectAnHTTPQuotedString(input, position);
          while (position < input.length && input[position] !== ";") {
            ++position;
          }
        } else {
          parameterValue = "";
          while (position < input.length && input[position] !== ";") {
            parameterValue += input[position];
            ++position;
          }
          parameterValue = removeTrailingHTTPWhitespace(parameterValue);
          if (parameterValue === "") {
            continue;
          }
        }
        if (parameterName.length > 0 && solelyContainsHTTPTokenCodePoints(parameterName) && soleyContainsHTTPQuotedStringTokenCodePoints(parameterValue) && !mimeType.parameters.has(parameterName)) {
          mimeType.parameters.set(parameterName, parameterValue);
        }
      }
      return mimeType;
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/serializer.js
var require_serializer = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/serializer.js"(exports2, module2) {
    "use strict";
    var { solelyContainsHTTPTokenCodePoints } = require_utils();
    module2.exports = (mimeType) => {
      let serialization = `${mimeType.type}/${mimeType.subtype}`;
      if (mimeType.parameters.size === 0) {
        return serialization;
      }
      for (let [name, value] of mimeType.parameters) {
        serialization += ";";
        serialization += name;
        serialization += "=";
        if (!solelyContainsHTTPTokenCodePoints(value) || value.length === 0) {
          value = value.replace(/(["\\])/ug, "\\$1");
          value = `"${value}"`;
        }
        serialization += value;
      }
      return serialization;
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type.js
var require_mime_type = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type.js"(exports2, module2) {
    "use strict";
    var MIMETypeParameters = require_mime_type_parameters();
    var parse2 = require_parser();
    var serialize = require_serializer();
    var {
      asciiLowercase,
      solelyContainsHTTPTokenCodePoints
    } = require_utils();
    module2.exports = class MIMEType {
      constructor(string3) {
        string3 = String(string3);
        const result = parse2(string3);
        if (result === null) {
          throw new Error(`Could not parse MIME type string "${string3}"`);
        }
        this._type = result.type;
        this._subtype = result.subtype;
        this._parameters = new MIMETypeParameters(result.parameters);
      }
      static parse(string3) {
        try {
          return new this(string3);
        } catch (e) {
          return null;
        }
      }
      get essence() {
        return `${this.type}/${this.subtype}`;
      }
      get type() {
        return this._type;
      }
      set type(value) {
        value = asciiLowercase(String(value));
        if (value.length === 0) {
          throw new Error("Invalid type: must be a non-empty string");
        }
        if (!solelyContainsHTTPTokenCodePoints(value)) {
          throw new Error(`Invalid type ${value}: must contain only HTTP token code points`);
        }
        this._type = value;
      }
      get subtype() {
        return this._subtype;
      }
      set subtype(value) {
        value = asciiLowercase(String(value));
        if (value.length === 0) {
          throw new Error("Invalid subtype: must be a non-empty string");
        }
        if (!solelyContainsHTTPTokenCodePoints(value)) {
          throw new Error(`Invalid subtype ${value}: must contain only HTTP token code points`);
        }
        this._subtype = value;
      }
      get parameters() {
        return this._parameters;
      }
      toString() {
        return serialize(this);
      }
      isJavaScript({ prohibitParameters = false } = {}) {
        switch (this._type) {
          case "text": {
            switch (this._subtype) {
              case "ecmascript":
              case "javascript":
              case "javascript1.0":
              case "javascript1.1":
              case "javascript1.2":
              case "javascript1.3":
              case "javascript1.4":
              case "javascript1.5":
              case "jscript":
              case "livescript":
              case "x-ecmascript":
              case "x-javascript": {
                return !prohibitParameters || this._parameters.size === 0;
              }
              default: {
                return false;
              }
            }
          }
          case "application": {
            switch (this._subtype) {
              case "ecmascript":
              case "javascript":
              case "x-ecmascript":
              case "x-javascript": {
                return !prohibitParameters || this._parameters.size === 0;
              }
              default: {
                return false;
              }
            }
          }
          default: {
            return false;
          }
        }
      }
      isXML() {
        return this._subtype === "xml" && (this._type === "text" || this._type === "application") || this._subtype.endsWith("+xml");
      }
      isHTML() {
        return this._subtype === "html" && this._type === "text";
      }
    };
  }
});

// ../../../node_modules/.pnpm/object-hash@3.0.0/node_modules/object-hash/index.js
var require_object_hash = __commonJS({
  "../../../node_modules/.pnpm/object-hash@3.0.0/node_modules/object-hash/index.js"(exports2, module2) {
    "use strict";
    var crypto2 = require("crypto");
    exports2 = module2.exports = objectHash;
    function objectHash(object3, options) {
      options = applyDefaults(object3, options);
      return hash2(object3, options);
    }
    exports2.sha1 = function(object3) {
      return objectHash(object3);
    };
    exports2.keys = function(object3) {
      return objectHash(object3, { excludeValues: true, algorithm: "sha1", encoding: "hex" });
    };
    exports2.MD5 = function(object3) {
      return objectHash(object3, { algorithm: "md5", encoding: "hex" });
    };
    exports2.keysMD5 = function(object3) {
      return objectHash(object3, { algorithm: "md5", encoding: "hex", excludeValues: true });
    };
    var hashes = crypto2.getHashes ? crypto2.getHashes().slice() : ["sha1", "md5"];
    hashes.push("passthrough");
    var encodings = ["buffer", "hex", "binary", "base64"];
    function applyDefaults(object3, sourceOptions) {
      sourceOptions = sourceOptions || {};
      var options = {};
      options.algorithm = sourceOptions.algorithm || "sha1";
      options.encoding = sourceOptions.encoding || "hex";
      options.excludeValues = sourceOptions.excludeValues ? true : false;
      options.algorithm = options.algorithm.toLowerCase();
      options.encoding = options.encoding.toLowerCase();
      options.ignoreUnknown = sourceOptions.ignoreUnknown !== true ? false : true;
      options.respectType = sourceOptions.respectType === false ? false : true;
      options.respectFunctionNames = sourceOptions.respectFunctionNames === false ? false : true;
      options.respectFunctionProperties = sourceOptions.respectFunctionProperties === false ? false : true;
      options.unorderedArrays = sourceOptions.unorderedArrays !== true ? false : true;
      options.unorderedSets = sourceOptions.unorderedSets === false ? false : true;
      options.unorderedObjects = sourceOptions.unorderedObjects === false ? false : true;
      options.replacer = sourceOptions.replacer || void 0;
      options.excludeKeys = sourceOptions.excludeKeys || void 0;
      if (typeof object3 === "undefined") {
        throw new Error("Object argument required.");
      }
      for (var i = 0; i < hashes.length; ++i) {
        if (hashes[i].toLowerCase() === options.algorithm.toLowerCase()) {
          options.algorithm = hashes[i];
        }
      }
      if (hashes.indexOf(options.algorithm) === -1) {
        throw new Error('Algorithm "' + options.algorithm + '"  not supported. supported values: ' + hashes.join(", "));
      }
      if (encodings.indexOf(options.encoding) === -1 && options.algorithm !== "passthrough") {
        throw new Error('Encoding "' + options.encoding + '"  not supported. supported values: ' + encodings.join(", "));
      }
      return options;
    }
    function isNativeFunction(f) {
      if (typeof f !== "function") {
        return false;
      }
      var exp = /^function\s+\w*\s*\(\s*\)\s*{\s+\[native code\]\s+}$/i;
      return exp.exec(Function.prototype.toString.call(f)) != null;
    }
    function hash2(object3, options) {
      var hashingStream;
      if (options.algorithm !== "passthrough") {
        hashingStream = crypto2.createHash(options.algorithm);
      } else {
        hashingStream = new PassThrough();
      }
      if (typeof hashingStream.write === "undefined") {
        hashingStream.write = hashingStream.update;
        hashingStream.end = hashingStream.update;
      }
      var hasher = typeHasher(options, hashingStream);
      hasher.dispatch(object3);
      if (!hashingStream.update) {
        hashingStream.end("");
      }
      if (hashingStream.digest) {
        return hashingStream.digest(options.encoding === "buffer" ? void 0 : options.encoding);
      }
      var buf = hashingStream.read();
      if (options.encoding === "buffer") {
        return buf;
      }
      return buf.toString(options.encoding);
    }
    exports2.writeToStream = function(object3, options, stream) {
      if (typeof stream === "undefined") {
        stream = options;
        options = {};
      }
      options = applyDefaults(object3, options);
      return typeHasher(options, stream).dispatch(object3);
    };
    function typeHasher(options, writeTo, context) {
      context = context || [];
      var write = function(str2) {
        if (writeTo.update) {
          return writeTo.update(str2, "utf8");
        } else {
          return writeTo.write(str2, "utf8");
        }
      };
      return {
        dispatch: function(value) {
          if (options.replacer) {
            value = options.replacer(value);
          }
          var type2 = typeof value;
          if (value === null) {
            type2 = "null";
          }
          return this["_" + type2](value);
        },
        _object: function(object3) {
          var pattern = /\[object (.*)\]/i;
          var objString = Object.prototype.toString.call(object3);
          var objType = pattern.exec(objString);
          if (!objType) {
            objType = "unknown:[" + objString + "]";
          } else {
            objType = objType[1];
          }
          objType = objType.toLowerCase();
          var objectNumber = null;
          if ((objectNumber = context.indexOf(object3)) >= 0) {
            return this.dispatch("[CIRCULAR:" + objectNumber + "]");
          } else {
            context.push(object3);
          }
          if (typeof Buffer !== "undefined" && Buffer.isBuffer && Buffer.isBuffer(object3)) {
            write("buffer:");
            return write(object3);
          }
          if (objType !== "object" && objType !== "function" && objType !== "asyncfunction") {
            if (this["_" + objType]) {
              this["_" + objType](object3);
            } else if (options.ignoreUnknown) {
              return write("[" + objType + "]");
            } else {
              throw new Error('Unknown object type "' + objType + '"');
            }
          } else {
            var keys5 = Object.keys(object3);
            if (options.unorderedObjects) {
              keys5 = keys5.sort();
            }
            if (options.respectType !== false && !isNativeFunction(object3)) {
              keys5.splice(0, 0, "prototype", "__proto__", "constructor");
            }
            if (options.excludeKeys) {
              keys5 = keys5.filter(function(key) {
                return !options.excludeKeys(key);
              });
            }
            write("object:" + keys5.length + ":");
            var self2 = this;
            return keys5.forEach(function(key) {
              self2.dispatch(key);
              write(":");
              if (!options.excludeValues) {
                self2.dispatch(object3[key]);
              }
              write(",");
            });
          }
        },
        _array: function(arr, unordered) {
          unordered = typeof unordered !== "undefined" ? unordered : options.unorderedArrays !== false;
          var self2 = this;
          write("array:" + arr.length + ":");
          if (!unordered || arr.length <= 1) {
            return arr.forEach(function(entry) {
              return self2.dispatch(entry);
            });
          }
          var contextAdditions = [];
          var entries4 = arr.map(function(entry) {
            var strm = new PassThrough();
            var localContext = context.slice();
            var hasher = typeHasher(options, strm, localContext);
            hasher.dispatch(entry);
            contextAdditions = contextAdditions.concat(localContext.slice(context.length));
            return strm.read().toString();
          });
          context = context.concat(contextAdditions);
          entries4.sort();
          return this._array(entries4, false);
        },
        _date: function(date3) {
          return write("date:" + date3.toJSON());
        },
        _symbol: function(sym) {
          return write("symbol:" + sym.toString());
        },
        _error: function(err) {
          return write("error:" + err.toString());
        },
        _boolean: function(bool2) {
          return write("bool:" + bool2.toString());
        },
        _string: function(string3) {
          write("string:" + string3.length + ":");
          write(string3.toString());
        },
        _function: function(fn) {
          write("fn:");
          if (isNativeFunction(fn)) {
            this.dispatch("[native]");
          } else {
            this.dispatch(fn.toString());
          }
          if (options.respectFunctionNames !== false) {
            this.dispatch("function-name:" + String(fn.name));
          }
          if (options.respectFunctionProperties) {
            this._object(fn);
          }
        },
        _number: function(number3) {
          return write("number:" + number3.toString());
        },
        _xml: function(xml) {
          return write("xml:" + xml.toString());
        },
        _null: function() {
          return write("Null");
        },
        _undefined: function() {
          return write("Undefined");
        },
        _regexp: function(regex) {
          return write("regex:" + regex.toString());
        },
        _uint8array: function(arr) {
          write("uint8array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint8clampedarray: function(arr) {
          write("uint8clampedarray:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int8array: function(arr) {
          write("int8array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint16array: function(arr) {
          write("uint16array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int16array: function(arr) {
          write("int16array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint32array: function(arr) {
          write("uint32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int32array: function(arr) {
          write("int32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _float32array: function(arr) {
          write("float32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _float64array: function(arr) {
          write("float64array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _arraybuffer: function(arr) {
          write("arraybuffer:");
          return this.dispatch(new Uint8Array(arr));
        },
        _url: function(url) {
          return write("url:" + url.toString(), "utf8");
        },
        _map: function(map2) {
          write("map:");
          var arr = Array.from(map2);
          return this._array(arr, options.unorderedSets !== false);
        },
        _set: function(set4) {
          write("set:");
          var arr = Array.from(set4);
          return this._array(arr, options.unorderedSets !== false);
        },
        _file: function(file) {
          write("file:");
          return this.dispatch([file.name, file.size, file.type, file.lastModfied]);
        },
        _blob: function() {
          if (options.ignoreUnknown) {
            return write("[blob]");
          }
          throw Error('Hashing Blob objects is currently not supported\n(see https://github.com/puleos/object-hash/issues/26)\nUse "options.replacer" or "options.ignoreUnknown"\n');
        },
        _domwindow: function() {
          return write("domwindow");
        },
        _bigint: function(number3) {
          return write("bigint:" + number3.toString());
        },
        /* Node.js standard native objects */
        _process: function() {
          return write("process");
        },
        _timer: function() {
          return write("timer");
        },
        _pipe: function() {
          return write("pipe");
        },
        _tcp: function() {
          return write("tcp");
        },
        _udp: function() {
          return write("udp");
        },
        _tty: function() {
          return write("tty");
        },
        _statwatcher: function() {
          return write("statwatcher");
        },
        _securecontext: function() {
          return write("securecontext");
        },
        _connection: function() {
          return write("connection");
        },
        _zlib: function() {
          return write("zlib");
        },
        _context: function() {
          return write("context");
        },
        _nodescript: function() {
          return write("nodescript");
        },
        _httpparser: function() {
          return write("httpparser");
        },
        _dataview: function() {
          return write("dataview");
        },
        _signal: function() {
          return write("signal");
        },
        _fsevent: function() {
          return write("fsevent");
        },
        _tlswrap: function() {
          return write("tlswrap");
        }
      };
    }
    function PassThrough() {
      return {
        buf: "",
        write: function(b) {
          this.buf += b;
        },
        end: function(b) {
          this.buf += b;
        },
        read: function() {
          return this.buf;
        }
      };
    }
  }
});

// src/index.ts
var src_exports = {};
__export(src_exports, {
  generateDynamicIR: () => generateDynamicIR
});
module.exports = __toCommonJS(src_exports);

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_freeGlobal.js
var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
var freeGlobal_default = freeGlobal;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal_default || freeSelf || Function("return this")();
var root_default = root;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Symbol.js
var Symbol2 = root_default.Symbol;
var Symbol_default = Symbol2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getRawTag.js
var objectProto = Object.prototype;
var hasOwnProperty = objectProto.hasOwnProperty;
var nativeObjectToString = objectProto.toString;
var symToStringTag = Symbol_default ? Symbol_default.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
  try {
    value[symToStringTag] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}
var getRawTag_default = getRawTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_objectToString.js
var objectProto2 = Object.prototype;
var nativeObjectToString2 = objectProto2.toString;
function objectToString(value) {
  return nativeObjectToString2.call(value);
}
var objectToString_default = objectToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js
var nullTag = "[object Null]";
var undefinedTag = "[object Undefined]";
var symToStringTag2 = Symbol_default ? Symbol_default.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag2 && symToStringTag2 in Object(value) ? getRawTag_default(value) : objectToString_default(value);
}
var baseGetTag_default = baseGetTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObjectLike.js
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_default = isObjectLike;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isSymbol.js
var symbolTag = "[object Symbol]";
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike_default(value) && baseGetTag_default(value) == symbolTag;
}
var isSymbol_default = isSymbol;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayMap.js
function arrayMap(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length, result = Array(length);
  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}
var arrayMap_default = arrayMap;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArray.js
var isArray = Array.isArray;
var isArray_default = isArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseToString.js
var INFINITY = 1 / 0;
var symbolProto = Symbol_default ? Symbol_default.prototype : void 0;
var symbolToString = symbolProto ? symbolProto.toString : void 0;
function baseToString(value) {
  if (typeof value == "string") {
    return value;
  }
  if (isArray_default(value)) {
    return arrayMap_default(value, baseToString) + "";
  }
  if (isSymbol_default(value)) {
    return symbolToString ? symbolToString.call(value) : "";
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
var baseToString_default = baseToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObject.js
function isObject(value) {
  var type2 = typeof value;
  return value != null && (type2 == "object" || type2 == "function");
}
var isObject_default = isObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/identity.js
function identity(value) {
  return value;
}
var identity_default = identity;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isFunction.js
var asyncTag = "[object AsyncFunction]";
var funcTag = "[object Function]";
var genTag = "[object GeneratorFunction]";
var proxyTag = "[object Proxy]";
function isFunction(value) {
  if (!isObject_default(value)) {
    return false;
  }
  var tag = baseGetTag_default(value);
  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}
var isFunction_default = isFunction;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_coreJsData.js
var coreJsData = root_default["__core-js_shared__"];
var coreJsData_default = coreJsData;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isMasked.js
var maskSrcKey = function() {
  var uid = /[^.]+$/.exec(coreJsData_default && coreJsData_default.keys && coreJsData_default.keys.IE_PROTO || "");
  return uid ? "Symbol(src)_1." + uid : "";
}();
function isMasked(func) {
  return !!maskSrcKey && maskSrcKey in func;
}
var isMasked_default = isMasked;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_toSource.js
var funcProto = Function.prototype;
var funcToString = funcProto.toString;
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {
    }
    try {
      return func + "";
    } catch (e) {
    }
  }
  return "";
}
var toSource_default = toSource;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsNative.js
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var funcProto2 = Function.prototype;
var objectProto3 = Object.prototype;
var funcToString2 = funcProto2.toString;
var hasOwnProperty2 = objectProto3.hasOwnProperty;
var reIsNative = RegExp(
  "^" + funcToString2.call(hasOwnProperty2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
);
function baseIsNative(value) {
  if (!isObject_default(value) || isMasked_default(value)) {
    return false;
  }
  var pattern = isFunction_default(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource_default(value));
}
var baseIsNative_default = baseIsNative;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getValue.js
function getValue(object3, key) {
  return object3 == null ? void 0 : object3[key];
}
var getValue_default = getValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getNative.js
function getNative(object3, key) {
  var value = getValue_default(object3, key);
  return baseIsNative_default(value) ? value : void 0;
}
var getNative_default = getNative;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_WeakMap.js
var WeakMap2 = getNative_default(root_default, "WeakMap");
var WeakMap_default = WeakMap2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseCreate.js
var objectCreate = Object.create;
var baseCreate = /* @__PURE__ */ function() {
  function object3() {
  }
  return function(proto) {
    if (!isObject_default(proto)) {
      return {};
    }
    if (objectCreate) {
      return objectCreate(proto);
    }
    object3.prototype = proto;
    var result = new object3();
    object3.prototype = void 0;
    return result;
  };
}();
var baseCreate_default = baseCreate;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_apply.js
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0:
      return func.call(thisArg);
    case 1:
      return func.call(thisArg, args[0]);
    case 2:
      return func.call(thisArg, args[0], args[1]);
    case 3:
      return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}
var apply_default = apply;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_copyArray.js
function copyArray(source, array) {
  var index = -1, length = source.length;
  array || (array = Array(length));
  while (++index < length) {
    array[index] = source[index];
  }
  return array;
}
var copyArray_default = copyArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_shortOut.js
var HOT_COUNT = 800;
var HOT_SPAN = 16;
var nativeNow = Date.now;
function shortOut(func) {
  var count = 0, lastCalled = 0;
  return function() {
    var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(void 0, arguments);
  };
}
var shortOut_default = shortOut;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/constant.js
function constant(value) {
  return function() {
    return value;
  };
}
var constant_default = constant;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_defineProperty.js
var defineProperty = function() {
  try {
    var func = getNative_default(Object, "defineProperty");
    func({}, "", {});
    return func;
  } catch (e) {
  }
}();
var defineProperty_default = defineProperty;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSetToString.js
var baseSetToString = !defineProperty_default ? identity_default : function(func, string3) {
  return defineProperty_default(func, "toString", {
    "configurable": true,
    "enumerable": false,
    "value": constant_default(string3),
    "writable": true
  });
};
var baseSetToString_default = baseSetToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setToString.js
var setToString = shortOut_default(baseSetToString_default);
var setToString_default = setToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFindIndex.js
function baseFindIndex(array, predicate, fromIndex, fromRight) {
  var length = array.length, index = fromIndex + (fromRight ? 1 : -1);
  while (fromRight ? index-- : ++index < length) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}
var baseFindIndex_default = baseFindIndex;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsNaN.js
function baseIsNaN(value) {
  return value !== value;
}
var baseIsNaN_default = baseIsNaN;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_strictIndexOf.js
function strictIndexOf(array, value, fromIndex) {
  var index = fromIndex - 1, length = array.length;
  while (++index < length) {
    if (array[index] === value) {
      return index;
    }
  }
  return -1;
}
var strictIndexOf_default = strictIndexOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIndexOf.js
function baseIndexOf(array, value, fromIndex) {
  return value === value ? strictIndexOf_default(array, value, fromIndex) : baseFindIndex_default(array, baseIsNaN_default, fromIndex);
}
var baseIndexOf_default = baseIndexOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayIncludes.js
function arrayIncludes(array, value) {
  var length = array == null ? 0 : array.length;
  return !!length && baseIndexOf_default(array, value, 0) > -1;
}
var arrayIncludes_default = arrayIncludes;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIndex.js
var MAX_SAFE_INTEGER = 9007199254740991;
var reIsUint = /^(?:0|[1-9]\d*)$/;
function isIndex(value, length) {
  var type2 = typeof value;
  length = length == null ? MAX_SAFE_INTEGER : length;
  return !!length && (type2 == "number" || type2 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
}
var isIndex_default = isIndex;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseAssignValue.js
function baseAssignValue(object3, key, value) {
  if (key == "__proto__" && defineProperty_default) {
    defineProperty_default(object3, key, {
      "configurable": true,
      "enumerable": true,
      "value": value,
      "writable": true
    });
  } else {
    object3[key] = value;
  }
}
var baseAssignValue_default = baseAssignValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/eq.js
function eq(value, other) {
  return value === other || value !== value && other !== other;
}
var eq_default = eq;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assignValue.js
var objectProto4 = Object.prototype;
var hasOwnProperty3 = objectProto4.hasOwnProperty;
function assignValue(object3, key, value) {
  var objValue = object3[key];
  if (!(hasOwnProperty3.call(object3, key) && eq_default(objValue, value)) || value === void 0 && !(key in object3)) {
    baseAssignValue_default(object3, key, value);
  }
}
var assignValue_default = assignValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_copyObject.js
function copyObject(source, props, object3, customizer) {
  var isNew = !object3;
  object3 || (object3 = {});
  var index = -1, length = props.length;
  while (++index < length) {
    var key = props[index];
    var newValue = customizer ? customizer(object3[key], source[key], key, object3, source) : void 0;
    if (newValue === void 0) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue_default(object3, key, newValue);
    } else {
      assignValue_default(object3, key, newValue);
    }
  }
  return object3;
}
var copyObject_default = copyObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overRest.js
var nativeMax = Math.max;
function overRest(func, start, transform3) {
  start = nativeMax(start === void 0 ? func.length - 1 : start, 0);
  return function() {
    var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length);
    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform3(array);
    return apply_default(func, this, otherArgs);
  };
}
var overRest_default = overRest;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseRest.js
function baseRest(func, start) {
  return setToString_default(overRest_default(func, start, identity_default), func + "");
}
var baseRest_default = baseRest;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isLength.js
var MAX_SAFE_INTEGER2 = 9007199254740991;
function isLength(value) {
  return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER2;
}
var isLength_default = isLength;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLike.js
function isArrayLike(value) {
  return value != null && isLength_default(value.length) && !isFunction_default(value);
}
var isArrayLike_default = isArrayLike;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIterateeCall.js
function isIterateeCall(value, index, object3) {
  if (!isObject_default(object3)) {
    return false;
  }
  var type2 = typeof index;
  if (type2 == "number" ? isArrayLike_default(object3) && isIndex_default(index, object3.length) : type2 == "string" && index in object3) {
    return eq_default(object3[index], value);
  }
  return false;
}
var isIterateeCall_default = isIterateeCall;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createAssigner.js
function createAssigner(assigner) {
  return baseRest_default(function(object3, sources) {
    var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : void 0, guard = length > 2 ? sources[2] : void 0;
    customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : void 0;
    if (guard && isIterateeCall_default(sources[0], sources[1], guard)) {
      customizer = length < 3 ? void 0 : customizer;
      length = 1;
    }
    object3 = Object(object3);
    while (++index < length) {
      var source = sources[index];
      if (source) {
        assigner(object3, source, index, customizer);
      }
    }
    return object3;
  });
}
var createAssigner_default = createAssigner;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isPrototype.js
var objectProto5 = Object.prototype;
function isPrototype(value) {
  var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto5;
  return value === proto;
}
var isPrototype_default = isPrototype;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseTimes.js
function baseTimes(n, iteratee) {
  var index = -1, result = Array(n);
  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}
var baseTimes_default = baseTimes;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsArguments.js
var argsTag = "[object Arguments]";
function baseIsArguments(value) {
  return isObjectLike_default(value) && baseGetTag_default(value) == argsTag;
}
var baseIsArguments_default = baseIsArguments;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArguments.js
var objectProto6 = Object.prototype;
var hasOwnProperty4 = objectProto6.hasOwnProperty;
var propertyIsEnumerable = objectProto6.propertyIsEnumerable;
var isArguments = baseIsArguments_default(/* @__PURE__ */ function() {
  return arguments;
}()) ? baseIsArguments_default : function(value) {
  return isObjectLike_default(value) && hasOwnProperty4.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
};
var isArguments_default = isArguments;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/stubFalse.js
function stubFalse() {
  return false;
}
var stubFalse_default = stubFalse;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isBuffer.js
var freeExports = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module;
var moduleExports = freeModule && freeModule.exports === freeExports;
var Buffer2 = moduleExports ? root_default.Buffer : void 0;
var nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0;
var isBuffer = nativeIsBuffer || stubFalse_default;
var isBuffer_default = isBuffer;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsTypedArray.js
var argsTag2 = "[object Arguments]";
var arrayTag = "[object Array]";
var boolTag = "[object Boolean]";
var dateTag = "[object Date]";
var errorTag = "[object Error]";
var funcTag2 = "[object Function]";
var mapTag = "[object Map]";
var numberTag = "[object Number]";
var objectTag = "[object Object]";
var regexpTag = "[object RegExp]";
var setTag = "[object Set]";
var stringTag = "[object String]";
var weakMapTag = "[object WeakMap]";
var arrayBufferTag = "[object ArrayBuffer]";
var dataViewTag = "[object DataView]";
var float32Tag = "[object Float32Array]";
var float64Tag = "[object Float64Array]";
var int8Tag = "[object Int8Array]";
var int16Tag = "[object Int16Array]";
var int32Tag = "[object Int32Array]";
var uint8Tag = "[object Uint8Array]";
var uint8ClampedTag = "[object Uint8ClampedArray]";
var uint16Tag = "[object Uint16Array]";
var uint32Tag = "[object Uint32Array]";
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag2] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag2] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
function baseIsTypedArray(value) {
  return isObjectLike_default(value) && isLength_default(value.length) && !!typedArrayTags[baseGetTag_default(value)];
}
var baseIsTypedArray_default = baseIsTypedArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseUnary.js
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}
var baseUnary_default = baseUnary;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nodeUtil.js
var freeExports2 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule2 = freeExports2 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports2 = freeModule2 && freeModule2.exports === freeExports2;
var freeProcess = moduleExports2 && freeGlobal_default.process;
var nodeUtil = function() {
  try {
    var types2 = freeModule2 && freeModule2.require && freeModule2.require("util").types;
    if (types2) {
      return types2;
    }
    return freeProcess && freeProcess.binding && freeProcess.binding("util");
  } catch (e) {
  }
}();
var nodeUtil_default = nodeUtil;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isTypedArray.js
var nodeIsTypedArray = nodeUtil_default && nodeUtil_default.isTypedArray;
var isTypedArray = nodeIsTypedArray ? baseUnary_default(nodeIsTypedArray) : baseIsTypedArray_default;
var isTypedArray_default = isTypedArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayLikeKeys.js
var objectProto7 = Object.prototype;
var hasOwnProperty5 = objectProto7.hasOwnProperty;
function arrayLikeKeys(value, inherited) {
  var isArr = isArray_default(value), isArg = !isArr && isArguments_default(value), isBuff = !isArr && !isArg && isBuffer_default(value), isType = !isArr && !isArg && !isBuff && isTypedArray_default(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes_default(value.length, String) : [], length = result.length;
  for (var key in value) {
    if ((inherited || hasOwnProperty5.call(value, key)) && !(skipIndexes && // Safari 9 has enumerable `arguments.length` in strict mode.
    (key == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
    isBuff && (key == "offset" || key == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
    isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || // Skip index properties.
    isIndex_default(key, length)))) {
      result.push(key);
    }
  }
  return result;
}
var arrayLikeKeys_default = arrayLikeKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overArg.js
function overArg(func, transform3) {
  return function(arg) {
    return func(transform3(arg));
  };
}
var overArg_default = overArg;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nativeKeys.js
var nativeKeys = overArg_default(Object.keys, Object);
var nativeKeys_default = nativeKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseKeys.js
var objectProto8 = Object.prototype;
var hasOwnProperty6 = objectProto8.hasOwnProperty;
function baseKeys(object3) {
  if (!isPrototype_default(object3)) {
    return nativeKeys_default(object3);
  }
  var result = [];
  for (var key in Object(object3)) {
    if (hasOwnProperty6.call(object3, key) && key != "constructor") {
      result.push(key);
    }
  }
  return result;
}
var baseKeys_default = baseKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keys.js
function keys(object3) {
  return isArrayLike_default(object3) ? arrayLikeKeys_default(object3) : baseKeys_default(object3);
}
var keys_default = keys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nativeKeysIn.js
function nativeKeysIn(object3) {
  var result = [];
  if (object3 != null) {
    for (var key in Object(object3)) {
      result.push(key);
    }
  }
  return result;
}
var nativeKeysIn_default = nativeKeysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseKeysIn.js
var objectProto9 = Object.prototype;
var hasOwnProperty7 = objectProto9.hasOwnProperty;
function baseKeysIn(object3) {
  if (!isObject_default(object3)) {
    return nativeKeysIn_default(object3);
  }
  var isProto = isPrototype_default(object3), result = [];
  for (var key in object3) {
    if (!(key == "constructor" && (isProto || !hasOwnProperty7.call(object3, key)))) {
      result.push(key);
    }
  }
  return result;
}
var baseKeysIn_default = baseKeysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keysIn.js
function keysIn(object3) {
  return isArrayLike_default(object3) ? arrayLikeKeys_default(object3, true) : baseKeysIn_default(object3);
}
var keysIn_default = keysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isKey.js
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/;
var reIsPlainProp = /^\w*$/;
function isKey(value, object3) {
  if (isArray_default(value)) {
    return false;
  }
  var type2 = typeof value;
  if (type2 == "number" || type2 == "symbol" || type2 == "boolean" || value == null || isSymbol_default(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object3 != null && value in Object(object3);
}
var isKey_default = isKey;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nativeCreate.js
var nativeCreate = getNative_default(Object, "create");
var nativeCreate_default = nativeCreate;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashClear.js
function hashClear() {
  this.__data__ = nativeCreate_default ? nativeCreate_default(null) : {};
  this.size = 0;
}
var hashClear_default = hashClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashDelete.js
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}
var hashDelete_default = hashDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashGet.js
var HASH_UNDEFINED = "__lodash_hash_undefined__";
var objectProto10 = Object.prototype;
var hasOwnProperty8 = objectProto10.hasOwnProperty;
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate_default) {
    var result = data[key];
    return result === HASH_UNDEFINED ? void 0 : result;
  }
  return hasOwnProperty8.call(data, key) ? data[key] : void 0;
}
var hashGet_default = hashGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashHas.js
var objectProto11 = Object.prototype;
var hasOwnProperty9 = objectProto11.hasOwnProperty;
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate_default ? data[key] !== void 0 : hasOwnProperty9.call(data, key);
}
var hashHas_default = hashHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashSet.js
var HASH_UNDEFINED2 = "__lodash_hash_undefined__";
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = nativeCreate_default && value === void 0 ? HASH_UNDEFINED2 : value;
  return this;
}
var hashSet_default = hashSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Hash.js
function Hash(entries4) {
  var index = -1, length = entries4 == null ? 0 : entries4.length;
  this.clear();
  while (++index < length) {
    var entry = entries4[index];
    this.set(entry[0], entry[1]);
  }
}
Hash.prototype.clear = hashClear_default;
Hash.prototype["delete"] = hashDelete_default;
Hash.prototype.get = hashGet_default;
Hash.prototype.has = hashHas_default;
Hash.prototype.set = hashSet_default;
var Hash_default = Hash;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheClear.js
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}
var listCacheClear_default = listCacheClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assocIndexOf.js
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq_default(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}
var assocIndexOf_default = assocIndexOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheDelete.js
var arrayProto = Array.prototype;
var splice = arrayProto.splice;
function listCacheDelete(key) {
  var data = this.__data__, index = assocIndexOf_default(data, key);
  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}
var listCacheDelete_default = listCacheDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheGet.js
function listCacheGet(key) {
  var data = this.__data__, index = assocIndexOf_default(data, key);
  return index < 0 ? void 0 : data[index][1];
}
var listCacheGet_default = listCacheGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheHas.js
function listCacheHas(key) {
  return assocIndexOf_default(this.__data__, key) > -1;
}
var listCacheHas_default = listCacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheSet.js
function listCacheSet(key, value) {
  var data = this.__data__, index = assocIndexOf_default(data, key);
  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}
var listCacheSet_default = listCacheSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_ListCache.js
function ListCache(entries4) {
  var index = -1, length = entries4 == null ? 0 : entries4.length;
  this.clear();
  while (++index < length) {
    var entry = entries4[index];
    this.set(entry[0], entry[1]);
  }
}
ListCache.prototype.clear = listCacheClear_default;
ListCache.prototype["delete"] = listCacheDelete_default;
ListCache.prototype.get = listCacheGet_default;
ListCache.prototype.has = listCacheHas_default;
ListCache.prototype.set = listCacheSet_default;
var ListCache_default = ListCache;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Map.js
var Map2 = getNative_default(root_default, "Map");
var Map_default = Map2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheClear.js
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    "hash": new Hash_default(),
    "map": new (Map_default || ListCache_default)(),
    "string": new Hash_default()
  };
}
var mapCacheClear_default = mapCacheClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isKeyable.js
function isKeyable(value) {
  var type2 = typeof value;
  return type2 == "string" || type2 == "number" || type2 == "symbol" || type2 == "boolean" ? value !== "__proto__" : value === null;
}
var isKeyable_default = isKeyable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getMapData.js
function getMapData(map2, key) {
  var data = map2.__data__;
  return isKeyable_default(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
}
var getMapData_default = getMapData;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheDelete.js
function mapCacheDelete(key) {
  var result = getMapData_default(this, key)["delete"](key);
  this.size -= result ? 1 : 0;
  return result;
}
var mapCacheDelete_default = mapCacheDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheGet.js
function mapCacheGet(key) {
  return getMapData_default(this, key).get(key);
}
var mapCacheGet_default = mapCacheGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheHas.js
function mapCacheHas(key) {
  return getMapData_default(this, key).has(key);
}
var mapCacheHas_default = mapCacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheSet.js
function mapCacheSet(key, value) {
  var data = getMapData_default(this, key), size2 = data.size;
  data.set(key, value);
  this.size += data.size == size2 ? 0 : 1;
  return this;
}
var mapCacheSet_default = mapCacheSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_MapCache.js
function MapCache(entries4) {
  var index = -1, length = entries4 == null ? 0 : entries4.length;
  this.clear();
  while (++index < length) {
    var entry = entries4[index];
    this.set(entry[0], entry[1]);
  }
}
MapCache.prototype.clear = mapCacheClear_default;
MapCache.prototype["delete"] = mapCacheDelete_default;
MapCache.prototype.get = mapCacheGet_default;
MapCache.prototype.has = mapCacheHas_default;
MapCache.prototype.set = mapCacheSet_default;
var MapCache_default = MapCache;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/memoize.js
var FUNC_ERROR_TEXT = "Expected a function";
function memoize(func, resolver) {
  if (typeof func != "function" || resolver != null && typeof resolver != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache_default)();
  return memoized;
}
memoize.Cache = MapCache_default;
var memoize_default = memoize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_memoizeCapped.js
var MAX_MEMOIZE_SIZE = 500;
function memoizeCapped(func) {
  var result = memoize_default(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });
  var cache = result.cache;
  return result;
}
var memoizeCapped_default = memoizeCapped;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringToPath.js
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
var reEscapeChar = /\\(\\)?/g;
var stringToPath = memoizeCapped_default(function(string3) {
  var result = [];
  if (string3.charCodeAt(0) === 46) {
    result.push("");
  }
  string3.replace(rePropName, function(match, number3, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, "$1") : number3 || match);
  });
  return result;
});
var stringToPath_default = stringToPath;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/toString.js
function toString2(value) {
  return value == null ? "" : baseToString_default(value);
}
var toString_default = toString2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_castPath.js
function castPath(value, object3) {
  if (isArray_default(value)) {
    return value;
  }
  return isKey_default(value, object3) ? [value] : stringToPath_default(toString_default(value));
}
var castPath_default = castPath;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_toKey.js
var INFINITY2 = 1 / 0;
function toKey(value) {
  if (typeof value == "string" || isSymbol_default(value)) {
    return value;
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY2 ? "-0" : result;
}
var toKey_default = toKey;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGet.js
function baseGet(object3, path5) {
  path5 = castPath_default(path5, object3);
  var index = 0, length = path5.length;
  while (object3 != null && index < length) {
    object3 = object3[toKey_default(path5[index++])];
  }
  return index && index == length ? object3 : void 0;
}
var baseGet_default = baseGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/get.js
function get(object3, path5, defaultValue) {
  var result = object3 == null ? void 0 : baseGet_default(object3, path5);
  return result === void 0 ? defaultValue : result;
}
var get_default = get;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayPush.js
function arrayPush(array, values) {
  var index = -1, length = values.length, offset = array.length;
  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}
var arrayPush_default = arrayPush;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isFlattenable.js
var spreadableSymbol = Symbol_default ? Symbol_default.isConcatSpreadable : void 0;
function isFlattenable(value) {
  return isArray_default(value) || isArguments_default(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
}
var isFlattenable_default = isFlattenable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFlatten.js
function baseFlatten(array, depth, predicate, isStrict, result) {
  var index = -1, length = array.length;
  predicate || (predicate = isFlattenable_default);
  result || (result = []);
  while (++index < length) {
    var value = array[index];
    if (depth > 0 && predicate(value)) {
      if (depth > 1) {
        baseFlatten(value, depth - 1, predicate, isStrict, result);
      } else {
        arrayPush_default(result, value);
      }
    } else if (!isStrict) {
      result[result.length] = value;
    }
  }
  return result;
}
var baseFlatten_default = baseFlatten;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getPrototype.js
var getPrototype = overArg_default(Object.getPrototypeOf, Object);
var getPrototype_default = getPrototype;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isPlainObject.js
var objectTag2 = "[object Object]";
var funcProto3 = Function.prototype;
var objectProto12 = Object.prototype;
var funcToString3 = funcProto3.toString;
var hasOwnProperty10 = objectProto12.hasOwnProperty;
var objectCtorString = funcToString3.call(Object);
function isPlainObject(value) {
  if (!isObjectLike_default(value) || baseGetTag_default(value) != objectTag2) {
    return false;
  }
  var proto = getPrototype_default(value);
  if (proto === null) {
    return true;
  }
  var Ctor = hasOwnProperty10.call(proto, "constructor") && proto.constructor;
  return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString3.call(Ctor) == objectCtorString;
}
var isPlainObject_default = isPlainObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSlice.js
function baseSlice(array, start, end) {
  var index = -1, length = array.length;
  if (start < 0) {
    start = -start > length ? 0 : length + start;
  }
  end = end > length ? length : end;
  if (end < 0) {
    end += length;
  }
  length = start > end ? 0 : end - start >>> 0;
  start >>>= 0;
  var result = Array(length);
  while (++index < length) {
    result[index] = array[index + start];
  }
  return result;
}
var baseSlice_default = baseSlice;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_castSlice.js
function castSlice(array, start, end) {
  var length = array.length;
  end = end === void 0 ? length : end;
  return !start && end >= length ? array : baseSlice_default(array, start, end);
}
var castSlice_default = castSlice;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasUnicode.js
var rsAstralRange = "\\ud800-\\udfff";
var rsComboMarksRange = "\\u0300-\\u036f";
var reComboHalfMarksRange = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange = "\\u20d0-\\u20ff";
var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
var rsVarRange = "\\ufe0e\\ufe0f";
var rsZWJ = "\\u200d";
var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
function hasUnicode(string3) {
  return reHasUnicode.test(string3);
}
var hasUnicode_default = hasUnicode;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiToArray.js
function asciiToArray(string3) {
  return string3.split("");
}
var asciiToArray_default = asciiToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeToArray.js
var rsAstralRange2 = "\\ud800-\\udfff";
var rsComboMarksRange2 = "\\u0300-\\u036f";
var reComboHalfMarksRange2 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange2 = "\\u20d0-\\u20ff";
var rsComboRange2 = rsComboMarksRange2 + reComboHalfMarksRange2 + rsComboSymbolsRange2;
var rsVarRange2 = "\\ufe0e\\ufe0f";
var rsAstral = "[" + rsAstralRange2 + "]";
var rsCombo = "[" + rsComboRange2 + "]";
var rsFitz = "\\ud83c[\\udffb-\\udfff]";
var rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")";
var rsNonAstral = "[^" + rsAstralRange2 + "]";
var rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsZWJ2 = "\\u200d";
var reOptMod = rsModifier + "?";
var rsOptVar = "[" + rsVarRange2 + "]?";
var rsOptJoin = "(?:" + rsZWJ2 + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*";
var rsSeq = rsOptVar + reOptMod + rsOptJoin;
var rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
function unicodeToArray(string3) {
  return string3.match(reUnicode) || [];
}
var unicodeToArray_default = unicodeToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringToArray.js
function stringToArray(string3) {
  return hasUnicode_default(string3) ? unicodeToArray_default(string3) : asciiToArray_default(string3);
}
var stringToArray_default = stringToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCaseFirst.js
function createCaseFirst(methodName) {
  return function(string3) {
    string3 = toString_default(string3);
    var strSymbols = hasUnicode_default(string3) ? stringToArray_default(string3) : void 0;
    var chr = strSymbols ? strSymbols[0] : string3.charAt(0);
    var trailing = strSymbols ? castSlice_default(strSymbols, 1).join("") : string3.slice(1);
    return chr[methodName]() + trailing;
  };
}
var createCaseFirst_default = createCaseFirst;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/upperFirst.js
var upperFirst = createCaseFirst_default("toUpperCase");
var upperFirst_default = upperFirst;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/capitalize.js
function capitalize(string3) {
  return upperFirst_default(toString_default(string3).toLowerCase());
}
var capitalize_default = capitalize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayReduce.js
function arrayReduce(array, iteratee, accumulator, initAccum) {
  var index = -1, length = array == null ? 0 : array.length;
  if (initAccum && length) {
    accumulator = array[++index];
  }
  while (++index < length) {
    accumulator = iteratee(accumulator, array[index], index, array);
  }
  return accumulator;
}
var arrayReduce_default = arrayReduce;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePropertyOf.js
function basePropertyOf(object3) {
  return function(key) {
    return object3 == null ? void 0 : object3[key];
  };
}
var basePropertyOf_default = basePropertyOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_deburrLetter.js
var deburredLetters = {
  // Latin-1 Supplement block.
  "\xC0": "A",
  "\xC1": "A",
  "\xC2": "A",
  "\xC3": "A",
  "\xC4": "A",
  "\xC5": "A",
  "\xE0": "a",
  "\xE1": "a",
  "\xE2": "a",
  "\xE3": "a",
  "\xE4": "a",
  "\xE5": "a",
  "\xC7": "C",
  "\xE7": "c",
  "\xD0": "D",
  "\xF0": "d",
  "\xC8": "E",
  "\xC9": "E",
  "\xCA": "E",
  "\xCB": "E",
  "\xE8": "e",
  "\xE9": "e",
  "\xEA": "e",
  "\xEB": "e",
  "\xCC": "I",
  "\xCD": "I",
  "\xCE": "I",
  "\xCF": "I",
  "\xEC": "i",
  "\xED": "i",
  "\xEE": "i",
  "\xEF": "i",
  "\xD1": "N",
  "\xF1": "n",
  "\xD2": "O",
  "\xD3": "O",
  "\xD4": "O",
  "\xD5": "O",
  "\xD6": "O",
  "\xD8": "O",
  "\xF2": "o",
  "\xF3": "o",
  "\xF4": "o",
  "\xF5": "o",
  "\xF6": "o",
  "\xF8": "o",
  "\xD9": "U",
  "\xDA": "U",
  "\xDB": "U",
  "\xDC": "U",
  "\xF9": "u",
  "\xFA": "u",
  "\xFB": "u",
  "\xFC": "u",
  "\xDD": "Y",
  "\xFD": "y",
  "\xFF": "y",
  "\xC6": "Ae",
  "\xE6": "ae",
  "\xDE": "Th",
  "\xFE": "th",
  "\xDF": "ss",
  // Latin Extended-A block.
  "\u0100": "A",
  "\u0102": "A",
  "\u0104": "A",
  "\u0101": "a",
  "\u0103": "a",
  "\u0105": "a",
  "\u0106": "C",
  "\u0108": "C",
  "\u010A": "C",
  "\u010C": "C",
  "\u0107": "c",
  "\u0109": "c",
  "\u010B": "c",
  "\u010D": "c",
  "\u010E": "D",
  "\u0110": "D",
  "\u010F": "d",
  "\u0111": "d",
  "\u0112": "E",
  "\u0114": "E",
  "\u0116": "E",
  "\u0118": "E",
  "\u011A": "E",
  "\u0113": "e",
  "\u0115": "e",
  "\u0117": "e",
  "\u0119": "e",
  "\u011B": "e",
  "\u011C": "G",
  "\u011E": "G",
  "\u0120": "G",
  "\u0122": "G",
  "\u011D": "g",
  "\u011F": "g",
  "\u0121": "g",
  "\u0123": "g",
  "\u0124": "H",
  "\u0126": "H",
  "\u0125": "h",
  "\u0127": "h",
  "\u0128": "I",
  "\u012A": "I",
  "\u012C": "I",
  "\u012E": "I",
  "\u0130": "I",
  "\u0129": "i",
  "\u012B": "i",
  "\u012D": "i",
  "\u012F": "i",
  "\u0131": "i",
  "\u0134": "J",
  "\u0135": "j",
  "\u0136": "K",
  "\u0137": "k",
  "\u0138": "k",
  "\u0139": "L",
  "\u013B": "L",
  "\u013D": "L",
  "\u013F": "L",
  "\u0141": "L",
  "\u013A": "l",
  "\u013C": "l",
  "\u013E": "l",
  "\u0140": "l",
  "\u0142": "l",
  "\u0143": "N",
  "\u0145": "N",
  "\u0147": "N",
  "\u014A": "N",
  "\u0144": "n",
  "\u0146": "n",
  "\u0148": "n",
  "\u014B": "n",
  "\u014C": "O",
  "\u014E": "O",
  "\u0150": "O",
  "\u014D": "o",
  "\u014F": "o",
  "\u0151": "o",
  "\u0154": "R",
  "\u0156": "R",
  "\u0158": "R",
  "\u0155": "r",
  "\u0157": "r",
  "\u0159": "r",
  "\u015A": "S",
  "\u015C": "S",
  "\u015E": "S",
  "\u0160": "S",
  "\u015B": "s",
  "\u015D": "s",
  "\u015F": "s",
  "\u0161": "s",
  "\u0162": "T",
  "\u0164": "T",
  "\u0166": "T",
  "\u0163": "t",
  "\u0165": "t",
  "\u0167": "t",
  "\u0168": "U",
  "\u016A": "U",
  "\u016C": "U",
  "\u016E": "U",
  "\u0170": "U",
  "\u0172": "U",
  "\u0169": "u",
  "\u016B": "u",
  "\u016D": "u",
  "\u016F": "u",
  "\u0171": "u",
  "\u0173": "u",
  "\u0174": "W",
  "\u0175": "w",
  "\u0176": "Y",
  "\u0177": "y",
  "\u0178": "Y",
  "\u0179": "Z",
  "\u017B": "Z",
  "\u017D": "Z",
  "\u017A": "z",
  "\u017C": "z",
  "\u017E": "z",
  "\u0132": "IJ",
  "\u0133": "ij",
  "\u0152": "Oe",
  "\u0153": "oe",
  "\u0149": "'n",
  "\u017F": "s"
};
var deburrLetter = basePropertyOf_default(deburredLetters);
var deburrLetter_default = deburrLetter;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/deburr.js
var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
var rsComboMarksRange3 = "\\u0300-\\u036f";
var reComboHalfMarksRange3 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange3 = "\\u20d0-\\u20ff";
var rsComboRange3 = rsComboMarksRange3 + reComboHalfMarksRange3 + rsComboSymbolsRange3;
var rsCombo2 = "[" + rsComboRange3 + "]";
var reComboMark = RegExp(rsCombo2, "g");
function deburr(string3) {
  string3 = toString_default(string3);
  return string3 && string3.replace(reLatin, deburrLetter_default).replace(reComboMark, "");
}
var deburr_default = deburr;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiWords.js
var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
function asciiWords(string3) {
  return string3.match(reAsciiWord) || [];
}
var asciiWords_default = asciiWords;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasUnicodeWord.js
var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
function hasUnicodeWord(string3) {
  return reHasUnicodeWord.test(string3);
}
var hasUnicodeWord_default = hasUnicodeWord;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeWords.js
var rsAstralRange3 = "\\ud800-\\udfff";
var rsComboMarksRange4 = "\\u0300-\\u036f";
var reComboHalfMarksRange4 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange4 = "\\u20d0-\\u20ff";
var rsComboRange4 = rsComboMarksRange4 + reComboHalfMarksRange4 + rsComboSymbolsRange4;
var rsDingbatRange = "\\u2700-\\u27bf";
var rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff";
var rsMathOpRange = "\\xac\\xb1\\xd7\\xf7";
var rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf";
var rsPunctuationRange = "\\u2000-\\u206f";
var rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000";
var rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde";
var rsVarRange3 = "\\ufe0e\\ufe0f";
var rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
var rsApos = "['\u2019]";
var rsBreak = "[" + rsBreakRange + "]";
var rsCombo3 = "[" + rsComboRange4 + "]";
var rsDigits = "\\d+";
var rsDingbat = "[" + rsDingbatRange + "]";
var rsLower = "[" + rsLowerRange + "]";
var rsMisc = "[^" + rsAstralRange3 + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]";
var rsFitz2 = "\\ud83c[\\udffb-\\udfff]";
var rsModifier2 = "(?:" + rsCombo3 + "|" + rsFitz2 + ")";
var rsNonAstral2 = "[^" + rsAstralRange3 + "]";
var rsRegional2 = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair2 = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsUpper = "[" + rsUpperRange + "]";
var rsZWJ3 = "\\u200d";
var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")";
var rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")";
var rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?";
var rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?";
var reOptMod2 = rsModifier2 + "?";
var rsOptVar2 = "[" + rsVarRange3 + "]?";
var rsOptJoin2 = "(?:" + rsZWJ3 + "(?:" + [rsNonAstral2, rsRegional2, rsSurrPair2].join("|") + ")" + rsOptVar2 + reOptMod2 + ")*";
var rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])";
var rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])";
var rsSeq2 = rsOptVar2 + reOptMod2 + rsOptJoin2;
var rsEmoji = "(?:" + [rsDingbat, rsRegional2, rsSurrPair2].join("|") + ")" + rsSeq2;
var reUnicodeWord = RegExp([
  rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
  rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
  rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
  rsUpper + "+" + rsOptContrUpper,
  rsOrdUpper,
  rsOrdLower,
  rsDigits,
  rsEmoji
].join("|"), "g");
function unicodeWords(string3) {
  return string3.match(reUnicodeWord) || [];
}
var unicodeWords_default = unicodeWords;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/words.js
function words(string3, pattern, guard) {
  string3 = toString_default(string3);
  pattern = guard ? void 0 : pattern;
  if (pattern === void 0) {
    return hasUnicodeWord_default(string3) ? unicodeWords_default(string3) : asciiWords_default(string3);
  }
  return string3.match(pattern) || [];
}
var words_default = words;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCompounder.js
var rsApos2 = "['\u2019]";
var reApos = RegExp(rsApos2, "g");
function createCompounder(callback) {
  return function(string3) {
    return arrayReduce_default(words_default(deburr_default(string3).replace(reApos, "")), callback, "");
  };
}
var createCompounder_default = createCompounder;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/camelCase.js
var camelCase = createCompounder_default(function(result, word, index) {
  word = word.toLowerCase();
  return result + (index ? capitalize_default(word) : word);
});
var camelCase_default = camelCase;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackClear.js
function stackClear() {
  this.__data__ = new ListCache_default();
  this.size = 0;
}
var stackClear_default = stackClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackDelete.js
function stackDelete(key) {
  var data = this.__data__, result = data["delete"](key);
  this.size = data.size;
  return result;
}
var stackDelete_default = stackDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackGet.js
function stackGet(key) {
  return this.__data__.get(key);
}
var stackGet_default = stackGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackHas.js
function stackHas(key) {
  return this.__data__.has(key);
}
var stackHas_default = stackHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackSet.js
var LARGE_ARRAY_SIZE = 200;
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache_default) {
    var pairs2 = data.__data__;
    if (!Map_default || pairs2.length < LARGE_ARRAY_SIZE - 1) {
      pairs2.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache_default(pairs2);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}
var stackSet_default = stackSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Stack.js
function Stack(entries4) {
  var data = this.__data__ = new ListCache_default(entries4);
  this.size = data.size;
}
Stack.prototype.clear = stackClear_default;
Stack.prototype["delete"] = stackDelete_default;
Stack.prototype.get = stackGet_default;
Stack.prototype.has = stackHas_default;
Stack.prototype.set = stackSet_default;
var Stack_default = Stack;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneBuffer.js
var freeExports3 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule3 = freeExports3 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports3 = freeModule3 && freeModule3.exports === freeExports3;
var Buffer3 = moduleExports3 ? root_default.Buffer : void 0;
var allocUnsafe = Buffer3 ? Buffer3.allocUnsafe : void 0;
function cloneBuffer(buffer, isDeep) {
  if (isDeep) {
    return buffer.slice();
  }
  var length = buffer.length, result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
  buffer.copy(result);
  return result;
}
var cloneBuffer_default = cloneBuffer;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayFilter.js
function arrayFilter(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}
var arrayFilter_default = arrayFilter;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/stubArray.js
function stubArray() {
  return [];
}
var stubArray_default = stubArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getSymbols.js
var objectProto13 = Object.prototype;
var propertyIsEnumerable2 = objectProto13.propertyIsEnumerable;
var nativeGetSymbols = Object.getOwnPropertySymbols;
var getSymbols = !nativeGetSymbols ? stubArray_default : function(object3) {
  if (object3 == null) {
    return [];
  }
  object3 = Object(object3);
  return arrayFilter_default(nativeGetSymbols(object3), function(symbol) {
    return propertyIsEnumerable2.call(object3, symbol);
  });
};
var getSymbols_default = getSymbols;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getSymbolsIn.js
var nativeGetSymbols2 = Object.getOwnPropertySymbols;
var getSymbolsIn = !nativeGetSymbols2 ? stubArray_default : function(object3) {
  var result = [];
  while (object3) {
    arrayPush_default(result, getSymbols_default(object3));
    object3 = getPrototype_default(object3);
  }
  return result;
};
var getSymbolsIn_default = getSymbolsIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetAllKeys.js
function baseGetAllKeys(object3, keysFunc, symbolsFunc) {
  var result = keysFunc(object3);
  return isArray_default(object3) ? result : arrayPush_default(result, symbolsFunc(object3));
}
var baseGetAllKeys_default = baseGetAllKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getAllKeys.js
function getAllKeys(object3) {
  return baseGetAllKeys_default(object3, keys_default, getSymbols_default);
}
var getAllKeys_default = getAllKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getAllKeysIn.js
function getAllKeysIn(object3) {
  return baseGetAllKeys_default(object3, keysIn_default, getSymbolsIn_default);
}
var getAllKeysIn_default = getAllKeysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_DataView.js
var DataView = getNative_default(root_default, "DataView");
var DataView_default = DataView;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Promise.js
var Promise2 = getNative_default(root_default, "Promise");
var Promise_default = Promise2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Set.js
var Set2 = getNative_default(root_default, "Set");
var Set_default = Set2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getTag.js
var mapTag2 = "[object Map]";
var objectTag3 = "[object Object]";
var promiseTag = "[object Promise]";
var setTag2 = "[object Set]";
var weakMapTag2 = "[object WeakMap]";
var dataViewTag2 = "[object DataView]";
var dataViewCtorString = toSource_default(DataView_default);
var mapCtorString = toSource_default(Map_default);
var promiseCtorString = toSource_default(Promise_default);
var setCtorString = toSource_default(Set_default);
var weakMapCtorString = toSource_default(WeakMap_default);
var getTag = baseGetTag_default;
if (DataView_default && getTag(new DataView_default(new ArrayBuffer(1))) != dataViewTag2 || Map_default && getTag(new Map_default()) != mapTag2 || Promise_default && getTag(Promise_default.resolve()) != promiseTag || Set_default && getTag(new Set_default()) != setTag2 || WeakMap_default && getTag(new WeakMap_default()) != weakMapTag2) {
  getTag = function(value) {
    var result = baseGetTag_default(value), Ctor = result == objectTag3 ? value.constructor : void 0, ctorString = Ctor ? toSource_default(Ctor) : "";
    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString:
          return dataViewTag2;
        case mapCtorString:
          return mapTag2;
        case promiseCtorString:
          return promiseTag;
        case setCtorString:
          return setTag2;
        case weakMapCtorString:
          return weakMapTag2;
      }
    }
    return result;
  };
}
var getTag_default = getTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Uint8Array.js
var Uint8Array2 = root_default.Uint8Array;
var Uint8Array_default = Uint8Array2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneArrayBuffer.js
function cloneArrayBuffer(arrayBuffer) {
  var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
  new Uint8Array_default(result).set(new Uint8Array_default(arrayBuffer));
  return result;
}
var cloneArrayBuffer_default = cloneArrayBuffer;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneTypedArray.js
function cloneTypedArray(typedArray, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer_default(typedArray.buffer) : typedArray.buffer;
  return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}
var cloneTypedArray_default = cloneTypedArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_initCloneObject.js
function initCloneObject(object3) {
  return typeof object3.constructor == "function" && !isPrototype_default(object3) ? baseCreate_default(getPrototype_default(object3)) : {};
}
var initCloneObject_default = initCloneObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/compact.js
function compact(array) {
  var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
  while (++index < length) {
    var value = array[index];
    if (value) {
      result[resIndex++] = value;
    }
  }
  return result;
}
var compact_default = compact;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setCacheAdd.js
var HASH_UNDEFINED3 = "__lodash_hash_undefined__";
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED3);
  return this;
}
var setCacheAdd_default = setCacheAdd;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setCacheHas.js
function setCacheHas(value) {
  return this.__data__.has(value);
}
var setCacheHas_default = setCacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_SetCache.js
function SetCache(values) {
  var index = -1, length = values == null ? 0 : values.length;
  this.__data__ = new MapCache_default();
  while (++index < length) {
    this.add(values[index]);
  }
}
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd_default;
SetCache.prototype.has = setCacheHas_default;
var SetCache_default = SetCache;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arraySome.js
function arraySome(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}
var arraySome_default = arraySome;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cacheHas.js
function cacheHas(cache, key) {
  return cache.has(key);
}
var cacheHas_default = cacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_equalArrays.js
var COMPARE_PARTIAL_FLAG = 1;
var COMPARE_UNORDERED_FLAG = 2;
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array.length, othLength = other.length;
  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache_default() : void 0;
  stack.set(array, other);
  stack.set(other, array);
  while (++index < arrLength) {
    var arrValue = array[index], othValue = other[index];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== void 0) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    if (seen) {
      if (!arraySome_default(other, function(othValue2, othIndex) {
        if (!cacheHas_default(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
          return seen.push(othIndex);
        }
      })) {
        result = false;
        break;
      }
    } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
      result = false;
      break;
    }
  }
  stack["delete"](array);
  stack["delete"](other);
  return result;
}
var equalArrays_default = equalArrays;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapToArray.js
function mapToArray(map2) {
  var index = -1, result = Array(map2.size);
  map2.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}
var mapToArray_default = mapToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setToArray.js
function setToArray(set4) {
  var index = -1, result = Array(set4.size);
  set4.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}
var setToArray_default = setToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_equalByTag.js
var COMPARE_PARTIAL_FLAG2 = 1;
var COMPARE_UNORDERED_FLAG2 = 2;
var boolTag2 = "[object Boolean]";
var dateTag2 = "[object Date]";
var errorTag2 = "[object Error]";
var mapTag3 = "[object Map]";
var numberTag2 = "[object Number]";
var regexpTag2 = "[object RegExp]";
var setTag3 = "[object Set]";
var stringTag2 = "[object String]";
var symbolTag2 = "[object Symbol]";
var arrayBufferTag2 = "[object ArrayBuffer]";
var dataViewTag3 = "[object DataView]";
var symbolProto2 = Symbol_default ? Symbol_default.prototype : void 0;
var symbolValueOf = symbolProto2 ? symbolProto2.valueOf : void 0;
function equalByTag(object3, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag3:
      if (object3.byteLength != other.byteLength || object3.byteOffset != other.byteOffset) {
        return false;
      }
      object3 = object3.buffer;
      other = other.buffer;
    case arrayBufferTag2:
      if (object3.byteLength != other.byteLength || !equalFunc(new Uint8Array_default(object3), new Uint8Array_default(other))) {
        return false;
      }
      return true;
    case boolTag2:
    case dateTag2:
    case numberTag2:
      return eq_default(+object3, +other);
    case errorTag2:
      return object3.name == other.name && object3.message == other.message;
    case regexpTag2:
    case stringTag2:
      return object3 == other + "";
    case mapTag3:
      var convert2 = mapToArray_default;
    case setTag3:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG2;
      convert2 || (convert2 = setToArray_default);
      if (object3.size != other.size && !isPartial) {
        return false;
      }
      var stacked = stack.get(object3);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG2;
      stack.set(object3, other);
      var result = equalArrays_default(convert2(object3), convert2(other), bitmask, customizer, equalFunc, stack);
      stack["delete"](object3);
      return result;
    case symbolTag2:
      if (symbolValueOf) {
        return symbolValueOf.call(object3) == symbolValueOf.call(other);
      }
  }
  return false;
}
var equalByTag_default = equalByTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_equalObjects.js
var COMPARE_PARTIAL_FLAG3 = 1;
var objectProto14 = Object.prototype;
var hasOwnProperty11 = objectProto14.hasOwnProperty;
function equalObjects(object3, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG3, objProps = getAllKeys_default(object3), objLength = objProps.length, othProps = getAllKeys_default(other), othLength = othProps.length;
  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty11.call(other, key))) {
      return false;
    }
  }
  var objStacked = stack.get(object3);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object3;
  }
  var result = true;
  stack.set(object3, other);
  stack.set(other, object3);
  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object3[key], othValue = other[key];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, objValue, key, other, object3, stack) : customizer(objValue, othValue, key, object3, other, stack);
    }
    if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == "constructor");
  }
  if (result && !skipCtor) {
    var objCtor = object3.constructor, othCtor = other.constructor;
    if (objCtor != othCtor && ("constructor" in object3 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack["delete"](object3);
  stack["delete"](other);
  return result;
}
var equalObjects_default = equalObjects;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsEqualDeep.js
var COMPARE_PARTIAL_FLAG4 = 1;
var argsTag3 = "[object Arguments]";
var arrayTag2 = "[object Array]";
var objectTag4 = "[object Object]";
var objectProto15 = Object.prototype;
var hasOwnProperty12 = objectProto15.hasOwnProperty;
function baseIsEqualDeep(object3, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray_default(object3), othIsArr = isArray_default(other), objTag = objIsArr ? arrayTag2 : getTag_default(object3), othTag = othIsArr ? arrayTag2 : getTag_default(other);
  objTag = objTag == argsTag3 ? objectTag4 : objTag;
  othTag = othTag == argsTag3 ? objectTag4 : othTag;
  var objIsObj = objTag == objectTag4, othIsObj = othTag == objectTag4, isSameTag = objTag == othTag;
  if (isSameTag && isBuffer_default(object3)) {
    if (!isBuffer_default(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack_default());
    return objIsArr || isTypedArray_default(object3) ? equalArrays_default(object3, other, bitmask, customizer, equalFunc, stack) : equalByTag_default(object3, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG4)) {
    var objIsWrapped = objIsObj && hasOwnProperty12.call(object3, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty12.call(other, "__wrapped__");
    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object3.value() : object3, othUnwrapped = othIsWrapped ? other.value() : other;
      stack || (stack = new Stack_default());
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack_default());
  return equalObjects_default(object3, other, bitmask, customizer, equalFunc, stack);
}
var baseIsEqualDeep_default = baseIsEqualDeep;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsEqual.js
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || !isObjectLike_default(value) && !isObjectLike_default(other)) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep_default(value, other, bitmask, customizer, baseIsEqual, stack);
}
var baseIsEqual_default = baseIsEqual;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsMatch.js
var COMPARE_PARTIAL_FLAG5 = 1;
var COMPARE_UNORDERED_FLAG3 = 2;
function baseIsMatch(object3, source, matchData, customizer) {
  var index = matchData.length, length = index, noCustomizer = !customizer;
  if (object3 == null) {
    return !length;
  }
  object3 = Object(object3);
  while (index--) {
    var data = matchData[index];
    if (noCustomizer && data[2] ? data[1] !== object3[data[0]] : !(data[0] in object3)) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0], objValue = object3[key], srcValue = data[1];
    if (noCustomizer && data[2]) {
      if (objValue === void 0 && !(key in object3)) {
        return false;
      }
    } else {
      var stack = new Stack_default();
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object3, source, stack);
      }
      if (!(result === void 0 ? baseIsEqual_default(srcValue, objValue, COMPARE_PARTIAL_FLAG5 | COMPARE_UNORDERED_FLAG3, customizer, stack) : result)) {
        return false;
      }
    }
  }
  return true;
}
var baseIsMatch_default = baseIsMatch;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isStrictComparable.js
function isStrictComparable(value) {
  return value === value && !isObject_default(value);
}
var isStrictComparable_default = isStrictComparable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getMatchData.js
function getMatchData(object3) {
  var result = keys_default(object3), length = result.length;
  while (length--) {
    var key = result[length], value = object3[key];
    result[length] = [key, value, isStrictComparable_default(value)];
  }
  return result;
}
var getMatchData_default = getMatchData;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_matchesStrictComparable.js
function matchesStrictComparable(key, srcValue) {
  return function(object3) {
    if (object3 == null) {
      return false;
    }
    return object3[key] === srcValue && (srcValue !== void 0 || key in Object(object3));
  };
}
var matchesStrictComparable_default = matchesStrictComparable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMatches.js
function baseMatches(source) {
  var matchData = getMatchData_default(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable_default(matchData[0][0], matchData[0][1]);
  }
  return function(object3) {
    return object3 === source || baseIsMatch_default(object3, source, matchData);
  };
}
var baseMatches_default = baseMatches;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseHasIn.js
function baseHasIn(object3, key) {
  return object3 != null && key in Object(object3);
}
var baseHasIn_default = baseHasIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasPath.js
function hasPath(object3, path5, hasFunc) {
  path5 = castPath_default(path5, object3);
  var index = -1, length = path5.length, result = false;
  while (++index < length) {
    var key = toKey_default(path5[index]);
    if (!(result = object3 != null && hasFunc(object3, key))) {
      break;
    }
    object3 = object3[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object3 == null ? 0 : object3.length;
  return !!length && isLength_default(length) && isIndex_default(key, length) && (isArray_default(object3) || isArguments_default(object3));
}
var hasPath_default = hasPath;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/hasIn.js
function hasIn(object3, path5) {
  return object3 != null && hasPath_default(object3, path5, baseHasIn_default);
}
var hasIn_default = hasIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMatchesProperty.js
var COMPARE_PARTIAL_FLAG6 = 1;
var COMPARE_UNORDERED_FLAG4 = 2;
function baseMatchesProperty(path5, srcValue) {
  if (isKey_default(path5) && isStrictComparable_default(srcValue)) {
    return matchesStrictComparable_default(toKey_default(path5), srcValue);
  }
  return function(object3) {
    var objValue = get_default(object3, path5);
    return objValue === void 0 && objValue === srcValue ? hasIn_default(object3, path5) : baseIsEqual_default(srcValue, objValue, COMPARE_PARTIAL_FLAG6 | COMPARE_UNORDERED_FLAG4);
  };
}
var baseMatchesProperty_default = baseMatchesProperty;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseProperty.js
function baseProperty(key) {
  return function(object3) {
    return object3 == null ? void 0 : object3[key];
  };
}
var baseProperty_default = baseProperty;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePropertyDeep.js
function basePropertyDeep(path5) {
  return function(object3) {
    return baseGet_default(object3, path5);
  };
}
var basePropertyDeep_default = basePropertyDeep;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/property.js
function property(path5) {
  return isKey_default(path5) ? baseProperty_default(toKey_default(path5)) : basePropertyDeep_default(path5);
}
var property_default = property;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIteratee.js
function baseIteratee(value) {
  if (typeof value == "function") {
    return value;
  }
  if (value == null) {
    return identity_default;
  }
  if (typeof value == "object") {
    return isArray_default(value) ? baseMatchesProperty_default(value[0], value[1]) : baseMatches_default(value);
  }
  return property_default(value);
}
var baseIteratee_default = baseIteratee;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayAggregator.js
function arrayAggregator(array, setter, iteratee, accumulator) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    var value = array[index];
    setter(accumulator, value, iteratee(value), array);
  }
  return accumulator;
}
var arrayAggregator_default = arrayAggregator;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createBaseFor.js
function createBaseFor(fromRight) {
  return function(object3, iteratee, keysFunc) {
    var index = -1, iterable = Object(object3), props = keysFunc(object3), length = props.length;
    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object3;
  };
}
var createBaseFor_default = createBaseFor;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFor.js
var baseFor = createBaseFor_default();
var baseFor_default = baseFor;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseForOwn.js
function baseForOwn(object3, iteratee) {
  return object3 && baseFor_default(object3, iteratee, keys_default);
}
var baseForOwn_default = baseForOwn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createBaseEach.js
function createBaseEach(eachFunc, fromRight) {
  return function(collection, iteratee) {
    if (collection == null) {
      return collection;
    }
    if (!isArrayLike_default(collection)) {
      return eachFunc(collection, iteratee);
    }
    var length = collection.length, index = fromRight ? length : -1, iterable = Object(collection);
    while (fromRight ? index-- : ++index < length) {
      if (iteratee(iterable[index], index, iterable) === false) {
        break;
      }
    }
    return collection;
  };
}
var createBaseEach_default = createBaseEach;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseEach.js
var baseEach = createBaseEach_default(baseForOwn_default);
var baseEach_default = baseEach;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseAggregator.js
function baseAggregator(collection, setter, iteratee, accumulator) {
  baseEach_default(collection, function(value, key, collection2) {
    setter(accumulator, value, iteratee(value), collection2);
  });
  return accumulator;
}
var baseAggregator_default = baseAggregator;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createAggregator.js
function createAggregator(setter, initializer) {
  return function(collection, iteratee) {
    var func = isArray_default(collection) ? arrayAggregator_default : baseAggregator_default, accumulator = initializer ? initializer() : {};
    return func(collection, setter, baseIteratee_default(iteratee, 2), accumulator);
  };
}
var createAggregator_default = createAggregator;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assignMergeValue.js
function assignMergeValue(object3, key, value) {
  if (value !== void 0 && !eq_default(object3[key], value) || value === void 0 && !(key in object3)) {
    baseAssignValue_default(object3, key, value);
  }
}
var assignMergeValue_default = assignMergeValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLikeObject.js
function isArrayLikeObject(value) {
  return isObjectLike_default(value) && isArrayLike_default(value);
}
var isArrayLikeObject_default = isArrayLikeObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_safeGet.js
function safeGet(object3, key) {
  if (key === "constructor" && typeof object3[key] === "function") {
    return;
  }
  if (key == "__proto__") {
    return;
  }
  return object3[key];
}
var safeGet_default = safeGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/toPlainObject.js
function toPlainObject(value) {
  return copyObject_default(value, keysIn_default(value));
}
var toPlainObject_default = toPlainObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMergeDeep.js
function baseMergeDeep(object3, source, key, srcIndex, mergeFunc, customizer, stack) {
  var objValue = safeGet_default(object3, key), srcValue = safeGet_default(source, key), stacked = stack.get(srcValue);
  if (stacked) {
    assignMergeValue_default(object3, key, stacked);
    return;
  }
  var newValue = customizer ? customizer(objValue, srcValue, key + "", object3, source, stack) : void 0;
  var isCommon = newValue === void 0;
  if (isCommon) {
    var isArr = isArray_default(srcValue), isBuff = !isArr && isBuffer_default(srcValue), isTyped = !isArr && !isBuff && isTypedArray_default(srcValue);
    newValue = srcValue;
    if (isArr || isBuff || isTyped) {
      if (isArray_default(objValue)) {
        newValue = objValue;
      } else if (isArrayLikeObject_default(objValue)) {
        newValue = copyArray_default(objValue);
      } else if (isBuff) {
        isCommon = false;
        newValue = cloneBuffer_default(srcValue, true);
      } else if (isTyped) {
        isCommon = false;
        newValue = cloneTypedArray_default(srcValue, true);
      } else {
        newValue = [];
      }
    } else if (isPlainObject_default(srcValue) || isArguments_default(srcValue)) {
      newValue = objValue;
      if (isArguments_default(objValue)) {
        newValue = toPlainObject_default(objValue);
      } else if (!isObject_default(objValue) || isFunction_default(objValue)) {
        newValue = initCloneObject_default(srcValue);
      }
    } else {
      isCommon = false;
    }
  }
  if (isCommon) {
    stack.set(srcValue, newValue);
    mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
    stack["delete"](srcValue);
  }
  assignMergeValue_default(object3, key, newValue);
}
var baseMergeDeep_default = baseMergeDeep;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMerge.js
function baseMerge(object3, source, srcIndex, customizer, stack) {
  if (object3 === source) {
    return;
  }
  baseFor_default(source, function(srcValue, key) {
    stack || (stack = new Stack_default());
    if (isObject_default(srcValue)) {
      baseMergeDeep_default(object3, source, key, srcIndex, baseMerge, customizer, stack);
    } else {
      var newValue = customizer ? customizer(safeGet_default(object3, key), srcValue, key + "", object3, source, stack) : void 0;
      if (newValue === void 0) {
        newValue = srcValue;
      }
      assignMergeValue_default(object3, key, newValue);
    }
  }, keysIn_default);
}
var baseMerge_default = baseMerge;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/mergeWith.js
var mergeWith = createAssigner_default(function(object3, source, srcIndex, customizer) {
  baseMerge_default(object3, source, srcIndex, customizer);
});
var mergeWith_default = mergeWith;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayIncludesWith.js
function arrayIncludesWith(array, value, comparator) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (comparator(value, array[index])) {
      return true;
    }
  }
  return false;
}
var arrayIncludesWith_default = arrayIncludesWith;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseDifference.js
var LARGE_ARRAY_SIZE2 = 200;
function baseDifference(array, values, iteratee, comparator) {
  var index = -1, includes = arrayIncludes_default, isCommon = true, length = array.length, result = [], valuesLength = values.length;
  if (!length) {
    return result;
  }
  if (iteratee) {
    values = arrayMap_default(values, baseUnary_default(iteratee));
  }
  if (comparator) {
    includes = arrayIncludesWith_default;
    isCommon = false;
  } else if (values.length >= LARGE_ARRAY_SIZE2) {
    includes = cacheHas_default;
    isCommon = false;
    values = new SetCache_default(values);
  }
  outer:
    while (++index < length) {
      var value = array[index], computed = iteratee == null ? value : iteratee(value);
      value = comparator || value !== 0 ? value : 0;
      if (isCommon && computed === computed) {
        var valuesIndex = valuesLength;
        while (valuesIndex--) {
          if (values[valuesIndex] === computed) {
            continue outer;
          }
        }
        result.push(value);
      } else if (!includes(values, computed, comparator)) {
        result.push(value);
      }
    }
  return result;
}
var baseDifference_default = baseDifference;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/difference.js
var difference = baseRest_default(function(array, values) {
  return isArrayLikeObject_default(array) ? baseDifference_default(array, baseFlatten_default(values, 1, isArrayLikeObject_default, true)) : [];
});
var difference_default = difference;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isString.js
var stringTag3 = "[object String]";
function isString(value) {
  return typeof value == "string" || !isArray_default(value) && isObjectLike_default(value) && baseGetTag_default(value) == stringTag3;
}
var isString_default = isString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isEqual.js
function isEqual(value, other) {
  return baseIsEqual_default(value, other);
}
var isEqual_default = isEqual;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isNull.js
function isNull(value) {
  return value === null;
}
var isNull_default = isNull;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keyBy.js
var keyBy = createAggregator_default(function(result, value, key) {
  baseAssignValue_default(result, key, value);
});
var keyBy_default = keyBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/mapKeys.js
function mapKeys(object3, iteratee) {
  var result = {};
  iteratee = baseIteratee_default(iteratee, 3);
  baseForOwn_default(object3, function(value, key, object4) {
    baseAssignValue_default(result, iteratee(value, key, object4), value);
  });
  return result;
}
var mapKeys_default = mapKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/mapValues.js
function mapValues(object3, iteratee) {
  var result = {};
  iteratee = baseIteratee_default(iteratee, 3);
  baseForOwn_default(object3, function(value, key, object4) {
    baseAssignValue_default(result, key, iteratee(value, key, object4));
  });
  return result;
}
var mapValues_default = mapValues;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/negate.js
var FUNC_ERROR_TEXT2 = "Expected a function";
function negate(predicate) {
  if (typeof predicate != "function") {
    throw new TypeError(FUNC_ERROR_TEXT2);
  }
  return function() {
    var args = arguments;
    switch (args.length) {
      case 0:
        return !predicate.call(this);
      case 1:
        return !predicate.call(this, args[0]);
      case 2:
        return !predicate.call(this, args[0], args[1]);
      case 3:
        return !predicate.call(this, args[0], args[1], args[2]);
    }
    return !predicate.apply(this, args);
  };
}
var negate_default = negate;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSet.js
function baseSet(object3, path5, value, customizer) {
  if (!isObject_default(object3)) {
    return object3;
  }
  path5 = castPath_default(path5, object3);
  var index = -1, length = path5.length, lastIndex = length - 1, nested = object3;
  while (nested != null && ++index < length) {
    var key = toKey_default(path5[index]), newValue = value;
    if (key === "__proto__" || key === "constructor" || key === "prototype") {
      return object3;
    }
    if (index != lastIndex) {
      var objValue = nested[key];
      newValue = customizer ? customizer(objValue, key, nested) : void 0;
      if (newValue === void 0) {
        newValue = isObject_default(objValue) ? objValue : isIndex_default(path5[index + 1]) ? [] : {};
      }
    }
    assignValue_default(nested, key, newValue);
    nested = nested[key];
  }
  return object3;
}
var baseSet_default = baseSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePickBy.js
function basePickBy(object3, paths, predicate) {
  var index = -1, length = paths.length, result = {};
  while (++index < length) {
    var path5 = paths[index], value = baseGet_default(object3, path5);
    if (predicate(value, path5)) {
      baseSet_default(result, castPath_default(path5, object3), value);
    }
  }
  return result;
}
var basePickBy_default = basePickBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/pickBy.js
function pickBy(object3, predicate) {
  if (object3 == null) {
    return {};
  }
  var props = arrayMap_default(getAllKeysIn_default(object3), function(prop) {
    return [prop];
  });
  predicate = baseIteratee_default(predicate);
  return basePickBy_default(object3, props, function(value, path5) {
    return predicate(value, path5[0]);
  });
}
var pickBy_default = pickBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/omitBy.js
function omitBy(object3, predicate) {
  return pickBy_default(object3, negate_default(baseIteratee_default(predicate)));
}
var omitBy_default = omitBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiSize.js
var asciiSize = baseProperty_default("length");
var asciiSize_default = asciiSize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeSize.js
var rsAstralRange4 = "\\ud800-\\udfff";
var rsComboMarksRange5 = "\\u0300-\\u036f";
var reComboHalfMarksRange5 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange5 = "\\u20d0-\\u20ff";
var rsComboRange5 = rsComboMarksRange5 + reComboHalfMarksRange5 + rsComboSymbolsRange5;
var rsVarRange4 = "\\ufe0e\\ufe0f";
var rsAstral2 = "[" + rsAstralRange4 + "]";
var rsCombo4 = "[" + rsComboRange5 + "]";
var rsFitz3 = "\\ud83c[\\udffb-\\udfff]";
var rsModifier3 = "(?:" + rsCombo4 + "|" + rsFitz3 + ")";
var rsNonAstral3 = "[^" + rsAstralRange4 + "]";
var rsRegional3 = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair3 = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsZWJ4 = "\\u200d";
var reOptMod3 = rsModifier3 + "?";
var rsOptVar3 = "[" + rsVarRange4 + "]?";
var rsOptJoin3 = "(?:" + rsZWJ4 + "(?:" + [rsNonAstral3, rsRegional3, rsSurrPair3].join("|") + ")" + rsOptVar3 + reOptMod3 + ")*";
var rsSeq3 = rsOptVar3 + reOptMod3 + rsOptJoin3;
var rsSymbol2 = "(?:" + [rsNonAstral3 + rsCombo4 + "?", rsCombo4, rsRegional3, rsSurrPair3, rsAstral2].join("|") + ")";
var reUnicode2 = RegExp(rsFitz3 + "(?=" + rsFitz3 + ")|" + rsSymbol2 + rsSeq3, "g");
function unicodeSize(string3) {
  var result = reUnicode2.lastIndex = 0;
  while (reUnicode2.test(string3)) {
    ++result;
  }
  return result;
}
var unicodeSize_default = unicodeSize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringSize.js
function stringSize(string3) {
  return hasUnicode_default(string3) ? unicodeSize_default(string3) : asciiSize_default(string3);
}
var stringSize_default = stringSize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/size.js
var mapTag4 = "[object Map]";
var setTag4 = "[object Set]";
function size(collection) {
  if (collection == null) {
    return 0;
  }
  if (isArrayLike_default(collection)) {
    return isString_default(collection) ? stringSize_default(collection) : collection.length;
  }
  var tag = getTag_default(collection);
  if (tag == mapTag4 || tag == setTag4) {
    return collection.size;
  }
  return baseKeys_default(collection).length;
}
var size_default = size;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/snakeCase.js
var snakeCase = createCompounder_default(function(result, word, index) {
  return result + (index ? "_" : "") + word.toLowerCase();
});
var snakeCase_default = snakeCase;

// ../../commons/core-utils/lib/assertNever.js
function assertNever(x) {
  throw new Error("Unexpected value: " + JSON.stringify(x));
}

// ../../commons/core-utils/lib/examples.js
var examples_exports = {};
__export(examples_exports, {
  BASE64: () => BASE64,
  BIG_INTEGER: () => BIG_INTEGER,
  BOOLEAN: () => BOOLEAN,
  DATE: () => DATE,
  DATE_TIME: () => DATE_TIME,
  DOUBLE: () => DOUBLE,
  FLOAT: () => FLOAT,
  INT: () => INT,
  INT64: () => INT64,
  SAMPLE_STRINGS: () => SAMPLE_STRINGS,
  STRING: () => STRING,
  UINT: () => UINT,
  UINT64: () => UINT64,
  UUID: () => UUID
});
var STRING = "string";
var BASE64 = "SGVsbG8gd29ybGQh";
var BOOLEAN = true;
var DATE = "2023-01-15";
var DATE_TIME = "2024-01-15T09:30:00Z";
var DOUBLE = 1.1;
var FLOAT = 1.1;
var INT = 1;
var INT64 = 1e6;
var UINT = 1;
var UINT64 = 1e6;
var UUID = "d5e9c84f-c2b2-4bf4-b4b0-7ffd7a9ffc32";
var BIG_INTEGER = "123456789123456789";
var SAMPLE_STRINGS = [
  "x",
  "xy",
  "foo",
  "buzz",
  "alpha",
  "banana",
  "apricot",
  "mandarin",
  "nectarine",
  "strawberry",
  "pomegranate",
  "blackcurrant"
];

// ../../commons/core-utils/lib/getDuplicates.js
function getDuplicates(items) {
  const seen = /* @__PURE__ */ new Set();
  const duplicatesSet = /* @__PURE__ */ new Set();
  const duplicates = [];
  for (const item of items) {
    if (seen.has(item) && !duplicatesSet.has(item)) {
      duplicatesSet.add(item);
      duplicates.push(item);
    }
    seen.add(item);
  }
  return duplicates;
}

// ../../commons/core-utils/lib/isNonNullish.js
function isNonNullish(x) {
  return x != null;
}

// ../../commons/core-utils/lib/mediaType.js
var import_whatwg_mimetype = __toESM(require_mime_type(), 1);
var MediaType = class _MediaType {
  type;
  subtype;
  essence;
  parameters;
  mimeType;
  input;
  constructor(type2, subtype, essence, parameters, mimeType, input) {
    this.type = type2;
    this.subtype = subtype;
    this.essence = essence;
    this.parameters = parameters;
    this.mimeType = mimeType;
    this.input = input;
  }
  static APPLICATION_JSON = "application/json";
  static APPLICATION_OCTET_STREAM = "application/octet-stream";
  static MULTIPART_FORM_DATA = "multipart/form-data";
  static parse(input) {
    if (input == null) {
      return null;
    }
    const parsed = import_whatwg_mimetype.default.parse(input);
    if (parsed == null) {
      return null;
    }
    return new _MediaType(parsed.type, parsed.subtype, parsed.essence, parsed.parameters, parsed, input);
  }
  toString() {
    return this.input;
  }
  /** Types */
  isText() {
    return this.type === "text";
  }
  isImage() {
    return this.type === "image";
  }
  isAudio() {
    return this.type === "audio";
  }
  isVideo() {
    return this.type === "video";
  }
  isFont() {
    return this.type === "font";
  }
  isMultipart() {
    return this.type === "multipart";
  }
  isApplication() {
    return this.type === "application";
  }
  isMessage() {
    return this.type === "message";
  }
  isModel() {
    return this.type === "model";
  }
  /** Text */
  isCSS() {
    return this.isText() && this.subtype === "css";
  }
  isCSV() {
    return this.isText() && this.subtype === "csv";
  }
  isMarkdown() {
    return this.isText() && this.subtype === "markdown";
  }
  isPlainText() {
    return this.isText() && this.subtype === "plain";
  }
  /** Multipart */
  isMultiPartFormData() {
    return this.isMultipart() && this.subtype === "form-data";
  }
  /** Application */
  isJSON() {
    return this.isApplication() && this.subtype === "json";
  }
  isURLEncoded() {
    return this.isApplication() && this.subtype === "x-www-form-urlencoded";
  }
  isOctetStream() {
    return this.isApplication() && this.subtype === "octet-stream";
  }
  isPDF() {
    return this.isApplication() && this.subtype === "pdf";
  }
  isZip() {
    return this.isApplication() && this.subtype === "zip";
  }
  isGzip() {
    return this.isApplication() && this.subtype === "gzip";
  }
  isTar() {
    return this.isApplication() && this.subtype === "tar";
  }
  isBrotli() {
    return this.isApplication() && this.subtype === "br";
  }
  isDeflate() {
    return this.isApplication() && this.subtype === "deflate";
  }
  isProtobuf() {
    return this.isApplication() && this.subtype === "protobuf";
  }
  /** Images */
  isAvif() {
    return this.isImage() && this.subtype === "avif";
  }
  isWebP() {
    return this.isImage() && this.subtype === "webp";
  }
  isSVG() {
    return this.isImage() && this.subtype === "svg+xml";
  }
  isPNG() {
    return this.isImage() && this.subtype === "png";
  }
  isJPEG() {
    return this.isImage() && this.subtype === "jpeg";
  }
  isGIF() {
    return this.isImage() && this.subtype === "gif";
  }
  /** Audio */
  isMPEG() {
    return this.isAudio() && this.subtype === "mpeg";
  }
  isWAV() {
    return this.isAudio() && this.subtype === "wav";
  }
  /** Mixed */
  isHTML() {
    return this.mimeType.isHTML();
  }
  isXML() {
    return this.mimeType.isXML();
  }
  isJavaScript() {
    return this.mimeType.isJavaScript();
  }
};

// ../../commons/core-utils/lib/noop.js
function noop() {
}

// ../../commons/core-utils/lib/objects/keys.js
function keys2(object3) {
  return Object.keys(object3);
}

// ../../commons/core-utils/lib/ObjectPropertiesVisitor.js
async function visitObject(object3, visitor) {
  for (const key of keys2(visitor)) {
    await visitor[key](object3[key]);
  }
}

// ../../commons/core-utils/lib/objects/entries.js
function entries(object3) {
  return Object.entries(object3);
}

// ../../commons/core-utils/lib/objects/isPlainObject.js
function isPlainObject2(value) {
  if (!isObjectLike2(value) || toString.call(value) !== "[object Object]") {
    return false;
  }
  if (Object.getPrototypeOf(value) == null) {
    return true;
  }
  let proto = value;
  while (Object.getPrototypeOf(proto) != null) {
    proto = Object.getPrototypeOf(proto);
  }
  return Object.getPrototypeOf(value) === proto;
}
function isObjectLike2(value) {
  return typeof value === "object" && value != null;
}

// ../../commons/core-utils/lib/mergeWithOverrides.js
async function mergeWithOverrides({ data, overrides }) {
  const merged = mergeWith_default(data, mergeWith_default, overrides, (obj, src) => Array.isArray(obj) && Array.isArray(src) ? src.every((element) => typeof element === "object") && obj.every((element) => typeof element === "object") ? (
    // nested arrays of objects are merged
    void 0
  ) : (
    // nested arrays of primitives are replaced
    [...src]
  ) : void 0);
  const filtered = omitDeepBy(merged, isNull_default);
  return filtered;
}
var omitDeepBy = (object3, cb) => {
  function omitByDeepByOnOwnProps(object4) {
    if (Array.isArray(object4)) {
      return object4.map((element) => omitDeepBy(element, cb));
    }
    if (isPlainObject_default(object4)) {
      const temp = {};
      for (const [key, value] of Object.entries(object4)) {
        temp[key] = omitDeepBy(value, cb);
      }
      return omitBy_default(temp, cb);
    }
    return object4;
  }
  return omitByDeepByOnOwnProps(object3);
};

// ../../cli/configuration/lib/constants.js
var ROOT_API_FILENAME = "api.yml";
var FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION = "__package__";
var FERN_PACKAGE_MARKER_FILENAME = `${FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION}.yml`;
var DEFAULT_GROUP_NAME = "local";

// ../../cli/configuration/lib/generators-yml/index.js
var generators_yml_exports = {};
__export(generators_yml_exports, {
  API_ORIGIN_LOCATION_KEY: () => API_ORIGIN_LOCATION_KEY,
  API_SETTINGS_KEY: () => API_SETTINGS_KEY,
  ASYNC_API_LOCATION_KEY: () => ASYNC_API_LOCATION_KEY,
  DEFAULT_GROUP_GENERATORS_CONFIG_KEY: () => DEFAULT_GROUP_GENERATORS_CONFIG_KEY,
  DEFAULT_GROUP_NAME: () => DEFAULT_GROUP_NAME,
  GenerationLanguage: () => GenerationLanguage,
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode,
  GithubLicenseType: () => GithubLicenseType,
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema,
  OPENAPI_LOCATION_KEY: () => OPENAPI_LOCATION_KEY,
  OPENAPI_OVERRIDES_LOCATION_KEY: () => OPENAPI_OVERRIDES_LOCATION_KEY,
  UnionSettingsSchema: () => UnionSettingsSchema,
  fernDefinition: () => fernDefinition_exports,
  generators: () => generators_exports,
  getPackageName: () => getPackageName,
  group: () => group_exports,
  isApiConfigurationV2Schema: () => isApiConfigurationV2Schema,
  isAsyncAPISchema: () => isAsyncAPISchema,
  isConjureSchema: () => isConjureSchema,
  isNamespacedApiConfiguration: () => isNamespacedApiConfiguration,
  isOpenAPISchema: () => isOpenAPISchema,
  isRawProtobufAPIDefinitionSchema: () => isRawProtobufAPIDefinitionSchema,
  license: () => license_exports,
  reviewers: () => reviewers_exports,
  serialization: () => serialization_exports
});

// ../../cli/configuration/lib/generators-yml/utils/isApiConfigurationV2Schema.js
function isApiConfigurationV2Schema(api) {
  return api?.specs != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isAsyncAPISpecSchema.js
function isAsyncAPISchema(spec) {
  return spec?.asyncapi != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isOpenAPISpecSchema.js
function isOpenAPISchema(spec) {
  return spec?.openapi != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isConjureSchema.js
function isConjureSchema(specs) {
  return specs?.conjure != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isNamespacedApiConfiguration.js
function isNamespacedApiConfiguration(api) {
  return api?.namespaces != null;
}

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/generators/index.js
var generators_exports = {};
__export(generators_exports, {
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema,
  UnionSettingsSchema: () => UnionSettingsSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/generators/types/UnionSettingsSchema.js
var UnionSettingsSchema = {
  V1: "v1"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/generators/types/MessageNamingSettingsSchema.js
var MessageNamingSettingsSchema = {
  V1: "v1",
  V2: "v2"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/group/index.js
var group_exports = {};
__export(group_exports, {
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/group/types/GithubCommitAndReleaseMode.js
var GithubCommitAndReleaseMode = {
  Commit: "commit",
  Release: "release"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/license/index.js
var license_exports = {};
__export(license_exports, {
  GithubLicenseType: () => GithubLicenseType
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/license/types/GithubLicenseType.js
var GithubLicenseType = {
  Mit: "MIT",
  Apache: "Apache-2.0"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/reviewers/index.js
var reviewers_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/index.js
var fernDefinition_exports = {};
__export(fernDefinition_exports, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema,
  auth: () => auth_exports,
  availability: () => availability_exports,
  commons: () => commons_exports,
  encoding: () => encoding_exports,
  environments: () => environments_exports,
  file: () => file_exports,
  service: () => service_exports,
  types: () => types_exports,
  validation: () => validation_exports
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/auth/index.js
var auth_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/availability/index.js
var availability_exports = {};
__export(availability_exports, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema = {
  InDevelopment: "in-development",
  PreRelease: "pre-release",
  Deprecated: "deprecated",
  GenerallyAvailable: "generally-available"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/commons/index.js
var commons_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/encoding/index.js
var encoding_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/environments/index.js
var environments_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/file/index.js
var file_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/service/index.js
var service_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/types/index.js
var types_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/validation/index.js
var validation_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/serialization/index.js
var serialization_exports = {};
__export(serialization_exports, {
  ApiConfigurationSchema: () => ApiConfigurationSchema,
  ApiConfigurationSchemaInternal: () => ApiConfigurationSchemaInternal,
  ApiConfigurationV2Schema: () => ApiConfigurationV2Schema,
  ApiConfigurationV2SpecsSchema: () => ApiConfigurationV2SpecsSchema,
  ApiDefinitionList: () => ApiDefinitionList,
  ApiDefinitionPathSchema: () => ApiDefinitionPathSchema,
  ApiDefinitionSchema: () => ApiDefinitionSchema,
  ApiDefinitionSettingsSchema: () => ApiDefinitionSettingsSchema,
  ApiDefinitionWithOverridesSchema: () => ApiDefinitionWithOverridesSchema,
  AsyncApiOrOpenApiSpecSchema: () => AsyncApiOrOpenApiSpecSchema,
  AsyncApiSchema: () => AsyncApiSchema,
  AsyncApiSettingsSchema: () => AsyncApiSettingsSchema,
  ConjureSchema: () => ConjureSchema,
  GeneratorApiSettingsSchema: () => GeneratorApiSettingsSchema,
  GeneratorGroupSchema: () => GeneratorGroupSchema,
  GeneratorInvocationSchema: () => GeneratorInvocationSchema,
  GeneratorOutputSchema: () => GeneratorOutputSchema,
  GeneratorPublishMetadataSchema: () => GeneratorPublishMetadataSchema,
  GeneratorSnippetsSchema: () => GeneratorSnippetsSchema,
  GeneratorsConfigurationSchema: () => GeneratorsConfigurationSchema,
  GeneratorsOpenApiObjectSchema: () => GeneratorsOpenApiObjectSchema,
  GeneratorsOpenApiSchema: () => GeneratorsOpenApiSchema,
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode2,
  GithubCommitAndReleaseSchema: () => GithubCommitAndReleaseSchema,
  GithubConfigurationSchema: () => GithubConfigurationSchema,
  GithubLicenseCustomSchema: () => GithubLicenseCustomSchema,
  GithubLicenseSchema: () => GithubLicenseSchema,
  GithubLicenseType: () => GithubLicenseType2,
  GithubPullRequestSchema: () => GithubPullRequestSchema,
  GithubPushSchema: () => GithubPushSchema,
  LocalFileSystemOutputLocationSchema: () => LocalFileSystemOutputLocationSchema,
  MavenOutputLocationSchema: () => MavenOutputLocationSchema,
  MavenOutputSignatureSchema: () => MavenOutputSignatureSchema,
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema2,
  NamespacedApiConfigurationSchema: () => NamespacedApiConfigurationSchema,
  NpmOutputLocationSchema: () => NpmOutputLocationSchema,
  NugetOutputLocationSchema: () => NugetOutputLocationSchema,
  OpenApiSettingsSchema: () => OpenApiSettingsSchema,
  OpenApiSpecSchema: () => OpenApiSpecSchema,
  OutputMetadataAuthor: () => OutputMetadataAuthor,
  OutputMetadataSchema: () => OutputMetadataSchema,
  PostmanOutputLocationSchema: () => PostmanOutputLocationSchema,
  ProtobufApiDefinitionSchema: () => ProtobufApiDefinitionSchema,
  ProtobufDefinitionSchema: () => ProtobufDefinitionSchema,
  PypiOutputLocationSchema: () => PypiOutputLocationSchema,
  PypiOutputMetadataSchema: () => PypiOutputMetadataSchema,
  ReadmeEndpointObjectSchema: () => ReadmeEndpointObjectSchema,
  ReadmeEndpointSchema: () => ReadmeEndpointSchema,
  ReadmeSchema: () => ReadmeSchema,
  ReviewerSchema: () => ReviewerSchema,
  ReviewersSchema: () => ReviewersSchema,
  RubyGemsOutputLocationSchema: () => RubyGemsOutputLocationSchema,
  UnionSettingsSchema: () => UnionSettingsSchema2,
  WhitelabelConfigurationSchema: () => WhitelabelConfigurationSchema,
  WhitelabelGithubConfigurationSchema: () => WhitelabelGithubConfigurationSchema,
  fernDefinition: () => fernDefinition_exports2,
  generators: () => generators_exports2,
  group: () => group_exports2,
  license: () => license_exports2,
  reviewers: () => reviewers_exports2
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/index.js
var generators_exports2 = {};
__export(generators_exports2, {
  ApiConfigurationSchema: () => ApiConfigurationSchema,
  ApiConfigurationSchemaInternal: () => ApiConfigurationSchemaInternal,
  ApiConfigurationV2Schema: () => ApiConfigurationV2Schema,
  ApiConfigurationV2SpecsSchema: () => ApiConfigurationV2SpecsSchema,
  ApiDefinitionList: () => ApiDefinitionList,
  ApiDefinitionPathSchema: () => ApiDefinitionPathSchema,
  ApiDefinitionSchema: () => ApiDefinitionSchema,
  ApiDefinitionSettingsSchema: () => ApiDefinitionSettingsSchema,
  ApiDefinitionWithOverridesSchema: () => ApiDefinitionWithOverridesSchema,
  AsyncApiOrOpenApiSpecSchema: () => AsyncApiOrOpenApiSpecSchema,
  AsyncApiSchema: () => AsyncApiSchema,
  AsyncApiSettingsSchema: () => AsyncApiSettingsSchema,
  ConjureSchema: () => ConjureSchema,
  GeneratorsConfigurationSchema: () => GeneratorsConfigurationSchema,
  GeneratorsOpenApiObjectSchema: () => GeneratorsOpenApiObjectSchema,
  GeneratorsOpenApiSchema: () => GeneratorsOpenApiSchema,
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema2,
  NamespacedApiConfigurationSchema: () => NamespacedApiConfigurationSchema,
  OpenApiSettingsSchema: () => OpenApiSettingsSchema,
  OpenApiSpecSchema: () => OpenApiSpecSchema,
  OutputMetadataAuthor: () => OutputMetadataAuthor,
  OutputMetadataSchema: () => OutputMetadataSchema,
  ProtobufApiDefinitionSchema: () => ProtobufApiDefinitionSchema,
  ProtobufDefinitionSchema: () => ProtobufDefinitionSchema,
  ReadmeEndpointObjectSchema: () => ReadmeEndpointObjectSchema,
  ReadmeEndpointSchema: () => ReadmeEndpointSchema,
  ReadmeSchema: () => ReadmeSchema,
  UnionSettingsSchema: () => UnionSettingsSchema2,
  WhitelabelConfigurationSchema: () => WhitelabelConfigurationSchema,
  WhitelabelGithubConfigurationSchema: () => WhitelabelGithubConfigurationSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/index.js
var schemas_exports = {};
__export(schemas_exports, {
  JsonError: () => JsonError,
  ParseError: () => ParseError,
  any: () => any,
  boolean: () => boolean,
  booleanLiteral: () => booleanLiteral,
  date: () => date,
  discriminant: () => discriminant,
  enum_: () => enum_,
  getObjectLikeUtils: () => getObjectLikeUtils,
  getObjectUtils: () => getObjectUtils,
  getSchemaUtils: () => getSchemaUtils,
  isProperty: () => isProperty,
  lazy: () => lazy,
  lazyObject: () => lazyObject,
  list: () => list,
  number: () => number,
  object: () => object,
  objectWithoutOptionalProperties: () => objectWithoutOptionalProperties,
  optional: () => optional,
  property: () => property2,
  record: () => record,
  set: () => set,
  string: () => string,
  stringLiteral: () => stringLiteral,
  transform: () => transform,
  undiscriminatedUnion: () => undiscriminatedUnion,
  union: () => union,
  unknown: () => unknown,
  withParsedProperties: () => withParsedProperties
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/Schema.js
var SchemaType = {
  DATE: "date",
  ENUM: "enum",
  LIST: "list",
  STRING_LITERAL: "stringLiteral",
  BOOLEAN_LITERAL: "booleanLiteral",
  OBJECT: "object",
  ANY: "any",
  BOOLEAN: "boolean",
  NUMBER: "number",
  STRING: "string",
  UNKNOWN: "unknown",
  RECORD: "record",
  SET: "set",
  UNION: "union",
  UNDISCRIMINATED_UNION: "undiscriminatedUnion",
  OPTIONAL: "optional"
};

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/getErrorMessageForIncorrectType.js
function getErrorMessageForIncorrectType(value, expectedType) {
  return `Expected ${expectedType}. Received ${getTypeAsString(value)}.`;
}
function getTypeAsString(value) {
  if (Array.isArray(value)) {
    return "list";
  }
  if (value === null) {
    return "null";
  }
  switch (typeof value) {
    case "string":
      return `"${value}"`;
    case "number":
    case "boolean":
    case "undefined":
      return `${value}`;
  }
  return typeof value;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/maybeSkipValidation.js
function maybeSkipValidation(schema2) {
  return {
    ...schema2,
    json: transformAndMaybeSkipValidation(schema2.json),
    parse: transformAndMaybeSkipValidation(schema2.parse)
  };
}
function transformAndMaybeSkipValidation(transform3) {
  return (value, opts) => {
    const transformed = transform3(value, opts);
    const { skipValidation = false } = opts ?? {};
    if (!transformed.ok && skipValidation) {
      console.warn([
        "Failed to validate.",
        ...transformed.errors.map((error) => "  - " + (error.path.length > 0 ? `${error.path.join(".")}: ${error.message}` : error.message))
      ].join("\n"));
      return {
        ok: true,
        value
      };
    } else {
      return transformed;
    }
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/stringifyValidationErrors.js
function stringifyValidationError(error) {
  if (error.path.length === 0) {
    return error.message;
  }
  return `${error.path.join(" -> ")}: ${error.message}`;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/JsonError.js
var JsonError = class _JsonError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _JsonError.prototype);
  }
};

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/ParseError.js
var ParseError = class _ParseError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _ParseError.prototype);
  }
};

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/getSchemaUtils.js
function getSchemaUtils(schema2) {
  return {
    optional: () => optional(schema2),
    transform: (transformer) => transform(schema2, transformer),
    parseOrThrow: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (parsed.ok) {
        return parsed.value;
      }
      throw new ParseError(parsed.errors);
    },
    jsonOrThrow: (parsed, opts) => {
      const raw = schema2.json(parsed, opts);
      if (raw.ok) {
        return raw.value;
      }
      throw new JsonError(raw.errors);
    }
  };
}
function optional(schema2) {
  const baseSchema = {
    parse: (raw, opts) => {
      if (raw == null) {
        return {
          ok: true,
          value: void 0
        };
      }
      return schema2.parse(raw, opts);
    },
    json: (parsed, opts) => {
      if (opts?.omitUndefined && parsed === void 0) {
        return {
          ok: true,
          value: void 0
        };
      }
      if (parsed == null) {
        return {
          ok: true,
          value: null
        };
      }
      return schema2.json(parsed, opts);
    },
    getType: () => SchemaType.OPTIONAL
  };
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema)
  };
}
function transform(schema2, transformer) {
  const baseSchema = {
    parse: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (!parsed.ok) {
        return parsed;
      }
      return {
        ok: true,
        value: transformer.transform(parsed.value)
      };
    },
    json: (transformed, opts) => {
      const parsed = transformer.untransform(transformed);
      return schema2.json(parsed, opts);
    },
    getType: () => schema2.getType()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/date/date.js
var ISO_8601_REGEX = /^([+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([.,]\d+(?!:))?)?(\17[0-5]\d([.,]\d+)?)?([zZ]|([+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;
function date() {
  const baseSchema = {
    parse: (raw, { breadcrumbsPrefix = [] } = {}) => {
      if (typeof raw !== "string") {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType(raw, "string")
            }
          ]
        };
      }
      if (!ISO_8601_REGEX.test(raw)) {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType(raw, "ISO 8601 date string")
            }
          ]
        };
      }
      return {
        ok: true,
        value: new Date(raw)
      };
    },
    json: (date3, { breadcrumbsPrefix = [] } = {}) => {
      if (date3 instanceof Date) {
        return {
          ok: true,
          value: date3.toISOString()
        };
      } else {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType(date3, "Date object")
            }
          ]
        };
      }
    },
    getType: () => SchemaType.DATE
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/createIdentitySchemaCreator.js
function createIdentitySchemaCreator(schemaType, validate) {
  return () => {
    const baseSchema = {
      parse: validate,
      json: validate,
      getType: () => schemaType
    };
    return {
      ...maybeSkipValidation(baseSchema),
      ...getSchemaUtils(baseSchema)
    };
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/enum/enum.js
function enum_(values) {
  const validValues = new Set(values);
  const schemaCreator = createIdentitySchemaCreator(SchemaType.ENUM, (value, { allowUnrecognizedEnumValues, breadcrumbsPrefix = [] } = {}) => {
    if (typeof value !== "string") {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, "string")
          }
        ]
      };
    }
    if (!validValues.has(value) && !allowUnrecognizedEnumValues) {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, "enum")
          }
        ]
      };
    }
    return {
      ok: true,
      value
    };
  });
  return schemaCreator();
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/lazy/lazy.js
function lazy(getter) {
  const baseSchema = constructLazyBaseSchema(getter);
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema)
  };
}
function constructLazyBaseSchema(getter) {
  return {
    parse: (raw, opts) => getMemoizedSchema(getter).parse(raw, opts),
    json: (parsed, opts) => getMemoizedSchema(getter).json(parsed, opts),
    getType: () => getMemoizedSchema(getter).getType()
  };
}
function getMemoizedSchema(getter) {
  const castedGetter = getter;
  if (castedGetter.__zurg_memoized == null) {
    castedGetter.__zurg_memoized = getter();
  }
  return castedGetter.__zurg_memoized;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/entries.js
function entries2(object3) {
  return Object.entries(object3);
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/filterObject.js
function filterObject(obj, keysToInclude) {
  const keysToIncludeSet = new Set(keysToInclude);
  return Object.entries(obj).reduce((acc, [key, value]) => {
    if (keysToIncludeSet.has(key)) {
      acc[key] = value;
    }
    return acc;
  }, {});
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/isPlainObject.js
function isPlainObject3(value) {
  if (typeof value !== "object" || value === null) {
    return false;
  }
  if (Object.getPrototypeOf(value) === null) {
    return true;
  }
  let proto = value;
  while (Object.getPrototypeOf(proto) !== null) {
    proto = Object.getPrototypeOf(proto);
  }
  return Object.getPrototypeOf(value) === proto;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/keys.js
function keys3(object3) {
  return Object.keys(object3);
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/partition.js
function partition(items, predicate) {
  const trueItems = [], falseItems = [];
  for (const item of items) {
    if (predicate(item)) {
      trueItems.push(item);
    } else {
      falseItems.push(item);
    }
  }
  return [trueItems, falseItems];
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object-like/getObjectLikeUtils.js
function getObjectLikeUtils(schema2) {
  return {
    withParsedProperties: (properties) => withParsedProperties(schema2, properties)
  };
}
function withParsedProperties(objectLike, properties) {
  const objectSchema = {
    parse: (raw, opts) => {
      const parsedObject = objectLike.parse(raw, opts);
      if (!parsedObject.ok) {
        return parsedObject;
      }
      const additionalProperties = Object.entries(properties).reduce((processed, [key, value]) => {
        return {
          ...processed,
          [key]: typeof value === "function" ? value(parsedObject.value) : value
        };
      }, {});
      return {
        ok: true,
        value: {
          ...parsedObject.value,
          ...additionalProperties
        }
      };
    },
    json: (parsed, opts) => {
      if (!isPlainObject3(parsed)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType(parsed, "object")
            }
          ]
        };
      }
      const addedPropertyKeys = new Set(Object.keys(properties));
      const parsedWithoutAddedProperties = filterObject(parsed, Object.keys(parsed).filter((key) => !addedPropertyKeys.has(key)));
      return objectLike.json(parsedWithoutAddedProperties, opts);
    },
    getType: () => objectLike.getType()
  };
  return {
    ...objectSchema,
    ...getSchemaUtils(objectSchema),
    ...getObjectLikeUtils(objectSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object/property.js
function property2(rawKey, valueSchema) {
  return {
    rawKey,
    valueSchema,
    isProperty: true
  };
}
function isProperty(maybeProperty) {
  return maybeProperty.isProperty;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object/object.js
function object(schemas) {
  const baseSchema = {
    _getRawProperties: () => Object.entries(schemas).map(([parsedKey, propertySchema]) => isProperty(propertySchema) ? propertySchema.rawKey : parsedKey),
    _getParsedProperties: () => keys3(schemas),
    parse: (raw, opts) => {
      const rawKeyToProperty = {};
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries2(schemas)) {
        const rawKey = isProperty(schemaOrObjectProperty) ? schemaOrObjectProperty.rawKey : parsedKey;
        const valueSchema = isProperty(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        const property4 = {
          rawKey,
          parsedKey,
          valueSchema
        };
        rawKeyToProperty[rawKey] = property4;
        if (isSchemaRequired(valueSchema)) {
          requiredKeys.push(rawKey);
        }
      }
      return validateAndTransformObject({
        value: raw,
        requiredKeys,
        getProperty: (rawKey) => {
          const property4 = rawKeyToProperty[rawKey];
          if (property4 == null) {
            return void 0;
          }
          return {
            transformedKey: property4.parsedKey,
            transform: (propertyValue) => property4.valueSchema.parse(propertyValue, {
              ...opts,
              breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawKey]
            })
          };
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    json: (parsed, opts) => {
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries2(schemas)) {
        const valueSchema = isProperty(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        if (isSchemaRequired(valueSchema)) {
          requiredKeys.push(parsedKey);
        }
      }
      return validateAndTransformObject({
        value: parsed,
        requiredKeys,
        getProperty: (parsedKey) => {
          const property4 = schemas[parsedKey];
          if (property4 == null) {
            return void 0;
          }
          if (isProperty(property4)) {
            return {
              transformedKey: property4.rawKey,
              transform: (propertyValue) => property4.valueSchema.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          } else {
            return {
              transformedKey: parsedKey,
              transform: (propertyValue) => property4.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          }
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    getType: () => SchemaType.OBJECT
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema),
    ...getObjectLikeUtils(baseSchema),
    ...getObjectUtils(baseSchema)
  };
}
function validateAndTransformObject({ value, requiredKeys, getProperty: getProperty2, unrecognizedObjectKeys = "fail", skipValidation = false, breadcrumbsPrefix = [] }) {
  if (!isPlainObject3(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "object")
        }
      ]
    };
  }
  const missingRequiredKeys = new Set(requiredKeys);
  const errors = [];
  const transformed = {};
  for (const [preTransformedKey, preTransformedItemValue] of Object.entries(value)) {
    const property4 = getProperty2(preTransformedKey);
    if (property4 != null) {
      missingRequiredKeys.delete(preTransformedKey);
      const value2 = property4.transform(preTransformedItemValue);
      if (value2.ok) {
        transformed[property4.transformedKey] = value2.value;
      } else {
        transformed[preTransformedKey] = preTransformedItemValue;
        errors.push(...value2.errors);
      }
    } else {
      switch (unrecognizedObjectKeys) {
        case "fail":
          errors.push({
            path: [...breadcrumbsPrefix, preTransformedKey],
            message: `Unexpected key "${preTransformedKey}"`
          });
          break;
        case "strip":
          break;
        case "passthrough":
          transformed[preTransformedKey] = preTransformedItemValue;
          break;
      }
    }
  }
  errors.push(...requiredKeys.filter((key) => missingRequiredKeys.has(key)).map((key) => ({
    path: breadcrumbsPrefix,
    message: `Missing required key "${key}"`
  })));
  if (errors.length === 0 || skipValidation) {
    return {
      ok: true,
      value: transformed
    };
  } else {
    return {
      ok: false,
      errors
    };
  }
}
function getObjectUtils(schema2) {
  return {
    extend: (extension) => {
      const baseSchema = {
        _getParsedProperties: () => [...schema2._getParsedProperties(), ...extension._getParsedProperties()],
        _getRawProperties: () => [...schema2._getRawProperties(), ...extension._getRawProperties()],
        parse: (raw, opts) => {
          return validateAndTransformExtendedObject({
            extensionKeys: extension._getRawProperties(),
            value: raw,
            transformBase: (rawBase) => schema2.parse(rawBase, opts),
            transformExtension: (rawExtension) => extension.parse(rawExtension, opts)
          });
        },
        json: (parsed, opts) => {
          return validateAndTransformExtendedObject({
            extensionKeys: extension._getParsedProperties(),
            value: parsed,
            transformBase: (parsedBase) => schema2.json(parsedBase, opts),
            transformExtension: (parsedExtension) => extension.json(parsedExtension, opts)
          });
        },
        getType: () => SchemaType.OBJECT
      };
      return {
        ...baseSchema,
        ...getSchemaUtils(baseSchema),
        ...getObjectLikeUtils(baseSchema),
        ...getObjectUtils(baseSchema)
      };
    }
  };
}
function validateAndTransformExtendedObject({ extensionKeys, value, transformBase, transformExtension }) {
  const extensionPropertiesSet = new Set(extensionKeys);
  const [extensionProperties, baseProperties] = partition(keys3(value), (key) => extensionPropertiesSet.has(key));
  const transformedBase = transformBase(filterObject(value, baseProperties));
  const transformedExtension = transformExtension(filterObject(value, extensionProperties));
  if (transformedBase.ok && transformedExtension.ok) {
    return {
      ok: true,
      value: {
        ...transformedBase.value,
        ...transformedExtension.value
      }
    };
  } else {
    return {
      ok: false,
      errors: [
        ...transformedBase.ok ? [] : transformedBase.errors,
        ...transformedExtension.ok ? [] : transformedExtension.errors
      ]
    };
  }
}
function isSchemaRequired(schema2) {
  return !isSchemaOptional(schema2);
}
function isSchemaOptional(schema2) {
  switch (schema2.getType()) {
    case SchemaType.ANY:
    case SchemaType.UNKNOWN:
    case SchemaType.OPTIONAL:
      return true;
    default:
      return false;
  }
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object/objectWithoutOptionalProperties.js
function objectWithoutOptionalProperties(schemas) {
  return object(schemas);
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/lazy/lazyObject.js
function lazyObject(getter) {
  const baseSchema = {
    ...constructLazyBaseSchema(getter),
    _getRawProperties: () => getMemoizedSchema(getter)._getRawProperties(),
    _getParsedProperties: () => getMemoizedSchema(getter)._getParsedProperties()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema),
    ...getObjectLikeUtils(baseSchema),
    ...getObjectUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/list/list.js
function list(schema2) {
  const baseSchema = {
    parse: (raw, opts) => validateAndTransformArray(raw, (item, index) => schema2.parse(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    json: (parsed, opts) => validateAndTransformArray(parsed, (item, index) => schema2.json(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    getType: () => SchemaType.LIST
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}
function validateAndTransformArray(value, transformItem) {
  if (!Array.isArray(value)) {
    return {
      ok: false,
      errors: [
        {
          message: getErrorMessageForIncorrectType(value, "list"),
          path: []
        }
      ]
    };
  }
  const maybeValidItems = value.map((item, index) => transformItem(item, index));
  return maybeValidItems.reduce((acc, item) => {
    if (acc.ok && item.ok) {
      return {
        ok: true,
        value: [...acc.value, item.value]
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!item.ok) {
      errors.push(...item.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: [] });
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/literals/stringLiteral.js
function stringLiteral(literal) {
  const schemaCreator = createIdentitySchemaCreator(SchemaType.STRING_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, `"${literal}"`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/literals/booleanLiteral.js
function booleanLiteral(literal) {
  const schemaCreator = createIdentitySchemaCreator(SchemaType.BOOLEAN_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, `${literal.toString()}`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/any.js
var any = createIdentitySchemaCreator(SchemaType.ANY, (value) => ({ ok: true, value }));

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/boolean.js
var boolean = createIdentitySchemaCreator(SchemaType.BOOLEAN, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "boolean") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "boolean")
        }
      ]
    };
  }
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/number.js
var number = createIdentitySchemaCreator(SchemaType.NUMBER, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "number") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "number")
        }
      ]
    };
  }
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/string.js
var string = createIdentitySchemaCreator(SchemaType.STRING, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "string") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "string")
        }
      ]
    };
  }
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/unknown.js
var unknown = createIdentitySchemaCreator(SchemaType.UNKNOWN, (value) => ({ ok: true, value }));

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/record/record.js
function record(keySchema, valueSchema) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformRecord({
        value: raw,
        isKeyNumeric: keySchema.getType() === SchemaType.NUMBER,
        transformKey: (key) => keySchema.parse(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.parse(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return validateAndTransformRecord({
        value: parsed,
        isKeyNumeric: keySchema.getType() === SchemaType.NUMBER,
        transformKey: (key) => keySchema.json(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.json(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType.RECORD
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}
function validateAndTransformRecord({ value, isKeyNumeric, transformKey, transformValue, breadcrumbsPrefix = [] }) {
  if (!isPlainObject3(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "object")
        }
      ]
    };
  }
  return entries2(value).reduce((accPromise, [stringKey, value2]) => {
    if (value2 == null) {
      return accPromise;
    }
    const acc = accPromise;
    let key = stringKey;
    if (isKeyNumeric) {
      const numberKey = stringKey.length > 0 ? Number(stringKey) : NaN;
      if (!isNaN(numberKey)) {
        key = numberKey;
      }
    }
    const transformedKey = transformKey(key);
    const transformedValue = transformValue(value2, key);
    if (acc.ok && transformedKey.ok && transformedValue.ok) {
      return {
        ok: true,
        value: {
          ...acc.value,
          [transformedKey.value]: transformedValue.value
        }
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!transformedKey.ok) {
      errors.push(...transformedKey.errors);
    }
    if (!transformedValue.ok) {
      errors.push(...transformedValue.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: {} });
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/set/set.js
function set(schema2) {
  const listSchema = list(schema2);
  const baseSchema = {
    parse: (raw, opts) => {
      const parsedList = listSchema.parse(raw, opts);
      if (parsedList.ok) {
        return {
          ok: true,
          value: new Set(parsedList.value)
        };
      } else {
        return parsedList;
      }
    },
    json: (parsed, opts) => {
      if (!(parsed instanceof Set)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType(parsed, "Set")
            }
          ]
        };
      }
      const jsonList = listSchema.json([...parsed], opts);
      return jsonList;
    },
    getType: () => SchemaType.SET
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/undiscriminated-union/undiscriminatedUnion.js
function undiscriminatedUnion(schemas) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformUndiscriminatedUnion((schema2, opts2) => schema2.parse(raw, opts2), schemas, opts);
    },
    json: (parsed, opts) => {
      return validateAndTransformUndiscriminatedUnion((schema2, opts2) => schema2.json(parsed, opts2), schemas, opts);
    },
    getType: () => SchemaType.UNDISCRIMINATED_UNION
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}
function validateAndTransformUndiscriminatedUnion(transform3, schemas, opts) {
  const errors = [];
  for (const [index, schema2] of schemas.entries()) {
    const transformed = transform3(schema2, { ...opts, skipValidation: false });
    if (transformed.ok) {
      return transformed;
    } else {
      for (const error of transformed.errors) {
        errors.push({
          path: error.path,
          message: `[Variant ${index}] ${error.message}`
        });
      }
    }
  }
  return {
    ok: false,
    errors
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/union/discriminant.js
function discriminant(parsedDiscriminant, rawDiscriminant) {
  return {
    parsedDiscriminant,
    rawDiscriminant
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/union/union.js
function union(discriminant3, union3) {
  const rawDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.rawDiscriminant;
  const parsedDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.parsedDiscriminant;
  const discriminantValueSchema = enum_(keys3(union3));
  const baseSchema = {
    parse: (raw, opts) => {
      return transformAndValidateUnion({
        value: raw,
        discriminant: rawDiscriminant,
        transformedDiscriminant: parsedDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.parse(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.parse(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return transformAndValidateUnion({
        value: parsed,
        discriminant: parsedDiscriminant,
        transformedDiscriminant: rawDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.json(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.json(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType.UNION
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema),
    ...getObjectLikeUtils(baseSchema)
  };
}
function transformAndValidateUnion({ value, discriminant: discriminant3, transformedDiscriminant, transformDiscriminantValue, getAdditionalPropertiesSchema, allowUnrecognizedUnionMembers = false, transformAdditionalProperties, breadcrumbsPrefix = [] }) {
  if (!isPlainObject3(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "object")
        }
      ]
    };
  }
  const { [discriminant3]: discriminantValue, ...additionalProperties } = value;
  if (discriminantValue == null) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: `Missing discriminant ("${discriminant3}")`
        }
      ]
    };
  }
  const transformedDiscriminantValue = transformDiscriminantValue(discriminantValue);
  if (!transformedDiscriminantValue.ok) {
    return {
      ok: false,
      errors: transformedDiscriminantValue.errors
    };
  }
  const additionalPropertiesSchema = getAdditionalPropertiesSchema(transformedDiscriminantValue.value);
  if (additionalPropertiesSchema == null) {
    if (allowUnrecognizedUnionMembers) {
      return {
        ok: true,
        value: {
          [transformedDiscriminant]: transformedDiscriminantValue.value,
          ...additionalProperties
        }
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: [...breadcrumbsPrefix, discriminant3],
            message: "Unexpected discriminant value"
          }
        ]
      };
    }
  }
  const transformedAdditionalProperties = transformAdditionalProperties(additionalProperties, additionalPropertiesSchema);
  if (!transformedAdditionalProperties.ok) {
    return transformedAdditionalProperties;
  }
  return {
    ok: true,
    value: {
      [transformedDiscriminant]: discriminantValue,
      ...transformedAdditionalProperties.value
    }
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthAccessTokenRequestPropertiesSchema.js
var OAuthAccessTokenRequestPropertiesSchema = schemas_exports.object({
  "client-id": schemas_exports.string().optional(),
  "client-secret": schemas_exports.string().optional(),
  scopes: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthAccessTokenResponsePropertiesSchema.js
var OAuthAccessTokenResponsePropertiesSchema = schemas_exports.object({
  "access-token": schemas_exports.string().optional(),
  "expires-in": schemas_exports.string().optional(),
  "refresh-token": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthGetTokenEndpointSchema.js
var OAuthGetTokenEndpointSchema = schemas_exports.object({
  endpoint: schemas_exports.string(),
  "request-properties": OAuthAccessTokenRequestPropertiesSchema.optional(),
  "response-properties": OAuthAccessTokenResponsePropertiesSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthRefreshTokenRequestPropertiesSchema.js
var OAuthRefreshTokenRequestPropertiesSchema = schemas_exports.object({
  "refresh-token": schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthRefreshTokenResponsePropertiesSchema.js
var OAuthRefreshTokenResponsePropertiesSchema = schemas_exports.object({
  "access-token": schemas_exports.string().optional(),
  "expires-in": schemas_exports.string().optional(),
  "refresh-token": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthRefreshTokenEndpointSchema.js
var OAuthRefreshTokenEndpointSchema = schemas_exports.object({
  endpoint: schemas_exports.string(),
  "request-properties": OAuthRefreshTokenRequestPropertiesSchema.optional(),
  "response-properties": OAuthRefreshTokenResponsePropertiesSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithDocsSchema.js
var WithDocsSchema = schemas_exports.object({
  docs: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthSchemeSchema.js
var OAuthSchemeSchema = schemas_exports.object({
  scheme: schemas_exports.stringLiteral("oauth"),
  type: schemas_exports.stringLiteral("client-credentials"),
  scopes: schemas_exports.list(schemas_exports.string()).optional(),
  "client-id-env": schemas_exports.string().optional(),
  "client-secret-env": schemas_exports.string().optional(),
  "token-prefix": schemas_exports.string().optional(),
  "token-header": schemas_exports.string().optional(),
  "get-token": OAuthGetTokenEndpointSchema,
  "refresh-token": OAuthRefreshTokenEndpointSchema.optional()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/WithEnvironmentVariable.js
var WithEnvironmentVariable = schemas_exports.object({
  env: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithName.js
var WithName = schemas_exports.object({
  name: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/HeaderAuthSchemeSchema.js
var HeaderAuthSchemeSchema = schemas_exports.object({
  header: schemas_exports.string(),
  type: schemas_exports.string().optional(),
  prefix: schemas_exports.string().optional()
}).extend(WithEnvironmentVariable).extend(WithName).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AuthVariable.js
var AuthVariable = schemas_exports.object({}).extend(WithEnvironmentVariable).extend(WithName);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/BasicAuthSchemeSchema.js
var BasicAuthSchemeSchema = schemas_exports.object({
  scheme: schemas_exports.stringLiteral("basic"),
  username: AuthVariable.optional(),
  password: AuthVariable.optional()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/BearerAuthSchemeSchema.js
var BearerAuthSchemeSchema = schemas_exports.object({
  scheme: schemas_exports.stringLiteral("bearer"),
  token: AuthVariable.optional()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AuthSchemeDeclarationSchema.js
var AuthSchemeDeclarationSchema = schemas_exports.undiscriminatedUnion([
  OAuthSchemeSchema,
  HeaderAuthSchemeSchema,
  BasicAuthSchemeSchema,
  BearerAuthSchemeSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionPathSchema.js
var ApiDefinitionPathSchema = schemas_exports.string();

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/UnionSettingsSchema.js
var UnionSettingsSchema2 = schemas_exports.enum_(["v1"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/MessageNamingSettingsSchema.js
var MessageNamingSettingsSchema2 = schemas_exports.enum_(["v1", "v2"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionSettingsSchema.js
var ApiDefinitionSettingsSchema = schemas_exports.object({
  "use-title": schemas_exports.boolean().optional(),
  unions: UnionSettingsSchema2.optional(),
  "message-naming": MessageNamingSettingsSchema2.optional(),
  "only-include-referenced-schemas": schemas_exports.boolean().optional(),
  "inline-path-parameters": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionWithOverridesSchema.js
var ApiDefinitionWithOverridesSchema = schemas_exports.object({
  path: ApiDefinitionPathSchema,
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  audiences: schemas_exports.list(schemas_exports.string()).optional(),
  settings: ApiDefinitionSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ProtobufDefinitionSchema.js
var ProtobufDefinitionSchema = schemas_exports.object({
  root: schemas_exports.string(),
  target: schemas_exports.string(),
  overrides: schemas_exports.string().optional(),
  "local-generation": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ProtobufApiDefinitionSchema.js
var ProtobufApiDefinitionSchema = schemas_exports.object({
  proto: ProtobufDefinitionSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionSchema.js
var ApiDefinitionSchema = schemas_exports.undiscriminatedUnion([
  ApiDefinitionPathSchema,
  ApiDefinitionWithOverridesSchema,
  ProtobufApiDefinitionSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionList.js
var ApiDefinitionList = schemas_exports.list(ApiDefinitionSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationSchemaInternal.js
var ApiConfigurationSchemaInternal = schemas_exports.undiscriminatedUnion([
  ApiDefinitionPathSchema,
  ApiDefinitionWithOverridesSchema,
  ApiDefinitionList,
  ProtobufApiDefinitionSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/NamespacedApiConfigurationSchema.js
var NamespacedApiConfigurationSchema = schemas_exports.object({
  namespaces: schemas_exports.record(schemas_exports.string(), ApiConfigurationSchemaInternal)
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AuthSchemeReferenceSchema.js
var AuthSchemeReferenceSchema = schemas_exports.object({
  scheme: schemas_exports.string()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AnyAuthItem.js
var AnyAuthItem = schemas_exports.undiscriminatedUnion([schemas_exports.string(), AuthSchemeReferenceSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AnyAuthSchemesSchema.js
var AnyAuthSchemesSchema = schemas_exports.object({
  any: schemas_exports.list(AnyAuthItem)
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/ApiAuthSchema.js
var ApiAuthSchema = schemas_exports.undiscriminatedUnion([
  schemas_exports.string(),
  AuthSchemeReferenceSchema,
  AnyAuthSchemesSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OpenApiSettingsSchema.js
var OpenApiSettingsSchema = schemas_exports.object({
  "title-as-schema-name": schemas_exports.boolean().optional(),
  "optional-additional-properties": schemas_exports.boolean().optional(),
  "coerce-enums-to-literals": schemas_exports.boolean().optional(),
  "object-query-parameters": schemas_exports.boolean().optional(),
  "respect-readonly-schemas": schemas_exports.boolean().optional(),
  "only-include-referenced-schemas": schemas_exports.boolean().optional(),
  "inline-path-parameters": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OpenApiSpecSchema.js
var OpenApiSpecSchema = schemas_exports.object({
  openapi: schemas_exports.string(),
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  namespace: schemas_exports.string().optional(),
  settings: OpenApiSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/AsyncApiSettingsSchema.js
var AsyncApiSettingsSchema = schemas_exports.object({
  "title-as-schema-name": schemas_exports.boolean().optional(),
  "optional-additional-properties": schemas_exports.boolean().optional(),
  "coerce-enums-to-literals": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/AsyncApiSchema.js
var AsyncApiSchema = schemas_exports.object({
  asyncapi: schemas_exports.string(),
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  namespace: schemas_exports.string().optional(),
  settings: AsyncApiSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/AsyncApiOrOpenApiSpecSchema.js
var AsyncApiOrOpenApiSpecSchema = schemas_exports.undiscriminatedUnion([OpenApiSpecSchema, AsyncApiSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ConjureSchema.js
var ConjureSchema = schemas_exports.object({
  conjure: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationV2SpecsSchema.js
var ApiConfigurationV2SpecsSchema = schemas_exports.undiscriminatedUnion([schemas_exports.list(AsyncApiOrOpenApiSpecSchema), ConjureSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/encoding/types/ProtobufTypeSchema.js
var ProtobufTypeSchema = schemas_exports.object({
  type: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/encoding/types/EncodingSchema.js
var EncodingSchema = schemas_exports.object({
  proto: ProtobufTypeSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/types/StringValidationSchema.js
var StringValidationSchema = schemas_exports.object({
  minLength: schemas_exports.number().optional(),
  maxLength: schemas_exports.number().optional(),
  pattern: schemas_exports.string().optional(),
  format: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/types/NumberValidationSchema.js
var NumberValidationSchema = schemas_exports.object({
  min: schemas_exports.number().optional(),
  max: schemas_exports.number().optional(),
  exclusiveMin: schemas_exports.boolean().optional(),
  exclusiveMax: schemas_exports.boolean().optional(),
  multipleOf: schemas_exports.number().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/types/ValidationSchema.js
var ValidationSchema = schemas_exports.undiscriminatedUnion([StringValidationSchema, NumberValidationSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema2 = schemas_exports.enum_(["in-development", "pre-release", "deprecated", "generally-available"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/types/AvailabilitySchema.js
var AvailabilitySchema = schemas_exports.object({
  status: AvailabilityStatusSchema2,
  message: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/types/AvailabilityUnionSchema.js
var AvailabilityUnionSchema = schemas_exports.undiscriminatedUnion([AvailabilityStatusSchema2, AvailabilitySchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithAvailability.js
var WithAvailability = schemas_exports.object({
  availability: AvailabilityUnionSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/types/types/BaseTypeReferenceSchema.js
var BaseTypeReferenceSchema = schemas_exports.object({
  default: schemas_exports.unknown().optional(),
  encoding: EncodingSchema.optional(),
  validation: ValidationSchema.optional()
}).extend(WithDocsSchema).extend(WithAvailability);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithAudiences.js
var WithAudiences = schemas_exports.object({
  audiences: schemas_exports.list(schemas_exports.string()).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/types/types/TypeReferenceDeclarationWithName.js
var TypeReferenceDeclarationWithName = schemas_exports.object({
  type: schemas_exports.string()
}).extend(BaseTypeReferenceSchema).extend(WithName).extend(WithAudiences);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/types/TypeReferenceDeclarationWithEnvOverrideSchema.js
var TypeReferenceDeclarationWithEnvOverrideSchema = schemas_exports.object({
  env: schemas_exports.string().optional()
}).extend(TypeReferenceDeclarationWithName);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/types/TypeReferenceDeclarationWithEnvOverride.js
var TypeReferenceDeclarationWithEnvOverride = schemas_exports.undiscriminatedUnion([
  schemas_exports.string(),
  TypeReferenceDeclarationWithEnvOverrideSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/types/HttpHeaderSchema.js
var HttpHeaderSchema = TypeReferenceDeclarationWithEnvOverride;

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/file/types/WithHeadersSchema.js
var WithHeadersSchema = schemas_exports.object({
  headers: schemas_exports.record(schemas_exports.string(), HttpHeaderSchema).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/SingleBaseUrlEnvironmentSchema.js
var SingleBaseUrlEnvironmentSchema = schemas_exports.object({
  url: schemas_exports.string()
}).extend(WithAudiences).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/MultipleBaseUrlsEnvironmentSchema.js
var MultipleBaseUrlsEnvironmentSchema = schemas_exports.object({
  urls: schemas_exports.record(schemas_exports.string(), schemas_exports.string())
}).extend(WithAudiences).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/EnvironmentSchema.js
var EnvironmentSchema = schemas_exports.undiscriminatedUnion([
  schemas_exports.string(),
  SingleBaseUrlEnvironmentSchema,
  MultipleBaseUrlsEnvironmentSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/WithEnvironmentsSchema.js
var WithEnvironmentsSchema = schemas_exports.object({
  "default-url": schemas_exports.string().optional(),
  "default-environment": schemas_exports.string().optional(),
  environments: schemas_exports.record(schemas_exports.string(), EnvironmentSchema).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationV2Schema.js
var ApiConfigurationV2Schema = schemas_exports.object({
  auth: ApiAuthSchema.optional(),
  specs: ApiConfigurationV2SpecsSchema
}).extend(WithHeadersSchema).extend(WithEnvironmentsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationSchema.js
var ApiConfigurationSchema = schemas_exports.undiscriminatedUnion([
  ApiConfigurationSchemaInternal,
  NamespacedApiConfigurationSchema,
  ApiConfigurationV2Schema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/WhitelabelGithubConfigurationSchema.js
var WhitelabelGithubConfigurationSchema = schemas_exports.object({
  username: schemas_exports.string(),
  email: schemas_exports.string(),
  token: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/WhitelabelConfigurationSchema.js
var WhitelabelConfigurationSchema = schemas_exports.object({
  github: WhitelabelGithubConfigurationSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OutputMetadataAuthor.js
var OutputMetadataAuthor = schemas_exports.object({
  name: schemas_exports.string(),
  email: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OutputMetadataSchema.js
var OutputMetadataSchema = schemas_exports.object({
  description: schemas_exports.string().optional(),
  authors: schemas_exports.list(OutputMetadataAuthor).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ReadmeEndpointObjectSchema.js
var ReadmeEndpointObjectSchema = schemas_exports.object({
  method: schemas_exports.string(),
  path: schemas_exports.string(),
  stream: schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ReadmeEndpointSchema.js
var ReadmeEndpointSchema = schemas_exports.undiscriminatedUnion([schemas_exports.string(), ReadmeEndpointObjectSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ReadmeSchema.js
var ReadmeSchema = schemas_exports.object({
  bannerLink: schemas_exports.string().optional(),
  introduction: schemas_exports.string().optional(),
  apiReferenceLink: schemas_exports.string().optional(),
  defaultEndpoint: ReadmeEndpointSchema.optional(),
  features: schemas_exports.record(schemas_exports.string(), schemas_exports.list(ReadmeEndpointSchema)).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/NpmOutputLocationSchema.js
var NpmOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  token: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/MavenOutputSignatureSchema.js
var MavenOutputSignatureSchema = schemas_exports.object({
  keyId: schemas_exports.string(),
  password: schemas_exports.string(),
  secretKey: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/MavenOutputLocationSchema.js
var MavenOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  coordinate: schemas_exports.string(),
  username: schemas_exports.string().optional(),
  password: schemas_exports.string().optional(),
  signature: MavenOutputSignatureSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/PypiOutputMetadataSchema.js
var PypiOutputMetadataSchema = schemas_exports.object({
  keywords: schemas_exports.list(schemas_exports.string()).optional(),
  "documentation-link": schemas_exports.string().optional(),
  "homepage-link": schemas_exports.string().optional()
}).extend(OutputMetadataSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/PypiOutputLocationSchema.js
var PypiOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  token: schemas_exports.string().optional(),
  username: schemas_exports.string().optional(),
  password: schemas_exports.string().optional(),
  metadata: PypiOutputMetadataSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/PostmanOutputLocationSchema.js
var PostmanOutputLocationSchema = schemas_exports.object({
  "api-key": schemas_exports.string(),
  "workspace-id": schemas_exports.string(),
  "collection-id": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/LocalFileSystemOutputLocationSchema.js
var LocalFileSystemOutputLocationSchema = schemas_exports.object({
  path: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/NugetOutputLocationSchema.js
var NugetOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  "api-key": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/RubyGemsOutputLocationSchema.js
var RubyGemsOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  "api-key": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorOutputSchema.js
var GeneratorOutputSchema = schemas_exports.union("location", {
  npm: NpmOutputLocationSchema,
  maven: MavenOutputLocationSchema,
  pypi: PypiOutputLocationSchema,
  postman: PostmanOutputLocationSchema,
  "local-file-system": LocalFileSystemOutputLocationSchema,
  nuget: NugetOutputLocationSchema,
  rubygems: RubyGemsOutputLocationSchema
}).transform({
  transform: (value) => value,
  untransform: (value) => value
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/types/GithubLicenseType.js
var GithubLicenseType2 = schemas_exports.enum_(["MIT", "Apache-2.0"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/types/GithubLicenseCustomSchema.js
var GithubLicenseCustomSchema = schemas_exports.object({
  custom: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/types/GithubLicenseSchema.js
var GithubLicenseSchema = schemas_exports.undiscriminatedUnion([GithubLicenseType2, GithubLicenseCustomSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubCommitAndReleaseMode.js
var GithubCommitAndReleaseMode2 = schemas_exports.enum_(["commit", "release"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubCommitAndReleaseSchema.js
var GithubCommitAndReleaseSchema = schemas_exports.object({
  repository: schemas_exports.string(),
  license: GithubLicenseSchema.optional(),
  mode: GithubCommitAndReleaseMode2.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/reviewers/types/ReviewerSchema.js
var ReviewerSchema = schemas_exports.object({
  name: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/reviewers/types/ReviewersSchema.js
var ReviewersSchema = schemas_exports.object({
  teams: schemas_exports.list(ReviewerSchema).optional(),
  users: schemas_exports.list(ReviewerSchema).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubPullRequestSchema.js
var GithubPullRequestSchema = schemas_exports.object({
  repository: schemas_exports.string(),
  branch: schemas_exports.string().optional(),
  license: GithubLicenseSchema.optional(),
  mode: schemas_exports.stringLiteral("pull-request"),
  reviewers: ReviewersSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubPushSchema.js
var GithubPushSchema = schemas_exports.object({
  repository: schemas_exports.string(),
  license: GithubLicenseSchema.optional(),
  mode: schemas_exports.stringLiteral("push"),
  branch: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubConfigurationSchema.js
var GithubConfigurationSchema = schemas_exports.undiscriminatedUnion([GithubCommitAndReleaseSchema, GithubPullRequestSchema, GithubPushSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorPublishMetadataSchema.js
var GeneratorPublishMetadataSchema = schemas_exports.object({
  "package-description": schemas_exports.string().optional(),
  email: schemas_exports.string().optional(),
  "reference-url": schemas_exports.string().optional(),
  author: schemas_exports.string().optional(),
  license: GithubLicenseSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorSnippetsSchema.js
var GeneratorSnippetsSchema = schemas_exports.object({
  path: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorApiSettingsSchema.js
var GeneratorApiSettingsSchema = schemas_exports.object({
  settings: ApiDefinitionSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorInvocationSchema.js
var GeneratorInvocationSchema = schemas_exports.object({
  name: schemas_exports.string(),
  version: schemas_exports.string(),
  output: GeneratorOutputSchema.optional(),
  github: GithubConfigurationSchema.optional(),
  config: schemas_exports.unknown(),
  metadata: GeneratorPublishMetadataSchema.optional(),
  keywords: schemas_exports.list(schemas_exports.string()).optional(),
  snippets: GeneratorSnippetsSchema.optional(),
  "ir-version": schemas_exports.string().optional(),
  "smart-casing": schemas_exports.boolean().optional(),
  api: GeneratorApiSettingsSchema.optional(),
  "disable-examples": schemas_exports.boolean().optional(),
  "publish-metadata": GeneratorPublishMetadataSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorGroupSchema.js
var GeneratorGroupSchema = schemas_exports.object({
  audiences: schemas_exports.list(schemas_exports.string()).optional(),
  generators: schemas_exports.list(GeneratorInvocationSchema),
  metadata: OutputMetadataSchema.optional(),
  reviewers: ReviewersSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/GeneratorsOpenApiObjectSchema.js
var GeneratorsOpenApiObjectSchema = schemas_exports.object({
  path: schemas_exports.string(),
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  "disable-examples": schemas_exports.boolean().optional(),
  settings: ApiDefinitionSettingsSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/GeneratorsOpenApiSchema.js
var GeneratorsOpenApiSchema = schemas_exports.undiscriminatedUnion([GeneratorsOpenApiObjectSchema, schemas_exports.string()]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/GeneratorsConfigurationSchema.js
var GeneratorsConfigurationSchema = schemas_exports.object({
  "auth-schemes": schemas_exports.record(schemas_exports.string(), AuthSchemeDeclarationSchema).optional(),
  api: ApiConfigurationSchema.optional(),
  whitelabel: WhitelabelConfigurationSchema.optional(),
  metadata: OutputMetadataSchema.optional(),
  readme: ReadmeSchema.optional(),
  "default-group": schemas_exports.string().optional(),
  groups: schemas_exports.record(schemas_exports.string(), GeneratorGroupSchema).optional(),
  reviewers: ReviewersSchema.optional(),
  openapi: GeneratorsOpenApiSchema.optional(),
  "openapi-overrides": schemas_exports.string().optional(),
  "spec-origin": schemas_exports.string().optional(),
  "async-api": schemas_exports.string().optional(),
  "api-settings": ApiDefinitionSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/index.js
var group_exports2 = {};
__export(group_exports2, {
  GeneratorApiSettingsSchema: () => GeneratorApiSettingsSchema,
  GeneratorGroupSchema: () => GeneratorGroupSchema,
  GeneratorInvocationSchema: () => GeneratorInvocationSchema,
  GeneratorOutputSchema: () => GeneratorOutputSchema,
  GeneratorPublishMetadataSchema: () => GeneratorPublishMetadataSchema,
  GeneratorSnippetsSchema: () => GeneratorSnippetsSchema,
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode2,
  GithubCommitAndReleaseSchema: () => GithubCommitAndReleaseSchema,
  GithubConfigurationSchema: () => GithubConfigurationSchema,
  GithubPullRequestSchema: () => GithubPullRequestSchema,
  GithubPushSchema: () => GithubPushSchema,
  LocalFileSystemOutputLocationSchema: () => LocalFileSystemOutputLocationSchema,
  MavenOutputLocationSchema: () => MavenOutputLocationSchema,
  MavenOutputSignatureSchema: () => MavenOutputSignatureSchema,
  NpmOutputLocationSchema: () => NpmOutputLocationSchema,
  NugetOutputLocationSchema: () => NugetOutputLocationSchema,
  PostmanOutputLocationSchema: () => PostmanOutputLocationSchema,
  PypiOutputLocationSchema: () => PypiOutputLocationSchema,
  PypiOutputMetadataSchema: () => PypiOutputMetadataSchema,
  RubyGemsOutputLocationSchema: () => RubyGemsOutputLocationSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/index.js
var license_exports2 = {};
__export(license_exports2, {
  GithubLicenseCustomSchema: () => GithubLicenseCustomSchema,
  GithubLicenseSchema: () => GithubLicenseSchema,
  GithubLicenseType: () => GithubLicenseType2
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/reviewers/index.js
var reviewers_exports2 = {};
__export(reviewers_exports2, {
  ReviewerSchema: () => ReviewerSchema,
  ReviewersSchema: () => ReviewersSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/index.js
var fernDefinition_exports2 = {};
__export(fernDefinition_exports2, {
  AnyAuthItem: () => AnyAuthItem,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema,
  ApiAuthSchema: () => ApiAuthSchema,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema,
  AuthVariable: () => AuthVariable,
  AvailabilitySchema: () => AvailabilitySchema,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema2,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema,
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema,
  EncodingSchema: () => EncodingSchema,
  EnvironmentSchema: () => EnvironmentSchema,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema,
  HttpHeaderSchema: () => HttpHeaderSchema,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema,
  NumberValidationSchema: () => NumberValidationSchema,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema,
  OAuthSchemeSchema: () => OAuthSchemeSchema,
  ProtobufTypeSchema: () => ProtobufTypeSchema,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema,
  StringValidationSchema: () => StringValidationSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName,
  ValidationSchema: () => ValidationSchema,
  WithAudiences: () => WithAudiences,
  WithAvailability: () => WithAvailability,
  WithDocsSchema: () => WithDocsSchema,
  WithEnvironmentVariable: () => WithEnvironmentVariable,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema,
  WithHeadersSchema: () => WithHeadersSchema,
  WithName: () => WithName,
  auth: () => auth_exports2,
  availability: () => availability_exports2,
  commons: () => commons_exports2,
  encoding: () => encoding_exports2,
  environments: () => environments_exports2,
  file: () => file_exports2,
  service: () => service_exports2,
  types: () => types_exports2,
  validation: () => validation_exports2
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/index.js
var auth_exports2 = {};
__export(auth_exports2, {
  AnyAuthItem: () => AnyAuthItem,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema,
  ApiAuthSchema: () => ApiAuthSchema,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema,
  AuthVariable: () => AuthVariable,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema,
  OAuthSchemeSchema: () => OAuthSchemeSchema,
  WithEnvironmentVariable: () => WithEnvironmentVariable
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/index.js
var availability_exports2 = {};
__export(availability_exports2, {
  AvailabilitySchema: () => AvailabilitySchema,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema2,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/index.js
var commons_exports2 = {};
__export(commons_exports2, {
  WithAudiences: () => WithAudiences,
  WithAvailability: () => WithAvailability,
  WithDocsSchema: () => WithDocsSchema,
  WithName: () => WithName
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/encoding/index.js
var encoding_exports2 = {};
__export(encoding_exports2, {
  EncodingSchema: () => EncodingSchema,
  ProtobufTypeSchema: () => ProtobufTypeSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/index.js
var environments_exports2 = {};
__export(environments_exports2, {
  EnvironmentSchema: () => EnvironmentSchema,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/file/index.js
var file_exports2 = {};
__export(file_exports2, {
  WithHeadersSchema: () => WithHeadersSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/index.js
var service_exports2 = {};
__export(service_exports2, {
  HttpHeaderSchema: () => HttpHeaderSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/types/index.js
var types_exports2 = {};
__export(types_exports2, {
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/index.js
var validation_exports2 = {};
__export(validation_exports2, {
  NumberValidationSchema: () => NumberValidationSchema,
  StringValidationSchema: () => StringValidationSchema,
  ValidationSchema: () => ValidationSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/index.js
var API_ORIGIN_LOCATION_KEY = "spec-origin";
var ASYNC_API_LOCATION_KEY = "async-api";
var DEFAULT_GROUP_GENERATORS_CONFIG_KEY = "default-group";
var OPENAPI_LOCATION_KEY = "openapi";
var OPENAPI_OVERRIDES_LOCATION_KEY = "openapi-overrides";
var API_SETTINGS_KEY = "api-settings";

// ../../cli/configuration/lib/generators-yml/GeneratorsConfiguration.js
var GenerationLanguage = {
  TYPESCRIPT: "typescript",
  JAVA: "java",
  PYTHON: "python",
  GO: "go",
  RUBY: "ruby",
  CSHARP: "csharp",
  SWIFT: "swift",
  PHP: "php"
};
function getPackageName({ generatorInvocation }) {
  return generatorInvocation.outputMode._visit({
    downloadFiles: () => void 0,
    github: (val) => val.publishInfo?._visit({
      maven: (val2) => val2.coordinate,
      npm: (val2) => val2.packageName,
      pypi: (val2) => val2.packageName,
      postman: () => void 0,
      rubygems: (val2) => val2.packageName,
      nuget: (val2) => val2.packageName,
      _other: () => void 0
    }),
    githubV2: (val) => val.publishInfo?._visit({
      maven: (val2) => val2.coordinate,
      npm: (val2) => val2.packageName,
      pypi: (val2) => val2.packageName,
      postman: () => void 0,
      rubygems: (val2) => val2.packageName,
      nuget: (val2) => val2.packageName,
      _other: () => void 0
    }),
    publish: () => void 0,
    publishV2: () => void 0,
    _other: () => void 0
  });
}

// ../../cli/configuration/lib/generators-yml/isRawProtobufAPIDefinitionSchema.js
function isRawProtobufAPIDefinitionSchema(rawApiConfiguration) {
  return typeof rawApiConfiguration !== "string" && "proto" in rawApiConfiguration;
}

// ../../cli/generation/ir-generator/lib/casings/reserved.js
var RESERVED_KEYWORDS = {
  [generators_yml_exports.GenerationLanguage.PHP]: new Set([
    "abstract",
    "and",
    "as",
    "break",
    "callable",
    "case",
    "catch",
    "class",
    "clone",
    "const",
    "continue",
    "declare",
    "default",
    "do",
    "echo",
    "else",
    "elseif",
    "enddeclare",
    "endfor",
    "endforeach",
    "endif",
    "endswitch",
    "endwhile",
    "extends",
    "final",
    "finally",
    "fn",
    "for",
    "foreach",
    "function",
    "global",
    "goto",
    "list",
    "if",
    "implements",
    "include",
    "include_once",
    "instanceof",
    "insteadof",
    "interface",
    "match",
    "namespace",
    "new",
    "or",
    "parent",
    "Parent",
    "print",
    "private",
    "protected",
    "public",
    "readonly",
    "require",
    "require_once",
    "return",
    "static",
    "switch",
    "throw",
    "trait",
    "try",
    "use",
    "var",
    "while",
    "xor",
    "yield"
  ].flatMap((str2) => [str2, upperFirst_default(str2)])),
  [generators_yml_exports.GenerationLanguage.TYPESCRIPT]: /* @__PURE__ */ new Set([
    "any",
    "as",
    "boolean",
    "break",
    "case",
    "catch",
    "class",
    "const",
    "constructor",
    "continue",
    "debugger",
    "declare",
    "default",
    "delete",
    "do",
    "else",
    "enum",
    "export",
    "extends",
    "false",
    "finally",
    "for",
    "from",
    "function",
    "get",
    "if",
    "implements",
    "import",
    "in",
    "instanceof",
    "interface",
    "let",
    "module",
    "new",
    "null",
    "number",
    "of",
    "package",
    "private",
    "protected",
    "public",
    "require",
    "return",
    "set",
    "static",
    "string",
    "super",
    "switch",
    "symbol",
    "this",
    "throw",
    "true",
    "try",
    "type",
    "typeof",
    "var",
    "void",
    "while",
    "with",
    "yield",
    "Date",
    "Error",
    "File",
    "Object",
    "Record"
  ]),
  [generators_yml_exports.GenerationLanguage.JAVA]: /* @__PURE__ */ new Set([
    "abstract",
    "assert",
    "boolean",
    "break",
    "byte",
    "case",
    "catch",
    "char",
    "class",
    "const",
    "continue",
    "default",
    "do",
    "double",
    "else",
    "enum",
    "extends",
    "final",
    "finally",
    "float",
    "for",
    "goto",
    "if",
    "implements",
    "import",
    "instanceof",
    "int",
    "interface",
    "long",
    "native",
    "new",
    "null",
    "package",
    "private",
    "protected",
    "public",
    "return",
    "short",
    "static",
    "strictfp",
    "super",
    "switch",
    "synchronized",
    "this",
    "throw",
    "throws",
    "transient",
    "try",
    "void",
    "volatile",
    "while"
  ]),
  [generators_yml_exports.GenerationLanguage.PYTHON]: /* @__PURE__ */ new Set([
    "False",
    "None",
    "True",
    "and",
    "as",
    "assert",
    "async",
    "await",
    "break",
    "class",
    "continue",
    "def",
    "del",
    "elif",
    "else",
    "except",
    "finally",
    "for",
    "from",
    "global",
    "if",
    "import",
    "in",
    "is",
    "lambda",
    "nonlocal",
    "not",
    "or",
    "pass",
    "raise",
    "return",
    "try",
    "while",
    "with",
    "yield",
    "float",
    "int",
    "complex",
    "bool",
    "uuid",
    "list",
    "set",
    "map",
    "long",
    // the following aren't actually reserved, but we treat them as unavailable
    "self",
    "all"
  ]),
  [generators_yml_exports.GenerationLanguage.GO]: /* @__PURE__ */ new Set([
    // Keywords - these are not allowed. https://go.dev/ref/spec#Keywords
    "break",
    "case",
    "chan",
    "const",
    "continue",
    "default",
    "defer",
    "else",
    "fallthrough",
    "for",
    "func",
    "go",
    "goto",
    "if",
    "import",
    "interface",
    "map",
    "package",
    "range",
    "return",
    "select",
    "struct",
    "switch",
    "type",
    "var",
    // Technically allowed as identifiers, but should be avoided.
    "any",
    "bool",
    "byte",
    "complex64",
    "complex128",
    "error",
    "float32",
    "float64",
    "int",
    "int8",
    "int16",
    "int32",
    "int64",
    "make",
    "new",
    "rune",
    "string",
    "uint",
    "uint8",
    "uint16",
    "uint32",
    "uint64",
    "uintptr"
  ]),
  [generators_yml_exports.GenerationLanguage.RUBY]: /* @__PURE__ */ new Set([
    // https://docs.ruby-lang.org/en/2.2.0/keywords_rdoc.html
    "__ENCODING__",
    "__LINE__",
    "__FILE__",
    "alias",
    "and",
    "begin",
    "break",
    "case",
    "class",
    "def",
    "defined",
    "do",
    "else",
    "elsif",
    "end",
    "ensure",
    "false",
    "for",
    "if",
    "in",
    "module",
    "next",
    "nil",
    "not",
    "or",
    "redo",
    "rescue",
    "retry",
    "return",
    "self",
    "super",
    "then",
    "true",
    "undef",
    "unless",
    "until",
    "when",
    "while",
    "yield",
    "Object",
    "JSON",
    "Date",
    "DateTime"
  ]),
  [generators_yml_exports.GenerationLanguage.CSHARP]: /* @__PURE__ */ new Set([
    "abstract",
    "as",
    "base",
    "bool",
    "break",
    "byte",
    "case",
    "catch",
    "char",
    "checked",
    "class",
    "const",
    "continue",
    "decimal",
    "default",
    "delegate",
    "do",
    "double",
    "else",
    "enum",
    "event",
    "explicit",
    "extern",
    "false",
    "finally",
    "fixed",
    "float",
    "for",
    "foreach",
    "goto",
    "if",
    "implicit",
    "in",
    "int",
    "interface",
    "internal",
    "is",
    "lock",
    "long",
    "namespace",
    "new",
    "null",
    "object",
    "operator",
    "out",
    "override",
    "params",
    "private",
    "protected",
    "public",
    "readonly",
    "ref",
    "return",
    "sbyte",
    "sealed",
    "short",
    "sizeof",
    "stackalloc",
    "static",
    "string",
    "struct",
    "switch",
    "this",
    "throw",
    "true",
    "try",
    "typeof",
    "uint",
    "ulong",
    "unchecked",
    "unsafe",
    "ushort",
    "using",
    "virtual",
    "void",
    "volatile",
    "while",
    "add",
    "and",
    "alias",
    "ascending",
    "args",
    "async",
    "await",
    "by",
    "descending",
    "dynamic",
    "equals",
    "file",
    "from",
    "get",
    "global",
    "group",
    "init",
    "into",
    "join",
    "let",
    "managed",
    "nameof",
    "nint",
    "not",
    "notnull",
    "nuint",
    "on",
    "or",
    "orderby",
    "partial",
    "record",
    "remove",
    "required",
    "scoped",
    "select",
    "set",
    "unmanaged",
    "value",
    "var",
    "when",
    "where",
    "with",
    "yield"
  ]),
  // TODO(mikemilla): add reserved keywords for Swift
  [generators_yml_exports.GenerationLanguage.SWIFT]: /* @__PURE__ */ new Set([])
};

// ../../cli/generation/ir-generator/lib/casings/CasingsGenerator.js
var CAPITALIZE_INITIALISM = ["go", "ruby"];
function constructCasingsGenerator({ generationLanguage, keywords, smartCasing }) {
  const casingsGenerator = {
    generateName: (name, opts) => {
      const generateSafeAndUnsafeString = (unsafeString) => ({
        unsafeName: unsafeString,
        safeName: sanitizeName({
          name: unsafeString,
          keywords: getKeywords({ generationLanguage, keywords })
        })
      });
      let camelCaseName = camelCase_default(name);
      let pascalCaseName = upperFirst_default(camelCaseName);
      let snakeCaseName = snakeCase_default(name);
      const camelCaseWords = words_default(camelCaseName);
      if (smartCasing) {
        if (!hasAdjacentCommonInitialisms(camelCaseWords) && (generationLanguage == null || CAPITALIZE_INITIALISM.includes(generationLanguage))) {
          camelCaseName = camelCaseWords.map((word, index) => {
            if (index > 0) {
              const pluralInitialism = maybeGetPluralInitialism(word);
              if (pluralInitialism != null) {
                return pluralInitialism;
              }
              if (isCommonInitialism(word)) {
                return word.toUpperCase();
              }
            }
            return word;
          }).join("");
          pascalCaseName = camelCaseWords.map((word, index) => {
            const pluralInitialism = maybeGetPluralInitialism(word);
            if (pluralInitialism != null) {
              return pluralInitialism;
            }
            if (isCommonInitialism(word)) {
              return word.toUpperCase();
            }
            if (index === 0) {
              return upperFirst_default(word);
            }
            return word;
          }).join("");
        }
        snakeCaseName = name.split(" ").map((part) => part.split(/(\d+)/).map(snakeCase_default).join("")).join("_");
      }
      return {
        originalName: name,
        camelCase: generateSafeAndUnsafeString(opts?.casingOverrides?.camel ?? camelCaseName),
        snakeCase: generateSafeAndUnsafeString(opts?.casingOverrides?.snake ?? snakeCaseName),
        screamingSnakeCase: generateSafeAndUnsafeString(opts?.casingOverrides?.["screaming-snake"] ?? snakeCaseName.toUpperCase()),
        pascalCase: generateSafeAndUnsafeString(opts?.casingOverrides?.pascal ?? pascalCaseName)
      };
    },
    generateNameAndWireValue: ({ name, wireValue, opts }) => ({
      name: casingsGenerator.generateName(name, opts),
      wireValue
    })
  };
  return casingsGenerator;
}
function sanitizeName({ name, keywords }) {
  if (keywords == null) {
    return name;
  }
  if (keywords.has(name)) {
    return name + "_";
  } else if (startsWithNumber(name)) {
    return "_" + name;
  } else {
    return name;
  }
}
function getKeywords({ generationLanguage, keywords }) {
  if (keywords != null) {
    return new Set(keywords);
  }
  if (generationLanguage != null) {
    return RESERVED_KEYWORDS[generationLanguage];
  }
  return void 0;
}
var STARTS_WITH_NUMBER = /^[0-9]/;
function startsWithNumber(str2) {
  return STARTS_WITH_NUMBER.test(str2);
}
function hasAdjacentCommonInitialisms(wordList) {
  return wordList.some((word, index) => {
    if (index === 0) {
      return false;
    }
    const previousWord = wordList[index - 1];
    if (previousWord == null) {
      return false;
    }
    const previousWordIsInitialism = maybeGetPluralInitialism(previousWord) != null || isCommonInitialism(previousWord);
    const currentWordIsInitialism = maybeGetPluralInitialism(word) != null || isCommonInitialism(word);
    return previousWordIsInitialism && currentWordIsInitialism;
  });
}
function maybeGetPluralInitialism(name) {
  return PLURAL_COMMON_ITIALISMS.get(name.toUpperCase());
}
function isCommonInitialism(name) {
  return COMMON_ITIALISMS.has(name.toUpperCase());
}
var COMMON_ITIALISMS = /* @__PURE__ */ new Set([
  "ACL",
  "API",
  "ASCII",
  "CPU",
  "CSS",
  "DNS",
  "EOF",
  "GUID",
  "HTML",
  "HTTP",
  "HTTPS",
  "ID",
  "IP",
  "JSON",
  "LHS",
  "QPS",
  "RAM",
  "RHS",
  "RPC",
  "SAML",
  "SCIM",
  "SLA",
  "SMTP",
  "SQL",
  "SSH",
  "SSO",
  "TCP",
  "TLS",
  "TTL",
  "UDP",
  "UI",
  "UID",
  "UUID",
  "URI",
  "URL",
  "UTF8",
  "VM",
  "XML",
  "XMPP",
  "XSRF",
  "XSS"
]);
var PLURAL_COMMON_ITIALISMS = /* @__PURE__ */ new Map([
  ["ACLS", "ACLs"],
  ["APIS", "APIs"],
  ["CPUS", "CPUs"],
  ["GUIDS", "GUIDs"],
  ["IDS", "IDs"],
  ["UIDS", "UIDs"],
  ["UUIDS", "UUIDs"],
  ["URIS", "URIs"],
  ["URLS", "URLs"]
]);

// ../../cli/generation/ir-generator/lib/converters/services/constructHttpPath.js
function constructHttpPath(rawPath) {
  const rawPathGenerator = createStringGenerator(rawPath);
  const { value: head, done } = readUntil(rawPathGenerator, "{");
  if (done) {
    return { head, parts: [] };
  } else {
    return {
      head,
      parts: [...getAllParts(rawPathGenerator)]
    };
  }
}
function* getAllParts(rawPathGenerator) {
  let done;
  do {
    const { value: pathParameter } = readUntil(rawPathGenerator, "}");
    const untilNextOpeningBrace = readUntil(rawPathGenerator, "{");
    done = untilNextOpeningBrace.done;
    yield {
      pathParameter,
      tail: untilNextOpeningBrace.value
    };
  } while (!done);
}
function* createStringGenerator(str2) {
  for (const char of str2) {
    yield char;
  }
}
function readUntil(generator, delimiter) {
  let value = "";
  let nextResult = generator.next();
  while (nextResult.done !== true && nextResult.value !== delimiter) {
    value += nextResult.value;
    nextResult = generator.next();
  }
  return {
    value,
    done: nextResult.done ?? false
  };
}

// ../../cli/generation/ir-generator/lib/IdGenerator.js
var IdGenerator = {
  generateTypeId: (typeName) => {
    const joinedFernFilePath = stringifyFernFilepath(typeName.fernFilepath);
    return `type_${joinedFernFilePath}:${typeName.name.originalName}`;
  },
  generateErrorId: (errorName) => {
    const joinedFernFilePath = stringifyFernFilepath(errorName.fernFilepath);
    return `error_${joinedFernFilePath}:${errorName.name.originalName}`;
  },
  generateServiceId: (serviceName) => {
    const joinedFernFilePath = stringifyFernFilepath(serviceName.fernFilepath);
    return `service_${joinedFernFilePath}`;
  },
  generateServiceIdFromFernFilepath: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `service_${joinedFernFilePath}`;
  },
  generateSubpackageId: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `subpackage_${joinedFernFilePath}`;
  },
  generateEndpointId: (declaredServiceName, httpEndpoint) => {
    const joinedFernFilePath = stringifyFernFilepath(declaredServiceName.fernFilepath);
    const endpointId = httpEndpoint.name.originalName;
    return `endpoint_${joinedFernFilePath}.${endpointId}`;
  },
  generateEndpointIdFromResolvedEndpoint: (resolvedEndpoint) => {
    const joinedFernFilePath = stringifyFernFilepath(resolvedEndpoint.file.fernFilepath);
    const endpointId = resolvedEndpoint.endpointId;
    return `endpoint_${joinedFernFilePath}.${endpointId}`;
  },
  generateWebhookGroupId: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `webhooks_${joinedFernFilePath}`;
  },
  generateWebhookId: (fernFilepath, webhookId) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `webhooks_${joinedFernFilePath}.${webhookId}`;
  },
  generateWebSocketChannelId: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `channel_${joinedFernFilePath}`;
  }
};
function stringifyFernFilepath(fernFilepath) {
  return fernFilepath.allParts.map((part) => part.originalName).join("/");
}

// ../../commons/path-utils/lib/isBrowser.js
function isBrowser() {
  return typeof window !== "undefined";
}

// ../../commons/path-utils/lib/getPathModule.js
function getPathModule() {
  if (isBrowser()) {
    return {
      isAbsolute: (value) => {
        return value.startsWith("/");
      }
    };
  } else {
    return require("path");
  }
}

// ../../commons/path-utils/lib/convertToOsPath.js
function convertToOsPath(path5) {
  if (isBrowser()) {
    return path5.replace(/\\/g, "/");
  }
  if (process.platform === "win32") {
    return path5.replace(/\//g, "\\");
  } else {
    return path5.replace(/\\/g, "/");
  }
}

// ../../commons/path-utils/lib/AbsoluteFilePath.js
var path = getPathModule();
var AbsoluteFilePath = {
  of: (value) => {
    if (!path.isAbsolute(value)) {
      throw new Error("Filepath is not absolute: " + value);
    }
    return convertToOsPath(value);
  }
};

// ../../commons/path-utils/lib/RelativeFilePath.js
var path2 = getPathModule();
var RelativeFilePath = {
  of: (value) => {
    if (path2.isAbsolute(value)) {
      throw new Error("Filepath is not relative: " + value);
    }
    return convertToOsPath(value);
  }
};

// ../../commons/path-utils/lib/basename.js
function basename(path5, options) {
  const basename3 = path5.split("/").pop() ?? path5;
  if (options?.stripExtension) {
    return basename3.split(".")[0] ?? basename3;
  }
  return basename3;
}

// ../../commons/path-utils/lib/dirname.js
function dirname(filepath) {
  const trimmed = filepath.replace(/\/+$/, "");
  const lastSlashIndex = trimmed.lastIndexOf("/");
  if (lastSlashIndex === -1) {
    return ".";
  }
  if (lastSlashIndex === 0) {
    return "/";
  }
  return filepath.slice(0, lastSlashIndex);
}

// ../../commons/path-utils/lib/join.js
function join(...parts) {
  const stack = [];
  for (const part of parts.flatMap((segment) => segment.split("/")).filter(Boolean)) {
    if (part === "." || part === "") {
      continue;
    }
    if (part === "..") {
      if (stack.length > 0 && stack[stack.length - 1] !== "..") {
        stack.pop();
      } else {
        stack.push(part);
      }
    } else {
      stack.push(part);
    }
  }
  return (parts[0]?.startsWith("/") ? "/" : "") + stack.join("/");
}

// ../../commons/path-utils/lib/sep.js
var sep = "/";

// ../../commons/path-utils/lib/relative.js
function relative(from, to) {
  const fromParts = from.split(sep).filter(Boolean);
  const toParts = to.split(sep).filter(Boolean);
  let i = 0;
  while (i < fromParts.length && i < toParts.length && fromParts[i] === toParts[i]) {
    i++;
  }
  const upLevels = fromParts.length - i;
  const result = [
    ...Array(upLevels).fill(".."),
    ...toParts.slice(i)
    // Add the remaining path parts from `to`
  ];
  return result.join(sep) || ".";
}

// ../../cli/generation/ir-generator/lib/utils/convertToFernFilepath.js
function convertToFernFilepath({ relativeFilepath, casingsGenerator }) {
  const pathToPackage = dirname(relativeFilepath);
  const filename = basename(relativeFilepath, { stripExtension: true });
  const packagePath = pathToPackage === "." ? [] : pathToPackage.split(sep).map((part) => casingsGenerator.generateName(part));
  const file = filename !== FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION ? casingsGenerator.generateName(filename) : void 0;
  const allParts = [];
  allParts.push(...packagePath);
  if (file != null) {
    allParts.push(file);
  }
  return {
    allParts,
    packagePath,
    file
  };
}

// ../../cli/generation/ir-generator/lib/utils/getResolvedPathOfImportedFile.js
function getResolvedPathOfImportedFile({ referencedIn, importPath }) {
  return join(dirname(referencedIn), importPath);
}

// ../../cli/generation/ir-generator/lib/utils/parseReferenceToTypeName.js
function parseReferenceToTypeName({ reference, referencedIn, imports }) {
  const [firstPart, secondPart, ...rest] = reference.split(".");
  if (firstPart == null || rest.length > 0) {
    return void 0;
  }
  if (secondPart == null) {
    return {
      typeName: firstPart,
      relativeFilepath: referencedIn
    };
  }
  const importAlias = firstPart;
  const importPath = imports[importAlias];
  if (importPath == null) {
    return void 0;
  }
  return {
    relativeFilepath: getResolvedPathOfImportedFile({ referencedIn, importPath }),
    typeName: secondPart
  };
}

// ../../cli/generation/ir-generator/lib/utils/parseErrorName.js
function parseErrorName({ errorName, file }) {
  const reference = parseReferenceToTypeName({
    reference: errorName,
    referencedIn: file.relativeFilepath,
    imports: file.imports
  });
  if (reference == null) {
    throw new Error("Failed to locate error " + errorName);
  }
  const nameWithoutId = {
    name: file.casingsGenerator.generateName(reference.typeName),
    fernFilepath: convertToFernFilepath({
      relativeFilepath: reference.relativeFilepath,
      casingsGenerator: file.casingsGenerator
    })
  };
  return {
    ...nameWithoutId,
    errorId: IdGenerator.generateErrorId(nameWithoutId)
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertResponseErrors.js
function convertResponseErrors({ errors, file }) {
  return errors == null ? [] : Object.values(errors).map((errorReference) => {
    const referenceToError = typeof errorReference === "string" ? errorReference : errorReference.error;
    const errorName = parseErrorName({
      errorName: referenceToError,
      file
    });
    return {
      docs: typeof errorReference !== "string" ? errorReference.docs : void 0,
      error: errorName
    };
  });
}

// ../../ir-sdk/lib/sdk/api/resources/auth/types/AuthSchemesRequirement.js
var AuthSchemesRequirement = {
  All: "ALL",
  Any: "ANY",
  _visit: (value, visitor) => {
    switch (value) {
      case AuthSchemesRequirement.All:
        return visitor.all();
      case AuthSchemesRequirement.Any:
        return visitor.any();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/auth/types/AuthScheme.js
var AuthScheme = {
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function(visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function(visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function(visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  oauth: (value) => {
    return {
      ...value,
      type: "oauth",
      _visit: function(visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "bearer":
        return visitor.bearer(value);
      case "basic":
        return visitor.basic(value);
      case "header":
        return visitor.header(value);
      case "oauth":
        return visitor.oauth(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/auth/types/OAuthConfiguration.js
var OAuthConfiguration = {
  clientCredentials: (value) => {
    return {
      ...value,
      type: "clientCredentials",
      _visit: function(visitor) {
        return OAuthConfiguration._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "clientCredentials":
        return visitor.clientCredentials(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/commons/types/AvailabilityStatus.js
var AvailabilityStatus = {
  InDevelopment: "IN_DEVELOPMENT",
  PreRelease: "PRE_RELEASE",
  GeneralAvailability: "GENERAL_AVAILABILITY",
  Deprecated: "DEPRECATED",
  _visit: (value, visitor) => {
    switch (value) {
      case AvailabilityStatus.InDevelopment:
        return visitor.inDevelopment();
      case AvailabilityStatus.PreRelease:
        return visitor.preRelease();
      case AvailabilityStatus.GeneralAvailability:
        return visitor.generalAvailability();
      case AvailabilityStatus.Deprecated:
        return visitor.deprecated();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/index.js
var dynamic_exports = {};
__export(dynamic_exports, {
  Auth: () => Auth,
  AuthValues: () => AuthValues,
  ErrorSeverity: () => ErrorSeverity,
  FileUploadRequestBodyProperty: () => FileUploadRequestBodyProperty,
  InlinedRequestBody: () => InlinedRequestBody,
  LiteralType: () => LiteralType,
  NamedType: () => NamedType,
  ReferencedRequestBodyType: () => ReferencedRequestBodyType,
  Request: () => Request,
  Response: () => Response,
  SingleDiscriminatedUnionType: () => SingleDiscriminatedUnionType,
  TypeReference: () => TypeReference,
  auth: () => auth_exports3,
  declaration: () => declaration_exports,
  endpoints: () => endpoints_exports,
  ir: () => ir_exports,
  snippets: () => snippets_exports,
  types: () => types_exports3
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/auth/index.js
var auth_exports3 = {};
__export(auth_exports3, {
  Auth: () => Auth,
  AuthValues: () => AuthValues
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/auth/types/Auth.js
var Auth = {
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function(visitor) {
        return dynamic_exports.Auth._visit(this, visitor);
      }
    };
  },
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function(visitor) {
        return dynamic_exports.Auth._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function(visitor) {
        return dynamic_exports.Auth._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "basic":
        return visitor.basic(value);
      case "bearer":
        return visitor.bearer(value);
      case "header":
        return visitor.header(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/auth/types/AuthValues.js
var AuthValues = {
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function(visitor) {
        return dynamic_exports.AuthValues._visit(this, visitor);
      }
    };
  },
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function(visitor) {
        return dynamic_exports.AuthValues._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function(visitor) {
        return dynamic_exports.AuthValues._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "basic":
        return visitor.basic(value);
      case "bearer":
        return visitor.bearer(value);
      case "header":
        return visitor.header(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/declaration/index.js
var declaration_exports = {};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/index.js
var endpoints_exports = {};
__export(endpoints_exports, {
  FileUploadRequestBodyProperty: () => FileUploadRequestBodyProperty,
  InlinedRequestBody: () => InlinedRequestBody,
  ReferencedRequestBodyType: () => ReferencedRequestBodyType,
  Request: () => Request,
  Response: () => Response
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/Request.js
var Request = {
  body: (value) => {
    return {
      ...value,
      type: "body",
      _visit: function(visitor) {
        return dynamic_exports.Request._visit(this, visitor);
      }
    };
  },
  inlined: (value) => {
    return {
      ...value,
      type: "inlined",
      _visit: function(visitor) {
        return dynamic_exports.Request._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "body":
        return visitor.body(value);
      case "inlined":
        return visitor.inlined(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/Response.js
var Response = {
  json: () => {
    return {
      type: "json",
      _visit: function(visitor) {
        return dynamic_exports.Response._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/InlinedRequestBody.js
var InlinedRequestBody = {
  properties: (value) => {
    return {
      value,
      type: "properties",
      _visit: function(visitor) {
        return dynamic_exports.InlinedRequestBody._visit(this, visitor);
      }
    };
  },
  referenced: (value) => {
    return {
      ...value,
      type: "referenced",
      _visit: function(visitor) {
        return dynamic_exports.InlinedRequestBody._visit(this, visitor);
      }
    };
  },
  fileUpload: (value) => {
    return {
      ...value,
      type: "fileUpload",
      _visit: function(visitor) {
        return dynamic_exports.InlinedRequestBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "properties":
        return visitor.properties(value.value);
      case "referenced":
        return visitor.referenced(value);
      case "fileUpload":
        return visitor.fileUpload(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/ReferencedRequestBodyType.js
var ReferencedRequestBodyType = {
  bytes: () => {
    return {
      type: "bytes",
      _visit: function(visitor) {
        return dynamic_exports.ReferencedRequestBodyType._visit(this, visitor);
      }
    };
  },
  typeReference: (value) => {
    return {
      value,
      type: "typeReference",
      _visit: function(visitor) {
        return dynamic_exports.ReferencedRequestBodyType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "bytes":
        return visitor.bytes();
      case "typeReference":
        return visitor.typeReference(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/FileUploadRequestBodyProperty.js
var FileUploadRequestBodyProperty = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function(visitor) {
        return dynamic_exports.FileUploadRequestBodyProperty._visit(this, visitor);
      }
    };
  },
  fileArray: (value) => {
    return {
      ...value,
      type: "fileArray",
      _visit: function(visitor) {
        return dynamic_exports.FileUploadRequestBodyProperty._visit(this, visitor);
      }
    };
  },
  bodyProperty: (value) => {
    return {
      ...value,
      type: "bodyProperty",
      _visit: function(visitor) {
        return dynamic_exports.FileUploadRequestBodyProperty._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "fileArray":
        return visitor.fileArray(value);
      case "bodyProperty":
        return visitor.bodyProperty(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/ir/index.js
var ir_exports = {};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/snippets/index.js
var snippets_exports = {};
__export(snippets_exports, {
  ErrorSeverity: () => ErrorSeverity
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/snippets/types/ErrorSeverity.js
var ErrorSeverity = {
  Critical: "CRITICAL",
  Warning: "WARNING",
  _visit: (value, visitor) => {
    switch (value) {
      case ErrorSeverity.Critical:
        return visitor.critical();
      case ErrorSeverity.Warning:
        return visitor.warning();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/index.js
var types_exports3 = {};
__export(types_exports3, {
  LiteralType: () => LiteralType,
  NamedType: () => NamedType,
  SingleDiscriminatedUnionType: () => SingleDiscriminatedUnionType,
  TypeReference: () => TypeReference
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/NamedType.js
var NamedType = {
  alias: (value) => {
    return {
      ...value,
      type: "alias",
      _visit: function(visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function(visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  discriminatedUnion: (value) => {
    return {
      ...value,
      type: "discriminatedUnion",
      _visit: function(visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  undiscriminatedUnion: (value) => {
    return {
      ...value,
      type: "undiscriminatedUnion",
      _visit: function(visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "alias":
        return visitor.alias(value);
      case "enum":
        return visitor.enum(value);
      case "object":
        return visitor.object(value);
      case "discriminatedUnion":
        return visitor.discriminatedUnion(value);
      case "undiscriminatedUnion":
        return visitor.undiscriminatedUnion(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/TypeReference.js
var TypeReference = {
  list: (value) => {
    return {
      value,
      type: "list",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      value,
      type: "literal",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      value,
      type: "named",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      value,
      type: "optional",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  primitive: (value) => {
    return {
      value,
      type: "primitive",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  set: (value) => {
    return {
      value,
      type: "set",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  unknown: () => {
    return {
      type: "unknown",
      _visit: function(visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "list":
        return visitor.list(value.value);
      case "literal":
        return visitor.literal(value.value);
      case "map":
        return visitor.map(value);
      case "named":
        return visitor.named(value.value);
      case "optional":
        return visitor.optional(value.value);
      case "primitive":
        return visitor.primitive(value.value);
      case "set":
        return visitor.set(value.value);
      case "unknown":
        return visitor.unknown();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/SingleDiscriminatedUnionType.js
var SingleDiscriminatedUnionType = {
  samePropertiesAsObject: (value) => {
    return {
      ...value,
      type: "samePropertiesAsObject",
      _visit: function(visitor) {
        return dynamic_exports.SingleDiscriminatedUnionType._visit(this, visitor);
      }
    };
  },
  singleProperty: (value) => {
    return {
      ...value,
      type: "singleProperty",
      _visit: function(visitor) {
        return dynamic_exports.SingleDiscriminatedUnionType._visit(this, visitor);
      }
    };
  },
  noProperties: (value) => {
    return {
      ...value,
      type: "noProperties",
      _visit: function(visitor) {
        return dynamic_exports.SingleDiscriminatedUnionType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "samePropertiesAsObject":
        return visitor.samePropertiesAsObject(value);
      case "singleProperty":
        return visitor.singleProperty(value);
      case "noProperties":
        return visitor.noProperties(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/LiteralType.js
var LiteralType = {
  boolean: (value) => {
    return {
      value,
      type: "boolean",
      _visit: function(visitor) {
        return dynamic_exports.LiteralType._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      value,
      type: "string",
      _visit: function(visitor) {
        return dynamic_exports.LiteralType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "boolean":
        return visitor.boolean(value.value);
      case "string":
        return visitor.string(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/environment/types/Environments.js
var Environments = {
  singleBaseUrl: (value) => {
    return {
      ...value,
      type: "singleBaseUrl",
      _visit: function(visitor) {
        return Environments._visit(this, visitor);
      }
    };
  },
  multipleBaseUrls: (value) => {
    return {
      ...value,
      type: "multipleBaseUrls",
      _visit: function(visitor) {
        return Environments._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "singleBaseUrl":
        return visitor.singleBaseUrl(value);
      case "multipleBaseUrls":
        return visitor.multipleBaseUrls(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/Transport.js
var Transport = {
  http: () => {
    return {
      type: "http",
      _visit: function(visitor) {
        return Transport._visit(this, visitor);
      }
    };
  },
  grpc: (value) => {
    return {
      ...value,
      type: "grpc",
      _visit: function(visitor) {
        return Transport._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "http":
        return visitor.http();
      case "grpc":
        return visitor.grpc(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/HttpMethod.js
var HttpMethod = {
  Get: "GET",
  Post: "POST",
  Put: "PUT",
  Patch: "PATCH",
  Delete: "DELETE",
  _visit: (value, visitor) => {
    switch (value) {
      case HttpMethod.Get:
        return visitor.get();
      case HttpMethod.Post:
        return visitor.post();
      case HttpMethod.Put:
        return visitor.put();
      case HttpMethod.Patch:
        return visitor.patch();
      case HttpMethod.Delete:
        return visitor.delete();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/PathParameterLocation.js
var PathParameterLocation = {
  Root: "ROOT",
  Service: "SERVICE",
  Endpoint: "ENDPOINT",
  _visit: (value, visitor) => {
    switch (value) {
      case PathParameterLocation.Root:
        return visitor.root();
      case PathParameterLocation.Service:
        return visitor.service();
      case PathParameterLocation.Endpoint:
        return visitor.endpoint();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/HttpRequestBody.js
var HttpRequestBody = {
  inlinedRequestBody: (value) => {
    return {
      ...value,
      type: "inlinedRequestBody",
      _visit: function(visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  fileUpload: (value) => {
    return {
      ...value,
      type: "fileUpload",
      _visit: function(visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  bytes: (value) => {
    return {
      ...value,
      type: "bytes",
      _visit: function(visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedRequestBody":
        return visitor.inlinedRequestBody(value);
      case "reference":
        return visitor.reference(value);
      case "fileUpload":
        return visitor.fileUpload(value);
      case "bytes":
        return visitor.bytes(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/FileUploadRequestProperty.js
var FileUploadRequestProperty = {
  file: (value) => {
    return {
      value,
      type: "file",
      _visit: function(visitor) {
        return FileUploadRequestProperty._visit(this, visitor);
      }
    };
  },
  bodyProperty: (value) => {
    return {
      ...value,
      type: "bodyProperty",
      _visit: function(visitor) {
        return FileUploadRequestProperty._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value.value);
      case "bodyProperty":
        return visitor.bodyProperty(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/FileProperty.js
var FileProperty = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function(visitor) {
        return FileProperty._visit(this, visitor);
      }
    };
  },
  fileArray: (value) => {
    return {
      ...value,
      type: "fileArray",
      _visit: function(visitor) {
        return FileProperty._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "fileArray":
        return visitor.fileArray(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/SdkRequestBodyType.js
var SdkRequestBodyType = {
  typeReference: (value) => {
    return {
      ...value,
      type: "typeReference",
      _visit: function(visitor) {
        return SdkRequestBodyType._visit(this, visitor);
      }
    };
  },
  bytes: (value) => {
    return {
      ...value,
      type: "bytes",
      _visit: function(visitor) {
        return SdkRequestBodyType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "typeReference":
        return visitor.typeReference(value);
      case "bytes":
        return visitor.bytes(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/SdkRequestShape.js
var SdkRequestShape = {
  justRequestBody: (value) => {
    return {
      value,
      type: "justRequestBody",
      _visit: function(visitor) {
        return SdkRequestShape._visit(this, visitor);
      }
    };
  },
  wrapper: (value) => {
    return {
      ...value,
      type: "wrapper",
      _visit: function(visitor) {
        return SdkRequestShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "justRequestBody":
        return visitor.justRequestBody(value.value);
      case "wrapper":
        return visitor.wrapper(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/NonStreamHttpResponseBody.js
var NonStreamHttpResponseBody = {
  json: (value) => {
    return {
      value,
      type: "json",
      _visit: function(visitor) {
        return NonStreamHttpResponseBody._visit(this, visitor);
      }
    };
  },
  fileDownload: (value) => {
    return {
      ...value,
      type: "fileDownload",
      _visit: function(visitor) {
        return NonStreamHttpResponseBody._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function(visitor) {
        return NonStreamHttpResponseBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json(value.value);
      case "fileDownload":
        return visitor.fileDownload(value);
      case "text":
        return visitor.text(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/HttpResponseBody.js
var HttpResponseBody = {
  json: (value) => {
    return {
      value,
      type: "json",
      _visit: function(visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  fileDownload: (value) => {
    return {
      ...value,
      type: "fileDownload",
      _visit: function(visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function(visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  streaming: (value) => {
    return {
      value,
      type: "streaming",
      _visit: function(visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  streamParameter: (value) => {
    return {
      ...value,
      type: "streamParameter",
      _visit: function(visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json(value.value);
      case "fileDownload":
        return visitor.fileDownload(value);
      case "text":
        return visitor.text(value);
      case "streaming":
        return visitor.streaming(value.value);
      case "streamParameter":
        return visitor.streamParameter(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/JsonResponse.js
var JsonResponse = {
  response: (value) => {
    return {
      ...value,
      type: "response",
      _visit: function(visitor) {
        return JsonResponse._visit(this, visitor);
      }
    };
  },
  nestedPropertyAsResponse: (value) => {
    return {
      ...value,
      type: "nestedPropertyAsResponse",
      _visit: function(visitor) {
        return JsonResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "response":
        return visitor.response(value);
      case "nestedPropertyAsResponse":
        return visitor.nestedPropertyAsResponse(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/StreamingResponse.js
var StreamingResponse = {
  json: (value) => {
    return {
      ...value,
      type: "json",
      _visit: function(visitor) {
        return StreamingResponse._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function(visitor) {
        return StreamingResponse._visit(this, visitor);
      }
    };
  },
  sse: (value) => {
    return {
      ...value,
      type: "sse",
      _visit: function(visitor) {
        return StreamingResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json(value);
      case "text":
        return visitor.text(value);
      case "sse":
        return visitor.sse(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/Pagination.js
var Pagination = {
  cursor: (value) => {
    return {
      ...value,
      type: "cursor",
      _visit: function(visitor) {
        return Pagination._visit(this, visitor);
      }
    };
  },
  offset: (value) => {
    return {
      ...value,
      type: "offset",
      _visit: function(visitor) {
        return Pagination._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "cursor":
        return visitor.cursor(value);
      case "offset":
        return visitor.offset(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/RequestPropertyValue.js
var RequestPropertyValue = {
  query: (value) => {
    return {
      ...value,
      type: "query",
      _visit: function(visitor) {
        return RequestPropertyValue._visit(this, visitor);
      }
    };
  },
  body: (value) => {
    return {
      ...value,
      type: "body",
      _visit: function(visitor) {
        return RequestPropertyValue._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "query":
        return visitor.query(value);
      case "body":
        return visitor.body(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleCodeSample.js
var ExampleCodeSample = {
  language: (value) => {
    return {
      ...value,
      type: "language",
      _visit: function(visitor) {
        return ExampleCodeSample._visit(this, visitor);
      }
    };
  },
  sdk: (value) => {
    return {
      ...value,
      type: "sdk",
      _visit: function(visitor) {
        return ExampleCodeSample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "language":
        return visitor.language(value);
      case "sdk":
        return visitor.sdk(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleQueryParameterShape.js
var ExampleQueryParameterShape = {
  single: () => {
    return {
      type: "single",
      _visit: function(visitor) {
        return ExampleQueryParameterShape._visit(this, visitor);
      }
    };
  },
  exploded: () => {
    return {
      type: "exploded",
      _visit: function(visitor) {
        return ExampleQueryParameterShape._visit(this, visitor);
      }
    };
  },
  commaSeparated: () => {
    return {
      type: "commaSeparated",
      _visit: function(visitor) {
        return ExampleQueryParameterShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "single":
        return visitor.single();
      case "exploded":
        return visitor.exploded();
      case "commaSeparated":
        return visitor.commaSeparated();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleRequestBody.js
var ExampleRequestBody = {
  inlinedRequestBody: (value) => {
    return {
      ...value,
      type: "inlinedRequestBody",
      _visit: function(visitor) {
        return ExampleRequestBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return ExampleRequestBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedRequestBody":
        return visitor.inlinedRequestBody(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleResponse.js
var ExampleResponse = {
  ok: (value) => {
    return {
      value,
      type: "ok",
      _visit: function(visitor) {
        return ExampleResponse._visit(this, visitor);
      }
    };
  },
  error: (value) => {
    return {
      ...value,
      type: "error",
      _visit: function(visitor) {
        return ExampleResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "ok":
        return visitor.ok(value.value);
      case "error":
        return visitor.error(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleEndpointSuccessResponse.js
var ExampleEndpointSuccessResponse = {
  body: (value) => {
    return {
      value,
      type: "body",
      _visit: function(visitor) {
        return ExampleEndpointSuccessResponse._visit(this, visitor);
      }
    };
  },
  stream: (value) => {
    return {
      value,
      type: "stream",
      _visit: function(visitor) {
        return ExampleEndpointSuccessResponse._visit(this, visitor);
      }
    };
  },
  sse: (value) => {
    return {
      value,
      type: "sse",
      _visit: function(visitor) {
        return ExampleEndpointSuccessResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "body":
        return visitor.body(value.value);
      case "stream":
        return visitor.stream(value.value);
      case "sse":
        return visitor.sse(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/ir/types/ApiVersionScheme.js
var ApiVersionScheme = {
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function(visitor) {
        return ApiVersionScheme._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "header":
        return visitor.header(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/ir/types/ErrorDiscriminationStrategy.js
var ErrorDiscriminationStrategy = {
  statusCode: () => {
    return {
      type: "statusCode",
      _visit: function(visitor) {
        return ErrorDiscriminationStrategy._visit(this, visitor);
      }
    };
  },
  property: (value) => {
    return {
      ...value,
      type: "property",
      _visit: function(visitor) {
        return ErrorDiscriminationStrategy._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "statusCode":
        return visitor.statusCode();
      case "property":
        return visitor.property(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/proto/types/ProtobufType.js
var ProtobufType = {
  wellKnown: (value) => {
    return {
      value,
      type: "wellKnown",
      _visit: function(visitor) {
        return ProtobufType._visit(this, visitor);
      }
    };
  },
  userDefined: (value) => {
    return {
      ...value,
      type: "userDefined",
      _visit: function(visitor) {
        return ProtobufType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "wellKnown":
        return visitor.wellKnown(value.value);
      case "userDefined":
        return visitor.userDefined(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/proto/types/WellKnownProtobufType.js
var WellKnownProtobufType = {
  any: () => {
    return {
      type: "any",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  api: () => {
    return {
      type: "api",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  boolValue: () => {
    return {
      type: "boolValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  bytesValue: () => {
    return {
      type: "bytesValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  doubleValue: () => {
    return {
      type: "doubleValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  duration: () => {
    return {
      type: "duration",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  empty: () => {
    return {
      type: "empty",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  enum: () => {
    return {
      type: "enum",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  enumValue: () => {
    return {
      type: "enumValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  field: () => {
    return {
      type: "field",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  fieldCardinality: () => {
    return {
      type: "fieldCardinality",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  fieldKind: () => {
    return {
      type: "fieldKind",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  fieldMask: () => {
    return {
      type: "fieldMask",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  floatValue: () => {
    return {
      type: "floatValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  int32Value: () => {
    return {
      type: "int32Value",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  int64Value: () => {
    return {
      type: "int64Value",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  listValue: () => {
    return {
      type: "listValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  method: () => {
    return {
      type: "method",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  mixin: () => {
    return {
      type: "mixin",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  nullValue: () => {
    return {
      type: "nullValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  option: () => {
    return {
      type: "option",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  sourceContext: () => {
    return {
      type: "sourceContext",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  stringValue: () => {
    return {
      type: "stringValue",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  struct: () => {
    return {
      type: "struct",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  syntax: () => {
    return {
      type: "syntax",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  timestamp: () => {
    return {
      type: "timestamp",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  type: () => {
    return {
      type: "type",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  uint32Value: () => {
    return {
      type: "uint32Value",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  uint64Value: () => {
    return {
      type: "uint64Value",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  value: () => {
    return {
      type: "value",
      _visit: function(visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "any":
        return visitor.any();
      case "api":
        return visitor.api();
      case "boolValue":
        return visitor.boolValue();
      case "bytesValue":
        return visitor.bytesValue();
      case "doubleValue":
        return visitor.doubleValue();
      case "duration":
        return visitor.duration();
      case "empty":
        return visitor.empty();
      case "enum":
        return visitor.enum();
      case "enumValue":
        return visitor.enumValue();
      case "field":
        return visitor.field();
      case "fieldCardinality":
        return visitor.fieldCardinality();
      case "fieldKind":
        return visitor.fieldKind();
      case "fieldMask":
        return visitor.fieldMask();
      case "floatValue":
        return visitor.floatValue();
      case "int32Value":
        return visitor.int32Value();
      case "int64Value":
        return visitor.int64Value();
      case "listValue":
        return visitor.listValue();
      case "method":
        return visitor.method();
      case "mixin":
        return visitor.mixin();
      case "nullValue":
        return visitor.nullValue();
      case "option":
        return visitor.option();
      case "sourceContext":
        return visitor.sourceContext();
      case "stringValue":
        return visitor.stringValue();
      case "struct":
        return visitor.struct();
      case "syntax":
        return visitor.syntax();
      case "timestamp":
        return visitor.timestamp();
      case "type":
        return visitor.type();
      case "uint32Value":
        return visitor.uint32Value();
      case "uint64Value":
        return visitor.uint64Value();
      case "value":
        return visitor.value();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/Source.js
var Source = {
  proto: (value) => {
    return {
      value,
      type: "proto",
      _visit: function(visitor) {
        return Source._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "proto":
        return visitor.proto(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/Type.js
var Type = {
  alias: (value) => {
    return {
      ...value,
      type: "alias",
      _visit: function(visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function(visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  union: (value) => {
    return {
      ...value,
      type: "union",
      _visit: function(visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  undiscriminatedUnion: (value) => {
    return {
      ...value,
      type: "undiscriminatedUnion",
      _visit: function(visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "alias":
        return visitor.alias(value);
      case "enum":
        return visitor.enum(value);
      case "object":
        return visitor.object(value);
      case "union":
        return visitor.union(value);
      case "undiscriminatedUnion":
        return visitor.undiscriminatedUnion(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ResolvedTypeReference.js
var ResolvedTypeReference = {
  container: (value) => {
    return {
      container: value,
      type: "container",
      _visit: function(visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      ...value,
      type: "named",
      _visit: function(visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  primitive: (value) => {
    return {
      primitive: value,
      type: "primitive",
      _visit: function(visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  unknown: () => {
    return {
      type: "unknown",
      _visit: function(visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "container":
        return visitor.container(value.container);
      case "named":
        return visitor.named(value);
      case "primitive":
        return visitor.primitive(value.primitive);
      case "unknown":
        return visitor.unknown();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ShapeType.js
var ShapeType = {
  Enum: "ENUM",
  Object: "OBJECT",
  Union: "UNION",
  UndiscriminatedUnion: "UNDISCRIMINATED_UNION",
  _visit: (value, visitor) => {
    switch (value) {
      case ShapeType.Enum:
        return visitor.enum();
      case ShapeType.Object:
        return visitor.object();
      case ShapeType.Union:
        return visitor.union();
      case ShapeType.UndiscriminatedUnion:
        return visitor.undiscriminatedUnion();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/SingleUnionTypeProperties.js
var SingleUnionTypeProperties = {
  samePropertiesAsObject: (value) => {
    return {
      ...value,
      propertiesType: "samePropertiesAsObject",
      _visit: function(visitor) {
        return SingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  singleProperty: (value) => {
    return {
      ...value,
      propertiesType: "singleProperty",
      _visit: function(visitor) {
        return SingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  noProperties: () => {
    return {
      propertiesType: "noProperties",
      _visit: function(visitor) {
        return SingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.propertiesType) {
      case "samePropertiesAsObject":
        return visitor.samePropertiesAsObject(value);
      case "singleProperty":
        return visitor.singleProperty(value);
      case "noProperties":
        return visitor.noProperties();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/TypeReference.js
var TypeReference2 = {
  container: (value) => {
    return {
      container: value,
      type: "container",
      _visit: function(visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      ...value,
      type: "named",
      _visit: function(visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  primitive: (value) => {
    return {
      primitive: value,
      type: "primitive",
      _visit: function(visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  unknown: () => {
    return {
      type: "unknown",
      _visit: function(visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "container":
        return visitor.container(value.container);
      case "named":
        return visitor.named(value);
      case "primitive":
        return visitor.primitive(value.primitive);
      case "unknown":
        return visitor.unknown();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ContainerType.js
var ContainerType = {
  list: (value) => {
    return {
      list: value,
      type: "list",
      _visit: function(visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function(visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      optional: value,
      type: "optional",
      _visit: function(visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  set: (value) => {
    return {
      set: value,
      type: "set",
      _visit: function(visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      literal: value,
      type: "literal",
      _visit: function(visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "list":
        return visitor.list(value.list);
      case "map":
        return visitor.map(value);
      case "optional":
        return visitor.optional(value.optional);
      case "set":
        return visitor.set(value.set);
      case "literal":
        return visitor.literal(value.literal);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/PrimitiveTypeV1.js
var PrimitiveTypeV1 = {
  Integer: "INTEGER",
  Long: "LONG",
  Uint: "UINT",
  Uint64: "UINT_64",
  Float: "FLOAT",
  Double: "DOUBLE",
  Boolean: "BOOLEAN",
  String: "STRING",
  Date: "DATE",
  DateTime: "DATE_TIME",
  Uuid: "UUID",
  Base64: "BASE_64",
  BigInteger: "BIG_INTEGER",
  _visit: (value, visitor) => {
    switch (value) {
      case PrimitiveTypeV1.Integer:
        return visitor.integer();
      case PrimitiveTypeV1.Long:
        return visitor.long();
      case PrimitiveTypeV1.Uint:
        return visitor.uint();
      case PrimitiveTypeV1.Uint64:
        return visitor.uint64();
      case PrimitiveTypeV1.Float:
        return visitor.float();
      case PrimitiveTypeV1.Double:
        return visitor.double();
      case PrimitiveTypeV1.Boolean:
        return visitor.boolean();
      case PrimitiveTypeV1.String:
        return visitor.string();
      case PrimitiveTypeV1.Date:
        return visitor.date();
      case PrimitiveTypeV1.DateTime:
        return visitor.dateTime();
      case PrimitiveTypeV1.Uuid:
        return visitor.uuid();
      case PrimitiveTypeV1.Base64:
        return visitor.base64();
      case PrimitiveTypeV1.BigInteger:
        return visitor.bigInteger();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/PrimitiveTypeV2.js
var PrimitiveTypeV2 = {
  integer: (value) => {
    return {
      ...value,
      type: "integer",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  long: (value) => {
    return {
      ...value,
      type: "long",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      ...value,
      type: "uint",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      ...value,
      type: "uint64",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      ...value,
      type: "float",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      ...value,
      type: "double",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      ...value,
      type: "boolean",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      ...value,
      type: "string",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      ...value,
      type: "date",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  dateTime: (value) => {
    return {
      ...value,
      type: "dateTime",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  uuid: (value) => {
    return {
      ...value,
      type: "uuid",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      ...value,
      type: "base64",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  bigInteger: (value) => {
    return {
      ...value,
      type: "bigInteger",
      _visit: function(visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "integer":
        return visitor.integer(value);
      case "long":
        return visitor.long(value);
      case "uint":
        return visitor.uint(value);
      case "uint64":
        return visitor.uint64(value);
      case "float":
        return visitor.float(value);
      case "double":
        return visitor.double(value);
      case "boolean":
        return visitor.boolean(value);
      case "string":
        return visitor.string(value);
      case "date":
        return visitor.date(value);
      case "dateTime":
        return visitor.dateTime(value);
      case "uuid":
        return visitor.uuid(value);
      case "base64":
        return visitor.base64(value);
      case "bigInteger":
        return visitor.bigInteger(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/Literal.js
var Literal = {
  string: (value) => {
    return {
      string: value,
      type: "string",
      _visit: function(visitor) {
        return Literal._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      boolean: value,
      type: "boolean",
      _visit: function(visitor) {
        return Literal._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "string":
        return visitor.string(value.string);
      case "boolean":
        return visitor.boolean(value.boolean);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleTypeShape.js
var ExampleTypeShape = {
  alias: (value) => {
    return {
      ...value,
      type: "alias",
      _visit: function(visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function(visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  union: (value) => {
    return {
      ...value,
      type: "union",
      _visit: function(visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  undiscriminatedUnion: (value) => {
    return {
      ...value,
      type: "undiscriminatedUnion",
      _visit: function(visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "alias":
        return visitor.alias(value);
      case "enum":
        return visitor.enum(value);
      case "object":
        return visitor.object(value);
      case "union":
        return visitor.union(value);
      case "undiscriminatedUnion":
        return visitor.undiscriminatedUnion(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleSingleUnionTypeProperties.js
var ExampleSingleUnionTypeProperties = {
  samePropertiesAsObject: (value) => {
    return {
      ...value,
      type: "samePropertiesAsObject",
      _visit: function(visitor) {
        return ExampleSingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  singleProperty: (value) => {
    return {
      ...value,
      type: "singleProperty",
      _visit: function(visitor) {
        return ExampleSingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  noProperties: () => {
    return {
      type: "noProperties",
      _visit: function(visitor) {
        return ExampleSingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "samePropertiesAsObject":
        return visitor.samePropertiesAsObject(value);
      case "singleProperty":
        return visitor.singleProperty(value);
      case "noProperties":
        return visitor.noProperties();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleTypeReferenceShape.js
var ExampleTypeReferenceShape = {
  primitive: (value) => {
    return {
      primitive: value,
      type: "primitive",
      _visit: function(visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  container: (value) => {
    return {
      container: value,
      type: "container",
      _visit: function(visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      unknown: value,
      type: "unknown",
      _visit: function(visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      ...value,
      type: "named",
      _visit: function(visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value.primitive);
      case "container":
        return visitor.container(value.container);
      case "unknown":
        return visitor.unknown(value.unknown);
      case "named":
        return visitor.named(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleContainer.js
var ExampleContainer = {
  list: (value) => {
    return {
      ...value,
      type: "list",
      _visit: function(visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  set: (value) => {
    return {
      ...value,
      type: "set",
      _visit: function(visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      ...value,
      type: "optional",
      _visit: function(visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function(visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      ...value,
      type: "literal",
      _visit: function(visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "list":
        return visitor.list(value);
      case "set":
        return visitor.set(value);
      case "optional":
        return visitor.optional(value);
      case "map":
        return visitor.map(value);
      case "literal":
        return visitor.literal(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExamplePrimitive.js
var ExamplePrimitive = {
  integer: (value) => {
    return {
      integer: value,
      type: "integer",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  long: (value) => {
    return {
      long: value,
      type: "long",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      uint: value,
      type: "uint",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      uint64: value,
      type: "uint64",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      float: value,
      type: "float",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      double: value,
      type: "double",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      boolean: value,
      type: "boolean",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      string: value,
      type: "string",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      date: value,
      type: "date",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  datetime: (value) => {
    return {
      ...value,
      type: "datetime",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  uuid: (value) => {
    return {
      uuid: value,
      type: "uuid",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      base64: value,
      type: "base64",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  bigInteger: (value) => {
    return {
      bigInteger: value,
      type: "bigInteger",
      _visit: function(visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "integer":
        return visitor.integer(value.integer);
      case "long":
        return visitor.long(value.long);
      case "uint":
        return visitor.uint(value.uint);
      case "uint64":
        return visitor.uint64(value.uint64);
      case "float":
        return visitor.float(value.float);
      case "double":
        return visitor.double(value.double);
      case "boolean":
        return visitor.boolean(value.boolean);
      case "string":
        return visitor.string(value.string);
      case "date":
        return visitor.date(value.date);
      case "datetime":
        return visitor.datetime(value);
      case "uuid":
        return visitor.uuid(value.uuid);
      case "base64":
        return visitor.base64(value.base64);
      case "bigInteger":
        return visitor.bigInteger(value.bigInteger);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/webhooks/types/WebhookPayload.js
var WebhookPayload = {
  inlinedPayload: (value) => {
    return {
      ...value,
      type: "inlinedPayload",
      _visit: function(visitor) {
        return WebhookPayload._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return WebhookPayload._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedPayload":
        return visitor.inlinedPayload(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/websocket/types/WebSocketMessageBody.js
var WebSocketMessageBody = {
  inlinedBody: (value) => {
    return {
      ...value,
      type: "inlinedBody",
      _visit: function(visitor) {
        return WebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return WebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedBody":
        return visitor.inlinedBody(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/websocket/types/ExampleWebSocketMessageBody.js
var ExampleWebSocketMessageBody = {
  inlinedBody: (value) => {
    return {
      ...value,
      type: "inlinedBody",
      _visit: function(visitor) {
        return ExampleWebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return ExampleWebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedBody":
        return visitor.inlinedBody(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/fern-definition/schema/lib/constants.js
var EXAMPLE_REFERENCE_PREFIX = "$";

// ../../cli/fern-definition/schema/lib/schemas/index.js
var schemas_exports3 = {};
__export(schemas_exports3, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema3,
  FernDefinitionError: () => FernDefinitionError,
  FernDefinitionTimeoutError: () => FernDefinitionTimeoutError,
  HttpMethodSchema: () => HttpMethodSchema,
  StreamFormat: () => StreamFormat,
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema,
  WebSocketOrigin: () => WebSocketOrigin,
  WebhookMethodSchema: () => WebhookMethodSchema,
  auth: () => auth_exports5,
  availability: () => availability_exports3,
  commons: () => commons_exports4,
  encoding: () => encoding_exports3,
  environments: () => environments_exports3,
  errors: () => errors_exports2,
  examples: () => examples_exports2,
  file: () => file_exports3,
  pagination: () => pagination_exports,
  serialization: () => serialization_exports2,
  service: () => service_exports3,
  source: () => source_exports,
  types: () => types_exports5,
  validation: () => validation_exports3,
  variables: () => variables_exports2,
  versioning: () => versioning_exports,
  webhooks: () => webhooks_exports2,
  websocket: () => websocket_exports2
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/auth/index.js
var auth_exports5 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/availability/index.js
var availability_exports3 = {};
__export(availability_exports3, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema3
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema3 = {
  InDevelopment: "in-development",
  PreRelease: "pre-release",
  Deprecated: "deprecated",
  GenerallyAvailable: "generally-available"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/commons/index.js
var commons_exports4 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/encoding/index.js
var encoding_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/environments/index.js
var environments_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/errors/index.js
var errors_exports2 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/examples/index.js
var examples_exports2 = {};
__export(examples_exports2, {
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/examples/types/SupportedSdkLanguageSchema.js
var SupportedSdkLanguageSchema = {
  Curl: "curl",
  Python: "python",
  Javascript: "javascript",
  Typescript: "typescript",
  Go: "go",
  Ruby: "ruby",
  Csharp: "csharp",
  Java: "java",
  Js: "js",
  Node: "node",
  Ts: "ts",
  Nodets: "nodets",
  Golang: "golang",
  Dotnet: "dotnet",
  Jvm: "jvm",
  Csharp2: "c#"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/file/index.js
var file_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/pagination/index.js
var pagination_exports = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/service/index.js
var service_exports3 = {};
__export(service_exports3, {
  HttpMethodSchema: () => HttpMethodSchema,
  StreamFormat: () => StreamFormat
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/service/types/HttpMethodSchema.js
var HttpMethodSchema = {
  Get: "GET",
  Post: "POST",
  Put: "PUT",
  Patch: "PATCH",
  Delete: "DELETE"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/service/types/StreamFormat.js
var StreamFormat = {
  Sse: "sse",
  Json: "json"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/source/index.js
var source_exports = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/types/index.js
var types_exports5 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/validation/index.js
var validation_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/variables/index.js
var variables_exports2 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/versioning/index.js
var versioning_exports = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/webhooks/index.js
var webhooks_exports2 = {};
__export(webhooks_exports2, {
  WebhookMethodSchema: () => WebhookMethodSchema
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/webhooks/types/WebhookMethodSchema.js
var WebhookMethodSchema = {
  Post: "POST",
  Get: "GET"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/websocket/index.js
var websocket_exports2 = {};
__export(websocket_exports2, {
  WebSocketOrigin: () => WebSocketOrigin
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/websocket/types/WebSocketOrigin.js
var WebSocketOrigin = {
  Client: "client",
  Server: "server"
};

// ../../cli/fern-definition/schema/lib/schemas/serialization/index.js
var serialization_exports2 = {};
__export(serialization_exports2, {
  AliasSchema: () => AliasSchema,
  AnyAuthItem: () => AnyAuthItem2,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema2,
  ApiAuthSchema: () => ApiAuthSchema2,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema2,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema2,
  AuthVariable: () => AuthVariable2,
  AvailabilitySchema: () => AvailabilitySchema2,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema4,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema2,
  BaseTypeDeclarationSchema: () => BaseTypeDeclarationSchema,
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema2,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema2,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema2,
  CasingOverridesSchema: () => CasingOverridesSchema,
  CursorPaginationSchema: () => CursorPaginationSchema,
  DeclarationSchema: () => DeclarationSchema,
  DeclarationWithNameSchema: () => DeclarationWithNameSchema,
  DeclarationWithoutDocsSchema: () => DeclarationWithoutDocsSchema,
  DefinitionFileSchema: () => DefinitionFileSchema,
  DiscriminatedUnionSchema: () => DiscriminatedUnionSchema,
  EncodingSchema: () => EncodingSchema2,
  EnumSchema: () => EnumSchema,
  EnumValue: () => EnumValue,
  EnumValueSchema: () => EnumValueSchema,
  EnvironmentSchema: () => EnvironmentSchema2,
  ErrorDeclarationSchema: () => ErrorDeclarationSchema,
  ErrorDiscriminationSchema: () => ErrorDiscriminationSchema,
  ExampleBodyResponseSchema: () => ExampleBodyResponseSchema,
  ExampleCodeSampleSchema: () => ExampleCodeSampleSchema,
  ExampleCodeSampleSchemaLanguage: () => ExampleCodeSampleSchemaLanguage,
  ExampleCodeSampleSchemaSdk: () => ExampleCodeSampleSchemaSdk,
  ExampleEndpointCallArraySchema: () => ExampleEndpointCallArraySchema,
  ExampleEndpointCallSchema: () => ExampleEndpointCallSchema,
  ExampleResponseSchema: () => ExampleResponseSchema,
  ExampleSseEventSchema: () => ExampleSseEventSchema,
  ExampleSseResponseSchema: () => ExampleSseResponseSchema,
  ExampleStreamResponseSchema: () => ExampleStreamResponseSchema,
  ExampleTypeReferenceSchema: () => ExampleTypeReferenceSchema,
  ExampleTypeSchema: () => ExampleTypeSchema,
  ExampleTypeValueSchema: () => ExampleTypeValueSchema,
  ExampleWebSocketMessage: () => ExampleWebSocketMessage,
  ExampleWebSocketSession: () => ExampleWebSocketSession,
  ExampleWebhookCallSchema: () => ExampleWebhookCallSchema,
  Export: () => Export,
  ExportDetailed: () => ExportDetailed,
  GrpcTransport: () => GrpcTransport,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema2,
  HttpEndpointSchema: () => HttpEndpointSchema,
  HttpHeaderSchema: () => HttpHeaderSchema2,
  HttpInlineRequestBodyPropertySchema: () => HttpInlineRequestBodyPropertySchema,
  HttpInlineRequestBodySchema: () => HttpInlineRequestBodySchema,
  HttpMethodSchema: () => HttpMethodSchema2,
  HttpPathParameterSchema: () => HttpPathParameterSchema,
  HttpQueryParameterSchema: () => HttpQueryParameterSchema,
  HttpReferencedRequestBodySchema: () => HttpReferencedRequestBodySchema,
  HttpRequest: () => HttpRequest,
  HttpRequestBodySchema: () => HttpRequestBodySchema,
  HttpRequestSchema: () => HttpRequestSchema,
  HttpResponseSchema: () => HttpResponseSchema,
  HttpResponseSchemaDetailed: () => HttpResponseSchemaDetailed,
  HttpResponseStreamSchema: () => HttpResponseStreamSchema,
  HttpResponseStreamSchemaDetailed: () => HttpResponseStreamSchemaDetailed,
  HttpServiceSchema: () => HttpServiceSchema,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema2,
  Navigation: () => Navigation,
  NumberValidationSchema: () => NumberValidationSchema2,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema2,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema2,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema2,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema2,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema2,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema2,
  OAuthSchemeSchema: () => OAuthSchemeSchema2,
  ObjectExtendsSchema: () => ObjectExtendsSchema,
  ObjectPropertySchema: () => ObjectPropertySchema,
  ObjectSchema: () => ObjectSchema,
  OffsetPaginationSchema: () => OffsetPaginationSchema,
  OpenApiSourceSchema: () => OpenApiSourceSchema,
  PackageMarkerFileSchema: () => PackageMarkerFileSchema,
  Pagination: () => Pagination2,
  PaginationSchema: () => PaginationSchema,
  PropertyBasedErrorDiscrimination: () => PropertyBasedErrorDiscrimination,
  ProtobufSourceSchema: () => ProtobufSourceSchema,
  ProtobufTypeSchema: () => ProtobufTypeSchema2,
  QueryParameterTypeReferenceDetailed: () => QueryParameterTypeReferenceDetailed,
  ResponseError: () => ResponseError,
  ResponseErrorWithDocsSchema: () => ResponseErrorWithDocsSchema,
  ResponseErrorsSchema: () => ResponseErrorsSchema,
  RootApiFileSchema: () => RootApiFileSchema,
  ServiceTransport: () => ServiceTransport,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema2,
  SingleUndiscriminatedUnionTypeDetailedSchema: () => SingleUndiscriminatedUnionTypeDetailedSchema,
  SingleUndiscriminatedUnionTypeSchema: () => SingleUndiscriminatedUnionTypeSchema,
  SingleUnionTypeDetailedSchema: () => SingleUnionTypeDetailedSchema,
  SingleUnionTypeKey: () => SingleUnionTypeKey,
  SingleUnionTypeKeySchema: () => SingleUnionTypeKeySchema,
  SingleUnionTypeSchema: () => SingleUnionTypeSchema,
  SourceSchema: () => SourceSchema,
  StatusCodeBasedErrorDiscrimination: () => StatusCodeBasedErrorDiscrimination,
  StreamFormat: () => StreamFormat2,
  StringValidationSchema: () => StringValidationSchema2,
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema2,
  TypeDeclarationSchema: () => TypeDeclarationSchema,
  TypeReferenceDeclarationWithContentTypeSchema: () => TypeReferenceDeclarationWithContentTypeSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride2,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema2,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName2,
  TypeReferenceDeclarationWithNameSchema: () => TypeReferenceDeclarationWithNameSchema,
  TypeReferenceDetailedSchema: () => TypeReferenceDetailedSchema,
  TypeReferenceSchema: () => TypeReferenceSchema,
  UndiscriminatedUnionSchema: () => UndiscriminatedUnionSchema,
  UnionDiscriminant: () => UnionDiscriminant,
  UnionDiscriminantSchema: () => UnionDiscriminantSchema,
  ValidationSchema: () => ValidationSchema2,
  VariableDeclarationDetailed: () => VariableDeclarationDetailed,
  VariableDeclarationSchema: () => VariableDeclarationSchema,
  VariableReferenceSchema: () => VariableReferenceSchema,
  VersionDeclarationHeaderObjectSchema: () => VersionDeclarationHeaderObjectSchema,
  VersionDeclarationHeaderSchema: () => VersionDeclarationHeaderSchema,
  VersionDeclarationSchema: () => VersionDeclarationSchema,
  VersionValue: () => VersionValue,
  VersionValueDetailed: () => VersionValueDetailed,
  WebSocketChannelInlinedMessageSchema: () => WebSocketChannelInlinedMessageSchema,
  WebSocketChannelMessageBodySchema: () => WebSocketChannelMessageBodySchema,
  WebSocketChannelMessageSchema: () => WebSocketChannelMessageSchema,
  WebSocketChannelReferencedMessageSchema: () => WebSocketChannelReferencedMessageSchema,
  WebSocketChannelSchema: () => WebSocketChannelSchema,
  WebSocketOrigin: () => WebSocketOrigin2,
  WebhookInlinedPayloadSchema: () => WebhookInlinedPayloadSchema,
  WebhookMethodSchema: () => WebhookMethodSchema2,
  WebhookPayloadSchema: () => WebhookPayloadSchema,
  WebhookReferencedPayloadSchema: () => WebhookReferencedPayloadSchema,
  WebhookSchema: () => WebhookSchema,
  WithAudiences: () => WithAudiences2,
  WithAuthSchema: () => WithAuthSchema,
  WithAvailability: () => WithAvailability2,
  WithDisplayName: () => WithDisplayName,
  WithDocsSchema: () => WithDocsSchema2,
  WithEnvironmentVariable: () => WithEnvironmentVariable2,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema2,
  WithHeadersSchema: () => WithHeadersSchema2,
  WithName: () => WithName2,
  auth: () => auth_exports6,
  availability: () => availability_exports4,
  commons: () => commons_exports5,
  encoding: () => encoding_exports4,
  environments: () => environments_exports4,
  errors: () => errors_exports3,
  examples: () => examples_exports3,
  file: () => file_exports4,
  pagination: () => pagination_exports2,
  service: () => service_exports4,
  source: () => source_exports2,
  types: () => types_exports6,
  validation: () => validation_exports4,
  variables: () => variables_exports3,
  versioning: () => versioning_exports2,
  webhooks: () => webhooks_exports3,
  websocket: () => websocket_exports3
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/index.js
var auth_exports6 = {};
__export(auth_exports6, {
  AnyAuthItem: () => AnyAuthItem2,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema2,
  ApiAuthSchema: () => ApiAuthSchema2,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema2,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema2,
  AuthVariable: () => AuthVariable2,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema2,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema2,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema2,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema2,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema2,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema2,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema2,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema2,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema2,
  OAuthSchemeSchema: () => OAuthSchemeSchema2,
  WithAuthSchema: () => WithAuthSchema,
  WithEnvironmentVariable: () => WithEnvironmentVariable2
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/index.js
var schemas_exports2 = {};
__export(schemas_exports2, {
  JsonError: () => JsonError2,
  ParseError: () => ParseError2,
  any: () => any2,
  boolean: () => boolean2,
  booleanLiteral: () => booleanLiteral2,
  date: () => date2,
  discriminant: () => discriminant2,
  enum_: () => enum_2,
  getObjectLikeUtils: () => getObjectLikeUtils2,
  getObjectUtils: () => getObjectUtils2,
  getSchemaUtils: () => getSchemaUtils2,
  isProperty: () => isProperty2,
  lazy: () => lazy2,
  lazyObject: () => lazyObject2,
  list: () => list2,
  number: () => number2,
  object: () => object2,
  objectWithoutOptionalProperties: () => objectWithoutOptionalProperties2,
  optional: () => optional2,
  property: () => property3,
  record: () => record2,
  set: () => set2,
  string: () => string2,
  stringLiteral: () => stringLiteral2,
  transform: () => transform2,
  undiscriminatedUnion: () => undiscriminatedUnion2,
  union: () => union2,
  unknown: () => unknown2,
  withParsedProperties: () => withParsedProperties2
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/Schema.js
var SchemaType2 = {
  DATE: "date",
  ENUM: "enum",
  LIST: "list",
  STRING_LITERAL: "stringLiteral",
  BOOLEAN_LITERAL: "booleanLiteral",
  OBJECT: "object",
  ANY: "any",
  BOOLEAN: "boolean",
  NUMBER: "number",
  STRING: "string",
  UNKNOWN: "unknown",
  RECORD: "record",
  SET: "set",
  UNION: "union",
  UNDISCRIMINATED_UNION: "undiscriminatedUnion",
  OPTIONAL: "optional"
};

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/getErrorMessageForIncorrectType.js
function getErrorMessageForIncorrectType2(value, expectedType) {
  return `Expected ${expectedType}. Received ${getTypeAsString2(value)}.`;
}
function getTypeAsString2(value) {
  if (Array.isArray(value)) {
    return "list";
  }
  if (value === null) {
    return "null";
  }
  switch (typeof value) {
    case "string":
      return `"${value}"`;
    case "number":
    case "boolean":
    case "undefined":
      return `${value}`;
  }
  return typeof value;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/maybeSkipValidation.js
function maybeSkipValidation2(schema2) {
  return {
    ...schema2,
    json: transformAndMaybeSkipValidation2(schema2.json),
    parse: transformAndMaybeSkipValidation2(schema2.parse)
  };
}
function transformAndMaybeSkipValidation2(transform3) {
  return (value, opts) => {
    const transformed = transform3(value, opts);
    const { skipValidation = false } = opts ?? {};
    if (!transformed.ok && skipValidation) {
      console.warn([
        "Failed to validate.",
        ...transformed.errors.map((error) => "  - " + (error.path.length > 0 ? `${error.path.join(".")}: ${error.message}` : error.message))
      ].join("\n"));
      return {
        ok: true,
        value
      };
    } else {
      return transformed;
    }
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/stringifyValidationErrors.js
function stringifyValidationError2(error) {
  if (error.path.length === 0) {
    return error.message;
  }
  return `${error.path.join(" -> ")}: ${error.message}`;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/JsonError.js
var JsonError2 = class _JsonError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError2).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _JsonError.prototype);
  }
};

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/ParseError.js
var ParseError2 = class _ParseError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError2).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _ParseError.prototype);
  }
};

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/getSchemaUtils.js
function getSchemaUtils2(schema2) {
  return {
    optional: () => optional2(schema2),
    transform: (transformer) => transform2(schema2, transformer),
    parseOrThrow: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (parsed.ok) {
        return parsed.value;
      }
      throw new ParseError2(parsed.errors);
    },
    jsonOrThrow: (parsed, opts) => {
      const raw = schema2.json(parsed, opts);
      if (raw.ok) {
        return raw.value;
      }
      throw new JsonError2(raw.errors);
    }
  };
}
function optional2(schema2) {
  const baseSchema = {
    parse: (raw, opts) => {
      if (raw == null) {
        return {
          ok: true,
          value: void 0
        };
      }
      return schema2.parse(raw, opts);
    },
    json: (parsed, opts) => {
      if (opts?.omitUndefined && parsed === void 0) {
        return {
          ok: true,
          value: void 0
        };
      }
      if (parsed == null) {
        return {
          ok: true,
          value: null
        };
      }
      return schema2.json(parsed, opts);
    },
    getType: () => SchemaType2.OPTIONAL
  };
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema)
  };
}
function transform2(schema2, transformer) {
  const baseSchema = {
    parse: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (!parsed.ok) {
        return parsed;
      }
      return {
        ok: true,
        value: transformer.transform(parsed.value)
      };
    },
    json: (transformed, opts) => {
      const parsed = transformer.untransform(transformed);
      return schema2.json(parsed, opts);
    },
    getType: () => schema2.getType()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/date/date.js
var ISO_8601_REGEX2 = /^([+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([.,]\d+(?!:))?)?(\17[0-5]\d([.,]\d+)?)?([zZ]|([+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;
function date2() {
  const baseSchema = {
    parse: (raw, { breadcrumbsPrefix = [] } = {}) => {
      if (typeof raw !== "string") {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType2(raw, "string")
            }
          ]
        };
      }
      if (!ISO_8601_REGEX2.test(raw)) {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType2(raw, "ISO 8601 date string")
            }
          ]
        };
      }
      return {
        ok: true,
        value: new Date(raw)
      };
    },
    json: (date3, { breadcrumbsPrefix = [] } = {}) => {
      if (date3 instanceof Date) {
        return {
          ok: true,
          value: date3.toISOString()
        };
      } else {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType2(date3, "Date object")
            }
          ]
        };
      }
    },
    getType: () => SchemaType2.DATE
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/createIdentitySchemaCreator.js
function createIdentitySchemaCreator2(schemaType, validate) {
  return () => {
    const baseSchema = {
      parse: validate,
      json: validate,
      getType: () => schemaType
    };
    return {
      ...maybeSkipValidation2(baseSchema),
      ...getSchemaUtils2(baseSchema)
    };
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/enum/enum.js
function enum_2(values) {
  const validValues = new Set(values);
  const schemaCreator = createIdentitySchemaCreator2(SchemaType2.ENUM, (value, { allowUnrecognizedEnumValues, breadcrumbsPrefix = [] } = {}) => {
    if (typeof value !== "string") {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, "string")
          }
        ]
      };
    }
    if (!validValues.has(value) && !allowUnrecognizedEnumValues) {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, "enum")
          }
        ]
      };
    }
    return {
      ok: true,
      value
    };
  });
  return schemaCreator();
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/lazy/lazy.js
function lazy2(getter) {
  const baseSchema = constructLazyBaseSchema2(getter);
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema)
  };
}
function constructLazyBaseSchema2(getter) {
  return {
    parse: (raw, opts) => getMemoizedSchema2(getter).parse(raw, opts),
    json: (parsed, opts) => getMemoizedSchema2(getter).json(parsed, opts),
    getType: () => getMemoizedSchema2(getter).getType()
  };
}
function getMemoizedSchema2(getter) {
  const castedGetter = getter;
  if (castedGetter.__zurg_memoized == null) {
    castedGetter.__zurg_memoized = getter();
  }
  return castedGetter.__zurg_memoized;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/entries.js
function entries3(object3) {
  return Object.entries(object3);
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/filterObject.js
function filterObject2(obj, keysToInclude) {
  const keysToIncludeSet = new Set(keysToInclude);
  return Object.entries(obj).reduce((acc, [key, value]) => {
    if (keysToIncludeSet.has(key)) {
      acc[key] = value;
    }
    return acc;
  }, {});
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/isPlainObject.js
function isPlainObject4(value) {
  if (typeof value !== "object" || value === null) {
    return false;
  }
  if (Object.getPrototypeOf(value) === null) {
    return true;
  }
  let proto = value;
  while (Object.getPrototypeOf(proto) !== null) {
    proto = Object.getPrototypeOf(proto);
  }
  return Object.getPrototypeOf(value) === proto;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/keys.js
function keys4(object3) {
  return Object.keys(object3);
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/partition.js
function partition2(items, predicate) {
  const trueItems = [], falseItems = [];
  for (const item of items) {
    if (predicate(item)) {
      trueItems.push(item);
    } else {
      falseItems.push(item);
    }
  }
  return [trueItems, falseItems];
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object-like/getObjectLikeUtils.js
function getObjectLikeUtils2(schema2) {
  return {
    withParsedProperties: (properties) => withParsedProperties2(schema2, properties)
  };
}
function withParsedProperties2(objectLike, properties) {
  const objectSchema = {
    parse: (raw, opts) => {
      const parsedObject = objectLike.parse(raw, opts);
      if (!parsedObject.ok) {
        return parsedObject;
      }
      const additionalProperties = Object.entries(properties).reduce((processed, [key, value]) => {
        return {
          ...processed,
          [key]: typeof value === "function" ? value(parsedObject.value) : value
        };
      }, {});
      return {
        ok: true,
        value: {
          ...parsedObject.value,
          ...additionalProperties
        }
      };
    },
    json: (parsed, opts) => {
      if (!isPlainObject4(parsed)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType2(parsed, "object")
            }
          ]
        };
      }
      const addedPropertyKeys = new Set(Object.keys(properties));
      const parsedWithoutAddedProperties = filterObject2(parsed, Object.keys(parsed).filter((key) => !addedPropertyKeys.has(key)));
      return objectLike.json(parsedWithoutAddedProperties, opts);
    },
    getType: () => objectLike.getType()
  };
  return {
    ...objectSchema,
    ...getSchemaUtils2(objectSchema),
    ...getObjectLikeUtils2(objectSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object/property.js
function property3(rawKey, valueSchema) {
  return {
    rawKey,
    valueSchema,
    isProperty: true
  };
}
function isProperty2(maybeProperty) {
  return maybeProperty.isProperty;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object/object.js
function object2(schemas) {
  const baseSchema = {
    _getRawProperties: () => Object.entries(schemas).map(([parsedKey, propertySchema]) => isProperty2(propertySchema) ? propertySchema.rawKey : parsedKey),
    _getParsedProperties: () => keys4(schemas),
    parse: (raw, opts) => {
      const rawKeyToProperty = {};
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries3(schemas)) {
        const rawKey = isProperty2(schemaOrObjectProperty) ? schemaOrObjectProperty.rawKey : parsedKey;
        const valueSchema = isProperty2(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        const property4 = {
          rawKey,
          parsedKey,
          valueSchema
        };
        rawKeyToProperty[rawKey] = property4;
        if (isSchemaRequired2(valueSchema)) {
          requiredKeys.push(rawKey);
        }
      }
      return validateAndTransformObject2({
        value: raw,
        requiredKeys,
        getProperty: (rawKey) => {
          const property4 = rawKeyToProperty[rawKey];
          if (property4 == null) {
            return void 0;
          }
          return {
            transformedKey: property4.parsedKey,
            transform: (propertyValue) => property4.valueSchema.parse(propertyValue, {
              ...opts,
              breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawKey]
            })
          };
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    json: (parsed, opts) => {
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries3(schemas)) {
        const valueSchema = isProperty2(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        if (isSchemaRequired2(valueSchema)) {
          requiredKeys.push(parsedKey);
        }
      }
      return validateAndTransformObject2({
        value: parsed,
        requiredKeys,
        getProperty: (parsedKey) => {
          const property4 = schemas[parsedKey];
          if (property4 == null) {
            return void 0;
          }
          if (isProperty2(property4)) {
            return {
              transformedKey: property4.rawKey,
              transform: (propertyValue) => property4.valueSchema.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          } else {
            return {
              transformedKey: parsedKey,
              transform: (propertyValue) => property4.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          }
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    getType: () => SchemaType2.OBJECT
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema),
    ...getObjectLikeUtils2(baseSchema),
    ...getObjectUtils2(baseSchema)
  };
}
function validateAndTransformObject2({ value, requiredKeys, getProperty: getProperty2, unrecognizedObjectKeys = "fail", skipValidation = false, breadcrumbsPrefix = [] }) {
  if (!isPlainObject4(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "object")
        }
      ]
    };
  }
  const missingRequiredKeys = new Set(requiredKeys);
  const errors = [];
  const transformed = {};
  for (const [preTransformedKey, preTransformedItemValue] of Object.entries(value)) {
    const property4 = getProperty2(preTransformedKey);
    if (property4 != null) {
      missingRequiredKeys.delete(preTransformedKey);
      const value2 = property4.transform(preTransformedItemValue);
      if (value2.ok) {
        transformed[property4.transformedKey] = value2.value;
      } else {
        transformed[preTransformedKey] = preTransformedItemValue;
        errors.push(...value2.errors);
      }
    } else {
      switch (unrecognizedObjectKeys) {
        case "fail":
          errors.push({
            path: [...breadcrumbsPrefix, preTransformedKey],
            message: `Unexpected key "${preTransformedKey}"`
          });
          break;
        case "strip":
          break;
        case "passthrough":
          transformed[preTransformedKey] = preTransformedItemValue;
          break;
      }
    }
  }
  errors.push(...requiredKeys.filter((key) => missingRequiredKeys.has(key)).map((key) => ({
    path: breadcrumbsPrefix,
    message: `Missing required key "${key}"`
  })));
  if (errors.length === 0 || skipValidation) {
    return {
      ok: true,
      value: transformed
    };
  } else {
    return {
      ok: false,
      errors
    };
  }
}
function getObjectUtils2(schema2) {
  return {
    extend: (extension) => {
      const baseSchema = {
        _getParsedProperties: () => [...schema2._getParsedProperties(), ...extension._getParsedProperties()],
        _getRawProperties: () => [...schema2._getRawProperties(), ...extension._getRawProperties()],
        parse: (raw, opts) => {
          return validateAndTransformExtendedObject2({
            extensionKeys: extension._getRawProperties(),
            value: raw,
            transformBase: (rawBase) => schema2.parse(rawBase, opts),
            transformExtension: (rawExtension) => extension.parse(rawExtension, opts)
          });
        },
        json: (parsed, opts) => {
          return validateAndTransformExtendedObject2({
            extensionKeys: extension._getParsedProperties(),
            value: parsed,
            transformBase: (parsedBase) => schema2.json(parsedBase, opts),
            transformExtension: (parsedExtension) => extension.json(parsedExtension, opts)
          });
        },
        getType: () => SchemaType2.OBJECT
      };
      return {
        ...baseSchema,
        ...getSchemaUtils2(baseSchema),
        ...getObjectLikeUtils2(baseSchema),
        ...getObjectUtils2(baseSchema)
      };
    }
  };
}
function validateAndTransformExtendedObject2({ extensionKeys, value, transformBase, transformExtension }) {
  const extensionPropertiesSet = new Set(extensionKeys);
  const [extensionProperties, baseProperties] = partition2(keys4(value), (key) => extensionPropertiesSet.has(key));
  const transformedBase = transformBase(filterObject2(value, baseProperties));
  const transformedExtension = transformExtension(filterObject2(value, extensionProperties));
  if (transformedBase.ok && transformedExtension.ok) {
    return {
      ok: true,
      value: {
        ...transformedBase.value,
        ...transformedExtension.value
      }
    };
  } else {
    return {
      ok: false,
      errors: [
        ...transformedBase.ok ? [] : transformedBase.errors,
        ...transformedExtension.ok ? [] : transformedExtension.errors
      ]
    };
  }
}
function isSchemaRequired2(schema2) {
  return !isSchemaOptional2(schema2);
}
function isSchemaOptional2(schema2) {
  switch (schema2.getType()) {
    case SchemaType2.ANY:
    case SchemaType2.UNKNOWN:
    case SchemaType2.OPTIONAL:
      return true;
    default:
      return false;
  }
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object/objectWithoutOptionalProperties.js
function objectWithoutOptionalProperties2(schemas) {
  return object2(schemas);
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/lazy/lazyObject.js
function lazyObject2(getter) {
  const baseSchema = {
    ...constructLazyBaseSchema2(getter),
    _getRawProperties: () => getMemoizedSchema2(getter)._getRawProperties(),
    _getParsedProperties: () => getMemoizedSchema2(getter)._getParsedProperties()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema),
    ...getObjectLikeUtils2(baseSchema),
    ...getObjectUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/list/list.js
function list2(schema2) {
  const baseSchema = {
    parse: (raw, opts) => validateAndTransformArray2(raw, (item, index) => schema2.parse(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    json: (parsed, opts) => validateAndTransformArray2(parsed, (item, index) => schema2.json(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    getType: () => SchemaType2.LIST
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}
function validateAndTransformArray2(value, transformItem) {
  if (!Array.isArray(value)) {
    return {
      ok: false,
      errors: [
        {
          message: getErrorMessageForIncorrectType2(value, "list"),
          path: []
        }
      ]
    };
  }
  const maybeValidItems = value.map((item, index) => transformItem(item, index));
  return maybeValidItems.reduce((acc, item) => {
    if (acc.ok && item.ok) {
      return {
        ok: true,
        value: [...acc.value, item.value]
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!item.ok) {
      errors.push(...item.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: [] });
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/literals/stringLiteral.js
function stringLiteral2(literal) {
  const schemaCreator = createIdentitySchemaCreator2(SchemaType2.STRING_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, `"${literal}"`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/literals/booleanLiteral.js
function booleanLiteral2(literal) {
  const schemaCreator = createIdentitySchemaCreator2(SchemaType2.BOOLEAN_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, `${literal.toString()}`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/any.js
var any2 = createIdentitySchemaCreator2(SchemaType2.ANY, (value) => ({ ok: true, value }));

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/boolean.js
var boolean2 = createIdentitySchemaCreator2(SchemaType2.BOOLEAN, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "boolean") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "boolean")
        }
      ]
    };
  }
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/number.js
var number2 = createIdentitySchemaCreator2(SchemaType2.NUMBER, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "number") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "number")
        }
      ]
    };
  }
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/string.js
var string2 = createIdentitySchemaCreator2(SchemaType2.STRING, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "string") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "string")
        }
      ]
    };
  }
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/unknown.js
var unknown2 = createIdentitySchemaCreator2(SchemaType2.UNKNOWN, (value) => ({ ok: true, value }));

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/record/record.js
function record2(keySchema, valueSchema) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformRecord2({
        value: raw,
        isKeyNumeric: keySchema.getType() === SchemaType2.NUMBER,
        transformKey: (key) => keySchema.parse(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.parse(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return validateAndTransformRecord2({
        value: parsed,
        isKeyNumeric: keySchema.getType() === SchemaType2.NUMBER,
        transformKey: (key) => keySchema.json(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.json(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType2.RECORD
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}
function validateAndTransformRecord2({ value, isKeyNumeric, transformKey, transformValue, breadcrumbsPrefix = [] }) {
  if (!isPlainObject4(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "object")
        }
      ]
    };
  }
  return entries3(value).reduce((accPromise, [stringKey, value2]) => {
    if (value2 == null) {
      return accPromise;
    }
    const acc = accPromise;
    let key = stringKey;
    if (isKeyNumeric) {
      const numberKey = stringKey.length > 0 ? Number(stringKey) : NaN;
      if (!isNaN(numberKey)) {
        key = numberKey;
      }
    }
    const transformedKey = transformKey(key);
    const transformedValue = transformValue(value2, key);
    if (acc.ok && transformedKey.ok && transformedValue.ok) {
      return {
        ok: true,
        value: {
          ...acc.value,
          [transformedKey.value]: transformedValue.value
        }
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!transformedKey.ok) {
      errors.push(...transformedKey.errors);
    }
    if (!transformedValue.ok) {
      errors.push(...transformedValue.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: {} });
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/set/set.js
function set2(schema2) {
  const listSchema = list2(schema2);
  const baseSchema = {
    parse: (raw, opts) => {
      const parsedList = listSchema.parse(raw, opts);
      if (parsedList.ok) {
        return {
          ok: true,
          value: new Set(parsedList.value)
        };
      } else {
        return parsedList;
      }
    },
    json: (parsed, opts) => {
      if (!(parsed instanceof Set)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType2(parsed, "Set")
            }
          ]
        };
      }
      const jsonList = listSchema.json([...parsed], opts);
      return jsonList;
    },
    getType: () => SchemaType2.SET
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/undiscriminated-union/undiscriminatedUnion.js
function undiscriminatedUnion2(schemas) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformUndiscriminatedUnion2((schema2, opts2) => schema2.parse(raw, opts2), schemas, opts);
    },
    json: (parsed, opts) => {
      return validateAndTransformUndiscriminatedUnion2((schema2, opts2) => schema2.json(parsed, opts2), schemas, opts);
    },
    getType: () => SchemaType2.UNDISCRIMINATED_UNION
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}
function validateAndTransformUndiscriminatedUnion2(transform3, schemas, opts) {
  const errors = [];
  for (const [index, schema2] of schemas.entries()) {
    const transformed = transform3(schema2, { ...opts, skipValidation: false });
    if (transformed.ok) {
      return transformed;
    } else {
      for (const error of transformed.errors) {
        errors.push({
          path: error.path,
          message: `[Variant ${index}] ${error.message}`
        });
      }
    }
  }
  return {
    ok: false,
    errors
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/union/discriminant.js
function discriminant2(parsedDiscriminant, rawDiscriminant) {
  return {
    parsedDiscriminant,
    rawDiscriminant
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/union/union.js
function union2(discriminant3, union3) {
  const rawDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.rawDiscriminant;
  const parsedDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.parsedDiscriminant;
  const discriminantValueSchema = enum_2(keys4(union3));
  const baseSchema = {
    parse: (raw, opts) => {
      return transformAndValidateUnion2({
        value: raw,
        discriminant: rawDiscriminant,
        transformedDiscriminant: parsedDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.parse(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.parse(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return transformAndValidateUnion2({
        value: parsed,
        discriminant: parsedDiscriminant,
        transformedDiscriminant: rawDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.json(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.json(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType2.UNION
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema),
    ...getObjectLikeUtils2(baseSchema)
  };
}
function transformAndValidateUnion2({ value, discriminant: discriminant3, transformedDiscriminant, transformDiscriminantValue, getAdditionalPropertiesSchema, allowUnrecognizedUnionMembers = false, transformAdditionalProperties, breadcrumbsPrefix = [] }) {
  if (!isPlainObject4(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "object")
        }
      ]
    };
  }
  const { [discriminant3]: discriminantValue, ...additionalProperties } = value;
  if (discriminantValue == null) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: `Missing discriminant ("${discriminant3}")`
        }
      ]
    };
  }
  const transformedDiscriminantValue = transformDiscriminantValue(discriminantValue);
  if (!transformedDiscriminantValue.ok) {
    return {
      ok: false,
      errors: transformedDiscriminantValue.errors
    };
  }
  const additionalPropertiesSchema = getAdditionalPropertiesSchema(transformedDiscriminantValue.value);
  if (additionalPropertiesSchema == null) {
    if (allowUnrecognizedUnionMembers) {
      return {
        ok: true,
        value: {
          [transformedDiscriminant]: transformedDiscriminantValue.value,
          ...additionalProperties
        }
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: [...breadcrumbsPrefix, discriminant3],
            message: "Unexpected discriminant value"
          }
        ]
      };
    }
  }
  const transformedAdditionalProperties = transformAdditionalProperties(additionalProperties, additionalPropertiesSchema);
  if (!transformedAdditionalProperties.ok) {
    return transformedAdditionalProperties;
  }
  return {
    ok: true,
    value: {
      [transformedDiscriminant]: discriminantValue,
      ...transformedAdditionalProperties.value
    }
  };
}

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithDocsSchema.js
var WithDocsSchema2 = schemas_exports2.object({
  docs: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AuthSchemeReferenceSchema.js
var AuthSchemeReferenceSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AnyAuthItem.js
var AnyAuthItem2 = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), AuthSchemeReferenceSchema2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AnyAuthSchemesSchema.js
var AnyAuthSchemesSchema2 = schemas_exports2.object({
  any: schemas_exports2.list(AnyAuthItem2)
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/ApiAuthSchema.js
var ApiAuthSchema2 = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  AuthSchemeReferenceSchema2,
  AnyAuthSchemesSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthAccessTokenRequestPropertiesSchema.js
var OAuthAccessTokenRequestPropertiesSchema2 = schemas_exports2.object({
  "client-id": schemas_exports2.string().optional(),
  "client-secret": schemas_exports2.string().optional(),
  scopes: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthAccessTokenResponsePropertiesSchema.js
var OAuthAccessTokenResponsePropertiesSchema2 = schemas_exports2.object({
  "access-token": schemas_exports2.string().optional(),
  "expires-in": schemas_exports2.string().optional(),
  "refresh-token": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthGetTokenEndpointSchema.js
var OAuthGetTokenEndpointSchema2 = schemas_exports2.object({
  endpoint: schemas_exports2.string(),
  "request-properties": OAuthAccessTokenRequestPropertiesSchema2.optional(),
  "response-properties": OAuthAccessTokenResponsePropertiesSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthRefreshTokenRequestPropertiesSchema.js
var OAuthRefreshTokenRequestPropertiesSchema2 = schemas_exports2.object({
  "refresh-token": schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthRefreshTokenResponsePropertiesSchema.js
var OAuthRefreshTokenResponsePropertiesSchema2 = schemas_exports2.object({
  "access-token": schemas_exports2.string().optional(),
  "expires-in": schemas_exports2.string().optional(),
  "refresh-token": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthRefreshTokenEndpointSchema.js
var OAuthRefreshTokenEndpointSchema2 = schemas_exports2.object({
  endpoint: schemas_exports2.string(),
  "request-properties": OAuthRefreshTokenRequestPropertiesSchema2.optional(),
  "response-properties": OAuthRefreshTokenResponsePropertiesSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthSchemeSchema.js
var OAuthSchemeSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.stringLiteral("oauth"),
  type: schemas_exports2.stringLiteral("client-credentials"),
  scopes: schemas_exports2.list(schemas_exports2.string()).optional(),
  "client-id-env": schemas_exports2.string().optional(),
  "client-secret-env": schemas_exports2.string().optional(),
  "token-prefix": schemas_exports2.string().optional(),
  "token-header": schemas_exports2.string().optional(),
  "get-token": OAuthGetTokenEndpointSchema2,
  "refresh-token": OAuthRefreshTokenEndpointSchema2.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/WithEnvironmentVariable.js
var WithEnvironmentVariable2 = schemas_exports2.object({
  env: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithName.js
var WithName2 = schemas_exports2.object({
  name: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/HeaderAuthSchemeSchema.js
var HeaderAuthSchemeSchema2 = schemas_exports2.object({
  header: schemas_exports2.string(),
  type: schemas_exports2.string().optional(),
  prefix: schemas_exports2.string().optional()
}).extend(WithEnvironmentVariable2).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AuthVariable.js
var AuthVariable2 = schemas_exports2.object({}).extend(WithEnvironmentVariable2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/BasicAuthSchemeSchema.js
var BasicAuthSchemeSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.stringLiteral("basic"),
  username: AuthVariable2.optional(),
  password: AuthVariable2.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/BearerAuthSchemeSchema.js
var BearerAuthSchemeSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.stringLiteral("bearer"),
  token: AuthVariable2.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AuthSchemeDeclarationSchema.js
var AuthSchemeDeclarationSchema2 = schemas_exports2.undiscriminatedUnion([
  OAuthSchemeSchema2,
  HeaderAuthSchemeSchema2,
  BasicAuthSchemeSchema2,
  BearerAuthSchemeSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/WithAuthSchema.js
var WithAuthSchema = schemas_exports2.object({
  auth: ApiAuthSchema2.optional(),
  "auth-schemes": schemas_exports2.record(schemas_exports2.string(), AuthSchemeDeclarationSchema2).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/index.js
var availability_exports4 = {};
__export(availability_exports4, {
  AvailabilitySchema: () => AvailabilitySchema2,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema4,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema4 = schemas_exports2.enum_(["in-development", "pre-release", "deprecated", "generally-available"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/types/AvailabilitySchema.js
var AvailabilitySchema2 = schemas_exports2.object({
  status: AvailabilityStatusSchema4,
  message: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/types/AvailabilityUnionSchema.js
var AvailabilityUnionSchema2 = schemas_exports2.undiscriminatedUnion([AvailabilityStatusSchema4, AvailabilitySchema2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/index.js
var commons_exports5 = {};
__export(commons_exports5, {
  DeclarationSchema: () => DeclarationSchema,
  DeclarationWithNameSchema: () => DeclarationWithNameSchema,
  DeclarationWithoutDocsSchema: () => DeclarationWithoutDocsSchema,
  WithAudiences: () => WithAudiences2,
  WithAvailability: () => WithAvailability2,
  WithDisplayName: () => WithDisplayName,
  WithDocsSchema: () => WithDocsSchema2,
  WithName: () => WithName2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithAvailability.js
var WithAvailability2 = schemas_exports2.object({
  availability: AvailabilityUnionSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithDisplayName.js
var WithDisplayName = schemas_exports2.object({
  "display-name": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithAudiences.js
var WithAudiences2 = schemas_exports2.object({
  audiences: schemas_exports2.list(schemas_exports2.string()).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/DeclarationSchema.js
var DeclarationSchema = schemas_exports2.object({}).extend(WithDocsSchema2).extend(WithAvailability2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/DeclarationWithoutDocsSchema.js
var DeclarationWithoutDocsSchema = schemas_exports2.object({}).extend(WithAvailability2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/DeclarationWithNameSchema.js
var DeclarationWithNameSchema = schemas_exports2.object({}).extend(DeclarationSchema).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/encoding/index.js
var encoding_exports4 = {};
__export(encoding_exports4, {
  EncodingSchema: () => EncodingSchema2,
  ProtobufTypeSchema: () => ProtobufTypeSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/encoding/types/ProtobufTypeSchema.js
var ProtobufTypeSchema2 = schemas_exports2.object({
  type: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/encoding/types/EncodingSchema.js
var EncodingSchema2 = schemas_exports2.object({
  proto: ProtobufTypeSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/index.js
var environments_exports4 = {};
__export(environments_exports4, {
  EnvironmentSchema: () => EnvironmentSchema2,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema2,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema2,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/SingleBaseUrlEnvironmentSchema.js
var SingleBaseUrlEnvironmentSchema2 = schemas_exports2.object({
  url: schemas_exports2.string()
}).extend(WithAudiences2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/MultipleBaseUrlsEnvironmentSchema.js
var MultipleBaseUrlsEnvironmentSchema2 = schemas_exports2.object({
  urls: schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string())
}).extend(WithAudiences2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/EnvironmentSchema.js
var EnvironmentSchema2 = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  SingleBaseUrlEnvironmentSchema2,
  MultipleBaseUrlsEnvironmentSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/WithEnvironmentsSchema.js
var WithEnvironmentsSchema2 = schemas_exports2.object({
  "default-url": schemas_exports2.string().optional(),
  "default-environment": schemas_exports2.string().optional(),
  environments: schemas_exports2.record(schemas_exports2.string(), EnvironmentSchema2).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/errors/index.js
var errors_exports3 = {};
__export(errors_exports3, {
  ErrorDeclarationSchema: () => ErrorDeclarationSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleTypeValueSchema.js
var ExampleTypeValueSchema = schemas_exports2.unknown();

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleTypeSchema.js
var ExampleTypeSchema = schemas_exports2.object({
  value: ExampleTypeValueSchema
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/errors/types/ErrorDeclarationSchema.js
var ErrorDeclarationSchema = schemas_exports2.object({
  "status-code": schemas_exports2.number(),
  type: schemas_exports2.string().optional(),
  examples: schemas_exports2.list(ExampleTypeSchema).optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/index.js
var examples_exports3 = {};
__export(examples_exports3, {
  ExampleBodyResponseSchema: () => ExampleBodyResponseSchema,
  ExampleCodeSampleSchema: () => ExampleCodeSampleSchema,
  ExampleCodeSampleSchemaLanguage: () => ExampleCodeSampleSchemaLanguage,
  ExampleCodeSampleSchemaSdk: () => ExampleCodeSampleSchemaSdk,
  ExampleEndpointCallArraySchema: () => ExampleEndpointCallArraySchema,
  ExampleEndpointCallSchema: () => ExampleEndpointCallSchema,
  ExampleResponseSchema: () => ExampleResponseSchema,
  ExampleSseEventSchema: () => ExampleSseEventSchema,
  ExampleSseResponseSchema: () => ExampleSseResponseSchema,
  ExampleStreamResponseSchema: () => ExampleStreamResponseSchema,
  ExampleTypeReferenceSchema: () => ExampleTypeReferenceSchema,
  ExampleTypeSchema: () => ExampleTypeSchema,
  ExampleTypeValueSchema: () => ExampleTypeValueSchema,
  ExampleWebSocketMessage: () => ExampleWebSocketMessage,
  ExampleWebSocketSession: () => ExampleWebSocketSession,
  ExampleWebhookCallSchema: () => ExampleWebhookCallSchema,
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleTypeReferenceSchema.js
var ExampleTypeReferenceSchema = schemas_exports2.unknown();

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleWebSocketMessage.js
var ExampleWebSocketMessage = schemas_exports2.object({
  type: schemas_exports2.string(),
  body: schemas_exports2.unknown()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleWebSocketSession.js
var ExampleWebSocketSession = schemas_exports2.object({
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  messages: schemas_exports2.list(ExampleWebSocketMessage)
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleBodyResponseSchema.js
var ExampleBodyResponseSchema = schemas_exports2.object({
  error: schemas_exports2.string().optional(),
  body: ExampleTypeReferenceSchema.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleStreamResponseSchema.js
var ExampleStreamResponseSchema = schemas_exports2.object({
  stream: schemas_exports2.list(ExampleTypeReferenceSchema)
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleSseEventSchema.js
var ExampleSseEventSchema = schemas_exports2.object({
  event: schemas_exports2.string(),
  data: ExampleTypeReferenceSchema.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleSseResponseSchema.js
var ExampleSseResponseSchema = schemas_exports2.object({
  stream: schemas_exports2.list(ExampleSseEventSchema)
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleResponseSchema.js
var ExampleResponseSchema = schemas_exports2.undiscriminatedUnion([
  ExampleBodyResponseSchema,
  ExampleStreamResponseSchema,
  ExampleSseResponseSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/SupportedSdkLanguageSchema.js
var SupportedSdkLanguageSchema2 = schemas_exports2.enum_([
  "curl",
  "python",
  "javascript",
  "typescript",
  "go",
  "ruby",
  "csharp",
  "java",
  "js",
  "node",
  "ts",
  "nodets",
  "golang",
  "dotnet",
  "jvm",
  "c#"
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleCodeSampleSchemaSdk.js
var ExampleCodeSampleSchemaSdk = schemas_exports2.object({
  sdk: SupportedSdkLanguageSchema2,
  code: schemas_exports2.string()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleCodeSampleSchemaLanguage.js
var ExampleCodeSampleSchemaLanguage = schemas_exports2.object({
  language: schemas_exports2.string(),
  code: schemas_exports2.string(),
  install: schemas_exports2.string().optional()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleCodeSampleSchema.js
var ExampleCodeSampleSchema = schemas_exports2.undiscriminatedUnion([ExampleCodeSampleSchemaSdk, ExampleCodeSampleSchemaLanguage]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleEndpointCallSchema.js
var ExampleEndpointCallSchema = schemas_exports2.object({
  id: schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  request: ExampleTypeReferenceSchema.optional(),
  response: ExampleResponseSchema.optional(),
  "code-samples": schemas_exports2.list(ExampleCodeSampleSchema).optional()
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleEndpointCallArraySchema.js
var ExampleEndpointCallArraySchema = schemas_exports2.list(ExampleEndpointCallSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleWebhookCallSchema.js
var ExampleWebhookCallSchema = schemas_exports2.object({
  id: schemas_exports2.string().optional(),
  payload: ExampleTypeReferenceSchema
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/index.js
var file_exports4 = {};
__export(file_exports4, {
  DefinitionFileSchema: () => DefinitionFileSchema,
  ErrorDiscriminationSchema: () => ErrorDiscriminationSchema,
  Export: () => Export,
  ExportDetailed: () => ExportDetailed,
  Navigation: () => Navigation,
  PackageMarkerFileSchema: () => PackageMarkerFileSchema,
  PropertyBasedErrorDiscrimination: () => PropertyBasedErrorDiscrimination,
  RootApiFileSchema: () => RootApiFileSchema,
  StatusCodeBasedErrorDiscrimination: () => StatusCodeBasedErrorDiscrimination,
  WithHeadersSchema: () => WithHeadersSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/ObjectExtendsSchema.js
var ObjectExtendsSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  schemas_exports2.list(schemas_exports2.string())
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/types/StringValidationSchema.js
var StringValidationSchema2 = schemas_exports2.object({
  minLength: schemas_exports2.number().optional(),
  maxLength: schemas_exports2.number().optional(),
  pattern: schemas_exports2.string().optional(),
  format: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/types/NumberValidationSchema.js
var NumberValidationSchema2 = schemas_exports2.object({
  min: schemas_exports2.number().optional(),
  max: schemas_exports2.number().optional(),
  exclusiveMin: schemas_exports2.boolean().optional(),
  exclusiveMax: schemas_exports2.boolean().optional(),
  multipleOf: schemas_exports2.number().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/types/ValidationSchema.js
var ValidationSchema2 = schemas_exports2.undiscriminatedUnion([StringValidationSchema2, NumberValidationSchema2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/BaseTypeReferenceSchema.js
var BaseTypeReferenceSchema2 = schemas_exports2.object({
  default: schemas_exports2.unknown().optional(),
  encoding: EncodingSchema2.optional(),
  validation: ValidationSchema2.optional()
}).extend(WithDocsSchema2).extend(WithAvailability2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceDeclarationWithName.js
var TypeReferenceDeclarationWithName2 = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(BaseTypeReferenceSchema2).extend(WithName2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceDeclarationWithNameSchema.js
var TypeReferenceDeclarationWithNameSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), TypeReferenceDeclarationWithName2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/ObjectPropertySchema.js
var ObjectPropertySchema = TypeReferenceDeclarationWithNameSchema;

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/types/OpenApiSourceSchema.js
var OpenApiSourceSchema = schemas_exports2.object({
  openapi: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/types/ProtobufSourceSchema.js
var ProtobufSourceSchema = schemas_exports2.object({
  proto: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/types/SourceSchema.js
var SourceSchema = schemas_exports2.undiscriminatedUnion([OpenApiSourceSchema, ProtobufSourceSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/BaseTypeDeclarationSchema.js
var BaseTypeDeclarationSchema = schemas_exports2.object({
  examples: schemas_exports2.list(ExampleTypeSchema).optional(),
  encoding: EncodingSchema2.optional(),
  source: SourceSchema.optional(),
  inline: schemas_exports2.boolean().optional()
}).extend(WithDocsSchema2).extend(WithAvailability2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/ObjectSchema.js
var ObjectSchema = schemas_exports2.object({
  extends: ObjectExtendsSchema.optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), ObjectPropertySchema).optional(),
  "extra-properties": schemas_exports2.boolean().optional()
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/CasingOverridesSchema.js
var CasingOverridesSchema = schemas_exports2.object({
  camel: schemas_exports2.string().optional(),
  snake: schemas_exports2.string().optional(),
  pascal: schemas_exports2.string().optional(),
  "screaming-snake": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/EnumValueSchema.js
var EnumValueSchema = schemas_exports2.object({
  value: schemas_exports2.string(),
  casing: CasingOverridesSchema.optional()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/EnumValue.js
var EnumValue = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), EnumValueSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/EnumSchema.js
var EnumSchema = schemas_exports2.object({
  default: schemas_exports2.string().optional(),
  enum: schemas_exports2.list(EnumValue)
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/UnionDiscriminantSchema.js
var UnionDiscriminantSchema = schemas_exports2.object({
  value: schemas_exports2.string()
}).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/UnionDiscriminant.js
var UnionDiscriminant = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), UnionDiscriminantSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceDetailedSchema.js
var TypeReferenceDetailedSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(BaseTypeReferenceSchema2).extend(WithName2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceSchema.js
var TypeReferenceSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), TypeReferenceDetailedSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeKeySchema.js
var SingleUnionTypeKeySchema = schemas_exports2.object({
  value: schemas_exports2.string()
}).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeKey.js
var SingleUnionTypeKey = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), SingleUnionTypeKeySchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeDetailedSchema.js
var SingleUnionTypeDetailedSchema = schemas_exports2.object({
  type: schemas_exports2.string().optional(),
  key: SingleUnionTypeKey.optional()
}).extend(WithDocsSchema2).extend(WithName2).extend(WithAvailability2).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeSchema.js
var SingleUnionTypeSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), SingleUnionTypeDetailedSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/DiscriminatedUnionSchema.js
var DiscriminatedUnionSchema = schemas_exports2.object({
  discriminant: UnionDiscriminant.optional(),
  extends: ObjectExtendsSchema.optional(),
  "base-properties": schemas_exports2.record(schemas_exports2.string(), TypeReferenceSchema).optional(),
  union: schemas_exports2.record(schemas_exports2.string(), SingleUnionTypeSchema)
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUndiscriminatedUnionTypeDetailedSchema.js
var SingleUndiscriminatedUnionTypeDetailedSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUndiscriminatedUnionTypeSchema.js
var SingleUndiscriminatedUnionTypeSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  SingleUndiscriminatedUnionTypeDetailedSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/UndiscriminatedUnionSchema.js
var UndiscriminatedUnionSchema = schemas_exports2.object({
  discriminated: schemas_exports2.booleanLiteral(false),
  union: schemas_exports2.list(SingleUndiscriminatedUnionTypeSchema)
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/AliasSchema.js
var AliasSchema = schemas_exports2.object({
  type: schemas_exports2.string(),
  validation: ValidationSchema2.optional()
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeDeclarationSchema.js
var TypeDeclarationSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  ObjectSchema,
  EnumSchema,
  DiscriminatedUnionSchema,
  UndiscriminatedUnionSchema,
  AliasSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/GrpcTransport.js
var GrpcTransport = schemas_exports2.object({
  "service-name": schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ServiceTransport.js
var ServiceTransport = schemas_exports2.object({
  grpc: GrpcTransport.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpMethodSchema.js
var HttpMethodSchema2 = schemas_exports2.enum_(["GET", "POST", "PUT", "PATCH", "DELETE"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/types/VariableReferenceSchema.js
var VariableReferenceSchema = schemas_exports2.object({
  variable: schemas_exports2.string()
}).extend(WithAvailability2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpPathParameterSchema.js
var HttpPathParameterSchema = schemas_exports2.undiscriminatedUnion([TypeReferenceSchema, VariableReferenceSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/QueryParameterTypeReferenceDetailed.js
var QueryParameterTypeReferenceDetailed = schemas_exports2.object({
  "allow-multiple": schemas_exports2.boolean().optional()
}).extend(TypeReferenceDeclarationWithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpQueryParameterSchema.js
var HttpQueryParameterSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), QueryParameterTypeReferenceDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/TypeReferenceDeclarationWithEnvOverrideSchema.js
var TypeReferenceDeclarationWithEnvOverrideSchema2 = schemas_exports2.object({
  env: schemas_exports2.string().optional()
}).extend(TypeReferenceDeclarationWithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/TypeReferenceDeclarationWithEnvOverride.js
var TypeReferenceDeclarationWithEnvOverride2 = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  TypeReferenceDeclarationWithEnvOverrideSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpHeaderSchema.js
var HttpHeaderSchema2 = TypeReferenceDeclarationWithEnvOverride2;

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpReferencedRequestBodySchema.js
var HttpReferencedRequestBodySchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/TypeReferenceDeclarationWithContentTypeSchema.js
var TypeReferenceDeclarationWithContentTypeSchema = schemas_exports2.object({
  "content-type": schemas_exports2.string().optional()
}).extend(TypeReferenceDeclarationWithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpInlineRequestBodyPropertySchema.js
var HttpInlineRequestBodyPropertySchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  TypeReferenceDeclarationWithContentTypeSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpInlineRequestBodySchema.js
var HttpInlineRequestBodySchema = schemas_exports2.object({
  extends: ObjectExtendsSchema.optional(),
  "extra-properties": schemas_exports2.boolean().optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), HttpInlineRequestBodyPropertySchema).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpRequestBodySchema.js
var HttpRequestBodySchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  HttpReferencedRequestBodySchema,
  HttpInlineRequestBodySchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpRequestSchema.js
var HttpRequestSchema = schemas_exports2.object({
  "content-type": schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), HttpQueryParameterSchema).optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  body: HttpRequestBodySchema.optional()
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpRequest.js
var HttpRequest = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), HttpRequestSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseSchemaDetailed.js
var HttpResponseSchemaDetailed = schemas_exports2.object({
  type: schemas_exports2.string(),
  property: schemas_exports2.string().optional(),
  "status-code": schemas_exports2.number().optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseSchema.js
var HttpResponseSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), HttpResponseSchemaDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/StreamFormat.js
var StreamFormat2 = schemas_exports2.enum_(["sse", "json"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseStreamSchemaDetailed.js
var HttpResponseStreamSchemaDetailed = schemas_exports2.object({
  type: schemas_exports2.string(),
  format: StreamFormat2.optional(),
  terminator: schemas_exports2.string().optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseStreamSchema.js
var HttpResponseStreamSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), HttpResponseStreamSchemaDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ResponseErrorWithDocsSchema.js
var ResponseErrorWithDocsSchema = schemas_exports2.object({
  error: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ResponseError.js
var ResponseError = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), ResponseErrorWithDocsSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ResponseErrorsSchema.js
var ResponseErrorsSchema = schemas_exports2.list(ResponseError);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/types/CursorPaginationSchema.js
var CursorPaginationSchema = schemas_exports2.object({
  cursor: schemas_exports2.string(),
  next_cursor: schemas_exports2.string(),
  results: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/types/OffsetPaginationSchema.js
var OffsetPaginationSchema = schemas_exports2.object({
  offset: schemas_exports2.string(),
  results: schemas_exports2.string(),
  step: schemas_exports2.string().optional(),
  "has-next-page": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/types/PaginationSchema.js
var PaginationSchema = schemas_exports2.undiscriminatedUnion([CursorPaginationSchema, OffsetPaginationSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/Pagination.js
var Pagination2 = schemas_exports2.undiscriminatedUnion([PaginationSchema, schemas_exports2.boolean()]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpEndpointSchema.js
var HttpEndpointSchema = schemas_exports2.object({
  method: HttpMethodSchema2.optional(),
  "base-path": schemas_exports2.string().optional(),
  path: schemas_exports2.string(),
  url: schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  auth: schemas_exports2.boolean().optional(),
  idempotent: schemas_exports2.boolean().optional(),
  "stream-condition": schemas_exports2.string().optional(),
  request: HttpRequest.optional(),
  response: HttpResponseSchema.optional(),
  "response-stream": HttpResponseStreamSchema.optional(),
  errors: ResponseErrorsSchema.optional(),
  examples: schemas_exports2.list(ExampleEndpointCallSchema).optional(),
  pagination: Pagination2.optional(),
  transport: ServiceTransport.optional(),
  source: SourceSchema.optional()
}).extend(WithDisplayName).extend(DeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpServiceSchema.js
var HttpServiceSchema = schemas_exports2.object({
  auth: schemas_exports2.boolean(),
  url: schemas_exports2.string().optional(),
  "base-path": schemas_exports2.string(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string()).optional(),
  idempotent: schemas_exports2.boolean().optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), TypeReferenceSchema).optional(),
  transport: ServiceTransport.optional(),
  source: SourceSchema.optional(),
  endpoints: schemas_exports2.record(schemas_exports2.string(), HttpEndpointSchema)
}).extend(DeclarationWithoutDocsSchema).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookMethodSchema.js
var WebhookMethodSchema2 = schemas_exports2.enum_(["POST", "GET"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookReferencedPayloadSchema.js
var WebhookReferencedPayloadSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookInlinedPayloadSchema.js
var WebhookInlinedPayloadSchema = schemas_exports2.object({
  name: schemas_exports2.string(),
  extends: ObjectExtendsSchema.optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), ObjectPropertySchema).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookPayloadSchema.js
var WebhookPayloadSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  WebhookReferencedPayloadSchema,
  WebhookInlinedPayloadSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookSchema.js
var WebhookSchema = schemas_exports2.object({
  method: WebhookMethodSchema2,
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  payload: WebhookPayloadSchema,
  examples: schemas_exports2.list(ExampleWebhookCallSchema).optional()
}).extend(WithAvailability2).extend(WithAudiences2).extend(WithDocsSchema2).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketOrigin.js
var WebSocketOrigin2 = schemas_exports2.enum_(["client", "server"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelReferencedMessageSchema.js
var WebSocketChannelReferencedMessageSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelInlinedMessageSchema.js
var WebSocketChannelInlinedMessageSchema = schemas_exports2.object({
  name: schemas_exports2.string(),
  extends: ObjectExtendsSchema.optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), ObjectPropertySchema).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelMessageBodySchema.js
var WebSocketChannelMessageBodySchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  WebSocketChannelReferencedMessageSchema,
  WebSocketChannelInlinedMessageSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelMessageSchema.js
var WebSocketChannelMessageSchema = schemas_exports2.object({
  origin: WebSocketOrigin2,
  body: WebSocketChannelMessageBodySchema
}).extend(DeclarationSchema).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelSchema.js
var WebSocketChannelSchema = schemas_exports2.object({
  auth: schemas_exports2.boolean(),
  path: schemas_exports2.string(),
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), HttpQueryParameterSchema).optional(),
  messages: schemas_exports2.record(schemas_exports2.string(), WebSocketChannelMessageSchema).optional(),
  examples: schemas_exports2.list(ExampleWebSocketSession).optional()
}).extend(DeclarationSchema).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/DefinitionFileSchema.js
var DefinitionFileSchema = schemas_exports2.object({
  imports: schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string()).optional(),
  types: schemas_exports2.record(schemas_exports2.string(), TypeDeclarationSchema).optional(),
  service: HttpServiceSchema.optional(),
  errors: schemas_exports2.record(schemas_exports2.string(), ErrorDeclarationSchema).optional(),
  webhooks: schemas_exports2.record(schemas_exports2.string(), WebhookSchema).optional(),
  channel: WebSocketChannelSchema.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/Navigation.js
var Navigation = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  schemas_exports2.list(schemas_exports2.string())
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/ExportDetailed.js
var ExportDetailed = schemas_exports2.object({
  dependency: schemas_exports2.string(),
  url: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/Export.js
var Export = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), ExportDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/PackageMarkerFileSchema.js
var PackageMarkerFileSchema = schemas_exports2.object({
  navigation: Navigation.optional(),
  export: Export.optional()
}).extend(DefinitionFileSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/WithHeadersSchema.js
var WithHeadersSchema2 = schemas_exports2.object({
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/PropertyBasedErrorDiscrimination.js
var PropertyBasedErrorDiscrimination = schemas_exports2.object({
  strategy: schemas_exports2.stringLiteral("property"),
  "property-name": schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/StatusCodeBasedErrorDiscrimination.js
var StatusCodeBasedErrorDiscrimination = schemas_exports2.object({
  strategy: schemas_exports2.stringLiteral("status-code")
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/ErrorDiscriminationSchema.js
var ErrorDiscriminationSchema = schemas_exports2.undiscriminatedUnion([PropertyBasedErrorDiscrimination, StatusCodeBasedErrorDiscrimination]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/types/VariableDeclarationDetailed.js
var VariableDeclarationDetailed = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/types/VariableDeclarationSchema.js
var VariableDeclarationSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), VariableDeclarationDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionValueDetailed.js
var VersionValueDetailed = schemas_exports2.object({
  value: schemas_exports2.string()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionValue.js
var VersionValue = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), VersionValueDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionDeclarationHeaderObjectSchema.js
var VersionDeclarationHeaderObjectSchema = schemas_exports2.object({
  name: schemas_exports2.string().optional(),
  env: schemas_exports2.string().optional(),
  value: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionDeclarationHeaderSchema.js
var VersionDeclarationHeaderSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), VersionDeclarationHeaderObjectSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionDeclarationSchema.js
var VersionDeclarationSchema = schemas_exports2.object({
  default: schemas_exports2.string().optional(),
  values: schemas_exports2.list(VersionValue),
  header: VersionDeclarationHeaderSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/RootApiFileSchema.js
var RootApiFileSchema = schemas_exports2.object({
  name: schemas_exports2.string(),
  imports: schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string()).optional(),
  "error-discrimination": ErrorDiscriminationSchema.optional(),
  audiences: schemas_exports2.list(schemas_exports2.string()).optional(),
  errors: schemas_exports2.list(schemas_exports2.string()).optional(),
  "base-path": schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  "idempotency-headers": schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  variables: schemas_exports2.record(schemas_exports2.string(), VariableDeclarationSchema).optional(),
  pagination: PaginationSchema.optional(),
  version: VersionDeclarationSchema.optional()
}).extend(WithDocsSchema2).extend(WithDisplayName).extend(WithEnvironmentsSchema2).extend(WithAuthSchema).extend(WithHeadersSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/index.js
var pagination_exports2 = {};
__export(pagination_exports2, {
  CursorPaginationSchema: () => CursorPaginationSchema,
  OffsetPaginationSchema: () => OffsetPaginationSchema,
  PaginationSchema: () => PaginationSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/index.js
var service_exports4 = {};
__export(service_exports4, {
  GrpcTransport: () => GrpcTransport,
  HttpEndpointSchema: () => HttpEndpointSchema,
  HttpHeaderSchema: () => HttpHeaderSchema2,
  HttpInlineRequestBodyPropertySchema: () => HttpInlineRequestBodyPropertySchema,
  HttpInlineRequestBodySchema: () => HttpInlineRequestBodySchema,
  HttpMethodSchema: () => HttpMethodSchema2,
  HttpPathParameterSchema: () => HttpPathParameterSchema,
  HttpQueryParameterSchema: () => HttpQueryParameterSchema,
  HttpReferencedRequestBodySchema: () => HttpReferencedRequestBodySchema,
  HttpRequest: () => HttpRequest,
  HttpRequestBodySchema: () => HttpRequestBodySchema,
  HttpRequestSchema: () => HttpRequestSchema,
  HttpResponseSchema: () => HttpResponseSchema,
  HttpResponseSchemaDetailed: () => HttpResponseSchemaDetailed,
  HttpResponseStreamSchema: () => HttpResponseStreamSchema,
  HttpResponseStreamSchemaDetailed: () => HttpResponseStreamSchemaDetailed,
  HttpServiceSchema: () => HttpServiceSchema,
  Pagination: () => Pagination2,
  QueryParameterTypeReferenceDetailed: () => QueryParameterTypeReferenceDetailed,
  ResponseError: () => ResponseError,
  ResponseErrorWithDocsSchema: () => ResponseErrorWithDocsSchema,
  ResponseErrorsSchema: () => ResponseErrorsSchema,
  ServiceTransport: () => ServiceTransport,
  StreamFormat: () => StreamFormat2,
  TypeReferenceDeclarationWithContentTypeSchema: () => TypeReferenceDeclarationWithContentTypeSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride2,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/index.js
var source_exports2 = {};
__export(source_exports2, {
  OpenApiSourceSchema: () => OpenApiSourceSchema,
  ProtobufSourceSchema: () => ProtobufSourceSchema,
  SourceSchema: () => SourceSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/index.js
var types_exports6 = {};
__export(types_exports6, {
  AliasSchema: () => AliasSchema,
  BaseTypeDeclarationSchema: () => BaseTypeDeclarationSchema,
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema2,
  CasingOverridesSchema: () => CasingOverridesSchema,
  DiscriminatedUnionSchema: () => DiscriminatedUnionSchema,
  EnumSchema: () => EnumSchema,
  EnumValue: () => EnumValue,
  EnumValueSchema: () => EnumValueSchema,
  ObjectExtendsSchema: () => ObjectExtendsSchema,
  ObjectPropertySchema: () => ObjectPropertySchema,
  ObjectSchema: () => ObjectSchema,
  SingleUndiscriminatedUnionTypeDetailedSchema: () => SingleUndiscriminatedUnionTypeDetailedSchema,
  SingleUndiscriminatedUnionTypeSchema: () => SingleUndiscriminatedUnionTypeSchema,
  SingleUnionTypeDetailedSchema: () => SingleUnionTypeDetailedSchema,
  SingleUnionTypeKey: () => SingleUnionTypeKey,
  SingleUnionTypeKeySchema: () => SingleUnionTypeKeySchema,
  SingleUnionTypeSchema: () => SingleUnionTypeSchema,
  TypeDeclarationSchema: () => TypeDeclarationSchema,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName2,
  TypeReferenceDeclarationWithNameSchema: () => TypeReferenceDeclarationWithNameSchema,
  TypeReferenceDetailedSchema: () => TypeReferenceDetailedSchema,
  TypeReferenceSchema: () => TypeReferenceSchema,
  UndiscriminatedUnionSchema: () => UndiscriminatedUnionSchema,
  UnionDiscriminant: () => UnionDiscriminant,
  UnionDiscriminantSchema: () => UnionDiscriminantSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/index.js
var validation_exports4 = {};
__export(validation_exports4, {
  NumberValidationSchema: () => NumberValidationSchema2,
  StringValidationSchema: () => StringValidationSchema2,
  ValidationSchema: () => ValidationSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/index.js
var variables_exports3 = {};
__export(variables_exports3, {
  VariableDeclarationDetailed: () => VariableDeclarationDetailed,
  VariableDeclarationSchema: () => VariableDeclarationSchema,
  VariableReferenceSchema: () => VariableReferenceSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/index.js
var versioning_exports2 = {};
__export(versioning_exports2, {
  VersionDeclarationHeaderObjectSchema: () => VersionDeclarationHeaderObjectSchema,
  VersionDeclarationHeaderSchema: () => VersionDeclarationHeaderSchema,
  VersionDeclarationSchema: () => VersionDeclarationSchema,
  VersionValue: () => VersionValue,
  VersionValueDetailed: () => VersionValueDetailed
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/index.js
var webhooks_exports3 = {};
__export(webhooks_exports3, {
  WebhookInlinedPayloadSchema: () => WebhookInlinedPayloadSchema,
  WebhookMethodSchema: () => WebhookMethodSchema2,
  WebhookPayloadSchema: () => WebhookPayloadSchema,
  WebhookReferencedPayloadSchema: () => WebhookReferencedPayloadSchema,
  WebhookSchema: () => WebhookSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/index.js
var websocket_exports3 = {};
__export(websocket_exports3, {
  WebSocketChannelInlinedMessageSchema: () => WebSocketChannelInlinedMessageSchema,
  WebSocketChannelMessageBodySchema: () => WebSocketChannelMessageBodySchema,
  WebSocketChannelMessageSchema: () => WebSocketChannelMessageSchema,
  WebSocketChannelReferencedMessageSchema: () => WebSocketChannelReferencedMessageSchema,
  WebSocketChannelSchema: () => WebSocketChannelSchema,
  WebSocketOrigin: () => WebSocketOrigin2
});

// ../../cli/fern-definition/schema/lib/schemas/errors/FernDefinitionError.js
var FernDefinitionError = class _FernDefinitionError extends Error {
  statusCode;
  body;
  constructor({ message, statusCode, body }) {
    super(buildMessage({ message, statusCode, body }));
    Object.setPrototypeOf(this, _FernDefinitionError.prototype);
    if (statusCode != null) {
      this.statusCode = statusCode;
    }
    if (body !== void 0) {
      this.body = body;
    }
  }
};
function buildMessage({ message, statusCode, body }) {
  let lines = [];
  if (message != null) {
    lines.push(message);
  }
  if (statusCode != null) {
    lines.push(`Status code: ${statusCode.toString()}`);
  }
  if (body != null) {
    lines.push(`Body: ${JSON.stringify(body, void 0, 2)}`);
  }
  return lines.join("\n");
}

// ../../cli/fern-definition/schema/lib/schemas/errors/FernDefinitionTimeoutError.js
var FernDefinitionTimeoutError = class _FernDefinitionTimeoutError extends Error {
  constructor() {
    super("Timeout");
    Object.setPrototypeOf(this, _FernDefinitionTimeoutError.prototype);
  }
};

// ../../cli/fern-definition/schema/lib/utils/RawContainerType.js
var RawContainerType = {
  optional: "optional",
  set: "set",
  list: "list",
  map: "map",
  literal: "literal"
};
var RawContainerTypes = new Set(Object.values(RawContainerType));

// ../../cli/fern-definition/schema/lib/utils/generics/parseGeneric.js
function parseGeneric(name) {
  const genericMatch = name.match(/([\w.]+)<([\w,\s]+)>/);
  if (genericMatch?.[0] != null && genericMatch[1] != null && genericMatch[2] != null && !RawContainerTypes.has(genericMatch[1].trim())) {
    return {
      name: genericMatch[1].trim(),
      arguments: genericMatch[2].split(",").map((arg) => arg.trim())
    };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/generics/isGeneric.js
function isGeneric(name) {
  return parseGeneric(name) != null;
}

// ../../cli/fern-definition/schema/lib/utils/isInlineRequestBody.js
function isInlineRequestBody(requestBody) {
  if (typeof requestBody === "string") {
    return false;
  }
  return (
    // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
    requestBody?.extends != null || // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
    requestBody?.properties != null
  );
}

// ../../cli/fern-definition/schema/lib/utils/isRawProtobufSourceSchema.js
function isRawProtobufSourceSchema(rawSourceSchema) {
  if (!rawSourceSchema) {
    return false;
  }
  return rawSourceSchema.proto != null;
}

// ../../cli/fern-definition/schema/lib/utils/isRawTextType.js
var TEXT_TYPE = "text";
function isRawTextType(typeReference) {
  return typeReference === TEXT_TYPE;
}

// ../../cli/fern-definition/schema/lib/utils/RawPrimitiveType.js
var RawPrimitiveType = {
  integer: "integer",
  long: "long",
  uint: "uint",
  uint64: "uint64",
  float: "float",
  double: "double",
  boolean: "boolean",
  string: "string",
  datetime: "datetime",
  base64: "base64",
  uuid: "uuid",
  date: "date",
  bigint: "bigint",
  unknown: "unknown"
};

// ../../cli/fern-definition/schema/lib/utils/visitRawTypeReference.js
var FernContainerRegex = {
  MAP: /^map<\s*([^,]*)\s*,\s*(.*)\s*>$/,
  LIST: /^list<\s*(.*)\s*>$/,
  SET: /^set<\s*(.*)\s*>$/,
  OPTIONAL: /^optional<\s*(.*)\s*>$/,
  LITERAL: /^literal<\s*(?:"(.*)"|(true|false))\s*>$/
};
function visitRawTypeReference({ type: type2, _default: _default2, validation, visitor }) {
  switch (type2) {
    case RawPrimitiveType.integer: {
      const maybeNumberValidation2 = validation != null ? validation : void 0;
      return visitor.primitive({
        v1: PrimitiveTypeV1.Integer,
        v2: PrimitiveTypeV2.integer({
          default: _default2 != null ? _default2 : void 0,
          validation: maybeNumberValidation2 != null ? {
            min: maybeNumberValidation2.min,
            max: maybeNumberValidation2.max,
            exclusiveMin: maybeNumberValidation2.exclusiveMin,
            exclusiveMax: maybeNumberValidation2.exclusiveMax,
            multipleOf: maybeNumberValidation2.multipleOf
          } : void 0
        })
      });
    }
    case RawPrimitiveType.double: {
      const maybeNumberValidation2 = validation != null ? validation : void 0;
      return visitor.primitive({
        v1: PrimitiveTypeV1.Double,
        v2: PrimitiveTypeV2.double({
          default: _default2 != null ? _default2 : void 0,
          validation: maybeNumberValidation2 != null ? {
            min: maybeNumberValidation2.min,
            max: maybeNumberValidation2.max,
            exclusiveMin: maybeNumberValidation2.exclusiveMin,
            exclusiveMax: maybeNumberValidation2.exclusiveMax,
            multipleOf: maybeNumberValidation2.multipleOf
          } : void 0
        })
      });
    }
    case RawPrimitiveType.string: {
      const maybeStringValidation3 = validation != null ? validation : void 0;
      return visitor.primitive({
        v1: PrimitiveTypeV1.String,
        v2: PrimitiveTypeV2.string({
          default: _default2 != null ? _default2 : void 0,
          validation: maybeStringValidation3 != null ? {
            format: maybeStringValidation3.format,
            pattern: maybeStringValidation3.pattern,
            minLength: maybeStringValidation3.minLength,
            maxLength: maybeStringValidation3.maxLength
          } : void 0
        })
      });
    }
    case RawPrimitiveType.float:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Float,
        v2: void 0
      });
    case RawPrimitiveType.long:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Long,
        v2: void 0
      });
    case RawPrimitiveType.boolean:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Boolean,
        v2: void 0
      });
    case RawPrimitiveType.datetime:
      return visitor.primitive({
        v1: PrimitiveTypeV1.DateTime,
        v2: void 0
      });
    case RawPrimitiveType.date:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Date,
        v2: void 0
      });
    case RawPrimitiveType.uuid:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Uuid,
        v2: void 0
      });
    case RawPrimitiveType.base64:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Base64,
        v2: void 0
      });
    case RawPrimitiveType.bigint:
      return visitor.primitive({
        v1: PrimitiveTypeV1.BigInteger,
        v2: void 0
      });
    case RawPrimitiveType.uint:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Uint,
        v2: void 0
      });
    case RawPrimitiveType.uint64:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Uint64,
        v2: void 0
      });
    case RawPrimitiveType.unknown:
      return visitor.unknown();
  }
  const mapMatch = type2.match(FernContainerRegex.MAP);
  if (mapMatch?.[1] != null && mapMatch[2] != null) {
    return visitor.map({
      keyType: mapMatch[1],
      valueType: mapMatch[2]
    });
  }
  const listMatch = type2.match(FernContainerRegex.LIST);
  if (listMatch?.[1] != null) {
    return visitor.list(listMatch[1]);
  }
  const setMatch = type2.match(FernContainerRegex.SET);
  if (setMatch?.[1] != null) {
    return visitor.set(setMatch[1]);
  }
  const optionalMatch = type2.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] != null) {
    return visitor.optional(optionalMatch[1]);
  }
  const literalMatch = type2.match(FernContainerRegex.LITERAL);
  if (literalMatch?.[1] != null) {
    return visitor.literal(Literal.string(literalMatch[1]));
  }
  if (literalMatch?.[2] != null) {
    const group = literalMatch[2];
    switch (group) {
      case "false":
        return visitor.literal(Literal.boolean(false));
      case "true":
        return visitor.literal(Literal.boolean(true));
      default:
        throw new Error(`Unsupported literal value: ${group}`);
    }
  }
  return visitor.named(type2);
}

// ../../cli/fern-definition/schema/lib/utils/parseRawBytesType.js
var BYTES_TYPE = "bytes";
function parseRawBytesType(typeReference) {
  if (typeReference === BYTES_TYPE) {
    return { isOptional: false };
  }
  const optionalMatch = typeReference.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] === BYTES_TYPE) {
    return { isOptional: true };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/parseBytesRequest.js
function parseBytesRequest(request) {
  const reference = typeof request === "string" ? request : typeof request.body === "string" ? request.body : void 0;
  if (reference == null) {
    return void 0;
  }
  return parseRawBytesType(reference);
}

// ../../cli/fern-definition/schema/lib/utils/parseRawFileType.js
var FILE_TYPE = "file";
function isFileArray(typeReference) {
  const listMatch = typeReference.match(FernContainerRegex.LIST);
  if (listMatch?.[1] === FILE_TYPE) {
    return true;
  }
  return false;
}
function parseRawFileType(typeReference) {
  if (typeReference === FILE_TYPE) {
    return { isOptional: false, isArray: false };
  }
  const optionalMatch = typeReference.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] !== void 0) {
    if (optionalMatch[1] === FILE_TYPE) {
      return { isOptional: true, isArray: false };
    } else if (isFileArray(optionalMatch[1])) {
      return { isOptional: true, isArray: true };
    }
  }
  if (isFileArray(typeReference)) {
    return { isOptional: false, isArray: true };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/parseFileUploadRequest.js
function isFileUploadRequest(request) {
  if (typeof request === "string") {
    return false;
  }
  if (MediaType.parse(request["content-type"])?.isMultiPartFormData() ?? false) {
    return true;
  }
  if (request.body != null && isInlineRequestBody(request.body)) {
    if (Object.values(request.body.properties ?? []).some((property4) => {
      const propertyType = typeof property4 === "string" ? property4 : property4.type;
      return propertyType === "file";
    })) {
      return true;
    }
  }
  return false;
}
function parseFileUploadRequest(request) {
  if (!isFileUploadRequest(request) || request.body == null) {
    return void 0;
  }
  if (request.name == null) {
    return void 0;
  }
  if (request.body != null && isInlineRequestBody(request.body)) {
    return createRawFileUploadRequest(request.name, request.body);
  }
  return void 0;
}
function createRawFileUploadRequest(requestName, requestBody) {
  const properties = Object.entries(requestBody.properties ?? []).reduce((acc, [key, propertyType]) => {
    const docs = typeof propertyType !== "string" ? propertyType.docs : void 0;
    const contentType = typeof propertyType !== "string" ? propertyType["content-type"] : void 0;
    const maybeParsedFileType = parseRawFileType(typeof propertyType === "string" ? propertyType : propertyType.type);
    if (maybeParsedFileType != null) {
      acc.push({
        isFile: true,
        key,
        docs,
        isOptional: maybeParsedFileType.isOptional,
        isArray: maybeParsedFileType.isArray,
        contentType
      });
    } else {
      acc.push({ isFile: false, key, propertyType, docs, contentType });
    }
    return acc;
  }, []);
  if (requestBody["extra-properties"]) {
  }
  return {
    name: requestName,
    // TODO: handle requestBody.extends
    extends: requestBody.extends,
    properties
  };
}

// ../../cli/fern-definition/schema/lib/utils/parseRawTextType.js
var TEXT_TYPE2 = "text";
function parseRawTextType(typeReference) {
  if (typeReference === TEXT_TYPE2) {
    return { isOptional: false };
  }
  const optionalMatch = typeReference.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] === TEXT_TYPE2) {
    return { isOptional: true };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/recursivelyVisitRawTypeReference.js
function recursivelyVisitRawTypeReference({ type: type2, _default: _default2, validation, visitor }) {
  return visitRawTypeReference({
    type: type2,
    _default: _default2,
    validation,
    visitor: {
      primitive: visitor.primitive,
      map: ({ keyType, valueType }) => visitor.map({
        keyType: recursivelyVisitRawTypeReference({
          type: keyType,
          _default: void 0,
          validation: void 0,
          visitor
        }),
        valueType: recursivelyVisitRawTypeReference({
          type: valueType,
          _default: void 0,
          validation: void 0,
          visitor
        })
      }),
      list: (valueType) => visitor.list(recursivelyVisitRawTypeReference({
        type: valueType,
        _default: void 0,
        validation: void 0,
        visitor
      })),
      set: (valueType) => visitor.set(recursivelyVisitRawTypeReference({
        type: valueType,
        _default: void 0,
        validation: void 0,
        visitor
      })),
      optional: (valueType) => visitor.optional(recursivelyVisitRawTypeReference({ type: valueType, _default: _default2, validation, visitor })),
      literal: visitor.literal,
      named: visitor.named,
      unknown: visitor.unknown
    }
  });
}

// ../../cli/fern-definition/schema/lib/utils/visitExampleCodeSampleSchema.js
function visitExampleCodeSampleSchema(codeSample, visitor) {
  if (isExampleCodeSampleSchemaSdk(codeSample)) {
    return visitor.sdk(codeSample);
  }
  if (isExampleCodeSampleSchemaLanguage(codeSample)) {
    return visitor.language(codeSample);
  }
  assertNever(codeSample);
}
function isExampleCodeSampleSchemaSdk(codeSample) {
  return codeSample.sdk != null;
}
function isExampleCodeSampleSchemaLanguage(codeSample) {
  return codeSample.language != null;
}

// ../../cli/fern-definition/schema/lib/utils/isSimpleStreamResponseSchema.js
function isSimpleStreamResponseSchema(endpoint) {
  return endpoint["response-stream"] != null && (typeof endpoint["response-stream"] === "string" || endpoint["response-stream"].format == null || endpoint["response-stream"].format === "json");
}

// ../../cli/fern-definition/schema/lib/utils/isSseStreamResponseSchema.js
function isSseStsreamResponseSchema(endpoint) {
  return endpoint["response-stream"] != null && typeof endpoint["response-stream"] !== "string" && endpoint["response-stream"].format === "sse";
}

// ../../cli/fern-definition/schema/lib/utils/visitExampleResponseSchema.js
function visitExampleResponseSchema(endpoint, example, visitor) {
  if (isExampleStreamResponseSchema(endpoint, example)) {
    return visitor.stream(example);
  } else if (isExampleSseResponseSchema(endpoint, example)) {
    return visitor.events(example);
  } else {
    return visitor.body(example);
  }
}
function isExampleStreamResponseSchema(endpoint, example) {
  return example.stream !== void 0 && isSimpleStreamResponseSchema(endpoint);
}
function isExampleSseResponseSchema(endpoint, example) {
  return example.stream !== void 0 && isSseStsreamResponseSchema(endpoint);
}

// ../../cli/fern-definition/schema/lib/utils/visitRawApiAuth.js
function visitRawApiAuth(apiAuth, visitor) {
  if (isSingleAuthScheme(apiAuth)) {
    return visitor.single(apiAuth);
  }
  if (isAnyAuthSchemes(apiAuth)) {
    return visitor.any(apiAuth);
  }
  assertNever(apiAuth);
}
function isSingleAuthScheme(apiAuth) {
  return typeof apiAuth === "string" || apiAuth.scheme != null;
}
function isAnyAuthSchemes(apiAuth) {
  const [firstKey, ...rest] = Object.keys(apiAuth);
  return firstKey === "any" && rest.length === 0;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawAuthSchemeDeclaration.js
function visitRawAuthSchemeDeclaration(authScheme, visitor) {
  if (isHeaderAuthScheme(authScheme)) {
    return visitor.header(authScheme);
  }
  switch (authScheme.scheme) {
    case "basic":
      return visitor.basic(authScheme);
    case "bearer":
      return visitor.bearer(authScheme);
    case "oauth":
      return visitor.oauth(authScheme);
    default:
      assertNever(authScheme);
  }
}
function isHeaderAuthScheme(authScheme) {
  return authScheme.header != null;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawEnvironmentDeclaration.js
function visitRawEnvironmentDeclaration(environment, visitor) {
  if (isRawSingleBaseUrlEnvironment(environment)) {
    return visitor.singleBaseUrl(environment);
  }
  if (isRawMultipleBaseUrlsEnvironment(environment)) {
    return visitor.multipleBaseUrls(environment);
  }
  assertNever(environment);
}
function isRawSingleBaseUrlEnvironment(environment) {
  return typeof environment === "string" || "url" in environment;
}
function isRawMultipleBaseUrlsEnvironment(environment) {
  return typeof environment !== "string" && "urls" in environment;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawPathParameter.js
function isVariablePathParameter(rawPathParameter) {
  if (typeof rawPathParameter === "string") {
    return rawPathParameter.startsWith("$");
  }
  return "variable" in rawPathParameter;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawTypeDeclaration.js
function visitRawTypeDeclaration(declaration, visitor) {
  if (isRawAliasDefinition(declaration)) {
    return visitor.alias(declaration);
  }
  if (isRawDiscriminatedUnionDefinition(declaration)) {
    return visitor.discriminatedUnion(declaration);
  }
  if (isRawObjectDefinition(declaration)) {
    return visitor.object(declaration);
  }
  if (isRawUndiscriminatedUnionDefinition(declaration)) {
    return visitor.undiscriminatedUnion(declaration);
  }
  if (isRawEnumDefinition(declaration)) {
    return visitor.enum(declaration);
  }
  assertNever(declaration);
}
function isRawAliasDefinition(rawTypeDeclaration) {
  return typeof rawTypeDeclaration === "string" || rawTypeDeclaration.type != null;
}
function isRawObjectDefinition(rawTypeDeclaration) {
  return rawTypeDeclaration.extends != null || rawTypeDeclaration.properties != null;
}
function isRawDiscriminatedUnionDefinition(rawTypeDeclaration) {
  return (
    // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
    rawTypeDeclaration.union != null && // eslint-disable-next-line @typescript-eslint/no-explicit-any
    rawTypeDeclaration.discriminated == null
  );
}
function isRawUndiscriminatedUnionDefinition(rawTypeDeclaration) {
  const undiscriminatedUnionSchema = rawTypeDeclaration;
  return undiscriminatedUnionSchema.union != null && undiscriminatedUnionSchema.discriminated != null;
}
function isRawEnumDefinition(rawTypeDeclaration) {
  return rawTypeDeclaration.enum != null;
}

// ../../cli/fern-definition/schema/lib/utils/HttpEndpointReferenceParser.js
var HttpEndpointReferenceParser = class {
  //eslint-disable-next-line
  REFERENCE_REGEX = /^(GET|POST|PUT|DELETE|PATCH)\s(\/[a-zA-Z0-9\/]*)$/;
  validate(reference) {
    const validFormat = this.REFERENCE_REGEX.test(reference);
    if (!validFormat) {
      return { type: "invalid" };
    }
    return { type: "valid" };
  }
  tryParse(reference) {
    const validationResponse = this.validate(reference);
    if (validationResponse.type === "invalid") {
      return void 0;
    }
    const match = reference.match(this.REFERENCE_REGEX);
    if (match == null || match[1] == null || match[2] == null) {
      return void 0;
    }
    return {
      method: match[1],
      path: match[2]
    };
  }
};

// ../../cli/generation/ir-generator/lib/utils/parseTypeName.js
function parseTypeName({ typeName, file }) {
  const reference = parseReferenceToTypeName({
    reference: typeName,
    referencedIn: file.relativeFilepath,
    imports: file.imports
  });
  if (reference == null) {
    throw new Error("Failed to locate type: " + typeName);
  }
  const nameWithoutId = {
    name: file.casingsGenerator.generateName(reference.typeName),
    fernFilepath: convertToFernFilepath({
      relativeFilepath: reference.relativeFilepath,
      casingsGenerator: file.casingsGenerator
    })
  };
  return {
    ...nameWithoutId,
    typeId: IdGenerator.generateTypeId(nameWithoutId)
  };
}

// ../../cli/generation/ir-generator/lib/formatDocs.js
var isBrowser2 = typeof window !== "undefined" && typeof window.document !== "undefined";
async function formatDocs(docs) {
  if (docs == null || isBrowser2) {
    return void 0;
  }
  const prettier = await import("prettier");
  const formattedDocs = prettier.format(docs, {
    parser: "markdown"
  });
  if (formattedDocs.endsWith("\n") || formattedDocs.endsWith("\r")) {
    return formattedDocs.substring(0, formattedDocs.length - 1);
  }
  return formattedDocs;
}

// ../../cli/generation/ir-generator/lib/converters/convertDeclaration.js
var DEFAULT_DECLARATION = {
  docs: void 0,
  availability: void 0
};
async function convertDeclaration(declaration) {
  if (typeof declaration === "string") {
    return DEFAULT_DECLARATION;
  }
  return {
    docs: await formatDocs(declaration.docs),
    availability: convertAvailability(declaration.availability)
  };
}
function convertAvailability(availability) {
  if (availability == null) {
    return void 0;
  }
  return {
    status: convertAvailabilityStatus(typeof availability === "string" ? availability : availability.status),
    message: typeof availability !== "string" ? availability.message : void 0
  };
}
function getAudiences(schema2) {
  if (typeof schema2 === "string") {
    return [];
  }
  return schema2.audiences ?? [];
}
function convertAvailabilityStatus(status) {
  switch (status) {
    case "in-development":
      return AvailabilityStatus.InDevelopment;
    case "pre-release":
      return AvailabilityStatus.PreRelease;
    case "deprecated":
      return AvailabilityStatus.Deprecated;
    case "generally-available":
      return AvailabilityStatus.GeneralAvailability;
    default:
      assertNever(status);
  }
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertObjectTypeDeclaration.js
async function convertObjectTypeDeclaration({ object: object3, file }) {
  return Type.object({
    extends: getExtensionsAsList(object3.extends).map((extended) => parseTypeName({ typeName: extended, file })),
    properties: await getObjectPropertiesFromRawObjectSchema(object3, file),
    extraProperties: object3["extra-properties"] ?? false,
    extendedProperties: void 0
  });
}
async function getObjectPropertiesFromRawObjectSchema(object3, file) {
  if (object3.properties == null) {
    return [];
  }
  return await Promise.all(Object.entries(object3.properties).map(async ([propertyKey, propertyDefinition]) => ({
    ...await convertDeclaration(propertyDefinition),
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: propertyKey,
      name: getPropertyName({ propertyKey, property: propertyDefinition }).name
    }),
    valueType: file.parseTypeReference(propertyDefinition)
  })));
}
function getExtensionsAsList(extensions) {
  if (extensions == null) {
    return [];
  }
  if (typeof extensions === "string") {
    return [extensions];
  }
  return extensions;
}
function getPropertyName({ propertyKey, property: property4 }) {
  if (typeof property4 !== "string" && property4.name != null) {
    return {
      name: property4.name,
      wasExplicitlySet: true
    };
  }
  return {
    name: propertyKey,
    wasExplicitlySet: false
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpRequestBody.js
function convertHttpRequestBody({ request, file }) {
  const bytesRequest = request != null ? parseBytesRequest(request) : void 0;
  if (bytesRequest != null) {
    return HttpRequestBody.bytes({
      isOptional: bytesRequest.isOptional,
      contentType: typeof request === "string" ? void 0 : request?.["content-type"],
      docs: typeof request === "string" ? void 0 : request?.docs
    });
  }
  if (typeof request === "string") {
    return HttpRequestBody.reference(convertReferenceHttpRequestBody({
      requestBody: request,
      file
    }));
  }
  if (request?.body == null) {
    return void 0;
  }
  const fileUploadRequest = parseFileUploadRequest(request);
  if (fileUploadRequest != null) {
    return HttpRequestBody.fileUpload({
      name: file.casingsGenerator.generateName(fileUploadRequest.name),
      properties: fileUploadRequest.properties.map((property4) => {
        if (property4.isFile) {
          if (property4.isArray) {
            return FileUploadRequestProperty.file(FileProperty.fileArray({
              key: file.casingsGenerator.generateNameAndWireValue({
                wireValue: property4.key,
                name: property4.key
              }),
              isOptional: property4.isOptional,
              contentType: property4.contentType
            }));
          } else {
            return FileUploadRequestProperty.file(FileProperty.file({
              key: file.casingsGenerator.generateNameAndWireValue({
                wireValue: property4.key,
                name: property4.key
              }),
              isOptional: property4.isOptional,
              contentType: property4.contentType
            }));
          }
        } else {
          return FileUploadRequestProperty.bodyProperty({
            ...convertInlinedRequestProperty({
              propertyKey: property4.key,
              propertyDefinition: property4.propertyType,
              docs: property4.docs,
              availability: convertAvailability(property4.availability),
              file
            }),
            contentType: property4.contentType
          });
        }
      }),
      docs: request.docs
    });
  }
  if (isInlineRequestBody(request.body)) {
    if (request.name == null) {
      throw new Error("Name is missing for inlined request");
    }
    return HttpRequestBody.inlinedRequestBody({
      name: file.casingsGenerator.generateName(request.name),
      extends: getExtensionsAsList(request.body.extends).map((extended) => parseTypeName({ typeName: extended, file })),
      contentType: request["content-type"],
      docs: request.docs,
      properties: request.body.properties != null ? Object.entries(request.body.properties).map(([propertyKey, propertyDefinition]) => convertInlinedRequestProperty({
        propertyKey,
        propertyDefinition,
        docs: typeof propertyDefinition !== "string" ? propertyDefinition.docs : void 0,
        availability: typeof propertyDefinition !== "string" ? convertAvailability(propertyDefinition.availability) : void 0,
        file
      })) : [],
      extraProperties: request.body["extra-properties"] ?? false,
      extendedProperties: void 0
    });
  }
  return HttpRequestBody.reference(convertReferenceHttpRequestBody({
    requestBody: request.body,
    file,
    contentType: request["content-type"]
  }));
}
function convertReferenceHttpRequestBody({ requestBody, file, contentType }) {
  return {
    docs: typeof requestBody !== "string" ? requestBody.docs : void 0,
    requestBodyType: file.parseTypeReference(requestBody),
    contentType
  };
}
function convertInlinedRequestProperty({ propertyKey, propertyDefinition, docs, availability, file }) {
  return {
    docs,
    availability,
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: propertyKey,
      name: getPropertyName({ propertyKey, property: propertyDefinition }).name
    }),
    valueType: file.parseTypeReference(propertyDefinition)
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/getObjectPropertyFromResolvedType.js
async function getObjectPropertyFromResolvedType({ typeResolver, file, resolvedType, property: property4 }) {
  switch (resolvedType._type) {
    case "container":
      if (resolvedType.container._type === "optional") {
        return await getObjectPropertyFromResolvedType({
          typeResolver,
          file,
          resolvedType: resolvedType.container.itemType,
          property: property4
        });
      }
      break;
    case "named":
      if (isRawObjectDefinition(resolvedType.declaration)) {
        return await getObjectPropertyFromObjectSchema({
          typeResolver,
          file: resolvedType.file,
          objectSchema: resolvedType.declaration,
          property: property4
        });
      }
      break;
    case "primitive":
    case "unknown":
      break;
    default:
      assertNever(resolvedType);
  }
  throw new Error("Internal error; response must be an object in order to return a property as a response");
}
async function getObjectPropertyFromObjectSchema({ typeResolver, file, objectSchema, property: property4 }) {
  const properties = await getAllPropertiesForRawObjectSchema(objectSchema, file, typeResolver);
  const objectProperty = properties[property4];
  if (objectProperty == null) {
    throw new Error(`Object does not have a property named ${property4}.`);
  }
  return objectProperty;
}
async function getAllPropertiesForRawObjectSchema(objectSchema, file, typeResolver) {
  let extendedTypes = [];
  if (typeof objectSchema.extends === "string") {
    extendedTypes = [objectSchema.extends];
  } else if (Array.isArray(objectSchema.extends)) {
    extendedTypes = objectSchema.extends;
  }
  const properties = {};
  for (const extendedType of extendedTypes) {
    const extendedProperties = await getAllPropertiesForExtendedType(extendedType, file, typeResolver);
    Object.entries(extendedProperties).map(([propertyKey, objectProperty]) => {
      properties[propertyKey] = objectProperty;
    });
  }
  const objectProperties = await getObjectPropertiesFromRawObjectSchema(objectSchema, file);
  objectProperties.forEach((objectProperty) => {
    properties[objectProperty.name.name.originalName] = objectProperty;
  });
  return properties;
}
async function getAllPropertiesForExtendedType(extendedType, file, typeResolver) {
  const resolvedType = typeResolver.resolveNamedTypeOrThrow({
    referenceToNamedType: extendedType,
    file
  });
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    return await getAllPropertiesForRawObjectSchema(resolvedType.declaration, file, typeResolver);
  }
  throw new Error(`Extended type ${extendedType} must be another named type`);
}

// ../../cli/generation/ir-generator/lib/converters/services/convertProperty.js
async function getNestedObjectPropertyFromResolvedType({ typeResolver, file, resolvedType, propertyComponents }) {
  if (propertyComponents.length === 0) {
    return void 0;
  }
  if (propertyComponents.length === 1) {
    return await getObjectPropertyFromResolvedType({
      typeResolver,
      file,
      resolvedType,
      property: propertyComponents[0] ?? ""
    });
  }
  const objectSchema = maybeObjectSchema(resolvedType);
  if (objectSchema == null) {
    return void 0;
  }
  return getNestedObjectPropertyFromObjectSchema({
    typeResolver,
    file,
    objectSchema,
    propertyComponents
  });
}
async function getNestedObjectPropertyFromObjectSchema({ typeResolver, file, objectSchema, propertyComponents }) {
  if (propertyComponents.length === 0) {
    return void 0;
  }
  if (propertyComponents.length === 1) {
    return await getObjectPropertyFromObjectSchema({
      typeResolver,
      file,
      objectSchema,
      property: propertyComponents[0] ?? ""
    });
  }
  const propertyType = await getPropertyTypeFromObjectSchema({
    typeResolver,
    file,
    objectSchema,
    property: propertyComponents[0] ?? ""
  });
  const resolvedTypeProperty = typeResolver.resolveTypeOrThrow({
    type: propertyType,
    file
  });
  return getNestedObjectPropertyFromResolvedType({
    typeResolver,
    file: maybeFileFromResolvedType(resolvedTypeProperty) ?? file,
    resolvedType: resolvedTypeProperty,
    propertyComponents: propertyComponents.slice(1)
  });
}
async function getPropertyTypeFromObjectSchema({ typeResolver, file, objectSchema, property: property4 }) {
  const properties = await getAllPropertiesForRawObjectSchema2({
    typeResolver,
    file,
    objectSchema
  });
  const propertyType = properties[property4];
  if (propertyType == null) {
    throw new Error(`Response does not have a property named ${property4}.`);
  }
  return propertyType;
}
async function getAllPropertiesForRawObjectSchema2({ typeResolver, file, objectSchema }) {
  let extendedTypes = [];
  if (typeof objectSchema.extends === "string") {
    extendedTypes = [objectSchema.extends];
  } else if (Array.isArray(objectSchema.extends)) {
    extendedTypes = objectSchema.extends;
  }
  const properties = {};
  for (const extendedType of extendedTypes) {
    const extendedProperties = await getAllPropertiesForExtendedType2({
      typeResolver,
      file,
      extendedType
    });
    Object.entries(extendedProperties).map(([propertyKey, propertyType]) => {
      properties[propertyKey] = propertyType;
    });
  }
  if (objectSchema.properties != null) {
    Object.entries(objectSchema.properties).map(([propertyKey, propertyType]) => {
      properties[propertyKey] = typeof propertyType === "string" ? propertyType : propertyType.type;
    });
  }
  return properties;
}
async function getAllPropertiesForExtendedType2({ typeResolver, file, extendedType }) {
  const resolvedType = typeResolver.resolveNamedTypeOrThrow({
    referenceToNamedType: extendedType,
    file
  });
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    return await getAllPropertiesForRawObjectSchema2({
      typeResolver,
      file: maybeFileFromResolvedType(resolvedType) ?? file,
      objectSchema: resolvedType.declaration
    });
  }
  throw new Error(`Extended type ${extendedType} must be another named type.`);
}
function maybeFileFromResolvedType(resolvedType) {
  if (resolvedType == null) {
    return void 0;
  }
  if (resolvedType._type === "named") {
    return resolvedType.file;
  }
  if (resolvedType._type === "container" && resolvedType.container._type === "optional") {
    return maybeFileFromResolvedType(resolvedType.container.itemType);
  }
  return void 0;
}
function maybeObjectSchema(resolvedType) {
  if (resolvedType == null) {
    return void 0;
  }
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    return resolvedType.declaration;
  }
  if (resolvedType._type === "container" && resolvedType.container._type === "optional") {
    return maybeObjectSchema(resolvedType.container.itemType);
  }
  return void 0;
}
function getRequestPropertyComponents(value) {
  const trimmed = value.substring("$request.".length);
  return trimmed?.split(".") ?? [];
}
function getResponsePropertyComponents(value) {
  const trimmed = value.substring("$response.".length);
  return trimmed?.split(".") ?? [];
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpSdkRequest.js
var DEFAULT_REQUEST_PARAMETER_NAME = "request";
var DEFAULT_BODY_PROPERTY_KEY_IN_WRAPPER = "body";
async function convertHttpSdkRequest({ request, endpointKey, endpoint, service, file, typeResolver, propertyResolver }) {
  const shape = convertHttpSdkRequestShape({ request, service, file, typeResolver });
  if (shape == null) {
    return void 0;
  }
  return {
    shape,
    requestParameterName: file.casingsGenerator.generateName(DEFAULT_REQUEST_PARAMETER_NAME),
    streamParameter: endpoint["stream-condition"] != null ? await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointKey,
      propertyComponents: getRequestPropertyComponents(endpoint["stream-condition"])
    }) : void 0
  };
}
function convertHttpSdkRequestShape({ service, request, file, typeResolver }) {
  const constructWrapper = () => {
    if (typeof request === "string" || request?.name == null) {
      throw new Error("Name is missing for request wrapper");
    }
    return SdkRequestShape.wrapper({
      wrapperName: file.casingsGenerator.generateName(request.name),
      bodyKey: file.casingsGenerator.generateName(DEFAULT_BODY_PROPERTY_KEY_IN_WRAPPER),
      includePathParameters: shouldIncludePathParametersInWrapper(request),
      onlyPathParameters: doesRequestHaveOnlyPathParameters({ request, file, typeResolver })
    });
  };
  if (!areAllHeadersLiteral({ headers: service.headers ?? {}, file, typeResolver })) {
    return constructWrapper();
  }
  if (request == null) {
    return void 0;
  }
  if (typeof request === "string") {
    return SdkRequestShape.justRequestBody(getSdkJustRequestBodyType({ requestBody: request, file }));
  }
  const { body } = request;
  if (doesRequestHaveNonBodyProperties({ request, file, typeResolver }) || body != null && isInlineRequestBody(body)) {
    return constructWrapper();
  }
  if (body == null) {
    return void 0;
  }
  return SdkRequestShape.justRequestBody(getSdkJustRequestBodyType({ requestBody: body, file }));
}
function getSdkJustRequestBodyType({ requestBody, file, contentType }) {
  const rawBytes = typeof requestBody === "string" ? parseRawBytesType(requestBody) : parseRawBytesType(requestBody.type);
  if (rawBytes != null) {
    return SdkRequestBodyType.bytes({
      isOptional: rawBytes.isOptional,
      contentType,
      docs: void 0
    });
  }
  return SdkRequestBodyType.typeReference(convertReferenceHttpRequestBody({
    requestBody,
    file,
    contentType
  }));
}
function doesRequestHaveNonBodyProperties({ request, file, typeResolver }) {
  const { headers = {}, "path-parameters": pathParameters = {}, "query-parameters": queryParameters = {} } = request;
  return !areAllHeadersLiteral({ headers, file, typeResolver }) || size_default(pathParameters) > 0 || size_default(queryParameters) > 0;
}
function doesRequestHaveOnlyPathParameters({ request, file, typeResolver }) {
  const { headers = {}, "path-parameters": pathParameters = {}, "query-parameters": queryParameters = {} } = request;
  return size_default(pathParameters) > 0 && areAllHeadersLiteral({ headers, file, typeResolver }) && size_default(queryParameters) === 0 && request.body == null;
}
function shouldIncludePathParametersInWrapper(request) {
  return typeof request !== "string" && request?.["path-parameters"] != null;
}
function areAllHeadersLiteral({ headers, file, typeResolver }) {
  return Object.values(headers).filter((header) => {
    const headerType = typeof header === "string" ? header : header.type;
    const resolvedType = typeResolver.resolveTypeOrThrow({
      type: headerType,
      file
    });
    const isLiteral = resolvedType._type === "container" && resolvedType.container._type === "literal";
    return !isLiteral;
  }).length === 0;
}

// ../../../node_modules/.pnpm/url-join@5.0.0/node_modules/url-join/lib/url-join.js
function normalize(strArray) {
  var resultArray = [];
  if (strArray.length === 0) {
    return "";
  }
  if (typeof strArray[0] !== "string") {
    throw new TypeError("Url must be a string. Received " + strArray[0]);
  }
  if (strArray[0].match(/^[^/:]+:\/*$/) && strArray.length > 1) {
    var first = strArray.shift();
    strArray[0] = first + strArray[0];
  }
  if (strArray[0].match(/^file:\/\/\//)) {
    strArray[0] = strArray[0].replace(/^([^/:]+):\/*/, "$1:///");
  } else {
    strArray[0] = strArray[0].replace(/^([^/:]+):\/*/, "$1://");
  }
  for (var i = 0; i < strArray.length; i++) {
    var component = strArray[i];
    if (typeof component !== "string") {
      throw new TypeError("Url must be a string. Received " + component);
    }
    if (component === "") {
      continue;
    }
    if (i > 0) {
      component = component.replace(/^[\/]+/, "");
    }
    if (i < strArray.length - 1) {
      component = component.replace(/[\/]+$/, "");
    } else {
      component = component.replace(/[\/]+$/, "/");
    }
    resultArray.push(component);
  }
  var str2 = resultArray.join("/");
  str2 = str2.replace(/\/(\?|&|#[^!])/g, "$1");
  var parts = str2.split("?");
  str2 = parts.shift() + (parts.length > 0 ? "?" : "") + parts.join("&");
  return str2;
}
function urlJoin() {
  var input;
  if (typeof arguments[0] === "object") {
    input = arguments[0];
  } else {
    input = [].slice.call(arguments);
  }
  return normalize(input);
}

// ../../cli/generation/ir-generator/lib/converters/services/convertCodeSamples.js
function convertCodeSample({ codeSample, file }) {
  return visitExampleCodeSampleSchema(codeSample, {
    language: (languageScheme) => ExampleCodeSample.language({
      name: languageScheme.name != null ? file.casingsGenerator.generateName(languageScheme.name) : void 0,
      docs: languageScheme.docs,
      language: languageScheme.language,
      code: languageScheme.code,
      install: languageScheme.install
    }),
    sdk: (sdkScheme) => ExampleCodeSample.sdk({
      name: sdkScheme.name != null ? file.casingsGenerator.generateName(sdkScheme.name) : void 0,
      docs: sdkScheme.docs,
      sdk: removeSdkAlias(sdkScheme.sdk),
      code: sdkScheme.code
    })
  });
}
function removeSdkAlias(sdk) {
  switch (sdk) {
    case "js":
      return "javascript";
    case "node":
      return "javascript";
    case "ts":
      return "typescript";
    case "nodets":
      return "typescript";
    case "golang":
      return "go";
    case "dotnet":
      return "csharp";
    case "c#":
      return "csharp";
    case "jvm":
      return "java";
    default:
      return sdk;
  }
}

// ../../cli/generation/ir-generator/lib/converters/services/convertExampleEndpointCall.js
var import_crypto = __toESM(require("crypto"), 1);

// ../../cli/generation/ir-generator/lib/examples/getViolationsForMisshapenExample.js
function getViolationsForMisshapenExample(example, expectedTypeIncludingArticle) {
  return [
    {
      message: `Expected example to be ${expectedTypeIncludingArticle}. Example is: ${JSON.stringify(example)}`
    }
  ];
}

// ../../cli/generation/ir-generator/lib/examples/validateAliasExample.js
function validateAliasExample({ rawAlias, example, file, typeResolver, exampleResolver, workspace, breadcrumbs, depth }) {
  return validateTypeReferenceExample({
    rawTypeReference: typeof rawAlias === "string" ? rawAlias : rawAlias.type,
    example,
    file,
    typeResolver,
    exampleResolver,
    workspace,
    breadcrumbs,
    depth: depth + 1
  });
}

// ../../cli/generation/ir-generator/lib/examples/validateEnumExample.js
function validateEnumExample({ rawEnum, example, breadcrumbs }) {
  const wireValues = rawEnum.enum.map((enumValue) => typeof enumValue === "string" ? enumValue : enumValue.value);
  const validEnumValuesLines = wireValues.map((wireValue) => `  - ${wireValue}`).join("\n");
  if (typeof example !== "string") {
    return getViolationsForMisshapenExample(example, "a string");
  }
  if (wireValues.includes(example)) {
    return [];
  }
  return [
    {
      message: `"${example}" is not a valid example for this enum. Enum values are:
` + validEnumValuesLines
    }
  ];
}

// ../../cli/workspace/commons/lib/AbstractAPIWorkspace.js
var AbstractAPIWorkspace = class {
  generatorsConfiguration;
  workspaceName;
  cliVersion;
  absoluteFilePath;
  changelog;
  type = "api";
  constructor({ generatorsConfiguration, workspaceName, cliVersion, absoluteFilePath, changelog }) {
    this.generatorsConfiguration = generatorsConfiguration;
    this.workspaceName = workspaceName;
    this.cliVersion = cliVersion;
    this.absoluteFilePath = absoluteFilePath;
    this.changelog = changelog;
  }
};

// ../../cli/workspace/commons/lib/FernWorkspace.js
var FernWorkspace = class extends AbstractAPIWorkspace {
  definition;
  sources;
  constructor({ definition, sources, ...superArgs }) {
    super(superArgs);
    this.definition = definition;
    this.sources = sources ?? [];
  }
  async getDefinition() {
    return this.definition;
  }
  async toFernWorkspace() {
    return this;
  }
  getSources() {
    return this.sources;
  }
  getAbsoluteFilePaths() {
    return [this.absoluteFilePath];
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/commons/types/Source.js
var Source2 = {
  openapi: (value) => {
    return {
      ...value,
      type: "openapi",
      _visit: function(visitor) {
        return Source2._visit(this, visitor);
      }
    };
  },
  protobuf: (value) => {
    return {
      ...value,
      type: "protobuf",
      _visit: function(visitor) {
        return Source2._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "openapi":
        return visitor.openapi(value);
      case "protobuf":
        return visitor.protobuf(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/commons/types/Encoding.js
var Encoding = {
  protobuf: (value) => {
    return {
      ...value,
      type: "protobuf",
      _visit: function(visitor) {
        return Encoding._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "protobuf":
        return visitor.protobuf(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/commons/types/SecurityScheme.js
var SecurityScheme = {
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function(visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function(visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function(visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  query: (value) => {
    return {
      ...value,
      type: "query",
      _visit: function(visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  oauth: (value) => {
    return {
      ...value,
      type: "oauth",
      _visit: function(visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "basic":
        return visitor.basic(value);
      case "bearer":
        return visitor.bearer(value);
      case "header":
        return visitor.header(value);
      case "query":
        return visitor.query(value);
      case "oauth":
        return visitor.oauth(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/example/types/FullExample.js
var FullExample = {
  primitive: (value) => {
    return {
      value,
      type: "primitive",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  array: (value) => {
    return {
      value,
      type: "array",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      value,
      type: "map",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      value,
      type: "enum",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      value,
      type: "literal",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  oneOf: (value) => {
    return {
      value,
      type: "oneOf",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      value,
      type: "unknown",
      _visit: function(visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value.value);
      case "object":
        return visitor.object(value);
      case "array":
        return visitor.array(value.value);
      case "map":
        return visitor.map(value.value);
      case "enum":
        return visitor.enum(value.value);
      case "literal":
        return visitor.literal(value.value);
      case "oneOf":
        return visitor.oneOf(value.value);
      case "unknown":
        return visitor.unknown(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/example/types/PrimitiveExample.js
var PrimitiveExample = {
  int: (value) => {
    return {
      value,
      type: "int",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  int64: (value) => {
    return {
      value,
      type: "int64",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      value,
      type: "uint",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      value,
      type: "uint64",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      value,
      type: "float",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      value,
      type: "double",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      value,
      type: "string",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  datetime: (value) => {
    return {
      value,
      type: "datetime",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      value,
      type: "date",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      value,
      type: "base64",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      value,
      type: "boolean",
      _visit: function(visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "int":
        return visitor.int(value.value);
      case "int64":
        return visitor.int64(value.value);
      case "uint":
        return visitor.uint(value.value);
      case "uint64":
        return visitor.uint64(value.value);
      case "float":
        return visitor.float(value.value);
      case "double":
        return visitor.double(value.value);
      case "string":
        return visitor.string(value.value);
      case "datetime":
        return visitor.datetime(value.value);
      case "date":
        return visitor.date(value.value);
      case "base64":
        return visitor.base64(value.value);
      case "boolean":
        return visitor.boolean(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/example/types/FullOneOfExample.js
var FullOneOfExample = {
  discriminated: (value) => {
    return {
      value,
      type: "discriminated",
      _visit: function(visitor) {
        return FullOneOfExample._visit(this, visitor);
      }
    };
  },
  undisciminated: (value) => {
    return {
      value,
      type: "undisciminated",
      _visit: function(visitor) {
        return FullOneOfExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "discriminated":
        return visitor.discriminated(value.value);
      case "undisciminated":
        return visitor.undisciminated(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/Availability.js
var Availability = {
  GenerallyAvailable: "GenerallyAvailable",
  Beta: "Beta",
  Deprecated: "Deprecated",
  _visit: (value, visitor) => {
    switch (value) {
      case Availability.GenerallyAvailable:
        return visitor.generallyAvailable();
      case Availability.Beta:
        return visitor.beta();
      case Availability.Deprecated:
        return visitor.deprecated();
      default:
        return visitor._other();
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/Pagination.js
var Pagination3 = {
  cursor: (value) => {
    return {
      ...value,
      type: "cursor",
      _visit: function(visitor) {
        return Pagination3._visit(this, visitor);
      }
    };
  },
  offset: (value) => {
    return {
      ...value,
      type: "offset",
      _visit: function(visitor) {
        return Pagination3._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "cursor":
        return visitor.cursor(value);
      case "offset":
        return visitor.offset(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/CustomCodeSample.js
var CustomCodeSample = {
  language: (value) => {
    return {
      ...value,
      type: "language",
      _visit: function(visitor) {
        return CustomCodeSample._visit(this, visitor);
      }
    };
  },
  sdk: (value) => {
    return {
      ...value,
      type: "sdk",
      _visit: function(visitor) {
        return CustomCodeSample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "language":
        return visitor.language(value);
      case "sdk":
        return visitor.sdk(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/SupportedSdkLanguage.js
var SupportedSdkLanguage = {
  Curl: "curl",
  Python: "python",
  Javascript: "javascript",
  Typescript: "typescript",
  Go: "go",
  Ruby: "ruby",
  Csharp: "csharp",
  Java: "java",
  Js: "js",
  Node: "node",
  Ts: "ts",
  Nodets: "nodets",
  Golang: "golang",
  Dotnet: "dotnet",
  Jvm: "jvm",
  _visit: (value, visitor) => {
    switch (value) {
      case SupportedSdkLanguage.Curl:
        return visitor.curl();
      case SupportedSdkLanguage.Python:
        return visitor.python();
      case SupportedSdkLanguage.Javascript:
        return visitor.javascript();
      case SupportedSdkLanguage.Typescript:
        return visitor.typescript();
      case SupportedSdkLanguage.Go:
        return visitor.go();
      case SupportedSdkLanguage.Ruby:
        return visitor.ruby();
      case SupportedSdkLanguage.Csharp:
        return visitor.csharp();
      case SupportedSdkLanguage.Java:
        return visitor.java();
      case SupportedSdkLanguage.Js:
        return visitor.js();
      case SupportedSdkLanguage.Node:
        return visitor.node();
      case SupportedSdkLanguage.Ts:
        return visitor.ts();
      case SupportedSdkLanguage.Nodets:
        return visitor.nodets();
      case SupportedSdkLanguage.Golang:
        return visitor.golang();
      case SupportedSdkLanguage.Dotnet:
        return visitor.dotnet();
      case SupportedSdkLanguage.Jvm:
        return visitor.jvm();
      default:
        return visitor._other();
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/EndpointExample.js
var EndpointExample = {
  unknown: (value) => {
    return {
      value,
      type: "unknown",
      _visit: function(visitor) {
        return EndpointExample._visit(this, visitor);
      }
    };
  },
  full: (value) => {
    return {
      ...value,
      type: "full",
      _visit: function(visitor) {
        return EndpointExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "unknown":
        return visitor.unknown(value.value);
      case "full":
        return visitor.full(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/EndpointResponseExample.js
var EndpointResponseExample = {
  withStreaming: (value) => {
    return {
      value,
      type: "withStreaming",
      _visit: function(visitor) {
        return EndpointResponseExample._visit(this, visitor);
      }
    };
  },
  withoutStreaming: (value) => {
    return {
      value,
      type: "withoutStreaming",
      _visit: function(visitor) {
        return EndpointResponseExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "withStreaming":
        return visitor.withStreaming(value.value);
      case "withoutStreaming":
        return visitor.withoutStreaming(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/HttpMethod.js
var HttpMethod2 = {
  Get: "GET",
  Post: "POST",
  Put: "PUT",
  Patch: "PATCH",
  Delete: "DELETE",
  Head: "HEAD",
  Options: "OPTIONS",
  Trace: "TRACE",
  _visit: (value, visitor) => {
    switch (value) {
      case HttpMethod2.Get:
        return visitor.get();
      case HttpMethod2.Post:
        return visitor.post();
      case HttpMethod2.Put:
        return visitor.put();
      case HttpMethod2.Patch:
        return visitor.patch();
      case HttpMethod2.Delete:
        return visitor.delete();
      case HttpMethod2.Head:
        return visitor.head();
      case HttpMethod2.Options:
        return visitor.options();
      case HttpMethod2.Trace:
        return visitor.trace();
      default:
        return visitor._other();
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/MultipartSchema.js
var MultipartSchema = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function(visitor) {
        return MultipartSchema._visit(this, visitor);
      }
    };
  },
  json: (value) => {
    return {
      value,
      type: "json",
      _visit: function(visitor) {
        return MultipartSchema._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "json":
        return visitor.json(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/Schema.js
var Schema = {
  primitive: (value) => {
    return {
      ...value,
      type: "primitive",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  array: (value) => {
    return {
      ...value,
      type: "array",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      ...value,
      type: "optional",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      ...value,
      type: "literal",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  oneOf: (value) => {
    return {
      value,
      type: "oneOf",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  nullable: (value) => {
    return {
      ...value,
      type: "nullable",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      ...value,
      type: "unknown",
      _visit: function(visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value);
      case "object":
        return visitor.object(value);
      case "array":
        return visitor.array(value);
      case "map":
        return visitor.map(value);
      case "optional":
        return visitor.optional(value);
      case "enum":
        return visitor.enum(value);
      case "reference":
        return visitor.reference(value);
      case "literal":
        return visitor.literal(value);
      case "oneOf":
        return visitor.oneOf(value.value);
      case "nullable":
        return visitor.nullable(value);
      case "unknown":
        return visitor.unknown(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/PrimitiveSchemaValue.js
var PrimitiveSchemaValue = {
  int: (value) => {
    return {
      ...value,
      type: "int",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  int64: (value) => {
    return {
      ...value,
      type: "int64",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  uint: () => {
    return {
      type: "uint",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  uint64: () => {
    return {
      type: "uint64",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  float: () => {
    return {
      type: "float",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      ...value,
      type: "double",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      ...value,
      type: "string",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  datetime: () => {
    return {
      type: "datetime",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  date: () => {
    return {
      type: "date",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  base64: () => {
    return {
      type: "base64",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      ...value,
      type: "boolean",
      _visit: function(visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "int":
        return visitor.int(value);
      case "int64":
        return visitor.int64(value);
      case "uint":
        return visitor.uint();
      case "uint64":
        return visitor.uint64();
      case "float":
        return visitor.float();
      case "double":
        return visitor.double(value);
      case "string":
        return visitor.string(value);
      case "datetime":
        return visitor.datetime();
      case "date":
        return visitor.date();
      case "base64":
        return visitor.base64();
      case "boolean":
        return visitor.boolean(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/LiteralSchemaValue.js
var LiteralSchemaValue = {
  boolean: (value) => {
    return {
      value,
      type: "boolean",
      _visit: function(visitor) {
        return LiteralSchemaValue._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      value,
      type: "string",
      _visit: function(visitor) {
        return LiteralSchemaValue._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "boolean":
        return visitor.boolean(value.value);
      case "string":
        return visitor.string(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/OneOfSchema.js
var OneOfSchema = {
  discriminated: (value) => {
    return {
      ...value,
      type: "discriminated",
      _visit: function(visitor) {
        return OneOfSchema._visit(this, visitor);
      }
    };
  },
  undisciminated: (value) => {
    return {
      ...value,
      type: "undisciminated",
      _visit: function(visitor) {
        return OneOfSchema._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "discriminated":
        return visitor.discriminated(value);
      case "undisciminated":
        return visitor.undisciminated(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/RequestWithExample.js
var RequestWithExample = {
  octetStream: (value) => {
    return {
      ...value,
      type: "octetStream",
      _visit: function(visitor) {
        return RequestWithExample._visit(this, visitor);
      }
    };
  },
  multipart: (value) => {
    return {
      ...value,
      type: "multipart",
      _visit: function(visitor) {
        return RequestWithExample._visit(this, visitor);
      }
    };
  },
  json: (value) => {
    return {
      ...value,
      type: "json",
      _visit: function(visitor) {
        return RequestWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "octetStream":
        return visitor.octetStream(value);
      case "multipart":
        return visitor.multipart(value);
      case "json":
        return visitor.json(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/ResponseWithExample.js
var ResponseWithExample = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  json: (value) => {
    return {
      ...value,
      type: "json",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  streamingSse: (value) => {
    return {
      ...value,
      type: "streamingSse",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  streamingText: (value) => {
    return {
      ...value,
      type: "streamingText",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  streamingJson: (value) => {
    return {
      ...value,
      type: "streamingJson",
      _visit: function(visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "json":
        return visitor.json(value);
      case "text":
        return visitor.text(value);
      case "streamingSse":
        return visitor.streamingSse(value);
      case "streamingText":
        return visitor.streamingText(value);
      case "streamingJson":
        return visitor.streamingJson(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/SchemaWithExample.js
var SchemaWithExample = {
  primitive: (value) => {
    return {
      ...value,
      type: "primitive",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  array: (value) => {
    return {
      ...value,
      type: "array",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      ...value,
      type: "optional",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      ...value,
      type: "literal",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  oneOf: (value) => {
    return {
      value,
      type: "oneOf",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  nullable: (value) => {
    return {
      ...value,
      type: "nullable",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      ...value,
      type: "unknown",
      _visit: function(visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value);
      case "object":
        return visitor.object(value);
      case "array":
        return visitor.array(value);
      case "map":
        return visitor.map(value);
      case "optional":
        return visitor.optional(value);
      case "enum":
        return visitor.enum(value);
      case "reference":
        return visitor.reference(value);
      case "literal":
        return visitor.literal(value);
      case "oneOf":
        return visitor.oneOf(value.value);
      case "nullable":
        return visitor.nullable(value);
      case "unknown":
        return visitor.unknown(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/OneOfSchemaWithExample.js
var OneOfSchemaWithExample = {
  discriminated: (value) => {
    return {
      ...value,
      type: "discriminated",
      _visit: function(visitor) {
        return OneOfSchemaWithExample._visit(this, visitor);
      }
    };
  },
  undisciminated: (value) => {
    return {
      ...value,
      type: "undisciminated",
      _visit: function(visitor) {
        return OneOfSchemaWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "discriminated":
        return visitor.discriminated(value);
      case "undisciminated":
        return visitor.undisciminated(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/PrimitiveSchemaValueWithExample.js
var PrimitiveSchemaValueWithExample = {
  int: (value) => {
    return {
      ...value,
      type: "int",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  int64: (value) => {
    return {
      ...value,
      type: "int64",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      ...value,
      type: "uint",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      ...value,
      type: "uint64",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      ...value,
      type: "float",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      ...value,
      type: "double",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      ...value,
      type: "string",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  datetime: (value) => {
    return {
      ...value,
      type: "datetime",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      ...value,
      type: "date",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      ...value,
      type: "base64",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      ...value,
      type: "boolean",
      _visit: function(visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "int":
        return visitor.int(value);
      case "int64":
        return visitor.int64(value);
      case "uint":
        return visitor.uint(value);
      case "uint64":
        return visitor.uint64(value);
      case "float":
        return visitor.float(value);
      case "double":
        return visitor.double(value);
      case "string":
        return visitor.string(value);
      case "datetime":
        return visitor.datetime(value);
      case "date":
        return visitor.date(value);
      case "base64":
        return visitor.base64(value);
      case "boolean":
        return visitor.boolean(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/constants.js
var NUMERIC_REGEX = /^(\d+)/;
var VALID_ENUM_NAME_REGEX = /^[a-zA-Z][a-zA-Z0-9_]*$/;
var HARDCODED_ENUM_NAMES = {
  "<": "LESS_THAN",
  ">": "GREATER_THAN",
  ">=": "GREATER_THAN_OR_EQUAL_TO",
  "<=": "LESS_THAN_OR_EQUAL_TO",
  "!=": "NOT_EQUALS",
  "=": "EQUAL_TO",
  "==": "EQUAL_TO",
  "*": "ALL",
  "": "EMPTY",
  '""': "EMPTY_STRING",
  "-": "HYPHEN",
  "|": "PIPE",
  ".": "DOT",
  "/": "SLASH"
};

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/convertNumberToSnakeCase.js
function convertNumberToSnakeCase(number3) {
  const singleDigits = ["zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine"];
  const teenNumbers = [
    "ten",
    "eleven",
    "twelve",
    "thirteen",
    "fourteen",
    "fifteen",
    "sixteen",
    "seventeen",
    "eighteen",
    "nineteen"
  ];
  const tensNumbers = ["", "", "twenty", "thirty", "forty", "fifty", "sixty", "seventy", "eighty", "ninety"];
  if (number3 < 0 || number3 > 9999) {
    return void 0;
  }
  if (number3 < 10) {
    return singleDigits[number3];
  }
  if (number3 < 20) {
    return teenNumbers[number3 - 10];
  }
  if (number3 < 100) {
    const tens = Math.floor(number3 / 10);
    const remainder2 = number3 % 10;
    if (remainder2 === 0) {
      return tensNumbers[tens];
    } else {
      return `${tensNumbers[tens]}_${singleDigits[remainder2]}`;
    }
  }
  if (number3 < 1e3) {
    const hundreds = Math.floor(number3 / 100);
    const remainder2 = number3 % 100;
    if (remainder2 === 0) {
      return `${singleDigits[hundreds]}_hundred`;
    } else {
      return `${singleDigits[hundreds]}_hundred_${convertNumberToSnakeCase(remainder2)}`;
    }
  }
  const thousands = Math.floor(number3 / 1e3);
  const remainder = number3 % 1e3;
  if (remainder === 0) {
    return `${singleDigits[thousands]}_thousand`;
  } else {
    return `${singleDigits[thousands]}_thousand_${convertNumberToSnakeCase(remainder)}`;
  }
}

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/replaceStartingNumber.js
function replaceStartingNumber(input) {
  const matches = input.match(NUMERIC_REGEX);
  if (matches && matches[0] != null) {
    const numericPart = matches[0];
    const nonNumericPart = input.substring(numericPart.length);
    const parsedNumber = parseFloat(numericPart);
    if (!isNaN(parsedNumber) && isFinite(parsedNumber)) {
      const snakeCasedNumber = convertNumberToSnakeCase(parsedNumber);
      return nonNumericPart.length > 0 ? `${snakeCasedNumber}_${nonNumericPart}` : snakeCasedNumber;
    }
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/generateEnumNameFromValue.js
function generateEnumNameFromValue(value) {
  const maybeParsedNumber = replaceStartingNumber(value);
  const maybeHardcodedEnumName = HARDCODED_ENUM_NAMES[value];
  if (maybeParsedNumber != null) {
    return upperFirst_default(camelCase_default(maybeParsedNumber));
  } else if (maybeHardcodedEnumName != null) {
    return maybeHardcodedEnumName;
  } else {
    if (value.toLowerCase() === "n/a") {
      return "NOT_APPLICABLE";
    }
    return upperFirst_default(camelCase_default(value));
  }
}

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/isSchemaEqual.js
function isSchemaEqual(a, b) {
  if (a.type === "primitive" && b.type === "primitive") {
    return isPrimitiveSchemaValueEqual(a.schema, b.schema);
  } else if (a.type === "enum" && b.type === "enum") {
    return areEnumValuesEqual(a.values, b.values);
  } else if (a.type === "array" && b.type === "array") {
    return isSchemaEqual(a.value, b.value);
  } else if (a.type === "unknown" && b.type === "unknown") {
    return true;
  } else if (a.type === "reference" && b.type === "reference") {
    return a.schema === b.schema;
  } else if (a.type === "optional" && b.type === "optional") {
    return isSchemaEqual(a.value, b.value);
  } else if (a.type === "oneOf" && b.type === "oneOf") {
    return isOneOfEqual(a.value, b.value);
  } else if (a.type === "object" && b.type === "object") {
    return isObjectEqual(a, b);
  } else if (a.type === "map" && b.type === "map") {
    return isPrimitiveSchemaValueEqual(a.key.schema, b.key.schema) && isSchemaEqual(a.value, b.value);
  } else if (a.type === "literal" && b.type === "literal") {
    return a.value === b.value;
  }
  return false;
}
function isPrimitiveSchemaValueEqual(a, b) {
  return a.type === b.type;
}
function areEnumValuesEqual(a, b) {
  const aSet = new Set(...a.map((enumValue) => enumValue.value));
  const bSet = new Set(...b.map((enumValue) => enumValue.value));
  return isEqual_default(aSet, bSet);
}
function isOneOfEqual(a, b) {
  if (a.type === "discriminated" && b.type === "discriminated") {
    return a.discriminantProperty === b.discriminantProperty && Object.keys(a.schemas).length === Object.keys(b.schemas).length && Object.entries(a.schemas).every(([discrminant, aSchema]) => {
      const bSchema = b.schemas[discrminant];
      if (bSchema == null) {
        return false;
      }
      return isSchemaEqual(aSchema, bSchema);
    });
  }
  if (a.type === "undisciminated" && b.type === "undisciminated") {
    return a.schemas.length === b.schemas.length && a.schemas.every((aSchema, index) => {
      const bSchema = b.schemas[index];
      if (bSchema == null) {
        return false;
      }
      return isSchemaEqual(aSchema, bSchema);
    });
  }
  return false;
}
function isObjectEqual(a, b) {
  if (Object.keys(a.properties).length !== Object.keys(b.properties).length) {
    return false;
  }
  const aPropertyMap = Object.fromEntries(a.properties.map((property4) => {
    return [property4.key, property4.schema];
  }));
  return Object.entries(b.properties).every(([bPropertyName, bPropertySchema]) => {
    const aProperty = aPropertyMap[bPropertyName];
    if (aProperty == null) {
      return false;
    }
    return isSchemaEqual(aProperty, bPropertySchema.schema);
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertToEncodingSchema.js
function convertToEncodingSchema(encoding) {
  switch (encoding.type) {
    case "protobuf":
      return {
        proto: {
          type: encoding.typeName
        }
      };
    default:
      assertNever(encoding.type);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getGroupNameForSchema.js
function getGroupNameForSchema(schema2) {
  switch (schema2.type) {
    case "object":
    case "enum":
    case "array":
    case "map":
    case "reference":
    case "literal":
    case "optional":
    case "nullable":
    case "primitive":
      return schema2.groupName ?? void 0;
    case "oneOf":
      return schema2.value.groupName ?? void 0;
    case "unknown":
      return void 0;
    default:
      assertNever(schema2);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getTypeFromTypeReference.js
function getTypeFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return typeReference;
  }
  return typeReference.type;
}
function getDocsFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return void 0;
  }
  return typeReference.docs;
}
function getDefaultFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return void 0;
  }
  return typeReference.default;
}
function getValidationFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return void 0;
  }
  return typeReference.validation;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertSdkGroupName.js
function cleanSdkGroupName(groupName) {
  const maybeNamespace = groupName.find((group) => typeof group === "object" && group.type === "namespace");
  const noNamespace = groupName.filter((group) => typeof group === "string" || group.type !== "namespace");
  return maybeNamespace ? [maybeNamespace, ...noNamespace] : noNamespace;
}
function convertSdkGroupNameToFileWithoutExtension(groupName) {
  const cleanedGroupName = groupName ? cleanSdkGroupName(groupName) : void 0;
  if (cleanedGroupName == null || cleanedGroupName.length === 0) {
    return FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION;
  }
  const fileNames = [];
  for (const [index, group] of cleanedGroupName.entries()) {
    if (typeof group === "string") {
      fileNames.push(camelCase_default(group));
    } else if (typeof group === "object") {
      switch (group.type) {
        case "namespace": {
          if (index < cleanedGroupName.length - 1) {
            fileNames.push(camelCase_default(group.name));
          } else {
            fileNames.push(...[group.name, FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION]);
          }
          break;
        }
        default:
          assertNever(group.type);
      }
    } else {
      assertNever(group);
    }
  }
  return fileNames.join("/");
}
function convertSdkGroupNameToFile(groupName) {
  return RelativeFilePath.of(`${convertSdkGroupNameToFileWithoutExtension(groupName)}.yml`);
}
function convertEndpointSdkNameToFileWithoutExtension({ sdkName, namespaceOverride }) {
  let groupName;
  if (sdkName == null || sdkName.groupName.length === 0 && namespaceOverride == null) {
    return FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION;
  } else if (namespaceOverride != null) {
    groupName = [
      { type: "namespace", name: namespaceOverride },
      ...sdkName.groupName.filter((group) => typeof group === "string" || group.type !== "namespace")
    ];
  } else {
    groupName = sdkName.groupName;
  }
  return convertSdkGroupNameToFileWithoutExtension(groupName);
}
function convertEndpointSdkNameToFile({ sdkName, namespaceOverride }) {
  return RelativeFilePath.of(`${convertEndpointSdkNameToFileWithoutExtension({ sdkName, namespaceOverride })}.yml`);
}
function resolveLocationWithNamespace({ location, namespaceOverride }) {
  if (namespaceOverride != null) {
    return join(RelativeFilePath.of(namespaceOverride), location);
  }
  return location;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertAvailability.js
function convertAvailability2(availability) {
  switch (availability) {
    case Availability.Deprecated:
      return "deprecated";
    case Availability.Beta:
      return "pre-release";
    case Availability.GenerallyAvailable:
      return "generally-available";
    default:
      return void 0;
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildTypeReference.js
var MIN_INT_32 = -2147483648;
var MAX_INT_32 = 2147483647;
var MIN_DOUBLE_64 = -17976931348623157e292;
var MAX_DOUBLE_64 = 17976931348623157e292;
function buildTypeReference({
  schema: schema2,
  /* The file the type reference will be written to */
  fileContainingReference,
  /* The file any type declarations will be written to. Defaults to fileContainingReference if not present */
  declarationFile = fileContainingReference,
  context,
  namespace,
  declarationDepth
}) {
  if (context.shouldMarkSchemaAsReferenced()) {
    context.markSchemaAsReferenced(schema2, namespace);
  }
  switch (schema2.type) {
    case "primitive": {
      return buildPrimitiveTypeReference(schema2);
    }
    case "array":
      return buildArrayTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "map":
      return buildMapTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "reference":
      return buildReferenceTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        namespace
      });
    case "unknown":
      return buildUnknownTypeReference();
    case "optional":
    case "nullable":
      return buildOptionalTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "enum":
      return buildEnumTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        declarationDepth
      });
    case "literal":
      schema2.value;
      return buildLiteralTypeReference(schema2);
    case "object":
      return buildObjectTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "oneOf":
      return buildOneOfTypeReference({
        schema: schema2.value,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    default:
      assertNever(schema2);
  }
}
function buildPrimitiveTypeReference(primitiveSchema) {
  switch (primitiveSchema.schema.type) {
    case "string":
      return buildStringTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "int":
      return buildIntegerTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "float":
      return buildFloatTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "double":
      return buildDoubleTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "boolean":
      return buildBooleanTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "int64":
      return buildLongTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
  }
  const typeReference = primitiveSchema.schema._visit({
    int: () => "integer",
    int64: () => "long",
    uint: () => "uint",
    uint64: () => "uint64",
    float: () => "double",
    double: () => "double",
    string: () => "string",
    datetime: () => "datetime",
    date: () => "date",
    base64: () => "base64",
    boolean: () => "boolean",
    _other: () => "unknown"
  });
  if (primitiveSchema.description == null && primitiveSchema.title == null) {
    return typeReference;
  }
  return {
    type: typeReference,
    ...primitiveSchema.description != null ? { docs: primitiveSchema.description } : {},
    ...primitiveSchema.availability != null ? { availability: convertAvailability2(primitiveSchema.availability) } : {}
  };
}
function buildBooleanTypeReference({ description, schema: schema2 }) {
  const type2 = "boolean";
  if (description == null && schema2.default == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  return result;
}
function buildLongTypeReference({ description, schema: schema2 }) {
  const type2 = "long";
  if (description == null && schema2.default == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  return result;
}
function buildStringTypeReference({ description, schema: schema2 }) {
  const type2 = "string";
  const validation = maybeStringValidation(schema2);
  if (description == null && schema2.default == null && validation == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  if (validation != null) {
    result.validation = validation;
  }
  return result;
}
function buildIntegerTypeReference({ description, schema: schema2 }) {
  const type2 = "integer";
  const validation = maybeNumberValidation(schema2, type2);
  if (description == null && schema2.default == null && validation == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  if (validation != null) {
    result.validation = validation;
  }
  return result;
}
function buildFloatTypeReference({ description, schema: schema2 }) {
  const type2 = "float";
  if (description == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  return result;
}
function buildDoubleTypeReference({ description, schema: schema2 }) {
  const type2 = "double";
  const validation = maybeNumberValidation(schema2, type2);
  if (description == null && schema2.default == null && validation == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  if (validation != null) {
    result.validation = validation;
  }
  return result;
}
function maybeStringValidation(schema2) {
  if (schema2 == null) {
    return void 0;
  }
  const { format, pattern, minLength, maxLength } = schema2;
  const validFormat = maybeValidFormat(format);
  if (validFormat == null && pattern == null && minLength == null && maxLength == null) {
    return void 0;
  }
  return {
    format: validFormat,
    pattern,
    minLength,
    maxLength
  };
}
function maybeValidFormat(format) {
  switch (format) {
    case "date":
    case "date-time":
    case "password":
    case "byte":
    case "bytes":
    case "binary":
    case "email":
    case "uuid":
    case "uri":
    case "hostname":
    case "ipv4":
    case "ipv6":
      return format;
    default:
      return void 0;
  }
}
function maybeNumberValidation(schema2, type2) {
  if (schema2 == null) {
    return void 0;
  }
  let { minimum, maximum, multipleOf } = schema2;
  const { exclusiveMinimum, exclusiveMaximum } = schema2;
  minimum = makeUndefinedIfOutsideRange(minimum, type2);
  maximum = makeUndefinedIfOutsideRange(maximum, type2);
  multipleOf = makeUndefinedIfOutsideRange(multipleOf, type2);
  if (minimum == null && maximum == null && exclusiveMinimum == null && exclusiveMaximum == null && multipleOf == null) {
    return void 0;
  }
  return {
    min: minimum,
    max: maximum,
    exclusiveMin: exclusiveMinimum,
    exclusiveMax: exclusiveMaximum,
    multipleOf
  };
}
function makeUndefinedIfOutsideRange(num, type2) {
  if (num === void 0) {
    return void 0;
  }
  const [min, max] = type2 === "integer" ? [MIN_INT_32, MAX_INT_32] : [MIN_DOUBLE_64, MAX_DOUBLE_64];
  return num < min || num > max ? void 0 : num;
}
function buildReferenceTypeReference({ schema: schema2, fileContainingReference, context, namespace }) {
  const resolvedSchema = context.getSchema(schema2.schema, namespace);
  if (resolvedSchema == null) {
    return "unknown";
  }
  const schemaName = getSchemaName(resolvedSchema) ?? schema2.schema;
  const groupName = getGroupNameForSchema(resolvedSchema);
  const displayName = getDisplayName(resolvedSchema);
  const typeWithPrefix = getPrefixedType({
    context,
    fileContainingReference,
    declarationFile: convertSdkGroupNameToFile(groupName),
    type: schemaName
  });
  const type2 = resolvedSchema.type === "nullable" ? `optional<${typeWithPrefix}>` : typeWithPrefix;
  if (schema2.description == null && displayName == null) {
    return type2;
  }
  return {
    type: resolvedSchema.type === "nullable" ? `optional<${typeWithPrefix}>` : typeWithPrefix,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function buildArrayTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const item = buildTypeReference({
    schema: schema2.value,
    fileContainingReference,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const type2 = `list<${getTypeFromTypeReference(item)}>`;
  if (schema2.description == null && schema2.title == null) {
    return type2;
  }
  return {
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {},
    type: type2
  };
}
function buildMapTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const keyTypeReference = buildPrimitiveTypeReference(schema2.key);
  const valueTypeReference = buildTypeReference({
    schema: schema2.value,
    fileContainingReference,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const encoding = schema2.encoding != null ? convertToEncodingSchema(schema2.encoding) : void 0;
  const type2 = `map<${getTypeFromTypeReference(keyTypeReference)}, ${getTypeFromTypeReference(valueTypeReference)}>`;
  if (schema2.description == null && encoding == null && schema2.title == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (schema2.description != null) {
    result.docs = schema2.description;
  }
  if (schema2.encoding != null) {
    result.encoding = encoding;
  }
  if (schema2.availability != null) {
    result.availability = convertAvailability2(schema2.availability);
  }
  return result;
}
function buildOptionalTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const itemTypeReference = buildTypeReference({
    schema: schema2.value,
    fileContainingReference,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const itemType = getTypeFromTypeReference(itemTypeReference);
  const itemDocs = getDocsFromTypeReference(itemTypeReference);
  const itemDefault = getDefaultFromTypeReference(itemTypeReference);
  const itemValidation = getValidationFromTypeReference(itemTypeReference);
  const type2 = itemType.startsWith("optional<") ? itemType : `optional<${itemType}>`;
  if (schema2.availability == null && schema2.description == null && itemDocs == null && itemDefault == null && itemValidation == null && schema2.title == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (schema2.description != null || itemDocs != null) {
    result.docs = schema2.description ?? itemDocs;
  }
  if (itemDefault != null) {
    result.default = itemDefault;
  }
  if (itemValidation != null) {
    result.validation = itemValidation;
  }
  if (schema2.availability != null) {
    result.availability = convertAvailability2(schema2.availability);
  }
  return result;
}
function buildUnknownTypeReference() {
  return "unknown";
}
function buildLiteralTypeReference(schema2) {
  let value;
  switch (schema2.value.type) {
    case "boolean": {
      value = `literal<${schema2.value.value}>`;
      break;
    }
    case "string": {
      value = `literal<"${schema2.value.value}">`;
      break;
    }
    default:
      assertNever(schema2.value);
  }
  if (schema2.description == null && schema2.title == null) {
    return value;
  }
  return {
    type: value,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function buildEnumTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, declarationDepth }) {
  const enumTypeDeclaration = buildEnumTypeDeclaration(schema2, declarationDepth);
  const name = schema2.nameOverride ?? schema2.generatedName;
  context.builder.addType(declarationFile, {
    name,
    schema: enumTypeDeclaration.schema
  });
  const prefixedType = getPrefixedType({ type: name, fileContainingReference, declarationFile, context });
  if (schema2.description == null && schema2.default == null && schema2.title == null) {
    return prefixedType;
  }
  const result = {
    type: prefixedType
  };
  if (schema2.description != null) {
    result.docs = schema2.description;
  }
  if (schema2.default != null) {
    result.default = schema2.default.value;
  }
  if (schema2.availability != null) {
    result.availability = convertAvailability2(schema2.availability);
  }
  return result;
}
function buildObjectTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const objectTypeDeclaration = buildObjectTypeDeclaration({
    schema: schema2,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const name = schema2.nameOverride ?? schema2.generatedName;
  context.builder.addType(declarationFile, {
    name,
    schema: objectTypeDeclaration.schema
  });
  const prefixedType = getPrefixedType({ type: name, fileContainingReference, declarationFile, context });
  if (schema2.description == null && schema2.title == null) {
    return prefixedType;
  }
  return {
    type: prefixedType,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function buildOneOfTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const unionTypeDeclaration = buildOneOfTypeDeclaration({
    schema: schema2,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const name = schema2.nameOverride ?? schema2.generatedName;
  context.builder.addType(declarationFile, {
    name,
    schema: unionTypeDeclaration.schema
  });
  const prefixedType = getPrefixedType({ type: name, fileContainingReference, declarationFile, context });
  if (schema2.description == null && schema2.title == null) {
    return prefixedType;
  }
  return {
    ...schema2.title != null ? { "display-name": schema2.title } : {},
    type: prefixedType,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function getPrefixedType({ type: type2, fileContainingReference, declarationFile, context }) {
  if (declarationFile === fileContainingReference) {
    return type2;
  }
  const prefix = context.builder.addImport({
    file: fileContainingReference,
    fileToImport: declarationFile
  });
  return prefix != null ? `${prefix}.${type2}` : type2;
}
function getSchemaName(schema2) {
  return Schema._visit(schema2, {
    primitive: (s) => s.nameOverride ?? s.generatedName,
    object: (s) => s.nameOverride ?? s.generatedName,
    array: (s) => s.nameOverride ?? s.generatedName,
    map: (s) => s.nameOverride ?? s.generatedName,
    enum: (s) => s.nameOverride ?? s.generatedName,
    reference: (s) => s.nameOverride ?? s.generatedName,
    literal: (s) => s.nameOverride ?? s.generatedName,
    oneOf: (s) => s.nameOverride ?? s.generatedName,
    optional: (s) => s.nameOverride ?? s.generatedName,
    nullable: (s) => s.nameOverride ?? s.generatedName,
    unknown: (s) => s.nameOverride ?? s.generatedName,
    _other: () => void 0
  });
}
function getDisplayName(schema2) {
  return Schema._visit(schema2, {
    primitive: (s) => s.title,
    object: (s) => s.title,
    array: (s) => s.title,
    map: (s) => s.title,
    enum: (s) => s.title,
    reference: (s) => s.title,
    literal: (s) => s.title,
    oneOf: (s) => s.title,
    optional: (s) => s.title,
    nullable: (s) => s.title,
    unknown: (s) => void 0,
    _other: () => void 0
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertToSourceSchema.js
function convertToSourceSchema(source) {
  switch (source.type) {
    case "openapi":
      return {
        openapi: source.file
      };
    case "protobuf":
      return {
        proto: source.file
      };
    default:
      assertNever(source);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/State.js
var State;
(function(State3) {
  State3[State3["Channel"] = 0] = "Channel";
  State3[State3["Endpoint"] = 1] = "Endpoint";
  State3[State3["Request"] = 2] = "Request";
  State3[State3["Webhook"] = 3] = "Webhook";
})(State || (State = {}));

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildTypeDeclaration.js
function buildTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  switch (schema2.type) {
    case "primitive":
      return buildPrimitiveTypeDeclaration(schema2);
    case "array":
      return buildArrayTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "map":
      return buildMapTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "reference":
      return buildReferenceTypeDeclaration({ schema: schema2, context, declarationFile, namespace });
    case "unknown":
      return buildUnknownTypeDeclaration(schema2.nameOverride, schema2.generatedName);
    case "optional":
    case "nullable":
      return buildOptionalTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "enum":
      return buildEnumTypeDeclaration(schema2, declarationDepth);
    case "literal":
      return buildLiteralTypeDeclaration(schema2, schema2.nameOverride, schema2.generatedName);
    case "object":
      return buildObjectTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "oneOf":
      return buildOneOfTypeDeclaration({
        schema: schema2.value,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    default:
      assertNever(schema2);
  }
}
function buildObjectTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  const shouldSkipReadonly = context.isInState(State.Request) && context.respectReadonlySchemas && (context.getEndpointMethod() === "POST" || context.getEndpointMethod() === "PUT" || context.getEndpointMethod() === "PATCH");
  let readOnlyPropertyPresent = false;
  const properties = {};
  const schemasToInline = /* @__PURE__ */ new Set();
  for (const property4 of schema2.properties) {
    if (property4.readonly) {
      readOnlyPropertyPresent = true;
    }
    if (shouldSkipReadonly && property4.readonly) {
      continue;
    }
    if (Object.keys(property4.conflict).length > 0) {
      const parentHasIdentiticalProperty = Object.entries(property4.conflict).every(([_, conflict]) => {
        return !conflict.differentSchema;
      });
      if (parentHasIdentiticalProperty) {
        continue;
      } else {
        Object.entries(property4.conflict).forEach(([schemaId]) => {
          const parentSchemasToInine = getAllParentSchemasToInline({
            property: property4.key,
            schemaId,
            context,
            namespace
          });
          parentSchemasToInine.forEach((schemaToInline) => {
            schemasToInline.add(schemaToInline);
          });
        });
      }
    }
    const typeReference = buildTypeReference({
      schema: property4.schema,
      context,
      fileContainingReference: declarationFile,
      namespace,
      declarationDepth: declarationDepth + 1
    });
    const audiences = property4.audiences;
    const name2 = property4.nameOverride;
    const availability = convertAvailability2(property4.availability);
    properties[property4.key] = convertPropertyTypeReferenceToTypeDefinition({
      typeReference,
      audiences,
      name: name2,
      availability
    });
  }
  const propertiesToSetToUnknown = /* @__PURE__ */ new Set();
  for (const allOfPropertyConflict of schema2.allOfPropertyConflicts) {
    allOfPropertyConflict.allOfSchemaIds.forEach((schemaId) => schemasToInline.add(schemaId));
    if (allOfPropertyConflict.conflictingTypeSignatures) {
      propertiesToSetToUnknown.add(allOfPropertyConflict.propertyKey);
    }
  }
  const extendedSchemas = [];
  for (const allOf of schema2.allOf) {
    const resolvedSchemaId = getSchemaIdOfResolvedType({ schema: allOf.schema, context, namespace });
    if (resolvedSchemaId == null) {
      continue;
    }
    if (schemasToInline.has(allOf.schema) || schemasToInline.has(resolvedSchemaId)) {
      continue;
    }
    const allOfTypeReference = buildTypeReference({
      schema: Schema.reference(allOf),
      context,
      fileContainingReference: declarationFile,
      namespace,
      declarationDepth: declarationDepth + 1
    });
    extendedSchemas.push(getTypeFromTypeReference(allOfTypeReference));
  }
  for (const inlineSchemaId of schemasToInline) {
    const inlinedSchemaPropertyInfo = getProperties(context, inlineSchemaId, namespace);
    for (const propertyToInline of inlinedSchemaPropertyInfo.properties) {
      if (properties[propertyToInline.key] == null) {
        if (propertiesToSetToUnknown.has(propertyToInline.key)) {
          properties[propertyToInline.key] = "unknown";
        }
        properties[propertyToInline.key] = buildTypeReference({
          schema: propertyToInline.schema,
          context,
          fileContainingReference: declarationFile,
          namespace,
          declarationDepth: declarationDepth + 1
        });
      }
    }
    for (const extendedSchema of inlinedSchemaPropertyInfo.allOf) {
      if (schemasToInline.has(extendedSchema.schema)) {
        continue;
      }
      const extendedSchemaTypeReference = buildTypeReference({
        schema: Schema.reference(extendedSchema),
        context,
        fileContainingReference: declarationFile,
        namespace,
        declarationDepth: declarationDepth + 1
      });
      extendedSchemas.push(getTypeFromTypeReference(extendedSchemaTypeReference));
    }
  }
  const objectTypeDeclaration = {
    docs: schema2.description ?? void 0,
    properties: Object.fromEntries(Object.entries(properties).map(([propertyKey, propertyDefinition]) => {
      if (startsWithNumber2(propertyKey)) {
        return [
          propertyKey,
          typeof propertyDefinition === "string" ? {
            type: propertyDefinition,
            name: `_${propertyKey}`
          } : {
            ...propertyDefinition,
            name: `_${propertyKey}`
          }
        ];
      }
      return [propertyKey, propertyDefinition];
    }))
  };
  if (extendedSchemas.length > 0) {
    objectTypeDeclaration.extends = extendedSchemas;
  }
  if (schema2.additionalProperties) {
    objectTypeDeclaration["extra-properties"] = true;
  }
  if (schema2.availability != null) {
    objectTypeDeclaration.availability = convertAvailability2(schema2.availability);
  }
  if (schema2.source != null) {
    objectTypeDeclaration.source = convertToSourceSchema(schema2.source);
  }
  objectTypeDeclaration.inline = getInline(declarationDepth);
  const name = schema2.nameOverride ?? schema2.generatedName;
  return {
    name: readOnlyPropertyPresent && context.respectReadonlySchemas && !shouldSkipReadonly ? `${name}Read` : name,
    schema: objectTypeDeclaration
  };
}
function getAllParentSchemasToInline({ property: property4, schemaId, context, namespace }) {
  const schema2 = context.getSchema(schemaId, namespace);
  if (schema2 == null) {
    return [];
  }
  if (schema2.type === "reference") {
    return getAllParentSchemasToInline({ property: property4, schemaId: schema2.schema, context, namespace });
  }
  if (schema2.type === "object") {
    const { properties, allOf } = getProperties(context, schemaId, namespace);
    const hasProperty = properties.some((p) => {
      return p.key === property4;
    });
    const parentSchemasToInline = [
      ...allOf.flatMap((parent) => {
        return getAllParentSchemasToInline({ property: property4, context, schemaId: parent.schema, namespace });
      })
    ];
    if (hasProperty || parentSchemasToInline.length > 0) {
      return [schemaId, ...parentSchemasToInline];
    }
  }
  return [];
}
function getProperties(context, schemaId, namespace) {
  const schema2 = context.getSchema(schemaId, namespace);
  if (schema2 == null) {
    return { properties: [], allOf: [] };
  }
  if (schema2.type === "object") {
    return { properties: schema2.properties, allOf: schema2.allOf };
  } else if (schema2.type === "reference") {
    return getProperties(context, schema2.schema, namespace);
  }
  throw new Error(`Cannot getAllProperties for a non-object schema. schemaId=${schemaId}, type=${schema2.type}`);
}
function buildArrayTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildArrayTypeReference({
      schema: schema2,
      fileContainingReference: declarationFile,
      declarationFile,
      context,
      namespace,
      declarationDepth
    })
  };
}
function buildMapTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildMapTypeReference({
      schema: schema2,
      fileContainingReference: declarationFile,
      declarationFile,
      context,
      namespace,
      declarationDepth
    })
  };
}
function buildPrimitiveTypeDeclaration(schema2) {
  const typeReference = buildPrimitiveTypeReference(schema2);
  if (typeof typeReference === "string") {
    return {
      name: schema2.nameOverride ?? schema2.generatedName,
      schema: typeReference
    };
  }
  const { default: _, ...rest } = typeReference;
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: {
      ...rest
    }
  };
}
function isCasingEmpty(casing) {
  return casing.camel == null && casing.pascal == null && casing.screamingSnake == null && casing.snake == null;
}
function buildEnumTypeDeclaration(schema2, declarationDepth) {
  const enumSchema = {
    enum: schema2.values.map((enumValue) => {
      const name = enumValue.nameOverride ?? enumValue.generatedName;
      const value = enumValue.value;
      if (name === value && enumValue.description == null && (enumValue.casing == null || isCasingEmpty(enumValue.casing))) {
        return name;
      }
      const enumValueDeclaration = {
        value: enumValue.value
      };
      if (name !== value) {
        enumValueDeclaration.name = name;
      }
      if (enumValue.description != null) {
        enumValueDeclaration.docs = enumValue.description;
      }
      if (enumValue.casing != null && !isCasingEmpty(enumValue.casing)) {
        const casing = {};
        let setCasing = false;
        if (enumValue.casing.camel != null) {
          casing.camel = enumValue.casing.camel;
          setCasing = true;
        }
        if (enumValue.casing.screamingSnake != null) {
          casing["screaming-snake"] = enumValue.casing.screamingSnake;
          setCasing = true;
        }
        if (enumValue.casing.snake != null) {
          casing.snake = enumValue.casing.snake;
          setCasing = true;
        }
        if (enumValue.casing.pascal != null) {
          casing.pascal = enumValue.casing.pascal;
          setCasing = true;
        }
        if (setCasing) {
          enumValueDeclaration.casing = casing;
        }
      }
      return enumValueDeclaration;
    })
  };
  if (schema2.description != null) {
    enumSchema.docs = schema2.description;
  }
  if (schema2.default != null) {
    enumSchema.default = schema2.default.value;
  }
  const uniqueEnumName = /* @__PURE__ */ new Set();
  const uniqueEnumSchema = {
    ...enumSchema,
    enum: [],
    source: schema2.source != null ? convertToSourceSchema(schema2.source) : void 0
  };
  for (const enumValue of enumSchema.enum) {
    const name = typeof enumValue === "string" ? enumValue : enumValue.name ?? enumValue.value;
    if (!uniqueEnumName.has(name.toLowerCase())) {
      uniqueEnumSchema.enum.push(enumValue);
      uniqueEnumName.add(name.toLowerCase());
    }
  }
  enumSchema.inline = getInline(declarationDepth);
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: uniqueEnumSchema
  };
}
function buildReferenceTypeDeclaration({ schema: schema2, context, declarationFile, namespace }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildReferenceTypeReference({
      schema: schema2,
      context,
      fileContainingReference: declarationFile,
      namespace
    })
  };
}
function buildOptionalTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildOptionalTypeReference({
      schema: schema2,
      context,
      fileContainingReference: declarationFile,
      declarationFile,
      namespace,
      declarationDepth
    })
  };
}
function buildUnknownTypeDeclaration(nameOverride, generatedName) {
  return {
    name: nameOverride ?? generatedName,
    schema: buildUnknownTypeReference()
  };
}
function buildLiteralTypeDeclaration(schema2, nameOverride, generatedName) {
  return {
    name: nameOverride ?? generatedName,
    schema: buildLiteralTypeReference(schema2)
  };
}
function buildOneOfTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  const encoding = schema2.encoding != null ? convertToEncodingSchema(schema2.encoding) : void 0;
  if (schema2.type === "discriminated") {
    const baseProperties = {};
    for (const property4 of schema2.commonProperties) {
      baseProperties[property4.key] = buildTypeReference({
        schema: property4.schema,
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: declarationDepth + 1
      });
    }
    const union4 = {};
    for (const [discriminantValue, subSchema] of Object.entries(schema2.schemas)) {
      union4[discriminantValue] = buildTypeReference({
        schema: subSchema,
        context,
        fileContainingReference: declarationFile,
        namespace,
        declarationDepth: declarationDepth + 1
      });
    }
    return {
      name: schema2.nameOverride ?? schema2.generatedName,
      schema: {
        discriminant: schema2.discriminantProperty,
        "base-properties": baseProperties,
        docs: schema2.description ?? void 0,
        availability: schema2.availability != null ? convertAvailability2(schema2.availability) : void 0,
        union: union4,
        encoding,
        source: schema2.source != null ? convertToSourceSchema(schema2.source) : void 0
      }
    };
  }
  const union3 = [];
  for (const subSchema of schema2.schemas) {
    union3.push(buildTypeReference({
      schema: subSchema,
      fileContainingReference: declarationFile,
      context,
      namespace,
      declarationDepth: declarationDepth + 1
    }));
  }
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: {
      discriminated: false,
      docs: schema2.description ?? void 0,
      union: union3,
      encoding,
      source: schema2.source != null ? convertToSourceSchema(schema2.source) : void 0,
      inline: getInline(declarationDepth)
    }
  };
}
var STARTS_WITH_NUMBER2 = /^[0-9]/;
function startsWithNumber2(str2) {
  return STARTS_WITH_NUMBER2.test(str2);
}
function getSchemaIdOfResolvedType({ schema: schema2, context, namespace }) {
  const resolvedSchema = context.getSchema(schema2, namespace);
  if (resolvedSchema == null) {
    return void 0;
  }
  if (resolvedSchema.type === "reference") {
    return getSchemaIdOfResolvedType({ context, schema: resolvedSchema.schema, namespace });
  }
  return schema2;
}
function convertPropertyTypeReferenceToTypeDefinition({ typeReference, audiences, name, availability }) {
  if (audiences.length === 0 && name == null && availability == null) {
    return typeReference;
  } else {
    return {
      ...typeof typeReference === "string" ? { type: typeReference } : { ...typeReference },
      ...audiences.length > 0 ? { audiences } : {},
      ...name != null ? { name } : {},
      ...availability != null ? { availability } : {}
    };
  }
}
function getInline(declarationDepth) {
  return declarationDepth > 0 ? true : void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getHeaderName.js
function getHeaderName(headerWireKey) {
  const headerWithoutXPrefix = headerWireKey.replace(/^x-|^X-/, "");
  return camelCase_default(headerWithoutXPrefix);
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildAuthSchemes.js
var BASIC_AUTH_SCHEME = "BasicAuthScheme";
var BEARER_AUTH_SCHEME = "BearerAuthScheme";
function buildAuthSchemes(context) {
  if (context.authOverrides != null) {
    for (const [name, declaration] of Object.entries(context.authOverrides["auth-schemes"] ?? {})) {
      context.builder.addAuthScheme({
        name,
        schema: declaration
      });
    }
    if (context.authOverrides.auth != null) {
      context.builder.setAuth(context.authOverrides.auth);
    }
    return;
  }
  let setAuth = false;
  for (const [id, securityScheme] of Object.entries(context.ir.securitySchemes)) {
    if (securityScheme.type === "basic") {
      const basicAuthScheme = {
        scheme: "basic"
      };
      if (securityScheme.usernameVariableName != null) {
        if (basicAuthScheme.username === void 0) {
          basicAuthScheme.username = {
            name: securityScheme.usernameVariableName
          };
        } else {
          basicAuthScheme.username.name = securityScheme.usernameVariableName;
        }
      }
      if (securityScheme.usernameEnvVar != null) {
        if (basicAuthScheme.username === void 0) {
          basicAuthScheme.username = {
            env: securityScheme.usernameEnvVar
          };
        } else {
          basicAuthScheme.username.env = securityScheme.usernameEnvVar;
        }
      }
      if (securityScheme.passwordVariableName != null) {
        if (basicAuthScheme.password === void 0) {
          basicAuthScheme.password = {
            name: securityScheme.passwordVariableName
          };
        } else {
          basicAuthScheme.password.name = securityScheme.passwordVariableName;
        }
      }
      if (securityScheme.passwordEnvVar != null) {
        if (basicAuthScheme.password === void 0) {
          basicAuthScheme.password = {
            env: securityScheme.passwordEnvVar
          };
        } else {
          basicAuthScheme.password.env = securityScheme.passwordEnvVar;
        }
      }
      context.builder.addAuthScheme({
        name: BASIC_AUTH_SCHEME,
        schema: basicAuthScheme
      });
      if (!setAuth) {
        context.builder.setAuth(BASIC_AUTH_SCHEME);
        setAuth = true;
      }
    } else if (securityScheme.type === "bearer") {
      const bearerAuthScheme = {
        scheme: "bearer"
      };
      if (securityScheme.tokenVariableName != null) {
        if (bearerAuthScheme.token === void 0) {
          bearerAuthScheme.token = {
            name: securityScheme.tokenVariableName
          };
        } else {
          bearerAuthScheme.token.name = securityScheme.tokenVariableName;
        }
      }
      if (securityScheme.tokenEnvVar != null) {
        if (bearerAuthScheme.token === void 0) {
          bearerAuthScheme.token = {
            env: securityScheme.tokenEnvVar
          };
        } else {
          bearerAuthScheme.token.env = securityScheme.tokenEnvVar;
        }
      }
      context.builder.addAuthScheme({
        name: BEARER_AUTH_SCHEME,
        schema: bearerAuthScheme
      });
      if (!setAuth) {
        context.builder.setAuth(BEARER_AUTH_SCHEME);
        setAuth = true;
      }
    } else if (securityScheme.type === "header") {
      if (!setAuth) {
        const schema2 = {
          header: securityScheme.headerName,
          name: securityScheme.headerVariableName ?? "apiKey",
          type: "string"
        };
        if (securityScheme.headerEnvVar != null) {
          schema2.env = securityScheme.headerEnvVar;
        }
        if (securityScheme.prefix != null) {
          schema2.prefix = securityScheme.prefix;
        }
        context.builder.addAuthScheme({
          name: id,
          schema: schema2
        });
        context.builder.setAuth(id);
        setAuth = true;
      } else {
        context.builder.addGlobalHeader({
          name: securityScheme.headerName,
          schema: {
            type: "string",
            name: securityScheme.headerVariableName ?? getHeaderName(securityScheme.headerName),
            env: securityScheme.headerEnvVar
          }
        });
      }
    } else if (securityScheme.type === "oauth") {
      const bearerAuthScheme = {
        scheme: "bearer"
      };
      context.builder.addAuthScheme({
        name: BEARER_AUTH_SCHEME,
        schema: bearerAuthScheme
      });
      if (!setAuth) {
        context.builder.setAuth(BEARER_AUTH_SCHEME);
        setAuth = true;
      }
      if (securityScheme.scopesEnum != null && securityScheme.scopesEnum.values.length > 0) {
        context.builder.addType(RelativeFilePath.of("__package__.yml"), {
          name: "OauthScope",
          schema: buildEnumTypeDeclaration(securityScheme.scopesEnum, 0).schema
        });
      }
    }
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildHeader.js
function buildHeader({ header, context, fileContainingReference, namespace }) {
  const typeReference = buildTypeReference({
    schema: header.schema,
    context,
    fileContainingReference,
    namespace,
    declarationDepth: 0
  });
  const headerType = getTypeFromTypeReference(typeReference);
  const headerWithoutXPrefix = header.name.replace(/^x-|^X-/, "");
  const headerVariableName = header.parameterNameOverride != null ? header.parameterNameOverride : camelCase_default(headerWithoutXPrefix);
  if (header.description == null && header.name === headerVariableName && header.env == null && header.availability == null) {
    return headerType;
  }
  const headerSchema = {
    type: headerType
  };
  if (headerVariableName !== header.name) {
    headerSchema.name = headerVariableName;
  }
  if (header.description != null) {
    headerSchema.docs = header.description;
  }
  if (header.env != null) {
    headerSchema.env = header.env;
  }
  if (header.availability != null) {
    headerSchema.availability = convertAvailability2(header.availability);
  }
  return headerSchema;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildPathParameter.js
function buildPathParameter({ pathParameter, context, fileContainingReference, namespace }) {
  const typeReference = buildTypeReference({
    schema: pathParameter.schema,
    context,
    fileContainingReference,
    namespace,
    declarationDepth: 0
  });
  if (pathParameter.variableReference == null && pathParameter.description == null && pathParameter.availability == null) {
    return getTypeFromTypeReference(typeReference);
  }
  const pathParameterSchema = pathParameter.variableReference != null ? {
    variable: `$${pathParameter.variableReference}`
  } : {
    type: getTypeFromTypeReference(typeReference)
  };
  if (pathParameter.description != null) {
    pathParameterSchema.docs = pathParameter.description;
  }
  if (pathParameter.availability != null) {
    pathParameterSchema.availability = convertAvailability2(pathParameter.availability);
  }
  return pathParameterSchema;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildQueryParameter.js
function buildQueryParameter({ queryParameter, context, fileContainingReference, namespace }) {
  const typeReference = getQueryParameterTypeReference({
    schema: queryParameter.schema,
    context,
    fileContainingReference,
    namespace
  });
  if (typeReference == null) {
    return void 0;
  }
  let queryParameterType = getTypeFromTypeReference(typeReference.value);
  if (queryParameterType === "unknown") {
    queryParameterType = "string";
  } else if (queryParameterType === "optional<unknown>") {
    queryParameterType = "optional<string>";
  }
  if (queryParameter.description == null && !typeReference.allowMultiple && queryParameter.parameterNameOverride == null && queryParameter.availability == null) {
    return queryParameterType;
  }
  const queryParameterSchema = {
    type: queryParameterType
  };
  if (typeReference.allowMultiple) {
    queryParameterSchema["allow-multiple"] = true;
  }
  if (queryParameter.description != null) {
    queryParameterSchema.docs = queryParameter.description;
  }
  if (queryParameter.parameterNameOverride != null) {
    queryParameterSchema.name = queryParameter.parameterNameOverride;
  }
  if (queryParameter.availability != null) {
    queryParameterSchema.availability = convertAvailability2(queryParameter.availability);
  }
  if (isRawTypeReferenceDetailedSchema(typeReference.value)) {
    if (typeReference.value.validation !== void 0) {
      queryParameterSchema.validation = typeReference.value.validation;
    }
  }
  return queryParameterSchema;
}
function getQueryParameterTypeReference({ schema: schema2, context, fileContainingReference, namespace }) {
  if (schema2.type === "reference") {
    const resolvedSchema = context.getSchema(schema2.schema, namespace);
    if (resolvedSchema == null) {
      return void 0;
    } else if (resolvedSchema.type === "array") {
      return {
        value: buildTypeReference({
          schema: Schema.optional({
            nameOverride: schema2.nameOverride,
            generatedName: schema2.generatedName,
            title: schema2.title,
            value: resolvedSchema.value,
            description: schema2.description ?? resolvedSchema.description,
            availability: schema2.availability,
            groupName: void 0
          }),
          context,
          declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
          fileContainingReference,
          namespace,
          declarationDepth: 0
        }),
        allowMultiple: true
      };
    } else if (resolvedSchema.type === "oneOf" && resolvedSchema.value.type === "undisciminated") {
      const potentialEnumValues = [];
      for (const [_, schema3] of Object.entries(resolvedSchema.value.schemas)) {
        if (schema3.type === "literal" && schema3.value.type === "string") {
          if (VALID_ENUM_NAME_REGEX.test(schema3.value.value)) {
            potentialEnumValues.push(schema3.value.value);
          } else {
            potentialEnumValues.push({
              value: schema3.value.value,
              name: generateEnumNameFromValue(schema3.value.value)
            });
          }
        }
      }
      if (potentialEnumValues.length > 0) {
        context.builder.addType(fileContainingReference, {
          name: schema2.generatedName,
          schema: { enum: potentialEnumValues }
        });
        return {
          value: schema2.generatedName,
          allowMultiple: false
        };
      }
      if (resolvedSchema.value.schemas.length === 2) {
        const [firstSchema, secondSchema] = resolvedSchema.value.schemas;
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: firstSchema, primitive: secondSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: secondSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: firstSchema, primitive: secondSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: firstSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
      }
      for (const [_, schema3] of Object.entries(resolvedSchema.value.schemas)) {
        return getQueryParameterTypeReference({
          schema: schema3,
          context,
          fileContainingReference,
          namespace
        });
      }
    } else if (context.objectQueryParameters) {
      return {
        value: buildTypeReference({
          schema: schema2,
          context,
          fileContainingReference,
          declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
          namespace,
          declarationDepth: 0
        }),
        allowMultiple: false
      };
    }
  }
  if (schema2.type === "optional" || schema2.type === "nullable") {
    if (schema2.value.type === "reference") {
      const resolvedSchema = context.getSchema(schema2.value.schema, namespace);
      if (resolvedSchema == null) {
        return void 0;
      } else if (resolvedSchema.type === "array") {
        return {
          value: buildTypeReference({
            schema: Schema.optional({
              nameOverride: schema2.nameOverride,
              generatedName: schema2.generatedName,
              title: schema2.title,
              value: resolvedSchema.value,
              description: schema2.description ?? resolvedSchema.description,
              availability: schema2.availability,
              groupName: void 0
            }),
            context,
            fileContainingReference,
            declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
            namespace,
            declarationDepth: 0
          }),
          allowMultiple: true
        };
      } else if (context.objectQueryParameters) {
        return {
          value: buildTypeReference({
            schema: schema2,
            context,
            fileContainingReference,
            declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
            namespace,
            declarationDepth: 0
          }),
          allowMultiple: false
        };
      }
    }
    if (schema2.value.type === "array") {
      return {
        value: buildTypeReference({
          schema: Schema.optional({
            nameOverride: schema2.nameOverride,
            generatedName: schema2.generatedName,
            title: schema2.title,
            value: schema2.value.value,
            description: schema2.description,
            availability: schema2.availability,
            groupName: void 0
          }),
          context,
          fileContainingReference,
          namespace,
          declarationDepth: 0
        }),
        allowMultiple: true
      };
    } else if (schema2.value.type === "oneOf" && schema2.value.value.type === "undisciminated") {
      const potentialEnumValues = [];
      for (const [_, oneOfSchema] of Object.entries(schema2.value.value.schemas)) {
        if (oneOfSchema.type === "literal" && oneOfSchema.value.type === "string") {
          if (VALID_ENUM_NAME_REGEX.test(oneOfSchema.value.value)) {
            potentialEnumValues.push(oneOfSchema.value.value);
          } else {
            potentialEnumValues.push({
              value: oneOfSchema.value.value,
              name: generateEnumNameFromValue(oneOfSchema.value.value)
            });
          }
        }
      }
      if (potentialEnumValues.length > 0) {
        context.builder.addType(fileContainingReference, {
          name: schema2.generatedName,
          schema: { enum: potentialEnumValues }
        });
        return {
          value: `optional<${schema2.value.value.generatedName}>`,
          allowMultiple: false
        };
      }
      if (schema2.value.value.schemas.length === 2) {
        const [firstSchema, secondSchema] = schema2.value.value.schemas;
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: firstSchema, primitive: secondSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: secondSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: secondSchema, primitive: firstSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: firstSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
      }
      for (const [_, oneOfSchema] of Object.entries(schema2.value.value.schemas)) {
        return getQueryParameterTypeReference({
          schema: Schema.optional({
            nameOverride: schema2.nameOverride,
            generatedName: schema2.generatedName,
            title: schema2.title,
            value: oneOfSchema,
            description: void 0,
            availability: schema2.availability,
            groupName: void 0
          }),
          context,
          fileContainingReference,
          namespace
        });
      }
    } else if (schema2.value.type === "object") {
      if (context.objectQueryParameters) {
        return {
          value: buildTypeReference({
            schema: schema2,
            context,
            fileContainingReference,
            declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
            namespace,
            declarationDepth: 0
          }),
          allowMultiple: false
        };
      }
      return void 0;
    }
    return {
      value: buildTypeReference({
        schema: schema2,
        context,
        fileContainingReference,
        namespace,
        declarationDepth: 0
      }),
      allowMultiple: false
    };
  }
  if (schema2.type === "array") {
    return {
      value: buildTypeReference({
        schema: Schema.optional({
          nameOverride: schema2.nameOverride,
          generatedName: schema2.generatedName,
          title: schema2.title,
          value: schema2.value,
          description: schema2.description,
          availability: schema2.availability,
          groupName: void 0
        }),
        context,
        fileContainingReference,
        namespace,
        declarationDepth: 0
      }),
      allowMultiple: true
    };
  } else {
    return {
      value: buildTypeReference({
        schema: schema2,
        context,
        fileContainingReference,
        namespace,
        declarationDepth: 0
      }),
      allowMultiple: false
    };
  }
}
function hasSamePrimitiveValueType({ array, primitive }) {
  return array?.type === "array" && array.value.type === "primitive" && primitive?.type === "primitive" && array.value.schema.type === primitive.schema.type;
}
function isRawTypeReferenceDetailedSchema(rawTypeReference) {
  return rawTypeReference.type != null;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildWebsocketSessionExample.js
function buildWebsocketSessionExample({ websocketExample, context }) {
  const example = {
    messages: []
  };
  if (websocketExample.name != null) {
    example.name = websocketExample.name;
  }
  if (websocketExample.description != null) {
    example.docs = websocketExample.description;
  }
  if (websocketExample.queryParameters != null && websocketExample.queryParameters.length > 0) {
    example["query-parameters"] = convertQueryParameterExample(websocketExample.queryParameters);
  }
  if (websocketExample.headers != null && websocketExample.headers.length > 0) {
    example.headers = convertHeaderExamples({ context, namedFullExamples: websocketExample.headers });
  }
  for (const message of websocketExample.messages) {
    const convertedMessage = convertFullExample(message.payload);
    if (convertedMessage != null) {
      example.messages.push({
        type: message.messageType,
        body: convertedMessage
      });
    }
  }
  return example;
}
function convertQueryParameterExample(namedFullExamples) {
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample(namedFullExample.value);
    if (Array.isArray(convertedExample)) {
      result[namedFullExample.name] = convertedExample[0];
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}
function convertHeaderExamples({ context, namedFullExamples }) {
  const globalHeaderNames = context.builder.getGlobalHeaderNames();
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample(namedFullExample.value);
    if (globalHeaderNames.has(namedFullExample.name)) {
      return;
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}
function convertFullExample(fullExample) {
  switch (fullExample.type) {
    case "primitive":
      return convertPrimitive(fullExample.value);
    case "object":
      return convertObject(fullExample.properties);
    case "array":
      return convertArrayExample(fullExample.value);
    case "map":
      return convertMapExample(fullExample.value);
    case "oneOf":
      return convertOneOfExample(fullExample.value);
    case "enum":
      return fullExample.value;
    case "literal":
      return convertLiteralExample(fullExample.value);
    case "unknown":
      return convertFullExample(fullExample.value);
    default:
      assertNever(fullExample);
  }
}
function convertPrimitive(primitiveExample) {
  switch (primitiveExample.type) {
    case "int":
      return primitiveExample.value;
    case "int64":
      return primitiveExample.value;
    case "uint":
      return primitiveExample.value;
    case "uint64":
      return primitiveExample.value;
    case "float":
      return primitiveExample.value;
    case "double":
      return primitiveExample.value;
    case "string": {
      if (primitiveExample.value.startsWith("$")) {
        return `${primitiveExample.value.slice(1)}`;
      }
      return primitiveExample.value;
    }
    case "datetime":
      try {
        return new Date(primitiveExample.value).toISOString().replace(/\.\d{3}Z$/, "Z");
      } catch (e) {
        return "2024-01-15T09:30:00Z";
      }
    case "date":
      return primitiveExample.value;
    case "base64":
    case "boolean":
      return primitiveExample.value;
    default:
      assertNever(primitiveExample);
  }
}
function convertObject(object3) {
  return Object.fromEntries(Object.entries(object3).map(([propertyKey, fullExample]) => {
    return [propertyKey, convertFullExample(fullExample)];
  }));
}
function convertArrayExample(fullExamples) {
  return fullExamples.map((fullExample) => {
    return convertFullExample(fullExample);
  });
}
function convertMapExample(pairs2) {
  return Object.fromEntries(pairs2.map((pair) => {
    return [convertPrimitive(pair.key), convertFullExample(pair.value)];
  }));
}
function convertOneOfExample(oneOf) {
  if (oneOf.type === "discriminated") {
    return convertObject(oneOf.value);
  }
  return convertFullExample(oneOf.value);
}
function convertLiteralExample(literal) {
  switch (literal.type) {
    case "string":
      return literal.value;
    case "boolean":
      return literal.value;
    default:
      assertNever(literal);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getNamespaceFromGroup.js
function getNamespaceFromGroup(groupName) {
  return groupName.find((group) => typeof group !== "string" && group.type === "namespace")?.name;
}
function getEndpointNamespace(sdkName, namespaceOverride) {
  return namespaceOverride != null ? namespaceOverride : sdkName?.groupName != null ? getNamespaceFromGroup(sdkName.groupName) : void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildChannel.js
function buildChannel({ channel, context, declarationFile }) {
  const convertedChannel = {
    path: channel.path,
    auth: false
  };
  if (channel.summary != null) {
    convertedChannel["display-name"] = channel.summary;
  }
  const maybeChannelNamespace = getNamespaceFromGroup(channel.groupName);
  const pathParameters = {};
  if (channel.handshake.pathParameters.length > 0) {
    for (const pathParameter of channel.handshake.pathParameters) {
      pathParameters[pathParameter.name] = buildPathParameter({
        pathParameter,
        context,
        fileContainingReference: declarationFile,
        namespace: maybeChannelNamespace
      });
    }
  }
  if (Object.keys(pathParameters).length > 0) {
    convertedChannel["path-parameters"] = pathParameters;
  }
  const queryParameters = {};
  if (channel.handshake.queryParameters.length > 0) {
    for (const queryParameter of channel.handshake.queryParameters) {
      const convertedQueryParameter = buildQueryParameter({
        queryParameter,
        context,
        fileContainingReference: declarationFile,
        namespace: maybeChannelNamespace
      });
      if (convertedQueryParameter == null) {
        continue;
      }
      queryParameters[queryParameter.name] = convertedQueryParameter;
    }
  }
  if (Object.keys(queryParameters).length > 0) {
    convertedChannel["query-parameters"] = queryParameters;
  }
  const headers = {};
  if (channel.handshake.headers.length > 0) {
    for (const header of channel.handshake.headers) {
      const headerSchema = buildHeader({
        header,
        context,
        fileContainingReference: declarationFile,
        namespace: maybeChannelNamespace
      });
      headers[header.name] = headerSchema;
    }
  }
  if (Object.keys(headers).length > 0) {
    convertedChannel.headers = headers;
  }
  context.builder.addChannel(declarationFile, {
    channel: convertedChannel
  });
  if (channel.subscribe != null) {
    context.builder.addChannelMessage(declarationFile, {
      messageId: "subscribe",
      message: {
        origin: "server",
        body: buildTypeReference({
          schema: channel.subscribe,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeChannelNamespace,
          declarationDepth: 0
        })
      }
    });
  }
  if (channel.publish != null) {
    context.builder.addChannelMessage(declarationFile, {
      messageId: "publish",
      message: {
        origin: "client",
        body: buildTypeReference({
          schema: channel.publish,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeChannelNamespace,
          declarationDepth: 0
        })
      }
    });
  }
  for (const example of channel.examples) {
    const websocketExample = buildWebsocketSessionExample({ context, websocketExample: example });
    context.builder.addChannelExample(declarationFile, {
      example: websocketExample
    });
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildEnvironments.js
var PRODUCTION_ENVNIRONMENT_NAME = "Production";
var DEFAULT_ENVIRONMENT_NAME = "Default";
function extractUrlsFromEnvironmentSchema(record3) {
  return Object.entries(record3).reduce((acc, [name, schemaOrUrl]) => {
    if (isRawMultipleBaseUrlsEnvironment(schemaOrUrl)) {
      Object.entries(schemaOrUrl.urls).forEach(([urlsName, urlsValue]) => {
        acc[urlsName] = urlsValue;
      });
    } else {
      acc[name] = typeof schemaOrUrl === "string" ? schemaOrUrl : schemaOrUrl.url;
    }
    return acc;
  }, {});
}
function buildEnvironments(context) {
  if (context.environmentOverrides != null) {
    for (const [environment, environmentDeclaration] of Object.entries(context.environmentOverrides.environments ?? {})) {
      context.builder.addEnvironment({
        name: environment,
        schema: environmentDeclaration
      });
    }
    if (context.environmentOverrides["default-environment"] != null) {
      context.builder.setDefaultEnvironment(context.environmentOverrides["default-environment"]);
    }
    if (context.environmentOverrides["default-url"] != null) {
      context.builder.setDefaultUrl(context.environmentOverrides["default-url"]);
    }
    return;
  }
  const topLevelServersWithName = {};
  const topLevelSkippedServers = [];
  for (const server of context.ir.servers) {
    const environmentSchema = server.audiences ? {
      url: server.url,
      audiences: server.audiences
    } : server.url;
    if (server.name == null) {
      topLevelSkippedServers.push(environmentSchema);
      continue;
    }
    topLevelServersWithName[server.name] = environmentSchema;
  }
  const endpointLevelServersWithName = {};
  const endpointLevelSkippedServers = [];
  for (const endpoint of context.ir.endpoints) {
    for (const server of endpoint.server) {
      if (server.url == null) {
        continue;
      }
      const environmentSchema = server.audiences ? {
        url: server.url,
        audiences: server.audiences
      } : server.url;
      if (server.name == null) {
        endpointLevelSkippedServers.push(environmentSchema);
        continue;
      }
      endpointLevelServersWithName[server.name] = environmentSchema;
    }
  }
  const numTopLevelServers = Object.keys(topLevelServersWithName).length;
  const numEndpointLevelServers = Object.keys(endpointLevelServersWithName).length;
  if (numTopLevelServers === 0 && numEndpointLevelServers === 0) {
    const singleURL = context.ir.servers[0]?.url;
    const singleURLAudiences = context.ir.servers[0]?.audiences;
    if (singleURL != null) {
      context.builder.addEnvironment({
        name: DEFAULT_ENVIRONMENT_NAME,
        schema: singleURLAudiences ? {
          url: singleURL,
          audiences: singleURLAudiences
        } : singleURL
      });
      context.builder.setDefaultEnvironment(DEFAULT_ENVIRONMENT_NAME);
    }
  } else if (numTopLevelServers > 0 && numEndpointLevelServers === 0) {
    let count = 0;
    if (topLevelSkippedServers.length > 0) {
      context.logger.error(`Skipping servers ${topLevelSkippedServers.map((server) => typeof server === "string" ? server : server.url).join(", ")} because x-fern-server-name was not provided.`);
    }
    for (const [name, schema2] of Object.entries(topLevelServersWithName)) {
      if (count === 0) {
        context.builder.setDefaultEnvironment(name);
      }
      context.builder.addEnvironment({
        name,
        schema: schema2
      });
      count += 1;
    }
  } else if (numEndpointLevelServers > 0) {
    if (topLevelSkippedServers.length > 0 || endpointLevelSkippedServers.length > 0) {
      context.logger.error(`Skipping servers ${[...topLevelSkippedServers, ...endpointLevelSkippedServers].map((server) => typeof server === "string" ? server : server.url).join(", ")} because x-fern-server-name was not provided.`);
    }
    const toplevelServerEntries = Object.entries(topLevelServersWithName)[0];
    if (toplevelServerEntries != null) {
      const [name, _] = toplevelServerEntries;
      context.setDefaultServerName(name);
    }
    context.builder.addEnvironment({
      name: PRODUCTION_ENVNIRONMENT_NAME,
      schema: {
        urls: {
          ...extractUrlsFromEnvironmentSchema(topLevelServersWithName),
          ...extractUrlsFromEnvironmentSchema(endpointLevelServersWithName)
        }
      }
    });
    context.builder.setDefaultEnvironment(PRODUCTION_ENVNIRONMENT_NAME);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/wrapTypeReferenceAsOptional.js
function wrapTypeReferenceAsOptional(typeReference) {
  const type2 = getTypeFromTypeReference(typeReference);
  if (type2.startsWith("optional")) {
    return typeReference;
  } else if (typeof typeReference === "string") {
    return `optional<${typeReference}>`;
  } else {
    return { ...typeReference, type: `optional<${typeReference.type}>` };
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildGlobalHeaders.js
var HeaderWithCount = class {
  schema;
  count = 0;
  constructor(schema2) {
    this.schema = schema2;
  }
  increment() {
    this.count += 1;
  }
};
var GLOBAL_HEADER_PERCENTAGE_THRESHOLD = 0.75;
var HEADERS_TO_IGNORE = new Set(...["authorization"]);
function buildGlobalHeaders(context) {
  if (context.globalHeaderOverrides != null) {
    for (const [name, declaration] of Object.entries(context.globalHeaderOverrides.headers ?? {})) {
      context.builder.addGlobalHeader({
        name,
        schema: declaration
      });
    }
    return;
  }
  const predefinedGlobalHeaders = Object.fromEntries((context.ir.globalHeaders ?? []).map((header) => [header.header, header]));
  for (const [headerName, header] of Object.entries(predefinedGlobalHeaders)) {
    let schema2 = "optional<string>";
    if (header.name == null && header.env == null && typeof header.schema === "string") {
      schema2 = header.schema;
    } else if (header != null) {
      const groupName = header.schema ? getGroupNameForSchema(header.schema) : void 0;
      const namespace = groupName != null ? getNamespaceFromGroup(groupName) : void 0;
      const defaultFile = RelativeFilePath.of("api.yml");
      schema2 = {
        name: header.name,
        env: header.env,
        type: header.schema != null ? getTypeFromTypeReference(buildTypeReference({
          schema: header.schema,
          context,
          fileContainingReference: namespace ? join(RelativeFilePath.of(camelCase_default(namespace)), defaultFile) : defaultFile,
          namespace,
          declarationDepth: 0
        })) ?? "optional<string>" : "optional<string>"
      };
    }
    context.builder.addGlobalHeader({
      name: headerName,
      schema: schema2
    });
  }
  if (context.detectGlobalHeaders) {
    const globalHeaders = {};
    for (const endpoint of context.ir.endpoints) {
      for (const header of endpoint.headers) {
        if (HEADERS_TO_IGNORE.has(header.name.toLowerCase())) {
          continue;
        }
        let headerWithCount = globalHeaders[header.name];
        if (headerWithCount == null) {
          const predefinedHeader = predefinedGlobalHeaders[header.name];
          const convertedHeader = buildHeader({
            header: {
              ...header,
              schema: predefinedHeader?.schema ?? header.schema,
              name: predefinedHeader?.name ?? header.name
            },
            fileContainingReference: RelativeFilePath.of(ROOT_API_FILENAME),
            context,
            // TODO: how are we namespacing global headers
            namespace: void 0
          });
          headerWithCount = new HeaderWithCount(convertedHeader);
          globalHeaders[header.name] = headerWithCount;
        }
        headerWithCount.increment();
      }
    }
    const globalHeaderThreshold = context.ir.endpoints.length * GLOBAL_HEADER_PERCENTAGE_THRESHOLD;
    for (const [headerName, header] of Object.entries(globalHeaders)) {
      const predefinedHeader = predefinedGlobalHeaders[headerName];
      const isRequired = header.count === context.ir.endpoints.length;
      const isOptional2 = header.count >= globalHeaderThreshold;
      if (predefinedHeader != null) {
        continue;
      } else if (isRequired) {
        context.builder.addGlobalHeader({
          name: headerName,
          schema: header.schema
        });
      } else if (isOptional2) {
        context.builder.addGlobalHeader({
          name: headerName,
          schema: wrapTypeReferenceAsOptional(header.schema)
        });
      }
    }
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildIdempotencyHeaders.js
function buildIdempotencyHeaders(context) {
  for (const header of context.ir.idempotencyHeaders ?? []) {
    const groupName = header.schema ? getGroupNameForSchema(header.schema) : void 0;
    const namespace = groupName != null ? getNamespaceFromGroup(groupName) : void 0;
    const convertedHeader = buildHeader({
      header: {
        ...header,
        schema: header.schema ?? Schema.primitive({
          description: void 0,
          availability: void 0,
          generatedName: "",
          title: void 0,
          groupName: void 0,
          nameOverride: void 0,
          schema: PrimitiveSchemaValue.string({
            default: void 0,
            pattern: void 0,
            format: void 0,
            minLength: void 0,
            maxLength: void 0
          })
        }),
        name: header.name ?? header.header,
        parameterNameOverride: void 0,
        description: void 0,
        availability: void 0,
        source: void 0
      },
      fileContainingReference: RelativeFilePath.of(ROOT_API_FILENAME),
      context,
      namespace
    });
    context.builder.addIdempotencyHeader({
      name: header.header,
      schema: wrapTypeReferenceAsOptional(convertedHeader)
    });
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertFullExample.js
function convertFullExample2(fullExample) {
  switch (fullExample.type) {
    case "primitive":
      return convertPrimitive2(fullExample.value);
    case "object":
      return convertObject2(fullExample.properties);
    case "array":
      return convertArrayExample2(fullExample.value);
    case "map":
      return convertMapExample2(fullExample.value);
    case "oneOf":
      return convertOneOfExample2(fullExample.value);
    case "enum":
      return fullExample.value;
    case "literal":
      return convertLiteralExample2(fullExample.value);
    case "unknown":
      return convertFullExample2(fullExample.value);
    default:
      assertNever(fullExample);
  }
}
function convertEndpointResponseExample(endpointResponseExample) {
  switch (endpointResponseExample.type) {
    case "withStreaming":
      return {
        stream: convertArrayExample2(endpointResponseExample.value)
      };
    case "withoutStreaming":
      return {
        body: convertFullExample2(endpointResponseExample.value)
      };
    default:
      assertNever(endpointResponseExample);
  }
}
function convertPrimitive2(primitiveExample) {
  switch (primitiveExample.type) {
    case "int":
      return primitiveExample.value;
    case "int64":
      return primitiveExample.value;
    case "uint":
      return primitiveExample.value;
    case "uint64":
      return primitiveExample.value;
    case "float":
      return primitiveExample.value;
    case "double":
      return primitiveExample.value;
    case "string": {
      if (primitiveExample.value.startsWith("$")) {
        return `${primitiveExample.value.slice(1)}`;
      }
      return primitiveExample.value;
    }
    case "datetime":
      try {
        if (!primitiveExample.value.endsWith("Z") && !primitiveExample.value.includes("+")) {
          primitiveExample.value += "Z";
        }
        return new Date(primitiveExample.value).toISOString().replace(/\.\d{3}Z$/, "Z");
      } catch (e) {
        return "2024-01-15T09:30:00Z";
      }
    case "date":
      return primitiveExample.value;
    case "base64":
    case "boolean":
      return primitiveExample.value;
    default:
      assertNever(primitiveExample);
  }
}
function convertObject2(object3) {
  return Object.fromEntries(Object.entries(object3).map(([propertyKey, fullExample]) => {
    return [propertyKey, convertFullExample2(fullExample)];
  }));
}
function convertArrayExample2(fullExamples) {
  return fullExamples.map((fullExample) => {
    return convertFullExample2(fullExample);
  });
}
function convertMapExample2(pairs2) {
  return Object.fromEntries(pairs2.map((pair) => {
    return [convertPrimitive2(pair.key), convertFullExample2(pair.value)];
  }));
}
function convertOneOfExample2(oneOf) {
  if (oneOf.type === "discriminated") {
    return convertObject2(oneOf.value);
  }
  return convertFullExample2(oneOf.value);
}
function convertLiteralExample2(literal) {
  switch (literal.type) {
    case "string":
      return literal.value;
    case "boolean":
      return literal.value;
    default:
      assertNever(literal);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildEndpointExample.js
function buildEndpointExample({ endpointExample, context }) {
  const example = {};
  if (endpointExample.type !== "full") {
    return endpointExample.value;
  }
  if (endpointExample.name != null) {
    example.name = endpointExample.name;
  }
  if (endpointExample.description != null) {
    example.docs = endpointExample.description;
  }
  if (endpointExample.pathParameters != null && endpointExample.pathParameters.length > 0) {
    example["path-parameters"] = convertPathParameterExample(endpointExample.pathParameters);
  }
  if (endpointExample.queryParameters != null && endpointExample.queryParameters.length > 0) {
    example["query-parameters"] = convertQueryParameterExample2(endpointExample.queryParameters);
  }
  if (endpointExample.headers != null && endpointExample.headers.length > 0) {
    example.headers = convertHeaderExamples2({ context, namedFullExamples: endpointExample.headers });
  }
  if (endpointExample.request != null) {
    example.request = convertFullExample2(endpointExample.request);
  }
  if (endpointExample.response != null) {
    example.response = convertEndpointResponseExample(endpointExample.response);
  }
  if (endpointExample.codeSamples != null && endpointExample.codeSamples.length > 0) {
    example["code-samples"] = endpointExample.codeSamples.map((codeSample) => {
      if (codeSample.type === "language") {
        return {
          name: codeSample.name ?? void 0,
          docs: codeSample.description ?? void 0,
          language: codeSample.language,
          code: codeSample.code,
          install: codeSample.install ?? void 0
        };
      } else {
        return {
          name: codeSample.name ?? void 0,
          docs: codeSample.description ?? void 0,
          sdk: codeSample.sdk,
          code: codeSample.code
        };
      }
    }).filter(isNonNullish);
  }
  return example;
}
function convertPathParameterExample(pathParameterExamples) {
  const result = {};
  pathParameterExamples.forEach((pathParameterExample) => {
    const convertedExample = convertFullExample2(pathParameterExample.value);
    if (convertedExample != null) {
      result[pathParameterExample.parameterNameOverride ?? pathParameterExample.name] = convertedExample;
    }
  });
  return result;
}
function convertQueryParameterExample2(namedFullExamples) {
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample2(namedFullExample.value);
    if (Array.isArray(convertedExample)) {
      result[namedFullExample.name] = convertedExample[0];
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}
function convertHeaderExamples2({ context, namedFullExamples }) {
  const globalHeaderNames = context.builder.getGlobalHeaderNames();
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample2(namedFullExample.value);
    if (globalHeaderNames.has(namedFullExample.name)) {
      return;
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertToHttpMethod.js
function convertToHttpMethod(httpMethod) {
  return HttpMethod2._visit(httpMethod, {
    get: () => schemas_exports3.HttpMethodSchema.Get,
    post: () => schemas_exports3.HttpMethodSchema.Post,
    put: () => schemas_exports3.HttpMethodSchema.Put,
    patch: () => schemas_exports3.HttpMethodSchema.Patch,
    delete: () => schemas_exports3.HttpMethodSchema.Delete,
    head: () => {
      throw new Error("HEAD is unsupported");
    },
    options: () => {
      throw new Error("HEAD is unsupported");
    },
    trace: () => {
      throw new Error("HEAD is unsupported");
    },
    _other: () => {
      throw new Error("Unkown http method is unsupported");
    }
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildEndpoint.js
function buildEndpoint({ endpoint, declarationFile, context }) {
  const { nonRequestReferencedSchemas } = context.ir;
  let schemaIdsToExclude = [];
  const names = /* @__PURE__ */ new Set();
  let path5 = endpoint.path;
  const maybeEndpointNamespace = getEndpointNamespace(endpoint.sdkName, endpoint.namespace);
  const pathParameters = {};
  for (const pathParameter of endpoint.pathParameters) {
    if (pathParameter.parameterNameOverride) {
      path5 = path5.replace(pathParameter.name, pathParameter.parameterNameOverride);
    }
    pathParameters[pathParameter.parameterNameOverride ?? pathParameter.name] = buildPathParameter({
      pathParameter,
      context,
      fileContainingReference: declarationFile,
      namespace: maybeEndpointNamespace
    });
    names.add(pathParameter.name);
  }
  const queryParameters = {};
  for (const queryParameter of endpoint.queryParameters) {
    const convertedQueryParameter = buildQueryParameter({
      queryParameter,
      context,
      fileContainingReference: declarationFile,
      namespace: maybeEndpointNamespace
    });
    if (convertedQueryParameter == null) {
      continue;
    }
    queryParameters[queryParameter.name] = convertedQueryParameter;
    names.add(queryParameter.name);
  }
  let pagination = void 0;
  if (endpoint.pagination != null) {
    if (endpoint.pagination.type === "cursor") {
      pagination = {
        cursor: endpoint.pagination.cursor,
        next_cursor: endpoint.pagination.nextCursor,
        results: endpoint.pagination.results
      };
    } else {
      pagination = {
        offset: endpoint.pagination.offset,
        step: endpoint.pagination.step,
        results: endpoint.pagination.results,
        "has-next-page": endpoint.pagination.hasNextPage
      };
    }
  }
  const convertedEndpoint = {
    path: path5,
    method: convertToHttpMethod(endpoint.method),
    auth: endpoint.authed,
    docs: endpoint.description ?? void 0,
    pagination,
    source: endpoint.source != null ? convertToSourceSchema(endpoint.source) : void 0
  };
  if (!endpointRequestSupportsInlinedPathParameters({ context, request: endpoint.request }) && Object.keys(pathParameters).length > 0) {
    convertedEndpoint["path-parameters"] = pathParameters;
  }
  if (endpoint.summary != null) {
    convertedEndpoint["display-name"] = endpoint.summary;
  }
  const headers = {};
  const globalHeaderNames = context.builder.getGlobalHeaderNames();
  const endpointSpecificHeaders = endpoint.headers.filter((header) => {
    return !globalHeaderNames.has(header.name);
  });
  for (const header of endpointSpecificHeaders) {
    const headerSchema = buildHeader({
      header,
      context,
      fileContainingReference: declarationFile,
      namespace: maybeEndpointNamespace
    });
    headers[header.name] = headerSchema;
    names.add(typeof headerSchema === "string" ? header.name : headerSchema.name ?? header.name);
  }
  if (endpoint.request != null) {
    context.setInState(State.Request);
    const convertedRequest = getRequest({
      endpoint,
      context,
      declarationFile,
      request: endpoint.request,
      generatedRequestName: endpoint.generatedRequestName,
      requestNameOverride: endpoint.requestNameOverride ?? void 0,
      pathParameters: context.inlinePathParameters && Object.keys(pathParameters).length > 0 ? pathParameters : void 0,
      queryParameters: Object.keys(queryParameters).length > 0 ? queryParameters : void 0,
      nonRequestReferencedSchemas: Array.from(nonRequestReferencedSchemas),
      headers: Object.keys(headers).length > 0 ? headers : void 0,
      usedNames: names,
      namespace: maybeEndpointNamespace
    });
    convertedEndpoint.request = convertedRequest.value;
    schemaIdsToExclude = [...schemaIdsToExclude, ...convertedRequest.schemaIdsToExclude ?? []];
    context.unsetInState(State.Request);
  } else {
    const hasPathParams = context.inlinePathParameters && Object.keys(pathParameters).length > 0;
    const hasQueryParams = Object.keys(queryParameters).length > 0;
    const hasHeaders = Object.keys(headers).length > 0;
    const convertedRequest = {};
    if (hasPathParams || hasQueryParams || hasHeaders) {
      convertedRequest.name = endpoint.requestNameOverride ?? endpoint.generatedRequestName;
    }
    if (hasPathParams) {
      convertedRequest["path-parameters"] = pathParameters;
    }
    if (hasQueryParams) {
      convertedRequest["query-parameters"] = queryParameters;
    }
    if (hasHeaders) {
      convertedRequest.headers = headers;
    }
    if (Object.keys(convertedRequest).length > 0) {
      convertedEndpoint.request = convertedRequest;
    }
  }
  if (endpoint.response != null) {
    endpoint.response._visit({
      json: (jsonResponse) => {
        const responseTypeReference = buildTypeReference({
          schema: jsonResponse.schema,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeEndpointNamespace,
          declarationDepth: 0
        });
        convertedEndpoint.response = {
          docs: jsonResponse.description ?? void 0,
          type: getTypeFromTypeReference(responseTypeReference)
        };
        if (jsonResponse.responseProperty != null) {
          convertedEndpoint.response.property = jsonResponse.responseProperty;
        }
      },
      streamingJson: (jsonResponse) => {
        const responseTypeReference = buildTypeReference({
          schema: jsonResponse.schema,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeEndpointNamespace,
          declarationDepth: 0
        });
        convertedEndpoint["response-stream"] = {
          docs: jsonResponse.description ?? void 0,
          type: getTypeFromTypeReference(responseTypeReference),
          format: "json"
        };
      },
      streamingSse: (jsonResponse) => {
        const responseTypeReference = buildTypeReference({
          schema: jsonResponse.schema,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeEndpointNamespace,
          declarationDepth: 0
        });
        convertedEndpoint["response-stream"] = {
          docs: jsonResponse.description ?? void 0,
          type: getTypeFromTypeReference(responseTypeReference),
          format: "sse"
        };
      },
      file: (fileResponse) => {
        convertedEndpoint.response = {
          docs: fileResponse.description ?? void 0,
          type: "file"
        };
      },
      streamingText: (textResponse) => {
        convertedEndpoint["response-stream"] = {
          docs: textResponse.description ?? void 0,
          type: "text"
        };
      },
      text: (textResponse) => {
        convertedEndpoint.response = {
          docs: textResponse.description ?? void 0,
          type: "text"
        };
      },
      _other: () => {
        throw new Error("Unrecognized Response type: " + endpoint.response?.type);
      }
    });
  }
  if (context.builder.getEnvironmentType() === "multi") {
    const defaultServer = context.getDefaultServerName();
    const serverOverride = endpoint.server[0];
    if (serverOverride == null) {
      if (defaultServer != null) {
        convertedEndpoint.url = defaultServer;
      }
    } else {
      convertedEndpoint.url = serverOverride.name ?? void 0;
    }
  }
  if (endpoint.idempotent) {
    convertedEndpoint.idempotent = true;
  }
  if (endpoint.availability != null) {
    convertedEndpoint.availability = convertAvailability2(endpoint.availability);
  }
  Object.entries(endpoint.errors).forEach(([statusCode, httpError]) => {
    let errorName = httpError.generatedName;
    const fileContainingReference = RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME);
    if (context.builder.enableUniqueErrorsPerEndpoint) {
      errorName = `${endpoint.generatedRequestName}${httpError.generatedName}`;
      if (httpError.schema != null) {
        if (httpError.schema.type !== "reference" && httpError.schema.type !== "oneOf") {
          httpError.schema.generatedName = `${endpoint.generatedRequestName}${httpError.schema.generatedName}`;
        } else if (httpError.schema.type === "oneOf") {
          httpError.schema.value.generatedName = `${endpoint.generatedRequestName}${httpError.schema.value.generatedName}`;
        }
      }
    }
    const errorDeclaration = {
      "status-code": parseInt(statusCode)
    };
    const errorDeclarationFile = resolveLocationWithNamespace({
      location: ERROR_DECLARATIONS_FILENAME,
      namespaceOverride: maybeEndpointNamespace
    });
    if (httpError.schema != null) {
      const typeReference = buildTypeReference({
        schema: httpError.schema,
        context,
        fileContainingReference: errorDeclarationFile,
        declarationFile: errorDeclarationFile,
        namespace: maybeEndpointNamespace,
        declarationDepth: 0
      });
      errorDeclaration.type = getTypeFromTypeReference(typeReference);
      errorDeclaration.docs = httpError.description;
    }
    context.builder.addError(errorDeclarationFile, {
      name: errorName,
      schema: context.isErrorUnknownSchema(parseInt(statusCode)) ? { ...errorDeclaration, type: "unknown" } : errorDeclaration
    });
    if (convertedEndpoint.errors == null) {
      convertedEndpoint.errors = [];
    }
    const prefix = context.builder.addImport({
      file: declarationFile,
      fileToImport: errorDeclarationFile
    });
    convertedEndpoint.errors.push(prefix != null ? `${prefix}.${errorName}` : errorName);
    const errorTypeReference = errorDeclaration.type;
    if (errorTypeReference != null) {
      httpError.examples?.forEach((example) => {
        const convertedExample = {
          value: convertFullExample2(example.example),
          name: example.name,
          docs: example.description
        };
        context.builder.addErrorExample(errorDeclarationFile, {
          name: errorName,
          example: convertedExample
        });
      });
    }
  });
  if (endpoint.examples.length > 0) {
    convertedEndpoint.examples = convertEndpointExamples({
      endpointExamples: endpoint.examples,
      context
    });
  }
  if (context.ir.hasEndpointsMarkedInternal && (endpoint.internal == null || !endpoint.internal)) {
    convertedEndpoint.audiences = [EXTERNAL_AUDIENCE, ...endpoint.audiences];
  } else if (endpoint.audiences.length > 0) {
    convertedEndpoint.audiences = endpoint.audiences;
  }
  return {
    value: convertedEndpoint,
    schemaIdsToExclude
  };
}
function convertEndpointExamples({ endpointExamples, context }) {
  return endpointExamples.map((endpointExample) => {
    try {
      return buildEndpointExample({ endpointExample, context });
    } catch (e) {
      console.error(`Error building endpoint example: ${e}`);
      throw e;
    }
  });
}
function getRequest({ endpoint, declarationFile, context, request, requestNameOverride, generatedRequestName, pathParameters, queryParameters, nonRequestReferencedSchemas, headers, usedNames, namespace }) {
  if (request.type === "json") {
    const maybeSchemaId = request.schema.type === "reference" ? request.schema.schema : void 0;
    const resolvedSchema = request.schema.type === "reference" ? context.getSchema(request.schema.schema, namespace) : request.schema;
    if (resolvedSchema?.type !== "object" || maybeSchemaId != null && nonRequestReferencedSchemas.includes(maybeSchemaId)) {
      const requestTypeReference = buildTypeReference({
        schema: request.schema,
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: 0
      });
      const convertedRequest = {
        schemaIdsToExclude: [],
        value: {
          body: requestTypeReference
        }
      };
      const hasPathParams = Object.keys(pathParameters ?? {}).length > 0;
      const hasQueryParams = Object.keys(queryParameters ?? {}).length > 0;
      const hasHeaders = Object.keys(headers ?? {}).length > 0;
      if (hasPathParams) {
        convertedRequest.value["path-parameters"] = pathParameters;
      }
      if (hasQueryParams) {
        convertedRequest.value["query-parameters"] = queryParameters;
      }
      if (hasHeaders) {
        convertedRequest.value.headers = headers;
      }
      if (hasPathParams || hasQueryParams || hasHeaders) {
        convertedRequest.value.name = requestNameOverride ?? generatedRequestName;
      }
      if (request.contentType != null) {
        convertedRequest.value["content-type"] = request.contentType;
      }
      if (request.description != null) {
        convertedRequest.value.docs = request.description;
      }
      return convertedRequest;
    }
    const properties = Object.fromEntries(resolvedSchema.properties.filter((property4) => {
      if (property4.readonly == null) {
        return true;
      }
      const writeEndpoint = endpoint.method === "POST" || endpoint.method === "PUT";
      if (writeEndpoint && property4.readonly) {
        return false;
      }
      return true;
    }).map((property4) => {
      const propertyTypeReference = buildTypeReference({
        schema: property4.schema,
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: 1
        // 1 level deep for request body properties
      });
      const name = property4.nameOverride ?? property4.key;
      const availability = convertAvailability2(property4.availability);
      if (!usedNames.has(name) && property4.audiences.length <= 0) {
        usedNames.add(name);
        if (property4.nameOverride != null) {
          return [
            property4.key,
            {
              type: getTypeFromTypeReference(propertyTypeReference),
              docs: getDocsFromTypeReference(propertyTypeReference),
              name: property4.nameOverride,
              availability
            }
          ];
        }
        return [
          property4.key,
          availability ? {
            ...typeof propertyTypeReference === "string" ? { type: propertyTypeReference } : propertyTypeReference,
            availability
          } : propertyTypeReference
        ];
      }
      const typeReference = {
        type: getTypeFromTypeReference(propertyTypeReference),
        docs: getDocsFromTypeReference(propertyTypeReference)
      };
      if (usedNames.has(name)) {
        typeReference.name = property4.generatedName;
      }
      if (property4.audiences.length > 0) {
        typeReference.audiences = property4.audiences;
      }
      if (availability != null) {
        typeReference.availability = availability;
      }
      usedNames.add(name);
      return [property4.key, typeReference];
    }));
    const extendedSchemas = resolvedSchema.allOf.map((referencedSchema) => {
      const allOfTypeReference = buildTypeReference({
        schema: Schema.reference(referencedSchema),
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: 0
      });
      return getTypeFromTypeReference(allOfTypeReference);
    });
    const requestBodySchema = {
      properties
    };
    if (extendedSchemas.length > 0) {
      requestBodySchema.extends = extendedSchemas;
    }
    if (request.additionalProperties) {
      requestBodySchema["extra-properties"] = true;
    }
    const convertedRequestValue = {
      name: requestNameOverride ?? resolvedSchema.nameOverride ?? resolvedSchema.generatedName,
      "path-parameters": pathParameters,
      "query-parameters": queryParameters,
      headers,
      body: requestBodySchema
    };
    if (request.contentType != null) {
      convertedRequestValue["content-type"] = request.contentType;
    }
    if (request.description != null) {
      convertedRequestValue.docs = request.description;
    }
    return {
      schemaIdsToExclude: maybeSchemaId != null ? [maybeSchemaId] : [],
      value: convertedRequestValue
    };
  } else if (request.type === "octetStream") {
    return {
      schemaIdsToExclude: [],
      value: {
        body: "bytes",
        "content-type": MediaType.APPLICATION_OCTET_STREAM,
        ...request.description ? { docs: request.description } : {}
      }
    };
  } else if (request.type === "multipart") {
    const properties = Object.fromEntries(request.properties.map((property4) => {
      if (property4.schema.type === "file") {
        let fileType = property4.schema.isArray ? "list<file>" : "file";
        fileType = property4.schema.isOptional ? `optional<${fileType}>` : fileType;
        if (property4.description != null || property4.contentType != null) {
          const propertyTypeReference = {
            type: fileType
          };
          if (property4.description != null) {
            propertyTypeReference.docs = property4.description;
          }
          if (property4.contentType != null) {
            const contentType = property4.contentType.split(",")[0];
            propertyTypeReference["content-type"] = contentType;
          }
          return [property4.key, propertyTypeReference];
        }
        return [property4.key, fileType];
      } else {
        let propertyTypeReference = buildTypeReference({
          schema: property4.schema.value,
          fileContainingReference: declarationFile,
          context,
          namespace,
          declarationDepth: 1
          // 1 level deep for request body properties
        });
        if (property4.contentType != null) {
          if (typeof propertyTypeReference === "string") {
            propertyTypeReference = {
              type: propertyTypeReference,
              "content-type": property4.contentType
            };
          } else {
            propertyTypeReference["content-type"] = property4.contentType;
          }
        }
        return [property4.key, propertyTypeReference];
      }
    }));
    return {
      schemaIdsToExclude: request.name == null ? [] : [request.name],
      value: {
        name: requestNameOverride ?? request.name ?? generatedRequestName,
        "path-parameters": pathParameters,
        "query-parameters": queryParameters,
        headers,
        body: {
          properties
        },
        "content-type": MediaType.MULTIPART_FORM_DATA,
        ...request.description ? { docs: request.description } : {}
      }
    };
  } else {
    assertNever(request);
  }
}
function endpointRequestSupportsInlinedPathParameters({ context, request }) {
  if (!context.inlinePathParameters) {
    return false;
  }
  if (request == null) {
    return true;
  }
  switch (request.type) {
    case "octetStream":
      return false;
    case "multipart":
      return true;
    case "json":
      return true;
    default:
      assertNever(request);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getEndpointLocation.js
function resolveEndpointLocationWithNamespaceOverride({ location, namespaceOverride }) {
  if (namespaceOverride != null) {
    return {
      ...location,
      file: join(RelativeFilePath.of(namespaceOverride), location.file)
    };
  }
  return location;
}
function getUnresolvedEndpointLocation(endpoint) {
  const namespace = endpoint.namespace;
  const tag = endpoint.tags.filter((tag2) => tag2 !== namespace)[0];
  const operationId = endpoint.operationId;
  if (operationId == null) {
    if (tag != null) {
      return {
        file: RelativeFilePath.of(`${camelCase_default(tag)}.yml`),
        endpointId: endpoint.summary != null ? camelCase_default(endpoint.summary) : camelCase_default(`${endpoint.method}_${endpoint.path.split("/").join("_")}`)
      };
    }
    if (endpoint.summary != null) {
      return {
        file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
        endpointId: camelCase_default(endpoint.summary)
      };
    }
    return {
      file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      endpointId: camelCase_default(`${endpoint.method}_${endpoint.path.split("/").join("_")}`)
    };
  }
  if (tag == null) {
    return {
      file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      endpointId: operationId
    };
  }
  const tagTokens = tokenizeString(tag);
  const operationIdTokens = tokenizeString(operationId);
  if (isEqual_default(tagTokens, operationIdTokens)) {
    return {
      file: RelativeFilePath.of("__package__.yml"),
      endpointId: tag
    };
  }
  const fastapiEndpointLocation = maybeGetFastApiEndpointLocation({
    operationId,
    tag,
    path: endpoint.path,
    method: endpoint.method
  });
  if (fastapiEndpointLocation != null) {
    return fastapiEndpointLocation;
  }
  const fileParts = [];
  for (let i = 0; i < tagTokens.length; ++i) {
    const tagElement = tagTokens[i];
    if (tagElement != null && tagElement === operationIdTokens[i]) {
      fileParts.push(tagElement);
    } else {
      const camelCasedTag = camelCase_default(tag);
      return {
        file: RelativeFilePath.of(`${camelCasedTag}.yml`),
        endpointId: operationId,
        tag
      };
    }
  }
  if (fileParts.length >= operationIdTokens.length) {
    throw new Error(`Cannot get file for endpoint ${JSON.stringify(endpoint)}`);
  }
  return {
    file: RelativeFilePath.of(camelCase_default(fileParts.join("_")) + ".yml"),
    endpointId: camelCase_default(operationIdTokens.slice(fileParts.length).join("_")),
    tag
  };
}
function getEndpointLocation(endpoint) {
  const tag = endpoint.tags[0];
  if (endpoint.sdkName != null) {
    const filenameWithoutExtension = convertEndpointSdkNameToFileWithoutExtension({
      sdkName: endpoint.sdkName,
      namespaceOverride: endpoint.namespace
    });
    const filename = `${filenameWithoutExtension}.yml`;
    const isTagApplicable = filenameWithoutExtension.toLowerCase() === tag?.toLowerCase().replaceAll(" ", "");
    return {
      file: RelativeFilePath.of(filename),
      endpointId: endpoint.sdkName.methodName,
      // only if the tag lines up with `x-fern-sdk-group-name` do we use it
      tag: isTagApplicable ? tag : void 0
    };
  }
  return resolveEndpointLocationWithNamespaceOverride({
    namespaceOverride: endpoint.namespace,
    location: getUnresolvedEndpointLocation(endpoint)
  });
}
function tokenizeString(input) {
  let tokens;
  if (/^[a-z]+(?:[A-Z][a-z]+)*$/.test(input)) {
    tokens = input.split(/(?=[A-Z])/);
  } else {
    tokens = input.split(/[^a-zA-Z0-9]+/);
  }
  tokens = tokens.map((token) => token.toLowerCase());
  tokens = compact_default(tokens);
  return tokens;
}
var NON_ALPHANUMERIC_EXCEPT_BRACES_REGEX = new RegExp("[^a-zA-Z0-9{}]+");
var BRACE_REGEX = new RegExp("[{}]", "g");
function maybeGetFastApiEndpointLocation({ operationId, tag, path: path5, method }) {
  const pathSegment = path5.split(NON_ALPHANUMERIC_EXCEPT_BRACES_REGEX).join("_").replaceAll(BRACE_REGEX, "_");
  const operationIdSuffix = `${pathSegment}_${method.toLowerCase()}`;
  if (operationId.endsWith(operationIdSuffix)) {
    return {
      file: RelativeFilePath.of(camelCase_default(tag) + ".yml"),
      endpointId: camelCase_default(operationId.slice(0, -1 * operationIdSuffix.length)),
      tag
    };
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildServices.js
function buildServices(context) {
  const sdkGroups = /* @__PURE__ */ new Set();
  const { endpoints, tags } = context.ir;
  let schemaIdsToExclude = [];
  for (const endpoint of endpoints) {
    const { endpointId, file, tag } = getEndpointLocation(endpoint);
    const sdkGroup = file.split(".")[0];
    if (sdkGroup != null) {
      sdkGroups.add(sdkGroup);
    }
    let group = void 0;
    if (endpoint.sdkName != null) {
      const groupInfo = context.ir.groups;
      for (const groupName of endpoint.sdkName.groupName) {
        const trueGroupName = typeof groupName === "string" ? groupName : groupName.name;
        const value = groupInfo[trueGroupName];
        if (value == null) {
          break;
        } else if (value.summary != null || value.description != null) {
          group = groupInfo[trueGroupName];
          break;
        }
      }
    }
    const irTag = tag == null ? void 0 : tags.tagsById[tag];
    context.setInState(State.Endpoint);
    context.setEndpointMethod(endpoint.method);
    const convertedEndpoint = buildEndpoint({
      context,
      endpoint,
      declarationFile: file
    });
    context.unsetEndpointMethod();
    context.unsetInState(State.Endpoint);
    schemaIdsToExclude = [...schemaIdsToExclude, ...convertedEndpoint.schemaIdsToExclude];
    context.builder.addEndpoint(file, {
      name: endpointId,
      schema: convertedEndpoint.value,
      source: endpoint.source != null ? convertToSourceSchema(endpoint.source) : void 0
    });
    if (irTag?.id != null || irTag?.description != null) {
      context.builder.setServiceInfo(file, {
        "display-name": group?.summary ?? irTag?.id,
        docs: group?.description ?? irTag?.description ?? void 0
      });
    }
  }
  return { schemaIdsToExclude, sdkGroups };
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildVariables.js
function buildVariables(context) {
  for (const [variable, variableSchema] of Object.entries(context.ir.variables)) {
    const namespace = variableSchema.groupName != null ? getNamespaceFromGroup(variableSchema.groupName) : void 0;
    const typeReference = buildTypeReference({
      schema: Schema.primitive(variableSchema),
      context,
      fileContainingReference: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      namespace,
      declarationDepth: 0
    });
    context.builder.addVariable({
      name: variable,
      schema: {
        type: getTypeFromTypeReference(typeReference),
        docs: variableSchema.description ?? void 0
      }
    });
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildWebhooks.js
function buildWebhooks(context) {
  for (const webhook of context.ir.webhooks) {
    const webhookLocation = getWebhookLocation({ webhook, context });
    if (webhookLocation == null) {
      continue;
    }
    const maybeWebhookNamespace = getEndpointNamespace(webhook.sdkName, webhook.namespace);
    const headers = {};
    for (const header of webhook.headers) {
      headers[header.name] = buildHeader({
        header,
        context,
        fileContainingReference: webhookLocation.file,
        namespace: maybeWebhookNamespace
      });
    }
    const webhookDefinition = {
      method: webhook.method,
      "display-name": webhook.summary ?? void 0,
      headers,
      payload: buildTypeReference({
        schema: webhook.payload,
        context,
        fileContainingReference: webhookLocation.file,
        namespace: maybeWebhookNamespace,
        declarationDepth: 0
      }),
      examples: webhook.examples != null ? webhook.examples.map((exampleWebhookCall) => {
        return {
          docs: exampleWebhookCall.description,
          name: exampleWebhookCall.name,
          payload: convertFullExample2(exampleWebhookCall.payload)
        };
      }) : void 0
    };
    context.builder.addWebhook(webhookLocation.file, {
      name: webhookLocation.endpointId,
      schema: webhookDefinition
    });
    if (webhook.description != null) {
      webhookDefinition.docs = webhook.description;
    }
  }
}
function resolveWebhookLocationWithNamespaceOverride({ location, namespaceOverride }) {
  if (location == null) {
    return void 0;
  }
  if (namespaceOverride != null) {
    return {
      ...location,
      file: join(RelativeFilePath.of(namespaceOverride), location.file)
    };
  }
  return location;
}
function getUnresolvedWebhookLocation({ webhook, context }) {
  const tag = webhook.tags[0];
  const operationId = webhook.operationId;
  if (tag == null) {
    return {
      file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      endpointId: operationId
    };
  }
  const tagTokens = tokenizeString(tag);
  const operationIdTokens = tokenizeString(operationId);
  if (isEqual_default(tagTokens, operationIdTokens)) {
    return {
      file: RelativeFilePath.of("__package__.yml"),
      endpointId: tag
    };
  }
  const fileParts = [];
  for (let i = 0; i < tagTokens.length; ++i) {
    const tagElement = tagTokens[i];
    if (tagElement != null && tagElement === operationIdTokens[i]) {
      fileParts.push(tagElement);
    } else {
      const camelCasedTag = camelCase_default(tag);
      return {
        file: RelativeFilePath.of(`${camelCasedTag}.yml`),
        endpointId: operationId,
        tag
      };
    }
  }
  if (fileParts.length >= operationIdTokens.length) {
    context.logger.warn(`Skipping webhook ${webhook.operationId} because couldn't compute file location`);
    return void 0;
  }
  return {
    file: RelativeFilePath.of(camelCase_default(fileParts.join("_")) + ".yml"),
    endpointId: camelCase_default(operationIdTokens.slice(fileParts.length).join("_")),
    tag
  };
}
function getWebhookLocation({ webhook, context }) {
  if (webhook.sdkName != null) {
    return {
      file: convertEndpointSdkNameToFile({ sdkName: webhook.sdkName, namespaceOverride: webhook.namespace }),
      endpointId: webhook.sdkName.methodName
    };
  }
  return resolveWebhookLocationWithNamespaceOverride({
    namespaceOverride: webhook.namespace,
    location: getUnresolvedWebhookLocation({ webhook, context })
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getDeclarationFileForSchema.js
var PACKAGE_MARKER_RELATIVE_FILEPATH = RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME);
function getDeclarationFileForSchema(schema2) {
  switch (schema2.type) {
    case "object":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "enum":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "oneOf":
      return getDeclarationFileFromGroupName(schema2.value.groupName);
    case "array":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "map":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "reference":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "literal":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "optional":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "nullable":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "primitive":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "unknown":
      return PACKAGE_MARKER_RELATIVE_FILEPATH;
    default:
      assertNever(schema2);
  }
}
function getDeclarationFileFromGroupName(groupName) {
  return convertSdkGroupNameToFile(groupName);
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildFernDefinition.js
var EXTERNAL_AUDIENCE = "external";
var ERROR_DECLARATIONS_FILENAME = RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME);
function addSchemas({ schemas, schemaIdsToExclude, namespace, context }) {
  for (const [id, schema2] of Object.entries(schemas)) {
    if (schemaIdsToExclude.includes(id)) {
      continue;
    }
    const declarationFile = getDeclarationFileForSchema(schema2);
    const typeDeclaration = buildTypeDeclaration({
      schema: schema2,
      context,
      declarationFile,
      namespace,
      declarationDepth: 0
    });
    if (isRawAliasDefinition(typeDeclaration.schema)) {
      const aliasType = getTypeFromTypeReference(typeDeclaration.schema);
      if (aliasType === (typeDeclaration.name ?? id) || aliasType === `optional<${typeDeclaration.name ?? id}>`) {
        continue;
      }
    }
    context.builder.addType(declarationFile, {
      name: typeDeclaration.name ?? id,
      schema: typeDeclaration.schema
    });
  }
}
function buildFernDefinition(context) {
  if (context.ir.apiVersion != null) {
    context.builder.setApiVersion(context.ir.apiVersion);
  }
  buildEnvironments(context);
  buildGlobalHeaders(context);
  buildIdempotencyHeaders(context);
  buildAuthSchemes(context);
  buildVariables(context);
  if (context.ir.basePath != null) {
    context.builder.setBasePath(context.ir.basePath);
  }
  if (context.ir.hasEndpointsMarkedInternal) {
    context.builder.addAudience(EXTERNAL_AUDIENCE);
  }
  const convertedServices = buildServices(context);
  const sdkGroups = convertedServices.sdkGroups;
  context.setInState(State.Webhook);
  buildWebhooks(context);
  context.unsetInState(State.Webhook);
  context.setInState(State.Channel);
  for (const channel of context.ir.channel) {
    const declarationFile = convertSdkGroupNameToFile(channel.groupName);
    buildChannel({ channel, context, declarationFile });
  }
  context.unsetInState(State.Channel);
  const schemaIdsToExclude = getSchemaIdsToExclude({
    context,
    schemaIdsToExcludeFromServices: convertedServices.schemaIdsToExclude
  });
  addSchemas({ schemas: context.ir.groupedSchemas.rootSchemas, schemaIdsToExclude, namespace: void 0, context });
  for (const [namespace, schemas] of Object.entries(context.ir.groupedSchemas.namespacedSchemas)) {
    addSchemas({ schemas, schemaIdsToExclude, namespace, context });
  }
  if (context.ir.tags.orderedTagIds != null && context.ir.tags.orderedTagIds.length > 0) {
    const containsValidTagIds = context.ir.tags.orderedTagIds.every((tagId) => {
      return sdkGroups.has(tagId);
    });
    if (containsValidTagIds) {
      context.builder.addNavigation({
        navigation: context.ir.tags.orderedTagIds
      });
    }
  }
  return context.builder.build();
}
function getSchemaIdsToExclude({ context, schemaIdsToExcludeFromServices }) {
  const referencedSchemaIds = context.getReferencedSchemaIds();
  if (referencedSchemaIds == null) {
    return schemaIdsToExcludeFromServices;
  }
  const allSchemaIds = /* @__PURE__ */ new Set([
    ...Object.keys(context.ir.groupedSchemas.rootSchemas),
    ...Object.values(context.ir.groupedSchemas.namespacedSchemas).flatMap((schemas) => Object.keys(schemas))
  ]);
  const schemaIdsToExcludeSet = new Set(schemaIdsToExcludeFromServices);
  for (const schemaId of allSchemaIds) {
    if (!referencedSchemaIds.includes(schemaId)) {
      schemaIdsToExcludeSet.add(schemaId);
    }
  }
  return Array.from(schemaIdsToExcludeSet);
}

// ../../cli/api-importers/commons/lib/FernDefinitionBuilder.js
var import_path = __toESM(require("path"), 1);

// ../../cli/api-importers/commons/lib/utils/FernDefinitionDirectory.js
var FernDefinitionDirectory = class _FernDefinitionDirectory {
  files = {};
  directories = {};
  getAllFiles() {
    const files = {};
    const walk = (root2, currentPath) => {
      for (const [relativeFilePath, definition] of Object.entries(root2.files)) {
        const fullRelativeFilePath = currentPath != null ? RelativeFilePath.of(`${currentPath}${sep}${relativeFilePath}`) : RelativeFilePath.of(relativeFilePath);
        files[fullRelativeFilePath] = definition;
      }
      const sortedDirectories = Object.keys(root2.directories).sort();
      for (const directory of sortedDirectories) {
        const nextPath = currentPath != null ? `${currentPath}${sep}${directory}` : directory;
        const nextDirectory = root2.directories[directory];
        walk(nextDirectory, nextPath);
      }
    };
    walk(this);
    return files;
  }
  getOrCreateFile(relativeFilePath) {
    return this.getOrCreateFileRecursive(relativeFilePath.split(sep));
  }
  getOrCreateFileRecursive(pathParts) {
    if (pathParts.length === 1) {
      return this.files[RelativeFilePath.of(pathParts[0])] ??= {};
    }
    const [directory, ...remainingPath] = pathParts;
    if (directory == null) {
      throw new Error(`Internal error; cannot add file with path: ${pathParts}`);
    }
    if (!this.directories[directory]) {
      this.directories[directory] = new _FernDefinitionDirectory();
    }
    return this.directories[directory].getOrCreateFileRecursive(remainingPath);
  }
};

// ../../cli/api-importers/commons/lib/FernDefinitionBuilder.js
var FernDefinitionBuilderImpl = class {
  enableUniqueErrorsPerEndpoint;
  root;
  rootApiFile;
  packageMarkerFile = {};
  basePath = void 0;
  constructor(enableUniqueErrorsPerEndpoint) {
    this.enableUniqueErrorsPerEndpoint = enableUniqueErrorsPerEndpoint;
    this.root = new FernDefinitionDirectory();
    this.rootApiFile = {
      name: "api",
      "error-discrimination": {
        strategy: "status-code"
      }
    };
  }
  setDisplayName({ displayName }) {
    this.rootApiFile["display-name"] = displayName;
  }
  addNavigation({ navigation }) {
    this.packageMarkerFile.navigation = navigation;
  }
  setServiceInfo(file, { auth, "base-path": basePath, "display-name": displayName, docs }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.service == null) {
      fernFile.service = {
        auth: false,
        "base-path": "",
        endpoints: {}
      };
    }
    if (auth != null) {
      fernFile.service.auth = auth;
    }
    if (basePath != null) {
      fernFile.service["base-path"] = basePath;
    }
    if (displayName != null) {
      fernFile.service["display-name"] = displayName;
    }
    if (docs != null) {
      fernFile.docs = docs;
    }
  }
  addAudience(name) {
    if (this.rootApiFile.audiences == null) {
      this.rootApiFile.audiences = [];
    }
    this.rootApiFile.audiences.push(name);
  }
  setAuth(auth) {
    this.rootApiFile.auth = auth;
  }
  addAuthScheme({ name, schema: schema2 }) {
    if (this.rootApiFile["auth-schemes"] == null) {
      this.rootApiFile["auth-schemes"] = {};
    }
    if (this.rootApiFile["auth-schemes"][name] == null) {
      this.rootApiFile["auth-schemes"][name] = schema2;
    }
  }
  setDefaultEnvironment(name) {
    this.rootApiFile["default-environment"] = name;
  }
  setDefaultUrl(name) {
    this.rootApiFile["default-url"] = name;
  }
  setBasePath(basePath) {
    this.basePath = basePath;
  }
  setApiVersion(apiVersionScheme) {
    this.rootApiFile.version = apiVersionScheme;
  }
  getEnvironmentType() {
    const environmentEntry = Object.entries(this.rootApiFile.environments ?? {})[0];
    if (environmentEntry == null) {
      return void 0;
    }
    return visitRawEnvironmentDeclaration(environmentEntry[1], {
      singleBaseUrl: () => "single",
      multipleBaseUrls: () => "multi"
    });
  }
  addEnvironment({ name, schema: schema2 }) {
    if (this.rootApiFile.environments == null) {
      this.rootApiFile.environments = {};
    }
    this.rootApiFile.environments[name] = schema2;
  }
  getGlobalHeaderNames() {
    const headerNames = Object.keys(this.rootApiFile.headers ?? {});
    const maybeVersionHeader = this.getVersionHeader();
    if (maybeVersionHeader != null) {
      headerNames.push(maybeVersionHeader);
    }
    return new Set(headerNames);
  }
  addGlobalHeader({ name, schema: schema2 }) {
    const maybeVersionHeader = this.getVersionHeader();
    if (maybeVersionHeader != null && maybeVersionHeader === name) {
      return;
    }
    if (this.rootApiFile.headers == null) {
      this.rootApiFile.headers = {};
    }
    this.rootApiFile.headers[name] = schema2;
  }
  addIdempotencyHeader({ name, schema: schema2 }) {
    if (this.rootApiFile["idempotency-headers"] == null) {
      this.rootApiFile["idempotency-headers"] = {};
    }
    this.rootApiFile["idempotency-headers"][name] = schema2;
  }
  addVariable({ name, schema: schema2 }) {
    if (this.rootApiFile.variables == null) {
      this.rootApiFile.variables = {};
    }
    this.rootApiFile.variables[name] = schema2;
  }
  addImport({ file, fileToImport, alias }) {
    if (file === fileToImport) {
      return void 0;
    }
    const importPrefix = alias ?? camelCase_default((dirname(fileToImport) + "/" + (0, import_path.basename)(fileToImport, (0, import_path.extname)(fileToImport))).replaceAll("__package__", "root"));
    if (file === RelativeFilePath.of(ROOT_API_FILENAME)) {
      if (this.rootApiFile.imports == null) {
        this.rootApiFile.imports = {};
      }
      this.rootApiFile.imports[importPrefix] = relative(dirname(AbsoluteFilePath.of(`/${file}`)), AbsoluteFilePath.of(`/${fileToImport}`));
      return importPrefix;
    }
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.imports == null) {
      fernFile.imports = {};
    }
    fernFile.imports[importPrefix] = relative(dirname(AbsoluteFilePath.of(`/${file}`)), AbsoluteFilePath.of(`/${fileToImport}`));
    return importPrefix;
  }
  addType(file, { name, schema: schema2 }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.types == null) {
      fernFile.types = {};
    }
    fernFile.types[name] = schema2;
  }
  addTypeExample(file, name, convertedExample) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.types == null) {
      fernFile.types = {};
    }
    const type2 = fernFile.types[name];
    if (type2 != null) {
      if (typeof type2 === "string") {
        fernFile.types[name] = {
          type: type2,
          examples: [convertedExample]
        };
      } else {
        if (type2.examples == null) {
          type2.examples = [];
        }
        type2.examples.push(convertedExample);
      }
    }
  }
  addError(file, { name, schema: schema2 }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.errors == null) {
      fernFile.errors = {};
    }
    if (fernFile.errors[name] == null) {
      fernFile.errors[name] = schema2;
    } else if (fernFile.errors[name]?.type !== schema2.type) {
      fernFile.errors[name] = {
        "status-code": schema2["status-code"],
        type: "unknown"
      };
    }
  }
  addErrorExample(file, { name, example }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.errors == null) {
      return;
    }
    const errorDeclaration = fernFile.errors[name];
    if (errorDeclaration == null) {
      return;
    }
    if (errorDeclaration.examples == null) {
      errorDeclaration.examples = [];
    }
    const alreadyAdded = errorDeclaration.examples.some((existingExample) => {
      return isEqual_default(existingExample, example);
    }) ?? false;
    if (!alreadyAdded) {
      errorDeclaration.examples?.push(example);
    }
  }
  addEndpoint(file, { name, schema: schema2, source }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.service == null) {
      fernFile.service = {
        auth: false,
        "base-path": "",
        endpoints: {}
      };
    }
    if (source != null) {
      fernFile.service.source = source;
    }
    fernFile.service.endpoints[name] = schema2;
  }
  addWebhook(file, { name, schema: schema2 }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.webhooks == null) {
      fernFile.webhooks = {};
    }
    fernFile.webhooks[name] = schema2;
  }
  addChannel(file, { channel }) {
    const fernFile = this.getOrCreateFile(file);
    fernFile.channel = channel;
    const basePath = this.basePath;
    if (basePath != null) {
      fernFile.channel.path = import_path.default.join(basePath, channel.path);
    }
  }
  addChannelExample(file, { example }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.channel == null) {
      fernFile.channel = {
        path: "",
        auth: false
      };
    }
    if (fernFile.channel.messages == null) {
      fernFile.channel.messages = {};
    }
    if (fernFile.channel.examples == null) {
      fernFile.channel.examples = [];
    }
    fernFile.channel.examples.push(example);
  }
  addChannelMessage(file, { messageId, message }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.channel == null) {
      fernFile.channel = {
        path: "",
        auth: false
      };
    }
    if (fernFile.channel.messages == null) {
      fernFile.channel.messages = {};
    }
    fernFile.channel.messages[messageId] = message;
  }
  build() {
    const definitionFiles = this.root.getAllFiles();
    const basePath = this.basePath;
    if (basePath != null) {
      if (this.packageMarkerFile.service != null) {
        this.packageMarkerFile.service = {
          ...this.packageMarkerFile.service,
          endpoints: Object.fromEntries(Object.entries(this.packageMarkerFile.service.endpoints).map(([id, endpoint]) => {
            return [
              id,
              {
                ...endpoint,
                path: import_path.default.join(basePath, endpoint.path)
              }
            ];
          }))
        };
      }
      for (const file of Object.values(definitionFiles)) {
        if (file.service != null) {
          file.service = {
            ...file.service,
            endpoints: Object.fromEntries(Object.entries(file.service.endpoints).map(([id, endpoint]) => {
              return [
                id,
                {
                  ...endpoint,
                  path: import_path.default.join(basePath, endpoint.path)
                }
              ];
            }))
          };
        }
      }
    }
    const definition = {
      rootApiFile: this.rootApiFile,
      packageMarkerFile: this.packageMarkerFile,
      definitionFiles
    };
    return definition;
  }
  getOrCreateFile(file) {
    if (file === FERN_PACKAGE_MARKER_FILENAME) {
      return this.packageMarkerFile;
    } else {
      return this.root.getOrCreateFile(file);
    }
  }
  getVersionHeader() {
    if (this.rootApiFile.version == null) {
      return void 0;
    }
    return typeof this.rootApiFile.version.header === "string" ? this.rootApiFile.version.header : this.rootApiFile.version.header.value;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/OpenApiIrConverterContext.js
var OpenApiIrConverterContext = class {
  logger;
  taskContext;
  ir;
  builder;
  environmentOverrides;
  authOverrides;
  globalHeaderOverrides;
  detectGlobalHeaders;
  objectQueryParameters;
  respectReadonlySchemas;
  onlyIncludeReferencedSchemas;
  inlinePathParameters;
  enableUniqueErrorsPerEndpoint;
  defaultServerName = void 0;
  unknownSchema = /* @__PURE__ */ new Set();
  /**
   * The set of referenced schema ids to include in the generated definition.
   * If this value is undefined, _all_ schemaIds should be treated as referenced,
   * and therefore included in the generated definition.
   */
  referencedSchemaIds;
  /**
   * The current endpoint method being processed. This is used to determine
   * whether certain properties should be included in the generated definition
   * (e.g. readonly properties are excluded for POST/PUT endpoints).
   */
  endpointMethod;
  /**
   * Tracks the state in which a schema is being processed (e.g. endpoint, channel, webhook,
   * request). It's possible that a schema is being processed in multiple states (e.g. an
   * endpoint and a request).
   */
  state = /* @__PURE__ */ new Set();
  constructor({ taskContext, ir, enableUniqueErrorsPerEndpoint, detectGlobalHeaders, environmentOverrides, globalHeaderOverrides, authOverrides, objectQueryParameters, respectReadonlySchemas, onlyIncludeReferencedSchemas, inlinePathParameters }) {
    this.logger = taskContext.logger;
    this.taskContext = taskContext;
    this.ir = ir;
    this.enableUniqueErrorsPerEndpoint = enableUniqueErrorsPerEndpoint;
    this.builder = new FernDefinitionBuilderImpl(enableUniqueErrorsPerEndpoint);
    if (ir.title != null) {
      this.builder.setDisplayName({ displayName: ir.title });
    }
    this.detectGlobalHeaders = detectGlobalHeaders;
    this.environmentOverrides = environmentOverrides;
    this.authOverrides = authOverrides;
    this.globalHeaderOverrides = globalHeaderOverrides;
    this.objectQueryParameters = objectQueryParameters;
    this.respectReadonlySchemas = respectReadonlySchemas;
    this.onlyIncludeReferencedSchemas = onlyIncludeReferencedSchemas;
    this.inlinePathParameters = inlinePathParameters;
    this.referencedSchemaIds = onlyIncludeReferencedSchemas ? /* @__PURE__ */ new Set() : void 0;
    const schemaByStatusCode = {};
    if (!this.enableUniqueErrorsPerEndpoint) {
      for (const endpoint of ir.endpoints) {
        for (const [statusCodeString, error] of Object.entries(endpoint.errors)) {
          const statusCode = parseInt(statusCodeString);
          const existingSchema = schemaByStatusCode[statusCode];
          if (existingSchema == null && error.schema != null) {
            schemaByStatusCode[statusCode] = error.schema;
          } else if (existingSchema != null && error.schema != null && isSchemaEqual(existingSchema, error.schema)) {
          } else {
            this.unknownSchema.add(statusCode);
          }
        }
      }
    }
  }
  getReferencedSchemaIds() {
    if (this.referencedSchemaIds == null) {
      return void 0;
    }
    return Array.from(this.referencedSchemaIds);
  }
  getSchema(id, namespace) {
    if (namespace == null) {
      return this.ir.groupedSchemas.rootSchemas[id];
    }
    return this.ir.groupedSchemas.namespacedSchemas[namespace]?.[id];
  }
  /**
   * Returns the default server URL. This URL should only be set for multi-url cases.
   */
  getDefaultServerName() {
    return this.defaultServerName;
  }
  /**
   * Sets the default server URL. This URL should only be set for multi-url cases.
   */
  setDefaultServerName(name) {
    this.defaultServerName = name;
  }
  /**
   * Is error an unknown schema
   */
  isErrorUnknownSchema(statusCode) {
    return this.unknownSchema.has(statusCode);
  }
  /**
   * Returns the current endpoint method being processed
   */
  getEndpointMethod() {
    return this.endpointMethod;
  }
  /**
   * Sets the current endpoint method being processed
   */
  setEndpointMethod(method) {
    this.endpointMethod = method;
  }
  /**
   * Unsets the current endpoint method being processed
   */
  unsetEndpointMethod() {
    this.endpointMethod = void 0;
  }
  /**
   * Returns whether we're currently processing the given state.
   */
  isInState(state) {
    return this.state.has(state);
  }
  /**
   * Sets that we're currently processing the given state.
   */
  setInState(state) {
    this.state.add(state);
  }
  /**
   * Unsets that we're currently processing the given state.
   */
  unsetInState(state) {
    this.state.delete(state);
  }
  shouldMarkSchemaAsReferenced() {
    return this.onlyIncludeReferencedSchemas && this.isInAnyState(State.Channel, State.Endpoint, State.Webhook);
  }
  /**
   * Marks a schema as referenced.
   */
  markSchemaAsReferenced(schema2, namespace) {
    switch (schema2.type) {
      case "primitive":
        return;
      case "object":
        this.markObjectSchemaAsReferenced(schema2, namespace);
        return;
      case "array":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "map":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "optional":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "reference":
        this.markSchemaIdAsReferenced(schema2.schema, namespace);
        return;
      case "oneOf":
        this.markOneofSchemaAsReferenced(schema2.value, namespace);
        return;
      case "nullable":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "enum":
        return;
      case "literal":
        return;
      case "unknown":
        return;
      default:
        assertNever(schema2);
    }
  }
  markObjectSchemaAsReferenced(schema2, namespace) {
    for (const allOf of schema2.allOf) {
      this.markSchemaIdAsReferenced(allOf.schema, namespace);
    }
    for (const property4 of schema2.properties) {
      this.markSchemaAsReferenced(property4.schema, namespace);
    }
  }
  markOneofSchemaAsReferenced(schema2, namespace) {
    switch (schema2.type) {
      case "discriminated":
        for (const oneOf of Object.values(schema2.schemas)) {
          this.markSchemaAsReferenced(oneOf, namespace);
        }
        return;
      case "undisciminated":
        for (const oneOf of schema2.schemas) {
          this.markSchemaAsReferenced(oneOf, namespace);
        }
        return;
      default:
        assertNever(schema2);
    }
  }
  markSchemaIdAsReferenced(id, namespace) {
    if (this.referencedSchemaIds != null && !this.referencedSchemaIds.has(id)) {
      this.referencedSchemaIds.add(id);
      const schema2 = this.getSchema(id, namespace);
      if (schema2 != null) {
        this.markSchemaAsReferenced(schema2, namespace);
      }
    }
  }
  isInAnyState(...states) {
    return states.some((state) => this.isInState(state));
  }
};

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/convert.js
function convert(opts) {
  const context = new OpenApiIrConverterContext(opts);
  return buildFernDefinition(context);
}

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/dist/js-yaml.mjs
function isNothing(subject) {
  return typeof subject === "undefined" || subject === null;
}
function isObject2(subject) {
  return typeof subject === "object" && subject !== null;
}
function toArray(sequence) {
  if (Array.isArray(sequence)) return sequence;
  else if (isNothing(sequence)) return [];
  return [sequence];
}
function extend(target, source) {
  var index, length, key, sourceKeys;
  if (source) {
    sourceKeys = Object.keys(source);
    for (index = 0, length = sourceKeys.length; index < length; index += 1) {
      key = sourceKeys[index];
      target[key] = source[key];
    }
  }
  return target;
}
function repeat(string3, count) {
  var result = "", cycle;
  for (cycle = 0; cycle < count; cycle += 1) {
    result += string3;
  }
  return result;
}
function isNegativeZero(number3) {
  return number3 === 0 && Number.NEGATIVE_INFINITY === 1 / number3;
}
var isNothing_1 = isNothing;
var isObject_1 = isObject2;
var toArray_1 = toArray;
var repeat_1 = repeat;
var isNegativeZero_1 = isNegativeZero;
var extend_1 = extend;
var common = {
  isNothing: isNothing_1,
  isObject: isObject_1,
  toArray: toArray_1,
  repeat: repeat_1,
  isNegativeZero: isNegativeZero_1,
  extend: extend_1
};
function formatError(exception2, compact2) {
  var where = "", message = exception2.reason || "(unknown reason)";
  if (!exception2.mark) return message;
  if (exception2.mark.name) {
    where += 'in "' + exception2.mark.name + '" ';
  }
  where += "(" + (exception2.mark.line + 1) + ":" + (exception2.mark.column + 1) + ")";
  if (!compact2 && exception2.mark.snippet) {
    where += "\n\n" + exception2.mark.snippet;
  }
  return message + " " + where;
}
function YAMLException$1(reason, mark) {
  Error.call(this);
  this.name = "YAMLException";
  this.reason = reason;
  this.mark = mark;
  this.message = formatError(this, false);
  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, this.constructor);
  } else {
    this.stack = new Error().stack || "";
  }
}
YAMLException$1.prototype = Object.create(Error.prototype);
YAMLException$1.prototype.constructor = YAMLException$1;
YAMLException$1.prototype.toString = function toString3(compact2) {
  return this.name + ": " + formatError(this, compact2);
};
var exception = YAMLException$1;
function getLine(buffer, lineStart, lineEnd, position, maxLineLength) {
  var head = "";
  var tail = "";
  var maxHalfLength = Math.floor(maxLineLength / 2) - 1;
  if (position - lineStart > maxHalfLength) {
    head = " ... ";
    lineStart = position - maxHalfLength + head.length;
  }
  if (lineEnd - position > maxHalfLength) {
    tail = " ...";
    lineEnd = position + maxHalfLength - tail.length;
  }
  return {
    str: head + buffer.slice(lineStart, lineEnd).replace(/\t/g, "\u2192") + tail,
    pos: position - lineStart + head.length
    // relative position
  };
}
function padStart(string3, max) {
  return common.repeat(" ", max - string3.length) + string3;
}
function makeSnippet(mark, options) {
  options = Object.create(options || null);
  if (!mark.buffer) return null;
  if (!options.maxLength) options.maxLength = 79;
  if (typeof options.indent !== "number") options.indent = 1;
  if (typeof options.linesBefore !== "number") options.linesBefore = 3;
  if (typeof options.linesAfter !== "number") options.linesAfter = 2;
  var re = /\r?\n|\r|\0/g;
  var lineStarts = [0];
  var lineEnds = [];
  var match;
  var foundLineNo = -1;
  while (match = re.exec(mark.buffer)) {
    lineEnds.push(match.index);
    lineStarts.push(match.index + match[0].length);
    if (mark.position <= match.index && foundLineNo < 0) {
      foundLineNo = lineStarts.length - 2;
    }
  }
  if (foundLineNo < 0) foundLineNo = lineStarts.length - 1;
  var result = "", i, line;
  var lineNoLength = Math.min(mark.line + options.linesAfter, lineEnds.length).toString().length;
  var maxLineLength = options.maxLength - (options.indent + lineNoLength + 3);
  for (i = 1; i <= options.linesBefore; i++) {
    if (foundLineNo - i < 0) break;
    line = getLine(
      mark.buffer,
      lineStarts[foundLineNo - i],
      lineEnds[foundLineNo - i],
      mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i]),
      maxLineLength
    );
    result = common.repeat(" ", options.indent) + padStart((mark.line - i + 1).toString(), lineNoLength) + " | " + line.str + "\n" + result;
  }
  line = getLine(mark.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark.position, maxLineLength);
  result += common.repeat(" ", options.indent) + padStart((mark.line + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  result += common.repeat("-", options.indent + lineNoLength + 3 + line.pos) + "^\n";
  for (i = 1; i <= options.linesAfter; i++) {
    if (foundLineNo + i >= lineEnds.length) break;
    line = getLine(
      mark.buffer,
      lineStarts[foundLineNo + i],
      lineEnds[foundLineNo + i],
      mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i]),
      maxLineLength
    );
    result += common.repeat(" ", options.indent) + padStart((mark.line + i + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  }
  return result.replace(/\n$/, "");
}
var snippet = makeSnippet;
var TYPE_CONSTRUCTOR_OPTIONS = [
  "kind",
  "multi",
  "resolve",
  "construct",
  "instanceOf",
  "predicate",
  "represent",
  "representName",
  "defaultStyle",
  "styleAliases"
];
var YAML_NODE_KINDS = [
  "scalar",
  "sequence",
  "mapping"
];
function compileStyleAliases(map2) {
  var result = {};
  if (map2 !== null) {
    Object.keys(map2).forEach(function(style) {
      map2[style].forEach(function(alias) {
        result[String(alias)] = style;
      });
    });
  }
  return result;
}
function Type$1(tag, options) {
  options = options || {};
  Object.keys(options).forEach(function(name) {
    if (TYPE_CONSTRUCTOR_OPTIONS.indexOf(name) === -1) {
      throw new exception('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
    }
  });
  this.options = options;
  this.tag = tag;
  this.kind = options["kind"] || null;
  this.resolve = options["resolve"] || function() {
    return true;
  };
  this.construct = options["construct"] || function(data) {
    return data;
  };
  this.instanceOf = options["instanceOf"] || null;
  this.predicate = options["predicate"] || null;
  this.represent = options["represent"] || null;
  this.representName = options["representName"] || null;
  this.defaultStyle = options["defaultStyle"] || null;
  this.multi = options["multi"] || false;
  this.styleAliases = compileStyleAliases(options["styleAliases"] || null);
  if (YAML_NODE_KINDS.indexOf(this.kind) === -1) {
    throw new exception('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
  }
}
var type = Type$1;
function compileList(schema2, name) {
  var result = [];
  schema2[name].forEach(function(currentType) {
    var newIndex = result.length;
    result.forEach(function(previousType, previousIndex) {
      if (previousType.tag === currentType.tag && previousType.kind === currentType.kind && previousType.multi === currentType.multi) {
        newIndex = previousIndex;
      }
    });
    result[newIndex] = currentType;
  });
  return result;
}
function compileMap() {
  var result = {
    scalar: {},
    sequence: {},
    mapping: {},
    fallback: {},
    multi: {
      scalar: [],
      sequence: [],
      mapping: [],
      fallback: []
    }
  }, index, length;
  function collectType(type2) {
    if (type2.multi) {
      result.multi[type2.kind].push(type2);
      result.multi["fallback"].push(type2);
    } else {
      result[type2.kind][type2.tag] = result["fallback"][type2.tag] = type2;
    }
  }
  for (index = 0, length = arguments.length; index < length; index += 1) {
    arguments[index].forEach(collectType);
  }
  return result;
}
function Schema$1(definition) {
  return this.extend(definition);
}
Schema$1.prototype.extend = function extend2(definition) {
  var implicit = [];
  var explicit = [];
  if (definition instanceof type) {
    explicit.push(definition);
  } else if (Array.isArray(definition)) {
    explicit = explicit.concat(definition);
  } else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit))) {
    if (definition.implicit) implicit = implicit.concat(definition.implicit);
    if (definition.explicit) explicit = explicit.concat(definition.explicit);
  } else {
    throw new exception("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");
  }
  implicit.forEach(function(type$1) {
    if (!(type$1 instanceof type)) {
      throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
    }
    if (type$1.loadKind && type$1.loadKind !== "scalar") {
      throw new exception("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
    }
    if (type$1.multi) {
      throw new exception("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.");
    }
  });
  explicit.forEach(function(type$1) {
    if (!(type$1 instanceof type)) {
      throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
    }
  });
  var result = Object.create(Schema$1.prototype);
  result.implicit = (this.implicit || []).concat(implicit);
  result.explicit = (this.explicit || []).concat(explicit);
  result.compiledImplicit = compileList(result, "implicit");
  result.compiledExplicit = compileList(result, "explicit");
  result.compiledTypeMap = compileMap(result.compiledImplicit, result.compiledExplicit);
  return result;
};
var schema = Schema$1;
var str = new type("tag:yaml.org,2002:str", {
  kind: "scalar",
  construct: function(data) {
    return data !== null ? data : "";
  }
});
var seq = new type("tag:yaml.org,2002:seq", {
  kind: "sequence",
  construct: function(data) {
    return data !== null ? data : [];
  }
});
var map = new type("tag:yaml.org,2002:map", {
  kind: "mapping",
  construct: function(data) {
    return data !== null ? data : {};
  }
});
var failsafe = new schema({
  explicit: [
    str,
    seq,
    map
  ]
});
function resolveYamlNull(data) {
  if (data === null) return true;
  var max = data.length;
  return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
}
function constructYamlNull() {
  return null;
}
function isNull2(object3) {
  return object3 === null;
}
var _null = new type("tag:yaml.org,2002:null", {
  kind: "scalar",
  resolve: resolveYamlNull,
  construct: constructYamlNull,
  predicate: isNull2,
  represent: {
    canonical: function() {
      return "~";
    },
    lowercase: function() {
      return "null";
    },
    uppercase: function() {
      return "NULL";
    },
    camelcase: function() {
      return "Null";
    },
    empty: function() {
      return "";
    }
  },
  defaultStyle: "lowercase"
});
function resolveYamlBoolean(data) {
  if (data === null) return false;
  var max = data.length;
  return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
}
function constructYamlBoolean(data) {
  return data === "true" || data === "True" || data === "TRUE";
}
function isBoolean(object3) {
  return Object.prototype.toString.call(object3) === "[object Boolean]";
}
var bool = new type("tag:yaml.org,2002:bool", {
  kind: "scalar",
  resolve: resolveYamlBoolean,
  construct: constructYamlBoolean,
  predicate: isBoolean,
  represent: {
    lowercase: function(object3) {
      return object3 ? "true" : "false";
    },
    uppercase: function(object3) {
      return object3 ? "TRUE" : "FALSE";
    },
    camelcase: function(object3) {
      return object3 ? "True" : "False";
    }
  },
  defaultStyle: "lowercase"
});
function isHexCode(c) {
  return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
}
function isOctCode(c) {
  return 48 <= c && c <= 55;
}
function isDecCode(c) {
  return 48 <= c && c <= 57;
}
function resolveYamlInteger(data) {
  if (data === null) return false;
  var max = data.length, index = 0, hasDigits = false, ch;
  if (!max) return false;
  ch = data[index];
  if (ch === "-" || ch === "+") {
    ch = data[++index];
  }
  if (ch === "0") {
    if (index + 1 === max) return true;
    ch = data[++index];
    if (ch === "b") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (ch !== "0" && ch !== "1") return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "x") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (!isHexCode(data.charCodeAt(index))) return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "o") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (!isOctCode(data.charCodeAt(index))) return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
  }
  if (ch === "_") return false;
  for (; index < max; index++) {
    ch = data[index];
    if (ch === "_") continue;
    if (!isDecCode(data.charCodeAt(index))) {
      return false;
    }
    hasDigits = true;
  }
  if (!hasDigits || ch === "_") return false;
  return true;
}
function constructYamlInteger(data) {
  var value = data, sign = 1, ch;
  if (value.indexOf("_") !== -1) {
    value = value.replace(/_/g, "");
  }
  ch = value[0];
  if (ch === "-" || ch === "+") {
    if (ch === "-") sign = -1;
    value = value.slice(1);
    ch = value[0];
  }
  if (value === "0") return 0;
  if (ch === "0") {
    if (value[1] === "b") return sign * parseInt(value.slice(2), 2);
    if (value[1] === "x") return sign * parseInt(value.slice(2), 16);
    if (value[1] === "o") return sign * parseInt(value.slice(2), 8);
  }
  return sign * parseInt(value, 10);
}
function isInteger(object3) {
  return Object.prototype.toString.call(object3) === "[object Number]" && (object3 % 1 === 0 && !common.isNegativeZero(object3));
}
var int = new type("tag:yaml.org,2002:int", {
  kind: "scalar",
  resolve: resolveYamlInteger,
  construct: constructYamlInteger,
  predicate: isInteger,
  represent: {
    binary: function(obj) {
      return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
    },
    octal: function(obj) {
      return obj >= 0 ? "0o" + obj.toString(8) : "-0o" + obj.toString(8).slice(1);
    },
    decimal: function(obj) {
      return obj.toString(10);
    },
    /* eslint-disable max-len */
    hexadecimal: function(obj) {
      return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
    }
  },
  defaultStyle: "decimal",
  styleAliases: {
    binary: [2, "bin"],
    octal: [8, "oct"],
    decimal: [10, "dec"],
    hexadecimal: [16, "hex"]
  }
});
var YAML_FLOAT_PATTERN = new RegExp(
  // 2.5e4, 2.5 and integers
  "^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$"
);
function resolveYamlFloat(data) {
  if (data === null) return false;
  if (!YAML_FLOAT_PATTERN.test(data) || // Quick hack to not allow integers end with `_`
  // Probably should update regexp & check speed
  data[data.length - 1] === "_") {
    return false;
  }
  return true;
}
function constructYamlFloat(data) {
  var value, sign;
  value = data.replace(/_/g, "").toLowerCase();
  sign = value[0] === "-" ? -1 : 1;
  if ("+-".indexOf(value[0]) >= 0) {
    value = value.slice(1);
  }
  if (value === ".inf") {
    return sign === 1 ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
  } else if (value === ".nan") {
    return NaN;
  }
  return sign * parseFloat(value, 10);
}
var SCIENTIFIC_WITHOUT_DOT = /^[-+]?[0-9]+e/;
function representYamlFloat(object3, style) {
  var res;
  if (isNaN(object3)) {
    switch (style) {
      case "lowercase":
        return ".nan";
      case "uppercase":
        return ".NAN";
      case "camelcase":
        return ".NaN";
    }
  } else if (Number.POSITIVE_INFINITY === object3) {
    switch (style) {
      case "lowercase":
        return ".inf";
      case "uppercase":
        return ".INF";
      case "camelcase":
        return ".Inf";
    }
  } else if (Number.NEGATIVE_INFINITY === object3) {
    switch (style) {
      case "lowercase":
        return "-.inf";
      case "uppercase":
        return "-.INF";
      case "camelcase":
        return "-.Inf";
    }
  } else if (common.isNegativeZero(object3)) {
    return "-0.0";
  }
  res = object3.toString(10);
  return SCIENTIFIC_WITHOUT_DOT.test(res) ? res.replace("e", ".e") : res;
}
function isFloat(object3) {
  return Object.prototype.toString.call(object3) === "[object Number]" && (object3 % 1 !== 0 || common.isNegativeZero(object3));
}
var float = new type("tag:yaml.org,2002:float", {
  kind: "scalar",
  resolve: resolveYamlFloat,
  construct: constructYamlFloat,
  predicate: isFloat,
  represent: representYamlFloat,
  defaultStyle: "lowercase"
});
var json = failsafe.extend({
  implicit: [
    _null,
    bool,
    int,
    float
  ]
});
var core = json;
var YAML_DATE_REGEXP = new RegExp(
  "^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$"
);
var YAML_TIMESTAMP_REGEXP = new RegExp(
  "^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$"
);
function resolveYamlTimestamp(data) {
  if (data === null) return false;
  if (YAML_DATE_REGEXP.exec(data) !== null) return true;
  if (YAML_TIMESTAMP_REGEXP.exec(data) !== null) return true;
  return false;
}
function constructYamlTimestamp(data) {
  var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date3;
  match = YAML_DATE_REGEXP.exec(data);
  if (match === null) match = YAML_TIMESTAMP_REGEXP.exec(data);
  if (match === null) throw new Error("Date resolve error");
  year = +match[1];
  month = +match[2] - 1;
  day = +match[3];
  if (!match[4]) {
    return new Date(Date.UTC(year, month, day));
  }
  hour = +match[4];
  minute = +match[5];
  second = +match[6];
  if (match[7]) {
    fraction = match[7].slice(0, 3);
    while (fraction.length < 3) {
      fraction += "0";
    }
    fraction = +fraction;
  }
  if (match[9]) {
    tz_hour = +match[10];
    tz_minute = +(match[11] || 0);
    delta = (tz_hour * 60 + tz_minute) * 6e4;
    if (match[9] === "-") delta = -delta;
  }
  date3 = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
  if (delta) date3.setTime(date3.getTime() - delta);
  return date3;
}
function representYamlTimestamp(object3) {
  return object3.toISOString();
}
var timestamp = new type("tag:yaml.org,2002:timestamp", {
  kind: "scalar",
  resolve: resolveYamlTimestamp,
  construct: constructYamlTimestamp,
  instanceOf: Date,
  represent: representYamlTimestamp
});
function resolveYamlMerge(data) {
  return data === "<<" || data === null;
}
var merge = new type("tag:yaml.org,2002:merge", {
  kind: "scalar",
  resolve: resolveYamlMerge
});
var BASE64_MAP = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
function resolveYamlBinary(data) {
  if (data === null) return false;
  var code, idx, bitlen = 0, max = data.length, map2 = BASE64_MAP;
  for (idx = 0; idx < max; idx++) {
    code = map2.indexOf(data.charAt(idx));
    if (code > 64) continue;
    if (code < 0) return false;
    bitlen += 6;
  }
  return bitlen % 8 === 0;
}
function constructYamlBinary(data) {
  var idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP, bits = 0, result = [];
  for (idx = 0; idx < max; idx++) {
    if (idx % 4 === 0 && idx) {
      result.push(bits >> 16 & 255);
      result.push(bits >> 8 & 255);
      result.push(bits & 255);
    }
    bits = bits << 6 | map2.indexOf(input.charAt(idx));
  }
  tailbits = max % 4 * 6;
  if (tailbits === 0) {
    result.push(bits >> 16 & 255);
    result.push(bits >> 8 & 255);
    result.push(bits & 255);
  } else if (tailbits === 18) {
    result.push(bits >> 10 & 255);
    result.push(bits >> 2 & 255);
  } else if (tailbits === 12) {
    result.push(bits >> 4 & 255);
  }
  return new Uint8Array(result);
}
function representYamlBinary(object3) {
  var result = "", bits = 0, idx, tail, max = object3.length, map2 = BASE64_MAP;
  for (idx = 0; idx < max; idx++) {
    if (idx % 3 === 0 && idx) {
      result += map2[bits >> 18 & 63];
      result += map2[bits >> 12 & 63];
      result += map2[bits >> 6 & 63];
      result += map2[bits & 63];
    }
    bits = (bits << 8) + object3[idx];
  }
  tail = max % 3;
  if (tail === 0) {
    result += map2[bits >> 18 & 63];
    result += map2[bits >> 12 & 63];
    result += map2[bits >> 6 & 63];
    result += map2[bits & 63];
  } else if (tail === 2) {
    result += map2[bits >> 10 & 63];
    result += map2[bits >> 4 & 63];
    result += map2[bits << 2 & 63];
    result += map2[64];
  } else if (tail === 1) {
    result += map2[bits >> 2 & 63];
    result += map2[bits << 4 & 63];
    result += map2[64];
    result += map2[64];
  }
  return result;
}
function isBinary(obj) {
  return Object.prototype.toString.call(obj) === "[object Uint8Array]";
}
var binary = new type("tag:yaml.org,2002:binary", {
  kind: "scalar",
  resolve: resolveYamlBinary,
  construct: constructYamlBinary,
  predicate: isBinary,
  represent: representYamlBinary
});
var _hasOwnProperty$3 = Object.prototype.hasOwnProperty;
var _toString$2 = Object.prototype.toString;
function resolveYamlOmap(data) {
  if (data === null) return true;
  var objectKeys = [], index, length, pair, pairKey, pairHasKey, object3 = data;
  for (index = 0, length = object3.length; index < length; index += 1) {
    pair = object3[index];
    pairHasKey = false;
    if (_toString$2.call(pair) !== "[object Object]") return false;
    for (pairKey in pair) {
      if (_hasOwnProperty$3.call(pair, pairKey)) {
        if (!pairHasKey) pairHasKey = true;
        else return false;
      }
    }
    if (!pairHasKey) return false;
    if (objectKeys.indexOf(pairKey) === -1) objectKeys.push(pairKey);
    else return false;
  }
  return true;
}
function constructYamlOmap(data) {
  return data !== null ? data : [];
}
var omap = new type("tag:yaml.org,2002:omap", {
  kind: "sequence",
  resolve: resolveYamlOmap,
  construct: constructYamlOmap
});
var _toString$1 = Object.prototype.toString;
function resolveYamlPairs(data) {
  if (data === null) return true;
  var index, length, pair, keys5, result, object3 = data;
  result = new Array(object3.length);
  for (index = 0, length = object3.length; index < length; index += 1) {
    pair = object3[index];
    if (_toString$1.call(pair) !== "[object Object]") return false;
    keys5 = Object.keys(pair);
    if (keys5.length !== 1) return false;
    result[index] = [keys5[0], pair[keys5[0]]];
  }
  return true;
}
function constructYamlPairs(data) {
  if (data === null) return [];
  var index, length, pair, keys5, result, object3 = data;
  result = new Array(object3.length);
  for (index = 0, length = object3.length; index < length; index += 1) {
    pair = object3[index];
    keys5 = Object.keys(pair);
    result[index] = [keys5[0], pair[keys5[0]]];
  }
  return result;
}
var pairs = new type("tag:yaml.org,2002:pairs", {
  kind: "sequence",
  resolve: resolveYamlPairs,
  construct: constructYamlPairs
});
var _hasOwnProperty$2 = Object.prototype.hasOwnProperty;
function resolveYamlSet(data) {
  if (data === null) return true;
  var key, object3 = data;
  for (key in object3) {
    if (_hasOwnProperty$2.call(object3, key)) {
      if (object3[key] !== null) return false;
    }
  }
  return true;
}
function constructYamlSet(data) {
  return data !== null ? data : {};
}
var set3 = new type("tag:yaml.org,2002:set", {
  kind: "mapping",
  resolve: resolveYamlSet,
  construct: constructYamlSet
});
var _default = core.extend({
  implicit: [
    timestamp,
    merge
  ],
  explicit: [
    binary,
    omap,
    pairs,
    set3
  ]
});
var _hasOwnProperty$1 = Object.prototype.hasOwnProperty;
var CONTEXT_FLOW_IN = 1;
var CONTEXT_FLOW_OUT = 2;
var CONTEXT_BLOCK_IN = 3;
var CONTEXT_BLOCK_OUT = 4;
var CHOMPING_CLIP = 1;
var CHOMPING_STRIP = 2;
var CHOMPING_KEEP = 3;
var PATTERN_NON_PRINTABLE = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
var PATTERN_NON_ASCII_LINE_BREAKS = /[\x85\u2028\u2029]/;
var PATTERN_FLOW_INDICATORS = /[,\[\]\{\}]/;
var PATTERN_TAG_HANDLE = /^(?:!|!!|![a-z\-]+!)$/i;
var PATTERN_TAG_URI = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
function _class(obj) {
  return Object.prototype.toString.call(obj);
}
function is_EOL(c) {
  return c === 10 || c === 13;
}
function is_WHITE_SPACE(c) {
  return c === 9 || c === 32;
}
function is_WS_OR_EOL(c) {
  return c === 9 || c === 32 || c === 10 || c === 13;
}
function is_FLOW_INDICATOR(c) {
  return c === 44 || c === 91 || c === 93 || c === 123 || c === 125;
}
function fromHexCode(c) {
  var lc;
  if (48 <= c && c <= 57) {
    return c - 48;
  }
  lc = c | 32;
  if (97 <= lc && lc <= 102) {
    return lc - 97 + 10;
  }
  return -1;
}
function escapedHexLen(c) {
  if (c === 120) {
    return 2;
  }
  if (c === 117) {
    return 4;
  }
  if (c === 85) {
    return 8;
  }
  return 0;
}
function fromDecimalCode(c) {
  if (48 <= c && c <= 57) {
    return c - 48;
  }
  return -1;
}
function simpleEscapeSequence(c) {
  return c === 48 ? "\0" : c === 97 ? "\x07" : c === 98 ? "\b" : c === 116 ? "	" : c === 9 ? "	" : c === 110 ? "\n" : c === 118 ? "\v" : c === 102 ? "\f" : c === 114 ? "\r" : c === 101 ? "\x1B" : c === 32 ? " " : c === 34 ? '"' : c === 47 ? "/" : c === 92 ? "\\" : c === 78 ? "\x85" : c === 95 ? "\xA0" : c === 76 ? "\u2028" : c === 80 ? "\u2029" : "";
}
function charFromCodepoint(c) {
  if (c <= 65535) {
    return String.fromCharCode(c);
  }
  return String.fromCharCode(
    (c - 65536 >> 10) + 55296,
    (c - 65536 & 1023) + 56320
  );
}
var simpleEscapeCheck = new Array(256);
var simpleEscapeMap = new Array(256);
for (i = 0; i < 256; i++) {
  simpleEscapeCheck[i] = simpleEscapeSequence(i) ? 1 : 0;
  simpleEscapeMap[i] = simpleEscapeSequence(i);
}
var i;
function State$1(input, options) {
  this.input = input;
  this.filename = options["filename"] || null;
  this.schema = options["schema"] || _default;
  this.onWarning = options["onWarning"] || null;
  this.legacy = options["legacy"] || false;
  this.json = options["json"] || false;
  this.listener = options["listener"] || null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.typeMap = this.schema.compiledTypeMap;
  this.length = input.length;
  this.position = 0;
  this.line = 0;
  this.lineStart = 0;
  this.lineIndent = 0;
  this.firstTabInLine = -1;
  this.documents = [];
}
function generateError(state, message) {
  var mark = {
    name: state.filename,
    buffer: state.input.slice(0, -1),
    // omit trailing \0
    position: state.position,
    line: state.line,
    column: state.position - state.lineStart
  };
  mark.snippet = snippet(mark);
  return new exception(message, mark);
}
function throwError(state, message) {
  throw generateError(state, message);
}
function throwWarning(state, message) {
  if (state.onWarning) {
    state.onWarning.call(null, generateError(state, message));
  }
}
var directiveHandlers = {
  YAML: function handleYamlDirective(state, name, args) {
    var match, major, minor;
    if (state.version !== null) {
      throwError(state, "duplication of %YAML directive");
    }
    if (args.length !== 1) {
      throwError(state, "YAML directive accepts exactly one argument");
    }
    match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
    if (match === null) {
      throwError(state, "ill-formed argument of the YAML directive");
    }
    major = parseInt(match[1], 10);
    minor = parseInt(match[2], 10);
    if (major !== 1) {
      throwError(state, "unacceptable YAML version of the document");
    }
    state.version = args[0];
    state.checkLineBreaks = minor < 2;
    if (minor !== 1 && minor !== 2) {
      throwWarning(state, "unsupported YAML version of the document");
    }
  },
  TAG: function handleTagDirective(state, name, args) {
    var handle, prefix;
    if (args.length !== 2) {
      throwError(state, "TAG directive accepts exactly two arguments");
    }
    handle = args[0];
    prefix = args[1];
    if (!PATTERN_TAG_HANDLE.test(handle)) {
      throwError(state, "ill-formed tag handle (first argument) of the TAG directive");
    }
    if (_hasOwnProperty$1.call(state.tagMap, handle)) {
      throwError(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
    }
    if (!PATTERN_TAG_URI.test(prefix)) {
      throwError(state, "ill-formed tag prefix (second argument) of the TAG directive");
    }
    try {
      prefix = decodeURIComponent(prefix);
    } catch (err) {
      throwError(state, "tag prefix is malformed: " + prefix);
    }
    state.tagMap[handle] = prefix;
  }
};
function captureSegment(state, start, end, checkJson) {
  var _position, _length, _character, _result;
  if (start < end) {
    _result = state.input.slice(start, end);
    if (checkJson) {
      for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
        _character = _result.charCodeAt(_position);
        if (!(_character === 9 || 32 <= _character && _character <= 1114111)) {
          throwError(state, "expected valid JSON character");
        }
      }
    } else if (PATTERN_NON_PRINTABLE.test(_result)) {
      throwError(state, "the stream contains non-printable characters");
    }
    state.result += _result;
  }
}
function mergeMappings(state, destination, source, overridableKeys) {
  var sourceKeys, key, index, quantity;
  if (!common.isObject(source)) {
    throwError(state, "cannot merge mappings; the provided source object is unacceptable");
  }
  sourceKeys = Object.keys(source);
  for (index = 0, quantity = sourceKeys.length; index < quantity; index += 1) {
    key = sourceKeys[index];
    if (!_hasOwnProperty$1.call(destination, key)) {
      destination[key] = source[key];
      overridableKeys[key] = true;
    }
  }
}
function storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startLineStart, startPos) {
  var index, quantity;
  if (Array.isArray(keyNode)) {
    keyNode = Array.prototype.slice.call(keyNode);
    for (index = 0, quantity = keyNode.length; index < quantity; index += 1) {
      if (Array.isArray(keyNode[index])) {
        throwError(state, "nested arrays are not supported inside keys");
      }
      if (typeof keyNode === "object" && _class(keyNode[index]) === "[object Object]") {
        keyNode[index] = "[object Object]";
      }
    }
  }
  if (typeof keyNode === "object" && _class(keyNode) === "[object Object]") {
    keyNode = "[object Object]";
  }
  keyNode = String(keyNode);
  if (_result === null) {
    _result = {};
  }
  if (keyTag === "tag:yaml.org,2002:merge") {
    if (Array.isArray(valueNode)) {
      for (index = 0, quantity = valueNode.length; index < quantity; index += 1) {
        mergeMappings(state, _result, valueNode[index], overridableKeys);
      }
    } else {
      mergeMappings(state, _result, valueNode, overridableKeys);
    }
  } else {
    if (!state.json && !_hasOwnProperty$1.call(overridableKeys, keyNode) && _hasOwnProperty$1.call(_result, keyNode)) {
      state.line = startLine || state.line;
      state.lineStart = startLineStart || state.lineStart;
      state.position = startPos || state.position;
      throwError(state, "duplicated mapping key");
    }
    if (keyNode === "__proto__") {
      Object.defineProperty(_result, keyNode, {
        configurable: true,
        enumerable: true,
        writable: true,
        value: valueNode
      });
    } else {
      _result[keyNode] = valueNode;
    }
    delete overridableKeys[keyNode];
  }
  return _result;
}
function readLineBreak(state) {
  var ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 10) {
    state.position++;
  } else if (ch === 13) {
    state.position++;
    if (state.input.charCodeAt(state.position) === 10) {
      state.position++;
    }
  } else {
    throwError(state, "a line break is expected");
  }
  state.line += 1;
  state.lineStart = state.position;
  state.firstTabInLine = -1;
}
function skipSeparationSpace(state, allowComments, checkIndent) {
  var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    while (is_WHITE_SPACE(ch)) {
      if (ch === 9 && state.firstTabInLine === -1) {
        state.firstTabInLine = state.position;
      }
      ch = state.input.charCodeAt(++state.position);
    }
    if (allowComments && ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (ch !== 10 && ch !== 13 && ch !== 0);
    }
    if (is_EOL(ch)) {
      readLineBreak(state);
      ch = state.input.charCodeAt(state.position);
      lineBreaks++;
      state.lineIndent = 0;
      while (ch === 32) {
        state.lineIndent++;
        ch = state.input.charCodeAt(++state.position);
      }
    } else {
      break;
    }
  }
  if (checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent) {
    throwWarning(state, "deficient indentation");
  }
  return lineBreaks;
}
function testDocumentSeparator(state) {
  var _position = state.position, ch;
  ch = state.input.charCodeAt(_position);
  if ((ch === 45 || ch === 46) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2)) {
    _position += 3;
    ch = state.input.charCodeAt(_position);
    if (ch === 0 || is_WS_OR_EOL(ch)) {
      return true;
    }
  }
  return false;
}
function writeFoldedLines(state, count) {
  if (count === 1) {
    state.result += " ";
  } else if (count > 1) {
    state.result += common.repeat("\n", count - 1);
  }
}
function readPlainScalar(state, nodeIndent, withinFlowCollection) {
  var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
  ch = state.input.charCodeAt(state.position);
  if (is_WS_OR_EOL(ch) || is_FLOW_INDICATOR(ch) || ch === 35 || ch === 38 || ch === 42 || ch === 33 || ch === 124 || ch === 62 || ch === 39 || ch === 34 || ch === 37 || ch === 64 || ch === 96) {
    return false;
  }
  if (ch === 63 || ch === 45) {
    following = state.input.charCodeAt(state.position + 1);
    if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
      return false;
    }
  }
  state.kind = "scalar";
  state.result = "";
  captureStart = captureEnd = state.position;
  hasPendingContent = false;
  while (ch !== 0) {
    if (ch === 58) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
        break;
      }
    } else if (ch === 35) {
      preceding = state.input.charCodeAt(state.position - 1);
      if (is_WS_OR_EOL(preceding)) {
        break;
      }
    } else if (state.position === state.lineStart && testDocumentSeparator(state) || withinFlowCollection && is_FLOW_INDICATOR(ch)) {
      break;
    } else if (is_EOL(ch)) {
      _line = state.line;
      _lineStart = state.lineStart;
      _lineIndent = state.lineIndent;
      skipSeparationSpace(state, false, -1);
      if (state.lineIndent >= nodeIndent) {
        hasPendingContent = true;
        ch = state.input.charCodeAt(state.position);
        continue;
      } else {
        state.position = captureEnd;
        state.line = _line;
        state.lineStart = _lineStart;
        state.lineIndent = _lineIndent;
        break;
      }
    }
    if (hasPendingContent) {
      captureSegment(state, captureStart, captureEnd, false);
      writeFoldedLines(state, state.line - _line);
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
    }
    if (!is_WHITE_SPACE(ch)) {
      captureEnd = state.position + 1;
    }
    ch = state.input.charCodeAt(++state.position);
  }
  captureSegment(state, captureStart, captureEnd, false);
  if (state.result) {
    return true;
  }
  state.kind = _kind;
  state.result = _result;
  return false;
}
function readSingleQuotedScalar(state, nodeIndent) {
  var ch, captureStart, captureEnd;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 39) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 39) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (ch === 39) {
        captureStart = state.position;
        state.position++;
        captureEnd = state.position;
      } else {
        return true;
      }
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, "unexpected end of the document within a single quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError(state, "unexpected end of the stream within a single quoted scalar");
}
function readDoubleQuotedScalar(state, nodeIndent) {
  var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 34) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 34) {
      captureSegment(state, captureStart, state.position, true);
      state.position++;
      return true;
    } else if (ch === 92) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (is_EOL(ch)) {
        skipSeparationSpace(state, false, nodeIndent);
      } else if (ch < 256 && simpleEscapeCheck[ch]) {
        state.result += simpleEscapeMap[ch];
        state.position++;
      } else if ((tmp = escapedHexLen(ch)) > 0) {
        hexLength = tmp;
        hexResult = 0;
        for (; hexLength > 0; hexLength--) {
          ch = state.input.charCodeAt(++state.position);
          if ((tmp = fromHexCode(ch)) >= 0) {
            hexResult = (hexResult << 4) + tmp;
          } else {
            throwError(state, "expected hexadecimal character");
          }
        }
        state.result += charFromCodepoint(hexResult);
        state.position++;
      } else {
        throwError(state, "unknown escape sequence");
      }
      captureStart = captureEnd = state.position;
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, "unexpected end of the document within a double quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError(state, "unexpected end of the stream within a double quoted scalar");
}
function readFlowCollection(state, nodeIndent) {
  var readNext = true, _line, _lineStart, _pos, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = /* @__PURE__ */ Object.create(null), keyNode, keyTag, valueNode, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 91) {
    terminator = 93;
    isMapping = false;
    _result = [];
  } else if (ch === 123) {
    terminator = 125;
    isMapping = true;
    _result = {};
  } else {
    return false;
  }
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(++state.position);
  while (ch !== 0) {
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === terminator) {
      state.position++;
      state.tag = _tag;
      state.anchor = _anchor;
      state.kind = isMapping ? "mapping" : "sequence";
      state.result = _result;
      return true;
    } else if (!readNext) {
      throwError(state, "missed comma between flow collection entries");
    } else if (ch === 44) {
      throwError(state, "expected the node content, but found ','");
    }
    keyTag = keyNode = valueNode = null;
    isPair = isExplicitPair = false;
    if (ch === 63) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following)) {
        isPair = isExplicitPair = true;
        state.position++;
        skipSeparationSpace(state, true, nodeIndent);
      }
    }
    _line = state.line;
    _lineStart = state.lineStart;
    _pos = state.position;
    composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
    keyTag = state.tag;
    keyNode = state.result;
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if ((isExplicitPair || state.line === _line) && ch === 58) {
      isPair = true;
      ch = state.input.charCodeAt(++state.position);
      skipSeparationSpace(state, true, nodeIndent);
      composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
      valueNode = state.result;
    }
    if (isMapping) {
      storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos);
    } else if (isPair) {
      _result.push(storeMappingPair(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos));
    } else {
      _result.push(keyNode);
    }
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === 44) {
      readNext = true;
      ch = state.input.charCodeAt(++state.position);
    } else {
      readNext = false;
    }
  }
  throwError(state, "unexpected end of the stream within a flow collection");
}
function readBlockScalar(state, nodeIndent) {
  var captureStart, folding, chomping = CHOMPING_CLIP, didReadContent = false, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 124) {
    folding = false;
  } else if (ch === 62) {
    folding = true;
  } else {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  while (ch !== 0) {
    ch = state.input.charCodeAt(++state.position);
    if (ch === 43 || ch === 45) {
      if (CHOMPING_CLIP === chomping) {
        chomping = ch === 43 ? CHOMPING_KEEP : CHOMPING_STRIP;
      } else {
        throwError(state, "repeat of a chomping mode identifier");
      }
    } else if ((tmp = fromDecimalCode(ch)) >= 0) {
      if (tmp === 0) {
        throwError(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
      } else if (!detectedIndent) {
        textIndent = nodeIndent + tmp - 1;
        detectedIndent = true;
      } else {
        throwError(state, "repeat of an indentation width identifier");
      }
    } else {
      break;
    }
  }
  if (is_WHITE_SPACE(ch)) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (is_WHITE_SPACE(ch));
    if (ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (!is_EOL(ch) && ch !== 0);
    }
  }
  while (ch !== 0) {
    readLineBreak(state);
    state.lineIndent = 0;
    ch = state.input.charCodeAt(state.position);
    while ((!detectedIndent || state.lineIndent < textIndent) && ch === 32) {
      state.lineIndent++;
      ch = state.input.charCodeAt(++state.position);
    }
    if (!detectedIndent && state.lineIndent > textIndent) {
      textIndent = state.lineIndent;
    }
    if (is_EOL(ch)) {
      emptyLines++;
      continue;
    }
    if (state.lineIndent < textIndent) {
      if (chomping === CHOMPING_KEEP) {
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (chomping === CHOMPING_CLIP) {
        if (didReadContent) {
          state.result += "\n";
        }
      }
      break;
    }
    if (folding) {
      if (is_WHITE_SPACE(ch)) {
        atMoreIndented = true;
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (atMoreIndented) {
        atMoreIndented = false;
        state.result += common.repeat("\n", emptyLines + 1);
      } else if (emptyLines === 0) {
        if (didReadContent) {
          state.result += " ";
        }
      } else {
        state.result += common.repeat("\n", emptyLines);
      }
    } else {
      state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
    }
    didReadContent = true;
    detectedIndent = true;
    emptyLines = 0;
    captureStart = state.position;
    while (!is_EOL(ch) && ch !== 0) {
      ch = state.input.charCodeAt(++state.position);
    }
    captureSegment(state, captureStart, state.position, false);
  }
  return true;
}
function readBlockSequence(state, nodeIndent) {
  var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = false, ch;
  if (state.firstTabInLine !== -1) return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, "tab characters must not be used in indentation");
    }
    if (ch !== 45) {
      break;
    }
    following = state.input.charCodeAt(state.position + 1);
    if (!is_WS_OR_EOL(following)) {
      break;
    }
    detected = true;
    state.position++;
    if (skipSeparationSpace(state, true, -1)) {
      if (state.lineIndent <= nodeIndent) {
        _result.push(null);
        ch = state.input.charCodeAt(state.position);
        continue;
      }
    }
    _line = state.line;
    composeNode(state, nodeIndent, CONTEXT_BLOCK_IN, false, true);
    _result.push(state.result);
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError(state, "bad indentation of a sequence entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "sequence";
    state.result = _result;
    return true;
  }
  return false;
}
function readBlockMapping(state, nodeIndent, flowIndent) {
  var following, allowCompact, _line, _keyLine, _keyLineStart, _keyPos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = /* @__PURE__ */ Object.create(null), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
  if (state.firstTabInLine !== -1) return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (!atExplicitKey && state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, "tab characters must not be used in indentation");
    }
    following = state.input.charCodeAt(state.position + 1);
    _line = state.line;
    if ((ch === 63 || ch === 58) && is_WS_OR_EOL(following)) {
      if (ch === 63) {
        if (atExplicitKey) {
          storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
          keyTag = keyNode = valueNode = null;
        }
        detected = true;
        atExplicitKey = true;
        allowCompact = true;
      } else if (atExplicitKey) {
        atExplicitKey = false;
        allowCompact = true;
      } else {
        throwError(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line");
      }
      state.position += 1;
      ch = following;
    } else {
      _keyLine = state.line;
      _keyLineStart = state.lineStart;
      _keyPos = state.position;
      if (!composeNode(state, flowIndent, CONTEXT_FLOW_OUT, false, true)) {
        break;
      }
      if (state.line === _line) {
        ch = state.input.charCodeAt(state.position);
        while (is_WHITE_SPACE(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        if (ch === 58) {
          ch = state.input.charCodeAt(++state.position);
          if (!is_WS_OR_EOL(ch)) {
            throwError(state, "a whitespace character is expected after the key-value separator within a block mapping");
          }
          if (atExplicitKey) {
            storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
            keyTag = keyNode = valueNode = null;
          }
          detected = true;
          atExplicitKey = false;
          allowCompact = false;
          keyTag = state.tag;
          keyNode = state.result;
        } else if (detected) {
          throwError(state, "can not read an implicit mapping pair; a colon is missed");
        } else {
          state.tag = _tag;
          state.anchor = _anchor;
          return true;
        }
      } else if (detected) {
        throwError(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
      } else {
        state.tag = _tag;
        state.anchor = _anchor;
        return true;
      }
    }
    if (state.line === _line || state.lineIndent > nodeIndent) {
      if (atExplicitKey) {
        _keyLine = state.line;
        _keyLineStart = state.lineStart;
        _keyPos = state.position;
      }
      if (composeNode(state, nodeIndent, CONTEXT_BLOCK_OUT, true, allowCompact)) {
        if (atExplicitKey) {
          keyNode = state.result;
        } else {
          valueNode = state.result;
        }
      }
      if (!atExplicitKey) {
        storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos);
        keyTag = keyNode = valueNode = null;
      }
      skipSeparationSpace(state, true, -1);
      ch = state.input.charCodeAt(state.position);
    }
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError(state, "bad indentation of a mapping entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (atExplicitKey) {
    storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "mapping";
    state.result = _result;
  }
  return detected;
}
function readTagProperty(state) {
  var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 33) return false;
  if (state.tag !== null) {
    throwError(state, "duplication of a tag property");
  }
  ch = state.input.charCodeAt(++state.position);
  if (ch === 60) {
    isVerbatim = true;
    ch = state.input.charCodeAt(++state.position);
  } else if (ch === 33) {
    isNamed = true;
    tagHandle = "!!";
    ch = state.input.charCodeAt(++state.position);
  } else {
    tagHandle = "!";
  }
  _position = state.position;
  if (isVerbatim) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (ch !== 0 && ch !== 62);
    if (state.position < state.length) {
      tagName = state.input.slice(_position, state.position);
      ch = state.input.charCodeAt(++state.position);
    } else {
      throwError(state, "unexpected end of the stream within a verbatim tag");
    }
  } else {
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      if (ch === 33) {
        if (!isNamed) {
          tagHandle = state.input.slice(_position - 1, state.position + 1);
          if (!PATTERN_TAG_HANDLE.test(tagHandle)) {
            throwError(state, "named tag handle cannot contain such characters");
          }
          isNamed = true;
          _position = state.position + 1;
        } else {
          throwError(state, "tag suffix cannot contain exclamation marks");
        }
      }
      ch = state.input.charCodeAt(++state.position);
    }
    tagName = state.input.slice(_position, state.position);
    if (PATTERN_FLOW_INDICATORS.test(tagName)) {
      throwError(state, "tag suffix cannot contain flow indicator characters");
    }
  }
  if (tagName && !PATTERN_TAG_URI.test(tagName)) {
    throwError(state, "tag name cannot contain such characters: " + tagName);
  }
  try {
    tagName = decodeURIComponent(tagName);
  } catch (err) {
    throwError(state, "tag name is malformed: " + tagName);
  }
  if (isVerbatim) {
    state.tag = tagName;
  } else if (_hasOwnProperty$1.call(state.tagMap, tagHandle)) {
    state.tag = state.tagMap[tagHandle] + tagName;
  } else if (tagHandle === "!") {
    state.tag = "!" + tagName;
  } else if (tagHandle === "!!") {
    state.tag = "tag:yaml.org,2002:" + tagName;
  } else {
    throwError(state, 'undeclared tag handle "' + tagHandle + '"');
  }
  return true;
}
function readAnchorProperty(state) {
  var _position, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 38) return false;
  if (state.anchor !== null) {
    throwError(state, "duplication of an anchor property");
  }
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError(state, "name of an anchor node must contain at least one character");
  }
  state.anchor = state.input.slice(_position, state.position);
  return true;
}
function readAlias(state) {
  var _position, alias, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 42) return false;
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError(state, "name of an alias node must contain at least one character");
  }
  alias = state.input.slice(_position, state.position);
  if (!_hasOwnProperty$1.call(state.anchorMap, alias)) {
    throwError(state, 'unidentified alias "' + alias + '"');
  }
  state.result = state.anchorMap[alias];
  skipSeparationSpace(state, true, -1);
  return true;
}
function composeNode(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
  var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, typeList, type2, flowIndent, blockIndent;
  if (state.listener !== null) {
    state.listener("open", state);
  }
  state.tag = null;
  state.anchor = null;
  state.kind = null;
  state.result = null;
  allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT === nodeContext || CONTEXT_BLOCK_IN === nodeContext;
  if (allowToSeek) {
    if (skipSeparationSpace(state, true, -1)) {
      atNewLine = true;
      if (state.lineIndent > parentIndent) {
        indentStatus = 1;
      } else if (state.lineIndent === parentIndent) {
        indentStatus = 0;
      } else if (state.lineIndent < parentIndent) {
        indentStatus = -1;
      }
    }
  }
  if (indentStatus === 1) {
    while (readTagProperty(state) || readAnchorProperty(state)) {
      if (skipSeparationSpace(state, true, -1)) {
        atNewLine = true;
        allowBlockCollections = allowBlockStyles;
        if (state.lineIndent > parentIndent) {
          indentStatus = 1;
        } else if (state.lineIndent === parentIndent) {
          indentStatus = 0;
        } else if (state.lineIndent < parentIndent) {
          indentStatus = -1;
        }
      } else {
        allowBlockCollections = false;
      }
    }
  }
  if (allowBlockCollections) {
    allowBlockCollections = atNewLine || allowCompact;
  }
  if (indentStatus === 1 || CONTEXT_BLOCK_OUT === nodeContext) {
    if (CONTEXT_FLOW_IN === nodeContext || CONTEXT_FLOW_OUT === nodeContext) {
      flowIndent = parentIndent;
    } else {
      flowIndent = parentIndent + 1;
    }
    blockIndent = state.position - state.lineStart;
    if (indentStatus === 1) {
      if (allowBlockCollections && (readBlockSequence(state, blockIndent) || readBlockMapping(state, blockIndent, flowIndent)) || readFlowCollection(state, flowIndent)) {
        hasContent = true;
      } else {
        if (allowBlockScalars && readBlockScalar(state, flowIndent) || readSingleQuotedScalar(state, flowIndent) || readDoubleQuotedScalar(state, flowIndent)) {
          hasContent = true;
        } else if (readAlias(state)) {
          hasContent = true;
          if (state.tag !== null || state.anchor !== null) {
            throwError(state, "alias node should not have any properties");
          }
        } else if (readPlainScalar(state, flowIndent, CONTEXT_FLOW_IN === nodeContext)) {
          hasContent = true;
          if (state.tag === null) {
            state.tag = "?";
          }
        }
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
      }
    } else if (indentStatus === 0) {
      hasContent = allowBlockCollections && readBlockSequence(state, blockIndent);
    }
  }
  if (state.tag === null) {
    if (state.anchor !== null) {
      state.anchorMap[state.anchor] = state.result;
    }
  } else if (state.tag === "?") {
    if (state.result !== null && state.kind !== "scalar") {
      throwError(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
    }
    for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
      type2 = state.implicitTypes[typeIndex];
      if (type2.resolve(state.result)) {
        state.result = type2.construct(state.result);
        state.tag = type2.tag;
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
        break;
      }
    }
  } else if (state.tag !== "!") {
    if (_hasOwnProperty$1.call(state.typeMap[state.kind || "fallback"], state.tag)) {
      type2 = state.typeMap[state.kind || "fallback"][state.tag];
    } else {
      type2 = null;
      typeList = state.typeMap.multi[state.kind || "fallback"];
      for (typeIndex = 0, typeQuantity = typeList.length; typeIndex < typeQuantity; typeIndex += 1) {
        if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
          type2 = typeList[typeIndex];
          break;
        }
      }
    }
    if (!type2) {
      throwError(state, "unknown tag !<" + state.tag + ">");
    }
    if (state.result !== null && type2.kind !== state.kind) {
      throwError(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type2.kind + '", not "' + state.kind + '"');
    }
    if (!type2.resolve(state.result, state.tag)) {
      throwError(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
    } else {
      state.result = type2.construct(state.result, state.tag);
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = state.result;
      }
    }
  }
  if (state.listener !== null) {
    state.listener("close", state);
  }
  return state.tag !== null || state.anchor !== null || hasContent;
}
function readDocument(state) {
  var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
  state.version = null;
  state.checkLineBreaks = state.legacy;
  state.tagMap = /* @__PURE__ */ Object.create(null);
  state.anchorMap = /* @__PURE__ */ Object.create(null);
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if (state.lineIndent > 0 || ch !== 37) {
      break;
    }
    hasDirectives = true;
    ch = state.input.charCodeAt(++state.position);
    _position = state.position;
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      ch = state.input.charCodeAt(++state.position);
    }
    directiveName = state.input.slice(_position, state.position);
    directiveArgs = [];
    if (directiveName.length < 1) {
      throwError(state, "directive name must not be less than one character in length");
    }
    while (ch !== 0) {
      while (is_WHITE_SPACE(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (ch === 35) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (ch !== 0 && !is_EOL(ch));
        break;
      }
      if (is_EOL(ch)) break;
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      directiveArgs.push(state.input.slice(_position, state.position));
    }
    if (ch !== 0) readLineBreak(state);
    if (_hasOwnProperty$1.call(directiveHandlers, directiveName)) {
      directiveHandlers[directiveName](state, directiveName, directiveArgs);
    } else {
      throwWarning(state, 'unknown document directive "' + directiveName + '"');
    }
  }
  skipSeparationSpace(state, true, -1);
  if (state.lineIndent === 0 && state.input.charCodeAt(state.position) === 45 && state.input.charCodeAt(state.position + 1) === 45 && state.input.charCodeAt(state.position + 2) === 45) {
    state.position += 3;
    skipSeparationSpace(state, true, -1);
  } else if (hasDirectives) {
    throwError(state, "directives end mark is expected");
  }
  composeNode(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT, false, true);
  skipSeparationSpace(state, true, -1);
  if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart, state.position))) {
    throwWarning(state, "non-ASCII line breaks are interpreted as content");
  }
  state.documents.push(state.result);
  if (state.position === state.lineStart && testDocumentSeparator(state)) {
    if (state.input.charCodeAt(state.position) === 46) {
      state.position += 3;
      skipSeparationSpace(state, true, -1);
    }
    return;
  }
  if (state.position < state.length - 1) {
    throwError(state, "end of the stream or a document separator is expected");
  } else {
    return;
  }
}
function loadDocuments(input, options) {
  input = String(input);
  options = options || {};
  if (input.length !== 0) {
    if (input.charCodeAt(input.length - 1) !== 10 && input.charCodeAt(input.length - 1) !== 13) {
      input += "\n";
    }
    if (input.charCodeAt(0) === 65279) {
      input = input.slice(1);
    }
  }
  var state = new State$1(input, options);
  var nullpos = input.indexOf("\0");
  if (nullpos !== -1) {
    state.position = nullpos;
    throwError(state, "null byte is not allowed in input");
  }
  state.input += "\0";
  while (state.input.charCodeAt(state.position) === 32) {
    state.lineIndent += 1;
    state.position += 1;
  }
  while (state.position < state.length - 1) {
    readDocument(state);
  }
  return state.documents;
}
function loadAll$1(input, iterator, options) {
  if (iterator !== null && typeof iterator === "object" && typeof options === "undefined") {
    options = iterator;
    iterator = null;
  }
  var documents = loadDocuments(input, options);
  if (typeof iterator !== "function") {
    return documents;
  }
  for (var index = 0, length = documents.length; index < length; index += 1) {
    iterator(documents[index]);
  }
}
function load$1(input, options) {
  var documents = loadDocuments(input, options);
  if (documents.length === 0) {
    return void 0;
  } else if (documents.length === 1) {
    return documents[0];
  }
  throw new exception("expected a single document in the stream, but found more");
}
var loadAll_1 = loadAll$1;
var load_1 = load$1;
var loader = {
  loadAll: loadAll_1,
  load: load_1
};
var _toString = Object.prototype.toString;
var _hasOwnProperty = Object.prototype.hasOwnProperty;
var CHAR_BOM = 65279;
var CHAR_TAB = 9;
var CHAR_LINE_FEED = 10;
var CHAR_CARRIAGE_RETURN = 13;
var CHAR_SPACE = 32;
var CHAR_EXCLAMATION = 33;
var CHAR_DOUBLE_QUOTE = 34;
var CHAR_SHARP = 35;
var CHAR_PERCENT = 37;
var CHAR_AMPERSAND = 38;
var CHAR_SINGLE_QUOTE = 39;
var CHAR_ASTERISK = 42;
var CHAR_COMMA = 44;
var CHAR_MINUS = 45;
var CHAR_COLON = 58;
var CHAR_EQUALS = 61;
var CHAR_GREATER_THAN = 62;
var CHAR_QUESTION = 63;
var CHAR_COMMERCIAL_AT = 64;
var CHAR_LEFT_SQUARE_BRACKET = 91;
var CHAR_RIGHT_SQUARE_BRACKET = 93;
var CHAR_GRAVE_ACCENT = 96;
var CHAR_LEFT_CURLY_BRACKET = 123;
var CHAR_VERTICAL_LINE = 124;
var CHAR_RIGHT_CURLY_BRACKET = 125;
var ESCAPE_SEQUENCES = {};
ESCAPE_SEQUENCES[0] = "\\0";
ESCAPE_SEQUENCES[7] = "\\a";
ESCAPE_SEQUENCES[8] = "\\b";
ESCAPE_SEQUENCES[9] = "\\t";
ESCAPE_SEQUENCES[10] = "\\n";
ESCAPE_SEQUENCES[11] = "\\v";
ESCAPE_SEQUENCES[12] = "\\f";
ESCAPE_SEQUENCES[13] = "\\r";
ESCAPE_SEQUENCES[27] = "\\e";
ESCAPE_SEQUENCES[34] = '\\"';
ESCAPE_SEQUENCES[92] = "\\\\";
ESCAPE_SEQUENCES[133] = "\\N";
ESCAPE_SEQUENCES[160] = "\\_";
ESCAPE_SEQUENCES[8232] = "\\L";
ESCAPE_SEQUENCES[8233] = "\\P";
var DEPRECATED_BOOLEANS_SYNTAX = [
  "y",
  "Y",
  "yes",
  "Yes",
  "YES",
  "on",
  "On",
  "ON",
  "n",
  "N",
  "no",
  "No",
  "NO",
  "off",
  "Off",
  "OFF"
];
var DEPRECATED_BASE60_SYNTAX = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;
function compileStyleMap(schema2, map2) {
  var result, keys5, index, length, tag, style, type2;
  if (map2 === null) return {};
  result = {};
  keys5 = Object.keys(map2);
  for (index = 0, length = keys5.length; index < length; index += 1) {
    tag = keys5[index];
    style = String(map2[tag]);
    if (tag.slice(0, 2) === "!!") {
      tag = "tag:yaml.org,2002:" + tag.slice(2);
    }
    type2 = schema2.compiledTypeMap["fallback"][tag];
    if (type2 && _hasOwnProperty.call(type2.styleAliases, style)) {
      style = type2.styleAliases[style];
    }
    result[tag] = style;
  }
  return result;
}
function encodeHex(character) {
  var string3, handle, length;
  string3 = character.toString(16).toUpperCase();
  if (character <= 255) {
    handle = "x";
    length = 2;
  } else if (character <= 65535) {
    handle = "u";
    length = 4;
  } else if (character <= 4294967295) {
    handle = "U";
    length = 8;
  } else {
    throw new exception("code point within a string may not be greater than 0xFFFFFFFF");
  }
  return "\\" + handle + common.repeat("0", length - string3.length) + string3;
}
var QUOTING_TYPE_SINGLE = 1;
var QUOTING_TYPE_DOUBLE = 2;
function State2(options) {
  this.schema = options["schema"] || _default;
  this.indent = Math.max(1, options["indent"] || 2);
  this.noArrayIndent = options["noArrayIndent"] || false;
  this.skipInvalid = options["skipInvalid"] || false;
  this.flowLevel = common.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
  this.styleMap = compileStyleMap(this.schema, options["styles"] || null);
  this.sortKeys = options["sortKeys"] || false;
  this.lineWidth = options["lineWidth"] || 80;
  this.noRefs = options["noRefs"] || false;
  this.noCompatMode = options["noCompatMode"] || false;
  this.condenseFlow = options["condenseFlow"] || false;
  this.quotingType = options["quotingType"] === '"' ? QUOTING_TYPE_DOUBLE : QUOTING_TYPE_SINGLE;
  this.forceQuotes = options["forceQuotes"] || false;
  this.replacer = typeof options["replacer"] === "function" ? options["replacer"] : null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.explicitTypes = this.schema.compiledExplicit;
  this.tag = null;
  this.result = "";
  this.duplicates = [];
  this.usedDuplicates = null;
}
function indentString(string3, spaces) {
  var ind = common.repeat(" ", spaces), position = 0, next = -1, result = "", line, length = string3.length;
  while (position < length) {
    next = string3.indexOf("\n", position);
    if (next === -1) {
      line = string3.slice(position);
      position = length;
    } else {
      line = string3.slice(position, next + 1);
      position = next + 1;
    }
    if (line.length && line !== "\n") result += ind;
    result += line;
  }
  return result;
}
function generateNextLine(state, level) {
  return "\n" + common.repeat(" ", state.indent * level);
}
function testImplicitResolving(state, str2) {
  var index, length, type2;
  for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
    type2 = state.implicitTypes[index];
    if (type2.resolve(str2)) {
      return true;
    }
  }
  return false;
}
function isWhitespace(c) {
  return c === CHAR_SPACE || c === CHAR_TAB;
}
function isPrintable(c) {
  return 32 <= c && c <= 126 || 161 <= c && c <= 55295 && c !== 8232 && c !== 8233 || 57344 <= c && c <= 65533 && c !== CHAR_BOM || 65536 <= c && c <= 1114111;
}
function isNsCharOrWhitespace(c) {
  return isPrintable(c) && c !== CHAR_BOM && c !== CHAR_CARRIAGE_RETURN && c !== CHAR_LINE_FEED;
}
function isPlainSafe(c, prev, inblock) {
  var cIsNsCharOrWhitespace = isNsCharOrWhitespace(c);
  var cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace(c);
  return (
    // ns-plain-safe
    (inblock ? (
      // c = flow-in
      cIsNsCharOrWhitespace
    ) : cIsNsCharOrWhitespace && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET) && c !== CHAR_SHARP && !(prev === CHAR_COLON && !cIsNsChar) || isNsCharOrWhitespace(prev) && !isWhitespace(prev) && c === CHAR_SHARP || prev === CHAR_COLON && cIsNsChar
  );
}
function isPlainSafeFirst(c) {
  return isPrintable(c) && c !== CHAR_BOM && !isWhitespace(c) && c !== CHAR_MINUS && c !== CHAR_QUESTION && c !== CHAR_COLON && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET && c !== CHAR_SHARP && c !== CHAR_AMPERSAND && c !== CHAR_ASTERISK && c !== CHAR_EXCLAMATION && c !== CHAR_VERTICAL_LINE && c !== CHAR_EQUALS && c !== CHAR_GREATER_THAN && c !== CHAR_SINGLE_QUOTE && c !== CHAR_DOUBLE_QUOTE && c !== CHAR_PERCENT && c !== CHAR_COMMERCIAL_AT && c !== CHAR_GRAVE_ACCENT;
}
function isPlainSafeLast(c) {
  return !isWhitespace(c) && c !== CHAR_COLON;
}
function codePointAt(string3, pos) {
  var first = string3.charCodeAt(pos), second;
  if (first >= 55296 && first <= 56319 && pos + 1 < string3.length) {
    second = string3.charCodeAt(pos + 1);
    if (second >= 56320 && second <= 57343) {
      return (first - 55296) * 1024 + second - 56320 + 65536;
    }
  }
  return first;
}
function needIndentIndicator(string3) {
  var leadingSpaceRe = /^\n* /;
  return leadingSpaceRe.test(string3);
}
var STYLE_PLAIN = 1;
var STYLE_SINGLE = 2;
var STYLE_LITERAL = 3;
var STYLE_FOLDED = 4;
var STYLE_DOUBLE = 5;
function chooseScalarStyle(string3, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType, quotingType, forceQuotes, inblock) {
  var i;
  var char = 0;
  var prevChar = null;
  var hasLineBreak = false;
  var hasFoldableLine = false;
  var shouldTrackWidth = lineWidth !== -1;
  var previousLineBreak = -1;
  var plain = isPlainSafeFirst(codePointAt(string3, 0)) && isPlainSafeLast(codePointAt(string3, string3.length - 1));
  if (singleLineOnly || forceQuotes) {
    for (i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
      char = codePointAt(string3, i);
      if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
  } else {
    for (i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
      char = codePointAt(string3, i);
      if (char === CHAR_LINE_FEED) {
        hasLineBreak = true;
        if (shouldTrackWidth) {
          hasFoldableLine = hasFoldableLine || // Foldable line = too long, and not more-indented.
          i - previousLineBreak - 1 > lineWidth && string3[previousLineBreak + 1] !== " ";
          previousLineBreak = i;
        }
      } else if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
    hasFoldableLine = hasFoldableLine || shouldTrackWidth && (i - previousLineBreak - 1 > lineWidth && string3[previousLineBreak + 1] !== " ");
  }
  if (!hasLineBreak && !hasFoldableLine) {
    if (plain && !forceQuotes && !testAmbiguousType(string3)) {
      return STYLE_PLAIN;
    }
    return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
  }
  if (indentPerLevel > 9 && needIndentIndicator(string3)) {
    return STYLE_DOUBLE;
  }
  if (!forceQuotes) {
    return hasFoldableLine ? STYLE_FOLDED : STYLE_LITERAL;
  }
  return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
}
function writeScalar(state, string3, level, iskey, inblock) {
  state.dump = function() {
    if (string3.length === 0) {
      return state.quotingType === QUOTING_TYPE_DOUBLE ? '""' : "''";
    }
    if (!state.noCompatMode) {
      if (DEPRECATED_BOOLEANS_SYNTAX.indexOf(string3) !== -1 || DEPRECATED_BASE60_SYNTAX.test(string3)) {
        return state.quotingType === QUOTING_TYPE_DOUBLE ? '"' + string3 + '"' : "'" + string3 + "'";
      }
    }
    var indent = state.indent * Math.max(1, level);
    var lineWidth = state.lineWidth === -1 ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);
    var singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
    function testAmbiguity(string4) {
      return testImplicitResolving(state, string4);
    }
    switch (chooseScalarStyle(
      string3,
      singleLineOnly,
      state.indent,
      lineWidth,
      testAmbiguity,
      state.quotingType,
      state.forceQuotes && !iskey,
      inblock
    )) {
      case STYLE_PLAIN:
        return string3;
      case STYLE_SINGLE:
        return "'" + string3.replace(/'/g, "''") + "'";
      case STYLE_LITERAL:
        return "|" + blockHeader(string3, state.indent) + dropEndingNewline(indentString(string3, indent));
      case STYLE_FOLDED:
        return ">" + blockHeader(string3, state.indent) + dropEndingNewline(indentString(foldString(string3, lineWidth), indent));
      case STYLE_DOUBLE:
        return '"' + escapeString(string3) + '"';
      default:
        throw new exception("impossible error: invalid scalar style");
    }
  }();
}
function blockHeader(string3, indentPerLevel) {
  var indentIndicator = needIndentIndicator(string3) ? String(indentPerLevel) : "";
  var clip = string3[string3.length - 1] === "\n";
  var keep = clip && (string3[string3.length - 2] === "\n" || string3 === "\n");
  var chomp = keep ? "+" : clip ? "" : "-";
  return indentIndicator + chomp + "\n";
}
function dropEndingNewline(string3) {
  return string3[string3.length - 1] === "\n" ? string3.slice(0, -1) : string3;
}
function foldString(string3, width) {
  var lineRe = /(\n+)([^\n]*)/g;
  var result = function() {
    var nextLF = string3.indexOf("\n");
    nextLF = nextLF !== -1 ? nextLF : string3.length;
    lineRe.lastIndex = nextLF;
    return foldLine(string3.slice(0, nextLF), width);
  }();
  var prevMoreIndented = string3[0] === "\n" || string3[0] === " ";
  var moreIndented;
  var match;
  while (match = lineRe.exec(string3)) {
    var prefix = match[1], line = match[2];
    moreIndented = line[0] === " ";
    result += prefix + (!prevMoreIndented && !moreIndented && line !== "" ? "\n" : "") + foldLine(line, width);
    prevMoreIndented = moreIndented;
  }
  return result;
}
function foldLine(line, width) {
  if (line === "" || line[0] === " ") return line;
  var breakRe = / [^ ]/g;
  var match;
  var start = 0, end, curr = 0, next = 0;
  var result = "";
  while (match = breakRe.exec(line)) {
    next = match.index;
    if (next - start > width) {
      end = curr > start ? curr : next;
      result += "\n" + line.slice(start, end);
      start = end + 1;
    }
    curr = next;
  }
  result += "\n";
  if (line.length - start > width && curr > start) {
    result += line.slice(start, curr) + "\n" + line.slice(curr + 1);
  } else {
    result += line.slice(start);
  }
  return result.slice(1);
}
function escapeString(string3) {
  var result = "";
  var char = 0;
  var escapeSeq;
  for (var i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
    char = codePointAt(string3, i);
    escapeSeq = ESCAPE_SEQUENCES[char];
    if (!escapeSeq && isPrintable(char)) {
      result += string3[i];
      if (char >= 65536) result += string3[i + 1];
    } else {
      result += escapeSeq || encodeHex(char);
    }
  }
  return result;
}
function writeFlowSequence(state, level, object3) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object3.length; index < length; index += 1) {
    value = object3[index];
    if (state.replacer) {
      value = state.replacer.call(object3, String(index), value);
    }
    if (writeNode(state, level, value, false, false) || typeof value === "undefined" && writeNode(state, level, null, false, false)) {
      if (_result !== "") _result += "," + (!state.condenseFlow ? " " : "");
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = "[" + _result + "]";
}
function writeBlockSequence(state, level, object3, compact2) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object3.length; index < length; index += 1) {
    value = object3[index];
    if (state.replacer) {
      value = state.replacer.call(object3, String(index), value);
    }
    if (writeNode(state, level + 1, value, true, true, false, true) || typeof value === "undefined" && writeNode(state, level + 1, null, true, true, false, true)) {
      if (!compact2 || _result !== "") {
        _result += generateNextLine(state, level);
      }
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        _result += "-";
      } else {
        _result += "- ";
      }
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = _result || "[]";
}
function writeFlowMapping(state, level, object3) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, pairBuffer;
  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = "";
    if (_result !== "") pairBuffer += ", ";
    if (state.condenseFlow) pairBuffer += '"';
    objectKey = objectKeyList[index];
    objectValue = object3[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object3, objectKey, objectValue);
    }
    if (!writeNode(state, level, objectKey, false, false)) {
      continue;
    }
    if (state.dump.length > 1024) pairBuffer += "? ";
    pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " ");
    if (!writeNode(state, level, objectValue, false, false)) {
      continue;
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = "{" + _result + "}";
}
function writeBlockMapping(state, level, object3, compact2) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, explicitPair, pairBuffer;
  if (state.sortKeys === true) {
    objectKeyList.sort();
  } else if (typeof state.sortKeys === "function") {
    objectKeyList.sort(state.sortKeys);
  } else if (state.sortKeys) {
    throw new exception("sortKeys must be a boolean or a function");
  }
  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = "";
    if (!compact2 || _result !== "") {
      pairBuffer += generateNextLine(state, level);
    }
    objectKey = objectKeyList[index];
    objectValue = object3[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object3, objectKey, objectValue);
    }
    if (!writeNode(state, level + 1, objectKey, true, true, true)) {
      continue;
    }
    explicitPair = state.tag !== null && state.tag !== "?" || state.dump && state.dump.length > 1024;
    if (explicitPair) {
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        pairBuffer += "?";
      } else {
        pairBuffer += "? ";
      }
    }
    pairBuffer += state.dump;
    if (explicitPair) {
      pairBuffer += generateNextLine(state, level);
    }
    if (!writeNode(state, level + 1, objectValue, true, explicitPair)) {
      continue;
    }
    if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
      pairBuffer += ":";
    } else {
      pairBuffer += ": ";
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = _result || "{}";
}
function detectType(state, object3, explicit) {
  var _result, typeList, index, length, type2, style;
  typeList = explicit ? state.explicitTypes : state.implicitTypes;
  for (index = 0, length = typeList.length; index < length; index += 1) {
    type2 = typeList[index];
    if ((type2.instanceOf || type2.predicate) && (!type2.instanceOf || typeof object3 === "object" && object3 instanceof type2.instanceOf) && (!type2.predicate || type2.predicate(object3))) {
      if (explicit) {
        if (type2.multi && type2.representName) {
          state.tag = type2.representName(object3);
        } else {
          state.tag = type2.tag;
        }
      } else {
        state.tag = "?";
      }
      if (type2.represent) {
        style = state.styleMap[type2.tag] || type2.defaultStyle;
        if (_toString.call(type2.represent) === "[object Function]") {
          _result = type2.represent(object3, style);
        } else if (_hasOwnProperty.call(type2.represent, style)) {
          _result = type2.represent[style](object3, style);
        } else {
          throw new exception("!<" + type2.tag + '> tag resolver accepts not "' + style + '" style');
        }
        state.dump = _result;
      }
      return true;
    }
  }
  return false;
}
function writeNode(state, level, object3, block, compact2, iskey, isblockseq) {
  state.tag = null;
  state.dump = object3;
  if (!detectType(state, object3, false)) {
    detectType(state, object3, true);
  }
  var type2 = _toString.call(state.dump);
  var inblock = block;
  var tagStr;
  if (block) {
    block = state.flowLevel < 0 || state.flowLevel > level;
  }
  var objectOrArray = type2 === "[object Object]" || type2 === "[object Array]", duplicateIndex, duplicate;
  if (objectOrArray) {
    duplicateIndex = state.duplicates.indexOf(object3);
    duplicate = duplicateIndex !== -1;
  }
  if (state.tag !== null && state.tag !== "?" || duplicate || state.indent !== 2 && level > 0) {
    compact2 = false;
  }
  if (duplicate && state.usedDuplicates[duplicateIndex]) {
    state.dump = "*ref_" + duplicateIndex;
  } else {
    if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
      state.usedDuplicates[duplicateIndex] = true;
    }
    if (type2 === "[object Object]") {
      if (block && Object.keys(state.dump).length !== 0) {
        writeBlockMapping(state, level, state.dump, compact2);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowMapping(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type2 === "[object Array]") {
      if (block && state.dump.length !== 0) {
        if (state.noArrayIndent && !isblockseq && level > 0) {
          writeBlockSequence(state, level - 1, state.dump, compact2);
        } else {
          writeBlockSequence(state, level, state.dump, compact2);
        }
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowSequence(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type2 === "[object String]") {
      if (state.tag !== "?") {
        writeScalar(state, state.dump, level, iskey, inblock);
      }
    } else if (type2 === "[object Undefined]") {
      return false;
    } else {
      if (state.skipInvalid) return false;
      throw new exception("unacceptable kind of an object to dump " + type2);
    }
    if (state.tag !== null && state.tag !== "?") {
      tagStr = encodeURI(
        state.tag[0] === "!" ? state.tag.slice(1) : state.tag
      ).replace(/!/g, "%21");
      if (state.tag[0] === "!") {
        tagStr = "!" + tagStr;
      } else if (tagStr.slice(0, 18) === "tag:yaml.org,2002:") {
        tagStr = "!!" + tagStr.slice(18);
      } else {
        tagStr = "!<" + tagStr + ">";
      }
      state.dump = tagStr + " " + state.dump;
    }
  }
  return true;
}
function getDuplicateReferences(object3, state) {
  var objects = [], duplicatesIndexes = [], index, length;
  inspectNode(object3, objects, duplicatesIndexes);
  for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
    state.duplicates.push(objects[duplicatesIndexes[index]]);
  }
  state.usedDuplicates = new Array(length);
}
function inspectNode(object3, objects, duplicatesIndexes) {
  var objectKeyList, index, length;
  if (object3 !== null && typeof object3 === "object") {
    index = objects.indexOf(object3);
    if (index !== -1) {
      if (duplicatesIndexes.indexOf(index) === -1) {
        duplicatesIndexes.push(index);
      }
    } else {
      objects.push(object3);
      if (Array.isArray(object3)) {
        for (index = 0, length = object3.length; index < length; index += 1) {
          inspectNode(object3[index], objects, duplicatesIndexes);
        }
      } else {
        objectKeyList = Object.keys(object3);
        for (index = 0, length = objectKeyList.length; index < length; index += 1) {
          inspectNode(object3[objectKeyList[index]], objects, duplicatesIndexes);
        }
      }
    }
  }
}
function dump$1(input, options) {
  options = options || {};
  var state = new State2(options);
  if (!state.noRefs) getDuplicateReferences(input, state);
  var value = input;
  if (state.replacer) {
    value = state.replacer.call({ "": value }, "", value);
  }
  if (writeNode(state, 0, value, true, true)) return state.dump + "\n";
  return "";
}
var dump_1 = dump$1;
var dumper = {
  dump: dump_1
};
function renamed(from, to) {
  return function() {
    throw new Error("Function yaml." + from + " is removed in js-yaml 4. Use yaml." + to + " instead, which is now safe by default.");
  };
}
var Type2 = type;
var Schema2 = schema;
var FAILSAFE_SCHEMA = failsafe;
var JSON_SCHEMA = json;
var CORE_SCHEMA = core;
var DEFAULT_SCHEMA = _default;
var load = loader.load;
var loadAll = loader.loadAll;
var dump = dumper.dump;
var YAMLException = exception;
var types = {
  binary,
  float,
  map,
  null: _null,
  pairs,
  set: set3,
  timestamp,
  bool,
  int,
  merge,
  omap,
  seq,
  str
};
var safeLoad = renamed("safeLoad", "load");
var safeLoadAll = renamed("safeLoadAll", "loadAll");
var safeDump = renamed("safeDump", "dump");
var jsYaml = {
  Type: Type2,
  Schema: Schema2,
  FAILSAFE_SCHEMA,
  JSON_SCHEMA,
  CORE_SCHEMA,
  DEFAULT_SCHEMA,
  load,
  loadAll,
  dump,
  YAMLException,
  types,
  safeLoad,
  safeLoadAll,
  safeDump
};
var js_yaml_default = jsYaml;

// ../../cli/workspace/commons/lib/openapi/BaseOpenAPIWorkspace.js
var BaseOpenAPIWorkspace = class extends AbstractAPIWorkspace {
  inlinePathParameters;
  objectQueryParameters;
  onlyIncludeReferencedSchemas;
  respectReadonlySchemas;
  constructor(args) {
    super(args);
    this.inlinePathParameters = args.inlinePathParameters;
    this.objectQueryParameters = args.objectQueryParameters;
    this.onlyIncludeReferencedSchemas = args.onlyIncludeReferencedSchemas;
    this.respectReadonlySchemas = args.respectReadonlySchemas;
  }
  async getDefinition({ context, absoluteFilePath, relativePathToDependency }, settings) {
    const openApiIr = await this.getOpenAPIIr({ context, relativePathToDependency }, settings);
    const definition = convert({
      authOverrides: this.generatorsConfiguration?.api?.auth != null ? { ...this.generatorsConfiguration?.api } : void 0,
      environmentOverrides: this.generatorsConfiguration?.api?.environments != null ? { ...this.generatorsConfiguration?.api } : void 0,
      globalHeaderOverrides: this.generatorsConfiguration?.api?.headers != null ? { ...this.generatorsConfiguration?.api } : void 0,
      taskContext: context,
      ir: openApiIr,
      enableUniqueErrorsPerEndpoint: settings?.enableUniqueErrorsPerEndpoint ?? false,
      detectGlobalHeaders: settings?.detectGlobalHeaders ?? true,
      objectQueryParameters: this.objectQueryParameters,
      respectReadonlySchemas: this.respectReadonlySchemas,
      onlyIncludeReferencedSchemas: this.onlyIncludeReferencedSchemas,
      inlinePathParameters: this.inlinePathParameters
    });
    return {
      absoluteFilePath: absoluteFilePath ?? this.absoluteFilePath,
      rootApiFile: {
        defaultUrl: definition.rootApiFile["default-url"],
        contents: definition.rootApiFile,
        rawContents: js_yaml_default.dump(definition.rootApiFile)
      },
      namedDefinitionFiles: {
        ...mapValues_default(definition.definitionFiles, (definitionFile) => ({
          absoluteFilepath: absoluteFilePath ?? this.absoluteFilePath,
          rawContents: js_yaml_default.dump(definitionFile),
          contents: definitionFile
        })),
        [RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME)]: {
          absoluteFilepath: absoluteFilePath ?? this.absoluteFilePath,
          rawContents: js_yaml_default.dump(definition.packageMarkerFile),
          contents: definition.packageMarkerFile
        }
      },
      packageMarkers: {},
      importedDefinitions: {}
    };
  }
  async toFernWorkspace({ context }, settings) {
    const definition = await this.getDefinition({ context }, settings);
    return new FernWorkspace({
      absoluteFilePath: this.absoluteFilePath,
      workspaceName: this.workspaceName,
      generatorsConfiguration: this.generatorsConfiguration,
      dependenciesConfiguration: {
        dependencies: {}
      },
      definition,
      cliVersion: this.cliVersion
    });
  }
};

// ../../cli/workspace/commons/lib/openapi/getOptionsOverridesFromSettings.js
function getOptionsOverridesFromSettings(settings) {
  if (settings == null) {
    return void 0;
  }
  const result = {};
  if (settings.enableDiscriminatedUnionV2) {
    result.discriminatedUnionV2 = true;
  }
  if (settings.optionalAdditionalProperties) {
    result.optionalAdditionalProperties = true;
  }
  if (settings.cooerceEnumsToLiterals) {
    result.cooerceEnumsToLiterals = true;
  }
  if (settings.preserveSchemaIds) {
    result.preserveSchemaIds = true;
  }
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/options.js
var DEFAULT_PARSE_ASYNCAPI_SETTINGS = {
  naming: "v1"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/getExtension.js
function getExtension(object3, extension) {
  const extensions = Array.isArray(extension) ? extension : [extension];
  for (const extension2 of extensions) {
    const extensionValue = object3[extension2];
    if (extensionValue != null) {
      return extensionValue;
    }
  }
  return void 0;
}
function getExtensionAndValidate(object3, extension, schema2, logger, breadcrumbs = []) {
  try {
    const extensionValue = getExtension(object3, extension);
    if (extensionValue != null) {
      return schema2.parse(extensionValue);
    }
  } catch (e) {
    const breadcrumb = compact_default(breadcrumbs).join(" -> ");
    logger.error(`${breadcrumb.length > 0 ? `${breadcrumb}: ` : ""}Failed to parse ${extension}`);
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/id.js
var TypedExtensionId = {
  of(key) {
    return key;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/fernExtensions.js
var XFernStreaming = {
  properties: {
    "stream-condition": { type: "string" },
    response: "Schema",
    "response-stream": "Schema"
  },
  required: ["stream-condition", "response", "response-stream"],
  extensionsPrefix: "x-"
};
var FERN_TYPE_EXTENSIONS = {
  id: "",
  typeExtension: {
    oas3: (types2) => {
      return {
        ...types2,
        XFernStreaming,
        Operation: {
          ...types2.Operation,
          properties: {
            ...types2.Operation?.properties,
            "x-fern-streaming": "XFernStreaming"
          }
        }
      };
    }
  }
};
var FernOpenAPIExtension = {
  SDK_METHOD_NAME: TypedExtensionId.of("x-fern-sdk-method-name"),
  SDK_GROUP_NAME: TypedExtensionId.of("x-fern-sdk-group-name"),
  REQUEST_NAME_V1: "x-request-name",
  REQUEST_NAME_V2: "x-fern-request-name",
  TYPE_NAME: "x-fern-type-name",
  BOOLEAN_LITERAL: "x-fern-boolean-literal",
  SERVER_NAME_V1: "x-name",
  SERVER_NAME_V2: "x-fern-server-name",
  /**
   * Prepends the configured base path to all of the endpoint paths.
   *
   * x-fern-base-path: /v1
   * servers:
   *   - url: https://api.example.com
   * paths:
   *   /path/to/my/endpoint:
   */
  BASE_PATH: "x-fern-base-path",
  /**
   * Should align with the OpenAPI spec's `x-fern-sdk-group-name` extension.
   * This is a place where you can specify any display names related to the
   * configured SDK group names. These display names and descriptions will
   * come through in the docs.
   *
   * x-fern-groups:
   *  group1:
   *    display-name: Group 1
   *    description: This is group 1
   *    groups:
   *      group2 # add child groups
   */
  GROUPS: TypedExtensionId.of("x-fern-groups"),
  /**
   * Filepath that contains any OpenAPI overrides
   * that you wan't Fern to add on top of your existing spec.
   *
   * x-fern-overrides-filepath: relative/path/to/file
   */
  OPENAPI_OVERIDES_FILEPATH: "x-fern-overrides-filepath",
  /**
   * Used to override the type with fern's type syntax
   * Bar:
   *  properties:
   *    createdDate:
   *      type: string
   *      x-fern-type: datetime
   *      x-fern-type:
   *        properties:
   *         a: string
   *         b: integer
   *      x-fern-type: optional<map<string, integer>>
   */
  TYPE_DEFINITION: "x-fern-type",
  /**
   * Used to specify if an endpoint should be generated
   * as a streaming endpoint.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-streaming: true
   *
   * Used to specify if an endpoint should be generated
   * as a streaming endpoint with sever-sent0events.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-streaming:
   *          format: sse
   *
   * Alternatively, you can annotate the endpoint so that
   * it generates both a traditional unary endpoint,
   * as well as its streaming equivalent. The stream
   * condition property is included to specify a boolean
   * propetry that tells the server whether or not the
   * response should be streamed or not.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-streaming:
   *         format: sse # or json
   *         stream-condition: $request.stream
   *         stream-description: A description
   *         response:
   *           $ref: ./path/to/response/type.yaml
   *         response-stream:
   *           $ref: ./path/to/response-stream/type.yaml
   */
  STREAMING: "x-fern-streaming",
  /**
   * Used to specify if an endpoint should be generated
   * as a paginated endpoint. Both cursor and offset pagination
   * examples are shown below.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-pagination:
   *         cursor: $request.cursor
   *         next_cursor: $response.next
   *         results: $response.results
   *
   * Alternatively, if the configuration shown above is
   * specified at the document-level, paths can inherit the
   * configuration by setting the extension to true.
   *
   * Example usage:
   *   x-fern-pagination:
   *     offset: $request.page_number
   *     results: $response.results
   *
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-pagination: true
   */
  PAGINATION: "x-fern-pagination",
  /**
   * Used to specify if an endpoint is actually
   * representing a webhook
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-webhook: true
   */
  WEBHOOK: "x-fern-webhook",
  /**
   * Used to detect if an endpoint has an async version of it
   * Example usage:
   *   paths:
   *    /path/to/my/endpoint:
   *      x-fern-async-config:
   *        discriminant:
   *          type: header
   *          name: X-Header-Name
   *          value: async
   *        response-status-code: 202
   **/
  ASYNC_CONFIG: "x-fern-async-config",
  /**
   * Used to create veriables in the fern definition
   * Example usage:
   * x-fern-sdk-variables:
   *   appName:
   *     type: string
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     parameters:
   *       - name: id
   *         in: path
   *         type: string
   *         x-fern-sdk-variable: appName
   */
  SDK_VARIABLES: "x-fern-sdk-variables",
  SDK_VARIABLE: "x-fern-sdk-variable",
  /**
   * Used to customize the name of the parameter used for a header.
   * Example usage:
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     parameters:
   *       - in: header
   *         name: X-Fern-Version
   *         type: string
   *         x-fern-parameter-name: version
   */
  PARAMETER_NAME: "x-fern-parameter-name",
  /**
   * securitySchemes:
   *   Basic:
   *     scheme: http
   *     type: basic
   *     x-fern-username-variable-name: clientId
   *     x-fern-password-variable-name: clientSecret
   */
  BASIC_AUTH_USERNAME_VARIABLE_NAME: "x-fern-username-variable-name",
  BASIC_AUTH_PASSWORD_VARIABLE_NAME: "x-fern-password-variable-name",
  /**
   * securitySchemes:
   *   Bearer:
   *     scheme: http
   *     type: bearer
   *     x-fern-token-variable-name: apiKey
   */
  BEARER_TOKEN_VARIABLE_NAME: "x-fern-token-variable-name",
  /**
   * securitySchemes:
   *   Bearer:
   *     type: apiKey
   *     in: header
   *     name: X-API-KEY-ID
   *     x-fern-header-variable-name: apiKeyId
   */
  HEADER_VARIABLE_NAME: "x-fern-header-variable-name",
  /**
   * The x-fern-enum allows you to specify docs for the enum value.
   * If your enum is not codegen friendly (not alphanumeric), then you can specify a codegen name as well.
   *
   * MyEnum:
   *   enum:
   *     - VARIANT_ONE
   *     - VARIANT_TWO
   *   x-fern-enum:
   *     VARIANT_ONE:
   *       description: These are docs about the enum
   *       name: ONE
   */
  FERN_ENUM: "x-fern-enum",
  /**
   * Used to mark operations with audiences
   *
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     x-fern-audiences:
   *       - external
   */
  AUDIENCES: "x-fern-audiences",
  /**
   * Used to tell fern to ignore endpoints.
   *
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     get:
   *       x-fern-ignore: true
   */
  IGNORE: "x-fern-ignore",
  /**
   * paths:
   *  /path/to/my:
   *    get:
   *      x-fern-availability: ga # or beta, generally-available, deprecated,
   */
  AVAILABILITY: "x-fern-availability",
  /**
   * Used to signal that the SDK should return a specific property on the response.
   *
   * paths:
   *  /path/to/my:
   *    get:
   *      x-fern-sdk-return-value: data
   */
  RESPONSE_PROPERTY: "x-fern-sdk-return-value",
  /**
   * Used to resolve multiple schemas into a single schema. All the references
   * are replaced with a single schema.
   *
   * x-fern-resolutions:
   *  - name: User
   *    resolutions:
   *      - `#/components/schemas/Group/properties/user`
   *      - `#/components/schemas/User`
   */
  RESOLUTIONS: "x-fern-resolutions",
  /**
   * paths:
   *  /path/to/my:
   *    get:
   *     x-fern-examples:
   *      - name: Example 1
   *        docs: This is an example
   *        request: {}
   *        response:
   *          body: {}
   *        code-samples:
   *          - language: typescript
   *            install: npm install my-client
   *            code: |
   *              import { MyClient } from "my-client";
   *              const client = new MyClient();
   *              const response = await client.myEndpoint();
   *              console.log(response);
   *            name: Console Log My Endpoint
   *            description: This is a code sample that logs the response
   */
  EXAMPLES: "x-fern-examples",
  /**
   * securitySchemes:
   *   Bearer:
   *     scheme: http
   *     type: bearer
   *     x-fern-bearer:
   *       name: apiKey
   *       env: MY_AUTH_TOKEN
   */
  FERN_BEARER_TOKEN: "x-fern-bearer",
  /**
   * securitySchemes:
   *   Bearer:
   *     type: apiKey
   *     in: header
   *     name: X-API-KEY-ID
   *     x-fern-header:
   *       name: header
   *       env: MY_AUTH_TOKEN
   */
  FERN_HEADER_AUTH: "x-fern-header",
  /**
   * securitySchemes:
   *   Basic:
   *     scheme: http
   *     type: basic
   *     x-fern-basic:
   *       username:
   *          name: username
   *          env: MY_USERNAME
   *       password:
   *          name: password
   *          env: MY_PASSWORD
   */
  FERN_BASIC_AUTH: "x-fern-basic",
  /**
   * Allows users to specify which headers are global, and an optional alias for them
   * `header` is the name of the header used throughout your spec, while `name` is the
   * alias you'd like it to appear as within your generated SDK to the consumer.
   *
   * x-fern-global-headers:
   *  - header: our_api_key
   *    name: api_key
   *    optional: true
   *  - header: telemetry_id
   *    env: MY_ENVVAR
   *  - header: X-API-Version
   *    name: version
   *    type: literal<"2.10"> # The type of the header to use
   */
  FERN_GLOBAL_HEADERS: "x-fern-global-headers",
  /**
   * Allows users to specify which headers are idempotent.
   *
   * x-fern-idempotency-headers:
   *  - header: our_api_key
   *    name: api_key
   *    optional: true
   *  - header: telemetry_id
   *    env: MY_ENVVAR
   *  - header: X-API-Version
   *    name: version
   *    type: literal<"2.10"> # The type of the header to use
   */
  FERN_IDEMPOTENCY_HEADERS: "x-fern-idempotency-headers",
  /**
   * Mark a particular endpoint as idempotent.
   *
   * paths:
   *  send:
   *    post:
   *      x-fern-idempotent: true
   */
  IDEMPOTENT: "x-fern-idempotent",
  /**
   * Allows a user to configure the property name for the schema.
   */
  FERN_PROPERTY_NAME: "x-fern-property-name",
  /**
   * Allows a user to configure that a union wiht a discriminant should
   * be undiscriminated.
   *
   * Shape:
   *   x-fern-undiscriminated: true
   *   oneOf:
   *    - $ref: components/schemas/Triangle
   *    - $ref: components/schemas/Square
   */
  IS_UNDISCRIMINATED: "x-fern-undiscriminated",
  /**
   * Allows users to specify the version scheme supported by the API.
   *
   * x-fern-version:
   *   header: X-API-Version
   *   default: "2.0"
   *   values:
   *     - "1.0"
   *     - "2.0"
   *     - "Latest"
   */
  FERN_VERSION: "x-fern-version",
  /**
   * Allows users to specify the encoding of the type. For example, suppose you need to configure
   * Protobuf-encoding details like the following:
   *
   * User:
   *  properties:
   *    username:
   *      type: string
   *  x-fern-encoding:
   *    proto:
   *      type: user.v1.User
   */
  ENCODING: "x-fern-encoding",
  /**
   * Allows users to configure gRPC services. This must be specified on individual service
   * declarations.
   *
   * x-fern-transport:
   *   grpc:
   *     service-name: UserService
   */
  TRANSPORT: "x-fern-transport"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/isReferenceObject.js
function isReferenceObject(parameter) {
  return parameter.$ref != null;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertAvailability.js
function convertAvailability3(propertySchema) {
  switch (getExtension(propertySchema, FernOpenAPIExtension.AVAILABILITY)) {
    case "deprecated":
      return Availability.Deprecated;
    case "beta":
      return Availability.Beta;
    case "generally-available":
      return Availability.GenerallyAvailable;
    default:
      break;
  }
  if (!isReferenceObject(propertySchema) && propertySchema.deprecated) {
    return Availability.Deprecated;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/extensions.js
var OpenAPIExtension = {
  BEARER_FORMAT: "x-bearer-format",
  /* This is an extension that several OpenAPI generators use that we support */
  ENUM_VAR_NAMES: "x-enum-varnames",
  /* This extension is a boolean that several generators use */
  INTERNAL: "x-internal",
  /* This extension is used for specifying examples */
  EXAMPLES: "x-examples",
  /* This extension is used for specifying tags on schemas*/
  TAGS: "x-tags",
  /* https://redocly.com/docs/api-reference-docs/specification-extensions/x-code-samples/ */
  REDOCLY_CODE_SAMPLES_KEBAB: "x-code-samples",
  REDOCLY_CODE_SAMPLES_CAMEL: "x-codeSamples"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getExamples.js
function getExamples(schema2) {
  const examples = getExtension(schema2, "examples");
  if (examples != null && Array.isArray(examples)) {
    return examples;
  }
  return [];
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernEncoding.js
function getFernEncoding({ schema: schema2, logger }) {
  return getExtension(schema2, FernOpenAPIExtension.ENCODING) ?? void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernEnum.js
function getFernEnum(schema2) {
  return getExtension(schema2, FernOpenAPIExtension.FERN_ENUM);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernTypeExtension.js
function getFernTypeExtension({ nameOverride, generatedName, title, schema: schema2, description, availability }) {
  const groupName = getExtension(schema2, FernOpenAPIExtension.SDK_GROUP_NAME);
  const fernType = getExtension(schema2, FernOpenAPIExtension.TYPE_DEFINITION);
  if (fernType == null) {
    return;
  }
  return getSchemaFromFernType({
    fernType,
    nameOverride,
    generatedName,
    title,
    description,
    availability,
    groupName: typeof groupName === "string" ? [groupName] : groupName
  });
}
function getSchemaFromFernType({ fernType, nameOverride, generatedName, title, description, availability, groupName }) {
  return recursivelyVisitRawTypeReference({
    type: fernType,
    _default: void 0,
    validation: void 0,
    visitor: {
      primitive: (primitive) => {
        switch (primitive.v1) {
          case "BASE_64":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.base64({
                example: void 0
              })
            });
          case "BOOLEAN":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.boolean({
                default: void 0,
                example: void 0
              })
            });
          case "DATE":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.date({
                example: void 0
              })
            });
          case "DATE_TIME":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.datetime({
                example: void 0
              })
            });
          case "FLOAT":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.float({
                example: void 0
              })
            });
          case "DOUBLE":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.double({
                default: void 0,
                minimum: void 0,
                maximum: void 0,
                exclusiveMinimum: void 0,
                exclusiveMaximum: void 0,
                multipleOf: void 0,
                example: void 0
              })
            });
          case "UINT":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.uint({
                default: void 0,
                example: void 0
              })
            });
          case "INTEGER":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.int({
                default: void 0,
                minimum: void 0,
                maximum: void 0,
                exclusiveMinimum: void 0,
                exclusiveMaximum: void 0,
                multipleOf: void 0,
                example: void 0
              })
            });
          case "UINT_64":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.uint64({
                default: void 0,
                example: void 0
              })
            });
          case "LONG":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.int64({
                default: void 0,
                example: void 0
              })
            });
          case "STRING":
          case "UUID":
          case "BIG_INTEGER":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.string({
                default: void 0,
                pattern: void 0,
                maxLength: void 0,
                minLength: void 0,
                example: void 0,
                format: void 0
              })
            });
          default:
            assertNever(primitive.v1);
        }
      },
      unknown: () => {
        return SchemaWithExample.unknown({
          nameOverride,
          generatedName,
          title,
          example: void 0,
          description,
          availability,
          groupName
        });
      },
      map: ({ keyType, valueType }) => keyType?.type === "primitive" && valueType != null ? SchemaWithExample.map({
        nameOverride,
        generatedName,
        title,
        key: keyType,
        value: valueType,
        description,
        availability,
        groupName,
        encoding: void 0,
        example: void 0
      }) : void 0,
      list: (itemType) => itemType != null ? SchemaWithExample.array({
        nameOverride,
        generatedName,
        title,
        value: itemType,
        description,
        availability,
        groupName,
        example: void 0
      }) : void 0,
      optional: (itemType) => itemType != null ? SchemaWithExample.optional({
        nameOverride,
        generatedName,
        title,
        value: itemType,
        description,
        availability,
        groupName
      }) : void 0,
      set: (itemType) => itemType != null ? SchemaWithExample.array({
        nameOverride,
        generatedName,
        title,
        value: itemType,
        description,
        availability,
        groupName,
        example: void 0
      }) : void 0,
      literal: (literal) => SchemaWithExample.literal({
        nameOverride,
        generatedName,
        title,
        value: literal._visit({
          string: (value) => LiteralSchemaValue.string(value),
          boolean: (value) => LiteralSchemaValue.boolean(value),
          _other: () => {
            throw new Error("Unexpected literal type");
          }
        }),
        description,
        availability,
        groupName
      }),
      named: () => {
        return void 0;
      }
    }
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/utils/getValue.js
function getValueIfBoolean(value) {
  if (value != null && typeof value === "boolean") {
    return value;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertAdditionalProperties.js
function convertAdditionalProperties({ nameOverride, generatedName, title, breadcrumbs, additionalProperties, description, availability, wrapAsNullable, context, groupName, example, encoding, source, namespace }) {
  if (typeof additionalProperties === "boolean" || isAdditionalPropertiesAny(additionalProperties)) {
    return wrapMap({
      nameOverride,
      generatedName,
      title,
      wrapAsNullable,
      description,
      availability,
      keySchema: {
        nameOverride: void 0,
        generatedName: `${generatedName}Key`,
        title: void 0,
        description: void 0,
        availability: void 0,
        schema: PrimitiveSchemaValueWithExample.string({
          default: void 0,
          pattern: void 0,
          format: void 0,
          minLength: void 0,
          maxLength: void 0,
          example: void 0
        }),
        groupName: void 0
      },
      valueSchema: SchemaWithExample.unknown({
        nameOverride: void 0,
        generatedName: `${generatedName}Value`,
        title: void 0,
        description: void 0,
        availability: void 0,
        example: void 0,
        groupName: void 0
      }),
      groupName,
      example,
      encoding
    });
  }
  return wrapMap({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    description,
    availability,
    keySchema: {
      nameOverride: void 0,
      generatedName: `${generatedName}Key`,
      title: void 0,
      description: void 0,
      availability: void 0,
      schema: PrimitiveSchemaValueWithExample.string({
        default: void 0,
        pattern: void 0,
        format: void 0,
        minLength: void 0,
        maxLength: void 0,
        example: void 0
      }),
      groupName: void 0
    },
    valueSchema: convertSchema(additionalProperties, context.options.optionalAdditionalProperties ? wrapAsNullable : false, context, [...breadcrumbs, "Value"], source, namespace),
    groupName,
    example,
    encoding
  });
}
function wrapMap({ nameOverride, generatedName, title, keySchema, valueSchema, wrapAsNullable, description, availability, groupName, example, encoding }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.map({
        nameOverride,
        generatedName,
        title,
        description,
        availability: keySchema.availability,
        key: keySchema,
        value: valueSchema,
        groupName,
        encoding,
        example
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.map({
    nameOverride,
    generatedName,
    title,
    description,
    availability,
    key: keySchema,
    value: valueSchema,
    groupName,
    encoding,
    example
  });
}
function isAdditionalPropertiesAny(additionalProperties) {
  if (additionalProperties == null) {
    return false;
  }
  if (typeof additionalProperties === "boolean") {
    return additionalProperties;
  }
  return !isReferenceObject(additionalProperties) && Object.keys(additionalProperties).length === 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertArray.js
function convertArray({ nameOverride, generatedName, title, breadcrumbs, item, description, availability, wrapAsNullable, context, groupName, example, source, namespace }) {
  const itemSchema = item == null ? SchemaWithExample.unknown({
    nameOverride,
    generatedName,
    title,
    description: void 0,
    availability: void 0,
    example: void 0,
    groupName
  }) : convertSchema(item, false, context, [...breadcrumbs, "Item"], source, namespace);
  return wrapArray({
    nameOverride,
    generatedName,
    title,
    groupName,
    itemSchema,
    wrapAsNullable,
    description,
    availability,
    example
  });
}
function wrapArray({ nameOverride, generatedName, title, itemSchema, wrapAsNullable, description, availability, groupName, example }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.array({
        nameOverride,
        generatedName,
        title,
        value: itemSchema,
        description,
        availability,
        groupName,
        example
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.array({
    nameOverride,
    generatedName,
    title,
    value: itemSchema,
    description,
    availability,
    groupName,
    example
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertDiscriminatedOneOf.js
function convertDiscriminatedOneOf({ nameOverride, generatedName, title, breadcrumbs, properties, description, availability, required, wrapAsNullable, discriminator, context, groupName, encoding, source, namespace }) {
  const discriminant3 = discriminator.propertyName;
  const unionSubTypes = Object.fromEntries(Object.entries(discriminator.mapping ?? {}).map(([discriminantValue, schema2]) => {
    const subtypeReference = convertReferenceObject({
      $ref: schema2
    }, false, context, [schema2], encoding, source, namespace);
    context.markReferencedByDiscriminatedUnion({
      $ref: schema2
    }, discriminant3, 1);
    return [discriminantValue, subtypeReference];
  }));
  const convertedProperties = Object.entries(properties).filter(([propertyName]) => {
    return propertyName !== discriminant3;
  }).map(([propertyName, propertySchema]) => {
    const isRequired = required != null && required.includes(propertyName);
    const schema2 = convertSchema(propertySchema, !isRequired, context, [...breadcrumbs, propertyName], source, namespace);
    return {
      key: propertyName,
      schema: schema2
    };
  });
  return wrapDiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    properties: convertedProperties,
    description,
    availability,
    discriminant: discriminant3,
    subtypes: unionSubTypes,
    groupName,
    source
  });
}
function convertDiscriminatedOneOfWithVariants({ nameOverride, generatedName, title, breadcrumbs, properties, description, availability, required, wrapAsNullable, discriminant: discriminant3, variants, context, groupName, encoding, source, namespace }) {
  const unionSubTypes = Object.fromEntries(Object.entries(variants).map(([discriminantValue, schema2]) => {
    if (isReferenceObject(schema2)) {
      const subtypeReference = convertReferenceObject(schema2, false, context, [schema2.$ref], encoding, source, namespace);
      context.markReferencedByDiscriminatedUnion(schema2, discriminant3, 1);
      return [discriminantValue, subtypeReference];
    } else {
      const variantSchema = convertSchemaObject(schema2, false, context, [...breadcrumbs, discriminantValue], encoding, source, namespace, /* @__PURE__ */ new Set([discriminant3]));
      return [discriminantValue, variantSchema];
    }
  }));
  const convertedProperties = Object.entries(properties).filter(([propertyName]) => {
    return propertyName !== discriminant3;
  }).map(([propertyName, propertySchema]) => {
    const isRequired = required != null && required.includes(propertyName);
    const schema2 = convertSchema(propertySchema, !isRequired, context, [...breadcrumbs, propertyName], source, namespace);
    return {
      key: propertyName,
      schema: schema2
    };
  });
  return wrapDiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    properties: convertedProperties,
    description,
    availability,
    discriminant: discriminant3,
    subtypes: unionSubTypes,
    groupName,
    source
  });
}
function wrapDiscriminantedOneOf({ nameOverride, generatedName, title, wrapAsNullable, properties, description, availability, discriminant: discriminant3, subtypes, groupName, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.oneOf(OneOfSchemaWithExample.discriminated({
        description,
        availability,
        discriminantProperty: discriminant3,
        nameOverride,
        generatedName,
        title,
        schemas: subtypes,
        commonProperties: properties,
        groupName,
        encoding: void 0,
        source
      })),
      groupName,
      description,
      availability
    });
  }
  return SchemaWithExample.oneOf(OneOfSchemaWithExample.discriminated({
    description,
    availability,
    discriminantProperty: discriminant3,
    nameOverride,
    generatedName,
    title,
    schemas: subtypes,
    commonProperties: properties,
    groupName,
    encoding: void 0,
    source
  }));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertEncoding.js
function convertEncoding(encodingSchema) {
  if (encodingSchema.proto != null) {
    return Encoding.protobuf({
      typeName: encodingSchema.proto.type
    });
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertEnum.js
function convertEnum({ nameOverride, generatedName, title, fernEnum, enumVarNames, enumValues, _default: _default2, description, availability, wrapAsNullable, groupName, context, source }) {
  const strippedEnumVarNames = stripCommonPrefix(enumVarNames ?? []);
  const uniqueValues = new Set(enumValues);
  const values = Array.from(uniqueValues).map((value, index) => {
    const fernEnumValue = fernEnum?.[value];
    const enumVarName = strippedEnumVarNames[index];
    const valueIsValidName = VALID_ENUM_NAME_REGEX.test(value);
    let nameOverride2 = fernEnumValue?.name ?? enumVarName;
    const generatedName2 = valueIsValidName ? value : generateEnumNameFromValue(value);
    if (nameOverride2 != null && !VALID_ENUM_NAME_REGEX.test(nameOverride2)) {
      context?.logger.warn(`Enum name override ${nameOverride2} is not a valid name. Falling back on ${generatedName2}.`);
      nameOverride2 = void 0;
    }
    return {
      nameOverride: nameOverride2,
      generatedName: generatedName2,
      value,
      description: fernEnumValue?.description,
      availability,
      casing: {
        snake: fernEnumValue?.casing?.snake ?? void 0,
        pascal: fernEnumValue?.casing?.pascal ?? void 0,
        screamingSnake: fernEnumValue?.casing?.screamingSnake ?? void 0,
        camel: fernEnumValue?.casing?.camel ?? void 0
      }
    };
  });
  const _defaultEnumValue = _default2 != null ? values.find((value) => value.value === _default2) : void 0;
  return wrapEnum({
    wrapAsNullable,
    nameOverride,
    generatedName,
    title,
    values,
    _default: _defaultEnumValue,
    description,
    availability,
    groupName,
    source
  });
}
function wrapEnum({ wrapAsNullable, nameOverride, generatedName, title, values, _default: _default2, description, availability, groupName, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.enum({
        nameOverride,
        generatedName,
        title,
        values,
        description,
        default: _default2,
        availability,
        example: void 0,
        groupName,
        source
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.enum({
    nameOverride,
    generatedName,
    title,
    values,
    description,
    availability,
    default: _default2,
    example: void 0,
    groupName,
    source
  });
}
function stripCommonPrefix(names) {
  if (names.length <= 1 || names[0] == null) {
    return names;
  }
  const nameZero = names[0];
  let i = 0;
  while (nameZero[i] != null && names.every((name) => name[i] === nameZero[i])) {
    i++;
  }
  return names.map((name) => name.substring(i));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertInteger.js
function convertInteger({ nameOverride, generatedName, title, format, _default: _default2, minimum, maximum, exclusiveMinimum, exclusiveMaximum, multipleOf, description, availability, wrapAsNullable, example, groupName }) {
  if (format === "int64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.int64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint32") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  }
  return wrapPrimitive({
    nameOverride,
    generatedName,
    title,
    primitive: PrimitiveSchemaValueWithExample.int({
      default: _default2,
      minimum,
      maximum,
      exclusiveMinimum,
      exclusiveMaximum,
      multipleOf,
      example
    }),
    wrapAsNullable,
    description,
    availability,
    groupName
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertLiteral.js
function createLiteralSchemaValue(value) {
  if (typeof value === "string") {
    return LiteralSchemaValue.string(value);
  } else if (typeof value === "boolean") {
    return LiteralSchemaValue.boolean(value);
  } else {
    return LiteralSchemaValue.string(`${value}`);
  }
}
function convertLiteral({ nameOverride, generatedName, title, wrapAsNullable, value, description, availability, groupName }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.literal({
        nameOverride,
        generatedName,
        title,
        value: createLiteralSchemaValue(value),
        description,
        availability,
        groupName
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.literal({
    nameOverride,
    generatedName,
    title,
    value: createLiteralSchemaValue(value),
    description,
    availability,
    groupName
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertNumber.js
function convertNumber({ nameOverride, generatedName, title, format, _default: _default2, minimum, maximum, exclusiveMinimum, exclusiveMaximum, multipleOf, description, availability, wrapAsNullable, example, groupName }) {
  if (format == null || format === "double") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.double({
        default: _default2,
        minimum,
        maximum,
        exclusiveMinimum,
        exclusiveMaximum,
        multipleOf,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "float") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.float({
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "int32") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.int({
        default: _default2,
        minimum,
        maximum,
        exclusiveMinimum,
        exclusiveMaximum,
        multipleOf,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "int64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.int64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint32") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "time-delta") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.float({
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  }
  return wrapPrimitive({
    nameOverride,
    generatedName,
    title,
    primitive: PrimitiveSchemaValueWithExample.float({
      example
    }),
    wrapAsNullable,
    description,
    availability,
    groupName
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/getBreadcrumbsFromReference.js
var STARTS_WITH_COMPONENTS_SCHEMAS = {
  // if the first three breadcrumbs are "#", "components", "schemas"
  // then the fourth breadcrumb will be a user-defined value that we want to extract
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "#" && refUnderProcessing[1] === "components" && refUnderProcessing[2] === "schemas",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[3] ?? ""];
    return {
      refUnderProcessing: refUnderProcessing.slice(4),
      newBreadcrumbs
    };
  }
};
var STARTS_WITH_COMPONENTS_RESPONSES = {
  // if the first three breadcrumbs are "#", "components", "responses"
  // then the fourth breadcrumb will be a user-defined value that we want to extract
  isApplicable: (breadcrumbs) => breadcrumbs[0] === "#" && breadcrumbs[1] === "components" && breadcrumbs[2] === "responses",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[3] ?? ""];
    refUnderProcessing = refUnderProcessing.slice(4);
    return {
      refUnderProcessing: refUnderProcessing.slice(4),
      newBreadcrumbs
    };
  }
};
var STARTS_WITH_COMPONENTS_PARAMETERS = {
  // if the first three breadcrumbs are "#", "components", "parameters"
  // then the fourth breadcrumb will be a user-defined value that we want to extract
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "#" && refUnderProcessing[1] === "components" && refUnderProcessing[2] === "parameters",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[3] ?? ""];
    refUnderProcessing = refUnderProcessing.slice(4);
    if (refUnderProcessing[0] === "schema") {
      refUnderProcessing = refUnderProcessing.slice(1);
    }
    return {
      refUnderProcessing,
      newBreadcrumbs
    };
  }
};
var EXTRACT_PROPERTY = {
  // if the first breadcrumb is "properties"
  // then the second breadcrumb will be a user-defined value that we want to extract
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "properties",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[1] ?? ""];
    return {
      refUnderProcessing: refUnderProcessing.slice(2),
      newBreadcrumbs
    };
  }
};
var REMOVE_ITEMS_KEYWORD = {
  // if the first breadcrumb is "items"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "items",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
var REMOVE_ALL_OF_KEYWORD = {
  // if the first breadcrumb is "allOf"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "allOf",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
var REMOVE_ANY_OF_KEYWORD = {
  // if the first breadcrumb is "anyOf"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "anyOf",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
var REMOVE_ONE_OF_KEYWORD = {
  // if the first breadcrumb is "oneOf"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "oneOf",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
function getBreadcrumbsFromReference(reference) {
  let refUnderProcessing = reference.split("/").map((breadcrumb) => breadcrumb.replace(/~1/g, "/"));
  let breadcrumbs = [];
  const strategies = [
    // prefix strategies
    STARTS_WITH_COMPONENTS_SCHEMAS,
    STARTS_WITH_COMPONENTS_RESPONSES,
    STARTS_WITH_COMPONENTS_PARAMETERS,
    // index-aware strategies that must happen after prefix strategies
    EXTRACT_PROPERTY,
    REMOVE_ITEMS_KEYWORD,
    REMOVE_ALL_OF_KEYWORD,
    REMOVE_ANY_OF_KEYWORD,
    REMOVE_ONE_OF_KEYWORD
  ];
  let previousRefUnderProcessing;
  do {
    previousRefUnderProcessing = refUnderProcessing;
    for (const strategy of strategies) {
      if (strategy.isApplicable(refUnderProcessing)) {
        const { refUnderProcessing: newRefUnderProcessing, newBreadcrumbs } = strategy.applyStrategy(refUnderProcessing);
        refUnderProcessing = newRefUnderProcessing;
        breadcrumbs = [...breadcrumbs, ...newBreadcrumbs];
      }
    }
  } while (refUnderProcessing.join("") !== previousRefUnderProcessing.join(""));
  return breadcrumbs;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/getSchemaName.js
function getGeneratedTypeName(breadcrumbs, useOriginalSchemaIds) {
  const processedTokens = breadcrumbs.map((token) => {
    if (/^[^a-zA-Z0-9]+$/.test(token)) {
      return token;
    } else {
      return upperFirst_default(camelCase_default(token));
    }
  });
  const name = processedTokens.join("");
  if (/^\d/.test(name)) {
    return replaceStartingNumber(name) ?? name;
  }
  return name;
}
function getGeneratedPropertyName(breadcrumbs) {
  const underscoreDelimited = breadcrumbs.join("_");
  return camelCase_default(underscoreDelimited);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/convertSchemaWithExampleToSchema.js
function convertSchemaWithExampleToSchema(schema2) {
  switch (schema2.type) {
    case "object":
      return Schema.object({
        allOf: schema2.allOf,
        properties: schema2.properties.map((objectProperty) => convertToObjectProperty(objectProperty)),
        allOfPropertyConflicts: schema2.allOfPropertyConflicts,
        description: schema2.description,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName,
        additionalProperties: schema2.additionalProperties,
        availability: schema2.availability,
        source: schema2.source
      });
    case "array":
      return Schema.array({
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaWithExampleToSchema(schema2.value),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "enum":
      return Schema.enum({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        values: schema2.values,
        default: schema2.default,
        groupName: schema2.groupName,
        source: schema2.source
      });
    case "literal":
      return Schema.literal({
        description: schema2.description,
        availability: schema2.availability,
        value: schema2.value,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "nullable":
      return Schema.nullable({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaWithExampleToSchema(schema2.value),
        groupName: schema2.groupName
      });
    case "optional":
      return Schema.optional({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaWithExampleToSchema(schema2.value),
        groupName: schema2.groupName
      });
    case "primitive":
      return Schema.primitive({
        description: schema2.description,
        availability: schema2.availability,
        schema: convertToPrimitiveSchemaValue(schema2.schema),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "map":
      return Schema.map({
        description: schema2.description,
        availability: schema2.availability,
        key: Schema.primitive({
          description: schema2.key.description,
          availability: schema2.key.availability,
          schema: convertToPrimitiveSchemaValue(schema2.key.schema),
          generatedName: schema2.key.generatedName,
          title: schema2.key.title,
          nameOverride: schema2.key.nameOverride,
          groupName: schema2.groupName
        }),
        value: convertSchemaWithExampleToSchema(schema2.value),
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName,
        encoding: schema2.encoding
      });
    case "reference":
      return Schema.reference({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        schema: schema2.schema,
        groupName: schema2.groupName,
        source: schema2.source
      });
    case "oneOf":
      return Schema.oneOf(convertToOneOf(schema2.value));
    case "unknown":
      return Schema.unknown({ nameOverride: schema2.nameOverride, generatedName: schema2.generatedName });
    default:
      assertNever(schema2);
  }
}
function convertToOneOf(oneOfSchema) {
  switch (oneOfSchema.type) {
    case "discriminated":
      return OneOfSchema.discriminated({
        commonProperties: oneOfSchema.commonProperties.map((commonProperty) => {
          return {
            key: commonProperty.key,
            schema: convertSchemaWithExampleToSchema(commonProperty.schema)
          };
        }),
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        discriminantProperty: oneOfSchema.discriminantProperty,
        generatedName: oneOfSchema.generatedName,
        title: oneOfSchema.title,
        nameOverride: oneOfSchema.nameOverride,
        schemas: Object.fromEntries(Object.entries(oneOfSchema.schemas).map(([discriminantValue, schemaWithExample]) => {
          return [discriminantValue, convertSchemaWithExampleToSchema(schemaWithExample)];
        })),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    case "undisciminated":
      return OneOfSchema.undisciminated({
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        generatedName: oneOfSchema.generatedName,
        title: oneOfSchema.title,
        nameOverride: oneOfSchema.nameOverride,
        schemas: oneOfSchema.schemas.map((oneOfSchema2) => convertSchemaWithExampleToSchema(oneOfSchema2)),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    default:
      assertNever(oneOfSchema);
  }
}
function convertToPrimitiveSchemaValue(primitiveSchema) {
  switch (primitiveSchema.type) {
    case "string":
      return PrimitiveSchemaValue.string(primitiveSchema);
    case "base64":
      return PrimitiveSchemaValue.base64();
    case "boolean":
      return PrimitiveSchemaValue.boolean(primitiveSchema);
    case "date":
      return PrimitiveSchemaValue.date();
    case "datetime":
      return PrimitiveSchemaValue.datetime();
    case "double":
      return PrimitiveSchemaValue.double(primitiveSchema);
    case "float":
      return PrimitiveSchemaValue.float();
    case "int":
      return PrimitiveSchemaValue.int(primitiveSchema);
    case "int64":
      return PrimitiveSchemaValue.int64(primitiveSchema);
    case "uint":
      return PrimitiveSchemaValue.uint();
    case "uint64":
      return PrimitiveSchemaValue.uint64();
    default:
      assertNever(primitiveSchema);
  }
}
function convertToObjectProperty(objectProperty) {
  return {
    conflict: objectProperty.conflict,
    generatedName: objectProperty.generatedName,
    key: objectProperty.key,
    schema: convertSchemaWithExampleToSchema(objectProperty.schema),
    audiences: objectProperty.audiences,
    nameOverride: objectProperty.nameOverride,
    availability: objectProperty.availability,
    readonly: objectProperty.readonly
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/isSchemaWithExampleEqual.js
function isSchemaWithExampleEqual(a, b) {
  return isSchemaEqual(convertSchemaWithExampleToSchema(a), convertSchemaWithExampleToSchema(b));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertObject.js
function convertObject3({ nameOverride, generatedName, title, breadcrumbs, properties, description, required, wrapAsNullable, allOf, context, propertiesToExclude, groupName, fullExamples, additionalProperties, availability, encoding, source, namespace }) {
  const allRequired = [...required ?? []];
  const propertiesToConvert = { ...properties };
  const inlinedParentProperties = [];
  const parents = [];
  for (const allOfElement of allOf) {
    if (isReferenceObject(allOfElement)) {
      const resolvedReference = context.resolveSchemaReference(allOfElement);
      if (resolvedReference.discriminator != null && resolvedReference.discriminator.mapping != null) {
        continue;
      }
      if (resolvedReference.oneOf != null) {
        for (const oneOfSchema of resolvedReference.oneOf) {
          const resolvedOneOfSchema = isReferenceObject(oneOfSchema) ? context.resolveSchemaReference(oneOfSchema) : oneOfSchema;
          const convertedOneOfSchema = convertSchema(resolvedOneOfSchema, false, context.DUMMY, breadcrumbs, source, namespace);
          if (convertedOneOfSchema.type === "object") {
            inlinedParentProperties.push(...convertedOneOfSchema.properties.map((property4) => {
              if (property4.schema.type !== "optional" && property4.schema.type !== "nullable") {
                return {
                  ...property4,
                  schema: SchemaWithExample.optional({
                    nameOverride: void 0,
                    generatedName: "",
                    title: void 0,
                    value: property4.schema,
                    description: void 0,
                    availability: property4.availability,
                    groupName: void 0
                  })
                };
              }
              return property4;
            }));
          }
        }
        continue;
      }
      const schemaId = getSchemaIdFromReference(allOfElement);
      if (schemaId == null) {
        continue;
      }
      parents.push({
        schemaId,
        convertedSchema: convertToReferencedSchema(allOfElement, [schemaId], source, context.options.preserveSchemaIds),
        properties: getAllProperties({ schema: allOfElement, context, breadcrumbs, source, namespace })
      });
      context.markSchemaAsReferencedByNonRequest(schemaId);
    } else {
      const allOfSchema = convertSchema(allOfElement, false, context, breadcrumbs, source, namespace);
      if (allOfSchema.type === "object") {
        inlinedParentProperties.push(...allOfSchema.properties);
      }
    }
  }
  const allPropertiesMap = {};
  for (const parent of parents) {
    for (const [propertyKey, propertySchema] of Object.entries(parent.properties)) {
      const propertyInfo = allPropertiesMap[propertyKey];
      if (propertyInfo != null) {
        propertyInfo.schemaIds.push(parent.schemaId);
        const schemaExists = propertyInfo.schemas.some((schema2) => {
          return isSchemaWithExampleEqual(schema2, propertySchema);
        });
        if (!schemaExists) {
          propertyInfo.schemas.push(propertySchema);
        }
      } else {
        allPropertiesMap[propertyKey] = { schemaIds: [parent.schemaId], schemas: [propertySchema] };
      }
    }
  }
  const allOfPropertyConflicts = [];
  for (const [allOfPropertyKey, allOfPropertyInfo] of Object.entries(allPropertiesMap)) {
    if (allOfPropertyInfo.schemaIds.length > 1) {
      allOfPropertyConflicts.push({
        propertyKey: allOfPropertyKey,
        allOfSchemaIds: allOfPropertyInfo.schemaIds,
        conflictingTypeSignatures: allOfPropertyInfo.schemas.length > 1
      });
    }
  }
  const convertedProperties = Object.entries(propertiesToConvert).map(([propertyName, propertySchema]) => {
    const isRequired = allRequired.includes(propertyName);
    const audiences = getExtension(propertySchema, FernOpenAPIExtension.AUDIENCES) ?? [];
    const availability2 = convertAvailability3(propertySchema);
    const readonly = isReferenceObject(propertySchema) ? false : propertySchema.readOnly;
    const propertyNameOverride = getExtension(propertySchema, FernOpenAPIExtension.FERN_PROPERTY_NAME);
    const propertyBreadcrumbs = [...breadcrumbs, propertyName];
    const generatedName2 = getGeneratedPropertyName(propertyBreadcrumbs);
    const schema2 = isRequired ? convertSchema(propertySchema, false, context, propertyBreadcrumbs, source, namespace) : SchemaWithExample.optional({
      nameOverride,
      generatedName: generatedName2,
      title,
      description: void 0,
      availability: availability2,
      value: convertSchema(propertySchema, false, context, propertyBreadcrumbs, source, namespace),
      groupName
    });
    const conflicts = {};
    for (const parent of parents) {
      const parentPropertySchema = parent.properties[propertyName];
      if (parentPropertySchema != null && !isSchemaWithExampleEqual(schema2, parentPropertySchema)) {
        conflicts[parent.schemaId] = { differentSchema: true };
      } else if (parentPropertySchema != null) {
        conflicts[parent.schemaId] = { differentSchema: false };
      }
    }
    return {
      key: propertyName,
      schema: schema2,
      nameOverride: propertyNameOverride,
      audiences,
      conflict: conflicts,
      generatedName: getGeneratedPropertyName([...breadcrumbs, propertyName]),
      availability: availability2,
      readonly
    };
  });
  convertedProperties.push(...inlinedParentProperties.map((property4) => {
    const conflicts = property4.conflict;
    for (const parent of parents) {
      const parentPropertySchema = parent.properties[property4.key];
      if (parentPropertySchema != null && !isSchemaWithExampleEqual(property4.schema, parentPropertySchema)) {
        conflicts[parent.schemaId] = { differentSchema: true };
      } else if (parentPropertySchema != null) {
        conflicts[parent.schemaId] = { differentSchema: false };
      }
    }
    return {
      ...property4,
      conflict: conflicts
    };
  }));
  return wrapObject({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    properties: convertedProperties.filter((objectProperty) => {
      return !propertiesToExclude.has(objectProperty.key);
    }),
    description,
    allOf: parents.map((parent) => parent.convertedSchema),
    allOfPropertyConflicts,
    groupName,
    fullExamples,
    additionalProperties,
    availability,
    source
  });
}
function wrapObject({ nameOverride, generatedName, title, wrapAsNullable, properties, description, allOf, allOfPropertyConflicts, groupName, fullExamples, additionalProperties, availability, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.object({
        description,
        properties,
        nameOverride,
        generatedName,
        title,
        allOf,
        allOfPropertyConflicts,
        groupName,
        fullExamples,
        additionalProperties: isAdditionalPropertiesAny(additionalProperties),
        availability: void 0,
        source
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.object({
    description,
    properties,
    nameOverride,
    generatedName,
    title,
    allOf,
    allOfPropertyConflicts,
    groupName,
    fullExamples,
    additionalProperties: isAdditionalPropertiesAny(additionalProperties),
    availability,
    source
  });
}
function getAllProperties({ schema: schema2, context, breadcrumbs, source, namespace }) {
  let properties = {};
  const [resolvedSchema, resolvedBreadCrumbs] = isReferenceObject(schema2) ? [context.resolveSchemaReference(schema2), getBreadcrumbsFromReference(schema2.$ref)] : [schema2, breadcrumbs];
  for (const allOfElement of resolvedSchema.allOf ?? []) {
    properties = {
      ...properties,
      ...getAllProperties({ schema: allOfElement, context, breadcrumbs: resolvedBreadCrumbs, source, namespace })
    };
  }
  for (const [propertyName, propertySchema] of Object.entries(resolvedSchema.properties ?? {})) {
    const convertedPropertySchema = convertSchema(propertySchema, false, context, [...resolvedBreadCrumbs, propertyName], source, namespace);
    properties[propertyName] = convertedPropertySchema;
  }
  return properties;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertUndiscriminatedOneOf.js
function convertUndiscriminatedOneOf({ nameOverride, generatedName, title, breadcrumbs, description, availability, wrapAsNullable, context, subtypes, groupName, encoding, source, subtypePrefixOverrides, namespace }) {
  const derivedSubtypePrefixes = getUniqueSubTypeNames({ schemas: subtypes });
  const convertedSubtypes = subtypes.flatMap((schema2, index) => {
    if (!isReferenceObject(schema2) && schema2.enum != null && context.options.cooerceEnumsToLiterals) {
      return schema2.enum.map((enumValue) => {
        return SchemaWithExample.literal({
          nameOverride: void 0,
          generatedName: getGeneratedTypeName([generatedName, enumValue], context.options.preserveSchemaIds),
          title: void 0,
          value: LiteralSchemaValue.string(enumValue),
          groupName: void 0,
          description: void 0,
          availability: enumValue.availability
        });
      });
    }
    let subtypePrefix = derivedSubtypePrefixes[index];
    if (subtypePrefixOverrides != null) {
      const override = subtypePrefixOverrides[index];
      if (override != null && "name" in override) {
        subtypePrefix = override.name;
      }
    }
    return [
      convertSchema(schema2, false, context, [...breadcrumbs, subtypePrefix ?? `${index}`], source, namespace)
    ];
  });
  const uniqueSubtypes = [];
  for (let i = 0; i < convertedSubtypes.length; ++i) {
    const a = convertedSubtypes[i];
    let isDuplicate = false;
    for (let j = i + 1; j < convertedSubtypes.length; ++j) {
      const b = convertedSubtypes[j];
      if (a != null && b != null && isSchemaEqual(a, b)) {
        isDuplicate = true;
        break;
      }
    }
    if (a != null && !isDuplicate) {
      uniqueSubtypes.push(a);
    }
  }
  const everySubTypeIsLiteral = Object.entries(uniqueSubtypes).every(([_, schema2]) => {
    return schema2.type === "literal";
  });
  if (everySubTypeIsLiteral) {
    const enumDescriptions = {};
    const enumValues = [];
    Object.entries(uniqueSubtypes).forEach(([_, schema2]) => {
      if (schema2.type === "literal" && schema2.value.type === "string") {
        enumValues.push(schema2.value.value);
        if (schema2.description != null) {
          enumDescriptions[schema2.value.value] = {
            description: schema2.description
          };
        }
      }
    });
    return convertEnum({
      nameOverride,
      generatedName,
      title,
      wrapAsNullable,
      description,
      availability,
      fernEnum: enumDescriptions,
      enumVarNames: void 0,
      enumValues,
      _default: void 0,
      groupName,
      context,
      source
    });
  }
  if (uniqueSubtypes.length === 1 && uniqueSubtypes[0] != null) {
    return uniqueSubtypes[0];
  }
  return wrapUndiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    description,
    availability,
    subtypes: uniqueSubtypes,
    groupName,
    encoding,
    source
  });
}
function convertUndiscriminatedOneOfWithDiscriminant({ nameOverride, generatedName, title, description, availability, wrapAsNullable, context, groupName, discriminator, encoding, source, namespace }) {
  const convertedSubtypes = Object.entries(discriminator.mapping ?? {}).map(([discriminantValue, schema2], index) => {
    const subtypeReferenceSchema = {
      $ref: schema2
    };
    const subtypeReference = convertReferenceObject(subtypeReferenceSchema, false, context, [schema2], encoding, source, namespace);
    context.markSchemaWithDiscriminantValue(subtypeReferenceSchema, discriminator.propertyName, discriminantValue);
    if (subtypeReference.type === "object") {
      subtypeReference.properties = {
        [discriminator.propertyName]: SchemaWithExample.literal({
          nameOverride: void 0,
          generatedName: getGeneratedTypeName([generatedName, discriminantValue], context.options.preserveSchemaIds),
          title: void 0,
          value: LiteralSchemaValue.string(discriminantValue),
          groupName: void 0,
          description: void 0,
          availability: void 0
        }),
        ...subtypeReference.properties.filter((objectProperty) => {
          return objectProperty.key !== discriminator.propertyName;
        })
      };
    }
    return subtypeReference;
  });
  const uniqueSubtypes = [];
  for (let i = 0; i < convertedSubtypes.length; ++i) {
    const a = convertedSubtypes[i];
    let isDuplicate = false;
    for (let j = i + 1; j < convertedSubtypes.length; ++j) {
      const b = convertedSubtypes[j];
      if (a != null && b != null && isSchemaEqual(a, b)) {
        isDuplicate = true;
        break;
      }
    }
    if (a != null && !isDuplicate) {
      uniqueSubtypes.push(a);
    }
  }
  const everySubTypeIsLiteral = Object.entries(uniqueSubtypes).every(([_, schema2]) => {
    return schema2.type === "literal";
  });
  if (everySubTypeIsLiteral) {
    const enumDescriptions = {};
    const enumValues = [];
    Object.entries(uniqueSubtypes).forEach(([_, schema2]) => {
      if (schema2.type === "literal" && schema2.value.type === "string") {
        enumValues.push(schema2.value.value);
        if (schema2.description != null) {
          enumDescriptions[schema2.value.value] = {
            description: schema2.description
          };
        }
      }
    });
    return convertEnum({
      nameOverride,
      generatedName,
      title,
      wrapAsNullable,
      description,
      availability,
      fernEnum: enumDescriptions,
      enumVarNames: void 0,
      enumValues,
      _default: void 0,
      groupName,
      context,
      source
    });
  }
  if (uniqueSubtypes.length === 1 && uniqueSubtypes[0] != null) {
    return uniqueSubtypes[0];
  }
  return wrapUndiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    description,
    availability,
    subtypes: uniqueSubtypes,
    groupName,
    encoding,
    source
  });
}
function getUniqueSubTypeNames({ schemas }) {
  let uniquePropertySets = {};
  let index = 0;
  for (const schema2 of schemas) {
    if (isReferenceObject(schema2)) {
    } else if (schema2.properties != null && Object.entries(schema2.properties).length > 0) {
      const schemaProperties = Object.keys(schema2.properties);
      const updatedPropertySets = {};
      let uniqueSchemaProperties = schemaProperties;
      for (const [key, uniquePropertySet] of Object.entries(uniquePropertySets)) {
        const updatedSet = difference_default(uniquePropertySet, schemaProperties);
        uniqueSchemaProperties = difference_default(uniqueSchemaProperties, uniquePropertySet);
        updatedPropertySets[key] = updatedSet;
      }
      updatedPropertySets[index] = uniqueSchemaProperties;
      uniquePropertySets = updatedPropertySets;
    }
    index++;
  }
  const prefixes = [];
  let i = 0;
  for (const schema2 of schemas) {
    const propertySet = uniquePropertySets[i];
    if (propertySet != null && propertySet.length > 0) {
      const sortedProperties = propertySet.sort();
      if (sortedProperties[0] != null) {
        prefixes.push(sortedProperties[0]);
        ++i;
        continue;
      }
    }
    if (isReferenceObject(schema2)) {
      prefixes.push(convertNumberToSnakeCase(i) ?? `${i}`);
    } else if (schema2.type === "array" || schema2.type === "boolean" || schema2.type === "integer" || schema2.type === "number" || schema2.type === "string") {
      prefixes.push("");
    } else {
      prefixes.push(convertNumberToSnakeCase(i) ?? `${i}`);
    }
    ++i;
  }
  return prefixes;
}
function wrapUndiscriminantedOneOf({ nameOverride, generatedName, title, wrapAsNullable, description, availability, subtypes, groupName, encoding, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.oneOf(OneOfSchemaWithExample.undisciminated({
        description,
        availability,
        nameOverride,
        generatedName,
        title,
        schemas: subtypes,
        groupName,
        encoding,
        source
      })),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.oneOf(OneOfSchemaWithExample.undisciminated({
    description,
    availability,
    nameOverride,
    generatedName,
    title,
    schemas: subtypes,
    groupName,
    encoding,
    source
  }));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/defaults/getDefault.js
function getDefaultAsString(schema2) {
  if (schema2.default != null && typeof schema2.default === "string") {
    return schema2.default;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/getExample.js
function getExampleAsNumber({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && typeof schema2.example === "number") {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (typeof example === "number") {
      return example;
    }
  }
  if (fallback && typeof fallback === "number") {
    return fallback;
  }
  return void 0;
}
function getExampleAsBoolean({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && typeof schema2.example === "boolean") {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (typeof example === "boolean") {
      return example;
    }
  }
  if (fallback && typeof fallback === "boolean") {
    return fallback;
  }
  return void 0;
}
function getExamplesString({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && typeof schema2.example === "string") {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (typeof example === "string") {
      return example;
    }
  }
  if (fallback && typeof fallback === "string") {
    return fallback;
  }
  return void 0;
}
function getExampleAsArray({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && Array.isArray(schema2.example)) {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (Array.isArray(example)) {
      return example;
    }
  }
  if (fallback && Array.isArray(fallback)) {
    return fallback;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertSchemas.js
var SCHEMA_REFERENCE_PREFIX = "#/components/schemas/";
function convertSchema(schema2, wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest = false, propertiesToExclude = /* @__PURE__ */ new Set(), fallback) {
  const encoding = getEncoding({ schema: schema2, logger: context.logger });
  if (isReferenceObject(schema2)) {
    const schemaId = getSchemaIdFromReference(schema2);
    if (schemaId != null) {
      if (!referencedAsRequest) {
        context.markSchemaAsReferencedByNonRequest(schemaId);
      } else {
        context.markSchemaAsReferencedByRequest(schemaId);
      }
      return convertReferenceObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace);
    }
    return convertSchemaObject(context.resolveSchemaReference(schema2), wrapAsNullable, context, getBreadcrumbsFromReference(schema2.$ref), encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback);
  }
  return convertSchemaObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback);
}
function convertReferenceObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace) {
  const referenceSchema = schema2.$ref.includes("properties") ? convertSchemaObject(context.resolveSchemaReference(schema2), wrapAsNullable, context, breadcrumbs, encoding, source, namespace, /* @__PURE__ */ new Set()) : SchemaWithExample.reference(convertToReferencedSchema(schema2, breadcrumbs, source, context.options.preserveSchemaIds));
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      title: void 0,
      nameOverride: void 0,
      generatedName: getGeneratedTypeName(breadcrumbs, context.options.preserveSchemaIds),
      value: referenceSchema,
      description: void 0,
      availability: void 0,
      groupName: void 0
    });
  } else {
    return referenceSchema;
  }
}
function getTitleAsName(title) {
  if (title == null) {
    return void 0;
  }
  if (title.includes(" ")) {
    return void 0;
  }
  if (!/^[a-zA-Z]+$/.test(title)) {
    return void 0;
  }
  return title;
}
function convertSchemaObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude = /* @__PURE__ */ new Set(), referencedAsRequest = false, fallback) {
  const nameOverride = getExtension(schema2, FernOpenAPIExtension.TYPE_NAME) ?? (context.options.useTitlesAsName ? getTitleAsName(schema2.title) : void 0);
  const mixedGroupName = getExtension(schema2, FernOpenAPIExtension.SDK_GROUP_NAME) ?? getExtension(schema2, OpenAPIExtension.TAGS)?.[0];
  let groupName = (typeof mixedGroupName === "string" ? [mixedGroupName] : mixedGroupName) ?? [];
  groupName = context.resolveGroupName(groupName);
  const generatedName = getGeneratedTypeName(breadcrumbs, context.options.preserveSchemaIds);
  const title = schema2.title;
  const description = schema2.description;
  const availability = convertAvailability3(schema2);
  const fullExamples = [];
  if (schema2.example != null) {
    fullExamples.push({ name: void 0, value: schema2.example, description: void 0 });
  }
  const xExamples = getExtension(schema2, OpenAPIExtension.EXAMPLES);
  if (xExamples != null && Object.keys(xExamples).length > 0) {
    fullExamples.push(...Object.entries(xExamples).map(([name, value]) => {
      return { name: value?.summary ?? name, value: value.value, description: value.description };
    }));
  }
  const examples = getExamples(schema2);
  if (examples != null && Object.keys(examples).length > 0) {
    fullExamples.push(...examples.map((value) => {
      return { name: void 0, value, description: void 0 };
    }));
  }
  const fernSchema = getFernTypeExtension({ schema: schema2, description, title, nameOverride, generatedName, availability });
  if (fernSchema != null) {
    return fernSchema;
  }
  if (!wrapAsNullable && schema2.nullable === true) {
    return convertSchemaObject(schema2, true, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback);
  }
  if (schema2.enum != null && (schema2.type === "string" || schema2.type == null)) {
    if (!isListOfStrings(schema2.enum)) {
      return wrapPrimitive({
        nameOverride,
        generatedName,
        title,
        primitive: PrimitiveSchemaValueWithExample.string({
          default: getDefaultAsString(schema2),
          minLength: schema2.minLength,
          maxLength: schema2.maxLength,
          pattern: schema2.pattern,
          format: schema2.format,
          example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
        }),
        groupName,
        wrapAsNullable,
        description,
        availability
      });
    }
    const fernEnum = getFernEnum(schema2);
    if (schema2.enum.length === 1 && schema2.enum[0] != null && fernEnum == null) {
      return convertLiteral({
        nameOverride,
        generatedName,
        title,
        wrapAsNullable,
        value: schema2.enum[0],
        description,
        availability,
        groupName
      });
    }
    return convertEnum({
      nameOverride,
      generatedName,
      title,
      fernEnum,
      enumVarNames: getExtension(schema2, [OpenAPIExtension.ENUM_VAR_NAMES]),
      enumValues: schema2.enum,
      _default: schema2.default,
      description,
      availability,
      wrapAsNullable,
      groupName,
      context,
      source
    });
  }
  if (isListOfStrings(schema2.type) && schema2.type[1] != null && schema2.type[0] != null) {
    const firstElement = schema2.type[0];
    const secondElement = schema2.type[1];
    if (firstElement === "null") {
      return SchemaWithExample.nullable({
        nameOverride,
        generatedName,
        title,
        value: convertSchemaObject({
          ...schema2,
          type: secondElement
        }, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback),
        groupName,
        description: schema2.description,
        availability
      });
    } else if (secondElement === "null") {
      return SchemaWithExample.nullable({
        nameOverride,
        generatedName,
        title,
        value: convertSchemaObject({
          ...schema2,
          type: firstElement
        }, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback),
        groupName,
        description: schema2.description,
        availability
      });
    }
  }
  if (isListOfStrings(schema2.type) && schema2.type.length > 1) {
    const wrapVariantAsNullable = schema2.type.includes("null");
    const subtypes = schema2.type.filter((val) => val !== "null").map((type2) => {
      return {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        type: type2,
        nullable: wrapVariantAsNullable
      };
    });
    return convertUndiscriminatedOneOf({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      description,
      availability,
      wrapAsNullable,
      context,
      subtypes,
      groupName,
      encoding,
      source,
      namespace
    });
  }
  if (schema2 === "boolean" || schema2.type === "boolean") {
    const literalValue = getExtension(schema2, FernOpenAPIExtension.BOOLEAN_LITERAL);
    if (literalValue != null) {
      return wrapLiteral({
        nameOverride,
        generatedName,
        title,
        literal: LiteralSchemaValue.boolean(literalValue),
        wrapAsNullable,
        description,
        availability,
        groupName
      });
    }
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.boolean({
        default: schema2.default,
        example: getExampleAsBoolean({ schema: schema2, logger: context.logger, fallback })
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  }
  if (schema2 === "number" || schema2.type === "number") {
    return convertNumber({
      nameOverride,
      generatedName,
      title,
      format: schema2.format,
      _default: schema2.default,
      minimum: schema2.minimum,
      maximum: schema2.maximum,
      exclusiveMinimum: getValueIfBoolean(schema2.exclusiveMinimum),
      exclusiveMaximum: getValueIfBoolean(schema2.exclusiveMaximum),
      multipleOf: schema2.multipleOf,
      description,
      availability,
      wrapAsNullable,
      example: getExampleAsNumber({ schema: schema2, logger: context.logger, fallback }),
      groupName
    });
  }
  if (schema2 === "integer" || schema2.type === "integer") {
    return convertInteger({
      nameOverride,
      generatedName,
      title,
      format: schema2.format,
      _default: schema2.default,
      minimum: schema2.minimum,
      maximum: schema2.maximum,
      exclusiveMinimum: getValueIfBoolean(schema2.exclusiveMinimum),
      exclusiveMaximum: getValueIfBoolean(schema2.exclusiveMaximum),
      multipleOf: schema2.multipleOf,
      description,
      availability,
      wrapAsNullable,
      example: getExampleAsNumber({ schema: schema2, logger: context.logger, fallback }),
      groupName
    });
  }
  if (schema2 === "float") {
    return convertNumber({
      nameOverride,
      generatedName,
      title,
      format: "float",
      _default: schema2.default,
      minimum: schema2.minimum,
      maximum: schema2.maximum,
      exclusiveMinimum: getValueIfBoolean(schema2.exclusiveMinimum),
      exclusiveMaximum: getValueIfBoolean(schema2.exclusiveMaximum),
      multipleOf: schema2.multipleOf,
      description,
      availability,
      wrapAsNullable,
      example: getExampleAsNumber({ schema: schema2, logger: context.logger, fallback }),
      groupName
    });
  }
  if (schema2 === "string" || schema2.type === "string") {
    if (schema2.format === "date-time") {
      return wrapPrimitive({
        nameOverride,
        generatedName,
        title,
        primitive: PrimitiveSchemaValueWithExample.datetime({
          example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
        }),
        wrapAsNullable,
        description,
        availability,
        groupName
      });
    } else if (schema2.format === "json-string") {
      return SchemaWithExample.unknown({
        nameOverride,
        generatedName,
        title,
        description,
        availability,
        groupName,
        example: void 0
      });
    }
    const maybeConstValue = getProperty(schema2, "const");
    if (maybeConstValue != null) {
      return wrapLiteral({
        nameOverride,
        generatedName,
        title,
        literal: LiteralSchemaValue.string(maybeConstValue),
        wrapAsNullable,
        description,
        availability,
        groupName
      });
    }
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.string({
        default: getDefaultAsString(schema2),
        pattern: schema2.pattern,
        format: schema2.format,
        minLength: schema2.minLength,
        maxLength: schema2.maxLength,
        example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
      }),
      groupName,
      wrapAsNullable,
      description,
      availability
    });
  }
  if (schema2.type === "array") {
    return convertArray({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      item: schema2.items,
      description,
      availability,
      wrapAsNullable,
      context,
      groupName,
      example: getExampleAsArray({ schema: schema2, logger: context.logger, fallback }),
      source,
      namespace
    });
  }
  if (schema2.additionalProperties != null && schema2.additionalProperties !== false && hasNoProperties(schema2)) {
    return convertAdditionalProperties({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      additionalProperties: schema2.additionalProperties,
      description,
      availability,
      wrapAsNullable,
      context,
      groupName,
      encoding,
      example: schema2.example,
      source,
      namespace
    });
  }
  if (schema2.type === "object" && schema2.discriminator != null && schema2.discriminator.mapping != null) {
    if (!context.options.discriminatedUnionV2) {
      return convertDiscriminatedOneOf({
        nameOverride,
        generatedName,
        title,
        breadcrumbs,
        description,
        availability,
        discriminator: schema2.discriminator,
        properties: schema2.properties ?? {},
        required: schema2.required,
        wrapAsNullable,
        context,
        groupName,
        encoding,
        source,
        namespace
      });
    } else {
      return convertUndiscriminatedOneOfWithDiscriminant({
        nameOverride,
        generatedName,
        title,
        description,
        availability,
        wrapAsNullable,
        context,
        groupName,
        discriminator: schema2.discriminator,
        encoding,
        source,
        namespace
      });
    }
  }
  if (Array.isArray(schema2.type)) {
    if (schema2.oneOf == null) {
      schema2.oneOf = schema2.type;
    } else {
      schema2.oneOf.push(...schema2.type);
    }
  }
  if (schema2.oneOf != null && schema2.oneOf.length > 0) {
    const isUndiscriminated = getExtension(schema2, FernOpenAPIExtension.IS_UNDISCRIMINATED);
    if (schema2.discriminator != null && schema2.discriminator.mapping != null && Object.keys(schema2.discriminator.mapping).length > 0) {
      if (context.options.discriminatedUnionV2 || isUndiscriminated) {
        return convertUndiscriminatedOneOfWithDiscriminant({
          nameOverride,
          generatedName,
          title,
          description,
          availability,
          wrapAsNullable,
          context,
          groupName,
          discriminator: schema2.discriminator,
          encoding,
          source,
          namespace
        });
      } else {
        return convertDiscriminatedOneOf({
          nameOverride,
          generatedName,
          title,
          breadcrumbs,
          description,
          availability,
          discriminator: schema2.discriminator,
          properties: schema2.properties ?? {},
          required: schema2.required,
          wrapAsNullable,
          context,
          groupName,
          encoding,
          source,
          namespace
        });
      }
    } else if (schema2.oneOf.length === 1 && schema2.oneOf[0] != null) {
      const convertedSchema = convertSchema(schema2.oneOf[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    } else if (schema2.oneOf.length > 1) {
      if (schema2.oneOf.length === 2 && schema2.oneOf[0] != null && schema2.oneOf[1] != null) {
        const firstSchema = schema2.oneOf[0];
        const secondSchema = schema2.oneOf[1];
        if (!isReferenceObject(firstSchema) && firstSchema.type === "null") {
          return convertSchema(secondSchema, true, context, breadcrumbs, source, namespace);
        } else if (!isReferenceObject(secondSchema) && secondSchema.type === "null") {
          return convertSchema(firstSchema, true, context, breadcrumbs, source, namespace);
        }
      }
      const maybeAllEnumValues = getMaybeAllEnumValues({ schemas: schema2.oneOf });
      if (maybeAllEnumValues != null) {
        return convertEnum({
          nameOverride,
          generatedName,
          title,
          fernEnum: void 0,
          enumVarNames: void 0,
          enumValues: maybeAllEnumValues,
          _default: schema2.default,
          description,
          availability,
          wrapAsNullable,
          groupName,
          context,
          source
        });
      }
      const maybeDiscriminant = getDiscriminant({ schemas: schema2.oneOf, context });
      if (maybeDiscriminant != null && !context.options.discriminatedUnionV2 && !isUndiscriminated) {
        return convertDiscriminatedOneOfWithVariants({
          nameOverride,
          generatedName,
          title,
          breadcrumbs,
          properties: schema2.properties ?? {},
          required: schema2.required,
          description,
          availability,
          wrapAsNullable,
          discriminant: maybeDiscriminant.discriminant,
          variants: maybeDiscriminant.schemas,
          context,
          groupName,
          encoding,
          source,
          namespace
        });
      }
      const hasNullValue = schema2.oneOf.filter((schema3) => {
        return !isReferenceObject(schema3) && schema3.type === "null";
      }).length > 0;
      return convertUndiscriminatedOneOf({
        nameOverride,
        generatedName,
        title,
        breadcrumbs,
        description,
        availability,
        wrapAsNullable: wrapAsNullable || hasNullValue,
        context,
        subtypes: schema2.oneOf.filter((schema3) => {
          return isReferenceObject(schema3) || schema3.type !== "null";
        }),
        encoding,
        groupName,
        source,
        namespace
      });
    }
  }
  if (schema2.anyOf != null && schema2.anyOf.length > 0) {
    if (schema2.anyOf.length === 1 && schema2.anyOf[0] != null) {
      const convertedSchema = convertSchema(schema2.anyOf[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    }
    if (schema2.anyOf.length === 2) {
      const [firstSchema, secondSchema] = schema2.anyOf;
      if (firstSchema != null && secondSchema != null) {
        if (!isReferenceObject(firstSchema) && firstSchema.type === "null") {
          const convertedSchema = convertSchema(secondSchema, true, context, breadcrumbs, source, namespace);
          return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
        } else if (!isReferenceObject(secondSchema) && secondSchema.type === "null") {
          const convertedSchema = convertSchema(firstSchema, true, context, breadcrumbs, source, namespace);
          return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
        }
      }
    }
    const maybeDiscriminant = getDiscriminant({
      schemas: schema2.anyOf,
      context
    });
    if (maybeDiscriminant != null && !context.options.discriminatedUnionV2) {
      return convertDiscriminatedOneOfWithVariants({
        nameOverride,
        generatedName,
        title,
        breadcrumbs,
        properties: schema2.properties ?? {},
        required: schema2.required,
        description,
        availability,
        wrapAsNullable,
        discriminant: maybeDiscriminant.discriminant,
        variants: maybeDiscriminant.schemas,
        context,
        groupName,
        encoding,
        source,
        namespace
      });
    }
    const hasNullValue = schema2.anyOf.filter((schema3) => {
      return !isReferenceObject(schema3) && schema3.type === "null";
    }).length > 0;
    return convertUndiscriminatedOneOf({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      description,
      availability,
      wrapAsNullable: wrapAsNullable || hasNullValue,
      context,
      subtypes: schema2.anyOf.filter((schema3) => {
        return isReferenceObject(schema3) || schema3.type !== "null";
      }),
      encoding,
      groupName,
      source,
      namespace
    });
  }
  if (schema2.allOf != null || schema2.properties != null) {
    const filteredAllOfs = [];
    for (const allOf of schema2.allOf ?? []) {
      if (isReferenceObject(allOf) || Object.keys(allOf).length > 0) {
        filteredAllOfs.push(allOf);
      }
    }
    if ((schema2.properties == null || schema2.properties.length === 0) && filteredAllOfs.length === 1 && filteredAllOfs[0] != null) {
      const convertedSchema = convertSchema(filteredAllOfs[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    }
    const filteredAllOfObjects = filteredAllOfs.filter((allOf) => {
      const valid = isValidAllOfObject(allOf);
      if (!valid) {
        context.logger.warn(`Skipping non-object allOf element: ${JSON.stringify(allOf)}`);
      }
      return valid;
    });
    if ((schema2.properties == null || schema2.properties.length === 0) && filteredAllOfObjects.length === 1 && filteredAllOfObjects[0] != null) {
      const convertedSchema = convertSchema(filteredAllOfObjects[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    }
    return convertObject3({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      properties: schema2.properties ?? {},
      description,
      required: schema2.required,
      wrapAsNullable,
      allOf: filteredAllOfObjects,
      context,
      propertiesToExclude,
      groupName,
      fullExamples,
      additionalProperties: schema2.additionalProperties,
      availability,
      encoding,
      source,
      namespace
    });
  }
  if (schema2.type === "object" && hasNoOneOf(schema2) && hasNoAllOf(schema2) && hasNoProperties(schema2)) {
    return wrapMap({
      nameOverride,
      generatedName,
      title,
      description,
      availability,
      wrapAsNullable,
      keySchema: {
        nameOverride: void 0,
        generatedName: `${generatedName}Key`,
        title: void 0,
        description: void 0,
        availability: void 0,
        schema: PrimitiveSchemaValueWithExample.string({
          default: getDefaultAsString(schema2),
          pattern: schema2.pattern,
          format: schema2.format,
          minLength: schema2.minLength,
          maxLength: schema2.maxLength,
          example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
        }),
        groupName
      },
      valueSchema: SchemaWithExample.unknown({
        nameOverride: void 0,
        generatedName: `${generatedName}Value`,
        title: void 0,
        description: void 0,
        availability: void 0,
        example: void 0,
        groupName
      }),
      groupName,
      encoding,
      example: schema2.example
    });
  }
  if (schema2.type == null) {
    const inferredValue = schema2.example ?? schema2.default;
    return SchemaWithExample.unknown({
      nameOverride,
      generatedName,
      title,
      description,
      availability,
      groupName,
      example: inferredValue
    });
  }
  throw new Error(`Failed to convert schema breadcrumbs=${JSON.stringify(breadcrumbs)} value=${JSON.stringify(schema2)}`);
}
function getSchemaIdFromReference(ref) {
  if (!ref.$ref.startsWith(SCHEMA_REFERENCE_PREFIX)) {
    return void 0;
  }
  return ref.$ref.replace(SCHEMA_REFERENCE_PREFIX, "");
}
function convertToReferencedSchema(schema2, breadcrumbs, source, preserveSchemaIds) {
  const nameOverride = getExtension(schema2, FernOpenAPIExtension.TYPE_NAME);
  const generatedName = getGeneratedTypeName(breadcrumbs, preserveSchemaIds);
  const description = schema2.description;
  const availability = convertAvailability3(schema2);
  const schemaId = getSchemaIdFromReference(schema2);
  if (schemaId == null) {
    throw new Error(`Invalid schema reference ${JSON.stringify(schema2)}`);
  }
  return Schema.reference({
    // TODO(dsinghvi): references may contain files
    generatedName,
    nameOverride,
    title: void 0,
    schema: schemaId,
    description: description ?? void 0,
    availability,
    groupName: void 0,
    source
  });
}
function hasNoOneOf(schema2) {
  return schema2.oneOf == null || schema2.oneOf.length === 0;
}
function hasNoAllOf(schema2) {
  return schema2.allOf == null || schema2.allOf.length === 0;
}
function hasNoProperties(schema2) {
  return schema2.properties == null || Object.keys(schema2.properties).length === 0;
}
function isListOfStrings(x) {
  return Array.isArray(x) && x.every((item) => typeof item === "string");
}
function maybeInjectDescriptionOrGroupName(schema2, description, groupName) {
  if (schema2.type === "reference") {
    return SchemaWithExample.reference({
      ...schema2,
      description,
      availability: schema2.availability,
      groupName
    });
  } else if (schema2.type === "optional") {
    return SchemaWithExample.optional({
      nameOverride: schema2.nameOverride,
      generatedName: schema2.generatedName,
      title: schema2.title,
      value: schema2.value,
      description,
      availability: schema2.availability,
      groupName
    });
  } else if (schema2.type === "nullable") {
    return SchemaWithExample.nullable({
      nameOverride: schema2.nameOverride,
      generatedName: schema2.generatedName,
      title: schema2.title,
      value: schema2.value,
      description,
      availability: schema2.availability,
      groupName
    });
  }
  return schema2;
}
function isValidAllOfObject(allOf) {
  if (isReferenceObject(allOf) || allOf.type === "object" || allOf.properties != null) {
    return true;
  }
  if (allOf.allOf != null) {
    return allOf.allOf.every((elem) => isValidAllOfObject(elem));
  }
  if (allOf.oneOf != null) {
    return allOf.oneOf.every((elem) => isValidAllOfObject(elem));
  }
  if (allOf.anyOf != null) {
    return allOf.anyOf.every((elem) => isValidAllOfObject(elem));
  }
  return false;
}
function wrapLiteral({ literal, wrapAsNullable, groupName, description, availability, nameOverride, generatedName, title }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.literal({
        nameOverride,
        generatedName,
        title,
        value: literal,
        description,
        availability,
        groupName
      }),
      groupName,
      description,
      availability
    });
  }
  return SchemaWithExample.literal({
    nameOverride,
    generatedName,
    title,
    value: literal,
    groupName,
    description,
    availability
  });
}
function wrapPrimitive({ primitive, wrapAsNullable, groupName, description, availability, generatedName, nameOverride, title }) {
  groupName = typeof groupName === "string" ? [groupName] : groupName;
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.primitive({
        nameOverride,
        generatedName,
        title,
        schema: primitive,
        description,
        availability,
        groupName
      }),
      groupName,
      description,
      availability
    });
  }
  return SchemaWithExample.primitive({
    nameOverride,
    generatedName,
    title,
    schema: primitive,
    description,
    availability,
    groupName
  });
}
function getMaybeAllEnumValues({ schemas }) {
  const enumValues = /* @__PURE__ */ new Set();
  for (const schema2 of schemas) {
    if (isReferenceObject(schema2)) {
      return void 0;
    }
    if (schema2.enum != null && isListOfStrings(schema2.enum)) {
      schema2.enum.forEach((val) => enumValues.add(val));
    } else {
      return void 0;
    }
  }
  return Array.from(enumValues);
}
function getDiscriminant({ schemas, context }) {
  const discriminantToVariants = {};
  for (const schema2 of schemas) {
    const possibleDiscriminants = getPossibleDiscriminants({ schema: schema2, context });
    for (const [property4, value] of Object.entries(possibleDiscriminants)) {
      const variants = discriminantToVariants[property4];
      if (variants != null) {
        variants[value] = schema2;
      } else {
        discriminantToVariants[property4] = {
          [value]: schema2
        };
      }
    }
  }
  for (const [discriminant3, variants] of Object.entries(discriminantToVariants)) {
    if (Object.keys(variants).length === schemas.length) {
      return {
        discriminant: discriminant3,
        schemas: variants
      };
    }
  }
  return void 0;
}
function getPossibleDiscriminants({ schema: schema2, context }) {
  const resolvedSchema = isReferenceObject(schema2) ? context.resolveSchemaReference(schema2) : schema2;
  return getPossibleDiscriminantsForSchemaObject({ schema: resolvedSchema, context });
}
function getPossibleDiscriminantsForSchemaObject({ schema: schema2, context }) {
  const possibleDiscrimimants = {};
  if (schema2.anyOf != null) {
    for (const elem of schema2.anyOf) {
      const possibleDiscriminantsForVariant = getPossibleDiscriminants({
        schema: elem,
        context
      });
      for (const [key, value] of Object.entries(possibleDiscriminantsForVariant ?? {})) {
        possibleDiscrimimants[key] = value;
      }
    }
    return possibleDiscrimimants;
  }
  for (const [propertyName, propertySchema] of Object.entries(schema2.properties ?? {})) {
    const resolvedPropertySchema = isReferenceObject(propertySchema) ? context.resolveSchemaReference(propertySchema) : propertySchema;
    if (resolvedPropertySchema.type === "string" && resolvedPropertySchema.enum != null && isListOfStrings(resolvedPropertySchema.enum) && getEnumSet(resolvedPropertySchema.enum).length === 1 && resolvedPropertySchema.enum[0] != null) {
      possibleDiscrimimants[propertyName] = resolvedPropertySchema.enum[0];
    }
    const maybeConstValue = getProperty(resolvedPropertySchema, "const");
    if (resolvedPropertySchema.type === "string" && maybeConstValue != null) {
      possibleDiscrimimants[propertyName] = maybeConstValue;
    }
    if (propertyName === "type" && resolvedPropertySchema.example != null) {
      possibleDiscrimimants[propertyName] = resolvedPropertySchema.example;
    }
  }
  return possibleDiscrimimants;
}
function getEnumSet(enums) {
  if (!enums) {
    return [];
  }
  const set4 = /* @__PURE__ */ new Set();
  enums.forEach((item) => {
    if (typeof item === "string") {
      set4.add(item.toLowerCase());
    } else {
      set4.add(item);
    }
  });
  return Array.from(set4);
}
function getProperty(object3, property4) {
  const extensionValue = object3[property4];
  if (extensionValue != null) {
    return extensionValue;
  }
  return void 0;
}
function getEncoding({ schema: schema2, logger }) {
  const encoding = getFernEncoding({ schema: schema2, logger });
  if (encoding == null) {
    return void 0;
  }
  return convertEncoding(encoding);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/utils/getSchemas.js
function getSchemas(namespace, schemas) {
  let rootSchemas = {};
  let namespacedSchemas = {};
  if (namespace == null) {
    rootSchemas = schemas;
  } else {
    namespacedSchemas = {
      [namespace]: schemas
    };
  }
  return {
    rootSchemas,
    namespacedSchemas
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/AsyncAPIParserContext.js
var MESSAGE_REFERENCE_PREFIX = "#/components/messages/";
var AbstractAsyncAPIV2ParserContext = class {
  logger;
  document;
  taskContext;
  DUMMY;
  options;
  namespace;
  constructor({ document, taskContext, options, namespace }) {
    this.document = document;
    this.taskContext = taskContext;
    this.logger = taskContext.logger;
    this.DUMMY = this;
    this.options = options;
    this.namespace = namespace;
  }
  resolveGroupName(groupName) {
    if (this.namespace != null) {
      return [{ type: "namespace", name: this.namespace }, ...groupName];
    }
    return groupName;
  }
  resolveTags(operationTags, fallback) {
    if (this.namespace == null && operationTags == null && fallback != null) {
      return [fallback];
    }
    const tags = [];
    if (this.namespace != null) {
      const namespaceSegment = {
        type: "namespace",
        name: this.namespace
      };
      tags.push(namespaceSegment);
    }
    return tags.concat(operationTags ?? []);
  }
  resolveSchemaReference(schema2) {
    if (this.document.components == null || this.document.components.schemas == null || !schema2.$ref.startsWith(SCHEMA_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${schema2.$ref}`);
    }
    const schemaKey = schema2.$ref.substring(SCHEMA_REFERENCE_PREFIX.length);
    const splitSchemaKey = schemaKey.split("/");
    if (splitSchemaKey[0] == null) {
      throw new Error(`${schema2.$ref} is undefined`);
    }
    let resolvedSchema = this.document.components.schemas[splitSchemaKey[0]];
    if (resolvedSchema == null) {
      throw new Error(`${splitSchemaKey[0]} is undefined`);
    }
    if (isReferenceObject(resolvedSchema)) {
      resolvedSchema = this.resolveSchemaReference(resolvedSchema);
    }
    if (splitSchemaKey[1] === "properties" && splitSchemaKey[2] != null) {
      const resolvedProperty = resolvedSchema.properties?.[splitSchemaKey[2]];
      if (resolvedProperty == null) {
        throw new Error(`${schema2.$ref} is undefiened. Property does not exist on object.`);
      } else if (isReferenceObject(resolvedProperty)) {
        resolvedSchema = this.resolveSchemaReference(resolvedProperty);
      } else {
        resolvedSchema = resolvedProperty;
      }
    }
    return resolvedSchema;
  }
  resolveMessageReference(message) {
    if (this.document.components == null || this.document.components.messages == null || !message.$ref.startsWith(MESSAGE_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${message.$ref}`);
    }
    const messageKey = message.$ref.substring(MESSAGE_REFERENCE_PREFIX.length);
    const resolvedMessage = this.document.components.messages[messageKey];
    if (resolvedMessage == null) {
      throw new Error(`${message.$ref}  is undefined`);
    }
    return resolvedMessage;
  }
  referenceExists(ref) {
    const keys5 = ref.substring(2).split("/").map((key) => key.replace(/~1/g, "/"));
    let resolvedSchema = this.document;
    for (const key of keys5) {
      if (typeof resolvedSchema !== "object" || resolvedSchema == null) {
        return false;
      }
      resolvedSchema = resolvedSchema[key];
    }
    return true;
  }
};
var AsyncAPIV2ParserContext = class extends AbstractAsyncAPIV2ParserContext {
  constructor({ document, taskContext, options, namespace }) {
    super({
      document,
      taskContext,
      options,
      namespace
    });
  }
  markSchemaAsReferencedByNonRequest(schemaId) {
    return;
  }
  markSchemaAsReferencedByRequest(schemaId) {
    return;
  }
  markReferencedByDiscriminatedUnion(schema2, discrminant, times) {
    return;
  }
  markSchemaWithDiscriminantValue(schema2, discrminant, discriminantValue) {
    return;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/convertToFullExample.js
function convertToFullExample(value) {
  if (typeof value === "string") {
    return FullExample.primitive(PrimitiveExample.string(value));
  } else if (typeof value === "number") {
    if (Number.isInteger(value)) {
      return FullExample.primitive(PrimitiveExample.int(value));
    }
    return FullExample.primitive(PrimitiveExample.double(value));
  } else if (typeof value === "boolean") {
    return FullExample.primitive(PrimitiveExample.boolean(value));
  } else if (Array.isArray(value)) {
    const examples = value.map((example) => convertToFullExample(example));
    if (examples.length === 0) {
      return void 0;
    }
    return FullExample.array(examples.filter((example) => example != null));
  } else if (value != null && typeof value === "object" && Object.keys(value).every((key) => typeof key === "string")) {
    const kvs = [];
    for (const [property4, propertyValue] of Object.entries(value)) {
      const propertyExample = convertToFullExample(propertyValue);
      if (propertyExample != null) {
        kvs.push({
          key: PrimitiveExample.string(property4),
          value: propertyExample
        });
      }
    }
    return FullExample.map(kvs);
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/getFullExample.js
function getFullExampleAsObject(value) {
  if (value != null && typeof value === "object" && Object.keys(value).every((key) => typeof key === "string")) {
    return value;
  }
  return void 0;
}
function getFullExampleAsArray(value) {
  if (value != null && Array.isArray(value)) {
    return value;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/ExampleTypeFactory.js
var ExampleTypeFactory = class {
  schemas;
  nonRequestReferencedSchemas;
  context;
  constructor(schemas, nonRequestReferencedSchemas, context) {
    this.schemas = schemas;
    this.nonRequestReferencedSchemas = nonRequestReferencedSchemas;
    this.context = context;
  }
  buildExample({ schema: schema2, exampleId, example, options, skipReadonly }) {
    return this.buildExampleHelper({
      schema: schema2,
      visitedSchemaIds: /* @__PURE__ */ new Set(),
      exampleId,
      example,
      // Default maxCheckerDepth to 5
      options: { ...options, maxCheckerDepth: options.maxCheckerDepth ?? 5 },
      depth: 0,
      skipReadonly: skipReadonly ?? false
    });
  }
  buildExampleHelper({ exampleId, example, schema: schema2, depth, visitedSchemaIds, options, skipReadonly }) {
    switch (schema2.type) {
      case "enum":
        if (typeof example === "string" && enumContainsValue({ schema: schema2, value: example })) {
          return FullExample.enum(example);
        }
        return schema2.values[0] != null ? FullExample.enum(schema2.values[0]?.value) : void 0;
      case "literal":
        return FullExample.literal(schema2.value);
      case "nullable": {
        if (example == null && !this.hasExample(schema2.value, 0, visitedSchemaIds, options) && (options.ignoreOptionals || this.exceedsMaxDepth(depth, options))) {
          return void 0;
        }
        const result = this.buildExampleHelper({
          schema: schema2.value,
          visitedSchemaIds,
          exampleId,
          example,
          depth,
          options,
          skipReadonly
        });
        if (result != null && result.type === "array" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "map" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "object" && Object.keys(result.properties).length === 0) {
          return void 0;
        }
        return result;
      }
      case "optional": {
        if (example == null && !this.hasExample(schema2.value, 0, visitedSchemaIds, options) && (options.ignoreOptionals || this.exceedsMaxDepth(depth, options))) {
          return void 0;
        }
        if (Object.is(example, null)) {
          return void 0;
        }
        const result = this.buildExampleHelper({
          schema: schema2.value,
          visitedSchemaIds,
          exampleId,
          example,
          depth,
          options,
          skipReadonly
        });
        if (result != null && result.type === "array" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "map" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "object" && Object.keys(result.properties).length === 0) {
          return void 0;
        }
        return result;
      }
      case "primitive": {
        const primitiveExample = this.buildExampleFromPrimitive({ schema: schema2.schema, example, options });
        return FullExample.primitive(primitiveExample);
      }
      case "reference": {
        const referencedSchemaWithExample = this.schemas[schema2.schema];
        if (referencedSchemaWithExample != null && !visitedSchemaIds.has(schema2.schema)) {
          visitedSchemaIds.add(schema2.schema);
          const isInlinedRequest = referencedSchemaWithExample?.type === "object" && !this.nonRequestReferencedSchemas.has(schema2.schema);
          const referencedExample = this.buildExampleHelper({
            example,
            schema: referencedSchemaWithExample,
            exampleId,
            visitedSchemaIds,
            depth,
            options,
            // by default we respect readonly on inlined requests
            skipReadonly: isInlinedRequest || this.context.options.respectReadonlySchemas ? skipReadonly : false
          });
          visitedSchemaIds.delete(schema2.schema);
          return referencedExample;
        }
        return void 0;
      }
      case "oneOf":
        switch (schema2.value.type) {
          case "discriminated": {
            const result = {};
            let allProperties = {};
            let requiredProperties = {};
            const fullExample = getFullExampleAsObject(example);
            const exampleDiscriminant = fullExample?.[schema2.value.discriminantProperty];
            const exampleUnionVariantSchema = schema2.value.schemas[exampleDiscriminant];
            const unionVariants = [];
            const schemaFromExample = this.getDiscriminatedUnionVariantSchema(schema2.value, fullExample);
            if (schemaFromExample != null) {
              unionVariants.push(schemaFromExample);
            }
            unionVariants.push(...Object.entries(schema2.value.schemas));
            for (const unionVariant of unionVariants) {
              if (exampleDiscriminant != null && exampleUnionVariantSchema != null && exampleUnionVariantSchema.type === "object") {
                allProperties = this.getAllProperties(exampleUnionVariantSchema);
                requiredProperties = this.getAllRequiredProperties(exampleUnionVariantSchema);
                result[schema2.value.discriminantProperty] = FullExample.primitive(PrimitiveExample.string(exampleDiscriminant));
                break;
              } else {
                const objectSchema = this.getObjectSchema(unionVariant[1]);
                if (objectSchema == null) {
                  continue;
                }
                allProperties = this.getAllProperties(objectSchema);
                requiredProperties = this.getAllRequiredProperties(objectSchema);
                result[schema2.value.discriminantProperty] = FullExample.primitive(PrimitiveExample.string(unionVariant[0]));
              }
            }
            for (const commonProperty of schema2.value.commonProperties) {
              allProperties[commonProperty.key] = { schema: commonProperty.schema, readonly: false };
              const resolvedSchema = this.getResolvedSchema(commonProperty.schema);
              if (resolvedSchema.type !== "optional" && resolvedSchema.type !== "nullable") {
                requiredProperties[commonProperty.key] = commonProperty.schema;
              }
            }
            for (const [property4, schema3] of Object.entries(allProperties)) {
              const required = property4 in requiredProperties;
              if (required && fullExample?.[property4] != null) {
                const propertyExample = this.buildExampleHelper({
                  schema: schema3.schema,
                  exampleId,
                  example: fullExample[property4],
                  visitedSchemaIds,
                  depth: depth + 1,
                  options,
                  skipReadonly
                });
                if (propertyExample != null) {
                  result[property4] = propertyExample;
                } else {
                  return void 0;
                }
              } else {
                const propertyExample = this.buildExampleHelper({
                  exampleId,
                  schema: schema3.schema,
                  example: fullExample?.[property4],
                  visitedSchemaIds,
                  depth: depth + 1,
                  options,
                  skipReadonly
                });
                if (propertyExample != null) {
                  result[property4] = propertyExample;
                } else if (required) {
                  return void 0;
                }
              }
            }
            return FullExample.oneOf(FullOneOfExample.discriminated(result));
          }
          case "undisciminated": {
            const unionVariantSchema = this.getUnDiscriminatedUnionVariantSchema(schema2.value, example);
            if (unionVariantSchema != null) {
              return this.buildExampleHelper({
                exampleId,
                example,
                schema: unionVariantSchema,
                visitedSchemaIds,
                depth,
                options,
                skipReadonly
              });
            }
            break;
          }
        }
        return void 0;
      case "unknown":
        if (example != null) {
          const fullExample = convertToFullExample(example);
          if (fullExample != null) {
            return FullExample.unknown(fullExample);
          }
        }
        if (options.ignoreOptionals || this.exceedsMaxDepth(depth, options)) {
          return void 0;
        }
        if (options.isParameter) {
          return FullExample.primitive(PrimitiveExample.string(options.name ?? "string"));
        }
        return FullExample.map([
          {
            key: PrimitiveExample.string("key"),
            value: FullExample.primitive(PrimitiveExample.string("value"))
          }
        ]);
      case "array": {
        const fullExample = getFullExampleAsArray(example);
        const itemExamples = [];
        if (fullExample != null && fullExample.length > 0) {
          for (const item of fullExample) {
            const itemExample = this.buildExampleHelper({
              exampleId,
              example: item,
              schema: schema2.value,
              depth: depth + 1,
              visitedSchemaIds,
              options,
              skipReadonly
            });
            if (itemExample != null) {
              itemExamples.push(itemExample);
            }
          }
        } else if (schema2.example != null && schema2.example.length > 0) {
          for (const item of schema2.example) {
            const itemExample = this.buildExampleHelper({
              exampleId,
              example: item,
              schema: schema2.value,
              depth: depth + 1,
              visitedSchemaIds,
              options,
              skipReadonly
            });
            if (itemExample != null) {
              itemExamples.push(itemExample);
            }
          }
        } else {
          const itemExample = this.buildExampleHelper({
            exampleId,
            example: void 0,
            schema: schema2.value,
            depth: depth + 1,
            visitedSchemaIds,
            options,
            skipReadonly
          });
          if (itemExample != null) {
            itemExamples.push(itemExample);
          }
        }
        return FullExample.array(itemExamples);
      }
      case "map": {
        const objectExample = getFullExampleAsObject(example ?? schema2.example);
        if (objectExample != null && Object.entries(objectExample).length > 0) {
          const kvs = [];
          for (const [key, value] of Object.entries(objectExample)) {
            const keyExample2 = this.buildExampleFromPrimitive({
              schema: schema2.key.schema,
              example: key,
              options
            });
            const valueExample2 = this.buildExampleHelper({
              exampleId,
              example: value,
              schema: schema2.value,
              visitedSchemaIds,
              depth: depth + 1,
              options,
              skipReadonly
            });
            if (valueExample2 != null) {
              kvs.push({
                key: keyExample2,
                value: valueExample2
              });
            }
          }
          return FullExample.map(kvs);
        }
        if (schema2.key.schema.type === "string" && schema2.value.type === "unknown") {
          return FullExample.map([
            {
              key: PrimitiveExample.string("key"),
              value: FullExample.unknown(FullExample.primitive(PrimitiveExample.string("value")))
            }
          ]);
        }
        const keyExample = this.buildExampleFromPrimitive({
          schema: schema2.key.schema,
          example: void 0,
          options: {
            ...options,
            // override the name to be "key" for map keys otherwise you can start to get key name
            // nesting since primitive examples use their name e.g. "metadata": {"metadata": {...}}
            name: "key"
          }
        });
        const valueExample = this.buildExampleHelper({
          exampleId,
          example: void 0,
          schema: schema2.value,
          visitedSchemaIds,
          depth: depth + 1,
          options: {
            ...options,
            // override the name to be "value" for map value otherwise you can start to get key name
            // nesting since primitive examples use their name e.g. "metadata": {"metadata": "metadata"}
            name: "value"
          },
          skipReadonly
        });
        if (valueExample != null) {
          return FullExample.map([
            {
              key: keyExample,
              value: valueExample
            }
          ]);
        }
        return FullExample.map([]);
      }
      case "object": {
        const result = {};
        const foundObjectExample = schema2.fullExamples?.find((example2) => example2.name === exampleId) ?? schema2.fullExamples?.find((example2) => example2.name == null) ?? schema2.fullExamples?.[0];
        const fullExample = getFullExampleAsObject(example) ?? (foundObjectExample != null ? getFullExampleAsObject(foundObjectExample.value) : {}) ?? {};
        const allProperties = this.getAllProperties(schema2);
        const requiredProperties = this.getAllRequiredProperties(schema2);
        for (const [property4, schema3] of Object.entries(allProperties)) {
          if (skipReadonly && schema3.readonly) {
            continue;
          }
          const required = property4 in requiredProperties;
          const inExample = Object.keys(fullExample).includes(property4);
          const propertyExample = this.buildExampleHelper({
            schema: schema3.schema,
            exampleId,
            example: fullExample[property4],
            visitedSchemaIds,
            depth: depth + 1,
            options: {
              ...options,
              name: property4
            },
            skipReadonly
          });
          if (required && propertyExample != null) {
            result[property4] = propertyExample;
          } else if (required) {
            return void 0;
          } else if (inExample && propertyExample != null) {
            result[property4] = propertyExample;
          } else if (!options.ignoreOptionals && propertyExample != null) {
            result[property4] = propertyExample;
          }
        }
        return FullExample.object({
          properties: result
        });
      }
      default:
        assertNever(schema2);
    }
  }
  getObjectSchema(schema2) {
    if (schema2.type === "object") {
      return schema2;
    }
    if (schema2.type === "reference") {
      const referenceDeclaration = this.schemas[schema2.schema];
      if (referenceDeclaration != null) {
        return this.getObjectSchema(referenceDeclaration);
      }
    }
    return void 0;
  }
  getDiscriminatedUnionVariantSchema(schema2, fullExample) {
    const discriminantValue = fullExample?.[schema2.discriminantProperty];
    if (discriminantValue == null || typeof discriminantValue !== "string") {
      return Object.entries(schema2.schemas)[0];
    }
    const unionVariantSchema = schema2.schemas[discriminantValue];
    if (unionVariantSchema == null) {
      return Object.entries(schema2.schemas)[0];
    }
    return [discriminantValue, unionVariantSchema];
  }
  getUnDiscriminatedUnionVariantSchema(schema2, fullExample) {
    if (fullExample == null) {
      return schema2.schemas[0];
    }
    const matches = schema2.schemas.map((schema3) => ({
      schema: schema3,
      heuristic: this.calcExampleHeuristic(schema3, fullExample)
    }));
    const sortedMatches = matches.sort((a, b) => b.heuristic - a.heuristic);
    return sortedMatches[0]?.schema;
  }
  // this is not a perfect heuristic, but it's a start. algorithm is as follows:
  // * tally up all properties that are both in the schema and example when traversing recursively
  // * subtract 1 for every property that is in the example but not in the schema.
  // this doesn't account for objects that can have arbitrary properties, and overvalues schemas with more properties.
  calcExampleHeuristic(schema2, fullExample) {
    switch (schema2.type) {
      case "literal": {
        return schema2.value.value === fullExample ? 5 : 0;
      }
      case "enum": {
        return enumContainsValue({ schema: schema2, value: fullExample }) ? 5 : 0;
      }
      case "object": {
        if (!isPlainObject2(fullExample)) {
          return 0;
        }
        const allProperties = this.getAllProperties(schema2);
        let heuristic = 0;
        for (const [property4, schema3] of Object.entries(allProperties)) {
          if (fullExample[property4] != null) {
            heuristic++;
            heuristic += this.calcExampleHeuristic(schema3.schema, fullExample[property4]);
          } else {
            heuristic--;
          }
        }
        return heuristic;
      }
      case "array": {
        if (!Array.isArray(fullExample)) {
          return 0;
        }
        let heuristic = 0;
        for (const item of fullExample) {
          heuristic += this.calcExampleHeuristic(schema2.value, item);
        }
        return heuristic;
      }
      case "map": {
        if (!isPlainObject2(fullExample)) {
          return 0;
        }
        let heuristic = 0;
        for (const [, value] of Object.entries(fullExample)) {
          heuristic += this.calcExampleHeuristic(schema2.value, value);
        }
        return heuristic;
      }
      case "nullable":
      case "optional": {
        return this.calcExampleHeuristic(schema2.value, fullExample);
      }
      case "reference": {
        const resolvedSchema = this.getResolvedSchema(schema2);
        if (resolvedSchema == null) {
          return 0;
        }
        return this.calcExampleHeuristic(resolvedSchema, fullExample);
      }
      case "oneOf": {
        const matches = Object.values(schema2.value.schemas).map((schema3) => this.calcExampleHeuristic(schema3, fullExample));
        return matches.sort((a, b) => b - a)[0] ?? 0;
      }
      case "primitive": {
        if (fullExample == null) {
          return 0;
        }
        const matches = schema2.schema._visit({
          int: () => typeof fullExample === "number",
          int64: () => typeof fullExample === "number",
          uint: () => typeof fullExample === "number",
          uint64: () => typeof fullExample === "number",
          float: () => typeof fullExample === "number",
          double: () => typeof fullExample === "number",
          string: () => typeof fullExample === "string",
          datetime: () => typeof fullExample === "string",
          date: () => typeof fullExample === "string",
          base64: () => typeof fullExample === "string",
          boolean: () => typeof fullExample === "boolean",
          _other: () => true
        });
        return matches ? 1 : -1;
      }
      default:
        return 0;
    }
  }
  hasExample(schema2, depth, visitedSchemaIds = /* @__PURE__ */ new Set(), options) {
    if (this.exceedsMaxCheckerDepth(depth, options)) {
      return false;
    }
    switch (schema2.type) {
      case "array":
        return this.hasExample(schema2.value, depth + 1, visitedSchemaIds, options);
      case "enum":
        return schema2.example != null;
      case "literal":
        return false;
      case "map":
        return schema2.example != null || schema2.key.schema.example != null && this.hasExample(schema2.value, depth + 1, visitedSchemaIds, options);
      case "object": {
        const objectExample = schema2.fullExamples != null && schema2.fullExamples.length > 0;
        if (objectExample) {
          return true;
        }
        for (const property4 of schema2.properties) {
          if (this.hasExample(property4.schema, depth + 1, visitedSchemaIds, options)) {
            return true;
          }
        }
        return false;
      }
      case "primitive":
        return schema2.schema.example != null;
      case "reference": {
        const resolvedSchema = this.schemas[schema2.schema];
        if (resolvedSchema != null && !visitedSchemaIds.has(schema2.schema)) {
          visitedSchemaIds.add(schema2.schema);
          const hasExample = this.hasExample(resolvedSchema, depth, visitedSchemaIds, options);
          visitedSchemaIds.delete(schema2.schema);
          return hasExample;
        }
        return false;
      }
      case "unknown":
        return schema2.example != null;
      case "oneOf":
        return Object.values(schema2.value.schemas).some((schema3) => this.hasExample(schema3, depth, visitedSchemaIds, options));
      default:
        return false;
    }
  }
  exceedsMaxCheckerDepth(depth, options) {
    return depth > (options.maxCheckerDepth ?? 0);
  }
  exceedsMaxDepth(depth, options) {
    return depth > (options.maxDepth ?? 0);
  }
  getAllProperties(object3) {
    let properties = {};
    for (const property4 of object3.properties) {
      properties[property4.key] = { schema: property4.schema, readonly: property4.readonly ?? false };
    }
    for (const allOf of object3.allOf) {
      const allOfSchema = this.schemas[allOf.schema];
      if (allOfSchema == null) {
        continue;
      }
      const resolvedAllOfSchema = this.getResolvedSchema(allOfSchema);
      if (resolvedAllOfSchema.type !== "object") {
        continue;
      }
      properties = {
        ...this.getAllProperties(resolvedAllOfSchema),
        ...properties
      };
    }
    return properties;
  }
  getAllRequiredProperties(object3) {
    let requiredProperties = {};
    for (const property4 of object3.properties) {
      const resolvedSchema = this.getResolvedSchema(property4.schema);
      if (resolvedSchema.type !== "optional" && resolvedSchema.type !== "nullable") {
        requiredProperties[property4.key] = property4.schema;
      }
    }
    for (const allOf of object3.allOf) {
      const allOfSchema = this.schemas[allOf.schema];
      if (allOfSchema == null) {
        continue;
      }
      const resolvedAllOfSchema = this.getResolvedSchema(allOfSchema);
      if (resolvedAllOfSchema.type !== "object") {
        continue;
      }
      requiredProperties = {
        ...this.getAllRequiredProperties(resolvedAllOfSchema),
        ...requiredProperties
      };
    }
    return requiredProperties;
  }
  getResolvedSchema(schema2) {
    while (schema2.type === "reference") {
      const resolvedSchema = this.schemas[schema2.schema];
      if (resolvedSchema == null) {
        throw new Error(`Unexpected error: Failed to resolve schema reference: ${schema2.schema}`);
      }
      schema2 = resolvedSchema;
    }
    return schema2;
  }
  buildExampleFromPrimitive({ example, schema: schema2, options }) {
    switch (schema2.type) {
      case "string":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.string(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.string(schema2.example);
        } else {
          return PrimitiveExample.string(options.name ?? examples_exports.STRING);
        }
      case "base64":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.base64(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.base64(schema2.example);
        } else {
          return PrimitiveExample.base64(examples_exports.BASE64);
        }
      case "boolean":
        if (example != null && typeof example === "boolean") {
          return PrimitiveExample.boolean(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.boolean(schema2.example);
        } else {
          return PrimitiveExample.boolean(examples_exports.BOOLEAN);
        }
      case "date":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.date(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.date(schema2.example);
        } else {
          return PrimitiveExample.date(examples_exports.DATE);
        }
      case "datetime":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.datetime(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.datetime(schema2.example);
        } else {
          return PrimitiveExample.datetime(examples_exports.DATE_TIME);
        }
      case "double":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.double(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.double(schema2.example);
        } else {
          return PrimitiveExample.double(examples_exports.DOUBLE);
        }
      case "float":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.float(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.float(schema2.example);
        } else {
          return PrimitiveExample.float(examples_exports.FLOAT);
        }
      case "int":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.int(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.int(schema2.example);
        } else {
          return PrimitiveExample.int(examples_exports.INT);
        }
      case "int64":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.int64(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.int64(schema2.example);
        } else {
          return PrimitiveExample.int64(examples_exports.INT64);
        }
      case "uint":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.uint(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.uint(schema2.example);
        } else {
          return PrimitiveExample.uint(examples_exports.UINT);
        }
      case "uint64":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.uint64(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.uint64(schema2.example);
        } else {
          return PrimitiveExample.uint64(examples_exports.UINT64);
        }
      default:
        assertNever(schema2);
    }
  }
};
function enumContainsValue({ schema: schema2, value }) {
  return schema2.values.map((enumValue) => {
    return enumValue.value;
  }).includes(value);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/convertSchemaToSchemaWithExample.js
function convertSchemaToSchemaWithExample(schema2) {
  switch (schema2.type) {
    case "object":
      return SchemaWithExample.object({
        allOf: schema2.allOf,
        properties: schema2.properties.map((objectProperty) => convertToObjectProperty2(objectProperty)),
        allOfPropertyConflicts: schema2.allOfPropertyConflicts,
        description: schema2.description,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName,
        fullExamples: void 0,
        additionalProperties: schema2.additionalProperties,
        availability: schema2.availability,
        source: schema2.source
      });
    case "array":
      return SchemaWithExample.array({
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaToSchemaWithExample(schema2.value),
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName,
        example: void 0
      });
    case "enum":
      return SchemaWithExample.enum({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        values: schema2.values,
        default: schema2.default,
        groupName: schema2.groupName,
        example: void 0,
        source: schema2.source
      });
    case "literal":
      return SchemaWithExample.literal({
        description: schema2.description,
        availability: schema2.availability,
        value: schema2.value,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName
      });
    case "nullable":
      return SchemaWithExample.nullable({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaToSchemaWithExample(schema2.value),
        groupName: schema2.groupName
      });
    case "optional":
      return SchemaWithExample.optional({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaToSchemaWithExample(schema2.value),
        groupName: schema2.groupName
      });
    case "primitive":
      return SchemaWithExample.primitive({
        description: schema2.description,
        availability: schema2.availability,
        schema: convertToPrimitiveSchemaValue2(schema2.schema),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "map":
      return SchemaWithExample.map({
        description: schema2.description,
        availability: schema2.availability,
        key: SchemaWithExample.primitive({
          description: schema2.key.description,
          availability: schema2.key.availability,
          schema: convertToPrimitiveSchemaValue2(schema2.key.schema),
          generatedName: schema2.key.generatedName,
          nameOverride: schema2.key.nameOverride,
          title: schema2.key.title,
          groupName: schema2.groupName
        }),
        value: convertSchemaToSchemaWithExample(schema2.value),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName,
        encoding: schema2.encoding,
        example: void 0
      });
    case "reference":
      return SchemaWithExample.reference({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        schema: schema2.schema,
        groupName: schema2.groupName,
        source: schema2.source
      });
    case "oneOf":
      return SchemaWithExample.oneOf(convertToOneOf2(schema2.value));
    case "unknown":
      return SchemaWithExample.unknown({
        nameOverride: schema2.nameOverride,
        generatedName: schema2.generatedName,
        title: void 0,
        example: void 0,
        groupName: void 0,
        description: void 0,
        availability: void 0
      });
    default:
      assertNever(schema2);
  }
}
function convertToOneOf2(oneOfSchema) {
  switch (oneOfSchema.type) {
    case "discriminated":
      return OneOfSchemaWithExample.discriminated({
        commonProperties: oneOfSchema.commonProperties.map((commonProperty) => {
          return {
            key: commonProperty.key,
            schema: convertSchemaToSchemaWithExample(commonProperty.schema)
          };
        }),
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        discriminantProperty: oneOfSchema.discriminantProperty,
        generatedName: oneOfSchema.generatedName,
        nameOverride: oneOfSchema.nameOverride,
        title: oneOfSchema.title,
        schemas: Object.fromEntries(Object.entries(oneOfSchema.schemas).map(([discriminantValue, schemaWithExample]) => {
          return [discriminantValue, convertSchemaToSchemaWithExample(schemaWithExample)];
        })),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    case "undisciminated":
      return OneOfSchemaWithExample.undisciminated({
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        generatedName: oneOfSchema.generatedName,
        nameOverride: oneOfSchema.nameOverride,
        title: oneOfSchema.title,
        schemas: oneOfSchema.schemas.map((oneOfSchema2) => convertSchemaToSchemaWithExample(oneOfSchema2)),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    default:
      assertNever(oneOfSchema);
  }
}
function convertToPrimitiveSchemaValue2(primitiveSchema) {
  switch (primitiveSchema.type) {
    case "string":
      return PrimitiveSchemaValueWithExample.string({
        default: primitiveSchema.default,
        pattern: primitiveSchema.pattern,
        format: primitiveSchema.format,
        minLength: primitiveSchema.minLength,
        maxLength: primitiveSchema.maxLength,
        example: void 0
      });
    case "base64":
      return PrimitiveSchemaValueWithExample.base64({
        example: void 0
      });
    case "boolean":
      return PrimitiveSchemaValueWithExample.boolean({
        default: primitiveSchema.default,
        example: void 0
      });
    case "date":
      return PrimitiveSchemaValueWithExample.date({
        example: void 0
      });
    case "datetime":
      return PrimitiveSchemaValueWithExample.datetime({
        example: void 0
      });
    case "double":
      return PrimitiveSchemaValueWithExample.double({
        default: primitiveSchema.default,
        minimum: primitiveSchema.minimum,
        maximum: primitiveSchema.maximum,
        exclusiveMinimum: primitiveSchema.exclusiveMinimum,
        exclusiveMaximum: primitiveSchema.exclusiveMaximum,
        multipleOf: primitiveSchema.multipleOf,
        example: void 0
      });
    case "float":
      return PrimitiveSchemaValueWithExample.float({
        example: void 0
      });
    case "int":
      return PrimitiveSchemaValueWithExample.int({
        default: primitiveSchema.default,
        minimum: primitiveSchema.minimum,
        maximum: primitiveSchema.maximum,
        exclusiveMinimum: primitiveSchema.exclusiveMinimum,
        exclusiveMaximum: primitiveSchema.exclusiveMaximum,
        multipleOf: primitiveSchema.multipleOf,
        example: void 0
      });
    case "int64":
      return PrimitiveSchemaValueWithExample.int64({
        default: primitiveSchema.default,
        example: void 0
      });
    case "uint":
      return PrimitiveSchemaValueWithExample.uint({
        default: void 0,
        example: void 0
      });
    case "uint64":
      return PrimitiveSchemaValueWithExample.uint64({
        default: void 0,
        example: void 0
      });
    default:
      assertNever(primitiveSchema);
  }
}
function convertToObjectProperty2(objectProperty) {
  return {
    conflict: objectProperty.conflict,
    generatedName: objectProperty.generatedName,
    key: objectProperty.key,
    schema: convertSchemaToSchemaWithExample(objectProperty.schema),
    audiences: objectProperty.audiences,
    nameOverride: objectProperty.nameOverride,
    availability: objectProperty.availability,
    readonly: objectProperty.readonly
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/isSchemaRequired.js
function isSchemaRequired3(schema2) {
  return schema2.type !== "optional" && schema2.type !== "nullable";
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/hasIncompleteExample.js
function hasIncompleteExample(example) {
  if (example.type === "full") {
    return example.request == null && example.response == null && example.queryParameters == null && example.pathParameters == null && example.headers == null;
  } else {
    const castExample = example.value;
    return castExample.request == null && castExample.response == null && castExample["query-parameters"] == null && castExample["path-parameters"] == null && castExample.headers == null;
  }
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/ExampleEndpointFactory.js
var ExampleEndpointFactory = class {
  exampleTypeFactory;
  logger;
  schemas;
  constructor(schemas, context) {
    this.schemas = schemas;
    this.exampleTypeFactory = new ExampleTypeFactory(schemas, context.nonRequestReferencedSchemas, context);
    this.logger = context.logger;
  }
  buildEndpointExample(endpoint) {
    this.logger.debug(`Building endpoint example for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
    const requestSchemaIdResponse = getRequestSchema(endpoint.request);
    const responseSchemaIdResponse = getResponseSchema(endpoint.response);
    if (requestSchemaIdResponse?.type === "unsupported" || responseSchemaIdResponse?.type === "unsupported") {
      return [];
    }
    const requestExamples = [];
    if (requestSchemaIdResponse != null && requestSchemaIdResponse.type === "present") {
      const required = this.isSchemaRequired(requestSchemaIdResponse.schema);
      if (requestSchemaIdResponse.examples.length === 0) {
        const example = this.exampleTypeFactory.buildExample({
          skipReadonly: endpoint.method === "POST" || endpoint.method === "PUT",
          schema: requestSchemaIdResponse.schema,
          exampleId: void 0,
          example: void 0,
          options: {
            isParameter: false,
            ignoreOptionals: true
          }
        });
        if (example != null) {
          requestExamples.push([void 0, example]);
        }
      } else {
        for (const { name: exampleId, value: rawExample } of requestSchemaIdResponse.examples) {
          const example = this.exampleTypeFactory.buildExample({
            skipReadonly: endpoint.method === "POST" || endpoint.method === "PUT",
            schema: requestSchemaIdResponse.schema,
            exampleId,
            example: rawExample,
            options: {
              isParameter: false,
              ignoreOptionals: true
            }
          });
          if (example != null) {
            requestExamples.push([exampleId, example]);
          }
        }
      }
      if (required && requestExamples.length === 0) {
        this.logger.warn(`Failed to generate required request example for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        return [];
      }
    }
    const responseExamples = [];
    if (responseSchemaIdResponse != null && responseSchemaIdResponse.type === "present") {
      const required = this.isSchemaRequired(responseSchemaIdResponse.schema);
      if (responseSchemaIdResponse.examples.length === 0) {
        const example = this.exampleTypeFactory.buildExample({
          skipReadonly: false,
          schema: responseSchemaIdResponse.schema,
          exampleId: void 0,
          example: void 0,
          options: {
            maxDepth: 3,
            isParameter: false,
            ignoreOptionals: false
          }
        });
        if (example != null) {
          if (endpoint.response?.type === "json") {
            responseExamples.push([void 0, EndpointResponseExample.withoutStreaming(example)]);
          } else if (endpoint.response?.type === "streamingJson") {
            responseExamples.push([void 0, EndpointResponseExample.withStreaming([example])]);
          }
        }
      } else {
        for (const { name: exampleId, value: rawExample } of responseSchemaIdResponse.examples) {
          const example = this.exampleTypeFactory.buildExample({
            skipReadonly: false,
            schema: responseSchemaIdResponse.schema,
            exampleId,
            example: rawExample,
            options: {
              maxDepth: 3,
              isParameter: false,
              ignoreOptionals: false
            }
          });
          if (example != null) {
            if (endpoint.response?.type === "json") {
              responseExamples.push([exampleId, EndpointResponseExample.withoutStreaming(example)]);
            } else if (endpoint.response?.type === "streamingJson") {
              responseExamples.push([exampleId, EndpointResponseExample.withStreaming([example])]);
            }
          }
        }
      }
      if (required && responseExamples.length === 0) {
        this.logger.warn(`Failed to generate required response example for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        return [];
      }
    }
    const pathParameters = [];
    for (const pathParameter of endpoint.pathParameters) {
      const required = this.isSchemaRequired(pathParameter.schema);
      let example = this.exampleTypeFactory.buildExample({
        schema: pathParameter.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: pathParameter.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example != null && !isExamplePrimitive(example)) {
        this.logger.warn(`Expected a primitive example but got ${example.type} for path parameter ${pathParameter.name} for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        example = void 0;
      }
      if (required && example == null) {
        return [];
      } else if (example != null) {
        pathParameters.push({
          name: pathParameter.name,
          parameterNameOverride: pathParameter.parameterNameOverride,
          value: example
        });
      }
    }
    const queryParameters = [];
    for (const queryParameter of endpoint.queryParameters) {
      const required = this.isSchemaRequired(queryParameter.schema);
      let example = this.exampleTypeFactory.buildExample({
        schema: queryParameter.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: queryParameter.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example != null && !isExamplePrimitive(example)) {
        this.logger.warn(`Expected a primitive example but got ${example.type} for query parameter ${queryParameter.name} for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        example = void 0;
      }
      if (required && example == null) {
        return [];
      } else if (example != null) {
        queryParameters.push({
          name: queryParameter.name,
          value: example
        });
      }
    }
    const headers = [];
    for (const header of endpoint.headers) {
      const required = this.isSchemaRequired(header.schema);
      let example = this.exampleTypeFactory.buildExample({
        schema: header.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: header.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example != null && !isExamplePrimitive(example)) {
        this.logger.warn(`Expected a primitive example but got ${example.type} for header ${header.name} for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        example = void 0;
      }
      if (required && example == null) {
        return [];
      } else if (example != null) {
        headers.push({
          name: header.name,
          value: example
        });
      }
    }
    let requestResponsePairs = [];
    if (endpoint.request != null && endpoint.response != null) {
      requestResponsePairs = consolidateRequestResponseExamples(requestExamples, responseExamples);
    } else if (endpoint.request != null) {
      requestResponsePairs = requestExamples.map(([id, example]) => {
        return { id, request: example, response: void 0 };
      });
    } else if (endpoint.response != null) {
      requestResponsePairs = responseExamples.map(([id, example]) => {
        return { id, request: void 0, response: example };
      });
    }
    const codeSamples = endpoint.examples.filter((ex) => hasIncompleteExample(ex)).flatMap((ex) => {
      if (ex.type === "unknown") {
        if (ex.value != null) {
          const samples = ex.value["code-samples"];
          if (samples != null) {
            return this.convertCodeSamples(samples);
          }
        }
        return void 0;
      } else {
        return ex.codeSamples;
      }
    }).filter((ex) => isNonNullish(ex));
    if (requestResponsePairs.length === 0) {
      return [
        EndpointExample.full({
          name: void 0,
          description: void 0,
          pathParameters,
          queryParameters,
          headers,
          request: void 0,
          response: void 0,
          codeSamples
        })
      ];
    }
    return requestResponsePairs.map(({ id: exampleName, request: requestExample, response: responseExample }) => {
      return EndpointExample.full({
        name: exampleName,
        description: void 0,
        pathParameters,
        queryParameters,
        headers,
        request: requestExample,
        response: responseExample,
        codeSamples
      });
    });
  }
  convertCodeSamples(codeSamples) {
    return codeSamples.map((codeSample) => {
      if ("language" in codeSample) {
        return CustomCodeSample.language({
          name: codeSample.name ?? void 0,
          description: codeSample.docs ?? void 0,
          language: codeSample.language,
          code: codeSample.code,
          install: codeSample.install ?? void 0
        });
      } else {
        return CustomCodeSample.sdk({
          name: codeSample.name ?? void 0,
          description: codeSample.docs ?? void 0,
          sdk: codeSample.sdk === "c#" ? SupportedSdkLanguage.Csharp : codeSample.sdk,
          code: codeSample.code
        });
      }
    }).filter(isNonNullish);
  }
  isSchemaRequired(schema2) {
    return isSchemaRequired3(this.getResolvedSchema(schema2));
  }
  getResolvedSchema(schema2) {
    return schema2;
  }
};
function consolidateRequestResponseExamples(requestExamples, responseExamples) {
  const pairs2 = [];
  if (requestExamples.length <= 1) {
    const [requestId, requestExample] = requestExamples[0] ?? [];
    if (responseExamples.length === 0) {
      pairs2.push({
        id: requestId,
        request: requestExample,
        response: void 0
      });
      return pairs2;
    } else {
      for (const [responseId, responseExample] of responseExamples) {
        pairs2.push({
          id: responseId ?? requestId,
          request: requestExample,
          response: responseExample
        });
      }
    }
    return pairs2;
  }
  if (responseExamples.length <= 1) {
    const [responseId, responseExample] = responseExamples[0] ?? [];
    if (responseExamples.length === 0) {
      pairs2.push({
        id: responseId,
        request: void 0,
        response: responseExample
      });
      return pairs2;
    } else {
      for (const [requestId, requestExample] of requestExamples) {
        pairs2.push({
          id: requestId ?? responseId,
          request: requestExample,
          response: responseExample
        });
      }
    }
    return pairs2;
  }
  const visitedResponseIdx = /* @__PURE__ */ new Set();
  for (const [requestId, requestExample] of requestExamples) {
    const fallbackResponseExample = responseExamples.find(([responseId]) => responseId == null)?.[1] ?? responseExamples[0]?.[1];
    if (requestId == null) {
      if (fallbackResponseExample == null) {
        continue;
      }
      pairs2.push({
        id: void 0,
        request: requestExample,
        response: fallbackResponseExample
      });
      continue;
    }
    let paired = false;
    for (let idx = 0; idx < responseExamples.length; idx++) {
      const [responseId, responseExample] = responseExamples[idx];
      if (responseId == null || visitedResponseIdx.has(idx)) {
        continue;
      }
      if (requestId === responseId) {
        pairs2.push({
          id: requestId,
          request: requestExample,
          response: responseExample
        });
        if (responseId != null) {
          visitedResponseIdx.add(idx);
        }
        paired = true;
      }
    }
    if (!paired && fallbackResponseExample != null) {
      pairs2.push({
        id: requestId,
        request: requestExample,
        response: fallbackResponseExample
      });
    }
  }
  for (let idx = 0; idx < responseExamples.length; idx++) {
    if (visitedResponseIdx.has(idx)) {
      continue;
    }
    const [responseId, responseExample] = responseExamples[idx];
    const requestExample = requestExamples.find(([requestId]) => requestId == null)?.[1] ?? requestExamples[0]?.[1];
    if (requestExample != null) {
      pairs2.push({
        id: responseId,
        request: requestExample,
        response: responseExample
      });
    }
  }
  return pairs2;
}
function getRequestSchema(request) {
  if (request == null) {
    return void 0;
  }
  if (request.type === "multipart") {
    return {
      type: "present",
      schema: convertMultipartRequestToSchema(request),
      examples: []
    };
  }
  if (request.type === "json") {
    return { type: "present", schema: request.schema, examples: request.fullExamples ?? [] };
  }
  return { type: "unsupported" };
}
function getResponseSchema(response) {
  if (response == null) {
    return void 0;
  }
  if (response.type !== "json" && response.type !== "streamingJson") {
    return { type: "unsupported" };
  }
  return { type: "present", schema: response.schema, examples: response.fullExamples ?? [] };
}
function isExamplePrimitive(example) {
  switch (example.type) {
    case "primitive":
    case "enum":
    case "literal":
      return true;
    case "unknown":
      return isExamplePrimitive(example);
    case "array":
    case "object":
    case "map":
      return false;
    case "oneOf":
      switch (example.value.type) {
        case "discriminated":
          return false;
        case "undisciminated":
          return isExamplePrimitive(example.value.value);
        default:
          return false;
      }
    default:
      assertNever(example);
  }
}
function convertMultipartRequestToSchema(request) {
  return SchemaWithExample.object({
    properties: request.properties.map((property4) => {
      if (property4.schema.type === "file") {
        return null;
      }
      return {
        key: property4.key,
        // Convert the schema to a schema with example to ensure that the example is generated
        // This is a workaround for the fact that the example is not getting parsed upstream
        // TODO: Fix the example parsing upstream
        schema: convertSchemaToSchemaWithExample(property4.schema.value),
        audiences: [],
        conflict: {},
        generatedName: property4.key,
        nameOverride: void 0,
        availability: void 0,
        readonly: void 0,
        inline: void 0
      };
    }).filter(isNonNullish),
    allOf: [],
    allOfPropertyConflicts: [],
    fullExamples: void 0,
    description: request.description,
    nameOverride: void 0,
    generatedName: "",
    title: void 0,
    groupName: void 0,
    additionalProperties: false,
    availability: void 0,
    source: request.source
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/ExampleWebsocketSessionFactory.js
var ExampleWebsocketSessionFactory = class {
  exampleTypeFactory;
  schemas;
  constructor(schemas, context) {
    this.exampleTypeFactory = new ExampleTypeFactory(schemas, /* @__PURE__ */ new Set(), context);
    this.schemas = schemas;
  }
  buildWebsocketSessionExamplesForExtension({ context, extensionExamples, publish, subscribe, handshake, source, namespace }) {
    const result = [];
    for (const extensionExample of extensionExamples) {
      const queryParameters = [];
      for (const queryParameter of handshake.queryParameters) {
        const required = this.isSchemaRequired(queryParameter.schema);
        let example = this.exampleTypeFactory.buildExample({
          schema: queryParameter.schema,
          exampleId: void 0,
          example: extensionExample.queryParameters?.[queryParameter.name],
          options: {
            name: queryParameter.name,
            isParameter: true,
            ignoreOptionals: true
          }
        });
        if (example != null && !isExamplePrimitive(example)) {
          example = void 0;
        }
        if (required && example == null) {
          continue;
        } else if (example != null) {
          queryParameters.push({
            name: queryParameter.name,
            value: example
          });
        }
      }
      const headers = [];
      for (const header of handshake.headers) {
        const required = this.isSchemaRequired(header.schema);
        let example = this.exampleTypeFactory.buildExample({
          schema: header.schema,
          exampleId: void 0,
          example: extensionExample.headers?.[header.name],
          options: {
            name: header.name,
            isParameter: true,
            ignoreOptionals: true
          }
        });
        if (example != null && !isExamplePrimitive(example)) {
          example = void 0;
        }
        if (required && example == null) {
          continue;
        } else if (example != null) {
          headers.push({
            name: header.name,
            value: example
          });
        }
      }
      const messages = [];
      for (const messageExample of extensionExample.messages) {
        const messageSchema = context.resolveMessageReference({
          $ref: `#/components/messages/${messageExample.messageId}`
        });
        const resolvedSchema = isReferenceObject(messageSchema.payload) ? context.resolveSchemaReference(messageSchema.payload) : messageSchema.payload;
        const example = this.exampleTypeFactory.buildExample({
          schema: convertSchema(resolvedSchema, false, context, [messageExample.messageId], source, namespace),
          exampleId: void 0,
          example: messageExample.value,
          options: {
            isParameter: false,
            ignoreOptionals: true
          }
        });
        if (example != null) {
          messages.push({
            messageType: messageExample.type,
            payload: example,
            description: void 0
          });
        }
      }
      result.push({
        name: extensionExample.summary,
        queryParameters,
        headers,
        description: extensionExample.description,
        messages
      });
    }
    return result;
  }
  buildWebsocketSessionExample({ publish, subscribe, handshake }) {
    const example = {
      name: void 0,
      queryParameters: [],
      headers: [],
      description: void 0,
      messages: []
    };
    const queryParameters = [];
    for (const queryParameter of handshake.queryParameters) {
      const required = this.isSchemaRequired(queryParameter.schema);
      let example2 = this.exampleTypeFactory.buildExample({
        schema: queryParameter.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: queryParameter.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example2 != null && !isExamplePrimitive(example2)) {
        example2 = void 0;
      }
      if (required && example2 == null) {
        return void 0;
      } else if (example2 != null) {
        queryParameters.push({
          name: queryParameter.name,
          value: example2
        });
      }
    }
    const headers = [];
    for (const header of handshake.headers) {
      const required = this.isSchemaRequired(header.schema);
      let example2 = this.exampleTypeFactory.buildExample({
        schema: header.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: header.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example2 != null && !isExamplePrimitive(example2)) {
        example2 = void 0;
      }
      if (required && example2 == null) {
        return void 0;
      } else if (example2 != null) {
        headers.push({
          name: header.name,
          value: example2
        });
      }
    }
    if (publish != null) {
      const publishMessageExample = this.exampleTypeFactory.buildExample({
        schema: publish,
        exampleId: void 0,
        example: void 0,
        options: {
          isParameter: false,
          ignoreOptionals: true
        }
      });
      if (publishMessageExample != null) {
        example.messages.push({
          messageType: "publish",
          payload: publishMessageExample,
          description: void 0
        });
      }
    }
    if (subscribe != null) {
      const publishMessageExample = this.exampleTypeFactory.buildExample({
        schema: subscribe,
        exampleId: void 0,
        example: void 0,
        options: {
          isParameter: false,
          ignoreOptionals: true
        }
      });
      if (publishMessageExample != null) {
        example.messages.push({
          messageType: "subscribe",
          payload: publishMessageExample,
          description: void 0
        });
      }
    }
    return example;
  }
  isSchemaRequired(schema2) {
    return isSchemaRequired3(this.getResolvedSchema(schema2));
  }
  getResolvedSchema(schema2) {
    while (schema2.type === "reference") {
      const resolvedSchema = this.schemas[schema2.schema];
      if (resolvedSchema == null) {
        throw new Error(`Unexpected error: Failed to resolve schema reference: ${schema2.schema}`);
      }
      schema2 = resolvedSchema;
    }
    return schema2;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/fernExtensions.js
var FernAsyncAPIExtension = {
  /**
   * The x-fern-summary allows you to specify a display name for the websocket channel.
   */
  FERN_DISPLAY_NAME: "x-fern-display-name",
  /**
   * The x-fern-examples allows you to specify examples for the websocket session.
   *
   * channels:
   *   /my-channel:
   *      subscribe:
   *        ...
   *
   *      x-fern-examples:
   *       - name: example-1
   *         summary: This is an example of a websocket session
   *         description: This is a description of the example
   *         messages:
   *           - type: publish
   *             messageId: SendMessage
   *             value:
   *               data: "1223233"
   *           - type: subscribe
   *             messageId: ReceiveMessage
   *             value:
   *              data: "12340213"
   */
  FERN_EXAMPLES: "x-fern-examples",
  /**
   * Prepends the configured base path to all of the endpoint paths.
   *
   * x-fern-base-path: /v1
   * servers:
   *   - url: https://api.example.com
   * paths:
   *   /path/to/my/endpoint:
   */
  BASE_PATH: "x-fern-base-path"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/getFernExamples.js
function getFernExamples(channel) {
  return getExtension(channel, FernAsyncAPIExtension.FERN_EXAMPLES) ?? [];
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/parse.js
function parseAsyncAPI({ document, taskContext, options, source, asyncApiOptions, namespace }) {
  const breadcrumbs = [];
  if (namespace != null) {
    breadcrumbs.push(namespace);
  }
  if (document.tags?.[0] != null) {
    breadcrumbs.push(document.tags[0].name);
  } else if (asyncApiOptions.naming !== "v2") {
    breadcrumbs.push("websocket");
  }
  const context = new AsyncAPIV2ParserContext({
    document,
    taskContext,
    options,
    namespace
  });
  const schemas = {};
  let parsedChannel = void 0;
  for (const [schemaId, schema2] of Object.entries(document.components?.schemas ?? {})) {
    const convertedSchema = convertSchema(schema2, false, context, [schemaId], source, namespace);
    schemas[schemaId] = convertedSchema;
  }
  const exampleFactory = new ExampleWebsocketSessionFactory(schemas, context);
  for (const [channelPath, channel] of Object.entries(document.channels ?? {})) {
    if (channel.bindings?.ws == null) {
      context.logger.error(`Channel ${channelPath} does not have websocket bindings. Skipping.`);
      continue;
    }
    const pathParameters = [];
    if (channel.parameters != null) {
      for (const [name, parameter] of Object.entries(channel.parameters ?? {})) {
        pathParameters.push({
          name,
          description: parameter.description,
          parameterNameOverride: void 0,
          schema: parameter.schema != null ? convertSchema(parameter.schema, false, context, breadcrumbs, source, namespace) : SchemaWithExample.primitive({
            schema: PrimitiveSchemaValueWithExample.string({
              default: void 0,
              pattern: void 0,
              format: void 0,
              maxLength: void 0,
              minLength: void 0,
              example: void 0
            }),
            description: void 0,
            availability: void 0,
            generatedName: "",
            title: void 0,
            groupName: void 0,
            nameOverride: void 0
          }),
          variableReference: void 0,
          availability: convertAvailability3(parameter),
          source
        });
      }
    }
    const headers = [];
    if (channel.bindings.ws.headers != null) {
      const required = channel.bindings.ws.headers.required ?? [];
      for (const [name, schema2] of Object.entries(channel.bindings.ws.headers.properties ?? {})) {
        const resolvedHeader = isReferenceObject(schema2) ? context.resolveSchemaReference(schema2) : schema2;
        headers.push({
          name,
          schema: convertSchema(resolvedHeader, !required.includes(name), context, breadcrumbs, source, namespace),
          description: resolvedHeader.description,
          parameterNameOverride: void 0,
          env: void 0,
          availability: convertAvailability3(resolvedHeader),
          source
        });
      }
    }
    const queryParameters = [];
    if (channel.bindings.ws.query != null) {
      const required = channel.bindings.ws.query.required ?? [];
      for (const [name, schema2] of Object.entries(channel.bindings.ws.query.properties ?? {})) {
        const resolvedQueryParameter = isReferenceObject(schema2) ? context.resolveSchemaReference(schema2) : schema2;
        queryParameters.push({
          name,
          schema: convertSchema(resolvedQueryParameter, !required.includes(name), context, breadcrumbs, source, namespace),
          description: resolvedQueryParameter.description,
          parameterNameOverride: void 0,
          availability: convertAvailability3(resolvedQueryParameter),
          source
        });
      }
    }
    let publishSchema = void 0;
    if (channel.publish != null) {
      publishSchema = convertMessageToSchema({
        generatedName: channel.publish.operationId ?? "PublishEvent",
        event: channel.publish,
        breadcrumbs,
        context,
        source,
        options,
        asyncApiOptions
      });
    }
    let subscribeSchema = void 0;
    if (channel.subscribe != null) {
      subscribeSchema = convertMessageToSchema({
        generatedName: channel.subscribe.operationId ?? "SubscribeEvent",
        event: channel.subscribe,
        breadcrumbs,
        context,
        source,
        options,
        asyncApiOptions
      });
    }
    if (headers.length > 0 || queryParameters.length > 0 || publishSchema != null || subscribeSchema != null) {
      const fernExamples = getFernExamples(channel);
      let examples = [];
      if (fernExamples.length > 0) {
        examples = exampleFactory.buildWebsocketSessionExamplesForExtension({
          context,
          extensionExamples: fernExamples,
          handshake: {
            headers,
            queryParameters
          },
          publish: publishSchema,
          subscribe: subscribeSchema,
          source,
          namespace
        });
      } else {
        const autogenExample = exampleFactory.buildWebsocketSessionExample({
          handshake: {
            headers,
            queryParameters
          },
          publish: publishSchema,
          subscribe: subscribeSchema
        });
        if (autogenExample != null) {
          examples.push(autogenExample);
        }
      }
      const tags = document.tags?.[0]?.name != null ? [document.tags?.[0].name] : void 0;
      parsedChannel = {
        handshake: {
          headers: headers.map((header) => {
            return {
              ...header,
              schema: convertSchemaWithExampleToSchema(header.schema),
              env: header.env
            };
          }),
          queryParameters: queryParameters.map((param) => {
            return {
              ...param,
              schema: convertSchemaWithExampleToSchema(param.schema)
            };
          }),
          pathParameters: pathParameters.map((param) => {
            return {
              ...param,
              parameterNameOverride: void 0,
              schema: convertSchemaWithExampleToSchema(param.schema)
            };
          })
        },
        groupName: context.resolveTags(tags, "Websocket"),
        publish: publishSchema != null ? convertSchemaWithExampleToSchema(publishSchema) : publishSchema,
        subscribe: subscribeSchema != null ? convertSchemaWithExampleToSchema(subscribeSchema) : subscribeSchema,
        summary: getExtension(channel, FernAsyncAPIExtension.FERN_DISPLAY_NAME),
        path: channelPath,
        description: void 0,
        examples,
        source
      };
      break;
    }
  }
  return {
    groupedSchemas: getSchemas(namespace, schemas),
    channel: parsedChannel,
    basePath: getExtension(document, FernAsyncAPIExtension.BASE_PATH)
  };
}
function convertMessageToSchema({ generatedName, event, context, breadcrumbs, source, options, asyncApiOptions }) {
  if (event.message.oneOf != null) {
    const subtypes = [];
    const prefixes = [];
    for (const schema2 of event.message.oneOf) {
      let resolvedSchema;
      let namePrefix = { type: "notFound" };
      if (isReferenceObject(schema2)) {
        const resolvedMessage = context.resolveMessageReference(schema2);
        if (!isReferenceObject(resolvedMessage.payload) && asyncApiOptions.naming === "v2") {
          namePrefix = resolvedMessage.name ? { type: "name", name: resolvedMessage.name } : namePrefix;
          resolvedSchema = {
            ...resolvedMessage.payload,
            title: resolvedMessage.name ?? resolvedMessage.payload.title,
            description: resolvedMessage.name ?? resolvedMessage.payload.description
          };
        } else {
          resolvedSchema = resolvedMessage.payload;
        }
      } else {
        resolvedSchema = schema2;
      }
      prefixes.push(namePrefix);
      subtypes.push(resolvedSchema);
    }
    return convertUndiscriminatedOneOf({
      description: event.description ?? event.message.description,
      availability: convertAvailability3(event.message),
      subtypes,
      nameOverride: event.operationId,
      generatedName,
      title: event.message.title,
      groupName: void 0,
      wrapAsNullable: false,
      breadcrumbs,
      context,
      encoding: void 0,
      source,
      namespace: context.namespace,
      subtypePrefixOverrides: asyncApiOptions.naming === "v2" ? prefixes : []
    });
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernAsyncExtension.js
function getFernAsyncExtension(operation) {
  return getExtension(operation, FernOpenAPIExtension.ASYNC_CONFIG);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernStreamingExtension.js
var REQUEST_PREFIX = "$request.";
function getFernStreamingExtension(operation) {
  const streaming = getExtension(operation, FernOpenAPIExtension.STREAMING);
  if (streaming == null) {
    return void 0;
  }
  if (typeof streaming === "boolean") {
    return streaming ? {
      type: "stream",
      format: "json"
    } : void 0;
  }
  if (streaming["stream-condition"] == null && streaming.format != null) {
    return {
      type: "stream",
      format: streaming.format
    };
  }
  return {
    type: "streamCondition",
    format: streaming.format ?? "json",
    streamDescription: streaming["stream-description"],
    streamConditionProperty: maybeTrimRequestPrefix(streaming["stream-condition"]),
    responseStream: streaming["response-stream"],
    response: streaming.response
  };
}
function maybeTrimRequestPrefix(streamCondition) {
  if (streamCondition.startsWith(REQUEST_PREFIX)) {
    return streamCondition.slice(REQUEST_PREFIX.length);
  }
  return streamCondition;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getPaginationExtension.js
function convertPaginationExtension(pagination) {
  const maybeCursorPagination = pagination;
  if (maybeCursorPagination.cursor != null) {
    return Pagination3.cursor({
      cursor: maybeCursorPagination.cursor,
      nextCursor: maybeCursorPagination.next_cursor,
      results: maybeCursorPagination.results
    });
  }
  const maybeOffsetPagination = pagination;
  return Pagination3.offset({
    offset: maybeOffsetPagination.offset,
    results: maybeOffsetPagination.results,
    step: maybeOffsetPagination.step,
    hasNextPage: maybeOffsetPagination["has-next-page"]
  });
}
function getFernPaginationExtension(document, operation) {
  const pagination = getExtension(operation, FernOpenAPIExtension.PAGINATION);
  if (pagination == null) {
    return void 0;
  }
  if (typeof pagination === "boolean") {
    const topLevelPagination = getExtension(document, FernOpenAPIExtension.PAGINATION);
    if (typeof topLevelPagination === "boolean") {
      throw new Error("Global pagination extension is a boolean, expected an object. Only endpoints may declare a boolean for x-fern-pagination.");
    }
    return topLevelPagination == null ? void 0 : convertPaginationExtension(topLevelPagination);
  }
  return convertPaginationExtension(pagination);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/getReferenceOccurrences.js
function getReferenceOccurrences(document) {
  const contentConflictsRemovedDocument = removeApplicationJsonAndMultipartConflictsFromDocument(document);
  const occurrences = {};
  getReferenceOccurrencesHelper({ obj: contentConflictsRemovedDocument, occurrences, breadcrumbs: [] });
  return occurrences;
}
function getReferenceOccurrencesHelper({ obj, occurrences, breadcrumbs }) {
  if (obj == null) {
    return;
  }
  if (Array.isArray(obj)) {
    for (const element of obj) {
      getReferenceOccurrencesHelper({
        obj: element,
        occurrences,
        breadcrumbs
      });
    }
    return;
  }
  if (typeof obj !== "object") {
    return;
  }
  if (obj.$ref != null && typeof obj.$ref === "string") {
    const refProperty = obj.$ref;
    if (occurrences[refProperty] == null) {
      occurrences[refProperty] = 1;
    } else {
      occurrences[refProperty] += 1;
    }
    return;
  }
  for (const key in obj) {
    getReferenceOccurrencesHelper({
      obj: obj[key],
      occurrences,
      breadcrumbs: [...breadcrumbs, key]
    });
  }
}
function removeApplicationJsonAndMultipartConflictsFromDocument(document) {
  return {
    ...document,
    paths: Object.fromEntries(Object.entries(document.paths ?? {}).map(([path5, pathItem]) => {
      return [
        path5,
        {
          ...pathItem,
          get: pathItem?.get != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.get) : void 0,
          put: pathItem?.put != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.put) : void 0,
          post: pathItem?.post != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.post) : void 0,
          patch: pathItem?.patch != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.patch) : void 0,
          delete: pathItem?.delete != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.delete) : void 0
        }
      ];
    }))
  };
}
function removeApplicationJsonAndMultipartConflictsFromOperationObject(operationObject) {
  return {
    ...operationObject,
    requestBody: operationObject.requestBody != null ? isReferenceObject(operationObject.requestBody) ? operationObject.requestBody : removeApplicationJsonAndMultipartConflictsFromRequestBody(operationObject.requestBody) : void 0
  };
}
function removeApplicationJsonAndMultipartConflictsFromRequestBody(requestBody) {
  let jsonContent;
  let multipartContent;
  for (const mediatype in requestBody.content) {
    const mimetype = MediaType.parse(mediatype);
    if (mimetype == null) {
      continue;
    }
    if (mimetype.isJSON()) {
      jsonContent = requestBody.content[mediatype];
    } else if (mimetype.isMultipart()) {
      multipartContent = requestBody.content[mediatype];
    }
  }
  if (multipartContent != null && jsonContent != null) {
    return {
      ...requestBody,
      content: {
        [MediaType.MULTIPART_FORM_DATA]: multipartContent
      }
    };
  }
  return requestBody;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/AbstractOpenAPIV3ParserContext.js
var PARAMETER_REFERENCE_PREFIX = "#/components/parameters/";
var RESPONSE_REFERENCE_PREFIX = "#/components/responses/";
var EXAMPLES_REFERENCE_PREFIX = "#/components/examples/";
var REQUEST_BODY_REFERENCE_PREFIX = "#/components/requestBodies/";
var AbstractOpenAPIV3ParserContext = class {
  logger;
  document;
  taskContext;
  authHeaders;
  refOccurrences;
  DUMMY;
  options;
  source;
  namespace;
  constructor({ document, taskContext, authHeaders, options, source, namespace }) {
    this.document = document;
    this.logger = taskContext.logger;
    this.taskContext = taskContext;
    this.authHeaders = authHeaders;
    this.refOccurrences = getReferenceOccurrences(document);
    this.options = options;
    this.source = source;
    this.DUMMY = this.getDummy();
    this.namespace = namespace;
  }
  getNumberOfOccurrencesForRef(schema2) {
    return this.refOccurrences[schema2.$ref] ?? 0;
  }
  resolveTagsToTagIds(operationTags) {
    const tags = [];
    if (this.namespace != null) {
      tags.push(this.namespace);
    }
    return tags.concat(operationTags ?? []);
  }
  resolveTags(operationTags) {
    const tags = [];
    if (this.namespace != null) {
      const namespaceSegment = {
        type: "namespace",
        name: this.namespace
      };
      tags.push(namespaceSegment);
    }
    return tags.concat(operationTags ?? []);
  }
  resolveGroupName(groupName) {
    if (this.namespace != null) {
      return [{ type: "namespace", name: this.namespace }, ...groupName];
    }
    return groupName;
  }
  resolveSchemaReference(schema2) {
    const keys5 = schema2.$ref.substring(2).split("/").map((key) => key.replace(/~1/g, "/"));
    let resolvedSchema = this.document;
    for (const key of keys5) {
      if (typeof resolvedSchema !== "object" || resolvedSchema == null) {
        return {
          "x-fern-type": "unknown",
          additionalProperties: true
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
        };
      }
      resolvedSchema = resolvedSchema[key];
    }
    if (resolvedSchema == null) {
      return {
        "x-fern-type": "unknown",
        additionalProperties: true
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
      };
    }
    if (isReferenceObject(resolvedSchema)) {
      resolvedSchema = this.resolveSchemaReference(resolvedSchema);
    }
    return resolvedSchema;
  }
  resolveParameterReference(parameter) {
    if (this.document.components == null || this.document.components.parameters == null || !parameter.$ref.startsWith(PARAMETER_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${parameter.$ref}`);
    }
    const parameterKey = parameter.$ref.substring(PARAMETER_REFERENCE_PREFIX.length);
    const resolvedParameter = this.document.components.parameters[parameterKey];
    if (resolvedParameter == null) {
      throw new Error(`${parameter.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedParameter)) {
      return this.resolveParameterReference(resolvedParameter);
    }
    return resolvedParameter;
  }
  resolveRequestBodyReference(requestBody) {
    if (this.document.components == null || this.document.components.requestBodies == null || !requestBody.$ref.startsWith(REQUEST_BODY_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${requestBody.$ref}`);
    }
    const requestBodyKey = requestBody.$ref.substring(REQUEST_BODY_REFERENCE_PREFIX.length);
    const resolvedRequestBody = this.document.components.requestBodies[requestBodyKey];
    if (resolvedRequestBody == null) {
      throw new Error(`${requestBody.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedRequestBody)) {
      return this.resolveRequestBodyReference(resolvedRequestBody);
    }
    return resolvedRequestBody;
  }
  resolveResponseReference(response) {
    if (this.document.components == null || this.document.components.responses == null || !response.$ref.startsWith(RESPONSE_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${response.$ref}`);
    }
    const parameterKey = response.$ref.substring(RESPONSE_REFERENCE_PREFIX.length);
    const resolvedResponse = this.document.components.responses[parameterKey];
    if (resolvedResponse == null) {
      throw new Error(`${response.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedResponse)) {
      return this.resolveResponseReference(resolvedResponse);
    }
    return resolvedResponse;
  }
  resolveExampleReference(example) {
    if (this.document.components == null || this.document.components.examples == null || !example.$ref.startsWith(EXAMPLES_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${example.$ref}`);
    }
    const parameterKey = example.$ref.substring(EXAMPLES_REFERENCE_PREFIX.length);
    const resolvedExample = this.document.components.examples[parameterKey];
    if (resolvedExample == null) {
      throw new Error(`${example.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedExample)) {
      return this.resolveExampleReference(resolvedExample);
    }
    return resolvedExample;
  }
  referenceExists(ref) {
    const keys5 = ref.substring(2).split("/").map((key) => key.replace(/~1/g, "/"));
    let resolvedSchema = this.document;
    for (const key of keys5) {
      if (typeof resolvedSchema !== "object" || resolvedSchema == null) {
        return false;
      }
      resolvedSchema = resolvedSchema[key];
    }
    return true;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/DummyOpenAPIV3ParserContext.js
var DummyOpenAPIV3ParserContext = class extends AbstractOpenAPIV3ParserContext {
  constructor({ document, taskContext, options, source, namespace }) {
    super({
      document,
      taskContext,
      authHeaders: /* @__PURE__ */ new Set(),
      options,
      source,
      namespace
    });
  }
  getDummy() {
    return this;
  }
  markSchemaAsReferencedByNonRequest(_schemaId) {
    return;
  }
  markSchemaAsReferencedByRequest(_schemaId) {
    return;
  }
  getReferencedSchemas() {
    return /* @__PURE__ */ new Set();
  }
  markReferencedByDiscriminatedUnion(_schema, _discrminant, _times) {
    return;
  }
  getReferencesFromDiscriminatedUnion(_schema) {
    return void 0;
  }
  excludeSchema(_schemaId) {
  }
  isSchemaExcluded(_schemaId) {
    return false;
  }
  markSchemaWithDiscriminantValue(_schema, _discrminant, _discriminantValue) {
    return;
  }
  getDiscriminatedUnionMetadata(_schema) {
    return;
  }
};

// ../../../node_modules/.pnpm/zod@3.23.8/node_modules/zod/lib/index.mjs
var util;
(function(util2) {
  util2.assertEqual = (val) => val;
  function assertIs(_arg) {
  }
  util2.assertIs = assertIs;
  function assertNever2(_x) {
    throw new Error();
  }
  util2.assertNever = assertNever2;
  util2.arrayToEnum = (items) => {
    const obj = {};
    for (const item of items) {
      obj[item] = item;
    }
    return obj;
  };
  util2.getValidEnumValues = (obj) => {
    const validKeys = util2.objectKeys(obj).filter((k) => typeof obj[obj[k]] !== "number");
    const filtered = {};
    for (const k of validKeys) {
      filtered[k] = obj[k];
    }
    return util2.objectValues(filtered);
  };
  util2.objectValues = (obj) => {
    return util2.objectKeys(obj).map(function(e) {
      return obj[e];
    });
  };
  util2.objectKeys = typeof Object.keys === "function" ? (obj) => Object.keys(obj) : (object3) => {
    const keys5 = [];
    for (const key in object3) {
      if (Object.prototype.hasOwnProperty.call(object3, key)) {
        keys5.push(key);
      }
    }
    return keys5;
  };
  util2.find = (arr, checker) => {
    for (const item of arr) {
      if (checker(item))
        return item;
    }
    return void 0;
  };
  util2.isInteger = typeof Number.isInteger === "function" ? (val) => Number.isInteger(val) : (val) => typeof val === "number" && isFinite(val) && Math.floor(val) === val;
  function joinValues(array, separator = " | ") {
    return array.map((val) => typeof val === "string" ? `'${val}'` : val).join(separator);
  }
  util2.joinValues = joinValues;
  util2.jsonStringifyReplacer = (_, value) => {
    if (typeof value === "bigint") {
      return value.toString();
    }
    return value;
  };
})(util || (util = {}));
var objectUtil;
(function(objectUtil2) {
  objectUtil2.mergeShapes = (first, second) => {
    return {
      ...first,
      ...second
      // second overwrites first
    };
  };
})(objectUtil || (objectUtil = {}));
var ZodParsedType = util.arrayToEnum([
  "string",
  "nan",
  "number",
  "integer",
  "float",
  "boolean",
  "date",
  "bigint",
  "symbol",
  "function",
  "undefined",
  "null",
  "array",
  "object",
  "unknown",
  "promise",
  "void",
  "never",
  "map",
  "set"
]);
var getParsedType = (data) => {
  const t = typeof data;
  switch (t) {
    case "undefined":
      return ZodParsedType.undefined;
    case "string":
      return ZodParsedType.string;
    case "number":
      return isNaN(data) ? ZodParsedType.nan : ZodParsedType.number;
    case "boolean":
      return ZodParsedType.boolean;
    case "function":
      return ZodParsedType.function;
    case "bigint":
      return ZodParsedType.bigint;
    case "symbol":
      return ZodParsedType.symbol;
    case "object":
      if (Array.isArray(data)) {
        return ZodParsedType.array;
      }
      if (data === null) {
        return ZodParsedType.null;
      }
      if (data.then && typeof data.then === "function" && data.catch && typeof data.catch === "function") {
        return ZodParsedType.promise;
      }
      if (typeof Map !== "undefined" && data instanceof Map) {
        return ZodParsedType.map;
      }
      if (typeof Set !== "undefined" && data instanceof Set) {
        return ZodParsedType.set;
      }
      if (typeof Date !== "undefined" && data instanceof Date) {
        return ZodParsedType.date;
      }
      return ZodParsedType.object;
    default:
      return ZodParsedType.unknown;
  }
};
var ZodIssueCode = util.arrayToEnum([
  "invalid_type",
  "invalid_literal",
  "custom",
  "invalid_union",
  "invalid_union_discriminator",
  "invalid_enum_value",
  "unrecognized_keys",
  "invalid_arguments",
  "invalid_return_type",
  "invalid_date",
  "invalid_string",
  "too_small",
  "too_big",
  "invalid_intersection_types",
  "not_multiple_of",
  "not_finite"
]);
var quotelessJson = (obj) => {
  const json2 = JSON.stringify(obj, null, 2);
  return json2.replace(/"([^"]+)":/g, "$1:");
};
var ZodError = class _ZodError extends Error {
  constructor(issues) {
    super();
    this.issues = [];
    this.addIssue = (sub) => {
      this.issues = [...this.issues, sub];
    };
    this.addIssues = (subs = []) => {
      this.issues = [...this.issues, ...subs];
    };
    const actualProto = new.target.prototype;
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(this, actualProto);
    } else {
      this.__proto__ = actualProto;
    }
    this.name = "ZodError";
    this.issues = issues;
  }
  get errors() {
    return this.issues;
  }
  format(_mapper) {
    const mapper = _mapper || function(issue) {
      return issue.message;
    };
    const fieldErrors = { _errors: [] };
    const processError = (error) => {
      for (const issue of error.issues) {
        if (issue.code === "invalid_union") {
          issue.unionErrors.map(processError);
        } else if (issue.code === "invalid_return_type") {
          processError(issue.returnTypeError);
        } else if (issue.code === "invalid_arguments") {
          processError(issue.argumentsError);
        } else if (issue.path.length === 0) {
          fieldErrors._errors.push(mapper(issue));
        } else {
          let curr = fieldErrors;
          let i = 0;
          while (i < issue.path.length) {
            const el = issue.path[i];
            const terminal = i === issue.path.length - 1;
            if (!terminal) {
              curr[el] = curr[el] || { _errors: [] };
            } else {
              curr[el] = curr[el] || { _errors: [] };
              curr[el]._errors.push(mapper(issue));
            }
            curr = curr[el];
            i++;
          }
        }
      }
    };
    processError(this);
    return fieldErrors;
  }
  static assert(value) {
    if (!(value instanceof _ZodError)) {
      throw new Error(`Not a ZodError: ${value}`);
    }
  }
  toString() {
    return this.message;
  }
  get message() {
    return JSON.stringify(this.issues, util.jsonStringifyReplacer, 2);
  }
  get isEmpty() {
    return this.issues.length === 0;
  }
  flatten(mapper = (issue) => issue.message) {
    const fieldErrors = {};
    const formErrors = [];
    for (const sub of this.issues) {
      if (sub.path.length > 0) {
        fieldErrors[sub.path[0]] = fieldErrors[sub.path[0]] || [];
        fieldErrors[sub.path[0]].push(mapper(sub));
      } else {
        formErrors.push(mapper(sub));
      }
    }
    return { formErrors, fieldErrors };
  }
  get formErrors() {
    return this.flatten();
  }
};
ZodError.create = (issues) => {
  const error = new ZodError(issues);
  return error;
};
var errorMap = (issue, _ctx) => {
  let message;
  switch (issue.code) {
    case ZodIssueCode.invalid_type:
      if (issue.received === ZodParsedType.undefined) {
        message = "Required";
      } else {
        message = `Expected ${issue.expected}, received ${issue.received}`;
      }
      break;
    case ZodIssueCode.invalid_literal:
      message = `Invalid literal value, expected ${JSON.stringify(issue.expected, util.jsonStringifyReplacer)}`;
      break;
    case ZodIssueCode.unrecognized_keys:
      message = `Unrecognized key(s) in object: ${util.joinValues(issue.keys, ", ")}`;
      break;
    case ZodIssueCode.invalid_union:
      message = `Invalid input`;
      break;
    case ZodIssueCode.invalid_union_discriminator:
      message = `Invalid discriminator value. Expected ${util.joinValues(issue.options)}`;
      break;
    case ZodIssueCode.invalid_enum_value:
      message = `Invalid enum value. Expected ${util.joinValues(issue.options)}, received '${issue.received}'`;
      break;
    case ZodIssueCode.invalid_arguments:
      message = `Invalid function arguments`;
      break;
    case ZodIssueCode.invalid_return_type:
      message = `Invalid function return type`;
      break;
    case ZodIssueCode.invalid_date:
      message = `Invalid date`;
      break;
    case ZodIssueCode.invalid_string:
      if (typeof issue.validation === "object") {
        if ("includes" in issue.validation) {
          message = `Invalid input: must include "${issue.validation.includes}"`;
          if (typeof issue.validation.position === "number") {
            message = `${message} at one or more positions greater than or equal to ${issue.validation.position}`;
          }
        } else if ("startsWith" in issue.validation) {
          message = `Invalid input: must start with "${issue.validation.startsWith}"`;
        } else if ("endsWith" in issue.validation) {
          message = `Invalid input: must end with "${issue.validation.endsWith}"`;
        } else {
          util.assertNever(issue.validation);
        }
      } else if (issue.validation !== "regex") {
        message = `Invalid ${issue.validation}`;
      } else {
        message = "Invalid";
      }
      break;
    case ZodIssueCode.too_small:
      if (issue.type === "array")
        message = `Array must contain ${issue.exact ? "exactly" : issue.inclusive ? `at least` : `more than`} ${issue.minimum} element(s)`;
      else if (issue.type === "string")
        message = `String must contain ${issue.exact ? "exactly" : issue.inclusive ? `at least` : `over`} ${issue.minimum} character(s)`;
      else if (issue.type === "number")
        message = `Number must be ${issue.exact ? `exactly equal to ` : issue.inclusive ? `greater than or equal to ` : `greater than `}${issue.minimum}`;
      else if (issue.type === "date")
        message = `Date must be ${issue.exact ? `exactly equal to ` : issue.inclusive ? `greater than or equal to ` : `greater than `}${new Date(Number(issue.minimum))}`;
      else
        message = "Invalid input";
      break;
    case ZodIssueCode.too_big:
      if (issue.type === "array")
        message = `Array must contain ${issue.exact ? `exactly` : issue.inclusive ? `at most` : `less than`} ${issue.maximum} element(s)`;
      else if (issue.type === "string")
        message = `String must contain ${issue.exact ? `exactly` : issue.inclusive ? `at most` : `under`} ${issue.maximum} character(s)`;
      else if (issue.type === "number")
        message = `Number must be ${issue.exact ? `exactly` : issue.inclusive ? `less than or equal to` : `less than`} ${issue.maximum}`;
      else if (issue.type === "bigint")
        message = `BigInt must be ${issue.exact ? `exactly` : issue.inclusive ? `less than or equal to` : `less than`} ${issue.maximum}`;
      else if (issue.type === "date")
        message = `Date must be ${issue.exact ? `exactly` : issue.inclusive ? `smaller than or equal to` : `smaller than`} ${new Date(Number(issue.maximum))}`;
      else
        message = "Invalid input";
      break;
    case ZodIssueCode.custom:
      message = `Invalid input`;
      break;
    case ZodIssueCode.invalid_intersection_types:
      message = `Intersection results could not be merged`;
      break;
    case ZodIssueCode.not_multiple_of:
      message = `Number must be a multiple of ${issue.multipleOf}`;
      break;
    case ZodIssueCode.not_finite:
      message = "Number must be finite";
      break;
    default:
      message = _ctx.defaultError;
      util.assertNever(issue);
  }
  return { message };
};
var overrideErrorMap = errorMap;
function setErrorMap(map2) {
  overrideErrorMap = map2;
}
function getErrorMap() {
  return overrideErrorMap;
}
var makeIssue = (params) => {
  const { data, path: path5, errorMaps, issueData } = params;
  const fullPath = [...path5, ...issueData.path || []];
  const fullIssue = {
    ...issueData,
    path: fullPath
  };
  if (issueData.message !== void 0) {
    return {
      ...issueData,
      path: fullPath,
      message: issueData.message
    };
  }
  let errorMessage = "";
  const maps = errorMaps.filter((m) => !!m).slice().reverse();
  for (const map2 of maps) {
    errorMessage = map2(fullIssue, { data, defaultError: errorMessage }).message;
  }
  return {
    ...issueData,
    path: fullPath,
    message: errorMessage
  };
};
var EMPTY_PATH = [];
function addIssueToContext(ctx, issueData) {
  const overrideMap = getErrorMap();
  const issue = makeIssue({
    issueData,
    data: ctx.data,
    path: ctx.path,
    errorMaps: [
      ctx.common.contextualErrorMap,
      ctx.schemaErrorMap,
      overrideMap,
      overrideMap === errorMap ? void 0 : errorMap
      // then global default map
    ].filter((x) => !!x)
  });
  ctx.common.issues.push(issue);
}
var ParseStatus = class _ParseStatus {
  constructor() {
    this.value = "valid";
  }
  dirty() {
    if (this.value === "valid")
      this.value = "dirty";
  }
  abort() {
    if (this.value !== "aborted")
      this.value = "aborted";
  }
  static mergeArray(status, results) {
    const arrayValue = [];
    for (const s of results) {
      if (s.status === "aborted")
        return INVALID;
      if (s.status === "dirty")
        status.dirty();
      arrayValue.push(s.value);
    }
    return { status: status.value, value: arrayValue };
  }
  static async mergeObjectAsync(status, pairs2) {
    const syncPairs = [];
    for (const pair of pairs2) {
      const key = await pair.key;
      const value = await pair.value;
      syncPairs.push({
        key,
        value
      });
    }
    return _ParseStatus.mergeObjectSync(status, syncPairs);
  }
  static mergeObjectSync(status, pairs2) {
    const finalObject = {};
    for (const pair of pairs2) {
      const { key, value } = pair;
      if (key.status === "aborted")
        return INVALID;
      if (value.status === "aborted")
        return INVALID;
      if (key.status === "dirty")
        status.dirty();
      if (value.status === "dirty")
        status.dirty();
      if (key.value !== "__proto__" && (typeof value.value !== "undefined" || pair.alwaysSet)) {
        finalObject[key.value] = value.value;
      }
    }
    return { status: status.value, value: finalObject };
  }
};
var INVALID = Object.freeze({
  status: "aborted"
});
var DIRTY = (value) => ({ status: "dirty", value });
var OK = (value) => ({ status: "valid", value });
var isAborted = (x) => x.status === "aborted";
var isDirty = (x) => x.status === "dirty";
var isValid = (x) => x.status === "valid";
var isAsync = (x) => typeof Promise !== "undefined" && x instanceof Promise;
function __classPrivateFieldGet(receiver, state, kind, f) {
  if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
  if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
  return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
}
function __classPrivateFieldSet(receiver, state, value, kind, f) {
  if (kind === "m") throw new TypeError("Private method is not writable");
  if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
  if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
  return kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value), value;
}
var errorUtil;
(function(errorUtil2) {
  errorUtil2.errToObj = (message) => typeof message === "string" ? { message } : message || {};
  errorUtil2.toString = (message) => typeof message === "string" ? message : message === null || message === void 0 ? void 0 : message.message;
})(errorUtil || (errorUtil = {}));
var _ZodEnum_cache;
var _ZodNativeEnum_cache;
var ParseInputLazyPath = class {
  constructor(parent, value, path5, key) {
    this._cachedPath = [];
    this.parent = parent;
    this.data = value;
    this._path = path5;
    this._key = key;
  }
  get path() {
    if (!this._cachedPath.length) {
      if (this._key instanceof Array) {
        this._cachedPath.push(...this._path, ...this._key);
      } else {
        this._cachedPath.push(...this._path, this._key);
      }
    }
    return this._cachedPath;
  }
};
var handleResult = (ctx, result) => {
  if (isValid(result)) {
    return { success: true, data: result.value };
  } else {
    if (!ctx.common.issues.length) {
      throw new Error("Validation failed but no issues detected.");
    }
    return {
      success: false,
      get error() {
        if (this._error)
          return this._error;
        const error = new ZodError(ctx.common.issues);
        this._error = error;
        return this._error;
      }
    };
  }
};
function processCreateParams(params) {
  if (!params)
    return {};
  const { errorMap: errorMap2, invalid_type_error, required_error, description } = params;
  if (errorMap2 && (invalid_type_error || required_error)) {
    throw new Error(`Can't use "invalid_type_error" or "required_error" in conjunction with custom error map.`);
  }
  if (errorMap2)
    return { errorMap: errorMap2, description };
  const customMap = (iss, ctx) => {
    var _a, _b;
    const { message } = params;
    if (iss.code === "invalid_enum_value") {
      return { message: message !== null && message !== void 0 ? message : ctx.defaultError };
    }
    if (typeof ctx.data === "undefined") {
      return { message: (_a = message !== null && message !== void 0 ? message : required_error) !== null && _a !== void 0 ? _a : ctx.defaultError };
    }
    if (iss.code !== "invalid_type")
      return { message: ctx.defaultError };
    return { message: (_b = message !== null && message !== void 0 ? message : invalid_type_error) !== null && _b !== void 0 ? _b : ctx.defaultError };
  };
  return { errorMap: customMap, description };
}
var ZodType = class {
  constructor(def) {
    this.spa = this.safeParseAsync;
    this._def = def;
    this.parse = this.parse.bind(this);
    this.safeParse = this.safeParse.bind(this);
    this.parseAsync = this.parseAsync.bind(this);
    this.safeParseAsync = this.safeParseAsync.bind(this);
    this.spa = this.spa.bind(this);
    this.refine = this.refine.bind(this);
    this.refinement = this.refinement.bind(this);
    this.superRefine = this.superRefine.bind(this);
    this.optional = this.optional.bind(this);
    this.nullable = this.nullable.bind(this);
    this.nullish = this.nullish.bind(this);
    this.array = this.array.bind(this);
    this.promise = this.promise.bind(this);
    this.or = this.or.bind(this);
    this.and = this.and.bind(this);
    this.transform = this.transform.bind(this);
    this.brand = this.brand.bind(this);
    this.default = this.default.bind(this);
    this.catch = this.catch.bind(this);
    this.describe = this.describe.bind(this);
    this.pipe = this.pipe.bind(this);
    this.readonly = this.readonly.bind(this);
    this.isNullable = this.isNullable.bind(this);
    this.isOptional = this.isOptional.bind(this);
  }
  get description() {
    return this._def.description;
  }
  _getType(input) {
    return getParsedType(input.data);
  }
  _getOrReturnCtx(input, ctx) {
    return ctx || {
      common: input.parent.common,
      data: input.data,
      parsedType: getParsedType(input.data),
      schemaErrorMap: this._def.errorMap,
      path: input.path,
      parent: input.parent
    };
  }
  _processInputParams(input) {
    return {
      status: new ParseStatus(),
      ctx: {
        common: input.parent.common,
        data: input.data,
        parsedType: getParsedType(input.data),
        schemaErrorMap: this._def.errorMap,
        path: input.path,
        parent: input.parent
      }
    };
  }
  _parseSync(input) {
    const result = this._parse(input);
    if (isAsync(result)) {
      throw new Error("Synchronous parse encountered promise.");
    }
    return result;
  }
  _parseAsync(input) {
    const result = this._parse(input);
    return Promise.resolve(result);
  }
  parse(data, params) {
    const result = this.safeParse(data, params);
    if (result.success)
      return result.data;
    throw result.error;
  }
  safeParse(data, params) {
    var _a;
    const ctx = {
      common: {
        issues: [],
        async: (_a = params === null || params === void 0 ? void 0 : params.async) !== null && _a !== void 0 ? _a : false,
        contextualErrorMap: params === null || params === void 0 ? void 0 : params.errorMap
      },
      path: (params === null || params === void 0 ? void 0 : params.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data,
      parsedType: getParsedType(data)
    };
    const result = this._parseSync({ data, path: ctx.path, parent: ctx });
    return handleResult(ctx, result);
  }
  async parseAsync(data, params) {
    const result = await this.safeParseAsync(data, params);
    if (result.success)
      return result.data;
    throw result.error;
  }
  async safeParseAsync(data, params) {
    const ctx = {
      common: {
        issues: [],
        contextualErrorMap: params === null || params === void 0 ? void 0 : params.errorMap,
        async: true
      },
      path: (params === null || params === void 0 ? void 0 : params.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data,
      parsedType: getParsedType(data)
    };
    const maybeAsyncResult = this._parse({ data, path: ctx.path, parent: ctx });
    const result = await (isAsync(maybeAsyncResult) ? maybeAsyncResult : Promise.resolve(maybeAsyncResult));
    return handleResult(ctx, result);
  }
  refine(check, message) {
    const getIssueProperties = (val) => {
      if (typeof message === "string" || typeof message === "undefined") {
        return { message };
      } else if (typeof message === "function") {
        return message(val);
      } else {
        return message;
      }
    };
    return this._refinement((val, ctx) => {
      const result = check(val);
      const setError = () => ctx.addIssue({
        code: ZodIssueCode.custom,
        ...getIssueProperties(val)
      });
      if (typeof Promise !== "undefined" && result instanceof Promise) {
        return result.then((data) => {
          if (!data) {
            setError();
            return false;
          } else {
            return true;
          }
        });
      }
      if (!result) {
        setError();
        return false;
      } else {
        return true;
      }
    });
  }
  refinement(check, refinementData) {
    return this._refinement((val, ctx) => {
      if (!check(val)) {
        ctx.addIssue(typeof refinementData === "function" ? refinementData(val, ctx) : refinementData);
        return false;
      } else {
        return true;
      }
    });
  }
  _refinement(refinement) {
    return new ZodEffects({
      schema: this,
      typeName: ZodFirstPartyTypeKind.ZodEffects,
      effect: { type: "refinement", refinement }
    });
  }
  superRefine(refinement) {
    return this._refinement(refinement);
  }
  optional() {
    return ZodOptional.create(this, this._def);
  }
  nullable() {
    return ZodNullable.create(this, this._def);
  }
  nullish() {
    return this.nullable().optional();
  }
  array() {
    return ZodArray.create(this, this._def);
  }
  promise() {
    return ZodPromise.create(this, this._def);
  }
  or(option) {
    return ZodUnion.create([this, option], this._def);
  }
  and(incoming) {
    return ZodIntersection.create(this, incoming, this._def);
  }
  transform(transform3) {
    return new ZodEffects({
      ...processCreateParams(this._def),
      schema: this,
      typeName: ZodFirstPartyTypeKind.ZodEffects,
      effect: { type: "transform", transform: transform3 }
    });
  }
  default(def) {
    const defaultValueFunc = typeof def === "function" ? def : () => def;
    return new ZodDefault({
      ...processCreateParams(this._def),
      innerType: this,
      defaultValue: defaultValueFunc,
      typeName: ZodFirstPartyTypeKind.ZodDefault
    });
  }
  brand() {
    return new ZodBranded({
      typeName: ZodFirstPartyTypeKind.ZodBranded,
      type: this,
      ...processCreateParams(this._def)
    });
  }
  catch(def) {
    const catchValueFunc = typeof def === "function" ? def : () => def;
    return new ZodCatch({
      ...processCreateParams(this._def),
      innerType: this,
      catchValue: catchValueFunc,
      typeName: ZodFirstPartyTypeKind.ZodCatch
    });
  }
  describe(description) {
    const This = this.constructor;
    return new This({
      ...this._def,
      description
    });
  }
  pipe(target) {
    return ZodPipeline.create(this, target);
  }
  readonly() {
    return ZodReadonly.create(this);
  }
  isOptional() {
    return this.safeParse(void 0).success;
  }
  isNullable() {
    return this.safeParse(null).success;
  }
};
var cuidRegex = /^c[^\s-]{8,}$/i;
var cuid2Regex = /^[0-9a-z]+$/;
var ulidRegex = /^[0-9A-HJKMNP-TV-Z]{26}$/;
var uuidRegex = /^[0-9a-fA-F]{8}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{12}$/i;
var nanoidRegex = /^[a-z0-9_-]{21}$/i;
var durationRegex = /^[-+]?P(?!$)(?:(?:[-+]?\d+Y)|(?:[-+]?\d+[.,]\d+Y$))?(?:(?:[-+]?\d+M)|(?:[-+]?\d+[.,]\d+M$))?(?:(?:[-+]?\d+W)|(?:[-+]?\d+[.,]\d+W$))?(?:(?:[-+]?\d+D)|(?:[-+]?\d+[.,]\d+D$))?(?:T(?=[\d+-])(?:(?:[-+]?\d+H)|(?:[-+]?\d+[.,]\d+H$))?(?:(?:[-+]?\d+M)|(?:[-+]?\d+[.,]\d+M$))?(?:[-+]?\d+(?:[.,]\d+)?S)?)??$/;
var emailRegex = /^(?!\.)(?!.*\.\.)([A-Z0-9_'+\-\.]*)[A-Z0-9_+-]@([A-Z0-9][A-Z0-9\-]*\.)+[A-Z]{2,}$/i;
var _emojiRegex = `^(\\p{Extended_Pictographic}|\\p{Emoji_Component})+$`;
var emojiRegex;
var ipv4Regex = /^(?:(?:25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.){3}(?:25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])$/;
var ipv6Regex = /^(([a-f0-9]{1,4}:){7}|::([a-f0-9]{1,4}:){0,6}|([a-f0-9]{1,4}:){1}:([a-f0-9]{1,4}:){0,5}|([a-f0-9]{1,4}:){2}:([a-f0-9]{1,4}:){0,4}|([a-f0-9]{1,4}:){3}:([a-f0-9]{1,4}:){0,3}|([a-f0-9]{1,4}:){4}:([a-f0-9]{1,4}:){0,2}|([a-f0-9]{1,4}:){5}:([a-f0-9]{1,4}:){0,1})([a-f0-9]{1,4}|(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2})))$/;
var base64Regex = /^([0-9a-zA-Z+/]{4})*(([0-9a-zA-Z+/]{2}==)|([0-9a-zA-Z+/]{3}=))?$/;
var dateRegexSource = `((\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-((0[13578]|1[02])-(0[1-9]|[12]\\d|3[01])|(0[469]|11)-(0[1-9]|[12]\\d|30)|(02)-(0[1-9]|1\\d|2[0-8])))`;
var dateRegex = new RegExp(`^${dateRegexSource}$`);
function timeRegexSource(args) {
  let regex = `([01]\\d|2[0-3]):[0-5]\\d:[0-5]\\d`;
  if (args.precision) {
    regex = `${regex}\\.\\d{${args.precision}}`;
  } else if (args.precision == null) {
    regex = `${regex}(\\.\\d+)?`;
  }
  return regex;
}
function timeRegex(args) {
  return new RegExp(`^${timeRegexSource(args)}$`);
}
function datetimeRegex(args) {
  let regex = `${dateRegexSource}T${timeRegexSource(args)}`;
  const opts = [];
  opts.push(args.local ? `Z?` : `Z`);
  if (args.offset)
    opts.push(`([+-]\\d{2}:?\\d{2})`);
  regex = `${regex}(${opts.join("|")})`;
  return new RegExp(`^${regex}$`);
}
function isValidIP(ip, version) {
  if ((version === "v4" || !version) && ipv4Regex.test(ip)) {
    return true;
  }
  if ((version === "v6" || !version) && ipv6Regex.test(ip)) {
    return true;
  }
  return false;
}
var ZodString = class _ZodString extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = String(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.string) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.string,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    const status = new ParseStatus();
    let ctx = void 0;
    for (const check of this._def.checks) {
      if (check.kind === "min") {
        if (input.data.length < check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            minimum: check.value,
            type: "string",
            inclusive: true,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        if (input.data.length > check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            maximum: check.value,
            type: "string",
            inclusive: true,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "length") {
        const tooBig = input.data.length > check.value;
        const tooSmall = input.data.length < check.value;
        if (tooBig || tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          if (tooBig) {
            addIssueToContext(ctx, {
              code: ZodIssueCode.too_big,
              maximum: check.value,
              type: "string",
              inclusive: true,
              exact: true,
              message: check.message
            });
          } else if (tooSmall) {
            addIssueToContext(ctx, {
              code: ZodIssueCode.too_small,
              minimum: check.value,
              type: "string",
              inclusive: true,
              exact: true,
              message: check.message
            });
          }
          status.dirty();
        }
      } else if (check.kind === "email") {
        if (!emailRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "email",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "emoji") {
        if (!emojiRegex) {
          emojiRegex = new RegExp(_emojiRegex, "u");
        }
        if (!emojiRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "emoji",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "uuid") {
        if (!uuidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "uuid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "nanoid") {
        if (!nanoidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "nanoid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "cuid") {
        if (!cuidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "cuid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "cuid2") {
        if (!cuid2Regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "cuid2",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "ulid") {
        if (!ulidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "ulid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "url") {
        try {
          new URL(input.data);
        } catch (_a) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "url",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "regex") {
        check.regex.lastIndex = 0;
        const testResult = check.regex.test(input.data);
        if (!testResult) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "regex",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "trim") {
        input.data = input.data.trim();
      } else if (check.kind === "includes") {
        if (!input.data.includes(check.value, check.position)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: { includes: check.value, position: check.position },
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "toLowerCase") {
        input.data = input.data.toLowerCase();
      } else if (check.kind === "toUpperCase") {
        input.data = input.data.toUpperCase();
      } else if (check.kind === "startsWith") {
        if (!input.data.startsWith(check.value)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: { startsWith: check.value },
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "endsWith") {
        if (!input.data.endsWith(check.value)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: { endsWith: check.value },
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "datetime") {
        const regex = datetimeRegex(check);
        if (!regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: "datetime",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "date") {
        const regex = dateRegex;
        if (!regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: "date",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "time") {
        const regex = timeRegex(check);
        if (!regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: "time",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "duration") {
        if (!durationRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "duration",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "ip") {
        if (!isValidIP(input.data, check.version)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "ip",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "base64") {
        if (!base64Regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "base64",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return { status: status.value, value: input.data };
  }
  _regex(regex, validation, message) {
    return this.refinement((data) => regex.test(data), {
      validation,
      code: ZodIssueCode.invalid_string,
      ...errorUtil.errToObj(message)
    });
  }
  _addCheck(check) {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  email(message) {
    return this._addCheck({ kind: "email", ...errorUtil.errToObj(message) });
  }
  url(message) {
    return this._addCheck({ kind: "url", ...errorUtil.errToObj(message) });
  }
  emoji(message) {
    return this._addCheck({ kind: "emoji", ...errorUtil.errToObj(message) });
  }
  uuid(message) {
    return this._addCheck({ kind: "uuid", ...errorUtil.errToObj(message) });
  }
  nanoid(message) {
    return this._addCheck({ kind: "nanoid", ...errorUtil.errToObj(message) });
  }
  cuid(message) {
    return this._addCheck({ kind: "cuid", ...errorUtil.errToObj(message) });
  }
  cuid2(message) {
    return this._addCheck({ kind: "cuid2", ...errorUtil.errToObj(message) });
  }
  ulid(message) {
    return this._addCheck({ kind: "ulid", ...errorUtil.errToObj(message) });
  }
  base64(message) {
    return this._addCheck({ kind: "base64", ...errorUtil.errToObj(message) });
  }
  ip(options) {
    return this._addCheck({ kind: "ip", ...errorUtil.errToObj(options) });
  }
  datetime(options) {
    var _a, _b;
    if (typeof options === "string") {
      return this._addCheck({
        kind: "datetime",
        precision: null,
        offset: false,
        local: false,
        message: options
      });
    }
    return this._addCheck({
      kind: "datetime",
      precision: typeof (options === null || options === void 0 ? void 0 : options.precision) === "undefined" ? null : options === null || options === void 0 ? void 0 : options.precision,
      offset: (_a = options === null || options === void 0 ? void 0 : options.offset) !== null && _a !== void 0 ? _a : false,
      local: (_b = options === null || options === void 0 ? void 0 : options.local) !== null && _b !== void 0 ? _b : false,
      ...errorUtil.errToObj(options === null || options === void 0 ? void 0 : options.message)
    });
  }
  date(message) {
    return this._addCheck({ kind: "date", message });
  }
  time(options) {
    if (typeof options === "string") {
      return this._addCheck({
        kind: "time",
        precision: null,
        message: options
      });
    }
    return this._addCheck({
      kind: "time",
      precision: typeof (options === null || options === void 0 ? void 0 : options.precision) === "undefined" ? null : options === null || options === void 0 ? void 0 : options.precision,
      ...errorUtil.errToObj(options === null || options === void 0 ? void 0 : options.message)
    });
  }
  duration(message) {
    return this._addCheck({ kind: "duration", ...errorUtil.errToObj(message) });
  }
  regex(regex, message) {
    return this._addCheck({
      kind: "regex",
      regex,
      ...errorUtil.errToObj(message)
    });
  }
  includes(value, options) {
    return this._addCheck({
      kind: "includes",
      value,
      position: options === null || options === void 0 ? void 0 : options.position,
      ...errorUtil.errToObj(options === null || options === void 0 ? void 0 : options.message)
    });
  }
  startsWith(value, message) {
    return this._addCheck({
      kind: "startsWith",
      value,
      ...errorUtil.errToObj(message)
    });
  }
  endsWith(value, message) {
    return this._addCheck({
      kind: "endsWith",
      value,
      ...errorUtil.errToObj(message)
    });
  }
  min(minLength, message) {
    return this._addCheck({
      kind: "min",
      value: minLength,
      ...errorUtil.errToObj(message)
    });
  }
  max(maxLength, message) {
    return this._addCheck({
      kind: "max",
      value: maxLength,
      ...errorUtil.errToObj(message)
    });
  }
  length(len, message) {
    return this._addCheck({
      kind: "length",
      value: len,
      ...errorUtil.errToObj(message)
    });
  }
  /**
   * @deprecated Use z.string().min(1) instead.
   * @see {@link ZodString.min}
   */
  nonempty(message) {
    return this.min(1, errorUtil.errToObj(message));
  }
  trim() {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, { kind: "trim" }]
    });
  }
  toLowerCase() {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, { kind: "toLowerCase" }]
    });
  }
  toUpperCase() {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, { kind: "toUpperCase" }]
    });
  }
  get isDatetime() {
    return !!this._def.checks.find((ch) => ch.kind === "datetime");
  }
  get isDate() {
    return !!this._def.checks.find((ch) => ch.kind === "date");
  }
  get isTime() {
    return !!this._def.checks.find((ch) => ch.kind === "time");
  }
  get isDuration() {
    return !!this._def.checks.find((ch) => ch.kind === "duration");
  }
  get isEmail() {
    return !!this._def.checks.find((ch) => ch.kind === "email");
  }
  get isURL() {
    return !!this._def.checks.find((ch) => ch.kind === "url");
  }
  get isEmoji() {
    return !!this._def.checks.find((ch) => ch.kind === "emoji");
  }
  get isUUID() {
    return !!this._def.checks.find((ch) => ch.kind === "uuid");
  }
  get isNANOID() {
    return !!this._def.checks.find((ch) => ch.kind === "nanoid");
  }
  get isCUID() {
    return !!this._def.checks.find((ch) => ch.kind === "cuid");
  }
  get isCUID2() {
    return !!this._def.checks.find((ch) => ch.kind === "cuid2");
  }
  get isULID() {
    return !!this._def.checks.find((ch) => ch.kind === "ulid");
  }
  get isIP() {
    return !!this._def.checks.find((ch) => ch.kind === "ip");
  }
  get isBase64() {
    return !!this._def.checks.find((ch) => ch.kind === "base64");
  }
  get minLength() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min;
  }
  get maxLength() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max;
  }
};
ZodString.create = (params) => {
  var _a;
  return new ZodString({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodString,
    coerce: (_a = params === null || params === void 0 ? void 0 : params.coerce) !== null && _a !== void 0 ? _a : false,
    ...processCreateParams(params)
  });
};
function floatSafeRemainder(val, step) {
  const valDecCount = (val.toString().split(".")[1] || "").length;
  const stepDecCount = (step.toString().split(".")[1] || "").length;
  const decCount = valDecCount > stepDecCount ? valDecCount : stepDecCount;
  const valInt = parseInt(val.toFixed(decCount).replace(".", ""));
  const stepInt = parseInt(step.toFixed(decCount).replace(".", ""));
  return valInt % stepInt / Math.pow(10, decCount);
}
var ZodNumber = class _ZodNumber extends ZodType {
  constructor() {
    super(...arguments);
    this.min = this.gte;
    this.max = this.lte;
    this.step = this.multipleOf;
  }
  _parse(input) {
    if (this._def.coerce) {
      input.data = Number(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.number) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.number,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    let ctx = void 0;
    const status = new ParseStatus();
    for (const check of this._def.checks) {
      if (check.kind === "int") {
        if (!util.isInteger(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_type,
            expected: "integer",
            received: "float",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "min") {
        const tooSmall = check.inclusive ? input.data < check.value : input.data <= check.value;
        if (tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            minimum: check.value,
            type: "number",
            inclusive: check.inclusive,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        const tooBig = check.inclusive ? input.data > check.value : input.data >= check.value;
        if (tooBig) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            maximum: check.value,
            type: "number",
            inclusive: check.inclusive,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "multipleOf") {
        if (floatSafeRemainder(input.data, check.value) !== 0) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_multiple_of,
            multipleOf: check.value,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "finite") {
        if (!Number.isFinite(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_finite,
            message: check.message
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return { status: status.value, value: input.data };
  }
  gte(value, message) {
    return this.setLimit("min", value, true, errorUtil.toString(message));
  }
  gt(value, message) {
    return this.setLimit("min", value, false, errorUtil.toString(message));
  }
  lte(value, message) {
    return this.setLimit("max", value, true, errorUtil.toString(message));
  }
  lt(value, message) {
    return this.setLimit("max", value, false, errorUtil.toString(message));
  }
  setLimit(kind, value, inclusive, message) {
    return new _ZodNumber({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind,
          value,
          inclusive,
          message: errorUtil.toString(message)
        }
      ]
    });
  }
  _addCheck(check) {
    return new _ZodNumber({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  int(message) {
    return this._addCheck({
      kind: "int",
      message: errorUtil.toString(message)
    });
  }
  positive(message) {
    return this._addCheck({
      kind: "min",
      value: 0,
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  negative(message) {
    return this._addCheck({
      kind: "max",
      value: 0,
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  nonpositive(message) {
    return this._addCheck({
      kind: "max",
      value: 0,
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  nonnegative(message) {
    return this._addCheck({
      kind: "min",
      value: 0,
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  multipleOf(value, message) {
    return this._addCheck({
      kind: "multipleOf",
      value,
      message: errorUtil.toString(message)
    });
  }
  finite(message) {
    return this._addCheck({
      kind: "finite",
      message: errorUtil.toString(message)
    });
  }
  safe(message) {
    return this._addCheck({
      kind: "min",
      inclusive: true,
      value: Number.MIN_SAFE_INTEGER,
      message: errorUtil.toString(message)
    })._addCheck({
      kind: "max",
      inclusive: true,
      value: Number.MAX_SAFE_INTEGER,
      message: errorUtil.toString(message)
    });
  }
  get minValue() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min;
  }
  get maxValue() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max;
  }
  get isInt() {
    return !!this._def.checks.find((ch) => ch.kind === "int" || ch.kind === "multipleOf" && util.isInteger(ch.value));
  }
  get isFinite() {
    let max = null, min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "finite" || ch.kind === "int" || ch.kind === "multipleOf") {
        return true;
      } else if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      } else if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return Number.isFinite(min) && Number.isFinite(max);
  }
};
ZodNumber.create = (params) => {
  return new ZodNumber({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodNumber,
    coerce: (params === null || params === void 0 ? void 0 : params.coerce) || false,
    ...processCreateParams(params)
  });
};
var ZodBigInt = class _ZodBigInt extends ZodType {
  constructor() {
    super(...arguments);
    this.min = this.gte;
    this.max = this.lte;
  }
  _parse(input) {
    if (this._def.coerce) {
      input.data = BigInt(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.bigint) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.bigint,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    let ctx = void 0;
    const status = new ParseStatus();
    for (const check of this._def.checks) {
      if (check.kind === "min") {
        const tooSmall = check.inclusive ? input.data < check.value : input.data <= check.value;
        if (tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            type: "bigint",
            minimum: check.value,
            inclusive: check.inclusive,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        const tooBig = check.inclusive ? input.data > check.value : input.data >= check.value;
        if (tooBig) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            type: "bigint",
            maximum: check.value,
            inclusive: check.inclusive,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "multipleOf") {
        if (input.data % check.value !== BigInt(0)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_multiple_of,
            multipleOf: check.value,
            message: check.message
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return { status: status.value, value: input.data };
  }
  gte(value, message) {
    return this.setLimit("min", value, true, errorUtil.toString(message));
  }
  gt(value, message) {
    return this.setLimit("min", value, false, errorUtil.toString(message));
  }
  lte(value, message) {
    return this.setLimit("max", value, true, errorUtil.toString(message));
  }
  lt(value, message) {
    return this.setLimit("max", value, false, errorUtil.toString(message));
  }
  setLimit(kind, value, inclusive, message) {
    return new _ZodBigInt({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind,
          value,
          inclusive,
          message: errorUtil.toString(message)
        }
      ]
    });
  }
  _addCheck(check) {
    return new _ZodBigInt({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  positive(message) {
    return this._addCheck({
      kind: "min",
      value: BigInt(0),
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  negative(message) {
    return this._addCheck({
      kind: "max",
      value: BigInt(0),
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  nonpositive(message) {
    return this._addCheck({
      kind: "max",
      value: BigInt(0),
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  nonnegative(message) {
    return this._addCheck({
      kind: "min",
      value: BigInt(0),
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  multipleOf(value, message) {
    return this._addCheck({
      kind: "multipleOf",
      value,
      message: errorUtil.toString(message)
    });
  }
  get minValue() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min;
  }
  get maxValue() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max;
  }
};
ZodBigInt.create = (params) => {
  var _a;
  return new ZodBigInt({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodBigInt,
    coerce: (_a = params === null || params === void 0 ? void 0 : params.coerce) !== null && _a !== void 0 ? _a : false,
    ...processCreateParams(params)
  });
};
var ZodBoolean = class extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = Boolean(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.boolean) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.boolean,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodBoolean.create = (params) => {
  return new ZodBoolean({
    typeName: ZodFirstPartyTypeKind.ZodBoolean,
    coerce: (params === null || params === void 0 ? void 0 : params.coerce) || false,
    ...processCreateParams(params)
  });
};
var ZodDate = class _ZodDate extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = new Date(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.date) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.date,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    if (isNaN(input.data.getTime())) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_date
      });
      return INVALID;
    }
    const status = new ParseStatus();
    let ctx = void 0;
    for (const check of this._def.checks) {
      if (check.kind === "min") {
        if (input.data.getTime() < check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            message: check.message,
            inclusive: true,
            exact: false,
            minimum: check.value,
            type: "date"
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        if (input.data.getTime() > check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            message: check.message,
            inclusive: true,
            exact: false,
            maximum: check.value,
            type: "date"
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return {
      status: status.value,
      value: new Date(input.data.getTime())
    };
  }
  _addCheck(check) {
    return new _ZodDate({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  min(minDate, message) {
    return this._addCheck({
      kind: "min",
      value: minDate.getTime(),
      message: errorUtil.toString(message)
    });
  }
  max(maxDate, message) {
    return this._addCheck({
      kind: "max",
      value: maxDate.getTime(),
      message: errorUtil.toString(message)
    });
  }
  get minDate() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min != null ? new Date(min) : null;
  }
  get maxDate() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max != null ? new Date(max) : null;
  }
};
ZodDate.create = (params) => {
  return new ZodDate({
    checks: [],
    coerce: (params === null || params === void 0 ? void 0 : params.coerce) || false,
    typeName: ZodFirstPartyTypeKind.ZodDate,
    ...processCreateParams(params)
  });
};
var ZodSymbol = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.symbol) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.symbol,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodSymbol.create = (params) => {
  return new ZodSymbol({
    typeName: ZodFirstPartyTypeKind.ZodSymbol,
    ...processCreateParams(params)
  });
};
var ZodUndefined = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.undefined) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.undefined,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodUndefined.create = (params) => {
  return new ZodUndefined({
    typeName: ZodFirstPartyTypeKind.ZodUndefined,
    ...processCreateParams(params)
  });
};
var ZodNull = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.null) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.null,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodNull.create = (params) => {
  return new ZodNull({
    typeName: ZodFirstPartyTypeKind.ZodNull,
    ...processCreateParams(params)
  });
};
var ZodAny = class extends ZodType {
  constructor() {
    super(...arguments);
    this._any = true;
  }
  _parse(input) {
    return OK(input.data);
  }
};
ZodAny.create = (params) => {
  return new ZodAny({
    typeName: ZodFirstPartyTypeKind.ZodAny,
    ...processCreateParams(params)
  });
};
var ZodUnknown = class extends ZodType {
  constructor() {
    super(...arguments);
    this._unknown = true;
  }
  _parse(input) {
    return OK(input.data);
  }
};
ZodUnknown.create = (params) => {
  return new ZodUnknown({
    typeName: ZodFirstPartyTypeKind.ZodUnknown,
    ...processCreateParams(params)
  });
};
var ZodNever = class extends ZodType {
  _parse(input) {
    const ctx = this._getOrReturnCtx(input);
    addIssueToContext(ctx, {
      code: ZodIssueCode.invalid_type,
      expected: ZodParsedType.never,
      received: ctx.parsedType
    });
    return INVALID;
  }
};
ZodNever.create = (params) => {
  return new ZodNever({
    typeName: ZodFirstPartyTypeKind.ZodNever,
    ...processCreateParams(params)
  });
};
var ZodVoid = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.undefined) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.void,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodVoid.create = (params) => {
  return new ZodVoid({
    typeName: ZodFirstPartyTypeKind.ZodVoid,
    ...processCreateParams(params)
  });
};
var ZodArray = class _ZodArray extends ZodType {
  _parse(input) {
    const { ctx, status } = this._processInputParams(input);
    const def = this._def;
    if (ctx.parsedType !== ZodParsedType.array) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.array,
        received: ctx.parsedType
      });
      return INVALID;
    }
    if (def.exactLength !== null) {
      const tooBig = ctx.data.length > def.exactLength.value;
      const tooSmall = ctx.data.length < def.exactLength.value;
      if (tooBig || tooSmall) {
        addIssueToContext(ctx, {
          code: tooBig ? ZodIssueCode.too_big : ZodIssueCode.too_small,
          minimum: tooSmall ? def.exactLength.value : void 0,
          maximum: tooBig ? def.exactLength.value : void 0,
          type: "array",
          inclusive: true,
          exact: true,
          message: def.exactLength.message
        });
        status.dirty();
      }
    }
    if (def.minLength !== null) {
      if (ctx.data.length < def.minLength.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_small,
          minimum: def.minLength.value,
          type: "array",
          inclusive: true,
          exact: false,
          message: def.minLength.message
        });
        status.dirty();
      }
    }
    if (def.maxLength !== null) {
      if (ctx.data.length > def.maxLength.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_big,
          maximum: def.maxLength.value,
          type: "array",
          inclusive: true,
          exact: false,
          message: def.maxLength.message
        });
        status.dirty();
      }
    }
    if (ctx.common.async) {
      return Promise.all([...ctx.data].map((item, i) => {
        return def.type._parseAsync(new ParseInputLazyPath(ctx, item, ctx.path, i));
      })).then((result2) => {
        return ParseStatus.mergeArray(status, result2);
      });
    }
    const result = [...ctx.data].map((item, i) => {
      return def.type._parseSync(new ParseInputLazyPath(ctx, item, ctx.path, i));
    });
    return ParseStatus.mergeArray(status, result);
  }
  get element() {
    return this._def.type;
  }
  min(minLength, message) {
    return new _ZodArray({
      ...this._def,
      minLength: { value: minLength, message: errorUtil.toString(message) }
    });
  }
  max(maxLength, message) {
    return new _ZodArray({
      ...this._def,
      maxLength: { value: maxLength, message: errorUtil.toString(message) }
    });
  }
  length(len, message) {
    return new _ZodArray({
      ...this._def,
      exactLength: { value: len, message: errorUtil.toString(message) }
    });
  }
  nonempty(message) {
    return this.min(1, message);
  }
};
ZodArray.create = (schema2, params) => {
  return new ZodArray({
    type: schema2,
    minLength: null,
    maxLength: null,
    exactLength: null,
    typeName: ZodFirstPartyTypeKind.ZodArray,
    ...processCreateParams(params)
  });
};
function deepPartialify(schema2) {
  if (schema2 instanceof ZodObject) {
    const newShape = {};
    for (const key in schema2.shape) {
      const fieldSchema = schema2.shape[key];
      newShape[key] = ZodOptional.create(deepPartialify(fieldSchema));
    }
    return new ZodObject({
      ...schema2._def,
      shape: () => newShape
    });
  } else if (schema2 instanceof ZodArray) {
    return new ZodArray({
      ...schema2._def,
      type: deepPartialify(schema2.element)
    });
  } else if (schema2 instanceof ZodOptional) {
    return ZodOptional.create(deepPartialify(schema2.unwrap()));
  } else if (schema2 instanceof ZodNullable) {
    return ZodNullable.create(deepPartialify(schema2.unwrap()));
  } else if (schema2 instanceof ZodTuple) {
    return ZodTuple.create(schema2.items.map((item) => deepPartialify(item)));
  } else {
    return schema2;
  }
}
var ZodObject = class _ZodObject extends ZodType {
  constructor() {
    super(...arguments);
    this._cached = null;
    this.nonstrict = this.passthrough;
    this.augment = this.extend;
  }
  _getCached() {
    if (this._cached !== null)
      return this._cached;
    const shape = this._def.shape();
    const keys5 = util.objectKeys(shape);
    return this._cached = { shape, keys: keys5 };
  }
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.object) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    const { status, ctx } = this._processInputParams(input);
    const { shape, keys: shapeKeys } = this._getCached();
    const extraKeys = [];
    if (!(this._def.catchall instanceof ZodNever && this._def.unknownKeys === "strip")) {
      for (const key in ctx.data) {
        if (!shapeKeys.includes(key)) {
          extraKeys.push(key);
        }
      }
    }
    const pairs2 = [];
    for (const key of shapeKeys) {
      const keyValidator = shape[key];
      const value = ctx.data[key];
      pairs2.push({
        key: { status: "valid", value: key },
        value: keyValidator._parse(new ParseInputLazyPath(ctx, value, ctx.path, key)),
        alwaysSet: key in ctx.data
      });
    }
    if (this._def.catchall instanceof ZodNever) {
      const unknownKeys = this._def.unknownKeys;
      if (unknownKeys === "passthrough") {
        for (const key of extraKeys) {
          pairs2.push({
            key: { status: "valid", value: key },
            value: { status: "valid", value: ctx.data[key] }
          });
        }
      } else if (unknownKeys === "strict") {
        if (extraKeys.length > 0) {
          addIssueToContext(ctx, {
            code: ZodIssueCode.unrecognized_keys,
            keys: extraKeys
          });
          status.dirty();
        }
      } else if (unknownKeys === "strip") ;
      else {
        throw new Error(`Internal ZodObject error: invalid unknownKeys value.`);
      }
    } else {
      const catchall = this._def.catchall;
      for (const key of extraKeys) {
        const value = ctx.data[key];
        pairs2.push({
          key: { status: "valid", value: key },
          value: catchall._parse(
            new ParseInputLazyPath(ctx, value, ctx.path, key)
            //, ctx.child(key), value, getParsedType(value)
          ),
          alwaysSet: key in ctx.data
        });
      }
    }
    if (ctx.common.async) {
      return Promise.resolve().then(async () => {
        const syncPairs = [];
        for (const pair of pairs2) {
          const key = await pair.key;
          const value = await pair.value;
          syncPairs.push({
            key,
            value,
            alwaysSet: pair.alwaysSet
          });
        }
        return syncPairs;
      }).then((syncPairs) => {
        return ParseStatus.mergeObjectSync(status, syncPairs);
      });
    } else {
      return ParseStatus.mergeObjectSync(status, pairs2);
    }
  }
  get shape() {
    return this._def.shape();
  }
  strict(message) {
    errorUtil.errToObj;
    return new _ZodObject({
      ...this._def,
      unknownKeys: "strict",
      ...message !== void 0 ? {
        errorMap: (issue, ctx) => {
          var _a, _b, _c, _d;
          const defaultError = (_c = (_b = (_a = this._def).errorMap) === null || _b === void 0 ? void 0 : _b.call(_a, issue, ctx).message) !== null && _c !== void 0 ? _c : ctx.defaultError;
          if (issue.code === "unrecognized_keys")
            return {
              message: (_d = errorUtil.errToObj(message).message) !== null && _d !== void 0 ? _d : defaultError
            };
          return {
            message: defaultError
          };
        }
      } : {}
    });
  }
  strip() {
    return new _ZodObject({
      ...this._def,
      unknownKeys: "strip"
    });
  }
  passthrough() {
    return new _ZodObject({
      ...this._def,
      unknownKeys: "passthrough"
    });
  }
  // const AugmentFactory =
  //   <Def extends ZodObjectDef>(def: Def) =>
  //   <Augmentation extends ZodRawShape>(
  //     augmentation: Augmentation
  //   ): ZodObject<
  //     extendShape<ReturnType<Def["shape"]>, Augmentation>,
  //     Def["unknownKeys"],
  //     Def["catchall"]
  //   > => {
  //     return new ZodObject({
  //       ...def,
  //       shape: () => ({
  //         ...def.shape(),
  //         ...augmentation,
  //       }),
  //     }) as any;
  //   };
  extend(augmentation) {
    return new _ZodObject({
      ...this._def,
      shape: () => ({
        ...this._def.shape(),
        ...augmentation
      })
    });
  }
  /**
   * Prior to zod@1.0.12 there was a bug in the
   * inferred type of merged objects. Please
   * upgrade if you are experiencing issues.
   */
  merge(merging) {
    const merged = new _ZodObject({
      unknownKeys: merging._def.unknownKeys,
      catchall: merging._def.catchall,
      shape: () => ({
        ...this._def.shape(),
        ...merging._def.shape()
      }),
      typeName: ZodFirstPartyTypeKind.ZodObject
    });
    return merged;
  }
  // merge<
  //   Incoming extends AnyZodObject,
  //   Augmentation extends Incoming["shape"],
  //   NewOutput extends {
  //     [k in keyof Augmentation | keyof Output]: k extends keyof Augmentation
  //       ? Augmentation[k]["_output"]
  //       : k extends keyof Output
  //       ? Output[k]
  //       : never;
  //   },
  //   NewInput extends {
  //     [k in keyof Augmentation | keyof Input]: k extends keyof Augmentation
  //       ? Augmentation[k]["_input"]
  //       : k extends keyof Input
  //       ? Input[k]
  //       : never;
  //   }
  // >(
  //   merging: Incoming
  // ): ZodObject<
  //   extendShape<T, ReturnType<Incoming["_def"]["shape"]>>,
  //   Incoming["_def"]["unknownKeys"],
  //   Incoming["_def"]["catchall"],
  //   NewOutput,
  //   NewInput
  // > {
  //   const merged: any = new ZodObject({
  //     unknownKeys: merging._def.unknownKeys,
  //     catchall: merging._def.catchall,
  //     shape: () =>
  //       objectUtil.mergeShapes(this._def.shape(), merging._def.shape()),
  //     typeName: ZodFirstPartyTypeKind.ZodObject,
  //   }) as any;
  //   return merged;
  // }
  setKey(key, schema2) {
    return this.augment({ [key]: schema2 });
  }
  // merge<Incoming extends AnyZodObject>(
  //   merging: Incoming
  // ): //ZodObject<T & Incoming["_shape"], UnknownKeys, Catchall> = (merging) => {
  // ZodObject<
  //   extendShape<T, ReturnType<Incoming["_def"]["shape"]>>,
  //   Incoming["_def"]["unknownKeys"],
  //   Incoming["_def"]["catchall"]
  // > {
  //   // const mergedShape = objectUtil.mergeShapes(
  //   //   this._def.shape(),
  //   //   merging._def.shape()
  //   // );
  //   const merged: any = new ZodObject({
  //     unknownKeys: merging._def.unknownKeys,
  //     catchall: merging._def.catchall,
  //     shape: () =>
  //       objectUtil.mergeShapes(this._def.shape(), merging._def.shape()),
  //     typeName: ZodFirstPartyTypeKind.ZodObject,
  //   }) as any;
  //   return merged;
  // }
  catchall(index) {
    return new _ZodObject({
      ...this._def,
      catchall: index
    });
  }
  pick(mask) {
    const shape = {};
    util.objectKeys(mask).forEach((key) => {
      if (mask[key] && this.shape[key]) {
        shape[key] = this.shape[key];
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => shape
    });
  }
  omit(mask) {
    const shape = {};
    util.objectKeys(this.shape).forEach((key) => {
      if (!mask[key]) {
        shape[key] = this.shape[key];
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => shape
    });
  }
  /**
   * @deprecated
   */
  deepPartial() {
    return deepPartialify(this);
  }
  partial(mask) {
    const newShape = {};
    util.objectKeys(this.shape).forEach((key) => {
      const fieldSchema = this.shape[key];
      if (mask && !mask[key]) {
        newShape[key] = fieldSchema;
      } else {
        newShape[key] = fieldSchema.optional();
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => newShape
    });
  }
  required(mask) {
    const newShape = {};
    util.objectKeys(this.shape).forEach((key) => {
      if (mask && !mask[key]) {
        newShape[key] = this.shape[key];
      } else {
        const fieldSchema = this.shape[key];
        let newField = fieldSchema;
        while (newField instanceof ZodOptional) {
          newField = newField._def.innerType;
        }
        newShape[key] = newField;
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => newShape
    });
  }
  keyof() {
    return createZodEnum(util.objectKeys(this.shape));
  }
};
ZodObject.create = (shape, params) => {
  return new ZodObject({
    shape: () => shape,
    unknownKeys: "strip",
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params)
  });
};
ZodObject.strictCreate = (shape, params) => {
  return new ZodObject({
    shape: () => shape,
    unknownKeys: "strict",
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params)
  });
};
ZodObject.lazycreate = (shape, params) => {
  return new ZodObject({
    shape,
    unknownKeys: "strip",
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params)
  });
};
var ZodUnion = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const options = this._def.options;
    function handleResults(results) {
      for (const result of results) {
        if (result.result.status === "valid") {
          return result.result;
        }
      }
      for (const result of results) {
        if (result.result.status === "dirty") {
          ctx.common.issues.push(...result.ctx.common.issues);
          return result.result;
        }
      }
      const unionErrors = results.map((result) => new ZodError(result.ctx.common.issues));
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union,
        unionErrors
      });
      return INVALID;
    }
    if (ctx.common.async) {
      return Promise.all(options.map(async (option) => {
        const childCtx = {
          ...ctx,
          common: {
            ...ctx.common,
            issues: []
          },
          parent: null
        };
        return {
          result: await option._parseAsync({
            data: ctx.data,
            path: ctx.path,
            parent: childCtx
          }),
          ctx: childCtx
        };
      })).then(handleResults);
    } else {
      let dirty = void 0;
      const issues = [];
      for (const option of options) {
        const childCtx = {
          ...ctx,
          common: {
            ...ctx.common,
            issues: []
          },
          parent: null
        };
        const result = option._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: childCtx
        });
        if (result.status === "valid") {
          return result;
        } else if (result.status === "dirty" && !dirty) {
          dirty = { result, ctx: childCtx };
        }
        if (childCtx.common.issues.length) {
          issues.push(childCtx.common.issues);
        }
      }
      if (dirty) {
        ctx.common.issues.push(...dirty.ctx.common.issues);
        return dirty.result;
      }
      const unionErrors = issues.map((issues2) => new ZodError(issues2));
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union,
        unionErrors
      });
      return INVALID;
    }
  }
  get options() {
    return this._def.options;
  }
};
ZodUnion.create = (types2, params) => {
  return new ZodUnion({
    options: types2,
    typeName: ZodFirstPartyTypeKind.ZodUnion,
    ...processCreateParams(params)
  });
};
var getDiscriminator = (type2) => {
  if (type2 instanceof ZodLazy) {
    return getDiscriminator(type2.schema);
  } else if (type2 instanceof ZodEffects) {
    return getDiscriminator(type2.innerType());
  } else if (type2 instanceof ZodLiteral) {
    return [type2.value];
  } else if (type2 instanceof ZodEnum) {
    return type2.options;
  } else if (type2 instanceof ZodNativeEnum) {
    return util.objectValues(type2.enum);
  } else if (type2 instanceof ZodDefault) {
    return getDiscriminator(type2._def.innerType);
  } else if (type2 instanceof ZodUndefined) {
    return [void 0];
  } else if (type2 instanceof ZodNull) {
    return [null];
  } else if (type2 instanceof ZodOptional) {
    return [void 0, ...getDiscriminator(type2.unwrap())];
  } else if (type2 instanceof ZodNullable) {
    return [null, ...getDiscriminator(type2.unwrap())];
  } else if (type2 instanceof ZodBranded) {
    return getDiscriminator(type2.unwrap());
  } else if (type2 instanceof ZodReadonly) {
    return getDiscriminator(type2.unwrap());
  } else if (type2 instanceof ZodCatch) {
    return getDiscriminator(type2._def.innerType);
  } else {
    return [];
  }
};
var ZodDiscriminatedUnion = class _ZodDiscriminatedUnion extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.object) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const discriminator = this.discriminator;
    const discriminatorValue = ctx.data[discriminator];
    const option = this.optionsMap.get(discriminatorValue);
    if (!option) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union_discriminator,
        options: Array.from(this.optionsMap.keys()),
        path: [discriminator]
      });
      return INVALID;
    }
    if (ctx.common.async) {
      return option._parseAsync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      });
    } else {
      return option._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      });
    }
  }
  get discriminator() {
    return this._def.discriminator;
  }
  get options() {
    return this._def.options;
  }
  get optionsMap() {
    return this._def.optionsMap;
  }
  /**
   * The constructor of the discriminated union schema. Its behaviour is very similar to that of the normal z.union() constructor.
   * However, it only allows a union of objects, all of which need to share a discriminator property. This property must
   * have a different value for each object in the union.
   * @param discriminator the name of the discriminator property
   * @param types an array of object schemas
   * @param params
   */
  static create(discriminator, options, params) {
    const optionsMap = /* @__PURE__ */ new Map();
    for (const type2 of options) {
      const discriminatorValues = getDiscriminator(type2.shape[discriminator]);
      if (!discriminatorValues.length) {
        throw new Error(`A discriminator value for key \`${discriminator}\` could not be extracted from all schema options`);
      }
      for (const value of discriminatorValues) {
        if (optionsMap.has(value)) {
          throw new Error(`Discriminator property ${String(discriminator)} has duplicate value ${String(value)}`);
        }
        optionsMap.set(value, type2);
      }
    }
    return new _ZodDiscriminatedUnion({
      typeName: ZodFirstPartyTypeKind.ZodDiscriminatedUnion,
      discriminator,
      options,
      optionsMap,
      ...processCreateParams(params)
    });
  }
};
function mergeValues(a, b) {
  const aType = getParsedType(a);
  const bType = getParsedType(b);
  if (a === b) {
    return { valid: true, data: a };
  } else if (aType === ZodParsedType.object && bType === ZodParsedType.object) {
    const bKeys = util.objectKeys(b);
    const sharedKeys = util.objectKeys(a).filter((key) => bKeys.indexOf(key) !== -1);
    const newObj = { ...a, ...b };
    for (const key of sharedKeys) {
      const sharedValue = mergeValues(a[key], b[key]);
      if (!sharedValue.valid) {
        return { valid: false };
      }
      newObj[key] = sharedValue.data;
    }
    return { valid: true, data: newObj };
  } else if (aType === ZodParsedType.array && bType === ZodParsedType.array) {
    if (a.length !== b.length) {
      return { valid: false };
    }
    const newArray = [];
    for (let index = 0; index < a.length; index++) {
      const itemA = a[index];
      const itemB = b[index];
      const sharedValue = mergeValues(itemA, itemB);
      if (!sharedValue.valid) {
        return { valid: false };
      }
      newArray.push(sharedValue.data);
    }
    return { valid: true, data: newArray };
  } else if (aType === ZodParsedType.date && bType === ZodParsedType.date && +a === +b) {
    return { valid: true, data: a };
  } else {
    return { valid: false };
  }
}
var ZodIntersection = class extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    const handleParsed = (parsedLeft, parsedRight) => {
      if (isAborted(parsedLeft) || isAborted(parsedRight)) {
        return INVALID;
      }
      const merged = mergeValues(parsedLeft.value, parsedRight.value);
      if (!merged.valid) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.invalid_intersection_types
        });
        return INVALID;
      }
      if (isDirty(parsedLeft) || isDirty(parsedRight)) {
        status.dirty();
      }
      return { status: status.value, value: merged.data };
    };
    if (ctx.common.async) {
      return Promise.all([
        this._def.left._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        }),
        this._def.right._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        })
      ]).then(([left, right]) => handleParsed(left, right));
    } else {
      return handleParsed(this._def.left._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      }), this._def.right._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      }));
    }
  }
};
ZodIntersection.create = (left, right, params) => {
  return new ZodIntersection({
    left,
    right,
    typeName: ZodFirstPartyTypeKind.ZodIntersection,
    ...processCreateParams(params)
  });
};
var ZodTuple = class _ZodTuple extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.array) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.array,
        received: ctx.parsedType
      });
      return INVALID;
    }
    if (ctx.data.length < this._def.items.length) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.too_small,
        minimum: this._def.items.length,
        inclusive: true,
        exact: false,
        type: "array"
      });
      return INVALID;
    }
    const rest = this._def.rest;
    if (!rest && ctx.data.length > this._def.items.length) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.too_big,
        maximum: this._def.items.length,
        inclusive: true,
        exact: false,
        type: "array"
      });
      status.dirty();
    }
    const items = [...ctx.data].map((item, itemIndex) => {
      const schema2 = this._def.items[itemIndex] || this._def.rest;
      if (!schema2)
        return null;
      return schema2._parse(new ParseInputLazyPath(ctx, item, ctx.path, itemIndex));
    }).filter((x) => !!x);
    if (ctx.common.async) {
      return Promise.all(items).then((results) => {
        return ParseStatus.mergeArray(status, results);
      });
    } else {
      return ParseStatus.mergeArray(status, items);
    }
  }
  get items() {
    return this._def.items;
  }
  rest(rest) {
    return new _ZodTuple({
      ...this._def,
      rest
    });
  }
};
ZodTuple.create = (schemas, params) => {
  if (!Array.isArray(schemas)) {
    throw new Error("You must pass an array of schemas to z.tuple([ ... ])");
  }
  return new ZodTuple({
    items: schemas,
    typeName: ZodFirstPartyTypeKind.ZodTuple,
    rest: null,
    ...processCreateParams(params)
  });
};
var ZodRecord = class _ZodRecord extends ZodType {
  get keySchema() {
    return this._def.keyType;
  }
  get valueSchema() {
    return this._def.valueType;
  }
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.object) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const pairs2 = [];
    const keyType = this._def.keyType;
    const valueType = this._def.valueType;
    for (const key in ctx.data) {
      pairs2.push({
        key: keyType._parse(new ParseInputLazyPath(ctx, key, ctx.path, key)),
        value: valueType._parse(new ParseInputLazyPath(ctx, ctx.data[key], ctx.path, key)),
        alwaysSet: key in ctx.data
      });
    }
    if (ctx.common.async) {
      return ParseStatus.mergeObjectAsync(status, pairs2);
    } else {
      return ParseStatus.mergeObjectSync(status, pairs2);
    }
  }
  get element() {
    return this._def.valueType;
  }
  static create(first, second, third) {
    if (second instanceof ZodType) {
      return new _ZodRecord({
        keyType: first,
        valueType: second,
        typeName: ZodFirstPartyTypeKind.ZodRecord,
        ...processCreateParams(third)
      });
    }
    return new _ZodRecord({
      keyType: ZodString.create(),
      valueType: first,
      typeName: ZodFirstPartyTypeKind.ZodRecord,
      ...processCreateParams(second)
    });
  }
};
var ZodMap = class extends ZodType {
  get keySchema() {
    return this._def.keyType;
  }
  get valueSchema() {
    return this._def.valueType;
  }
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.map) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.map,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const keyType = this._def.keyType;
    const valueType = this._def.valueType;
    const pairs2 = [...ctx.data.entries()].map(([key, value], index) => {
      return {
        key: keyType._parse(new ParseInputLazyPath(ctx, key, ctx.path, [index, "key"])),
        value: valueType._parse(new ParseInputLazyPath(ctx, value, ctx.path, [index, "value"]))
      };
    });
    if (ctx.common.async) {
      const finalMap = /* @__PURE__ */ new Map();
      return Promise.resolve().then(async () => {
        for (const pair of pairs2) {
          const key = await pair.key;
          const value = await pair.value;
          if (key.status === "aborted" || value.status === "aborted") {
            return INVALID;
          }
          if (key.status === "dirty" || value.status === "dirty") {
            status.dirty();
          }
          finalMap.set(key.value, value.value);
        }
        return { status: status.value, value: finalMap };
      });
    } else {
      const finalMap = /* @__PURE__ */ new Map();
      for (const pair of pairs2) {
        const key = pair.key;
        const value = pair.value;
        if (key.status === "aborted" || value.status === "aborted") {
          return INVALID;
        }
        if (key.status === "dirty" || value.status === "dirty") {
          status.dirty();
        }
        finalMap.set(key.value, value.value);
      }
      return { status: status.value, value: finalMap };
    }
  }
};
ZodMap.create = (keyType, valueType, params) => {
  return new ZodMap({
    valueType,
    keyType,
    typeName: ZodFirstPartyTypeKind.ZodMap,
    ...processCreateParams(params)
  });
};
var ZodSet = class _ZodSet extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.set) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.set,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const def = this._def;
    if (def.minSize !== null) {
      if (ctx.data.size < def.minSize.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_small,
          minimum: def.minSize.value,
          type: "set",
          inclusive: true,
          exact: false,
          message: def.minSize.message
        });
        status.dirty();
      }
    }
    if (def.maxSize !== null) {
      if (ctx.data.size > def.maxSize.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_big,
          maximum: def.maxSize.value,
          type: "set",
          inclusive: true,
          exact: false,
          message: def.maxSize.message
        });
        status.dirty();
      }
    }
    const valueType = this._def.valueType;
    function finalizeSet(elements2) {
      const parsedSet = /* @__PURE__ */ new Set();
      for (const element of elements2) {
        if (element.status === "aborted")
          return INVALID;
        if (element.status === "dirty")
          status.dirty();
        parsedSet.add(element.value);
      }
      return { status: status.value, value: parsedSet };
    }
    const elements = [...ctx.data.values()].map((item, i) => valueType._parse(new ParseInputLazyPath(ctx, item, ctx.path, i)));
    if (ctx.common.async) {
      return Promise.all(elements).then((elements2) => finalizeSet(elements2));
    } else {
      return finalizeSet(elements);
    }
  }
  min(minSize, message) {
    return new _ZodSet({
      ...this._def,
      minSize: { value: minSize, message: errorUtil.toString(message) }
    });
  }
  max(maxSize, message) {
    return new _ZodSet({
      ...this._def,
      maxSize: { value: maxSize, message: errorUtil.toString(message) }
    });
  }
  size(size2, message) {
    return this.min(size2, message).max(size2, message);
  }
  nonempty(message) {
    return this.min(1, message);
  }
};
ZodSet.create = (valueType, params) => {
  return new ZodSet({
    valueType,
    minSize: null,
    maxSize: null,
    typeName: ZodFirstPartyTypeKind.ZodSet,
    ...processCreateParams(params)
  });
};
var ZodFunction = class _ZodFunction extends ZodType {
  constructor() {
    super(...arguments);
    this.validate = this.implement;
  }
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.function) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.function,
        received: ctx.parsedType
      });
      return INVALID;
    }
    function makeArgsIssue(args, error) {
      return makeIssue({
        data: args,
        path: ctx.path,
        errorMaps: [
          ctx.common.contextualErrorMap,
          ctx.schemaErrorMap,
          getErrorMap(),
          errorMap
        ].filter((x) => !!x),
        issueData: {
          code: ZodIssueCode.invalid_arguments,
          argumentsError: error
        }
      });
    }
    function makeReturnsIssue(returns, error) {
      return makeIssue({
        data: returns,
        path: ctx.path,
        errorMaps: [
          ctx.common.contextualErrorMap,
          ctx.schemaErrorMap,
          getErrorMap(),
          errorMap
        ].filter((x) => !!x),
        issueData: {
          code: ZodIssueCode.invalid_return_type,
          returnTypeError: error
        }
      });
    }
    const params = { errorMap: ctx.common.contextualErrorMap };
    const fn = ctx.data;
    if (this._def.returns instanceof ZodPromise) {
      const me = this;
      return OK(async function(...args) {
        const error = new ZodError([]);
        const parsedArgs = await me._def.args.parseAsync(args, params).catch((e) => {
          error.addIssue(makeArgsIssue(args, e));
          throw error;
        });
        const result = await Reflect.apply(fn, this, parsedArgs);
        const parsedReturns = await me._def.returns._def.type.parseAsync(result, params).catch((e) => {
          error.addIssue(makeReturnsIssue(result, e));
          throw error;
        });
        return parsedReturns;
      });
    } else {
      const me = this;
      return OK(function(...args) {
        const parsedArgs = me._def.args.safeParse(args, params);
        if (!parsedArgs.success) {
          throw new ZodError([makeArgsIssue(args, parsedArgs.error)]);
        }
        const result = Reflect.apply(fn, this, parsedArgs.data);
        const parsedReturns = me._def.returns.safeParse(result, params);
        if (!parsedReturns.success) {
          throw new ZodError([makeReturnsIssue(result, parsedReturns.error)]);
        }
        return parsedReturns.data;
      });
    }
  }
  parameters() {
    return this._def.args;
  }
  returnType() {
    return this._def.returns;
  }
  args(...items) {
    return new _ZodFunction({
      ...this._def,
      args: ZodTuple.create(items).rest(ZodUnknown.create())
    });
  }
  returns(returnType) {
    return new _ZodFunction({
      ...this._def,
      returns: returnType
    });
  }
  implement(func) {
    const validatedFunc = this.parse(func);
    return validatedFunc;
  }
  strictImplement(func) {
    const validatedFunc = this.parse(func);
    return validatedFunc;
  }
  static create(args, returns, params) {
    return new _ZodFunction({
      args: args ? args : ZodTuple.create([]).rest(ZodUnknown.create()),
      returns: returns || ZodUnknown.create(),
      typeName: ZodFirstPartyTypeKind.ZodFunction,
      ...processCreateParams(params)
    });
  }
};
var ZodLazy = class extends ZodType {
  get schema() {
    return this._def.getter();
  }
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const lazySchema = this._def.getter();
    return lazySchema._parse({ data: ctx.data, path: ctx.path, parent: ctx });
  }
};
ZodLazy.create = (getter, params) => {
  return new ZodLazy({
    getter,
    typeName: ZodFirstPartyTypeKind.ZodLazy,
    ...processCreateParams(params)
  });
};
var ZodLiteral = class extends ZodType {
  _parse(input) {
    if (input.data !== this._def.value) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_literal,
        expected: this._def.value
      });
      return INVALID;
    }
    return { status: "valid", value: input.data };
  }
  get value() {
    return this._def.value;
  }
};
ZodLiteral.create = (value, params) => {
  return new ZodLiteral({
    value,
    typeName: ZodFirstPartyTypeKind.ZodLiteral,
    ...processCreateParams(params)
  });
};
function createZodEnum(values, params) {
  return new ZodEnum({
    values,
    typeName: ZodFirstPartyTypeKind.ZodEnum,
    ...processCreateParams(params)
  });
}
var ZodEnum = class _ZodEnum extends ZodType {
  constructor() {
    super(...arguments);
    _ZodEnum_cache.set(this, void 0);
  }
  _parse(input) {
    if (typeof input.data !== "string") {
      const ctx = this._getOrReturnCtx(input);
      const expectedValues = this._def.values;
      addIssueToContext(ctx, {
        expected: util.joinValues(expectedValues),
        received: ctx.parsedType,
        code: ZodIssueCode.invalid_type
      });
      return INVALID;
    }
    if (!__classPrivateFieldGet(this, _ZodEnum_cache, "f")) {
      __classPrivateFieldSet(this, _ZodEnum_cache, new Set(this._def.values), "f");
    }
    if (!__classPrivateFieldGet(this, _ZodEnum_cache, "f").has(input.data)) {
      const ctx = this._getOrReturnCtx(input);
      const expectedValues = this._def.values;
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_enum_value,
        options: expectedValues
      });
      return INVALID;
    }
    return OK(input.data);
  }
  get options() {
    return this._def.values;
  }
  get enum() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  get Values() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  get Enum() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  extract(values, newDef = this._def) {
    return _ZodEnum.create(values, {
      ...this._def,
      ...newDef
    });
  }
  exclude(values, newDef = this._def) {
    return _ZodEnum.create(this.options.filter((opt) => !values.includes(opt)), {
      ...this._def,
      ...newDef
    });
  }
};
_ZodEnum_cache = /* @__PURE__ */ new WeakMap();
ZodEnum.create = createZodEnum;
var ZodNativeEnum = class extends ZodType {
  constructor() {
    super(...arguments);
    _ZodNativeEnum_cache.set(this, void 0);
  }
  _parse(input) {
    const nativeEnumValues = util.getValidEnumValues(this._def.values);
    const ctx = this._getOrReturnCtx(input);
    if (ctx.parsedType !== ZodParsedType.string && ctx.parsedType !== ZodParsedType.number) {
      const expectedValues = util.objectValues(nativeEnumValues);
      addIssueToContext(ctx, {
        expected: util.joinValues(expectedValues),
        received: ctx.parsedType,
        code: ZodIssueCode.invalid_type
      });
      return INVALID;
    }
    if (!__classPrivateFieldGet(this, _ZodNativeEnum_cache, "f")) {
      __classPrivateFieldSet(this, _ZodNativeEnum_cache, new Set(util.getValidEnumValues(this._def.values)), "f");
    }
    if (!__classPrivateFieldGet(this, _ZodNativeEnum_cache, "f").has(input.data)) {
      const expectedValues = util.objectValues(nativeEnumValues);
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_enum_value,
        options: expectedValues
      });
      return INVALID;
    }
    return OK(input.data);
  }
  get enum() {
    return this._def.values;
  }
};
_ZodNativeEnum_cache = /* @__PURE__ */ new WeakMap();
ZodNativeEnum.create = (values, params) => {
  return new ZodNativeEnum({
    values,
    typeName: ZodFirstPartyTypeKind.ZodNativeEnum,
    ...processCreateParams(params)
  });
};
var ZodPromise = class extends ZodType {
  unwrap() {
    return this._def.type;
  }
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.promise && ctx.common.async === false) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.promise,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const promisified = ctx.parsedType === ZodParsedType.promise ? ctx.data : Promise.resolve(ctx.data);
    return OK(promisified.then((data) => {
      return this._def.type.parseAsync(data, {
        path: ctx.path,
        errorMap: ctx.common.contextualErrorMap
      });
    }));
  }
};
ZodPromise.create = (schema2, params) => {
  return new ZodPromise({
    type: schema2,
    typeName: ZodFirstPartyTypeKind.ZodPromise,
    ...processCreateParams(params)
  });
};
var ZodEffects = class extends ZodType {
  innerType() {
    return this._def.schema;
  }
  sourceType() {
    return this._def.schema._def.typeName === ZodFirstPartyTypeKind.ZodEffects ? this._def.schema.sourceType() : this._def.schema;
  }
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    const effect = this._def.effect || null;
    const checkCtx = {
      addIssue: (arg) => {
        addIssueToContext(ctx, arg);
        if (arg.fatal) {
          status.abort();
        } else {
          status.dirty();
        }
      },
      get path() {
        return ctx.path;
      }
    };
    checkCtx.addIssue = checkCtx.addIssue.bind(checkCtx);
    if (effect.type === "preprocess") {
      const processed = effect.transform(ctx.data, checkCtx);
      if (ctx.common.async) {
        return Promise.resolve(processed).then(async (processed2) => {
          if (status.value === "aborted")
            return INVALID;
          const result = await this._def.schema._parseAsync({
            data: processed2,
            path: ctx.path,
            parent: ctx
          });
          if (result.status === "aborted")
            return INVALID;
          if (result.status === "dirty")
            return DIRTY(result.value);
          if (status.value === "dirty")
            return DIRTY(result.value);
          return result;
        });
      } else {
        if (status.value === "aborted")
          return INVALID;
        const result = this._def.schema._parseSync({
          data: processed,
          path: ctx.path,
          parent: ctx
        });
        if (result.status === "aborted")
          return INVALID;
        if (result.status === "dirty")
          return DIRTY(result.value);
        if (status.value === "dirty")
          return DIRTY(result.value);
        return result;
      }
    }
    if (effect.type === "refinement") {
      const executeRefinement = (acc) => {
        const result = effect.refinement(acc, checkCtx);
        if (ctx.common.async) {
          return Promise.resolve(result);
        }
        if (result instanceof Promise) {
          throw new Error("Async refinement encountered during synchronous parse operation. Use .parseAsync instead.");
        }
        return acc;
      };
      if (ctx.common.async === false) {
        const inner = this._def.schema._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        });
        if (inner.status === "aborted")
          return INVALID;
        if (inner.status === "dirty")
          status.dirty();
        executeRefinement(inner.value);
        return { status: status.value, value: inner.value };
      } else {
        return this._def.schema._parseAsync({ data: ctx.data, path: ctx.path, parent: ctx }).then((inner) => {
          if (inner.status === "aborted")
            return INVALID;
          if (inner.status === "dirty")
            status.dirty();
          return executeRefinement(inner.value).then(() => {
            return { status: status.value, value: inner.value };
          });
        });
      }
    }
    if (effect.type === "transform") {
      if (ctx.common.async === false) {
        const base = this._def.schema._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        });
        if (!isValid(base))
          return base;
        const result = effect.transform(base.value, checkCtx);
        if (result instanceof Promise) {
          throw new Error(`Asynchronous transform encountered during synchronous parse operation. Use .parseAsync instead.`);
        }
        return { status: status.value, value: result };
      } else {
        return this._def.schema._parseAsync({ data: ctx.data, path: ctx.path, parent: ctx }).then((base) => {
          if (!isValid(base))
            return base;
          return Promise.resolve(effect.transform(base.value, checkCtx)).then((result) => ({ status: status.value, value: result }));
        });
      }
    }
    util.assertNever(effect);
  }
};
ZodEffects.create = (schema2, effect, params) => {
  return new ZodEffects({
    schema: schema2,
    typeName: ZodFirstPartyTypeKind.ZodEffects,
    effect,
    ...processCreateParams(params)
  });
};
ZodEffects.createWithPreprocess = (preprocess, schema2, params) => {
  return new ZodEffects({
    schema: schema2,
    effect: { type: "preprocess", transform: preprocess },
    typeName: ZodFirstPartyTypeKind.ZodEffects,
    ...processCreateParams(params)
  });
};
var ZodOptional = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType === ZodParsedType.undefined) {
      return OK(void 0);
    }
    return this._def.innerType._parse(input);
  }
  unwrap() {
    return this._def.innerType;
  }
};
ZodOptional.create = (type2, params) => {
  return new ZodOptional({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodOptional,
    ...processCreateParams(params)
  });
};
var ZodNullable = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType === ZodParsedType.null) {
      return OK(null);
    }
    return this._def.innerType._parse(input);
  }
  unwrap() {
    return this._def.innerType;
  }
};
ZodNullable.create = (type2, params) => {
  return new ZodNullable({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodNullable,
    ...processCreateParams(params)
  });
};
var ZodDefault = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    let data = ctx.data;
    if (ctx.parsedType === ZodParsedType.undefined) {
      data = this._def.defaultValue();
    }
    return this._def.innerType._parse({
      data,
      path: ctx.path,
      parent: ctx
    });
  }
  removeDefault() {
    return this._def.innerType;
  }
};
ZodDefault.create = (type2, params) => {
  return new ZodDefault({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodDefault,
    defaultValue: typeof params.default === "function" ? params.default : () => params.default,
    ...processCreateParams(params)
  });
};
var ZodCatch = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const newCtx = {
      ...ctx,
      common: {
        ...ctx.common,
        issues: []
      }
    };
    const result = this._def.innerType._parse({
      data: newCtx.data,
      path: newCtx.path,
      parent: {
        ...newCtx
      }
    });
    if (isAsync(result)) {
      return result.then((result2) => {
        return {
          status: "valid",
          value: result2.status === "valid" ? result2.value : this._def.catchValue({
            get error() {
              return new ZodError(newCtx.common.issues);
            },
            input: newCtx.data
          })
        };
      });
    } else {
      return {
        status: "valid",
        value: result.status === "valid" ? result.value : this._def.catchValue({
          get error() {
            return new ZodError(newCtx.common.issues);
          },
          input: newCtx.data
        })
      };
    }
  }
  removeCatch() {
    return this._def.innerType;
  }
};
ZodCatch.create = (type2, params) => {
  return new ZodCatch({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodCatch,
    catchValue: typeof params.catch === "function" ? params.catch : () => params.catch,
    ...processCreateParams(params)
  });
};
var ZodNaN = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.nan) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.nan,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return { status: "valid", value: input.data };
  }
};
ZodNaN.create = (params) => {
  return new ZodNaN({
    typeName: ZodFirstPartyTypeKind.ZodNaN,
    ...processCreateParams(params)
  });
};
var BRAND = Symbol("zod_brand");
var ZodBranded = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const data = ctx.data;
    return this._def.type._parse({
      data,
      path: ctx.path,
      parent: ctx
    });
  }
  unwrap() {
    return this._def.type;
  }
};
var ZodPipeline = class _ZodPipeline extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.common.async) {
      const handleAsync = async () => {
        const inResult = await this._def.in._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        });
        if (inResult.status === "aborted")
          return INVALID;
        if (inResult.status === "dirty") {
          status.dirty();
          return DIRTY(inResult.value);
        } else {
          return this._def.out._parseAsync({
            data: inResult.value,
            path: ctx.path,
            parent: ctx
          });
        }
      };
      return handleAsync();
    } else {
      const inResult = this._def.in._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      });
      if (inResult.status === "aborted")
        return INVALID;
      if (inResult.status === "dirty") {
        status.dirty();
        return {
          status: "dirty",
          value: inResult.value
        };
      } else {
        return this._def.out._parseSync({
          data: inResult.value,
          path: ctx.path,
          parent: ctx
        });
      }
    }
  }
  static create(a, b) {
    return new _ZodPipeline({
      in: a,
      out: b,
      typeName: ZodFirstPartyTypeKind.ZodPipeline
    });
  }
};
var ZodReadonly = class extends ZodType {
  _parse(input) {
    const result = this._def.innerType._parse(input);
    const freeze = (data) => {
      if (isValid(data)) {
        data.value = Object.freeze(data.value);
      }
      return data;
    };
    return isAsync(result) ? result.then((data) => freeze(data)) : freeze(result);
  }
  unwrap() {
    return this._def.innerType;
  }
};
ZodReadonly.create = (type2, params) => {
  return new ZodReadonly({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodReadonly,
    ...processCreateParams(params)
  });
};
function custom(check, params = {}, fatal) {
  if (check)
    return ZodAny.create().superRefine((data, ctx) => {
      var _a, _b;
      if (!check(data)) {
        const p = typeof params === "function" ? params(data) : typeof params === "string" ? { message: params } : params;
        const _fatal = (_b = (_a = p.fatal) !== null && _a !== void 0 ? _a : fatal) !== null && _b !== void 0 ? _b : true;
        const p2 = typeof p === "string" ? { message: p } : p;
        ctx.addIssue({ code: "custom", ...p2, fatal: _fatal });
      }
    });
  return ZodAny.create();
}
var late = {
  object: ZodObject.lazycreate
};
var ZodFirstPartyTypeKind;
(function(ZodFirstPartyTypeKind2) {
  ZodFirstPartyTypeKind2["ZodString"] = "ZodString";
  ZodFirstPartyTypeKind2["ZodNumber"] = "ZodNumber";
  ZodFirstPartyTypeKind2["ZodNaN"] = "ZodNaN";
  ZodFirstPartyTypeKind2["ZodBigInt"] = "ZodBigInt";
  ZodFirstPartyTypeKind2["ZodBoolean"] = "ZodBoolean";
  ZodFirstPartyTypeKind2["ZodDate"] = "ZodDate";
  ZodFirstPartyTypeKind2["ZodSymbol"] = "ZodSymbol";
  ZodFirstPartyTypeKind2["ZodUndefined"] = "ZodUndefined";
  ZodFirstPartyTypeKind2["ZodNull"] = "ZodNull";
  ZodFirstPartyTypeKind2["ZodAny"] = "ZodAny";
  ZodFirstPartyTypeKind2["ZodUnknown"] = "ZodUnknown";
  ZodFirstPartyTypeKind2["ZodNever"] = "ZodNever";
  ZodFirstPartyTypeKind2["ZodVoid"] = "ZodVoid";
  ZodFirstPartyTypeKind2["ZodArray"] = "ZodArray";
  ZodFirstPartyTypeKind2["ZodObject"] = "ZodObject";
  ZodFirstPartyTypeKind2["ZodUnion"] = "ZodUnion";
  ZodFirstPartyTypeKind2["ZodDiscriminatedUnion"] = "ZodDiscriminatedUnion";
  ZodFirstPartyTypeKind2["ZodIntersection"] = "ZodIntersection";
  ZodFirstPartyTypeKind2["ZodTuple"] = "ZodTuple";
  ZodFirstPartyTypeKind2["ZodRecord"] = "ZodRecord";
  ZodFirstPartyTypeKind2["ZodMap"] = "ZodMap";
  ZodFirstPartyTypeKind2["ZodSet"] = "ZodSet";
  ZodFirstPartyTypeKind2["ZodFunction"] = "ZodFunction";
  ZodFirstPartyTypeKind2["ZodLazy"] = "ZodLazy";
  ZodFirstPartyTypeKind2["ZodLiteral"] = "ZodLiteral";
  ZodFirstPartyTypeKind2["ZodEnum"] = "ZodEnum";
  ZodFirstPartyTypeKind2["ZodEffects"] = "ZodEffects";
  ZodFirstPartyTypeKind2["ZodNativeEnum"] = "ZodNativeEnum";
  ZodFirstPartyTypeKind2["ZodOptional"] = "ZodOptional";
  ZodFirstPartyTypeKind2["ZodNullable"] = "ZodNullable";
  ZodFirstPartyTypeKind2["ZodDefault"] = "ZodDefault";
  ZodFirstPartyTypeKind2["ZodCatch"] = "ZodCatch";
  ZodFirstPartyTypeKind2["ZodPromise"] = "ZodPromise";
  ZodFirstPartyTypeKind2["ZodBranded"] = "ZodBranded";
  ZodFirstPartyTypeKind2["ZodPipeline"] = "ZodPipeline";
  ZodFirstPartyTypeKind2["ZodReadonly"] = "ZodReadonly";
})(ZodFirstPartyTypeKind || (ZodFirstPartyTypeKind = {}));
var instanceOfType = (cls, params = {
  message: `Input not instance of ${cls.name}`
}) => custom((data) => data instanceof cls, params);
var stringType = ZodString.create;
var numberType = ZodNumber.create;
var nanType = ZodNaN.create;
var bigIntType = ZodBigInt.create;
var booleanType = ZodBoolean.create;
var dateType = ZodDate.create;
var symbolType = ZodSymbol.create;
var undefinedType = ZodUndefined.create;
var nullType = ZodNull.create;
var anyType = ZodAny.create;
var unknownType = ZodUnknown.create;
var neverType = ZodNever.create;
var voidType = ZodVoid.create;
var arrayType = ZodArray.create;
var objectType = ZodObject.create;
var strictObjectType = ZodObject.strictCreate;
var unionType = ZodUnion.create;
var discriminatedUnionType = ZodDiscriminatedUnion.create;
var intersectionType = ZodIntersection.create;
var tupleType = ZodTuple.create;
var recordType = ZodRecord.create;
var mapType = ZodMap.create;
var setType = ZodSet.create;
var functionType = ZodFunction.create;
var lazyType = ZodLazy.create;
var literalType = ZodLiteral.create;
var enumType = ZodEnum.create;
var nativeEnumType = ZodNativeEnum.create;
var promiseType = ZodPromise.create;
var effectsType = ZodEffects.create;
var optionalType = ZodOptional.create;
var nullableType = ZodNullable.create;
var preprocessType = ZodEffects.createWithPreprocess;
var pipelineType = ZodPipeline.create;
var ostring = () => stringType().optional();
var onumber = () => numberType().optional();
var oboolean = () => booleanType().optional();
var coerce = {
  string: (arg) => ZodString.create({ ...arg, coerce: true }),
  number: (arg) => ZodNumber.create({ ...arg, coerce: true }),
  boolean: (arg) => ZodBoolean.create({
    ...arg,
    coerce: true
  }),
  bigint: (arg) => ZodBigInt.create({ ...arg, coerce: true }),
  date: (arg) => ZodDate.create({ ...arg, coerce: true })
};
var NEVER = INVALID;
var z = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  defaultErrorMap: errorMap,
  setErrorMap,
  getErrorMap,
  makeIssue,
  EMPTY_PATH,
  addIssueToContext,
  ParseStatus,
  INVALID,
  DIRTY,
  OK,
  isAborted,
  isDirty,
  isValid,
  isAsync,
  get util() {
    return util;
  },
  get objectUtil() {
    return objectUtil;
  },
  ZodParsedType,
  getParsedType,
  ZodType,
  datetimeRegex,
  ZodString,
  ZodNumber,
  ZodBigInt,
  ZodBoolean,
  ZodDate,
  ZodSymbol,
  ZodUndefined,
  ZodNull,
  ZodAny,
  ZodUnknown,
  ZodNever,
  ZodVoid,
  ZodArray,
  ZodObject,
  ZodUnion,
  ZodDiscriminatedUnion,
  ZodIntersection,
  ZodTuple,
  ZodRecord,
  ZodMap,
  ZodSet,
  ZodFunction,
  ZodLazy,
  ZodLiteral,
  ZodEnum,
  ZodNativeEnum,
  ZodPromise,
  ZodEffects,
  ZodTransformer: ZodEffects,
  ZodOptional,
  ZodNullable,
  ZodDefault,
  ZodCatch,
  ZodNaN,
  BRAND,
  ZodBranded,
  ZodPipeline,
  ZodReadonly,
  custom,
  Schema: ZodType,
  ZodSchema: ZodType,
  late,
  get ZodFirstPartyTypeKind() {
    return ZodFirstPartyTypeKind;
  },
  coerce,
  any: anyType,
  array: arrayType,
  bigint: bigIntType,
  boolean: booleanType,
  date: dateType,
  discriminatedUnion: discriminatedUnionType,
  effect: effectsType,
  "enum": enumType,
  "function": functionType,
  "instanceof": instanceOfType,
  intersection: intersectionType,
  lazy: lazyType,
  literal: literalType,
  map: mapType,
  nan: nanType,
  nativeEnum: nativeEnumType,
  never: neverType,
  "null": nullType,
  nullable: nullableType,
  number: numberType,
  object: objectType,
  oboolean,
  onumber,
  optional: optionalType,
  ostring,
  pipeline: pipelineType,
  preprocess: preprocessType,
  promise: promiseType,
  record: recordType,
  set: setType,
  strictObject: strictObjectType,
  string: stringType,
  symbol: symbolType,
  transformer: effectsType,
  tuple: tupleType,
  "undefined": undefinedType,
  union: unionType,
  unknown: unknownType,
  "void": voidType,
  NEVER,
  ZodIssueCode,
  quotelessJson,
  ZodError
});

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/schemas/RedoclyCodeSampleSchema.js
var RedoclyCodeSampleSchema = z.object({
  lang: z.string(),
  label: z.optional(z.string()),
  source: z.string()
});
var RedoclyCodeSampleArraySchema = z.array(RedoclyCodeSampleSchema);

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/readmeExtensions.js
var ReadmeOpenAPIExtension = {
  /**
   * Migrate from readme extensions to fern IR.
   *
   * https://docs.readme.com/main/docs/openapi-extensions
   */
  README_EXT: "x-readme"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getReadmeCodeSamples.js
function isReadMeCodeSamples(maybeCodeSamples) {
  if (!Array.isArray(maybeCodeSamples)) {
    return false;
  }
  for (const maybeCodeSample of maybeCodeSamples) {
    if (!isPlainObject2(maybeCodeSample)) {
      return false;
    }
    if (typeof maybeCodeSample.language !== "string" || typeof maybeCodeSample.code !== "string") {
      return false;
    }
  }
  return true;
}
function getRawReadmeCodeSamples(operationObject) {
  const readme = getExtension(operationObject, ReadmeOpenAPIExtension.README_EXT);
  if (!isPlainObject2(readme)) {
    return [];
  }
  const readmeCodeSamples = readme["code-samples"];
  if (!isReadMeCodeSamples(readmeCodeSamples)) {
    return [];
  }
  const customCodeSamples = [];
  for (const codeSample of readmeCodeSamples) {
    customCodeSamples.push({
      name: codeSample.name,
      language: codeSample.language,
      code: codeSample.code,
      install: codeSample.install,
      docs: void 0
    });
  }
  return customCodeSamples;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getExamplesFromExtension.js
function getExamplesFromExtension(operationContext, operationObject, context) {
  const exampleEndpointCalls = getExtension(
    operationObject,
    FernOpenAPIExtension.EXAMPLES
    // RawSchemas.ExampleEndpointCallArraySchema,
    // context.logger,
    // [...operationContext.baseBreadcrumbs, `${operationContext.method} ${operationContext.path}`]
  ) ?? [];
  const validatedExampleEndpointCalls = exampleEndpointCalls.filter((example) => {
    const maybeFernExample = schemas_exports3.serialization.ExampleEndpointCallSchema.parse(example);
    if (!maybeFernExample.ok) {
      context.logger.error(`Failed to parse x-fern-example in ${operationContext.path}/${operationContext.method}`);
    }
    return maybeFernExample.ok;
  });
  const redoclyCodeSamplesKebabCase = getExtensionAndValidate(operationObject, OpenAPIExtension.REDOCLY_CODE_SAMPLES_KEBAB, RedoclyCodeSampleArraySchema, context.logger, [...operationContext.baseBreadcrumbs, `${operationContext.method} ${operationContext.path}`]) ?? [];
  const redoclyCodeSamplesCamelCase = getExtensionAndValidate(operationObject, OpenAPIExtension.REDOCLY_CODE_SAMPLES_CAMEL, RedoclyCodeSampleArraySchema, context.logger, [...operationContext.baseBreadcrumbs, `${operationContext.method} ${operationContext.path}`]) ?? [];
  const redoclyCodeSamples = [
    ...redoclyCodeSamplesCamelCase,
    ...redoclyCodeSamplesKebabCase
  ];
  if (redoclyCodeSamples.length > 0) {
    validatedExampleEndpointCalls.push({
      "code-samples": redoclyCodeSamples.map((value) => ({
        name: value.label ?? value.lang,
        language: value.lang,
        code: value.source,
        install: void 0,
        docs: void 0
      }))
    });
  }
  const readmeCodeSamples = getRawReadmeCodeSamples(operationObject);
  if (readmeCodeSamples.length > 0) {
    validatedExampleEndpointCalls.push({
      "code-samples": readmeCodeSamples
    });
  }
  return validatedExampleEndpointCalls.map(EndpointExample.unknown);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernAvailability.js
function getFernAvailability(operationObject) {
  const availability = getExtension(operationObject, FernOpenAPIExtension.AVAILABILITY);
  if (availability === "ga" || availability === "generally-available") {
    return Availability.GenerallyAvailable;
  } else if (availability === "beta" || availability === "pre-release") {
    return Availability.Beta;
  } else if (availability === "deprecated") {
    return Availability.Deprecated;
  }
  if (operationObject.deprecated) {
    return Availability.Deprecated;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertServer.js
function convertServer(server) {
  return {
    url: getServerUrl({ url: server.url, variables: server.variables ?? {} }),
    description: server.description,
    name: getServerName(server),
    audiences: getExtension(server, FernOpenAPIExtension.AUDIENCES)
  };
}
function getServerUrl({ url, variables }) {
  const valuesToSubstitute = Object.fromEntries(Object.entries(variables).map(([name, declaration]) => {
    return [name, declaration.default];
  }));
  for (const [variable, value] of Object.entries(valuesToSubstitute)) {
    url = url.replace(`{${variable}}`, value);
  }
  return url;
}
function getServerName(server) {
  const name = getExtension(server, [
    FernOpenAPIExtension.SERVER_NAME_V1,
    FernOpenAPIExtension.SERVER_NAME_V2
  ]);
  if (name != null) {
    return name;
  }
  if (server.description?.toLowerCase() === "production") {
    return "Production";
  }
  if (server.description?.toLowerCase() === "sandbox") {
    return "Sandbox";
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getParameterName.js
function getParameterName(parameter) {
  return getExtension(parameter, FernOpenAPIExtension.PARAMETER_NAME);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getVariableReference.js
function getVariableReference(parameter) {
  return getExtension(parameter, FernOpenAPIExtension.SDK_VARIABLE);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/convertParameters.js
function convertParameters({ path: path5, httpMethod, parameters, context, requestBreadcrumbs, source }) {
  const convertedParameters = {
    pathParameters: [],
    queryParameters: [],
    headers: []
  };
  for (const parameter of parameters) {
    const shouldIgnore = getExtension(parameter, FernOpenAPIExtension.IGNORE);
    if (shouldIgnore != null && shouldIgnore) {
      context.logger.debug(`${httpMethod.toUpperCase()} ${path5} has a parameter marked with x-fern-ignore. Skipping.`);
      continue;
    }
    const resolvedParameter = isReferenceObject(parameter) ? context.resolveParameterReference(parameter) : parameter;
    const isRequired = resolvedParameter.required ?? false;
    const availability = convertAvailability3(resolvedParameter);
    const parameterBreadcrumbs = [...requestBreadcrumbs, resolvedParameter.name];
    const generatedName = getGeneratedTypeName(parameterBreadcrumbs, context.options.preserveSchemaIds);
    let schema2 = resolvedParameter.schema != null ? convertSchema(resolvedParameter.schema, !isRequired, context, parameterBreadcrumbs, source, context.namespace, false, /* @__PURE__ */ new Set(), getExamplesString({
      schema: resolvedParameter,
      logger: context.logger
    })) : isRequired ? SchemaWithExample.primitive({
      nameOverride: void 0,
      generatedName,
      title: void 0,
      schema: PrimitiveSchemaValueWithExample.string({
        default: void 0,
        pattern: void 0,
        format: void 0,
        minLength: void 0,
        maxLength: void 0,
        example: getExamplesString({
          schema: resolvedParameter,
          logger: context.logger
        })
      }),
      description: void 0,
      availability,
      groupName: void 0
    }) : SchemaWithExample.optional({
      nameOverride: void 0,
      generatedName,
      title: void 0,
      value: SchemaWithExample.primitive({
        nameOverride: void 0,
        generatedName,
        title: void 0,
        schema: PrimitiveSchemaValueWithExample.string({
          default: void 0,
          pattern: void 0,
          format: void 0,
          minLength: void 0,
          maxLength: void 0,
          example: getExamplesString({
            schema: resolvedParameter,
            logger: context.logger
          })
        }),
        description: void 0,
        availability: void 0,
        groupName: void 0
      }),
      description: void 0,
      availability,
      groupName: void 0
    });
    if (resolvedParameter.in === "header" && resolvedParameter.schema != null && !isReferenceObject(resolvedParameter.schema) && // eslint-disable-next-line @typescript-eslint/no-explicit-any
    resolvedParameter.schema.default != null) {
      const defaultValue = resolvedParameter.schema.default;
      if (typeof defaultValue === "string" && defaultValue.length > 0) {
        schema2 = SchemaWithExample.literal({
          nameOverride: void 0,
          generatedName,
          title: void 0,
          value: LiteralSchemaValue.string(defaultValue),
          description: void 0,
          availability,
          groupName: void 0
        });
      }
    }
    const convertedParameter = {
      name: resolvedParameter.name,
      schema: schema2,
      description: resolvedParameter.description,
      parameterNameOverride: getParameterName(resolvedParameter),
      availability,
      source
    };
    if (resolvedParameter.in === "query") {
      convertedParameters.queryParameters.push(convertedParameter);
    } else if (resolvedParameter.in === "path") {
      convertedParameters.pathParameters.push({
        ...convertedParameter,
        variableReference: getVariableReference(resolvedParameter)
      });
    } else if (resolvedParameter.in === "header") {
      if (!HEADERS_TO_SKIP.has(resolvedParameter.name.toLowerCase()) && !context.authHeaders.has(resolvedParameter.name)) {
        convertedParameters.headers.push({ ...convertedParameter, env: void 0 });
      } else {
        context.logger.debug(`Ignoring ${resolvedParameter.name} header, in ${httpMethod.toUpperCase()} ${path5}`);
      }
    } else {
      context.logger.warn(`Skipping ${resolvedParameter.in} parameter, ${resolvedParameter.name}, in ${httpMethod.toUpperCase()} ${path5}`);
    }
  }
  return convertedParameters;
}
var HEADERS_TO_SKIP = /* @__PURE__ */ new Set([
  "user-agent",
  "content-length",
  "content-type",
  "x-forwarded-for",
  "cookie",
  "origin",
  "content-disposition",
  "x-ping-custom-domain"
]);

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/getApplicationJsonSchema.js
function getTextEventStreamObject(media, context) {
  for (const contentType of Object.keys(media)) {
    if (contentType.includes("text/event-stream")) {
      const mediaObject = media[contentType];
      if (mediaObject == null) {
        continue;
      }
      const schema2 = mediaObject.schema;
      return {
        contentType,
        schema: schema2 ?? {},
        examples: getExamples2(mediaObject, context)
      };
    }
  }
  return void 0;
}
function getApplicationJsonSchemaMediaObject(media, context) {
  for (const contentType of Object.keys(media)) {
    if (contentType.includes("json") || contentType === "*/*") {
      const mediaObject = media[contentType];
      if (mediaObject == null) {
        continue;
      }
      const schema2 = mediaObject.schema;
      return {
        contentType: !contentType.includes("*") ? contentType : void 0,
        schema: schema2 ?? {},
        examples: getExamples2(mediaObject, context)
      };
    }
  }
  return void 0;
}
function getSchemaMediaObject(media, context) {
  for (const contentType of Object.keys(media)) {
    const mediaObject = media[contentType];
    if (mediaObject == null) {
      continue;
    }
    const schema2 = mediaObject.schema;
    return {
      schema: schema2 ?? {},
      examples: getExamples2(mediaObject, context)
    };
  }
  return void 0;
}
function getExamples2(mediaObject, context) {
  const fullExamples = [];
  if (mediaObject.example != null) {
    fullExamples.push({ name: void 0, value: mediaObject.example, description: void 0 });
  }
  const examples = getExtension(mediaObject, OpenAPIExtension.EXAMPLES);
  if (examples != null && Object.keys(examples).length > 0) {
    fullExamples.push(...Object.entries(examples).map(([name, value]) => {
      return { name: value.summary ?? name, value: value.value, description: value.description };
    }));
  }
  if (mediaObject.examples != null && Object.keys(mediaObject.examples).length > 0) {
    fullExamples.push(...Object.entries(mediaObject.examples).map(([name, example]) => {
      const resolvedExample = isReferenceObject(example) ? context.resolveExampleReference(example) : example;
      return {
        name: resolvedExample.summary ?? name,
        value: resolvedExample.value,
        description: resolvedExample.description
      };
    }));
  }
  return fullExamples;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/convertRequest.js
function getApplicationUrlFormEncodedRequest(requestBody, context) {
  for (const [mediaType, mediaTypeObject] of Object.entries(requestBody.content)) {
    if (MediaType.parse(mediaType)?.isURLEncoded()) {
      return {
        schema: mediaTypeObject.schema,
        contentType: mediaType,
        examples: getExamples2(mediaTypeObject, context)
      };
    }
  }
  return void 0;
}
function getMultipartFormDataRequest(requestBody) {
  for (const [mediaType, mediaTypeObject] of Object.entries(requestBody.content)) {
    if (MediaType.parse(mediaType)?.isMultipart()) {
      return { schema: mediaTypeObject.schema, encoding: mediaTypeObject.encoding };
    }
  }
  return void 0;
}
function isOctetStreamRequest(requestBody) {
  for (const mediaType in requestBody.content) {
    if (MediaType.parse(mediaType)?.isOctetStream()) {
      return true;
    }
  }
  return false;
}
function multipartRequestHasFile(multipartSchema, document) {
  const resolvedMultipartSchema = isReferenceObject(multipartSchema) ? resolveSchema(multipartSchema, document) : {
    id: void 0,
    schema: multipartSchema
  };
  return Object.entries(resolvedMultipartSchema.schema.properties ?? {}).find(([_, definition]) => {
    return !isReferenceObject(definition) && definition.type === "string" && definition.format === "binary";
  }) != null;
}
function convertRequest({ requestBody, document, context, requestBreadcrumbs, source, namespace }) {
  const resolvedRequestBody = isReferenceObject(requestBody) ? context.resolveRequestBodyReference(requestBody) : requestBody;
  const multipartFormData = getMultipartFormDataRequest(resolvedRequestBody);
  const multipartSchema = multipartFormData?.schema;
  const multipartEncoding = multipartFormData?.encoding;
  const urlEncodedRequest = getApplicationUrlFormEncodedRequest(resolvedRequestBody, context);
  const jsonMediaObject = getApplicationJsonSchemaMediaObject(resolvedRequestBody.content, context);
  if (urlEncodedRequest != null && urlEncodedRequest.schema != null) {
    const convertedUrlEncodedSchema = convertSchema(urlEncodedRequest.schema, false, context, requestBreadcrumbs, source, namespace);
    return RequestWithExample.json({
      schema: convertedUrlEncodedSchema,
      description: resolvedRequestBody.description,
      contentType: urlEncodedRequest.contentType,
      source,
      fullExamples: urlEncodedRequest.examples,
      additionalProperties: false
    });
  }
  if (isOctetStreamRequest(resolvedRequestBody)) {
    return RequestWithExample.octetStream({
      description: resolvedRequestBody.description,
      source
    });
  }
  if (multipartSchema != null && jsonMediaObject == null || multipartSchema != null && multipartRequestHasFile(multipartSchema, document)) {
    const resolvedMultipartSchema = isReferenceObject(multipartSchema) ? resolveSchema(multipartSchema, document) : {
      id: void 0,
      schema: multipartSchema
    };
    const convertedMultipartSchema = convertSchema(resolvedMultipartSchema.schema, false, context, requestBreadcrumbs, source, namespace);
    const properties = [];
    if (convertedMultipartSchema.type === "object") {
      for (const property4 of convertedMultipartSchema.properties) {
        if (property4.schema.type === "primitive" && property4.schema.schema.type === "string" && property4.schema.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: false, isArray: false }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        if (property4.schema.type === "optional" && property4.schema.value.type === "primitive" && property4.schema.value.schema.type === "string" && property4.schema.value.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: true, isArray: false }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        if (property4.schema.type === "array" && property4.schema.value.type === "primitive" && property4.schema.value.schema.type === "string" && property4.schema.value.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: false, isArray: true }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        if (property4.schema.type === "optional" && property4.schema.value.type === "array" && property4.schema.value.value.type === "primitive" && property4.schema.value.value.schema.type === "string" && property4.schema.value.value.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: true, isArray: true }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        properties.push({
          key: property4.key,
          schema: MultipartSchema.json(property4.schema),
          description: void 0,
          contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
        });
      }
    }
    return RequestWithExample.multipart({
      name: isReferenceObject(multipartSchema) && context.getNumberOfOccurrencesForRef(multipartSchema) === 1 ? resolvedMultipartSchema.id : void 0,
      description: resolvedMultipartSchema.schema.description,
      properties,
      source
    });
  }
  if (jsonMediaObject == null) {
    return void 0;
  }
  const requestSchema = convertSchema(jsonMediaObject.schema, false, context, requestBreadcrumbs, source, namespace, true);
  return RequestWithExample.json({
    description: void 0,
    schema: requestSchema,
    contentType: jsonMediaObject.contentType,
    fullExamples: jsonMediaObject.examples,
    additionalProperties: !isReferenceObject(jsonMediaObject.schema) && isAdditionalPropertiesAny(jsonMediaObject.schema.additionalProperties),
    source
  });
}
function resolveSchema(schema2, document) {
  if (!schema2.$ref.startsWith(SCHEMA_REFERENCE_PREFIX)) {
    throw new Error(`Failed to resolve schema reference because of unsupported prefix: ${schema2.$ref}`);
  }
  const schemaId = getSchemaIdFromReference(schema2);
  if (schemaId == null) {
    throw new Error(`Failed to resolve schema reference because missing schema id: ${schema2.$ref}`);
  }
  const resolvedSchema = document.components?.schemas?.[schemaId];
  if (resolvedSchema == null) {
    throw new Error(`Failed to resolve schema reference because missing: ${schema2.$ref}`);
  }
  if (isReferenceObject(resolvedSchema)) {
    return resolveSchema(resolvedSchema, document);
  }
  return {
    id: schemaId,
    schema: resolvedSchema
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertToHttpError.js
var ERROR_NAMES_BY_STATUS_CODE = {
  400: "BadRequestError",
  401: "UnauthorizedError",
  402: "PaymentRequiredError",
  403: "ForbiddenError",
  404: "NotFoundError",
  405: "MethodNotAllowedError",
  406: "NotAcceptableError",
  407: "ProxyAuthenticationRequiredError",
  408: "RequestTimeoutError",
  409: "ConflictError",
  410: "GoneError",
  411: "LengthRequiredError",
  412: "PreconditionFailedError",
  413: "ContentTooLargeError",
  414: "URITooLongError",
  415: "UnsupportedMediaTypeError",
  416: "RangeNotSatisfiableError",
  417: "ExpectationFailedError",
  418: "ImATeapotError",
  419: "AuthenticationTimeoutError",
  420: "MethodFailureError",
  421: "MisdirectedRequestError",
  422: "UnprocessableEntityError",
  423: "LockedError",
  424: "FailedDependencyError",
  425: "TooEarlyError",
  426: "UpgradeRequiredError",
  // TODO: 428 should be PreconditionRequiredError
  428: "PreconditionError",
  429: "TooManyRequestsError",
  430: "RequestHeaderFieldsTooLargeError",
  431: "RequestHeaderFieldsTooLargeError",
  444: "NoResponseError",
  449: "RetryWithError",
  450: "BlockedByWindowsParentalControlsError",
  451: "UnavailableForLegalReasonsError",
  498: "InvalidTokenError",
  499: "ClientClosedRequestError",
  500: "InternalServerError",
  501: "NotImplementedError",
  502: "BadGatewayError",
  503: "ServiceUnavailableError",
  504: "GatewayTimeoutError",
  505: "HTTPVersionNotSupportedError",
  506: "VariantAlsoNegotiatesError",
  507: "InsufficientStorageError",
  508: "LoopDetectedError",
  509: "BandwidthLimitExceededError",
  510: "NotExtendedError",
  511: "NetworkAuthenticationRequiredError"
};
var ERROR_NAMES = new Set(Object.values(ERROR_NAMES_BY_STATUS_CODE));

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/convertResponse.js
var SUCCESSFUL_STATUS_CODES = ["200", "201", "202", "204"];
function convertResponse({ operationContext, responses, context, responseBreadcrumbs, responseStatusCode, streamFormat, source }) {
  if (responses == null) {
    return { value: void 0, errors: {} };
  }
  const errors = markErrorSchemas({ responses, context, source, namespace: context.namespace });
  let successStatusCodePresent = false;
  let convertedResponse = void 0;
  for (const statusCode of responseStatusCode != null ? [responseStatusCode] : SUCCESSFUL_STATUS_CODES) {
    const response = responses[statusCode];
    if (response == null) {
      continue;
    }
    successStatusCodePresent = true;
    if (convertedResponse == null) {
      convertedResponse = convertResolvedResponse({
        operationContext,
        response,
        context,
        responseBreadcrumbs,
        streamFormat,
        source,
        namespace: context.namespace
      });
    }
  }
  if (convertedResponse == null && !successStatusCodePresent && responses.default != null) {
    convertedResponse = convertResolvedResponse({
      operationContext,
      response: responses.default,
      context,
      responseBreadcrumbs,
      streamFormat,
      source,
      namespace: context.namespace
    });
  }
  if (convertedResponse != null) {
    switch (convertedResponse.type) {
      case "json":
        return {
          value: convertedResponse,
          errors
        };
      case "streamingJson":
      case "streamingSse":
        return {
          value: convertedResponse,
          errors
        };
      case "file":
      case "text":
      case "streamingText":
        return {
          value: convertedResponse,
          errors
        };
      default:
        assertNever(convertedResponse);
    }
  }
  return {
    value: void 0,
    errors
  };
}
function convertResolvedResponse({ operationContext, streamFormat, response, context, responseBreadcrumbs, source, namespace }) {
  const resolvedResponse = isReferenceObject(response) ? context.resolveResponseReference(response) : response;
  if (resolvedResponse.content != null) {
    const isdownloadFile = Object.entries(resolvedResponse.content).find(([_, mediaObject]) => {
      if (mediaObject.schema == null) {
        return false;
      }
      const resolvedSchema = isReferenceObject(mediaObject.schema) ? context.resolveSchemaReference(mediaObject.schema) : mediaObject.schema;
      return resolvedSchema.type === "string" && resolvedSchema.format === "binary";
    });
    if (isdownloadFile) {
      return ResponseWithExample.file({ description: resolvedResponse.description, source });
    }
  }
  const textEventStreamObject = getTextEventStreamObject(resolvedResponse.content ?? {}, context);
  if (textEventStreamObject != null && streamFormat != null) {
    switch (streamFormat) {
      case "json":
        return ResponseWithExample.streamingJson({
          description: resolvedResponse.description,
          responseProperty: getExtension(operationContext.operation, FernOpenAPIExtension.RESPONSE_PROPERTY),
          fullExamples: textEventStreamObject.examples,
          schema: convertSchema(textEventStreamObject.schema, false, context, responseBreadcrumbs, source, namespace),
          source
        });
      case "sse":
        return ResponseWithExample.streamingSse({
          description: resolvedResponse.description,
          responseProperty: void 0,
          schema: convertSchemaWithExampleToSchema(convertSchema(textEventStreamObject.schema, false, context, responseBreadcrumbs, source, namespace)),
          source
        });
    }
  }
  const jsonMediaObject = getApplicationJsonSchemaMediaObject(resolvedResponse.content ?? {}, context);
  if (jsonMediaObject != null) {
    if (streamFormat != null) {
      switch (streamFormat) {
        case "json":
          return ResponseWithExample.streamingJson({
            description: resolvedResponse.description,
            responseProperty: void 0,
            fullExamples: jsonMediaObject.examples,
            schema: convertSchema(jsonMediaObject.schema, false, context, responseBreadcrumbs, source, namespace),
            source
          });
        case "sse":
          return ResponseWithExample.streamingSse({
            description: resolvedResponse.description,
            responseProperty: void 0,
            schema: convertSchemaWithExampleToSchema(convertSchema(jsonMediaObject.schema, false, context, responseBreadcrumbs, source, namespace)),
            source
          });
      }
    }
    return ResponseWithExample.json({
      description: resolvedResponse.description,
      schema: convertSchema(jsonMediaObject.schema, false, context, responseBreadcrumbs, source, namespace),
      responseProperty: getExtension(operationContext.operation, FernOpenAPIExtension.RESPONSE_PROPERTY),
      fullExamples: jsonMediaObject.examples,
      source
    });
  }
  for (const [mediaType, mediaObject] of Object.entries(resolvedResponse.content ?? {})) {
    const mimeType = MediaType.parse(mediaType);
    if (mimeType == null) {
      continue;
    }
    if (mimeType.isOctetStream() || mimeType.isPDF() || mimeType.isAudio() || mimeType.isImage() || mimeType.isVideo()) {
      return ResponseWithExample.file({ description: resolvedResponse.description, source });
    }
    if (mimeType.isPlainText()) {
      const textPlainSchema = mediaObject.schema;
      if (textPlainSchema == null) {
        return ResponseWithExample.text({ description: resolvedResponse.description, source });
      }
      const resolvedTextPlainSchema = isReferenceObject(textPlainSchema) ? context.resolveSchemaReference(textPlainSchema) : textPlainSchema;
      if (resolvedTextPlainSchema.type === "string" && resolvedTextPlainSchema.format === "byte") {
        return ResponseWithExample.file({ description: resolvedResponse.description, source });
      }
      return ResponseWithExample.text({ description: resolvedResponse.description, source });
    }
  }
  return void 0;
}
function markErrorSchemas({ responses, context, source, namespace }) {
  const errors = {};
  for (const [statusCode, response] of Object.entries(responses)) {
    if (statusCode === "default") {
      continue;
    }
    const parsedStatusCode = parseInt(statusCode);
    if (parsedStatusCode < 400 || parsedStatusCode > 600) {
      continue;
    }
    const resolvedResponse = isReferenceObject(response) ? context.resolveResponseReference(response) : response;
    const mediaObject = getSchemaMediaObject(resolvedResponse.content ?? {}, context);
    const errorName = ERROR_NAMES_BY_STATUS_CODE[parsedStatusCode];
    if (errorName == null) {
      context.logger.warn(`No error name found for status code ${statusCode}`);
      continue;
    }
    errors[parsedStatusCode] = {
      statusCode: parsedStatusCode,
      nameOverride: void 0,
      generatedName: errorName,
      description: resolvedResponse.description,
      schema: convertSchema(mediaObject?.schema ?? {}, false, context, [errorName, "Body"], source, namespace),
      fullExamples: mediaObject?.examples,
      source
    };
  }
  return errors;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertHttpOperation.js
function convertHttpOperation({ operationContext, context, responseStatusCode, suffix, streamFormat, source }) {
  const { document, operation, path: path5, method, baseBreadcrumbs, sdkMethodName } = operationContext;
  const idempotent = getExtension(operation, FernOpenAPIExtension.IDEMPOTENT);
  const requestNameOverride = getExtension(operation, [
    FernOpenAPIExtension.REQUEST_NAME_V1,
    FernOpenAPIExtension.REQUEST_NAME_V2
  ]);
  const requestBreadcrumbs = [...baseBreadcrumbs, "Request"];
  const convertedParameters = convertParameters({
    parameters: [...operationContext.pathItemParameters, ...operationContext.operationParameters],
    context,
    requestBreadcrumbs,
    path: path5,
    httpMethod: method,
    source
  });
  let convertedRequest = operation.requestBody != null ? convertRequest({
    requestBody: operation.requestBody,
    document,
    context: new DummyOpenAPIV3ParserContext({
      document: context.document,
      taskContext: context.taskContext,
      options: context.options,
      source: context.source,
      namespace: context.namespace
    }),
    requestBreadcrumbs,
    source,
    namespace: context.namespace
  }) : void 0;
  if (endpointHasNonRequestBodyParameters({ context, convertedParameters }) && convertedRequest != null && convertedRequest.type === "json" && convertedRequest.schema.type !== "object" && operation.requestBody != null) {
    convertedRequest = convertRequest({
      requestBody: operation.requestBody,
      document,
      context,
      requestBreadcrumbs: [...requestBreadcrumbs, "Body"],
      source,
      namespace: context.namespace
    });
  } else if (operation.requestBody != null) {
    convertedRequest = convertRequest({
      requestBody: operation.requestBody,
      document,
      context,
      requestBreadcrumbs: [...requestBreadcrumbs],
      source,
      namespace: context.namespace
    });
  }
  const responseBreadcrumbs = [...baseBreadcrumbs, "Response"];
  const convertedResponse = convertResponse({
    operationContext,
    streamFormat,
    responses: operation.responses,
    context,
    responseBreadcrumbs,
    responseStatusCode,
    source
  });
  const availability = getFernAvailability(operation);
  const examples = getExamplesFromExtension(operationContext, operation, context);
  const serverName = getExtension(operation, FernOpenAPIExtension.SERVER_NAME_V2);
  return {
    summary: operation.summary,
    internal: getExtension(operation, OpenAPIExtension.INTERNAL),
    idempotent,
    audiences: getExtension(operation, FernOpenAPIExtension.AUDIENCES) ?? [],
    operationId: operation.operationId != null && suffix != null ? operation.operationId + "_" + suffix : operation.operationId,
    tags: context.resolveTagsToTagIds(operation.tags),
    namespace: context.namespace,
    sdkName: sdkMethodName,
    pathParameters: convertedParameters.pathParameters,
    queryParameters: convertedParameters.queryParameters,
    headers: convertedParameters.headers,
    requestNameOverride: requestNameOverride ?? void 0,
    generatedRequestName: getGeneratedTypeName(requestBreadcrumbs, context.options.preserveSchemaIds),
    request: convertedRequest,
    response: convertedResponse.value,
    errors: convertedResponse.errors,
    server: serverName != null ? [{ name: serverName, url: void 0, audiences: void 0 }] : (operation.servers ?? []).map((server) => convertServer(server)),
    description: operation.description,
    authed: isEndpointAuthed(operation, document),
    availability,
    method,
    path: path5,
    examples,
    pagination: operationContext.pagination,
    source
  };
}
function isEndpointAuthed(operation, document) {
  if (operation.security != null) {
    return Object.keys(operation.security).length > 0;
  }
  if (document.security != null) {
    return Object.keys(document.security).length > 0;
  }
  return false;
}
function endpointHasNonRequestBodyParameters({ context, convertedParameters }) {
  return context.options.inlinePathParameters && convertedParameters.pathParameters.length > 0 || convertedParameters.queryParameters.length > 0 || convertedParameters.headers.length > 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertAsyncSyncOperation.js
function convertAsyncSyncOperation({ operationContext, context, asyncExtension, source }) {
  const { operation, pathItemParameters, operationParameters } = operationContext;
  const headerToIgnore = asyncExtension.discriminant.name;
  const headerValue = asyncExtension.discriminant.value;
  const asyncResponseStatusCode = asyncExtension["response-status-code"];
  const filteredPathItemParams = filterParameters({ context, headerToIgnore, parameters: pathItemParameters });
  const filteredOperationParams = filterParameters({ context, headerToIgnore, parameters: operationParameters });
  const syncOperation = convertHttpOperation({
    operationContext: {
      ...operationContext,
      pathItemParameters: filteredPathItemParams,
      operationParameters: filteredOperationParams,
      operation: {
        ...operation,
        responses: Object.fromEntries(Object.entries(operation.responses).filter(([statusCode]) => {
          return parseInt(statusCode) !== asyncResponseStatusCode;
        }))
      }
    },
    context,
    streamFormat: void 0,
    source
  });
  const asyncOperation = convertHttpOperation({
    operationContext: {
      ...operationContext,
      pathItemParameters: filteredPathItemParams,
      operationParameters: filteredOperationParams,
      baseBreadcrumbs: [...operationContext.baseBreadcrumbs, "async"]
    },
    context,
    suffix: "async",
    responseStatusCode: asyncResponseStatusCode,
    streamFormat: void 0,
    source
  });
  asyncOperation.headers.push({
    name: headerToIgnore,
    schema: SchemaWithExample.literal({
      nameOverride: void 0,
      generatedName: getGeneratedTypeName([headerToIgnore], context.options.preserveSchemaIds),
      title: void 0,
      description: void 0,
      availability: void 0,
      value: LiteralSchemaValue.string(headerValue),
      groupName: void 0
    }),
    description: void 0,
    parameterNameOverride: void 0,
    env: void 0,
    availability: void 0,
    source
  });
  return {
    sync: syncOperation,
    async: asyncOperation
  };
}
function filterParameters({ context, headerToIgnore, parameters }) {
  return parameters.filter((parameter) => {
    const resolvedParameter = isReferenceObject(parameter) ? context.resolveParameterReference(parameter) : parameter;
    if (resolvedParameter.in === "header" && resolvedParameter.name === headerToIgnore) {
      return false;
    }
    return true;
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertStreamingOperation.js
var STREAM_SUFFIX = "stream";
function convertStreamingOperation({ operationContext, context, streamingExtension }) {
  switch (streamingExtension.type) {
    case "stream": {
      const streamingOperation = convertHttpOperation({
        operationContext,
        context,
        streamFormat: streamingExtension.format,
        source: context.source
      });
      return {
        streaming: streamingOperation,
        nonStreaming: void 0
      };
    }
    case "streamCondition": {
      const streamingRequestBody = getRequestBody({
        context,
        operation: operationContext.operation,
        streamingExtension,
        isStreaming: true
      });
      if (streamingRequestBody?.schemaReference != null) {
        const schemaId = getSchemaIdFromReference(streamingRequestBody.schemaReference);
        if (schemaId != null) {
          context.excludeSchema(schemaId);
        }
      }
      const streamingResponses = getResponses({
        operation: operationContext.operation,
        response: streamingExtension.responseStream
      });
      const streamingOperation = convertHttpOperation({
        operationContext: {
          ...operationContext,
          sdkMethodName: operationContext.sdkMethodName != null ? {
            groupName: operationContext.sdkMethodName.groupName,
            methodName: operationContext.sdkMethodName.methodName + "_" + STREAM_SUFFIX
          } : void 0,
          operation: {
            ...operationContext.operation,
            description: streamingExtension.streamDescription ?? operationContext.operation.description,
            requestBody: streamingRequestBody?.requestBody,
            responses: streamingResponses
          },
          baseBreadcrumbs: [...operationContext.baseBreadcrumbs, STREAM_SUFFIX]
        },
        context,
        streamFormat: streamingExtension.format,
        suffix: STREAM_SUFFIX,
        source: context.source
      });
      streamingOperation.examples = streamingOperation.examples.filter((example) => isStreamingExample(example, context) !== false);
      const nonStreamingRequestBody = getRequestBody({
        context,
        operation: operationContext.operation,
        streamingExtension,
        isStreaming: false
      });
      const nonStreamingResponses = getResponses({
        operation: operationContext.operation,
        response: streamingExtension.response
      });
      const nonStreamingOperation = convertHttpOperation({
        streamFormat: void 0,
        operationContext: {
          ...operationContext,
          operation: {
            ...operationContext.operation,
            requestBody: nonStreamingRequestBody?.requestBody,
            responses: nonStreamingResponses
          }
        },
        context,
        source: context.source
      });
      nonStreamingOperation.examples = nonStreamingOperation.examples.filter((example) => isStreamingExample(example, context) !== true);
      return {
        streaming: streamingOperation,
        nonStreaming: nonStreamingOperation
      };
    }
    default:
      assertNever(streamingExtension);
  }
}
function getRequestBody({ context, operation, streamingExtension, isStreaming }) {
  if (operation.requestBody == null) {
    return void 0;
  }
  const resolvedRequestBody = isReferenceObject(operation.requestBody) ? context.resolveRequestBodyReference(operation.requestBody) : operation.requestBody;
  const jsonMediaObject = getApplicationJsonSchemaMediaObject(resolvedRequestBody.content, context);
  if (jsonMediaObject == null) {
    return void 0;
  }
  const resolvedRequstBodySchema = isReferenceObject(jsonMediaObject.schema) ? context.resolveSchemaReference(jsonMediaObject.schema) : jsonMediaObject.schema;
  if (resolvedRequstBodySchema.allOf == null && resolvedRequstBodySchema.properties == null) {
    return void 0;
  }
  let streamingProperty = resolvedRequstBodySchema.properties?.[streamingExtension.streamConditionProperty];
  if (streamingProperty != null && isReferenceObject(streamingProperty)) {
    streamingProperty = void 0;
  }
  const requestBodySchemaWithLiteralProperty = {
    ...resolvedRequstBodySchema,
    properties: {
      ...resolvedRequstBodySchema.properties,
      [streamingExtension.streamConditionProperty]: {
        type: "boolean",
        "x-fern-boolean-literal": isStreaming,
        ...streamingProperty ?? {}
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
      }
    },
    // Set to undefined because we inline both the streaming and non-streaming request schemas
    // and title would cause conflicting names
    title: void 0,
    required: [...resolvedRequstBodySchema.required ?? [], streamingExtension.streamConditionProperty]
  };
  return {
    requestBody: {
      content: {
        [MediaType.APPLICATION_JSON]: {
          schema: requestBodySchemaWithLiteralProperty
        }
      }
    },
    schemaReference: isReferenceObject(jsonMediaObject.schema) ? jsonMediaObject.schema : void 0
  };
}
function getResponses({ operation, response }) {
  return {
    ...operation.responses,
    "200": {
      description: "",
      content: {
        [MediaType.APPLICATION_JSON]: {
          schema: response
        }
      }
    }
  };
}
function isStreamingExample(example, context) {
  return example._visit({
    unknown: (unknownExample) => {
      const maybeFernExample = schemas_exports3.serialization.ExampleEndpointCallSchema.parse(unknownExample);
      if (!maybeFernExample.ok) {
        return void 0;
      }
      if (maybeFernExample.value.response == null) {
        return void 0;
      }
      return maybeFernExample.value.response.stream != null;
    },
    full: () => void 0,
    _other: () => void 0
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertWebhookOperation.js
function convertWebhookOperation({ context, operationContext, source }) {
  const { document, operation, path: path5, method, baseBreadcrumbs, sdkMethodName } = operationContext;
  const payloadBreadcrumbs = [...baseBreadcrumbs, "Payload"];
  const convertedParameters = convertParameters({
    parameters: [...operationContext.pathItemParameters, ...operationContext.operationParameters],
    context,
    requestBreadcrumbs: payloadBreadcrumbs,
    path: path5,
    httpMethod: method,
    source
  });
  if (operation.requestBody == null) {
    context.logger.error(`Skipping webhook ${method.toUpperCase()} ${path5}: Missing a request body`);
    return void 0;
  }
  if (method !== "POST" && method !== "GET") {
    context.logger.error(`Skipping webhook ${method.toUpperCase()} ${path5}: Not POST or GET`);
    return void 0;
  }
  const convertedPayload = convertRequest({
    requestBody: operation.requestBody,
    document,
    context,
    requestBreadcrumbs: [...baseBreadcrumbs, "Payload"],
    source,
    namespace: context.namespace
  });
  if (convertedPayload == null || convertedPayload.type !== "json") {
    context.logger.error(`Skipping webhook ${path5} because non-json request body`);
    return void 0;
  }
  if (operation.operationId == null) {
    context.logger.error(`Skipping webhook ${path5} because no operation id present`);
    return void 0;
  }
  return {
    summary: operation.summary,
    sdkName: sdkMethodName,
    namespace: context.namespace,
    method,
    operationId: operation.operationId,
    tags: context.resolveTagsToTagIds(operation.tags),
    headers: convertedParameters.headers,
    generatedPayloadName: getGeneratedTypeName(payloadBreadcrumbs, context.options.preserveSchemaIds),
    payload: convertedPayload.schema,
    description: operation.description,
    examples: convertWebhookExamples(convertedPayload.fullExamples),
    source
  };
}
function convertWebhookExamples(payloadExamples) {
  if (payloadExamples == null) {
    return [];
  }
  const webhookExampleCalls = [];
  for (const payloadExample of payloadExamples) {
    const fullExample = convertToFullExample(payloadExample.value);
    if (fullExample == null) {
      continue;
    }
    webhookExampleCalls.push({
      description: payloadExample.description,
      name: payloadExample.name,
      payload: fullExample
    });
  }
  return webhookExampleCalls;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertOperation.js
function convertOperation({ context, pathItemContext, operation, convertToWebhook }) {
  const shouldIgnore = getExtension(operation, FernOpenAPIExtension.IGNORE);
  if (shouldIgnore != null && shouldIgnore) {
    context.logger.info(`${pathItemContext.method.toUpperCase()} ${pathItemContext.path} is marked with x-fern-ignore. Skipping.`);
    return void 0;
  }
  const sdkMethodName = getSdkGroupAndMethod(operation, context);
  const pagination = getFernPaginationExtension(context.document, operation);
  const operationContext = {
    ...pathItemContext,
    sdkMethodName,
    baseBreadcrumbs: getBaseBreadcrumbs({
      operation,
      sdkMethodName,
      httpMethod: pathItemContext.method,
      path: pathItemContext.path
    }),
    operation,
    operationParameters: operation.parameters ?? [],
    pagination
  };
  if (convertToWebhook) {
    const webhook = convertWebhookOperation({
      context,
      operationContext,
      source: context.source
    });
    return webhook != null ? { type: "webhook", value: webhook } : void 0;
  }
  const streamingExtension = getFernStreamingExtension(operation);
  if (streamingExtension != null) {
    const streamingOperation = convertStreamingOperation({
      context,
      operationContext,
      streamingExtension
    });
    return streamingOperation != null ? {
      type: "streaming",
      streaming: streamingOperation.streaming,
      nonStreaming: streamingOperation.nonStreaming
    } : void 0;
  }
  const asyncExtension = getFernAsyncExtension(operation);
  if (asyncExtension != null) {
    const asyncAndSync = convertAsyncSyncOperation({
      context,
      operationContext,
      asyncExtension,
      source: context.source
    });
    return {
      type: "async",
      async: asyncAndSync.async,
      sync: asyncAndSync.sync
    };
  }
  const convertedHttpOperation = convertHttpOperation({
    context,
    operationContext,
    streamFormat: void 0,
    source: context.source
  });
  return { type: "http", value: convertedHttpOperation };
}
function getSdkGroupAndMethod(operation, context) {
  const sdkMethodName = getExtension(operation, FernOpenAPIExtension.SDK_METHOD_NAME);
  const sdkGroupName = getExtension(operation, FernOpenAPIExtension.SDK_GROUP_NAME) ?? [];
  if (sdkMethodName != null) {
    let groupName = typeof sdkGroupName === "string" ? [sdkGroupName] : sdkGroupName;
    groupName = context.resolveGroupName(groupName);
    return {
      groupName,
      methodName: sdkMethodName
    };
  }
  return void 0;
}
function getBaseBreadcrumbs({ sdkMethodName, operation, httpMethod, path: path5 }) {
  const baseBreadcrumbs = [];
  if (sdkMethodName != null) {
    if (sdkMethodName.groupName.length > 0) {
      const lastGroupName = sdkMethodName.groupName[sdkMethodName.groupName.length - 1];
      if (lastGroupName != null) {
        baseBreadcrumbs.push(typeof lastGroupName === "string" ? lastGroupName : lastGroupName.name);
      }
    }
    baseBreadcrumbs.push(sdkMethodName.methodName);
  } else if (operation.operationId != null) {
    baseBreadcrumbs.push(operation.operationId);
  } else {
    baseBreadcrumbs.push(camelCase_default(`${httpMethod}_${path5.split("/").join("_")}`));
  }
  return baseBreadcrumbs;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertPathItem.js
function convertPathItem(path5, pathItemObject, document, context) {
  const result = [];
  const operations = getOperationObjectsFromPathItem(pathItemObject);
  const basePathItemContext = {
    document,
    pathItem: pathItemObject,
    path: path5,
    pathItemParameters: pathItemObject.parameters ?? []
  };
  for (const operation of operations) {
    const convertToWebhook = isWebhook({ operation: operation.operation });
    const convertedOperation = convertOperation({
      context,
      pathItemContext: {
        ...basePathItemContext,
        method: operation.method
      },
      operation: operation.operation,
      convertToWebhook
    });
    if (convertedOperation != null) {
      result.push(convertedOperation);
    }
  }
  return result;
}
function convertPathItemToWebhooks(path5, pathItemObject, document, context) {
  const result = [];
  const operations = getOperationObjectsFromPathItem(pathItemObject);
  const basePathItemContext = {
    document,
    pathItem: pathItemObject,
    path: path5,
    pathItemParameters: pathItemObject.parameters ?? []
  };
  for (const operation of operations) {
    const convertedOperation = convertOperation({
      context,
      pathItemContext: {
        ...basePathItemContext,
        method: operation.method
      },
      operation: operation.operation,
      convertToWebhook: true
    });
    if (convertedOperation != null) {
      result.push(convertedOperation);
    }
  }
  return result;
}
function getOperationObjectsFromPathItem(pathItemObject) {
  const operations = [];
  if (pathItemObject.get != null) {
    operations.push({
      method: HttpMethod2.Get,
      operation: pathItemObject.get
    });
  }
  if (pathItemObject.post != null) {
    operations.push({
      method: HttpMethod2.Post,
      operation: pathItemObject.post
    });
  }
  if (pathItemObject.put != null) {
    operations.push({
      method: HttpMethod2.Put,
      operation: pathItemObject.put
    });
  }
  if (pathItemObject.delete != null) {
    operations.push({
      method: HttpMethod2.Delete,
      operation: pathItemObject.delete
    });
  }
  if (pathItemObject.patch != null) {
    operations.push({
      method: HttpMethod2.Patch,
      operation: pathItemObject.patch
    });
  }
  return operations;
}
function isWebhook({ operation }) {
  return getExtension(operation, [FernOpenAPIExtension.WEBHOOK]) ?? false;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getBasicSecuritySchemeNames.js
function getBasicSecuritySchemeNames(securityScheme) {
  const usernameVariable = getExtension(securityScheme, FernOpenAPIExtension.BASIC_AUTH_USERNAME_VARIABLE_NAME);
  const passwordVariable = getExtension(securityScheme, FernOpenAPIExtension.BASIC_AUTH_PASSWORD_VARIABLE_NAME);
  return {
    usernameVariable,
    passwordVariable
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getSecuritySchemeNameAndEnvvars.js
function getBasicSecuritySchemeNameAndEnvvar(securityScheme) {
  return getExtension(securityScheme, FernOpenAPIExtension.FERN_BASIC_AUTH);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertSecurityScheme.js
function convertSecurityScheme(securityScheme, source) {
  if (isReferenceObject(securityScheme)) {
    throw new Error(`Converting referenced security schemes is unsupported: ${JSON.stringify(securityScheme)}`);
  }
  return convertSecuritySchemeHelper(securityScheme, source);
}
function convertSecuritySchemeHelper(securityScheme, source) {
  if (securityScheme.type === "apiKey" && securityScheme.in === "header") {
    const bearerFormat = getExtension(securityScheme, OpenAPIExtension.BEARER_FORMAT);
    const headerNames = getExtension(securityScheme, FernOpenAPIExtension.FERN_HEADER_AUTH);
    return SecurityScheme.header({
      headerName: securityScheme.name,
      prefix: bearerFormat != null ? "Bearer" : headerNames?.prefix,
      headerVariableName: headerNames?.name ?? getExtension(securityScheme, FernOpenAPIExtension.HEADER_VARIABLE_NAME),
      headerEnvVar: headerNames?.env
    });
  } else if (securityScheme.type === "http" && securityScheme.scheme === "bearer") {
    const bearerNames = getExtension(securityScheme, FernOpenAPIExtension.FERN_BEARER_TOKEN);
    return SecurityScheme.bearer({
      tokenVariableName: bearerNames?.name ?? getExtension(securityScheme, FernOpenAPIExtension.BEARER_TOKEN_VARIABLE_NAME),
      tokenEnvVar: bearerNames?.env
    });
  } else if (securityScheme.type === "http" && securityScheme.scheme === "basic") {
    const basicSecuritySchemeNamingAndEnvvar = getBasicSecuritySchemeNameAndEnvvar(securityScheme);
    const basicSecuritySchemeNaming = getBasicSecuritySchemeNames(securityScheme);
    return SecurityScheme.basic({
      usernameVariableName: basicSecuritySchemeNamingAndEnvvar?.username?.name ?? basicSecuritySchemeNaming.usernameVariable,
      usernameEnvVar: basicSecuritySchemeNamingAndEnvvar?.username?.env,
      passwordVariableName: basicSecuritySchemeNamingAndEnvvar?.password?.name ?? basicSecuritySchemeNaming.passwordVariable,
      passwordEnvVar: basicSecuritySchemeNamingAndEnvvar?.password?.env
    });
  } else if (securityScheme.type === "openIdConnect") {
    return SecurityScheme.bearer({
      tokenVariableName: void 0,
      tokenEnvVar: void 0
    });
  } else if (securityScheme.type === "oauth2") {
    return SecurityScheme.oauth({
      scopesEnum: getScopes(securityScheme, source)
    });
  }
  throw new Error(`Failed to convert security scheme ${JSON.stringify(securityScheme)}`);
}
function getScopes(oauthSecurityScheme, source) {
  const scopes = oauthSecurityScheme.flows.authorizationCode?.scopes ?? oauthSecurityScheme.flows.clientCredentials?.scopes ?? oauthSecurityScheme.flows.implicit?.scopes ?? oauthSecurityScheme.flows.password?.scopes;
  if (scopes != null) {
    const schemaWithExample = convertEnum({
      nameOverride: void 0,
      generatedName: "OauthScope",
      title: void 0,
      enumValues: Object.keys(scopes),
      fernEnum: Object.fromEntries(Object.entries(scopes).map(([scope, description]) => {
        return [
          scope,
          {
            description
          }
        ];
      })),
      _default: void 0,
      description: void 0,
      availability: void 0,
      enumVarNames: void 0,
      wrapAsNullable: false,
      groupName: void 0,
      context: void 0,
      source
    });
    const schema2 = convertSchemaWithExampleToSchema(schemaWithExample);
    if (schema2.type === "enum") {
      return schema2;
    }
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernBasePath.js
function getFernBasePath(parameter) {
  return getExtension(parameter, FernOpenAPIExtension.BASE_PATH);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernGroups.js
var XFernGroupsSchema = z.record(z.string(), z.object({
  summary: z.string().optional(),
  description: z.string().optional()
}));
function getFernGroups({ document, context }) {
  return getExtensionAndValidate(document, FernOpenAPIExtension.GROUPS, XFernGroupsSchema, context.logger);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernVersion.js
function getFernVersion({ context, document }) {
  return getExtension(document, FernOpenAPIExtension.FERN_VERSION) ?? void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getGlobalHeaders.js
function getGlobalHeaders(document) {
  const globalHeaders = getExtension(document, FernOpenAPIExtension.FERN_GLOBAL_HEADERS);
  const result = [];
  for (const header of globalHeaders ?? []) {
    result.push({
      ...header,
      schema: header.type != null ? getSchemaFromFernType({
        fernType: header.type,
        description: void 0,
        availability: void 0,
        generatedName: header.name ?? header.header,
        title: void 0,
        groupName: void 0,
        nameOverride: void 0
      }) : void 0
    });
  }
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getIdempotencyHeaders.js
function getIdempotencyHeaders(document) {
  const idempotencyHeaders = getExtension(document, FernOpenAPIExtension.FERN_IDEMPOTENCY_HEADERS);
  const result = [];
  for (const header of idempotencyHeaders ?? []) {
    result.push({
      ...header,
      schema: header.type != null ? getSchemaFromFernType({
        fernType: header.type,
        description: void 0,
        availability: void 0,
        generatedName: header.name ?? header.header,
        title: void 0,
        groupName: void 0,
        nameOverride: void 0
      }) : void 0
    });
  }
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getVariableDefinitions.js
function getVariableDefinitions(document, preserveSchemaIds) {
  const variables = getExtension(document, FernOpenAPIExtension.SDK_VARIABLES);
  if (variables == null) {
    return {};
  }
  return Object.fromEntries(Object.entries(variables).map(([variableName, schema2]) => {
    if (schema2.type === "string") {
      return [
        variableName,
        {
          nameOverride: void 0,
          generatedName: getGeneratedTypeName([variableName], preserveSchemaIds),
          title: schema2.title,
          schema: PrimitiveSchemaValue.string({
            default: getDefaultAsString(schema2),
            pattern: schema2.pattern,
            format: schema2.format,
            minLength: schema2.minLength,
            maxLength: schema2.maxLength
          }),
          description: schema2.description,
          availability: void 0,
          groupName: void 0
        }
      ];
    } else {
      throw new Error(`Variable ${variableName} has unsupported schema ${JSON.stringify(schema2)}`);
    }
  }));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/getWebhookPathsObject.js
var WEBHOOKS = "webhooks";
function getWebhooksPathsObject(document) {
  return getExtension(document, WEBHOOKS) ?? {};
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/OpenAPIV3ParserContext.js
var OpenAPIV3ParserContext = class extends AbstractOpenAPIV3ParserContext {
  nonRequestReferencedSchemas = /* @__PURE__ */ new Set();
  twoOrMoreRequestsReferencedSchemas = /* @__PURE__ */ new Set();
  singleRequestReferencedSchemas = /* @__PURE__ */ new Set();
  discrminatedUnionReferences = {};
  discrminatedUnionMetadata = {};
  schemasToExclude = /* @__PURE__ */ new Set();
  constructor({ document, taskContext, authHeaders, options, source, namespace }) {
    super({
      document,
      taskContext,
      authHeaders,
      options,
      source,
      namespace
    });
  }
  getDummy() {
    return new DummyOpenAPIV3ParserContext({
      document: this.document,
      taskContext: this.taskContext,
      options: this.options,
      source: this.source,
      namespace: this.namespace
    });
  }
  markSchemaAsReferencedByNonRequest(schemaId) {
    this.nonRequestReferencedSchemas.add(schemaId);
  }
  markSchemaAsReferencedByRequest(schemaId) {
    if (this.singleRequestReferencedSchemas.has(schemaId)) {
      this.twoOrMoreRequestsReferencedSchemas.add(schemaId);
    } else {
      this.singleRequestReferencedSchemas.add(schemaId);
    }
  }
  getReferencedSchemas() {
    return /* @__PURE__ */ new Set([...this.nonRequestReferencedSchemas, ...this.twoOrMoreRequestsReferencedSchemas]);
  }
  markReferencedByDiscriminatedUnion(schema2, discrminant, times) {
    const existingReference = this.discrminatedUnionReferences[schema2.$ref];
    if (existingReference != null) {
      existingReference.discriminants.add(discrminant);
      existingReference.numReferences += times;
    } else {
      this.discrminatedUnionReferences[schema2.$ref] = {
        discriminants: /* @__PURE__ */ new Set([discrminant]),
        numReferences: times
      };
    }
  }
  getReferencesFromDiscriminatedUnion(schema2) {
    return this.discrminatedUnionReferences[schema2.$ref];
  }
  markSchemaWithDiscriminantValue(schema2, discrminant, discriminantValue) {
    const existingMetadata = this.discrminatedUnionMetadata[schema2.$ref];
    if (existingMetadata != null) {
      existingMetadata.discriminants.set(discrminant, discriminantValue);
    } else {
      this.discrminatedUnionMetadata[schema2.$ref] = {
        discriminants: /* @__PURE__ */ new Map([[discrminant, discriminantValue]])
      };
    }
  }
  getDiscriminatedUnionMetadata(schema2) {
    return this.discrminatedUnionMetadata[schema2.$ref];
  }
  excludeSchema(schemaId) {
    this.schemasToExclude.add(schemaId);
  }
  isSchemaExcluded(schemaId) {
    return this.schemasToExclude.has(schemaId);
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernResolutions.js
function getFernResolutions(openapi) {
  return getExtension(openapi, FernOpenAPIExtension.RESOLUTIONS);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/runResolutions.js
function runResolutions({ openapi }) {
  const resolutions = getFernResolutions(openapi);
  if (resolutions == null) {
    return openapi;
  }
  let replacedReferences = {};
  for (const resolution of resolutions) {
    const schemaReference = `#/components/schemas/${resolution.name}`;
    for (const resolutionPath of resolution.resolutions) {
      openapi = addComponentSchema({ openapi, schemaReference: resolutionPath, schemaName: resolution.name });
      openapi = replaceWithSchemaReference({
        openapi,
        replaceReference: resolutionPath,
        schemaReference,
        replacedReferences
      });
      replacedReferences = {
        ...replacedReferences,
        ...Object.fromEntries(resolution.resolutions.map((resolution2) => [schemaReference, resolution2]))
      };
    }
  }
  return openapi;
}
function addComponentSchema({ openapi, schemaReference, schemaName }) {
  const keys5 = schemaReference.replace("#/", "").split("/").map((key) => key.replace("~1", "/"));
  let value = openapi;
  for (const key of keys5) {
    const nextValue = value[key];
    if (nextValue == null) {
      return openapi;
    }
    value = nextValue;
  }
  if (openapi.components == null) {
    openapi.components = {};
  }
  if (openapi.components.schemas == null) {
    openapi.components.schemas = {};
  }
  openapi.components.schemas[schemaName] = value;
  return openapi;
}
function replaceWithSchemaReference({ openapi, replaceReference, schemaReference, replacedReferences }) {
  const overlappingReference = Object.keys(replacedReferences).filter((replacedReference) => replaceReference.startsWith(replacedReference)).sort((a, b) => b.length - a.length)[0];
  if (overlappingReference != null) {
    const resolvedOverlappingReference = replacedReferences[overlappingReference];
    if (resolvedOverlappingReference != null) {
      const newSchemaReference = schemaReference.replace(overlappingReference, resolvedOverlappingReference);
      return replaceWithSchemaReference({
        openapi,
        replaceReference,
        schemaReference: newSchemaReference,
        replacedReferences: {}
      });
    }
  }
  const keys5 = replaceReference.replace("#/", "").split("/").map((key) => key.replace("~1", "/"));
  let value = openapi;
  for (const key of keys5.slice(0, -1)) {
    const nextValue = value[key];
    if (nextValue == null) {
      return openapi;
    }
    value = nextValue;
  }
  const finalKey = keys5[keys5.length - 1];
  if (finalKey == null) {
    return openapi;
  }
  value[finalKey] = {
    $ref: schemaReference
  };
  return openapi;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/generateIr.js
function generateIr({ openApi, taskContext, options, source, namespace }) {
  openApi = runResolutions({ openapi: openApi });
  const securitySchemes = Object.fromEntries(Object.entries(openApi.components?.securitySchemes ?? {}).map(([key, securityScheme]) => {
    const convertedSecurityScheme = convertSecurityScheme(securityScheme, source);
    if (convertedSecurityScheme == null) {
      return [];
    }
    return [key, convertSecurityScheme(securityScheme, source)];
  }));
  const authHeaders = new Set(...Object.entries(securitySchemes).map(([_, securityScheme]) => {
    if (securityScheme.type === "basic" || securityScheme.type === "bearer") {
      return "Authorization";
    } else if (securityScheme.type === "header") {
      return securityScheme.headerName;
    }
    return null;
  }));
  const context = new OpenAPIV3ParserContext({
    document: openApi,
    taskContext,
    authHeaders,
    options,
    source,
    namespace
  });
  const variables = getVariableDefinitions(openApi, options.preserveSchemaIds);
  const globalHeaders = getGlobalHeaders(openApi);
  const idempotencyHeaders = getIdempotencyHeaders(openApi);
  const audiences = options.audiences ?? [];
  const endpointsWithExample = [];
  const webhooksWithExample = [];
  Object.entries(openApi.paths ?? {}).forEach(([path5, pathItem]) => {
    if (pathItem == null) {
      return;
    }
    taskContext.logger.debug(`Converting path ${path5}`);
    const convertedOperations = convertPathItem(path5, pathItem, openApi, context);
    for (const operation of convertedOperations) {
      const operationAudiences = getAudiences2({ operation });
      if (audiences.length > 0 && !audiences.some((audience) => operationAudiences.includes(audience))) {
        continue;
      }
      switch (operation.type) {
        case "async":
          endpointsWithExample.push(operation.sync);
          endpointsWithExample.push(operation.async);
          break;
        case "http":
          endpointsWithExample.push(operation.value);
          break;
        case "streaming":
          endpointsWithExample.push(operation.streaming);
          if (operation.nonStreaming) {
            endpointsWithExample.push(operation.nonStreaming);
          }
          break;
        case "webhook":
          webhooksWithExample.push(operation.value);
          break;
        default:
          assertNever(operation);
      }
    }
  });
  Object.entries(getWebhooksPathsObject(openApi)).forEach(([path5, pathItem]) => {
    if (pathItem == null) {
      return;
    }
    taskContext.logger.debug(`Converting path ${path5}`);
    const convertedWebhooks = convertPathItemToWebhooks(path5, pathItem, openApi, context);
    for (const webhook of convertedWebhooks) {
      const webhookAudiences = getAudiences2({ operation: webhook });
      if (audiences.length > 0 && !audiences.some((audience) => webhookAudiences.includes(audience))) {
        continue;
      }
      webhooksWithExample.push(webhook.value);
    }
  });
  const schemasWithExample = Object.fromEntries(Object.entries(openApi.components?.schemas ?? {}).map(([key, schema2]) => {
    if (!isReferenceObject(schema2)) {
      const ignoreSchema = getExtension(schema2, FernOpenAPIExtension.IGNORE);
      if (ignoreSchema != null && ignoreSchema) {
        return [];
      }
      if (ERROR_NAMES.has(key)) {
        return [
          key,
          convertSchema(
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            { ...schema2, "x-fern-type-name": `${key}Body` },
            false,
            context,
            [key],
            source,
            namespace
          )
        ];
      }
    }
    return [key, convertSchema(schema2, false, context, [key], source, namespace)];
  }).filter((entry) => entry.length > 0));
  const schemasWithoutDiscriminants = maybeRemoveDiscriminantsFromSchemas(schemasWithExample, context, source);
  const schemasWithDiscriminants = maybeAddBackDiscriminantsFromSchemas(schemasWithoutDiscriminants, context);
  const schemas = {};
  for (const [key, schemaWithExample] of Object.entries(schemasWithDiscriminants)) {
    const schema2 = convertSchemaWithExampleToSchema(schemaWithExample);
    if (context.isSchemaExcluded(key)) {
      continue;
    }
    schemas[key] = schema2;
    taskContext.logger.debug(`Converted schema ${key}`);
  }
  const exampleTypeFactory = new ExampleTypeFactory(schemasWithDiscriminants, context.nonRequestReferencedSchemas, context);
  const webhooks = webhooksWithExample.map((webhookWithExample) => {
    const extensionExamples = webhookWithExample.examples;
    let examples = extensionExamples;
    if (!options.disableExamples && examples.length === 0) {
      const webhookExample = exampleTypeFactory.buildExample({
        schema: webhookWithExample.payload,
        exampleId: void 0,
        example: void 0,
        skipReadonly: false,
        options: {
          ignoreOptionals: false,
          isParameter: false
        }
      });
      if (webhookExample != null) {
        examples = [
          {
            name: void 0,
            description: void 0,
            payload: webhookExample
          }
        ];
      }
    }
    return {
      ...webhookWithExample,
      payload: convertSchemaWithExampleToSchema(webhookWithExample.payload),
      examples
    };
  });
  const exampleEndpointFactory = new ExampleEndpointFactory(schemasWithDiscriminants, context);
  const endpoints = endpointsWithExample.map((endpointWithExample) => {
    const extensionExamples = endpointWithExample.examples;
    let examples = extensionExamples;
    if (!options.disableExamples && (extensionExamples.length === 0 || extensionExamples.every(hasIncompleteExample))) {
      const endpointExample = exampleEndpointFactory.buildEndpointExample(endpointWithExample);
      if (endpointExample.length > 0) {
        examples = [
          ...endpointExample,
          // Remove incomplete examples (codesamples are included in generated examples)
          ...extensionExamples.filter((example) => !hasIncompleteExample(example))
        ];
      }
    }
    const request = endpointWithExample.request;
    const response = endpointWithExample.response;
    return {
      ...endpointWithExample,
      request: request?.type === "json" ? {
        ...request,
        schema: convertSchemaWithExampleToSchema(request.schema)
      } : request,
      response: response?.type === "json" ? {
        ...response,
        schema: convertSchemaWithExampleToSchema(response.schema)
      } : response,
      queryParameters: endpointWithExample.queryParameters.map((queryParameter) => {
        return {
          description: queryParameter.description,
          name: queryParameter.name,
          schema: convertSchemaWithExampleToSchema(queryParameter.schema),
          parameterNameOverride: queryParameter.parameterNameOverride,
          availability: queryParameter.availability,
          source: queryParameter.source
        };
      }),
      pathParameters: endpointWithExample.pathParameters.map((pathParameter) => {
        return {
          description: pathParameter.description,
          name: pathParameter.name,
          schema: convertSchemaWithExampleToSchema(pathParameter.schema),
          parameterNameOverride: pathParameter.parameterNameOverride,
          variableReference: pathParameter.variableReference,
          availability: pathParameter.availability,
          source: pathParameter.source
        };
      }),
      headers: endpointWithExample.headers.map((header) => {
        return {
          description: header.description,
          name: header.name,
          schema: convertSchemaWithExampleToSchema(header.schema),
          parameterNameOverride: header.parameterNameOverride,
          env: header.env,
          availability: header.availability,
          source: header.source
        };
      }),
      examples,
      errors: mapValues_default(endpointWithExample.errors, (error) => {
        const examples2 = error.fullExamples?.map((example) => {
          const fullExample = convertToFullExample(example.value);
          if (fullExample == null) {
            return void 0;
          }
          return {
            name: example.name,
            description: example.description,
            example: fullExample
          };
        }).filter(isNonNullish);
        if (examples2?.length === 0) {
          const generatedExample = exampleTypeFactory.buildExample({
            schema: error.schema,
            example: void 0,
            exampleId: void 0,
            skipReadonly: false,
            options: {
              ignoreOptionals: false,
              isParameter: false
            }
          });
          if (generatedExample != null) {
            examples2.push({
              name: void 0,
              description: void 0,
              example: generatedExample
            });
          }
        }
        return {
          generatedName: error.generatedName,
          nameOverride: error.nameOverride,
          schema: convertSchemaWithExampleToSchema(error.schema),
          description: error.description,
          source: error.source,
          examples: examples2
        };
      })
    };
  });
  const groupInfo = getFernGroups({ document: openApi, context });
  const ir = {
    apiVersion: getFernVersion({
      context,
      document: openApi
    }),
    basePath: getFernBasePath(openApi),
    title: openApi.info.title,
    description: openApi.info.description,
    groups: Object.fromEntries(Object.entries(groupInfo ?? {}).map(([key, value]) => {
      return [key, { summary: value.summary ?? void 0, description: value.description ?? void 0 }];
    })),
    servers: (openApi.servers ?? []).map((server) => convertServer(server)),
    tags: {
      tagsById: Object.fromEntries((openApi.tags ?? []).map((tag) => {
        return [tag.name, { id: tag.name, description: tag.description }];
      })),
      orderedTagIds: openApi.tags?.map((tag) => tag.name)
    },
    endpoints,
    webhooks,
    channel: [],
    groupedSchemas: getSchemas(namespace, schemas),
    securitySchemes,
    hasEndpointsMarkedInternal: endpoints.some((endpoint) => endpoint.internal),
    nonRequestReferencedSchemas: context.getReferencedSchemas(),
    variables,
    globalHeaders,
    idempotencyHeaders
  };
  return ir;
}
function maybeRemoveDiscriminantsFromSchemas(schemas, context, source) {
  const result = {};
  for (const [schemaId, schema2] of Object.entries(schemas)) {
    if (schema2.type !== "object") {
      result[schemaId] = schema2;
      continue;
    }
    const referenceToSchema = {
      $ref: `#/components/schemas/${schemaId}`
    };
    const discriminatedUnionReference = context.getReferencesFromDiscriminatedUnion(referenceToSchema);
    if (discriminatedUnionReference == null) {
      result[schemaId] = schema2;
      continue;
    }
    const schemaWithoutDiscriminants = {
      ...schema2,
      type: "object",
      properties: schema2.properties.filter((objectProperty) => {
        return !discriminatedUnionReference.discriminants.has(objectProperty.key);
      }),
      allOfPropertyConflicts: schema2.allOfPropertyConflicts.filter((allOfPropertyConflict) => {
        return !discriminatedUnionReference.discriminants.has(allOfPropertyConflict.propertyKey);
      }),
      source
    };
    result[schemaId] = schemaWithoutDiscriminants;
    const parentSchemaIds = getAllParentSchemaIds({ schema: schema2, schemas });
    for (const parentSchemaId of [...new Set(parentSchemaIds)]) {
      const parentSchema = result[parentSchemaId] ?? schemas[parentSchemaId];
      if (parentSchema == null || parentSchema.type !== "object") {
        continue;
      }
      result[parentSchemaId] = {
        ...parentSchema,
        type: "object",
        properties: parentSchema.properties.filter((objectProperty) => {
          return !discriminatedUnionReference.discriminants.has(objectProperty.key);
        }),
        allOfPropertyConflicts: parentSchema.allOfPropertyConflicts.filter((allOfPropertyConflict) => {
          return !discriminatedUnionReference.discriminants.has(allOfPropertyConflict.propertyKey);
        })
      };
    }
  }
  return result;
}
function maybeAddBackDiscriminantsFromSchemas(schemas, context) {
  const result = {};
  for (const [schemaId, schema2] of Object.entries(schemas)) {
    if (schema2.type !== "object") {
      result[schemaId] = schema2;
      continue;
    }
    const referenceToSchema = {
      $ref: `#/components/schemas/${schemaId}`
    };
    const metadata = context.getDiscriminatedUnionMetadata(referenceToSchema);
    if (metadata == null) {
      result[schemaId] = schema2;
      continue;
    }
    const propertiesWithDiscriminants = [];
    for (const property4 of schema2.properties) {
      if (metadata.discriminants.has(property4.key)) {
        const discriminantValue = metadata.discriminants.get(property4.key);
        if (discriminantValue != null) {
          propertiesWithDiscriminants.push({
            ...property4,
            schema: SchemaWithExample.literal({
              nameOverride: void 0,
              generatedName: getGeneratedTypeName([schema2.generatedName, discriminantValue], context.options.preserveSchemaIds),
              title: void 0,
              value: LiteralSchemaValue.string(discriminantValue),
              groupName: void 0,
              description: void 0,
              availability: schema2.availability
            })
          });
        }
      } else {
        propertiesWithDiscriminants.push(property4);
      }
    }
    const schemaWithoutDiscriminants = {
      ...schema2,
      type: "object",
      properties: propertiesWithDiscriminants
    };
    result[schemaId] = schemaWithoutDiscriminants;
  }
  return result;
}
function getAllParentSchemaIds({ schema: schema2, schemas }) {
  const result = [];
  for (const allOfSchema of schema2.allOf) {
    result.push(allOfSchema.schema);
    const allOfSchemaDefinition = schemas[allOfSchema.schema];
    if (allOfSchemaDefinition != null && allOfSchemaDefinition.type === "object") {
      result.push(...getAllParentSchemaIds({ schema: allOfSchemaDefinition, schemas }));
    }
  }
  return result;
}
function getAudiences2({ operation }) {
  let endpointAudiences = [];
  switch (operation.type) {
    case "async":
      endpointAudiences = operation.async.audiences;
      break;
    case "http":
      endpointAudiences = operation.value.audiences;
      break;
    case "streaming":
      endpointAudiences = operation.streaming.audiences;
      break;
    case "webhook":
      break;
    default:
      assertNever(operation);
  }
  return endpointAudiences;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v2/generateIr.js
var isBrowser3 = typeof window !== "undefined" && typeof window.document !== "undefined";
async function generateIr2({ openApi, taskContext, options, source, namespace }) {
  if (isBrowser3) {
    throw new Error("Swagger 2.0 is not supported in the browser");
  }
  const swagger2openapi = await import("swagger2openapi");
  const conversionResult = await swagger2openapi.convertObj(openApi, {});
  return generateIr({
    openApi: conversionResult.openapi,
    taskContext,
    options,
    source,
    namespace
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/options.js
var DEFAULT_PARSE_OPENAPI_SETTINGS = {
  disableExamples: false,
  discriminatedUnionV2: false,
  useTitlesAsName: true,
  audiences: void 0,
  optionalAdditionalProperties: true,
  cooerceEnumsToLiterals: true,
  respectReadonlySchemas: false,
  onlyIncludeReferencedSchemas: false,
  inlinePathParameters: false,
  preserveSchemaIds: false
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/parse.js
async function parse({ context, documents, options }) {
  let ir = {
    apiVersion: void 0,
    title: void 0,
    description: void 0,
    basePath: void 0,
    servers: [],
    tags: {
      tagsById: {},
      orderedTagIds: void 0
    },
    hasEndpointsMarkedInternal: false,
    endpoints: [],
    webhooks: [],
    channel: [],
    groupedSchemas: {
      rootSchemas: {},
      namespacedSchemas: {}
    },
    variables: {},
    nonRequestReferencedSchemas: /* @__PURE__ */ new Set(),
    securitySchemes: {},
    globalHeaders: [],
    idempotencyHeaders: [],
    groups: {}
  };
  for (const document of documents) {
    const source = document.source != null ? document.source : Source2.openapi({ file: "<memory>" });
    switch (document.type) {
      case "openapi": {
        if (isOpenApiV3(document.value)) {
          const openapiIr = generateIr({
            taskContext: context,
            openApi: document.value,
            options: getParseOptions({ specSettings: document.settings, overrides: options }),
            source,
            namespace: document.namespace
          });
          ir = merge2(ir, openapiIr);
        } else if (isOpenApiV2(document.value)) {
          const openapiIr = await generateIr2({
            taskContext: context,
            openApi: document.value,
            options: getParseOptions({ specSettings: document.settings }),
            source,
            namespace: document.namespace
          });
          ir = merge2(ir, openapiIr);
        }
        break;
      }
      case "asyncapi": {
        const parsedAsyncAPI = parseAsyncAPI({
          document: document.value,
          taskContext: context,
          options: getParseOptions({ specSettings: document.settings }),
          source,
          asyncApiOptions: getParseAsyncOptions({ specSettings: document.settings }),
          namespace: document.namespace
        });
        if (parsedAsyncAPI.channel != null) {
          ir.channel.push(parsedAsyncAPI.channel);
        }
        if (parsedAsyncAPI.groupedSchemas != null) {
          ir.groupedSchemas = mergeSchemaMaps(ir.groupedSchemas, parsedAsyncAPI.groupedSchemas);
        }
        if (parsedAsyncAPI.basePath != null) {
          ir.basePath = parsedAsyncAPI.basePath;
        }
        break;
      }
      default:
        assertNever(document);
    }
  }
  return ir;
}
function getParseOptions({ specSettings, overrides }) {
  return {
    disableExamples: overrides?.disableExamples ?? DEFAULT_PARSE_OPENAPI_SETTINGS.disableExamples,
    discriminatedUnionV2: overrides?.discriminatedUnionV2 ?? specSettings?.shouldUseUndiscriminatedUnionsWithLiterals ?? DEFAULT_PARSE_OPENAPI_SETTINGS.discriminatedUnionV2,
    useTitlesAsName: overrides?.useTitlesAsName ?? specSettings?.shouldUseTitleAsName ?? DEFAULT_PARSE_OPENAPI_SETTINGS.useTitlesAsName,
    audiences: overrides?.audiences ?? specSettings?.audiences ?? DEFAULT_PARSE_OPENAPI_SETTINGS.audiences,
    optionalAdditionalProperties: overrides?.optionalAdditionalProperties ?? specSettings?.optionalAdditionalProperties ?? DEFAULT_PARSE_OPENAPI_SETTINGS.optionalAdditionalProperties,
    cooerceEnumsToLiterals: overrides?.cooerceEnumsToLiterals ?? specSettings?.cooerceEnumsToLiterals ?? DEFAULT_PARSE_OPENAPI_SETTINGS.cooerceEnumsToLiterals,
    respectReadonlySchemas: overrides?.respectReadonlySchemas ?? specSettings?.respectReadonlySchemas ?? DEFAULT_PARSE_OPENAPI_SETTINGS.respectReadonlySchemas,
    onlyIncludeReferencedSchemas: overrides?.onlyIncludeReferencedSchemas ?? specSettings?.onlyIncludeReferencedSchemas ?? DEFAULT_PARSE_OPENAPI_SETTINGS.onlyIncludeReferencedSchemas,
    inlinePathParameters: overrides?.inlinePathParameters ?? specSettings?.inlinePathParameters ?? DEFAULT_PARSE_OPENAPI_SETTINGS.inlinePathParameters,
    preserveSchemaIds: overrides?.preserveSchemaIds ?? DEFAULT_PARSE_OPENAPI_SETTINGS.preserveSchemaIds
  };
}
function getParseAsyncOptions({ specSettings, overrides }) {
  return {
    naming: overrides?.naming ?? specSettings?.asyncApiNaming ?? DEFAULT_PARSE_ASYNCAPI_SETTINGS.naming
  };
}
function merge2(ir1, ir2) {
  return {
    apiVersion: ir1.apiVersion ?? ir2.apiVersion,
    title: ir1.title ?? ir2.title,
    description: ir1.description ?? ir2.description,
    basePath: ir1.basePath ?? ir2.basePath,
    servers: [...ir1.servers, ...ir2.servers],
    tags: {
      tagsById: {
        ...ir1.tags.tagsById,
        ...ir2.tags.tagsById
      },
      orderedTagIds: ir1.tags.orderedTagIds == null && ir2.tags.orderedTagIds == null ? void 0 : [...ir1.tags.orderedTagIds ?? [], ...ir2.tags.orderedTagIds ?? []]
    },
    hasEndpointsMarkedInternal: ir1.hasEndpointsMarkedInternal || ir2.hasEndpointsMarkedInternal,
    endpoints: [...ir1.endpoints, ...ir2.endpoints],
    webhooks: [...ir1.webhooks, ...ir2.webhooks],
    channel: [...ir1.channel, ...ir2.channel],
    groupedSchemas: mergeSchemaMaps(ir1.groupedSchemas, ir2.groupedSchemas),
    variables: {
      ...ir1.variables,
      ...ir2.variables
    },
    nonRequestReferencedSchemas: /* @__PURE__ */ new Set([...ir1.nonRequestReferencedSchemas, ...ir2.nonRequestReferencedSchemas]),
    securitySchemes: {
      ...ir1.securitySchemes,
      ...ir2.securitySchemes
    },
    globalHeaders: ir1.globalHeaders != null ? [...ir1.globalHeaders, ...ir2.globalHeaders ?? []] : void 0,
    idempotencyHeaders: ir1.idempotencyHeaders != null ? [...ir1.idempotencyHeaders, ...ir2.idempotencyHeaders ?? []] : void 0,
    groups: {
      ...ir1.groups,
      ...ir2.groups
    }
  };
}
function mergeSchemaMaps(schemas1, schemas2) {
  schemas1.rootSchemas = { ...schemas1.rootSchemas, ...schemas2.rootSchemas };
  for (const [namespace, namespaceSchemas] of Object.entries(schemas2.namespacedSchemas)) {
    if (schemas1.namespacedSchemas[namespace] != null) {
      schemas1.namespacedSchemas[namespace] = { ...schemas1.namespacedSchemas[namespace], ...namespaceSchemas };
    } else {
      schemas1.namespacedSchemas[namespace] = namespaceSchemas;
    }
  }
  return schemas1;
}
function isOpenApiV3(openApi) {
  return openApi.openapi != null;
}
function isOpenApiV2(openApi) {
  return openApi.swagger != null;
}

// ../../cli/workspace/commons/lib/openapi/constants.js
var import_openapi_core = require("@redocly/openapi-core");
var DEFAULT_OPENAPI_BUNDLE_OPTIONS = {
  config: new import_openapi_core.Config({
    apis: {},
    styleguide: {
      plugins: [FERN_TYPE_EXTENSIONS],
      rules: {
        spec: "warn"
      }
    }
  }, void 0),
  dereference: false,
  removeUnusedComponents: false,
  keepUrlRefs: true
};

// ../../cli/workspace/commons/lib/utils/getAllNamedDefinitionFiles.js
function getAllNamedDefinitionFiles(definition, opts = {}) {
  return {
    ...Object.fromEntries(entries(definition.namedDefinitionFiles).map(([path5, file]) => {
      return [path5, { ...file, defaultUrl: opts.defaultURL }];
    })),
    ...entries(definition.importedDefinitions).reduce((acc, [pathToImportedDefinition, definition2]) => {
      return {
        ...acc,
        ...mapKeys_default(getAllNamedDefinitionFiles(definition2.definition, { defaultURL: definition2.url }), (_file, path5) => join(pathToImportedDefinition, RelativeFilePath.of(path5)))
      };
    }, {})
  };
}

// ../../cli/workspace/commons/lib/utils/getAllPackageMarkers.js
function getAllPackageMarkers(definition, opts = {}) {
  return {
    ...Object.fromEntries(entries(definition.packageMarkers).map(([path5, file]) => {
      return [path5, { ...file, defaultUrl: opts.defaultURL }];
    })),
    ...entries(definition.importedDefinitions).reduce((acc, [pathToImportedDefinition, definition2]) => {
      return {
        ...acc,
        ...mapKeys_default(getAllPackageMarkers(definition2.definition, { defaultURL: definition2.url }), (_file, path5) => join(pathToImportedDefinition, RelativeFilePath.of(path5)))
      };
    }, {})
  };
}

// ../../cli/workspace/commons/lib/utils/getAllDefinitionFiles.js
function getAllDefinitionFiles(definition) {
  return {
    ...getAllPackageMarkers(definition),
    ...getAllNamedDefinitionFiles(definition)
  };
}

// ../../cli/workspace/commons/lib/utils/getDefinitionFile.js
function getDefinitionFile(workspace, relativeFilepath) {
  return getAllDefinitionFiles(workspace.definition)[relativeFilepath]?.contents;
}

// ../../cli/workspace/commons/lib/utils/visitAllDefinitionFiles.js
var import_path2 = __toESM(require("path"), 1);
async function visitAllDefinitionFiles(workspace, visitor) {
  for (const [relativeFilepath, file] of entries(getAllDefinitionFiles(workspace.definition))) {
    await visitor(relativeFilepath, file.contents, {
      isPackageMarker: import_path2.default.basename(relativeFilepath) === FERN_PACKAGE_MARKER_FILENAME,
      defaultUrl: file.defaultUrl
    });
  }
}

// ../../cli/workspace/commons/lib/utils/visitAllPackageMarkers.js
async function visitAllPackageMarkers(workspace, visitor) {
  for (const [relativeFilepath, file] of entries(getAllPackageMarkers(workspace.definition))) {
    await visitor(relativeFilepath, file.contents);
  }
}

// ../../cli/generation/ir-generator/lib/utils/parseInlineType.js
function parseInlineType({ type: type2, file, _default: _default2, validation }) {
  return recursivelyVisitRawTypeReference({
    type: type2,
    _default: _default2,
    validation,
    visitor: {
      primitive: TypeReference2.primitive,
      unknown: TypeReference2.unknown,
      map: ({ keyType, valueType }) => TypeReference2.container(ContainerType.map({ keyType, valueType })),
      list: (valueType) => TypeReference2.container(ContainerType.list(valueType)),
      set: (valueType) => TypeReference2.container(ContainerType.set(valueType)),
      optional: (valueType) => TypeReference2.container(ContainerType.optional(valueType)),
      literal: (literal) => TypeReference2.container(ContainerType.literal(literal)),
      named: (namedType) => TypeReference2.named({
        ...parseTypeName({
          typeName: namedType,
          file
        }),
        default: void 0,
        inline: void 0
      })
    }
  });
}

// ../../cli/generation/ir-generator/lib/FernFileContext.js
function constructRootApiFileContext({ casingsGenerator, rootApiFile }) {
  return constructFernFileContext({
    relativeFilepath: RelativeFilePath.of("."),
    definitionFile: {
      imports: rootApiFile.imports
    },
    casingsGenerator,
    rootApiFile
  });
}
function constructFernFileContext({ defaultUrl, relativeFilepath, definitionFile, casingsGenerator, rootApiFile }) {
  const file = {
    defaultUrl,
    relativeFilepath,
    fernFilepath: convertToFernFilepath({ relativeFilepath, casingsGenerator }),
    imports: mapValues_default(definitionFile.imports ?? {}, RelativeFilePath.of),
    definitionFile,
    parseTypeReference: (type2) => {
      if (typeof type2 === "string") {
        return parseInlineType({ type: type2, _default: void 0, validation: void 0, file });
      }
      return parseInlineType({
        type: type2.type,
        _default: type2.default,
        validation: type2.validation,
        file
      });
    },
    casingsGenerator,
    rootApiFile
  };
  return file;
}

// ../../cli/generation/ir-generator/lib/utils/getAllPropertiesForObject.js
var CASINGS_GENERATOR = constructCasingsGenerator({
  generationLanguage: void 0,
  keywords: void 0,
  smartCasing: false
});
function getAllPropertiesForObject({
  typeName,
  objectDeclaration,
  filepathOfDeclaration,
  definitionFile,
  workspace,
  typeResolver,
  smartCasing,
  // used only for recursive calls
  path: path5 = [],
  seen = {}
}) {
  const properties = [];
  if (typeName != null) {
    const seenAtFilepath = seen[filepathOfDeclaration] ??= /* @__PURE__ */ new Set();
    if (seenAtFilepath.has(typeName)) {
      return properties;
    }
    seenAtFilepath.add(typeName);
  }
  let casingsGenerator = CASINGS_GENERATOR;
  if (smartCasing) {
    casingsGenerator = constructCasingsGenerator({
      generationLanguage: void 0,
      keywords: void 0,
      smartCasing
    });
  }
  const file = constructFernFileContext({
    relativeFilepath: filepathOfDeclaration,
    definitionFile,
    casingsGenerator,
    rootApiFile: workspace.definition.rootApiFile.contents
  });
  if (objectDeclaration.properties != null) {
    for (const [propertyKey, propertyDeclaration] of Object.entries(objectDeclaration.properties)) {
      const propertyType = typeof propertyDeclaration === "string" ? propertyDeclaration : propertyDeclaration.type;
      const resolvedPropertyType = typeResolver.resolveType({ type: propertyType, file });
      if (resolvedPropertyType != null) {
        properties.push({
          wireKey: propertyKey,
          name: getPropertyName({ propertyKey, property: propertyDeclaration }).name,
          filepathOfDeclaration,
          path: path5,
          propertyType,
          resolvedPropertyType,
          isOptional: resolvedPropertyType._type === "container" && resolvedPropertyType.container._type === "optional"
        });
      }
    }
  }
  if (objectDeclaration.extends != null) {
    const extensions = typeof objectDeclaration.extends === "string" ? [objectDeclaration.extends] : objectDeclaration.extends;
    for (const extension of extensions) {
      const resolvedTypeOfExtension = typeResolver.resolveNamedType({
        referenceToNamedType: extension,
        file
      });
      if (resolvedTypeOfExtension?._type === "named" && isRawObjectDefinition(resolvedTypeOfExtension.declaration)) {
        const definitionFile2 = getDefinitionFile(workspace, resolvedTypeOfExtension.filepath);
        if (definitionFile2 != null) {
          properties.push(...getAllPropertiesForObject({
            typeName: resolvedTypeOfExtension.rawName,
            objectDeclaration: resolvedTypeOfExtension.declaration,
            filepathOfDeclaration: resolvedTypeOfExtension.filepath,
            definitionFile: definitionFile2,
            workspace,
            typeResolver,
            smartCasing,
            path: [
              ...path5,
              {
                reference: extension,
                followedVia: "extension"
              },
              ...resolvedTypeOfExtension.objectPath.map((pathItem) => ({
                reference: pathItem.reference,
                followedVia: "alias"
              }))
            ],
            seen
          }));
        }
      }
    }
  }
  return properties;
}

// ../../cli/generation/ir-generator/lib/examples/validateObjectExample.js
function validateObjectExample({ typeName, typeNameForBreadcrumb, rawObject, file, typeResolver, exampleResolver, workspace, example, breadcrumbs, depth }) {
  if (!isPlainObject2(example)) {
    return getViolationsForMisshapenExample(example, "an object");
  }
  const violations = [];
  const allPropertiesForObject = getAllPropertiesForObject({
    typeName,
    objectDeclaration: rawObject,
    typeResolver,
    definitionFile: file.definitionFile,
    workspace,
    filepathOfDeclaration: file.relativeFilepath,
    smartCasing: false
  });
  const allPropertiesByWireKey = keyBy_default(allPropertiesForObject, (property4) => property4.wireKey);
  const requiredProperties = allPropertiesForObject.filter((property4) => !property4.isOptional && property4.resolvedPropertyType._type !== "unknown");
  for (const requiredProperty of requiredProperties) {
    if (requiredProperty.resolvedPropertyType._type === "container" && requiredProperty.resolvedPropertyType.container._type === "literal") {
      continue;
    }
    if (example[requiredProperty.wireKey] == null) {
      const propertyReference = breadcrumbs.length > 0 ? `${breadcrumbs.join(".")}.${requiredProperty.wireKey}` : requiredProperty.wireKey;
      const message = `Example is missing required property "${propertyReference}"`;
      violations.push({
        message
      });
    }
  }
  for (const [exampleKey, exampleValue] of Object.entries(example)) {
    const propertyWithPath = allPropertiesByWireKey[exampleKey];
    if (propertyWithPath == null) {
      violations.push({
        message: `Unexpected property "${exampleKey}"`
      });
    } else {
      const definitionFile = getDefinitionFile(workspace, propertyWithPath.filepathOfDeclaration);
      if (definitionFile == null) {
        throw new Error("Service file does not exist for property: " + propertyWithPath.wireKey);
      }
      violations.push(...validateTypeReferenceExample({
        rawTypeReference: propertyWithPath.propertyType,
        example: exampleValue,
        file: constructFernFileContext({
          relativeFilepath: propertyWithPath.filepathOfDeclaration,
          definitionFile,
          casingsGenerator: file.casingsGenerator,
          rootApiFile: workspace.definition.rootApiFile.contents
        }),
        workspace,
        typeResolver,
        exampleResolver,
        breadcrumbs: [...breadcrumbs, `${exampleKey}`],
        depth: depth + 1
      }));
    }
  }
  return violations;
}

// ../../cli/generation/ir-generator/lib/examples/validateUndiscriminatedUnionExample.js
function validateUndiscriminatedUnionExample({ rawUnion, example, typeResolver, exampleResolver, file, workspace, breadcrumbs, depth }) {
  const violations = [];
  for (const member of rawUnion.union) {
    const violationsForMember = validateTypeReferenceExample({
      rawTypeReference: typeof member === "string" ? member : member.type,
      example,
      typeResolver,
      exampleResolver,
      file,
      workspace,
      breadcrumbs,
      depth: depth + 1
    });
    if (violationsForMember.length === 0) {
      return [];
    } else if (violations.length === 0) {
      violations.push(...violationsForMember);
    }
  }
  return violations;
}

// ../../cli/generation/ir-generator/lib/utils/getAvailability.js
function getAvailability(field) {
  if (typeof field === "string" || field.availability == null) {
    return void 0;
  }
  const rawAvailability = typeof field.availability === "string" ? { status: field.availability } : field.availability;
  return convertAvailability(field.availability);
}

// ../../cli/generation/ir-generator/lib/utils/getDocs.js
function getDocs(field) {
  if (typeof field === "string") {
    return void 0;
  }
  return field.docs;
}

// ../../cli/generation/ir-generator/lib/utils/getDisplayName.js
function getDisplayName2(field) {
  if (typeof field === "string") {
    return void 0;
  }
  return field["display-name"];
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertDiscriminatedUnionTypeDeclaration.js
var DEFAULT_UNION_VALUE_PROPERTY_VALUE = "value";
async function convertDiscriminatedUnionTypeDeclaration({ union: union3, file, typeResolver }) {
  const discriminant3 = getUnionDiscriminant(union3);
  return Type.union({
    discriminant: file.casingsGenerator.generateNameAndWireValue({
      wireValue: discriminant3,
      name: getUnionDiscriminantName(union3).name
    }),
    extends: getExtensionsAsList(union3.extends).map((extended) => parseTypeName({ typeName: extended, file })),
    baseProperties: union3["base-properties"] != null ? await Promise.all(Object.entries(union3["base-properties"]).map(async ([propertyKey, propertyDefinition]) => ({
      ...await convertDeclaration(propertyDefinition),
      name: file.casingsGenerator.generateNameAndWireValue({
        wireValue: propertyKey,
        name: getPropertyName({ propertyKey, property: propertyDefinition }).name
      }),
      valueType: file.parseTypeReference(propertyDefinition)
    }))) : [],
    types: Object.entries(union3.union).map(([unionKey, rawSingleUnionType]) => {
      const rawType = typeof rawSingleUnionType === "string" ? rawSingleUnionType : typeof rawSingleUnionType.type === "string" ? rawSingleUnionType.type : void 0;
      const discriminantValue = file.casingsGenerator.generateNameAndWireValue({
        wireValue: unionKey,
        name: getSingleUnionTypeName({ unionKey, rawSingleUnionType }).name
      });
      const docs = getDocs(rawSingleUnionType);
      if (rawType == null) {
        return {
          discriminantValue,
          docs,
          shape: SingleUnionTypeProperties.noProperties(),
          displayName: void 0,
          availability: void 0
        };
      }
      const parsedValueType = file.parseTypeReference(rawType);
      return {
        discriminantValue,
        shape: getSingleUnionTypeProperties({
          rawSingleUnionType,
          rawValueType: rawType,
          parsedValueType,
          file,
          typeResolver
        }),
        docs: getDocs(rawSingleUnionType),
        displayName: getDisplayName2(rawSingleUnionType),
        availability: getAvailability(rawSingleUnionType)
      };
    })
  });
}
function getUnionDiscriminant(union3) {
  if (union3.discriminant == null) {
    return "type";
  }
  if (typeof union3.discriminant === "string") {
    return union3.discriminant;
  }
  return union3.discriminant.value;
}
function getUnionDiscriminantName(union3) {
  if (union3.discriminant != null && typeof union3.discriminant !== "string" && union3.discriminant.name != null) {
    return {
      name: union3.discriminant.name,
      wasExplicitlySet: true
    };
  }
  return {
    name: getUnionDiscriminant(union3),
    wasExplicitlySet: false
  };
}
function getSingleUnionTypeName({ unionKey, rawSingleUnionType }) {
  if (typeof rawSingleUnionType !== "string" && rawSingleUnionType.name != null) {
    return {
      name: rawSingleUnionType.name,
      wasExplicitlySet: true
    };
  }
  return {
    name: unionKey,
    wasExplicitlySet: false
  };
}
function getSingleUnionTypeProperties({ rawSingleUnionType, rawValueType, parsedValueType, file, typeResolver }) {
  const singlePropertyKey = typeof rawSingleUnionType !== "string" ? rawSingleUnionType.key : void 0;
  const resolvedType = typeResolver.resolveTypeOrThrow({ type: rawValueType, file });
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration) && singlePropertyKey == null) {
    return SingleUnionTypeProperties.samePropertiesAsObject(resolvedType.name);
  }
  return SingleUnionTypeProperties.singleProperty({
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: getSinglePropertyKeyValue(singlePropertyKey),
      name: getSinglePropertyKeyName(singlePropertyKey)
    }),
    type: parsedValueType
  });
}
function getSinglePropertyKeyName(rawSingleUnionType) {
  if (rawSingleUnionType != null) {
    if (typeof rawSingleUnionType === "string") {
      return rawSingleUnionType;
    }
    return rawSingleUnionType.name ?? rawSingleUnionType.value;
  }
  return DEFAULT_UNION_VALUE_PROPERTY_VALUE;
}
function getSinglePropertyKeyValue(rawSingleUnionType) {
  if (rawSingleUnionType != null) {
    if (typeof rawSingleUnionType === "string") {
      return rawSingleUnionType;
    }
    return rawSingleUnionType.value;
  }
  return DEFAULT_UNION_VALUE_PROPERTY_VALUE;
}

// ../../cli/generation/ir-generator/lib/examples/validateUnionExample.js
function validateUnionExample({ typeName, rawUnion, example, typeResolver, exampleResolver, file, workspace, breadcrumbs, depth }) {
  if (!isPlainObject2(example)) {
    return getViolationsForMisshapenExample(example, "an object");
  }
  const discriminant3 = getUnionDiscriminant(rawUnion);
  const { [discriminant3]: discriminantValue, ...nonDiscriminantPropertyExamples } = example;
  if (discriminantValue == null) {
    return [
      {
        message: `Missing discriminant property ("${discriminant3}")`
      }
    ];
  }
  if (typeof discriminantValue !== "string") {
    return getViolationsForMisshapenExample(discriminantValue, "a string");
  }
  const singleUnionTypeDefinition = rawUnion.union[discriminantValue];
  if (singleUnionTypeDefinition == null) {
    return [
      {
        message: `Invalid discriminant property: "${discriminantValue}". Allowed discriminant values:
` + Object.keys(rawUnion.union).map((otherDiscriminantValue) => `  - ${otherDiscriminantValue}`).join("\n")
      }
    ];
  }
  if (rawUnion["base-properties"] != null) {
    const example2 = Object.fromEntries(Object.entries(nonDiscriminantPropertyExamples).filter(([key]) => rawUnion["base-properties"]?.[key] != null));
    const basePropertyViolations = validateObjectExample({
      typeName,
      typeNameForBreadcrumb: typeName,
      rawObject: {
        properties: rawUnion["base-properties"]
      },
      file,
      example: example2,
      typeResolver,
      exampleResolver,
      workspace,
      breadcrumbs,
      depth: depth + 1
    });
    if (basePropertyViolations.length > 0) {
      return basePropertyViolations;
    }
  }
  const type2 = typeof singleUnionTypeDefinition === "string" ? singleUnionTypeDefinition : singleUnionTypeDefinition.type;
  if (typeof type2 !== "string") {
    return getRuleViolationForExtraProperties(nonDiscriminantPropertyExamples);
  }
  const resolvedType = typeResolver.resolveType({
    type: type2,
    file
  });
  if (resolvedType == null) {
    return [];
  }
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    const example2 = Object.fromEntries(Object.entries(nonDiscriminantPropertyExamples).filter(([key]) => rawUnion["base-properties"]?.[key] == null));
    return validateObjectExample({
      typeName,
      typeNameForBreadcrumb: typeName,
      rawObject: resolvedType.declaration,
      file: resolvedType.file,
      example: example2,
      typeResolver,
      exampleResolver,
      workspace,
      breadcrumbs,
      depth: depth + 1
    });
  }
  const singlePropertyKey = typeof singleUnionTypeDefinition !== "string" && typeof singleUnionTypeDefinition.key === "string" ? singleUnionTypeDefinition.key : void 0;
  if (singlePropertyKey == null) {
    return [];
  }
  const { [singlePropertyKey]: singlePropertyExample, ...extraProperties } = nonDiscriminantPropertyExamples;
  const violations = [];
  if (singlePropertyExample == null) {
    violations.push({
      message: `Missing property "${singlePropertyKey}"`
    });
  } else {
    violations.push(...validateTypeReferenceExample({
      rawTypeReference: type2,
      example: singlePropertyExample,
      typeResolver,
      exampleResolver,
      file,
      workspace,
      breadcrumbs,
      depth: depth + 1
    }));
  }
  violations.push(...getRuleViolationForExtraProperties(extraProperties));
  return violations;
}
function getRuleViolationForExtraProperties(extraProperties) {
  return Object.keys(extraProperties).map((key) => ({
    severity: "error",
    message: `Unexpected property "${key}"`
  }));
}

// ../../cli/generation/ir-generator/lib/examples/validateTypeExample.js
function validateTypeExample({ typeName, typeDeclaration, file, typeResolver, exampleResolver, example, workspace, breadcrumbs, depth }) {
  return visitRawTypeDeclaration(typeDeclaration, {
    alias: (rawAlias) => {
      return validateAliasExample({
        rawAlias,
        file,
        typeResolver,
        exampleResolver,
        example,
        workspace,
        breadcrumbs,
        depth
      });
    },
    enum: (rawEnum) => {
      return validateEnumExample({
        rawEnum,
        example,
        breadcrumbs
      });
    },
    object: (rawObject) => {
      return validateObjectExample({
        typeName,
        typeNameForBreadcrumb: typeName,
        rawObject,
        example,
        file,
        typeResolver,
        exampleResolver,
        workspace,
        breadcrumbs,
        depth
      });
    },
    discriminatedUnion: (rawUnion) => {
      return validateUnionExample({
        typeName,
        rawUnion,
        example,
        file,
        typeResolver,
        exampleResolver,
        workspace,
        breadcrumbs,
        depth
      });
    },
    undiscriminatedUnion: (rawUnion) => {
      return validateUndiscriminatedUnionExample({
        rawUnion,
        example,
        file,
        typeResolver,
        exampleResolver,
        workspace,
        breadcrumbs,
        depth
      });
    }
  });
}

// ../../cli/generation/ir-generator/lib/examples/validateTypeReferenceExample.js
var ISO_8601_REGEX3 = /^([+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([.,]\d+(?!:))?)?(\17[0-5]\d([.,]\d+)?)?([zZ]|([+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;
var UUID_REGEX = /^[0-9a-fA-F]{8}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{12}$/;
var RFC_3339_DATE_REGEX = /^\d{4}-\d{2}-\d{2}$/;
var MAX_RECURSION_DEPTH = 128;
function validateTypeReferenceExample({ rawTypeReference, example, typeResolver, exampleResolver, file, workspace, breadcrumbs, depth }) {
  if (depth > MAX_RECURSION_DEPTH) {
    return [
      {
        message: "Example is too deeply nested. This may indicate a circular reference."
      }
    ];
  }
  if (typeof example === "string" && example.startsWith(EXAMPLE_REFERENCE_PREFIX)) {
    const resolvedExpectedType = typeResolver.resolveType({
      type: rawTypeReference,
      file
    });
    if (resolvedExpectedType == null) {
      return [];
    }
    const parsedExampleReference = exampleResolver.parseExampleReference(example);
    if (parsedExampleReference == null) {
      return [];
    }
    const resolvedActualType = typeResolver.resolveNamedType({
      referenceToNamedType: parsedExampleReference.rawTypeReference,
      file
    });
    if (resolvedActualType == null) {
      return [];
    }
    if (areResolvedTypesEquivalent({ expected: resolvedExpectedType, actual: resolvedActualType })) {
      return [];
    } else {
      return [
        {
          message: `Expected example to be: ${rawTypeReference}. Example is ${example}.`
        }
      ];
    }
  }
  return visitRawTypeReference({
    type: rawTypeReference,
    _default: void 0,
    validation: void 0,
    visitor: {
      primitive: (primitiveType) => validatePrimitiveExample({ primitiveType, example }),
      named: (referenceToNamedType) => {
        const declaration = typeResolver.getDeclarationOfNamedType({
          referenceToNamedType,
          file
        });
        if (declaration == null) {
          return [];
        }
        return validateTypeExample({
          typeName: declaration.typeName,
          typeDeclaration: declaration.declaration,
          file: declaration.file,
          example,
          typeResolver,
          exampleResolver,
          workspace,
          breadcrumbs,
          depth: depth + 1
        });
      },
      map: ({ keyType, valueType }) => {
        if (!isPlainObject2(example)) {
          return getViolationsForMisshapenExample(example, "a map");
        }
        return Object.entries(example).flatMap(([exampleKey, exampleValue]) => [
          ...validateTypeReferenceExample({
            rawTypeReference: keyType,
            example: exampleKey,
            typeResolver,
            exampleResolver,
            file,
            workspace,
            breadcrumbs: [...breadcrumbs, exampleKey],
            depth: depth + 1
          }),
          ...validateTypeReferenceExample({
            rawTypeReference: valueType,
            example: exampleValue,
            typeResolver,
            exampleResolver,
            file,
            workspace,
            breadcrumbs: [...breadcrumbs, exampleKey],
            depth: depth + 1
          })
        ]);
      },
      list: (itemType) => {
        if (!Array.isArray(example)) {
          return getViolationsForMisshapenExample(example, "a list");
        }
        return example.flatMap((exampleItem, idx) => validateTypeReferenceExample({
          rawTypeReference: itemType,
          example: exampleItem,
          typeResolver,
          exampleResolver,
          file,
          workspace,
          breadcrumbs: [...breadcrumbs, `${idx}`],
          depth: depth + 1
        }));
      },
      set: (itemType) => {
        if (!Array.isArray(example)) {
          return getViolationsForMisshapenExample(example, "a list");
        }
        const duplicates = getDuplicates(example);
        if (duplicates.length > 0) {
          return [
            {
              severity: "error",
              message: "Set has duplicate elements:\n" + duplicates.map((item) => `  - ${JSON.stringify(item)}`).join("\n")
            }
          ];
        }
        return example.flatMap((exampleItem, idx) => validateTypeReferenceExample({
          rawTypeReference: itemType,
          example: exampleItem,
          typeResolver,
          exampleResolver,
          file,
          workspace,
          breadcrumbs: [...breadcrumbs, `${idx}`],
          depth: depth + 1
        }));
      },
      optional: (itemType) => {
        if (example == null) {
          return [];
        }
        return validateTypeReferenceExample({
          rawTypeReference: itemType,
          example,
          typeResolver,
          exampleResolver,
          file,
          workspace,
          breadcrumbs,
          depth: depth + 1
        });
      },
      unknown: () => {
        return [];
      },
      literal: (expectedLiteral) => {
        switch (expectedLiteral.type) {
          case "boolean":
            return createValidator((e) => e === expectedLiteral.boolean, expectedLiteral.boolean.toString())(example);
          case "string":
            return createValidator((e) => e === expectedLiteral.string, `"${expectedLiteral.string}"`)(example);
          default:
            assertNever(expectedLiteral);
        }
      }
    }
  });
}
function validatePrimitiveExample({ primitiveType, example }) {
  if (primitiveType.v2 != null) {
    return PrimitiveTypeV2._visit(primitiveType.v2, {
      integer: (v2) => validateIntegerWithRules({
        example,
        rules: v2.validation
      }),
      long: () => validateLong(example),
      uint: () => validateUint(example),
      uint64: () => validateUint64(example),
      double: (v2) => validateDoubleWithRules({
        example,
        rules: v2.validation
      }),
      float: () => validateFloat(example),
      boolean: () => validateBoolean(example),
      string: (v2) => validateStringWithRules({
        example,
        rules: v2.validation
      }),
      uuid: () => validateUuid(example),
      date: () => validateDate(example),
      dateTime: () => validateDateTime(example),
      base64: () => validateString(example),
      bigInteger: () => validateString(example),
      _other: () => {
        throw new Error("Unknown primitive type v2: " + primitiveType.v2);
      }
    });
  }
  return PrimitiveTypeV1._visit(primitiveType.v1, {
    integer: () => validateInteger(example),
    long: () => validateLong(example),
    uint: () => validateUint(example),
    uint64: () => validateUint64(example),
    double: () => validateDouble(example),
    float: () => validateFloat(example),
    boolean: () => validateBoolean(example),
    string: () => validateString(example),
    uuid: () => validateUuid(example),
    dateTime: () => validateDateTime(example),
    date: () => validateDate(example),
    base64: () => validateString(example),
    bigInteger: () => validateString(example),
    _other: () => {
      throw new Error("Unknown primitive type: " + primitiveType.v1);
    }
  });
}
function validateIntegerWithRules({ example, rules }) {
  const violations = validateInteger(example);
  if (violations.length > 0 || rules == null) {
    return violations;
  }
  const integer = example;
  if (rules.min != null) {
    if (rules.exclusiveMin && integer <= rules.min || !rules.exclusiveMin && integer < rules.min) {
      return [
        {
          message: `Expected integer to be greater than or equal to ${rules.min}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.max != null) {
    if (rules.exclusiveMax && integer >= rules.max || !rules.exclusiveMax && integer > rules.max) {
      return [
        {
          message: `Expected integer to be less than or equal to ${rules.max}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.multipleOf != null) {
    if (integer % rules.multipleOf !== 0) {
      return [
        {
          message: `Expected integer to be a multiple of ${rules.multipleOf}. Example is ${example}.`
        }
      ];
    }
  }
  return [];
}
function validateDoubleWithRules({ example, rules }) {
  const violations = validateDouble(example);
  if (violations.length > 0 || rules == null) {
    return violations;
  }
  const double = example;
  if (rules.min != null) {
    if (rules.exclusiveMin && double <= rules.min || !rules.exclusiveMin && double < rules.min) {
      return [
        {
          message: `Expected double to be greater than or equal to ${rules.min}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.max != null) {
    if (rules.exclusiveMax && double >= rules.max || !rules.exclusiveMax && double > rules.max) {
      return [
        {
          message: `Expected double to be less than or equal to ${rules.max}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.multipleOf != null) {
    if (double % rules.multipleOf !== 0) {
      return [
        {
          message: `Expected double to be a multiple of ${rules.multipleOf}. Example is ${example}.`
        }
      ];
    }
  }
  return [];
}
function validateStringWithRules({ example, rules }) {
  const violations = validateString(example);
  if (violations.length > 0 || rules == null) {
    return violations;
  }
  const str2 = example;
  if (rules.minLength != null) {
    if (str2.length < rules.minLength) {
      return [
        {
          message: `Expected string length to be greater than or equal to ${rules.minLength}. Example is ${example}, which is of length ${str2.length}.`
        }
      ];
    }
  }
  if (rules.maxLength != null) {
    if (str2.length > rules.maxLength) {
      return [
        {
          message: `Expected string length to be less than or equal to ${rules.maxLength}. Example is ${example}, which is of length ${str2.length}.`
        }
      ];
    }
  }
  if (rules.pattern != null) {
    const regex = new RegExp(rules.pattern);
    if (!regex.test(str2)) {
      return [
        {
          message: `Expected string to match pattern ${rules.pattern}. Example is ${example}.`
        }
      ];
    }
  }
  return [];
}
var validateString = createValidator((example) => typeof example === "string", "a string");
var validateInteger = createValidator((example) => Number.isInteger(example), "an integer");
var validateUint = createValidator((example) => Number.isInteger(example) && typeof example === "number" && example >= 0, "a uint");
var validateUint64 = createValidator((example) => Number.isInteger(example) && typeof example === "number" && example >= 0, "a uint64");
var validateFloat = createValidator((example) => typeof example === "number", "a float");
var validateDouble = createValidator((example) => typeof example === "number", "a double");
var validateLong = createValidator((example) => Number.isInteger(example), "an integer");
var validateBoolean = createValidator((example) => typeof example === "boolean", "a boolean");
var validateUuid = createValidator((example) => typeof example === "string" && UUID_REGEX.test(example), "a UUID");
var validateDateTime = createValidator((example) => typeof example === "string" && ISO_8601_REGEX3.test(example), "an ISO 8601 timestamp");
var validateDate = createValidator((example) => typeof example === "string" && RFC_3339_DATE_REGEX.test(example) && ISO_8601_REGEX3.test(example), "a date");
function createValidator(validate, expectedTypeIncludingArticle) {
  return (example) => {
    if (validate(example)) {
      return [];
    }
    return getViolationsForMisshapenExample(example, expectedTypeIncludingArticle);
  };
}
function areResolvedTypesEquivalent({ expected, actual }) {
  if (expected._type === "unknown") {
    return true;
  }
  if (expected._type === "primitive") {
    return actual._type === "primitive" && expected.primitive.v1 === actual.primitive.v1;
  }
  if (expected._type === "container") {
    switch (expected.container._type) {
      case "list":
      case "set":
        return actual._type === "container" && actual.container._type === expected.container._type && areResolvedTypesEquivalent({
          expected: expected.container.itemType,
          actual: actual.container.itemType
        });
      case "optional":
        return areResolvedTypesEquivalent({
          expected: expected.container.itemType,
          actual: actual._type === "container" && actual.container._type === "optional" ? actual.container.itemType : actual
        });
      case "map":
        return actual._type === "container" && actual.container._type === expected.container._type && areResolvedTypesEquivalent({
          expected: expected.container.keyType,
          actual: actual.container.keyType
        }) && areResolvedTypesEquivalent({
          expected: expected.container.valueType,
          actual: actual.container.valueType
        });
      case "literal":
        if (actual._type !== "container" || actual.container._type !== expected.container._type) {
          return false;
        }
        return areLiteralTypesEquivalent({
          expected: expected.container.literal,
          actual: actual.container.literal
        });
      default:
        assertNever(expected.container);
    }
  }
  if (expected._type === "named") {
    return actual._type === "named" && actual.filepath === expected.filepath && actual.rawName === expected.rawName;
  }
  assertNever(expected);
}
function areLiteralTypesEquivalent({ expected, actual }) {
  switch (expected.type) {
    case "boolean":
      return actual.type === "boolean" ? expected.boolean === actual.boolean : false;
    case "string":
      return actual.type === "string" ? expected.string === actual.string : false;
    default:
      assertNever(expected);
  }
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertEnumTypeDeclaration.js
async function convertEnumTypeDeclaration({ _enum, file }) {
  const values = await Promise.all(_enum.enum.map(async (value) => {
    return {
      ...await convertDeclaration(value),
      name: file.casingsGenerator.generateNameAndWireValue({
        wireValue: typeof value === "string" ? value : value.value,
        name: getEnumName(value).name,
        opts: {
          casingOverrides: typeof value !== "string" ? value.casing : void 0
        }
      })
    };
  }));
  let defaultValue;
  if (_enum.default != null) {
    defaultValue = values.find((enumValue) => enumValue.name.wireValue === _enum.default);
    if (defaultValue == null) {
      throw new Error(`Default value ${_enum.default} not found in enum values`);
    }
  }
  return {
    default: defaultValue,
    values
  };
}
function getEnumNameFromEnumValue(enumValue, _enum) {
  const maybeEnumDefintion = _enum.enum.find((value) => typeof value === "string" ? false : value.value === enumValue);
  return {
    name: typeof maybeEnumDefintion === "string" ? enumValue : maybeEnumDefintion?.name ?? enumValue,
    wasExplicitlySet: false
  };
}
function getEnumName(enumValue) {
  if (typeof enumValue === "string") {
    return {
      name: enumValue,
      wasExplicitlySet: false
    };
  }
  if (enumValue.name == null) {
    return {
      name: enumValue.value,
      wasExplicitlySet: false
    };
  }
  return {
    name: enumValue.name,
    wasExplicitlySet: true
  };
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertExampleType.js
function convertTypeExample({ typeName, typeDeclaration, example, typeResolver, exampleResolver, fileContainingType, fileContainingExample, workspace }) {
  return visitRawTypeDeclaration(typeDeclaration, {
    alias: (rawAlias) => {
      return ExampleTypeShape.alias({
        value: convertTypeReferenceExample({
          example,
          rawTypeBeingExemplified: typeof rawAlias === "string" ? rawAlias : rawAlias.type,
          fileContainingRawTypeReference: fileContainingType,
          fileContainingExample,
          typeResolver,
          exampleResolver,
          workspace
        })
      });
    },
    object: (rawObject) => {
      return convertObject4({
        typeName,
        rawObject,
        example,
        fileContainingType,
        fileContainingExample,
        typeResolver,
        exampleResolver,
        workspace
      });
    },
    discriminatedUnion: (rawUnion) => {
      const discriminant3 = getUnionDiscriminant(rawUnion);
      if (!isPlainObject2(example)) {
        throw new Error("Example is not an object");
      }
      const discriminantValueForExample = example[discriminant3];
      if (discriminantValueForExample == null) {
        throw new Error("Example is missing discriminant: " + discriminant3);
      }
      if (typeof discriminantValueForExample !== "string") {
        throw new Error("Discriminant value is not a string");
      }
      const rawSingleUnionType = rawUnion.union[discriminantValueForExample];
      if (rawSingleUnionType == null) {
        throw new Error(`${discriminantValueForExample} is not one of the specified discriminant values.`);
      }
      const rawValueType = typeof rawSingleUnionType === "string" ? rawSingleUnionType : typeof rawSingleUnionType.type === "string" ? rawSingleUnionType.type : void 0;
      return ExampleTypeShape.union({
        discriminant: fileContainingExample.casingsGenerator.generateNameAndWireValue({
          name: getUnionDiscriminantName(rawUnion).name,
          wireValue: discriminant3
        }),
        singleUnionType: convertSingleUnionType({
          rawValueType,
          rawSingleUnionType,
          fileContainingType,
          fileContainingExample,
          typeResolver,
          exampleResolver,
          example,
          discriminant: discriminant3,
          discriminantValueForExample,
          workspace
        })
      });
    },
    enum: (rawEnum) => {
      if (typeof example !== "string") {
        throw new Error("Enum example is not a string");
      }
      return ExampleTypeShape.enum({
        value: fileContainingExample.casingsGenerator.generateNameAndWireValue({
          name: getEnumNameFromEnumValue(example, rawEnum).name,
          wireValue: example
        })
      });
    },
    undiscriminatedUnion: (undiscriminatedUnion3) => {
      for (const [index, variant] of undiscriminatedUnion3.union.entries()) {
        const violationsForMember = validateTypeReferenceExample({
          rawTypeReference: typeof variant === "string" ? variant : variant.type,
          example,
          typeResolver,
          exampleResolver,
          file: fileContainingType,
          workspace,
          breadcrumbs: [],
          depth: 0
        });
        if (violationsForMember.length === 0) {
          return ExampleTypeShape.undiscriminatedUnion({
            index,
            singleUnionType: convertTypeReferenceExample({
              example,
              rawTypeBeingExemplified: typeof variant === "string" ? variant : variant.type,
              fileContainingRawTypeReference: fileContainingType,
              fileContainingExample,
              typeResolver,
              exampleResolver,
              workspace
            })
          });
        }
      }
      throw new Error("Example doesn't match any of the undiscriminated unions");
    }
  });
}
function convertTypeReferenceExample({ example, fileContainingExample, rawTypeBeingExemplified, fileContainingRawTypeReference, typeResolver, exampleResolver, workspace }) {
  const { resolvedExample, file: fileContainingResolvedExample } = exampleResolver.resolveExampleOrThrow({
    example,
    file: fileContainingExample
  });
  const jsonExample = exampleResolver.resolveAllReferencesInExampleOrThrow({
    example,
    file: fileContainingExample
  }).resolvedExample;
  const shape = visitRawTypeReference({
    type: rawTypeBeingExemplified,
    _default: void 0,
    validation: void 0,
    visitor: {
      primitive: (primitive) => {
        return convertPrimitiveExample({
          example: resolvedExample,
          typeBeingExemplified: primitive.v1
        });
      },
      map: ({ keyType, valueType }) => {
        if (!isPlainObject2(resolvedExample)) {
          throw new Error("Example is not an object");
        }
        return ExampleTypeReferenceShape.container(ExampleContainer.map({
          map: Object.entries(resolvedExample).map(([key, value]) => ({
            key: convertTypeReferenceExample({
              example: key,
              fileContainingExample: fileContainingResolvedExample,
              rawTypeBeingExemplified: keyType,
              fileContainingRawTypeReference,
              typeResolver,
              exampleResolver,
              workspace
            }),
            value: convertTypeReferenceExample({
              example: value,
              fileContainingExample: fileContainingResolvedExample,
              rawTypeBeingExemplified: valueType,
              fileContainingRawTypeReference,
              typeResolver,
              exampleResolver,
              workspace
            })
          })),
          keyType: fileContainingRawTypeReference.parseTypeReference(keyType),
          valueType: fileContainingRawTypeReference.parseTypeReference(valueType)
        }));
      },
      list: (itemType) => {
        if (!Array.isArray(resolvedExample)) {
          throw new Error("Example is not a list");
        }
        return ExampleTypeReferenceShape.container(ExampleContainer.list({
          list: resolvedExample.map((exampleItem) => convertTypeReferenceExample({
            example: exampleItem,
            fileContainingExample: fileContainingResolvedExample,
            rawTypeBeingExemplified: itemType,
            fileContainingRawTypeReference,
            typeResolver,
            exampleResolver,
            workspace
          })),
          itemType: fileContainingRawTypeReference.parseTypeReference(itemType)
        }));
      },
      set: (itemType) => {
        if (!Array.isArray(resolvedExample)) {
          throw new Error("Example is not a list");
        }
        return ExampleTypeReferenceShape.container(ExampleContainer.set({
          set: resolvedExample.map((exampleItem) => convertTypeReferenceExample({
            example: exampleItem,
            fileContainingExample: fileContainingResolvedExample,
            rawTypeBeingExemplified: itemType,
            fileContainingRawTypeReference,
            typeResolver,
            exampleResolver,
            workspace
          })),
          itemType: fileContainingRawTypeReference.parseTypeReference(itemType)
        }));
      },
      optional: (itemType) => {
        return ExampleTypeReferenceShape.container(ExampleContainer.optional({
          optional: resolvedExample != null ? convertTypeReferenceExample({
            example: resolvedExample,
            fileContainingExample: fileContainingResolvedExample,
            rawTypeBeingExemplified: itemType,
            fileContainingRawTypeReference,
            typeResolver,
            exampleResolver,
            workspace
          }) : void 0,
          valueType: fileContainingRawTypeReference.parseTypeReference(itemType)
        }));
      },
      literal: (literal) => {
        switch (literal.type) {
          case "boolean":
            return ExampleTypeReferenceShape.container(ExampleContainer.literal({ literal: ExamplePrimitive.boolean(literal.boolean) }));
          case "string":
            return ExampleTypeReferenceShape.container(ExampleContainer.literal({
              literal: ExamplePrimitive.string({
                original: literal.string
              })
            }));
          default:
            assertNever(literal);
        }
      },
      named: (named) => {
        const typeDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: rawTypeBeingExemplified,
          file: fileContainingRawTypeReference
        });
        const parsedReferenceToNamedType = fileContainingRawTypeReference.parseTypeReference(named);
        if (parsedReferenceToNamedType.type !== "named") {
          throw new Error("Type reference is not to a named type.");
        }
        const typeName = {
          typeId: parsedReferenceToNamedType.typeId,
          fernFilepath: parsedReferenceToNamedType.fernFilepath,
          name: parsedReferenceToNamedType.name
        };
        return ExampleTypeReferenceShape.named({
          typeName,
          shape: convertTypeExample({
            typeName,
            typeDeclaration: typeDeclaration.declaration,
            fileContainingType: typeDeclaration.file,
            fileContainingExample: fileContainingResolvedExample,
            example: resolvedExample,
            typeResolver,
            exampleResolver,
            workspace
          })
        });
      },
      unknown: () => {
        return ExampleTypeReferenceShape.unknown(jsonExample);
      }
    }
  });
  return {
    shape,
    jsonExample
  };
}
function convertPrimitiveExample({ example, typeBeingExemplified }) {
  return PrimitiveTypeV1._visit(typeBeingExemplified, {
    string: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.string({
        original: example
      }));
    },
    dateTime: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.datetime({
        datetime: new Date(example),
        raw: example
      }));
    },
    date: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.date(example));
    },
    base64: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.string({
        original: example
      }));
    },
    uint: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.uint(example));
    },
    uint64: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.uint64(example));
    },
    integer: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.integer(example));
    },
    float: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.float(example));
    },
    double: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.double(example));
    },
    long: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.long(example));
    },
    boolean: () => {
      if (typeof example !== "boolean") {
        throw new Error("Example is not a boolean");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.boolean(example));
    },
    uuid: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.uuid(example));
    },
    bigInteger: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.string({
        original: example
      }));
    },
    _other: () => {
      throw new Error("Unknown primitive type: " + typeBeingExemplified);
    }
  });
}
function convertObject4({ typeName, rawObject, example, fileContainingType, fileContainingExample, typeResolver, exampleResolver, workspace }) {
  if (!isPlainObject2(example)) {
    throw new Error(`Example is not an object. Got: ${JSON.stringify(example)}`);
  }
  return ExampleTypeShape.object({
    properties: rawObject.properties != null || rawObject.extends != null ? Object.entries(example).reduce((exampleProperties, [wireKey, propertyExample]) => {
      const originalTypeDeclaration = getOriginalTypeDeclarationForProperty({
        typeName,
        wirePropertyKey: wireKey,
        rawObject,
        typeResolver,
        file: fileContainingType
      });
      if (originalTypeDeclaration == null) {
        return exampleProperties;
      }
      const valueExample = convertTypeReferenceExample({
        example: propertyExample,
        fileContainingExample,
        rawTypeBeingExemplified: typeof originalTypeDeclaration.rawPropertyType === "string" ? originalTypeDeclaration.rawPropertyType : originalTypeDeclaration.rawPropertyType.type,
        fileContainingRawTypeReference: originalTypeDeclaration.file,
        typeResolver,
        exampleResolver,
        workspace
      });
      exampleProperties.push({
        name: fileContainingExample.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({
            propertyKey: wireKey,
            property: originalTypeDeclaration.rawPropertyType
          }).name,
          wireValue: wireKey
        }),
        value: valueExample,
        originalTypeDeclaration: originalTypeDeclaration.typeName
      });
      return exampleProperties;
    }, []) : []
  });
}
function getOriginalTypeDeclarationForProperty({ typeName, wirePropertyKey, rawObject, typeResolver, file }) {
  const rawPropertyType = rawObject.properties?.[wirePropertyKey];
  if (rawPropertyType != null) {
    return { typeName, rawPropertyType, file };
  } else {
    return getOriginalTypeDeclarationForPropertyFromExtensions({
      wirePropertyKey,
      extends_: rawObject.extends,
      typeResolver,
      file
    });
  }
}
function getOriginalTypeDeclarationForPropertyFromExtensions({ wirePropertyKey, extends_, typeResolver, file }) {
  if (extends_ != null) {
    const extendsList = typeof extends_ === "string" ? [extends_] : extends_;
    for (const typeName of extendsList) {
      const resolvedType = typeResolver.resolveNamedTypeOrThrow({
        referenceToNamedType: typeName,
        file
      });
      if (resolvedType._type !== "named" || !isRawObjectDefinition(resolvedType.declaration)) {
        throw new Error("Extension is not of a named object");
      }
      const originalTypeDeclaration = getOriginalTypeDeclarationForProperty({
        wirePropertyKey,
        rawObject: resolvedType.declaration,
        typeResolver,
        typeName: resolvedType.name,
        file: resolvedType.file
      });
      if (originalTypeDeclaration != null) {
        return originalTypeDeclaration;
      }
    }
  }
  return void 0;
}
function convertSingleUnionType({ rawValueType, rawSingleUnionType, fileContainingType, fileContainingExample, typeResolver, exampleResolver, example, discriminant: discriminant3, discriminantValueForExample, workspace }) {
  const wireDiscriminantValue = fileContainingExample.casingsGenerator.generateNameAndWireValue({
    name: getSingleUnionTypeName({ unionKey: discriminantValueForExample, rawSingleUnionType }).name,
    wireValue: discriminantValueForExample
  });
  if (rawValueType == null) {
    return {
      wireDiscriminantValue,
      shape: ExampleSingleUnionTypeProperties.noProperties()
    };
  }
  const parsedSingleUnionTypeProperties = getSingleUnionTypeProperties({
    rawSingleUnionType,
    rawValueType,
    parsedValueType: fileContainingType.parseTypeReference(rawValueType),
    file: fileContainingType,
    typeResolver
  });
  switch (parsedSingleUnionTypeProperties.propertiesType) {
    case "singleProperty": {
      if (!isPlainObject2(example)) {
        throw new Error("Example is not an object");
      }
      return {
        wireDiscriminantValue,
        shape: ExampleSingleUnionTypeProperties.singleProperty(convertTypeReferenceExample({
          example: example[parsedSingleUnionTypeProperties.name.wireValue],
          rawTypeBeingExemplified: rawValueType,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: fileContainingType,
          fileContainingExample,
          workspace
        }))
      };
    }
    case "samePropertiesAsObject": {
      if (!isPlainObject2(example)) {
        throw new Error("Example is not an object");
      }
      const { [discriminant3]: _discriminantValue, ...nonDiscriminantPropertiesFromExample } = example;
      let rawDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
        referenceToNamedType: rawValueType,
        file: fileContainingType
      });
      while (isRawAliasDefinition(rawDeclaration.declaration)) {
        rawDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: typeof rawDeclaration.declaration === "string" ? rawDeclaration.declaration : rawDeclaration.declaration.type,
          file: fileContainingType
        });
      }
      if (!isRawObjectDefinition(rawDeclaration.declaration)) {
        throw new Error(`${rawValueType} is not an object`);
      }
      const typeName = {
        typeId: parsedSingleUnionTypeProperties.typeId,
        fernFilepath: parsedSingleUnionTypeProperties.fernFilepath,
        name: parsedSingleUnionTypeProperties.name
      };
      return {
        wireDiscriminantValue,
        shape: ExampleSingleUnionTypeProperties.samePropertiesAsObject({
          typeId: IdGenerator.generateTypeId(typeName),
          object: convertObject4({
            rawObject: rawDeclaration.declaration,
            example: nonDiscriminantPropertiesFromExample,
            fileContainingType: rawDeclaration.file,
            fileContainingExample,
            typeResolver,
            exampleResolver,
            typeName,
            workspace
          })
        })
      };
    }
    default:
      assertNever(parsedSingleUnionTypeProperties);
  }
}

// ../../cli/generation/ir-generator/lib/converters/services/convertQueryParameter.js
async function convertQueryParameter({ file, queryParameterKey, queryParameter }) {
  const { name } = getQueryParameterName({ queryParameterKey, queryParameter });
  const valueType = file.parseTypeReference(queryParameter);
  return {
    ...await convertDeclaration(queryParameter),
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: queryParameterKey,
      name
    }),
    valueType,
    allowMultiple: typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false
  };
}
function getQueryParameterName({ queryParameterKey, queryParameter }) {
  if (typeof queryParameter !== "string") {
    if (queryParameter.name != null) {
      return { name: queryParameter.name, wasExplicitlySet: true };
    }
  }
  return { name: queryParameterKey, wasExplicitlySet: false };
}

// ../../cli/generation/ir-generator/lib/utils/getEndpointPathParameters.js
function getEndpointPathParameters(endpoint) {
  return typeof endpoint.request !== "string" && endpoint.request?.["path-parameters"] ? endpoint.request?.["path-parameters"] : endpoint["path-parameters"] != null ? endpoint["path-parameters"] : {};
}

// ../../cli/generation/ir-generator/lib/converters/services/convertExampleEndpointCall.js
function hashJSON(obj) {
  const jsonString = JSON.stringify(obj);
  return import_crypto.default.createHash("sha256").update(jsonString).digest("hex");
}
function convertExampleEndpointCall({ service, endpoint, example, typeResolver, errorResolver, exampleResolver, variableResolver, file, workspace }) {
  const convertedPathParameters = convertPathParameters({
    service,
    endpoint,
    example,
    typeResolver,
    exampleResolver,
    variableResolver,
    file,
    workspace
  });
  return {
    id: example.name ?? hashJSON(example),
    name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
    docs: example.docs,
    url: buildUrl({ file, service, endpoint, example, pathParams: convertedPathParameters }),
    ...convertedPathParameters,
    ...convertHeaders({ service, endpoint, example, typeResolver, exampleResolver, file, workspace }),
    queryParameters: example["query-parameters"] != null ? Object.entries(example["query-parameters"]).map(([wireKey, value]) => {
      const queryParameterDeclaration = typeof endpoint.request !== "string" ? endpoint.request?.["query-parameters"]?.[wireKey] : void 0;
      if (queryParameterDeclaration == null) {
        throw new Error(`Query parameter ${wireKey} does not exist`);
      }
      return {
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getQueryParameterName({
            queryParameterKey: wireKey,
            queryParameter: queryParameterDeclaration
          }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: value,
          rawTypeBeingExemplified: typeof queryParameterDeclaration === "string" ? queryParameterDeclaration : queryParameterDeclaration.type,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        }),
        shape: getQueryParamaterDeclationShape({ queryParameter: queryParameterDeclaration })
      };
    }) : [],
    request: convertExampleRequestBody({ endpoint, example, typeResolver, exampleResolver, file, workspace }),
    response: convertExampleResponse({
      endpoint,
      example,
      typeResolver,
      errorResolver,
      exampleResolver,
      file,
      workspace
    })
  };
}
function getQueryParamaterDeclationShape({ queryParameter }) {
  const isAllowMultiple = typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false;
  return isAllowMultiple ? ExampleQueryParameterShape.exploded() : ExampleQueryParameterShape.single();
}
function convertPathParameters({ service, endpoint, example, typeResolver, exampleResolver, variableResolver, file, workspace }) {
  const rootPathParameters = [];
  const servicePathParameters = [];
  const endpointPathParameters = [];
  const buildExamplePathParameter = ({ name, pathParameterDeclaration, examplePathParameter }) => {
    const resolvedPathParameter = resolvePathParameterOrThrow({
      parameter: pathParameterDeclaration,
      variableResolver,
      file
    });
    return {
      name,
      value: convertTypeReferenceExample({
        example: examplePathParameter,
        rawTypeBeingExemplified: resolvedPathParameter.rawType,
        typeResolver,
        exampleResolver,
        fileContainingRawTypeReference: resolvedPathParameter.file,
        fileContainingExample: file,
        workspace
      })
    };
  };
  if (example["path-parameters"] != null) {
    const rawEndpointPathParameters = getEndpointPathParameters(endpoint);
    for (const [key, examplePathParameter] of Object.entries(example["path-parameters"])) {
      const rootPathParameterDeclaration = file.rootApiFile["path-parameters"]?.[key];
      const servicePathParameterDeclaration = service["path-parameters"]?.[key];
      const endpointPathParameterDeclaration = rawEndpointPathParameters[key];
      if (rootPathParameterDeclaration != null) {
        rootPathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration: rootPathParameterDeclaration,
          examplePathParameter
        }));
      } else if (endpointPathParameterDeclaration != null) {
        endpointPathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration: endpointPathParameterDeclaration,
          examplePathParameter
        }));
      } else if (servicePathParameterDeclaration != null) {
        servicePathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration: servicePathParameterDeclaration,
          examplePathParameter
        }));
      } else {
        throw new Error(`Path parameter ${key} does not exist`);
      }
    }
  }
  return {
    rootPathParameters,
    endpointPathParameters,
    servicePathParameters
  };
}
function convertHeaders({ service, endpoint, example, typeResolver, exampleResolver, file, workspace }) {
  const serviceHeaders = [];
  const endpointHeaders = [];
  if (example.headers != null) {
    for (const [wireKey, exampleHeader] of Object.entries(example.headers)) {
      const endpointHeaderDeclaration = typeof endpoint.request !== "string" ? endpoint.request?.headers?.[wireKey] : void 0;
      const serviceHeaderDeclaration = service.headers?.[wireKey];
      if (endpointHeaderDeclaration != null) {
        endpointHeaders.push({
          name: file.casingsGenerator.generateNameAndWireValue({
            name: getHeaderName2({ headerKey: wireKey, header: endpointHeaderDeclaration }).name,
            wireValue: wireKey
          }),
          value: convertTypeReferenceExample({
            example: exampleHeader,
            rawTypeBeingExemplified: typeof endpointHeaderDeclaration === "string" ? endpointHeaderDeclaration : endpointHeaderDeclaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: file,
            fileContainingExample: file,
            workspace
          })
        });
      } else if (serviceHeaderDeclaration != null) {
        serviceHeaders.push({
          name: file.casingsGenerator.generateNameAndWireValue({
            name: getHeaderName2({ headerKey: wireKey, header: serviceHeaderDeclaration }).name,
            wireValue: wireKey
          }),
          value: convertTypeReferenceExample({
            example: exampleHeader,
            rawTypeBeingExemplified: typeof serviceHeaderDeclaration === "string" ? serviceHeaderDeclaration : serviceHeaderDeclaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: file,
            fileContainingExample: file,
            workspace
          })
        });
      } else {
        throw new Error(`Header ${wireKey} does not exist`);
      }
    }
  }
  return {
    endpointHeaders,
    serviceHeaders
  };
}
function convertExampleRequestBody({ endpoint, example, typeResolver, exampleResolver, file, workspace }) {
  const requestType = typeof endpoint.request !== "string" ? endpoint.request?.body : endpoint.request;
  if (requestType == null) {
    return void 0;
  }
  if (typeof requestType === "string" && parseBytesRequest(requestType) != null) {
    return void 0;
  }
  if (!isInlineRequestBody(requestType)) {
    return ExampleRequestBody.reference(convertTypeReferenceExample({
      example: example.request,
      rawTypeBeingExemplified: typeof requestType !== "string" ? requestType.type : requestType,
      typeResolver,
      exampleResolver,
      fileContainingRawTypeReference: file,
      fileContainingExample: file,
      workspace
    }));
  }
  if (!example.request) {
    return void 0;
  }
  if (!isPlainObject2(example.request)) {
    throw new Error(`Example is not an object. Got: ${JSON.stringify(example.request)}`);
  }
  const exampleProperties = [];
  for (const [wireKey, propertyExample] of Object.entries(example.request)) {
    const inlinedRequestPropertyDeclaration = requestType.properties?.[wireKey];
    const inilnedRequestPropertyType = typeof inlinedRequestPropertyDeclaration === "string" ? inlinedRequestPropertyDeclaration : inlinedRequestPropertyDeclaration?.type;
    if (inilnedRequestPropertyType != null && parseRawFileType(inilnedRequestPropertyType) != null) {
      continue;
    }
    if (inlinedRequestPropertyDeclaration != null) {
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: inlinedRequestPropertyDeclaration }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof inlinedRequestPropertyDeclaration !== "string" ? inlinedRequestPropertyDeclaration.type : inlinedRequestPropertyDeclaration,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: void 0
      });
    } else {
      const originalTypeDeclaration = getOriginalTypeDeclarationForPropertyFromExtensions({
        extends_: requestType.extends,
        wirePropertyKey: wireKey,
        typeResolver,
        file
      });
      if (originalTypeDeclaration == null) {
        throw new Error("Could not find original type declaration for property: " + wireKey);
      }
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: originalTypeDeclaration.rawPropertyType }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof originalTypeDeclaration.rawPropertyType === "string" ? originalTypeDeclaration.rawPropertyType : originalTypeDeclaration.rawPropertyType.type,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: originalTypeDeclaration.file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: originalTypeDeclaration.typeName
      });
    }
  }
  return ExampleRequestBody.inlinedRequestBody({
    jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({ example: example.request, file }).resolvedExample,
    properties: exampleProperties
  });
}
function convertExampleResponse({ endpoint, example, typeResolver, errorResolver, exampleResolver, file, workspace }) {
  if (example.response == null) {
    return ExampleResponse.ok(ExampleEndpointSuccessResponse.body(void 0));
  }
  return visitExampleResponseSchema(endpoint, example.response, {
    body: (example2) => {
      if (example2.error != null) {
        const errorDeclaration = errorResolver.getDeclarationOrThrow(example2.error, file);
        return ExampleResponse.error({
          error: parseErrorName({
            errorName: example2.error,
            file
          }),
          body: errorDeclaration.declaration.type != null ? convertTypeReferenceExample({
            example: example2.body,
            rawTypeBeingExemplified: errorDeclaration.declaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: errorDeclaration.file,
            fileContainingExample: file,
            workspace
          }) : void 0
        });
      }
      return ExampleResponse.ok(ExampleEndpointSuccessResponse.body(convertExampleResponseBody({ endpoint, example: example2, typeResolver, exampleResolver, file, workspace })));
    },
    stream: (example2) => {
      const rawTypeBeingExemplified = typeof endpoint["response-stream"] === "string" ? endpoint["response-stream"] : endpoint["response-stream"]?.type;
      return ExampleResponse.ok(ExampleEndpointSuccessResponse.stream(example2.stream.map((data) => {
        if (rawTypeBeingExemplified == null) {
          return void 0;
        }
        return convertTypeReferenceExample({
          example: data,
          rawTypeBeingExemplified,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        });
      }).filter(isNonNullish)));
    },
    events: (example2) => {
      const rawTypeBeingExemplified = typeof endpoint["response-stream"] === "string" ? endpoint["response-stream"] : endpoint["response-stream"]?.type;
      return ExampleResponse.ok(ExampleEndpointSuccessResponse.sse(example2.stream.map(({ event, data }) => {
        if (rawTypeBeingExemplified == null) {
          return void 0;
        }
        const convertedExample = convertTypeReferenceExample({
          example: data,
          rawTypeBeingExemplified,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        });
        return { event, data: convertedExample };
      }).filter(isNonNullish)));
    }
  });
}
function convertExampleResponseBody({ endpoint, example, typeResolver, exampleResolver, file, workspace }) {
  const responseBodyType = typeof endpoint.response !== "string" ? endpoint.response?.type : endpoint.response;
  if (responseBodyType == null) {
    return void 0;
  }
  if (example.body == null) {
    return void 0;
  }
  return convertTypeReferenceExample({
    example: example.body,
    rawTypeBeingExemplified: responseBodyType,
    typeResolver,
    exampleResolver,
    fileContainingRawTypeReference: file,
    fileContainingExample: file,
    workspace
  });
}
function buildUrl({ file, service, endpoint, example, pathParams }) {
  let url = urlJoin(file.rootApiFile["base-path"] ?? "", service["base-path"], endpoint.path);
  if (example["path-parameters"] != null) {
    for (const parameter of [
      ...pathParams.endpointPathParameters,
      ...pathParams.servicePathParameters,
      ...pathParams.rootPathParameters
    ]) {
      url = url.replaceAll(`{${parameter.name.originalName}}`, `${parameter.value.jsonExample}`);
    }
  }
  url = url.replaceAll("//", "/");
  if (!url.startsWith("/")) {
    url = `/${url}`;
  }
  return url;
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpResponse.js
async function convertHttpResponse({ endpoint, file, typeResolver }) {
  const responseBody = await convertHttpResponseBody({
    endpoint,
    file,
    typeResolver
  });
  return {
    body: responseBody,
    statusCode: typeof endpoint.response !== "string" ? endpoint.response?.["status-code"] : void 0
  };
}
async function convertHttpResponseBody({ endpoint, file, typeResolver }) {
  const response = await convertNonStreamHttpResponseBody({
    endpoint,
    file,
    typeResolver
  });
  const streamResponse = await convertStreamHttpResponseBody({
    endpoint,
    file,
    typeResolver
  });
  if (response != null && streamResponse != null) {
    let nonStreamResponse;
    switch (response.type) {
      case "fileDownload": {
        nonStreamResponse = NonStreamHttpResponseBody.fileDownload({ ...response });
        break;
      }
      case "json": {
        nonStreamResponse = NonStreamHttpResponseBody.json({
          ...response.value
        });
        break;
      }
      case "text": {
        nonStreamResponse = NonStreamHttpResponseBody.text({ ...response });
        break;
      }
      default:
        assertNever(response);
    }
    return HttpResponseBody.streamParameter({
      nonStreamResponse,
      streamResponse
    });
  } else if (response != null) {
    return response;
  } else if (streamResponse != null) {
    return HttpResponseBody.streaming(streamResponse);
  }
  return void 0;
}
async function convertNonStreamHttpResponseBody({ endpoint, file, typeResolver }) {
  const { response } = endpoint;
  if (response != null) {
    const docs = typeof response !== "string" ? response.docs : void 0;
    const responseType = typeof response === "string" ? response : response.type;
    if (parseRawFileType(responseType) != null) {
      return HttpResponseBody.fileDownload({
        docs
      });
    } else if (parseRawTextType(responseType) != null) {
      return HttpResponseBody.text({
        docs
      });
    } else {
      return await convertJsonResponse(response, docs, file, typeResolver);
    }
  }
  return void 0;
}
async function convertStreamHttpResponseBody({ endpoint, file, typeResolver }) {
  const { ["response-stream"]: responseStream } = endpoint;
  if (responseStream != null) {
    const docs = typeof responseStream !== "string" ? responseStream.docs : void 0;
    const typeReference = typeof responseStream === "string" ? responseStream : responseStream.type;
    const streamFormat = typeof responseStream === "string" ? "json" : responseStream.format ?? "json";
    if (isRawTextType(typeReference)) {
      return StreamingResponse.text({
        docs
      });
    } else if (typeof responseStream !== "string" && streamFormat === "sse") {
      return StreamingResponse.sse({
        docs,
        payload: file.parseTypeReference(typeReference),
        terminator: typeof responseStream !== "string" ? responseStream.terminator : void 0
      });
    } else {
      return StreamingResponse.json({
        docs,
        payload: file.parseTypeReference(typeReference),
        terminator: typeof responseStream !== "string" ? responseStream.terminator : void 0
      });
    }
  }
  return void 0;
}
async function convertJsonResponse(response, docs, file, typeResolver) {
  const responseBodyType = file.parseTypeReference(response);
  const resolvedType = typeResolver.resolveTypeOrThrow({
    type: typeof response !== "string" ? response.type : response,
    file
  });
  const responseProperty = typeof response !== "string" ? response.property : void 0;
  if (responseProperty != null) {
    return HttpResponseBody.json(JsonResponse.nestedPropertyAsResponse({
      docs,
      responseBodyType,
      responseProperty: await getObjectPropertyFromResolvedType({
        typeResolver,
        file,
        resolvedType,
        property: responseProperty
      })
    }));
  }
  return HttpResponseBody.json(JsonResponse.response({
    docs,
    responseBodyType
  }));
}

// ../../cli/generation/ir-generator/lib/converters/services/convertCursorPagination.js
async function convertCursorPagination({ propertyResolver, file, endpointName, endpointSchema, paginationPropertyComponents }) {
  return Pagination.cursor({
    page: await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.cursor
    }),
    next: await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.next_cursor
    }),
    results: await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.results
    })
  });
}

// ../../cli/generation/ir-generator/lib/converters/services/convertOffsetPagination.js
async function convertOffsetPagination({ propertyResolver, file, endpointName, endpointSchema, paginationPropertyComponents }) {
  return Pagination.offset({
    page: await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.offset
    }),
    results: await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.results
    }),
    step: paginationPropertyComponents.step != null ? await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.step
    }) : void 0,
    hasNextPage: paginationPropertyComponents.hasNextPage != null ? await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.hasNextPage
    }) : void 0
  });
}

// ../../cli/generation/ir-generator/lib/converters/services/convertPaginationUtils.js
function getPaginationPropertyComponents(endpointPagination) {
  if (isRawOffsetPaginationSchema(endpointPagination)) {
    return {
      type: "offset",
      offset: getRequestPropertyComponents(endpointPagination.offset),
      results: getResponsePropertyComponents(endpointPagination.results),
      step: endpointPagination.step != null ? getRequestPropertyComponents(endpointPagination.step) : void 0,
      hasNextPage: endpointPagination["has-next-page"] != null ? getResponsePropertyComponents(endpointPagination["has-next-page"]) : void 0
    };
  }
  return {
    type: "cursor",
    cursor: getRequestPropertyComponents(endpointPagination.cursor),
    next_cursor: getResponsePropertyComponents(endpointPagination.next_cursor),
    results: getResponsePropertyComponents(endpointPagination.results)
  };
}
function isRawOffsetPaginationSchema(rawPaginationSchema) {
  return rawPaginationSchema.offset != null && rawPaginationSchema.results != null;
}

// ../../cli/generation/ir-generator/lib/converters/services/convertPagination.js
async function convertPagination({ propertyResolver, file, endpointName, endpointSchema }) {
  const endpointPagination = typeof endpointSchema.pagination === "boolean" ? file.rootApiFile.pagination : endpointSchema.pagination;
  if (!endpointPagination) {
    return void 0;
  }
  const paginationPropertyComponents = getPaginationPropertyComponents(endpointPagination);
  switch (paginationPropertyComponents.type) {
    case "cursor":
      return await convertCursorPagination({
        propertyResolver,
        file,
        endpointName,
        endpointSchema,
        paginationPropertyComponents
      });
    case "offset":
      return convertOffsetPagination({
        propertyResolver,
        file,
        endpointName,
        endpointSchema,
        paginationPropertyComponents
      });
    default:
      assertNever(paginationPropertyComponents);
  }
}

// ../../cli/generation/ir-generator/lib/converters/convertProtobufFile.js
function convertProtobufFile({ source }) {
  return {
    filepath: source.relativeFilePath,
    packageName: source.packageName,
    options: source.csharpNamespace != null ? {
      csharp: {
        namespace: source.csharpNamespace
      }
    } : void 0
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertProtobufService.js
function convertProtobufService({ source, serviceNameOverride }) {
  const serviceName = serviceNameOverride ?? source.serviceName;
  if (serviceName == null) {
    return void 0;
  }
  return {
    file: convertProtobufFile({ source }),
    // Use the global casings generator so that the name is not
    // affected by the user's casing settings (e.g. smart-casing).
    name: CASINGS_GENERATOR.generateName(serviceName)
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertTransport.js
async function getTransportForService({ file, serviceDeclaration, sourceResolver }) {
  if (!isRawProtobufSourceSchema(serviceDeclaration.source)) {
    return Transport.http();
  }
  return await createProtobufService(file, serviceDeclaration.source, sourceResolver, serviceDeclaration.transport?.grpc?.["service-name"]);
}
async function getTransportForEndpoint({ file, serviceTransport, endpointDeclaration, sourceResolver }) {
  const isGrpcService = serviceTransport.type === "grpc";
  const isHttpService = serviceTransport.type === "http";
  const isGrpcEndpoint = isRawProtobufSourceSchema(endpointDeclaration.source);
  const isHttpEndpoint = !isGrpcEndpoint;
  if (!isGrpcService) {
    return void 0;
  }
  if (isHttpService && isGrpcEndpoint) {
    throw new Error("Cannot have a grpc endpoint on an http service");
  }
  if (isGrpcService && isHttpEndpoint) {
    return Transport.http();
  }
  if (isGrpcService && isGrpcEndpoint) {
    const protoSource = endpointDeclaration.source;
    const serviceNameOverride = endpointDeclaration.transport?.grpc?.["service-name"];
    if (!serviceNameOverride) {
      return void 0;
    } else {
      return await createProtobufService(file, protoSource, sourceResolver, serviceNameOverride);
    }
  }
  throw new Error(`Internal error; failed to determine endpoint transport for
  ${JSON.stringify(endpointDeclaration)}"`);
}
async function createProtobufService(file, source, sourceResolver, serviceNameOverride) {
  const resolvedSource = await sourceResolver.resolveSourceOrThrow({
    source,
    relativeFilepath: file.relativeFilepath
  });
  if (resolvedSource == null || resolvedSource.type !== "protobuf") {
    throw new Error(`Expected a protobuf source for ${source.proto}.`);
  }
  const protobufService = convertProtobufService({
    source: resolvedSource,
    serviceNameOverride
  });
  if (protobufService == null) {
    throw new Error(`Failed to resolve service name from ${resolvedSource.relativeFilePath}.`);
  }
  return Transport.grpc({
    service: protobufService
  });
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpService.js
async function convertHttpService({ rootDefaultUrl, rootPathParameters, serviceDefinition, file, errorResolver, typeResolver, propertyResolver, exampleResolver, variableResolver, sourceResolver, globalErrors, workspace }) {
  const servicePathParameters = await convertPathParameters2({
    pathParameters: serviceDefinition["path-parameters"],
    location: PathParameterLocation.Service,
    file,
    variableResolver
  });
  const transport = await getTransportForService({
    file,
    serviceDeclaration: serviceDefinition,
    sourceResolver
  });
  const serviceName = { fernFilepath: file.fernFilepath };
  const service = {
    availability: convertAvailability(serviceDefinition.availability),
    name: serviceName,
    displayName: serviceDefinition["display-name"] ?? void 0,
    basePath: constructHttpPath(serviceDefinition["base-path"]),
    headers: serviceDefinition.headers != null ? await Promise.all(Object.entries(serviceDefinition.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
    pathParameters: servicePathParameters,
    encoding: convertTransportToEncoding(transport, serviceDefinition),
    transport,
    endpoints: await Promise.all(Object.entries(serviceDefinition.endpoints).map(async ([endpointKey, endpoint]) => {
      const endpointPathParameters = await convertPathParameters2({
        pathParameters: getEndpointPathParameters(endpoint),
        location: PathParameterLocation.Endpoint,
        file,
        variableResolver
      });
      const httpEndpoint = {
        ...await convertDeclaration(endpoint),
        id: "",
        name: file.casingsGenerator.generateName(endpointKey),
        displayName: endpoint["display-name"],
        auth: endpoint.auth ?? serviceDefinition.auth,
        idempotent: endpoint.idempotent ?? serviceDefinition.idempotent ?? false,
        baseUrl: endpoint.url ?? serviceDefinition.url ?? rootDefaultUrl,
        method: endpoint.method != null ? convertHttpMethod(endpoint.method) : HttpMethod.Post,
        basePath: endpoint["base-path"] != null ? constructHttpPath(endpoint["base-path"]) : void 0,
        path: constructHttpPath(endpoint.path),
        fullPath: constructHttpPath(endpoint["base-path"] != null ? urlJoin(endpoint["base-path"], endpoint.path) : file.rootApiFile["base-path"] != null ? urlJoin(file.rootApiFile["base-path"], serviceDefinition["base-path"], endpoint.path) : urlJoin(serviceDefinition["base-path"], endpoint.path)),
        pathParameters: endpointPathParameters,
        allPathParameters: endpoint["base-path"] != null ? endpointPathParameters : [...rootPathParameters, ...servicePathParameters, ...endpointPathParameters],
        queryParameters: typeof endpoint.request !== "string" && endpoint.request?.["query-parameters"] != null ? await Promise.all(Object.entries(endpoint.request["query-parameters"]).map(async ([queryParameterKey, queryParameter]) => {
          return await convertQueryParameter({
            file,
            queryParameterKey,
            queryParameter
          });
        })) : [],
        headers: typeof endpoint.request !== "string" && endpoint.request?.headers != null ? await Promise.all(Object.entries(endpoint.request.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
        requestBody: convertHttpRequestBody({ request: endpoint.request, file }),
        sdkRequest: await convertHttpSdkRequest({
          service: serviceDefinition,
          request: endpoint.request,
          endpoint,
          endpointKey,
          file,
          typeResolver,
          propertyResolver
        }),
        response: await convertHttpResponse({ endpoint, file, typeResolver }),
        errors: [...convertResponseErrors({ errors: endpoint.errors, file }), ...globalErrors],
        userSpecifiedExamples: endpoint.examples != null ? endpoint.examples.map((example) => {
          return {
            example: convertExampleEndpointCall({
              service: serviceDefinition,
              endpoint,
              example,
              typeResolver,
              errorResolver,
              exampleResolver,
              variableResolver,
              file,
              workspace
            }),
            codeSamples: example["code-samples"]?.map((codeSample) => convertCodeSample({ codeSample, file }))
          };
        }) : [],
        autogeneratedExamples: [],
        pagination: await convertPagination({
          propertyResolver,
          file,
          endpointName: endpointKey,
          endpointSchema: endpoint
        }),
        transport: await getTransportForEndpoint({
          file,
          serviceTransport: transport,
          endpointDeclaration: endpoint,
          sourceResolver
        })
      };
      httpEndpoint.id = IdGenerator.generateEndpointId(serviceName, httpEndpoint);
      return httpEndpoint;
    }))
  };
  return service;
}
async function convertPathParameters2({ pathParameters, location, file, variableResolver }) {
  if (pathParameters == null) {
    return [];
  }
  return await Promise.all(Object.entries(pathParameters).map(([parameterName, parameter]) => convertPathParameter({
    parameterName,
    parameter,
    location,
    file,
    variableResolver
  })));
}
async function convertPathParameter({ parameterName, parameter, location, file, variableResolver }) {
  return {
    ...await convertDeclaration(parameter),
    name: file.casingsGenerator.generateName(parameterName),
    valueType: getPathParameterType({ parameter, variableResolver, file }),
    location,
    variable: isVariablePathParameter(parameter) ? variableResolver.getVariableIdOrThrow(typeof parameter === "string" ? parameter : parameter.variable) : void 0
  };
}
function getPathParameterType({ parameter, variableResolver, file }) {
  const parsed = resolvePathParameterOrThrow({
    parameter,
    variableResolver,
    file
  });
  return parsed.file.parseTypeReference(parsed.rawType);
}
function resolvePathParameterOrThrow({ parameter, variableResolver, file }) {
  const resolved = resolvePathParameter({
    parameter,
    variableResolver,
    file
  });
  if (resolved == null) {
    throw new Error("Cannot resolve path parameter");
  }
  return resolved;
}
function resolvePathParameter({ parameter, variableResolver, file }) {
  if (isVariablePathParameter(parameter)) {
    const variable = typeof parameter === "string" ? parameter : parameter.variable;
    const resolvedVariable = variableResolver.getDeclaration(variable, file);
    if (resolvedVariable == null) {
      return void 0;
    }
    const rawType = typeof resolvedVariable.declaration === "string" ? resolvedVariable.declaration : resolvedVariable.declaration.type;
    return {
      rawType,
      file: resolvedVariable.file
    };
  } else {
    return {
      file,
      rawType: typeof parameter === "string" ? parameter : parameter.type
    };
  }
}
function convertHttpMethod(method) {
  switch (method) {
    case "GET":
      return HttpMethod.Get;
    case "POST":
      return HttpMethod.Post;
    case "PUT":
      return HttpMethod.Put;
    case "PATCH":
      return HttpMethod.Patch;
    case "DELETE":
      return HttpMethod.Delete;
    default:
      assertNever(method);
  }
}
async function convertHttpHeader({ headerKey, header, file }) {
  const { name } = getHeaderName2({ headerKey, header });
  return {
    ...await convertDeclaration(header),
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: headerKey,
      name
    }),
    valueType: file.parseTypeReference(header),
    env: typeof header === "string" ? void 0 : header.env
  };
}
function getHeaderName2({ headerKey, header }) {
  if (typeof header !== "string") {
    if (header.name != null) {
      return {
        name: header.name,
        wasExplicitlySet: true
      };
    }
  }
  return {
    name: headerKey,
    wasExplicitlySet: false
  };
}
function convertTransportToEncoding(transport, service) {
  switch (transport.type) {
    case "http":
      return {
        json: {},
        proto: void 0
      };
    case "grpc":
      return {
        json: void 0,
        proto: {}
      };
    default:
      assertNever(transport);
  }
}

// ../../cli/generation/ir-generator/lib/converters/constants.js
function generateFernConstants(casingsGenerator) {
  return {
    errorInstanceIdKey: casingsGenerator.generateNameAndWireValue({
      wireValue: "errorInstanceId",
      name: "errorInstanceId"
    })
  };
}

// ../../cli/generation/ir-generator/lib/utils/isRootFernFilepath.js
function isRootFernFilepath({ fernFilePath }) {
  return fernFilePath.packagePath.length === 0 && fernFilePath.file == null;
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthRefreshEndpoint.js
async function convertOAuthRefreshEndpoint({ endpointResolver, propertyResolver, file, refreshTokenEndpoint }) {
  const resolvedEndpoint = await endpointResolver.resolveEndpointOrThrow({
    endpoint: refreshTokenEndpoint.endpoint,
    file
  });
  return {
    endpointReference: {
      endpointId: IdGenerator.generateEndpointIdFromResolvedEndpoint(resolvedEndpoint),
      serviceId: IdGenerator.generateServiceIdFromFernFilepath(resolvedEndpoint.file.fernFilepath),
      subpackageId: !isRootFernFilepath({ fernFilePath: resolvedEndpoint.file.fernFilepath }) ? IdGenerator.generateSubpackageId(resolvedEndpoint.file.fernFilepath) : void 0
    },
    requestProperties: {
      refreshToken: await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.requestProperties.refresh_token
      })
    },
    responseProperties: {
      accessToken: await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.responseProperties.access_token
      }),
      expiresIn: refreshTokenEndpoint.responseProperties.expires_in != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.responseProperties.expires_in
      }) : void 0,
      refreshToken: refreshTokenEndpoint.responseProperties.refresh_token != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.responseProperties.refresh_token
      }) : void 0
    }
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthTokenEndpoint.js
async function convertOAuthTokenEndpoint({ endpointResolver, propertyResolver, file, tokenEndpoint }) {
  const resolvedEndpoint = await endpointResolver.resolveEndpointOrThrow({
    endpoint: tokenEndpoint.endpoint,
    file
  });
  return {
    endpointReference: {
      endpointId: IdGenerator.generateEndpointIdFromResolvedEndpoint(resolvedEndpoint),
      serviceId: IdGenerator.generateServiceIdFromFernFilepath(resolvedEndpoint.file.fernFilepath),
      subpackageId: !isRootFernFilepath({ fernFilePath: resolvedEndpoint.file.fernFilepath }) ? IdGenerator.generateSubpackageId(resolvedEndpoint.file.fernFilepath) : void 0
    },
    requestProperties: {
      clientId: await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.requestProperties.client_id
      }),
      clientSecret: await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.requestProperties.client_secret
      }),
      scopes: tokenEndpoint.requestProperties.scopes != null ? await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.requestProperties.scopes
      }) : void 0
    },
    responseProperties: {
      accessToken: await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.responseProperties.access_token
      }),
      expiresIn: tokenEndpoint.responseProperties.expires_in != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.responseProperties.expires_in
      }) : void 0,
      refreshToken: tokenEndpoint.responseProperties.refresh_token != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.responseProperties.refresh_token
      }) : void 0
    }
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthClientCredentials.js
async function convertOAuthClientCredentials({ propertyResolver, endpointResolver, file, oauthScheme, tokenEndpoint, refreshTokenEndpoint }) {
  const oauthTokenEndpoint = await convertOAuthTokenEndpoint({
    propertyResolver,
    endpointResolver,
    file,
    tokenEndpoint
  });
  if (oauthTokenEndpoint == null) {
    throw new Error("Failed to convert OAuth token endpoint.");
  }
  const refreshEndpoint = refreshTokenEndpoint != null ? await convertOAuthRefreshEndpoint({
    propertyResolver,
    endpointResolver,
    file,
    refreshTokenEndpoint
  }) : void 0;
  return {
    clientIdEnvVar: oauthScheme["client-id-env"],
    clientSecretEnvVar: oauthScheme["client-secret-env"],
    tokenPrefix: oauthScheme["token-prefix"],
    tokenHeader: oauthScheme["token-header"],
    scopes: oauthScheme.scopes,
    tokenEndpoint: oauthTokenEndpoint,
    refreshEndpoint
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthUtils.js
var DEFAULT_TOKEN_ENDPOINT = {
  requestProperties: {
    type: "access_token",
    client_id: ["client_id"],
    client_secret: ["client_secret"],
    scopes: void 0
  },
  responseProperties: {
    type: "access_token",
    access_token: ["access_token"],
    expires_in: void 0,
    refresh_token: void 0
  }
};
var DEFAULT_REFRESH_TOKEN_ENDPOINT = {
  requestProperties: {
    type: "refresh_token",
    refresh_token: ["refresh_token"]
  },
  responseProperties: {
    type: "access_token",
    access_token: ["access_token"],
    refresh_token: void 0,
    expires_in: void 0
  }
};
function getTokenEndpoint(oauthSchema) {
  return {
    endpoint: oauthSchema["get-token"].endpoint,
    requestProperties: getTokenEndpointRequestProperties({
      requestProperties: oauthSchema["get-token"]?.["request-properties"]
    }),
    responseProperties: getTokenEndpointResponseProperties({
      responseProperties: oauthSchema["get-token"]?.["response-properties"]
    })
  };
}
function getRefreshTokenEndpoint(oauthSchema) {
  if (oauthSchema["refresh-token"] == null) {
    return void 0;
  }
  return {
    endpoint: oauthSchema["refresh-token"].endpoint,
    requestProperties: getRefreshTokenEndpointRequestProperties({
      requestProperties: oauthSchema["refresh-token"]?.["request-properties"]
    }),
    responseProperties: getRefreshTokenEndpointResponseProperties({
      responseProperties: oauthSchema["refresh-token"]?.["response-properties"]
    })
  };
}
function getTokenEndpointRequestProperties({ requestProperties }) {
  if (requestProperties == null) {
    return DEFAULT_TOKEN_ENDPOINT.requestProperties;
  }
  const maybeClientId = requestProperties["client-id"];
  const maybeClientSecret = requestProperties["client-secret"];
  const maybeScopes = requestProperties.scopes;
  return {
    type: "access_token",
    client_id: maybeClientId != null ? getRequestPropertyComponents(maybeClientId) : DEFAULT_TOKEN_ENDPOINT.requestProperties.client_id,
    client_secret: maybeClientSecret != null ? getRequestPropertyComponents(maybeClientSecret) : DEFAULT_TOKEN_ENDPOINT.requestProperties.client_secret,
    scopes: maybeScopes != null ? getRequestPropertyComponents(maybeScopes) : DEFAULT_TOKEN_ENDPOINT.requestProperties.scopes
  };
}
function getTokenEndpointResponseProperties({ responseProperties }) {
  return getTokenEndpointResponsePropertiesWithDefault({
    responseProperties,
    defaultValue: DEFAULT_TOKEN_ENDPOINT.responseProperties
  });
}
function getRefreshTokenEndpointRequestProperties({ requestProperties }) {
  if (requestProperties == null) {
    return DEFAULT_REFRESH_TOKEN_ENDPOINT.requestProperties;
  }
  const maybeRefreshToken = requestProperties["refresh-token"];
  return {
    type: "refresh_token",
    refresh_token: maybeRefreshToken != null ? getRequestPropertyComponents(maybeRefreshToken) : DEFAULT_REFRESH_TOKEN_ENDPOINT.requestProperties.refresh_token
  };
}
function getRefreshTokenEndpointResponseProperties({ responseProperties }) {
  return getTokenEndpointResponsePropertiesWithDefault({
    responseProperties,
    defaultValue: DEFAULT_REFRESH_TOKEN_ENDPOINT.responseProperties
  });
}
function getTokenEndpointResponsePropertiesWithDefault({ responseProperties, defaultValue }) {
  if (responseProperties == null) {
    return defaultValue;
  }
  const maybeAccessToken = responseProperties["access-token"];
  const maybeExpiresIn = responseProperties["expires-in"];
  const maybeRefreshToken = responseProperties["refresh-token"];
  return {
    type: "access_token",
    access_token: maybeAccessToken != null ? getResponsePropertyComponents(maybeAccessToken) : defaultValue.access_token,
    expires_in: maybeExpiresIn != null ? getResponsePropertyComponents(maybeExpiresIn) : defaultValue.expires_in,
    refresh_token: maybeRefreshToken != null ? getResponsePropertyComponents(maybeRefreshToken) : defaultValue.refresh_token
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertApiAuth.js
async function convertApiAuth({ rawApiFileSchema, file, propertyResolver, endpointResolver }) {
  if (rawApiFileSchema.auth == null) {
    return {
      docs: void 0,
      requirement: AuthSchemesRequirement.All,
      schemes: []
    };
  }
  const docs = typeof rawApiFileSchema.auth !== "string" ? rawApiFileSchema.auth.docs : void 0;
  return visitRawApiAuth(rawApiFileSchema.auth, {
    single: async (authScheme) => {
      const schemaReference = await convertSchemeReference({
        reference: authScheme,
        authSchemeDeclarations: rawApiFileSchema["auth-schemes"],
        file,
        propertyResolver,
        endpointResolver
      });
      return {
        docs,
        requirement: AuthSchemesRequirement.All,
        schemes: [schemaReference]
      };
    },
    any: async ({ any: any3 }) => ({
      docs,
      requirement: AuthSchemesRequirement.Any,
      schemes: await Promise.all(any3.map(async (schemeReference) => await convertSchemeReference({
        reference: schemeReference,
        authSchemeDeclarations: rawApiFileSchema["auth-schemes"],
        file,
        propertyResolver,
        endpointResolver
      })))
    })
  });
}
async function convertSchemeReference({ reference, authSchemeDeclarations, file, propertyResolver, endpointResolver }) {
  const convertNamedAuthSchemeReference = (reference2, docs) => {
    const declaration = authSchemeDeclarations?.[reference2];
    if (declaration == null) {
      throw new Error("Unknown auth scheme: " + reference2);
    }
    return visitRawAuthSchemeDeclaration(declaration, {
      header: async (rawHeader) => AuthScheme.header({
        docs,
        name: file.casingsGenerator.generateNameAndWireValue({
          name: rawHeader.name ?? reference2,
          wireValue: rawHeader.header
        }),
        valueType: file.parseTypeReference(rawHeader.type ?? "string"),
        prefix: rawHeader.prefix,
        headerEnvVar: rawHeader.env
      }),
      basic: async (rawScheme) => generateBasicAuth({
        file,
        docs,
        rawScheme
      }),
      bearer: async (rawScheme) => generateBearerAuth({
        file,
        docs,
        rawScheme
      }),
      oauth: async (rawScheme) => await generateOAuth({
        file,
        docs,
        rawScheme,
        propertyResolver,
        endpointResolver
      })
    });
  };
  const scheme = typeof reference === "string" ? reference : reference.scheme;
  switch (scheme) {
    case "bearer":
      return generateBearerAuth({
        file,
        docs: void 0,
        rawScheme: void 0
      });
    case "basic":
      return generateBasicAuth({
        file,
        docs: void 0,
        rawScheme: void 0
      });
    case "oauth":
      return await generateOAuth({
        file,
        docs: void 0,
        rawScheme: void 0,
        propertyResolver,
        endpointResolver
      });
    default:
      return convertNamedAuthSchemeReference(scheme, typeof reference !== "string" ? reference.docs : void 0);
  }
}
function generateBearerAuth({ file, docs, rawScheme }) {
  return AuthScheme.bearer({
    docs,
    token: file.casingsGenerator.generateName(rawScheme?.token?.name ?? "token"),
    tokenEnvVar: rawScheme?.token?.env
  });
}
function generateBasicAuth({ file, docs, rawScheme }) {
  return AuthScheme.basic({
    docs,
    username: file.casingsGenerator.generateName(rawScheme?.username?.name ?? "username"),
    usernameEnvVar: rawScheme?.username?.env,
    password: file.casingsGenerator.generateName(rawScheme?.password?.name ?? "password"),
    passwordEnvVar: rawScheme?.password?.env
  });
}
async function generateOAuth({ file, docs, rawScheme, propertyResolver, endpointResolver }) {
  switch (rawScheme?.type) {
    case "client-credentials":
      return AuthScheme.oauth({
        docs,
        configuration: OAuthConfiguration.clientCredentials(await convertOAuthClientCredentials({
          propertyResolver,
          endpointResolver,
          file,
          oauthScheme: rawScheme,
          tokenEndpoint: getTokenEndpoint(rawScheme),
          refreshTokenEndpoint: getRefreshTokenEndpoint(rawScheme)
        }))
      });
    default:
      throw new Error(`Unknown OAuth type: '${rawScheme?.type}'`);
  }
}

// ../../cli/generation/ir-generator/lib/converters/convertApiVersionScheme.js
async function convertApiVersionScheme({ file, rawApiFileSchema }) {
  if (rawApiFileSchema.version == null) {
    return void 0;
  }
  return ApiVersionScheme.header({
    header: await convertHeader({
      file,
      header: rawApiFileSchema.version.header
    }),
    value: await convertEnum2({
      file,
      versionDeclaration: rawApiFileSchema.version
    })
  });
}
async function convertHeader({ file, header }) {
  if (typeof header === "string") {
    return await convertHttpHeader({
      file,
      headerKey: header,
      header: {
        type: "string"
      }
    });
  }
  return await convertHttpHeader({
    file,
    headerKey: header.value,
    header: {
      type: "string",
      name: header.name,
      env: header.env
    }
  });
}
async function convertEnum2({ file, versionDeclaration }) {
  return await convertEnumTypeDeclaration({
    _enum: {
      default: versionDeclaration.default,
      enum: versionDeclaration.values
    },
    file
  });
}

// ../../cli/generation/ir-generator/lib/converters/convertChannel.js
async function convertChannel({ channel, typeResolver, exampleResolver, variableResolver, file, workspace }) {
  const messages = [];
  for (const [messageId, message] of Object.entries(channel.messages ?? {})) {
    messages.push({
      type: messageId,
      availability: convertAvailability(message.availability),
      docs: message.docs,
      origin: message.origin,
      body: convertMessageSchema({ body: message.body, file }),
      displayName: message["display-name"]
    });
  }
  return {
    availability: convertAvailability(channel.availability),
    path: constructHttpPath(channel.path),
    auth: channel.auth,
    // since there's only 1 channel per file, we can use the file name as the channel's name
    name: file.fernFilepath.file ?? file.casingsGenerator.generateName(channel["display-name"] ?? channel.path),
    displayName: channel["display-name"],
    headers: channel.headers != null ? await Promise.all(Object.entries(channel.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
    docs: channel.docs,
    pathParameters: channel["path-parameters"] != null ? await convertPathParameters2({
      pathParameters: channel["path-parameters"],
      location: PathParameterLocation.Endpoint,
      file,
      variableResolver
    }) : [],
    queryParameters: channel["query-parameters"] != null ? await Promise.all(Object.entries(channel["query-parameters"]).map(async ([queryParameterKey, queryParameter]) => {
      const { name } = getQueryParameterName({ queryParameterKey, queryParameter });
      const valueType = file.parseTypeReference(queryParameter);
      return {
        ...await convertDeclaration(queryParameter),
        name: file.casingsGenerator.generateNameAndWireValue({
          wireValue: queryParameterKey,
          name
        }),
        valueType,
        allowMultiple: typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false
      };
    })) : [],
    messages: Object.values(messages),
    examples: (channel.examples ?? []).map((example) => {
      const convertedPathParameters = convertChannelPathParameters({
        channel,
        example,
        typeResolver,
        exampleResolver,
        variableResolver,
        file,
        workspace
      });
      return {
        name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
        docs: example.docs,
        url: buildUrl2({ channel, example, pathParams: convertedPathParameters }),
        ...convertedPathParameters,
        ...convertHeaders2({ channel, example, typeResolver, exampleResolver, file, workspace }),
        queryParameters: example["query-parameters"] != null ? Object.entries(example["query-parameters"]).map(([wireKey, value]) => {
          const queryParameterDeclaration = channel["query-parameters"]?.[wireKey];
          if (queryParameterDeclaration == null) {
            throw new Error(`Query parameter ${wireKey} does not exist`);
          }
          return {
            name: file.casingsGenerator.generateNameAndWireValue({
              name: getQueryParameterName({
                queryParameterKey: wireKey,
                queryParameter: queryParameterDeclaration
              }).name,
              wireValue: wireKey
            }),
            value: convertTypeReferenceExample({
              example: value,
              rawTypeBeingExemplified: typeof queryParameterDeclaration === "string" ? queryParameterDeclaration : queryParameterDeclaration.type,
              typeResolver,
              exampleResolver,
              fileContainingRawTypeReference: file,
              fileContainingExample: file,
              workspace
            }),
            shape: getQueryParamaterDeclationShape2({ queryParameter: queryParameterDeclaration })
          };
        }) : [],
        messages: example.messages.map((messageExample) => {
          const message = channel.messages?.[messageExample.type];
          if (message == null) {
            throw new Error(`Message ${messageExample.type} does not exist`);
          }
          return {
            type: messageExample.type,
            body: convertExampleWebSocketMessageBody({
              message,
              example: messageExample.body,
              typeResolver,
              exampleResolver,
              file,
              workspace
            })
          };
        })
      };
    })
  };
}
function getQueryParamaterDeclationShape2({ queryParameter }) {
  const isAllowMultiple = typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false;
  return isAllowMultiple ? ExampleQueryParameterShape.exploded() : ExampleQueryParameterShape.single();
}
function convertExampleWebSocketMessageBody({ message, example, typeResolver, exampleResolver, file, workspace }) {
  if (!isInlineMessageBody(message.body)) {
    return ExampleWebSocketMessageBody.reference(convertTypeReferenceExample({
      example,
      rawTypeBeingExemplified: typeof message.body !== "string" ? message.body.type : message.body,
      typeResolver,
      exampleResolver,
      fileContainingRawTypeReference: file,
      fileContainingExample: file,
      workspace
    }));
  }
  if (!isPlainObject2(example)) {
    throw new Error("Example must be an object");
  }
  const exampleProperties = [];
  for (const [wireKey, propertyExample] of Object.entries(example)) {
    const inlinedRequestPropertyDeclaration = message.body.properties?.[wireKey];
    if (inlinedRequestPropertyDeclaration != null) {
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: inlinedRequestPropertyDeclaration }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof inlinedRequestPropertyDeclaration !== "string" ? inlinedRequestPropertyDeclaration.type : inlinedRequestPropertyDeclaration,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: void 0
      });
    } else {
      const originalTypeDeclaration = getOriginalTypeDeclarationForPropertyFromExtensions({
        extends_: message.body.extends,
        wirePropertyKey: wireKey,
        typeResolver,
        file
      });
      if (originalTypeDeclaration == null) {
        throw new Error("Could not find original type declaration for property: " + wireKey);
      }
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: originalTypeDeclaration.rawPropertyType }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof originalTypeDeclaration.rawPropertyType === "string" ? originalTypeDeclaration.rawPropertyType : originalTypeDeclaration.rawPropertyType.type,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: originalTypeDeclaration.file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: originalTypeDeclaration.typeName
      });
    }
  }
  return ExampleWebSocketMessageBody.inlinedBody({
    jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({ example, file }).resolvedExample,
    properties: exampleProperties
  });
}
function convertMessageSchema({ body, file }) {
  if (typeof body === "string") {
    return WebSocketMessageBody.reference({
      docs: void 0,
      bodyType: file.parseTypeReference(body)
    });
  } else if (isReferencedWebhookPayloadSchema(body)) {
    return WebSocketMessageBody.reference({
      docs: void 0,
      bodyType: file.parseTypeReference(body.type)
    });
  } else {
    return WebSocketMessageBody.inlinedBody({
      name: file.casingsGenerator.generateName(body.name),
      extends: getExtensionsAsList(body.extends ?? []).map((extended) => parseTypeName({ typeName: extended, file })),
      properties: []
    });
  }
}
function isReferencedWebhookPayloadSchema(payload) {
  return payload.type != null;
}
function convertChannelPathParameters({ channel, example, typeResolver, exampleResolver, variableResolver, file, workspace }) {
  const pathParameters = [];
  const buildExamplePathParameter = ({ name, pathParameterDeclaration, examplePathParameter }) => {
    const resolvedPathParameter = resolvePathParameterOrThrow({
      parameter: pathParameterDeclaration,
      variableResolver,
      file
    });
    return {
      name,
      value: convertTypeReferenceExample({
        example: examplePathParameter,
        rawTypeBeingExemplified: resolvedPathParameter.rawType,
        typeResolver,
        exampleResolver,
        fileContainingRawTypeReference: resolvedPathParameter.file,
        fileContainingExample: file,
        workspace
      })
    };
  };
  if (example["path-parameters"] != null) {
    const rawEndpointPathParameters = getEndpointPathParameters(channel);
    for (const [key, examplePathParameter] of Object.entries(example["path-parameters"])) {
      const pathParameterDeclaration = rawEndpointPathParameters[key];
      if (pathParameterDeclaration != null) {
        pathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration,
          examplePathParameter
        }));
      } else {
        throw new Error(`Path parameter ${key} does not exist`);
      }
    }
  }
  return { pathParameters };
}
function convertHeaders2({ channel, example, typeResolver, exampleResolver, file, workspace }) {
  const headers = [];
  if (example.headers != null) {
    for (const [wireKey, exampleHeader] of Object.entries(example.headers)) {
      const headerDeclaration = channel.headers?.[wireKey];
      if (headerDeclaration != null) {
        headers.push({
          name: file.casingsGenerator.generateNameAndWireValue({
            name: getHeaderName2({ headerKey: wireKey, header: headerDeclaration }).name,
            wireValue: wireKey
          }),
          value: convertTypeReferenceExample({
            example: exampleHeader,
            rawTypeBeingExemplified: typeof headerDeclaration === "string" ? headerDeclaration : headerDeclaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: file,
            fileContainingExample: file,
            workspace
          })
        });
      } else {
        throw new Error(`Heder ${wireKey} does not exist`);
      }
    }
  }
  return { headers };
}
function buildUrl2({ channel, example, pathParams }) {
  let url = channel.path;
  if (example["path-parameters"] != null) {
    for (const parameter of [...pathParams.pathParameters]) {
      url = url.replaceAll(`{${parameter.name.originalName}}`, `${parameter.value.jsonExample}`);
    }
  }
  return url;
}
function isInlineMessageBody(messageBody) {
  if (typeof messageBody === "string") {
    return false;
  }
  return messageBody.extends != null || messageBody.properties != null;
}

// ../../cli/generation/ir-generator/lib/converters/convertEnvironments.js
function convertEnvironments({ rawApiFileSchema: { "default-environment": defaultEnvironment, environments }, casingsGenerator }) {
  if (environments == null) {
    return void 0;
  }
  const firstEnvironment = Object.values(environments)[0];
  if (firstEnvironment == null) {
    return void 0;
  }
  return {
    defaultEnvironment: defaultEnvironment ?? void 0,
    environments: visitRawEnvironmentDeclaration(firstEnvironment, {
      singleBaseUrl: () => Environments.singleBaseUrl(convertSingleBaseUrlEnvironments({ environments, casingsGenerator })),
      multipleBaseUrls: (firstMultipleBaseUrlsEnvironment) => Environments.multipleBaseUrls(convertMultipleBaseUrlEnvironments({
        baseUrls: Object.keys(firstMultipleBaseUrlsEnvironment.urls),
        environments,
        casingsGenerator
      }))
    })
  };
}
function convertSingleBaseUrlEnvironments({ environments, casingsGenerator }) {
  return {
    environments: Object.entries(environments).map(([environmentName, rawEnvironment]) => visitRawEnvironmentDeclaration(rawEnvironment, {
      singleBaseUrl: (singleBaseUrlEnvironment) => ({
        docs: typeof singleBaseUrlEnvironment === "string" ? void 0 : singleBaseUrlEnvironment.docs,
        id: environmentName,
        name: casingsGenerator.generateName(environmentName),
        url: removeTrailingSlash(typeof singleBaseUrlEnvironment === "string" ? singleBaseUrlEnvironment : singleBaseUrlEnvironment.url)
      }),
      multipleBaseUrls: () => {
        throw new Error(`Environment ${environmentName} has multiple base URLs`);
      }
    }))
  };
}
function convertMultipleBaseUrlEnvironments({ baseUrls, environments, casingsGenerator }) {
  return {
    baseUrls: baseUrls.map((baseUrl) => ({
      id: baseUrl,
      name: casingsGenerator.generateName(baseUrl)
    })),
    environments: Object.entries(environments).map(([environmentName, rawEnvironment]) => visitRawEnvironmentDeclaration(rawEnvironment, {
      multipleBaseUrls: (multipleBaseUrlsEnvironment) => ({
        docs: multipleBaseUrlsEnvironment.docs,
        id: environmentName,
        name: casingsGenerator.generateName(environmentName),
        urls: mapValues_default(multipleBaseUrlsEnvironment.urls, (url) => removeTrailingSlash(url))
      }),
      singleBaseUrl: () => {
        throw new Error(`Environment ${environmentName} does not have multiple base URLs`);
      }
    }))
  };
}
function removeTrailingSlash(url) {
  return url.endsWith("/") ? url.slice(0, -1) : url;
}

// ../../cli/generation/ir-generator/lib/converters/convertErrorDeclaration.js
function convertErrorDeclaration({ errorName, errorDeclaration, file, typeResolver, exampleResolver, workspace }) {
  const examples = [];
  if (errorDeclaration.type != null && errorDeclaration.examples != null) {
    for (const example of errorDeclaration.examples) {
      examples.push({
        name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
        docs: example.docs,
        jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({
          example: example.value,
          file
        }).resolvedExample,
        shape: convertTypeReferenceExample({
          example: example.value,
          rawTypeBeingExemplified: errorDeclaration.type,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          typeResolver,
          exampleResolver,
          workspace
        })
      });
    }
  }
  return {
    name: parseErrorName({
      errorName,
      file
    }),
    discriminantValue: file.casingsGenerator.generateNameAndWireValue({
      wireValue: errorName,
      name: errorName
    }),
    docs: typeof errorDeclaration !== "string" ? errorDeclaration.docs : void 0,
    statusCode: errorDeclaration["status-code"],
    type: errorDeclaration.type != null ? file.parseTypeReference(errorDeclaration.type) : void 0,
    examples
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertErrorDiscriminationStrategy.js
var ERROR_CONTENT_PROPERTY_NAME = "content";
function convertErrorDiscriminationStrategy(rawStrategy, file) {
  if (rawStrategy == null || rawStrategy.strategy === "status-code") {
    return ErrorDiscriminationStrategy.statusCode();
  }
  switch (rawStrategy.strategy) {
    case "property":
      return ErrorDiscriminationStrategy.property({
        discriminant: file.casingsGenerator.generateNameAndWireValue({
          name: rawStrategy["property-name"],
          wireValue: rawStrategy["property-name"]
        }),
        contentProperty: file.casingsGenerator.generateNameAndWireValue({
          name: ERROR_CONTENT_PROPERTY_NAME,
          wireValue: ERROR_CONTENT_PROPERTY_NAME
        })
      });
    default:
      assertNever(rawStrategy);
  }
}

// ../../cli/generation/ir-generator/lib/converters/convertReadmeConfig.js
function convertReadmeConfig({ readme, services }) {
  const readmeEndpointCache = new ReadmeEndpointCache(services);
  return {
    apiReferenceLink: readme.apiReferenceLink,
    bannerLink: readme.bannerLink,
    introduction: readme.introduction,
    defaultEndpoint: readme.defaultEndpoint != null ? readmeEndpointCache.getEndpointForReadmeOrThrow(readme.defaultEndpoint).id : void 0,
    features: readme.features != null ? Object.fromEntries(Object.entries(readme.features).map(([featureId, endpoints]) => {
      return [
        featureId,
        endpoints.map((endpoint) => readmeEndpointCache.getEndpointForReadmeOrThrow(endpoint).id)
      ];
    })) : void 0
  };
}
var ReadmeEndpointCache = class {
  endpoints = {};
  constructor(services) {
    this.endpoints = this.buildEndpoints(services);
  }
  getEndpointForReadme(readmeEndpoint) {
    const readmeEndpointObject = getReadmeEndpointObject({ endpoint: readmeEndpoint });
    const endpointKey = this.getEndpointKeyForReadmeEndpoint(readmeEndpointObject);
    return this.endpoints[endpointKey];
  }
  getEndpointForReadmeOrThrow(readmeEndpoint) {
    const endpoint = this.getEndpointForReadme(readmeEndpoint);
    if (endpoint == null) {
      throw new Error(`Endpoint not found for ${JSON.stringify(readmeEndpoint)}`);
    }
    return endpoint;
  }
  buildEndpoints(services) {
    const endpoints = {};
    for (const service of Object.values(services)) {
      for (const endpoint of service.endpoints) {
        endpoints[this.getEndpointKeyForHttpEndpoint(endpoint)] = endpoint;
      }
    }
    return endpoints;
  }
  getEndpointKeyForReadmeEndpoint(endpoint) {
    return this.getEndpointKey({
      method: endpoint.method,
      path: endpoint.path,
      stream: endpoint.stream ?? false
    });
  }
  getEndpointKeyForHttpEndpoint(endpoint) {
    return this.getEndpointKey({
      method: endpoint.method,
      path: getFullPathForEndpoint(endpoint),
      stream: endpoint.response?.body?.type === "streaming"
    });
  }
  getEndpointKey({ method, path: path5, stream }) {
    return `${method}|${path5}|${stream}`;
  }
};
function getFullPathForEndpoint(endpoint) {
  let url = "";
  if (endpoint.fullPath.head.length > 0) {
    url = urlJoin(url, endpoint.fullPath.head);
  }
  for (const part of endpoint.fullPath.parts) {
    url = urlJoin(url, "{" + part.pathParameter + "}");
    if (part.tail.length > 0) {
      url = urlJoin(url, part.tail);
    }
  }
  return url.startsWith("/") ? url : `/${url}`;
}
function getReadmeEndpointObject({ endpoint }) {
  if (typeof endpoint === "string") {
    const split = endpoint.split(" ");
    if (split.length !== 2 || split[0] == null || split[1] == null) {
      throw new Error(`invalid endpoint string: ${endpoint}`);
    }
    return {
      method: split[0],
      path: split[1]
    };
  }
  return endpoint;
}

// ../../cli/generation/ir-generator/lib/converters/convertWebhookGroup.js
async function convertWebhookGroup({ webhooks, file, typeResolver, exampleResolver, workspace }) {
  const webhookGroup = [];
  for (const [webhookId, webhook] of Object.entries(webhooks)) {
    webhookGroup.push({
      id: IdGenerator.generateWebhookId(file.fernFilepath, webhookId),
      availability: convertAvailability(webhook.availability),
      displayName: webhook["display-name"],
      docs: webhook.docs,
      method: webhook.method,
      name: file.casingsGenerator.generateName(webhookId),
      headers: webhook.headers != null ? await Promise.all(Object.entries(webhook.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
      payload: convertWebhookPayloadSchema({ payload: webhook.payload, file }),
      examples: webhook.examples != null ? convertWebhookExamples2({
        webhook,
        examples: webhook.examples,
        file,
        typeResolver,
        exampleResolver,
        workspace
      }) : void 0
    });
  }
  return webhookGroup;
}
function convertWebhookPayloadSchema({ payload, file }) {
  if (typeof payload === "string") {
    return WebhookPayload.reference({
      docs: void 0,
      payloadType: file.parseTypeReference(payload)
    });
  } else if (isReferencedWebhookPayloadSchema2(payload)) {
    return WebhookPayload.reference({
      docs: void 0,
      payloadType: file.parseTypeReference(payload.type)
    });
  } else {
    return WebhookPayload.inlinedPayload({
      name: file.casingsGenerator.generateName(payload.name),
      extends: getExtensionsAsList(payload.extends).map((extended) => parseTypeName({ typeName: extended, file })),
      properties: payload.properties != null ? Object.entries(payload.properties).map(([propertyKey, propertyDefinition]) => convertInlinedRequestProperty2({
        propertyKey,
        propertyDefinition,
        docs: typeof propertyDefinition !== "string" ? propertyDefinition.docs : void 0,
        availability: typeof propertyDefinition !== "string" ? convertAvailability(propertyDefinition.availability) : void 0,
        file
      })) : []
    });
  }
}
function convertInlinedRequestProperty2({ propertyKey, propertyDefinition, docs, availability, file }) {
  return {
    docs,
    availability,
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: propertyKey,
      name: getPropertyName({ propertyKey, property: propertyDefinition }).name
    }),
    valueType: file.parseTypeReference(propertyDefinition)
  };
}
function convertWebhookExamples2({ webhook, examples, file, typeResolver, exampleResolver, workspace }) {
  const typeName = typeof webhook.payload === "string" ? webhook.payload : isReferencedWebhookPayloadSchema2(webhook.payload) ? webhook.payload.type : void 0;
  if (typeName != null) {
    return examples.map((example) => ({
      docs: webhook.docs,
      name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
      payload: convertTypeReferenceExample({
        example: example.payload,
        rawTypeBeingExemplified: typeName,
        fileContainingRawTypeReference: file,
        fileContainingExample: file,
        typeResolver,
        exampleResolver,
        workspace
      })
    }));
  }
  if (!isPlainObject2(webhook.payload)) {
    throw new Error(`Example webhook payload is not an object. Got: ${JSON.stringify(webhook.payload)}`);
  }
  return examples.map((example) => ({
    docs: webhook.docs,
    name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
    payload: convertTypeReferenceExample({
      example: example.payload,
      rawTypeBeingExemplified: "map<string, unknown>",
      fileContainingRawTypeReference: file,
      fileContainingExample: file,
      typeResolver,
      exampleResolver,
      workspace
    })
  }));
}
function isReferencedWebhookPayloadSchema2(payload) {
  return payload.type != null;
}

// ../../cli/generation/ir-generator/lib/utils/getPropertiesByAudience.js
function getPropertiesByAudience(properties) {
  const propertiesByAudience = {};
  for (const [property4, propertyDeclaration] of Object.entries(properties)) {
    if (typeof propertyDeclaration === "string") {
      continue;
    }
    for (const audience of propertyDeclaration.audiences ?? []) {
      if (propertiesByAudience[audience] == null) {
        propertiesByAudience[audience] = /* @__PURE__ */ new Set();
      }
      propertiesByAudience[audience]?.add(property4);
    }
  }
  return propertiesByAudience;
}

// ../../cli/generation/ir-generator/lib/converters/convertProtobufType.js
function convertSourceToProtobufType({ name, source }) {
  return ProtobufType.userDefined({
    file: convertProtobufFile({ source }),
    // Use the global casings generator so that the name is not
    // affected by the user's casing settings (e.g. smart-casing).
    name: CASINGS_GENERATOR.generateName(name)
  });
}
function maybeConvertEncodingToProtobufType({ encoding }) {
  if (encoding.proto != null && encoding.proto.type != null) {
    const wellKnownType = maybeConvertWellKnownProtobufType({ type: encoding.proto.type });
    if (wellKnownType != null) {
      return wellKnownType;
    }
  }
  return void 0;
}
function maybeConvertWellKnownProtobufType({ type: type2 }) {
  switch (type2) {
    case "google.protobuf.Any":
      return ProtobufType.wellKnown(WellKnownProtobufType.any());
    case "google.protobuf.Api":
      return ProtobufType.wellKnown(WellKnownProtobufType.api());
    case "google.protobuf.BoolValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.boolValue());
    case "google.protobuf.BytesValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.bytesValue());
    case "google.protobuf.DoubleValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.doubleValue());
    case "google.protobuf.Duration":
      return ProtobufType.wellKnown(WellKnownProtobufType.duration());
    case "google.protobuf.Empty":
      return ProtobufType.wellKnown(WellKnownProtobufType.empty());
    case "google.protobuf.Enum":
      return ProtobufType.wellKnown(WellKnownProtobufType.enum());
    case "google.protobuf.EnumValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.enumValue());
    case "google.protobuf.Field":
      return ProtobufType.wellKnown(WellKnownProtobufType.field());
    case "google.protobuf.FieldCardinality":
      return ProtobufType.wellKnown(WellKnownProtobufType.fieldCardinality());
    case "google.protobuf.FieldKind":
      return ProtobufType.wellKnown(WellKnownProtobufType.fieldKind());
    case "google.protobuf.FieldMask":
      return ProtobufType.wellKnown(WellKnownProtobufType.fieldMask());
    case "google.protobuf.FloatVlaue":
      return ProtobufType.wellKnown(WellKnownProtobufType.floatValue());
    case "google.protobuf.Int32Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.int32Value());
    case "google.protobuf.Int64Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.int64Value());
    case "google.protobuf.ListValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.listValue());
    case "google.protobuf.Method":
      return ProtobufType.wellKnown(WellKnownProtobufType.method());
    case "google.protobuf.Mixin":
      return ProtobufType.wellKnown(WellKnownProtobufType.mixin());
    case "google.protobuf.NullValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.nullValue());
    case "google.protobuf.Option":
      return ProtobufType.wellKnown(WellKnownProtobufType.option());
    case "google.protobuf.SourceContext":
      return ProtobufType.wellKnown(WellKnownProtobufType.sourceContext());
    case "google.protobuf.StringValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.stringValue());
    case "google.protobuf.Struct":
      return ProtobufType.wellKnown(WellKnownProtobufType.struct());
    case "google.protobuf.Syntax":
      return ProtobufType.wellKnown(WellKnownProtobufType.syntax());
    case "google.protobuf.Timestamp":
      return ProtobufType.wellKnown(WellKnownProtobufType.timestamp());
    case "google.protobuf.Type":
      return ProtobufType.wellKnown(WellKnownProtobufType.type());
    case "google.protobuf.Uint32Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.uint32Value());
    case "google.protobuf.Uint64Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.uint64Value());
    case "google.protobuf.Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.value());
  }
  return void 0;
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertGenericTypeDeclaration.js
async function convertGenericTypeDeclaration({ generic, file, typeResolver }) {
  const genericInstantiation = typeof generic === "string" ? generic : generic.type;
  const maybeGeneric = parseGeneric(genericInstantiation);
  if (maybeGeneric == null) {
    throw new Error(`Invalid generic type definition: ${genericInstantiation}`);
  }
  const resolvedBaseGeneric = typeResolver.getDeclarationOfNamedTypeOrThrow({
    referenceToNamedType: genericInstantiation,
    file
  });
  if (maybeGeneric.arguments && isRawObjectDefinition(resolvedBaseGeneric.declaration)) {
    const genericArgumentDefinitions = parseGeneric(resolvedBaseGeneric.typeName)?.arguments ?? [];
    const newProperties = Object.entries(resolvedBaseGeneric.declaration.properties ?? {}).map(([key, value]) => {
      let maybeReplacedValue = value;
      if (typeof value === "string" && genericArgumentDefinitions?.includes(value)) {
        maybeReplacedValue = maybeGeneric.arguments?.[genericArgumentDefinitions.indexOf(value)] ?? value;
      }
      return [key, maybeReplacedValue];
    });
    return Type.object({
      extends: getExtensionsAsList(resolvedBaseGeneric.declaration.extends).map((extended) => parseTypeName({ typeName: extended, file })),
      properties: await getObjectPropertiesFromRawObjectSchema({ properties: Object.fromEntries(newProperties) }, file),
      extraProperties: resolvedBaseGeneric.declaration["extra-properties"] ?? false,
      extendedProperties: void 0
    });
  }
  throw new Error(`Generic type definition not supported: ${genericInstantiation}`);
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertAliasTypeDeclaration.js
async function convertAliasTypeDeclaration({ alias, file, typeResolver }) {
  const aliasOfStr = typeof alias === "string" ? alias : alias.type;
  if (isGeneric(aliasOfStr)) {
    return await convertGenericTypeDeclaration({ generic: aliasOfStr, file, typeResolver });
  }
  return Type.alias({
    aliasOf: file.parseTypeReference(alias),
    resolvedType: constructResolvedTypeReference({ aliasOf: aliasOfStr, file, typeResolver })
  });
}
function constructResolvedTypeReference({ aliasOf, file, typeResolver }) {
  const resolvedType = typeResolver.resolveTypeOrThrow({ type: aliasOf, file });
  switch (resolvedType._type) {
    case "primitive":
      return ResolvedTypeReference.primitive(resolvedType.originalTypeReference.primitive);
    case "container":
      return ResolvedTypeReference.container(resolvedType.originalTypeReference.container);
    case "unknown":
      return ResolvedTypeReference.unknown();
    case "named": {
      const shapeType = isRawObjectDefinition(resolvedType.declaration) ? ShapeType.Object : isRawDiscriminatedUnionDefinition(resolvedType.declaration) ? ShapeType.Union : isRawEnumDefinition(resolvedType.declaration) ? ShapeType.Enum : isRawUndiscriminatedUnionDefinition(resolvedType.declaration) ? ShapeType.UndiscriminatedUnion : assertNever(resolvedType.declaration);
      return ResolvedTypeReference.named({
        name: resolvedType.name,
        shape: shapeType
      });
    }
  }
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertUndiscriminatedUnionTypeDeclaration.js
function convertUndiscriminatedUnionTypeDeclaration({ union: union3, file }) {
  return Type.undiscriminatedUnion({
    members: union3.union.map((unionMember) => {
      if (typeof unionMember === "string") {
        return {
          docs: void 0,
          type: file.parseTypeReference(unionMember)
        };
      }
      return {
        type: file.parseTypeReference(unionMember),
        docs: unionMember.docs
      };
    })
  });
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/getReferencedTypesFromRawDeclaration.js
function getObjectRawTypeReferences(objectDeclaration) {
  const types2 = [];
  if (objectDeclaration.extends != null) {
    const extendsArr = typeof objectDeclaration.extends === "string" ? [objectDeclaration.extends] : objectDeclaration.extends;
    types2.push(...extendsArr);
  }
  if (objectDeclaration.properties != null) {
    types2.push(...Object.values(objectDeclaration.properties).map((property4) => typeof property4 === "string" ? property4 : property4.type));
  }
  return types2;
}
function getReferencedTypesFromRawDeclaration({ typeDeclaration, file, typeResolver, seenTypeNames = new SeenTypeNamesImpl() }) {
  const rawTypeReferences = visitRawTypeDeclaration(typeDeclaration, {
    alias: (aliasDeclaration) => {
      const aliasTypeReference = typeof aliasDeclaration === "string" ? aliasDeclaration : aliasDeclaration.type;
      const parsedGeneric = parseGeneric(aliasTypeReference);
      if (parsedGeneric != null) {
        const rawTypeReferences2 = new Set(parsedGeneric.arguments ?? []);
        const resolvedBaseGeneric = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: aliasTypeReference,
          file
        });
        const resolvedBaseGenericArguments = parseGeneric(resolvedBaseGeneric.typeName)?.arguments;
        if (isRawObjectDefinition(resolvedBaseGeneric.declaration)) {
          const underlyingObjectRawTypeReferences = getObjectRawTypeReferences(resolvedBaseGeneric.declaration);
          if (resolvedBaseGenericArguments) {
            underlyingObjectRawTypeReferences.filter((typeReference) => !resolvedBaseGenericArguments.includes(typeReference)).forEach((type2) => rawTypeReferences2.add(type2));
          }
        }
        return Array.from(rawTypeReferences2);
      }
      return [aliasTypeReference];
    },
    object: (objectDeclaration) => getObjectRawTypeReferences(objectDeclaration),
    discriminatedUnion: (unionDeclaration) => {
      const types2 = [];
      if (unionDeclaration["base-properties"] != null) {
        types2.push(...Object.values(unionDeclaration["base-properties"]).map((property4) => typeof property4 === "string" ? property4 : property4.type));
      }
      types2.push(...Object.values(unionDeclaration.union).reduce((types3, singleUnionType) => {
        const rawType = typeof singleUnionType === "string" ? singleUnionType : singleUnionType.type;
        if (typeof rawType === "string") {
          types3.push(rawType);
        }
        return types3;
      }, []));
      return types2;
    },
    undiscriminatedUnion: (unionDeclaration) => {
      return Object.values(unionDeclaration.union).reduce((types2, unionMember) => {
        const rawType = typeof unionMember === "string" ? unionMember : unionMember.type;
        if (typeof rawType === "string") {
          types2.push(rawType);
        }
        return types2;
      }, []);
    },
    enum: () => []
  });
  const referencedTypes = [];
  for (const rawTypeReference of rawTypeReferences) {
    const rawNames = recursivelyVisitRawTypeReference({
      type: rawTypeReference,
      _default: void 0,
      validation: void 0,
      visitor: {
        primitive: () => [],
        map: ({ keyType, valueType }) => [...keyType, ...valueType],
        list: (valueType) => valueType,
        optional: (valueType) => valueType,
        set: (valueType) => valueType,
        named: (name) => [name],
        literal: () => [],
        unknown: () => []
      }
    });
    for (const rawName of rawNames) {
      const parsedTypeName = parseTypeName({ typeName: rawName, file });
      if (!seenTypeNames.hasTypeNameBeenSeen(parsedTypeName)) {
        seenTypeNames.addTypeName(parsedTypeName);
        referencedTypes.push(parsedTypeName);
        const maybeDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: rawName,
          file
        });
        if (isGeneric(maybeDeclaration.typeName)) {
          continue;
        }
        referencedTypes.push(...getReferencedTypesFromRawDeclaration({
          typeDeclaration: maybeDeclaration.declaration,
          file: maybeDeclaration.file,
          typeResolver,
          seenTypeNames
        }));
      }
    }
  }
  return referencedTypes;
}
var SeenTypeNamesImpl = class {
  cache = /* @__PURE__ */ new Set();
  addTypeName(typeName) {
    this.cache.add(this.computeCacheKey(typeName));
  }
  hasTypeNameBeenSeen(typeName) {
    return this.cache.has(this.computeCacheKey(typeName));
  }
  computeCacheKey(typeName) {
    return typeName.fernFilepath.allParts.map((part) => part.originalName).join("/") + ":" + typeName.name.originalName;
  }
};

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertTypeDeclaration.js
async function convertTypeDeclaration({ typeName, typeDeclaration, file, typeResolver, exampleResolver, sourceResolver, workspace }) {
  const declaration = await convertDeclaration(typeDeclaration);
  const declaredTypeName = parseTypeName({
    typeName,
    file
  });
  const referencedTypes = getReferencedTypesFromRawDeclaration({ typeDeclaration, file, typeResolver });
  let propertiesByAudience = {};
  if (isRawObjectDefinition(typeDeclaration)) {
    propertiesByAudience = getPropertiesByAudience(typeDeclaration.properties ?? {});
  }
  const source = await convertTypeDeclarationSource({
    file,
    typeDeclaration,
    typeName,
    sourceResolver
  });
  return {
    propertiesByAudience,
    typeDeclaration: {
      ...declaration,
      inline: getInline2(typeDeclaration),
      name: declaredTypeName,
      shape: await convertType({ typeDeclaration, file, typeResolver }),
      referencedTypes: new Set(referencedTypes.map((referencedType) => referencedType.typeId)),
      encoding: convertTypeDeclarationEncoding({ typeDeclaration, source }),
      source,
      userProvidedExamples: typeof typeDeclaration !== "string" && typeDeclaration.examples != null ? typeDeclaration.examples.map((example) => ({
        name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
        docs: example.docs,
        jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({
          example: example.value,
          file
        }).resolvedExample,
        shape: convertTypeExample({
          typeName: declaredTypeName,
          example: example.value,
          typeResolver,
          exampleResolver,
          typeDeclaration,
          fileContainingType: file,
          fileContainingExample: file,
          workspace
        })
      })) : [],
      autogeneratedExamples: []
    },
    descendantFilepaths: new Set(referencedTypes.map((referencedType) => referencedType.fernFilepath))
  };
}
async function convertType({ typeDeclaration, file, typeResolver }) {
  return await visitRawTypeDeclaration(typeDeclaration, {
    alias: (alias) => convertAliasTypeDeclaration({ alias, file, typeResolver }),
    object: (object3) => convertObjectTypeDeclaration({ object: object3, file }),
    discriminatedUnion: (union3) => convertDiscriminatedUnionTypeDeclaration({ union: union3, file, typeResolver }),
    undiscriminatedUnion: (union3) => convertUndiscriminatedUnionTypeDeclaration({ union: union3, file }),
    enum: async (enum_3) => Type.enum(await convertEnumTypeDeclaration({ _enum: enum_3, file }))
  });
}
async function convertTypeDeclarationSource({ file, typeDeclaration, typeName, sourceResolver }) {
  if (typeof typeDeclaration === "string" || typeDeclaration.source == null && typeDeclaration.encoding == null) {
    return void 0;
  }
  if (typeDeclaration.encoding != null) {
    const maybeProtobufType = maybeConvertEncodingToProtobufType({
      encoding: typeDeclaration.encoding
    });
    if (maybeProtobufType != null) {
      return Source.proto(maybeProtobufType);
    }
  }
  if (typeDeclaration.source == null) {
    return void 0;
  }
  const resolvedSource = await sourceResolver.resolveSourceOrThrow({
    source: typeDeclaration.source,
    relativeFilepath: file.relativeFilepath
  });
  if (resolvedSource == null || resolvedSource.type !== "protobuf") {
    return void 0;
  }
  return Source.proto(convertSourceToProtobufType({
    source: resolvedSource,
    name: typeName
  }));
}
function convertTypeDeclarationEncoding({ typeDeclaration, source }) {
  if (typeof typeDeclaration !== "string" && typeDeclaration.encoding != null) {
    return convertEncoding2(typeDeclaration.encoding);
  }
  return convertSourceToEncoding(source);
}
function convertEncoding2(encodingSchema) {
  return encodingSchema.proto != null ? {
    json: void 0,
    proto: {}
  } : {
    json: {},
    proto: void 0
  };
}
function convertSourceToEncoding(source) {
  return source != null && source.type === "proto" ? {
    json: void 0,
    proto: {}
  } : {
    json: {},
    proto: void 0
  };
}
function getInline2(typeDeclaration) {
  if (typeof typeDeclaration === "string") {
    return void 0;
  }
  if ("inline" in typeDeclaration) {
    return typeDeclaration.inline;
  }
  return void 0;
}

// ../../cli/task-context/lib/LoggableFernCliError.js
var LoggableFernCliError = class _LoggableFernCliError extends Error {
  log;
  constructor(log) {
    super();
    this.log = log;
    Object.setPrototypeOf(this, _LoggableFernCliError.prototype);
  }
};

// ../../cli/generation/ir-generator/lib/utils/getTypeDeclaration.js
function getTypeDeclaration(typeId, types2) {
  const maybeTypeDeclaration = types2[typeId];
  if (maybeTypeDeclaration == null) {
    throw new LoggableFernCliError(`Illegal Error: Failed to load type declaration for type ${typeId}`);
  }
  return maybeTypeDeclaration;
}

// ../../cli/generation/ir-generator/lib/extended-properties/addExtendedPropertiesToIr.js
function addExtendedPropertiesToIr(ir) {
  return {
    types: Object.fromEntries(Object.entries(ir.types).map(([typeId, typeDeclaration]) => {
      return [typeId, addExtendedPropertiesToType({ typeDeclaration, ir })];
    })),
    services: Object.fromEntries(Object.entries(ir.services).map(([serviceId, serviceDeclration]) => {
      return [
        serviceId,
        {
          ...serviceDeclration,
          endpoints: serviceDeclration.endpoints.map((endpoint) => {
            return addExtendedPropertiesToEndpoint({ endpoint, ir });
          })
        }
      ];
    }))
  };
}
function addExtendedPropertiesToEndpoint({ endpoint, ir }) {
  if (endpoint.requestBody?.type !== "inlinedRequestBody") {
    return endpoint;
  }
  return {
    ...endpoint,
    requestBody: {
      ...endpoint.requestBody,
      extendedProperties: endpoint.requestBody.extends.flatMap((extended) => getExtendedPropertiesForDeclaredTypeName(extended, ir))
    }
  };
}
function addExtendedPropertiesToType({ typeDeclaration, ir }) {
  switch (typeDeclaration.shape.type) {
    case "object":
      return {
        ...typeDeclaration,
        shape: {
          ...typeDeclaration.shape,
          extendedProperties: typeDeclaration.shape.extends.flatMap((extended) => getExtendedPropertiesForDeclaredTypeName(extended, ir))
        }
      };
  }
  return typeDeclaration;
}
function getExtendedPropertiesForDeclaredTypeName(declaredTypeName, ir) {
  const objectTypeDeclaration = getObjectTypeDeclarationFromTypeId(declaredTypeName.typeId, ir);
  return getAllPropertiesForObject2({ objectTypeDeclaration, ir });
}
function getObjectTypeDeclarationFromTypeId(typeId, ir) {
  const typeDeclaration = getTypeDeclaration(typeId, ir.types);
  switch (typeDeclaration.shape.type) {
    case "object":
      return typeDeclaration.shape;
    case "alias": {
      if (typeDeclaration.shape.resolvedType.type === "named") {
        return getObjectTypeDeclarationFromTypeId(typeDeclaration.shape.resolvedType.name.typeId, ir);
      }
    }
  }
  throw new LoggableFernCliError(`Unexpected error: ${typeId} is extended but has shape ${typeDeclaration.shape.type}`);
}
function getAllPropertiesForObject2({ objectTypeDeclaration, ir }) {
  const extendedProperties = objectTypeDeclaration.extends.flatMap((extended) => {
    const extendedObjectDeclaration = getObjectTypeDeclarationFromTypeId(extended.typeId, ir);
    return getAllPropertiesForObject2({ objectTypeDeclaration: extendedObjectDeclaration, ir });
  });
  return [...objectTypeDeclaration.properties, ...extendedProperties];
}

// ../../cli/generation/ir-generator/lib/filtered-ir/FilteredIr.js
var FilteredIrImpl = class {
  environments = /* @__PURE__ */ new Set();
  types = /* @__PURE__ */ new Set();
  properties;
  errors = /* @__PURE__ */ new Set();
  services = /* @__PURE__ */ new Set();
  endpoints = /* @__PURE__ */ new Set();
  requestProperties;
  queryParameters;
  webhooks = /* @__PURE__ */ new Set();
  webhookPayloadProperties;
  subpackages = /* @__PURE__ */ new Set();
  constructor({ types: types2, properties, errors, environments, services, endpoints, webhooks, subpackages, queryParameters, requestProperties, webhookPayloadProperties }) {
    this.environments = environments;
    this.types = types2;
    this.properties = properties;
    this.errors = errors;
    this.services = services;
    this.endpoints = endpoints;
    this.webhooks = webhooks;
    this.webhookPayloadProperties = webhookPayloadProperties;
    this.subpackages = subpackages;
    this.requestProperties = requestProperties;
    this.queryParameters = queryParameters;
  }
  hasTypeId(typeId) {
    return this.types.has(typeId);
  }
  hasErrorId(errorId) {
    return this.errors.has(errorId);
  }
  hasServiceId(serviceId) {
    return this.services.has(serviceId);
  }
  hasSubpackageId(subpackageId) {
    return this.subpackages.has(subpackageId);
  }
  hasType(type2) {
    const typeId = IdGenerator.generateTypeId(type2.name);
    return this.types.has(typeId);
  }
  hasProperty(typeId, property4) {
    const properties = this.properties[typeId];
    if (properties == null) {
      return true;
    }
    return properties.has(property4);
  }
  hasError(error) {
    const errorId = IdGenerator.generateErrorId(error.name);
    return this.errors.has(errorId);
  }
  hasService(service) {
    const serviceId = IdGenerator.generateServiceId(service.name);
    return this.services.has(serviceId);
  }
  hasEnvironmentId(environmentId) {
    return this.environments.has(environmentId);
  }
  hasEndpoint(endpoint) {
    return this.endpoints.has(endpoint.id);
  }
  hasRequestProperty(endpoint, property4) {
    const properties = this.requestProperties[endpoint];
    if (properties == null) {
      return true;
    }
    return properties.has(property4);
  }
  hasQueryParameter(endpoint, parameter) {
    const parameters = this.queryParameters[endpoint];
    if (parameters == null) {
      return true;
    }
    return parameters.has(parameter);
  }
  hasSubpackage(subpackageId) {
    return this.subpackages.has(subpackageId);
  }
  hasWebhook(webhook) {
    if (webhook.id) {
      return this.webhooks.has(webhook.id);
    }
    return true;
  }
  hasWebhookPayloadProperty(webhookId, property4) {
    const properties = this.webhookPayloadProperties[webhookId];
    if (properties == null) {
      return true;
    }
    return properties.has(property4);
  }
};

// ../../cli/generation/ir-generator/lib/filtered-ir/IrGraph.js
var IrGraph = class {
  types = {};
  properties = {};
  queryParameters = {};
  requestProperties = {};
  webhookProperties = {};
  errors = {};
  endpoints = {};
  webhooks = {};
  audiences;
  typesReferencedByService = {};
  environmentsNeededForAudience = /* @__PURE__ */ new Set();
  typesNeededForAudience = /* @__PURE__ */ new Set();
  servicesNeededForAudience = /* @__PURE__ */ new Set();
  endpointsNeededForAudience = /* @__PURE__ */ new Set();
  webhooksNeededForAudience = /* @__PURE__ */ new Set();
  subpackagesNeededForAudience = /* @__PURE__ */ new Set();
  constructor(audiences) {
    this.audiences = audiencesFromConfig(audiences);
  }
  addType({ declaredTypeName, descendantTypeIds, descendantFilepaths, descendantTypeIdsByAudience, propertiesByAudience }) {
    const typeId = IdGenerator.generateTypeId(declaredTypeName);
    const typeNode = {
      typeId,
      allDescendants: descendantTypeIds,
      descendantsByAudience: descendantTypeIdsByAudience,
      referencedSubpackages: descendantFilepaths
    };
    this.types[typeId] = typeNode;
    if (this.typesReferencedByService[typeId] == null) {
      this.typesReferencedByService[typeId] = /* @__PURE__ */ new Set();
    }
    this.properties[typeId] = {
      typeId,
      propertiesByAudience
    };
  }
  markTypeForAudiences(declaredTypeName, audiences) {
    const typeId = IdGenerator.generateTypeId(declaredTypeName);
    if (this.hasAudience(audiences)) {
      this.typesNeededForAudience.add(typeId);
      this.addSubpackages(declaredTypeName.fernFilepath);
      this.types[typeId]?.referencedSubpackages.forEach((fernFilePath) => {
        this.addSubpackages(fernFilePath);
      });
    }
  }
  markEnvironmentForAudiences(environment, audiences, ignoreAudiences) {
    if (environment) {
      if (this.hasAudience(audiences) || ignoreAudiences) {
        this.environmentsNeededForAudience.add(environment.id);
      }
    }
  }
  getTypesReferencedByService() {
    for (const endpoint of Object.values(this.endpoints)) {
      for (const typeId of endpoint.referencedTypes) {
        this.markTypeForService(typeId, endpoint.serviceId);
      }
    }
    return this.typesReferencedByService;
  }
  addError(errorDeclaration) {
    const errorId = IdGenerator.generateErrorId(errorDeclaration.name);
    const referencedTypes = /* @__PURE__ */ new Set();
    const referencedSubpackages = /* @__PURE__ */ new Set();
    if (errorDeclaration.type != null) {
      populateReferencesFromTypeReference(errorDeclaration.type, referencedTypes, referencedSubpackages);
    }
    const errorNode = {
      errorId,
      referencedTypes,
      referencedSubpackages
    };
    this.errors[errorId] = errorNode;
  }
  addEndpoint(service, httpEndpoint, rawEndpoint) {
    const serviceId = IdGenerator.generateServiceId(service.name);
    const endpointId = httpEndpoint.id;
    const referencedTypes = /* @__PURE__ */ new Set();
    const referencedErrors = /* @__PURE__ */ new Set();
    const referencedSubpackages = /* @__PURE__ */ new Set();
    for (const header of [...service.headers, ...httpEndpoint.headers]) {
      populateReferencesFromTypeReference(header.valueType, referencedTypes, referencedSubpackages);
    }
    for (const pathParameter of [...service.pathParameters, ...httpEndpoint.pathParameters]) {
      populateReferencesFromTypeReference(pathParameter.valueType, referencedTypes, referencedSubpackages);
    }
    for (const queryParameter of httpEndpoint.queryParameters) {
      populateReferencesFromTypeReference(queryParameter.valueType, referencedTypes, referencedSubpackages);
    }
    if (rawEndpoint != null && rawEndpoint.request != null && typeof rawEndpoint.request !== "string") {
      const parametersByAudience = getPropertiesByAudience(rawEndpoint.request["query-parameters"] ?? {});
      this.queryParameters[endpointId] = {
        endpointId,
        parametersByAudience
      };
    }
    if (httpEndpoint.requestBody != null) {
      HttpRequestBody._visit(httpEndpoint.requestBody, {
        inlinedRequestBody: (inlinedRequestBody) => {
          for (const extension of inlinedRequestBody.extends) {
            populateReferencesFromTypeName(extension, referencedTypes, referencedSubpackages);
          }
          for (const property4 of inlinedRequestBody.properties) {
            populateReferencesFromTypeReference(property4.valueType, referencedTypes, referencedSubpackages);
          }
          if (rawEndpoint != null && typeof rawEndpoint.request === "object" && typeof rawEndpoint.request.body === "object" && isInlineRequestBody(rawEndpoint.request.body)) {
            const propertiesByAudience = getPropertiesByAudience(rawEndpoint.request.body.properties ?? {});
            this.requestProperties[endpointId] = {
              endpointId,
              propertiesByAudience
            };
          }
        },
        reference: ({ requestBodyType }) => {
          populateReferencesFromTypeReference(requestBodyType, referencedTypes, referencedSubpackages);
        },
        fileUpload: ({ properties }) => {
          for (const property4 of properties) {
            FileUploadRequestProperty._visit(property4, {
              file: noop,
              bodyProperty: ({ valueType }) => {
                populateReferencesFromTypeReference(valueType, referencedTypes, referencedSubpackages);
              },
              _other: () => {
                throw new Error("Unknown FileUploadRequestProperty: " + property4.type);
              }
            });
          }
        },
        bytes: () => {
          return;
        },
        _other: () => {
          throw new Error("Unknown HttpRequestBody: " + httpEndpoint.requestBody?.type);
        }
      });
    }
    if (httpEndpoint.response?.body != null) {
      HttpResponseBody._visit(httpEndpoint.response.body, {
        fileDownload: noop,
        json: (jsonResponse) => {
          populateReferencesFromTypeReference(jsonResponse.responseBodyType, referencedTypes, referencedSubpackages);
        },
        streaming: (streamingResponse) => {
          streamingResponse._visit({
            sse: (sse) => populateReferencesFromTypeReference(sse.payload, referencedTypes, referencedSubpackages),
            json: (json2) => populateReferencesFromTypeReference(json2.payload, referencedTypes, referencedSubpackages),
            text: noop,
            _other: () => {
              throw new Error("Unknown streamingResponse type: " + streamingResponse.type);
            }
          });
        },
        streamParameter: (response) => {
          response.streamResponse._visit({
            sse: (sse) => populateReferencesFromTypeReference(sse.payload, referencedTypes, referencedSubpackages),
            json: (json2) => populateReferencesFromTypeReference(json2.payload, referencedTypes, referencedSubpackages),
            text: noop,
            _other: () => {
              throw new Error("Unknown streamingResponse type: " + response.streamResponse.type);
            }
          });
          if (response.nonStreamResponse.type === "json") {
            populateReferencesFromTypeReference(response.nonStreamResponse.value.responseBodyType, referencedTypes, referencedSubpackages);
          }
        },
        text: noop,
        _other: () => {
          throw new Error("Unknown HttpResponse: " + httpEndpoint.response?.body?.type);
        }
      });
    }
    httpEndpoint.errors.forEach((responseError) => {
      referencedErrors.add(IdGenerator.generateErrorId(responseError.error));
      referencedSubpackages.add(responseError.error.fernFilepath);
    });
    this.endpoints[endpointId] = {
      endpointId,
      serviceId,
      referencedTypes,
      referencedErrors,
      referencedSubpackages
    };
  }
  markEndpointForAudience(declaredServiceName, httpEndpoints, audiences) {
    if (this.hasAudience(audiences)) {
      const serviceId = IdGenerator.generateServiceId(declaredServiceName);
      this.servicesNeededForAudience.add(serviceId);
      httpEndpoints.forEach((httpEndpoint) => {
        const endpointId = httpEndpoint.id;
        this.endpointsNeededForAudience.add(endpointId);
        this.endpoints[endpointId]?.referencedSubpackages.forEach((fernFilePath) => {
          this.addSubpackages(fernFilePath);
        });
      });
      this.servicesNeededForAudience.add(serviceId);
      this.addSubpackages(declaredServiceName.fernFilepath);
    }
  }
  addWebhook(file, webhook, rawWebhook) {
    const webhookId = webhook.id;
    if (webhookId == null) {
      return;
    }
    const referencedTypes = /* @__PURE__ */ new Set();
    const referencedSubpackages = /* @__PURE__ */ new Set();
    if (webhook.payload != null) {
      WebhookPayload._visit(webhook.payload, {
        inlinedPayload: (inlinedPayload) => {
          for (const extension of inlinedPayload.extends) {
            populateReferencesFromTypeName(extension, referencedTypes, referencedSubpackages);
          }
          for (const property4 of inlinedPayload.properties) {
            populateReferencesFromTypeReference(property4.valueType, referencedTypes, referencedSubpackages);
          }
          if (rawWebhook?.payload != null && typeof rawWebhook.payload === "object" && !isReferencedWebhookPayloadSchema2(rawWebhook.payload)) {
            const propertiesByAudience = getPropertiesByAudience(rawWebhook.payload.properties ?? {});
            this.webhookProperties[webhookId] = {
              webhookId,
              propertiesByAudience
            };
          }
        },
        reference: ({ payloadType }) => {
          populateReferencesFromTypeReference(payloadType, referencedTypes, referencedSubpackages);
        },
        _other: () => {
          throw new Error("Unknown WebhookPayload: " + webhook.payload?.type);
        }
      });
    }
    referencedSubpackages.add(file.fernFilepath);
    this.webhooks[webhookId] = {
      webhookId,
      referencedTypes,
      referencedSubpackages
    };
  }
  markWebhookForAudiences(file, webhook, audiences) {
    const webhookId = webhook.id;
    if (webhookId == null) {
      return;
    }
    if (this.hasAudience(audiences)) {
      this.webhooksNeededForAudience.add(webhookId);
      this.addSubpackages(file.fernFilepath);
    }
  }
  build() {
    const typeIds = /* @__PURE__ */ new Set();
    const errorIds = /* @__PURE__ */ new Set();
    for (const endpointId of this.endpointsNeededForAudience.keys()) {
      const endpointNode = this.getEndpointNode(endpointId);
      for (const errorId of endpointNode.referencedErrors) {
        if (errorIds.has(errorId)) {
          continue;
        }
        errorIds.add(errorId);
        const errorNode = this.getErrorNode(errorId);
        this.addReferencedTypes(typeIds, errorNode.referencedTypes);
      }
      this.addReferencedTypes(typeIds, endpointNode.referencedTypes);
    }
    this.addReferencedTypes(typeIds, this.typesNeededForAudience);
    for (const webhookId of this.webhooksNeededForAudience.keys()) {
      const webhookNode = this.getWebhookNode(webhookId);
      this.addReferencedTypes(typeIds, webhookNode.referencedTypes);
    }
    const properties = {};
    const requestProperties = {};
    const queryParameters = {};
    const webhookPayloadProperties = {};
    if (this.audiences.type === "filtered") {
      for (const [typeId, typePropertiesNode] of Object.entries(this.properties)) {
        if (!typeIds.has(typeId)) {
          continue;
        }
        const propertiesForTypeId = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const propertiesForAudience = typePropertiesNode.propertiesByAudience[audience];
          if (propertiesForAudience != null) {
            propertiesForAudience.forEach((property4) => {
              propertiesForTypeId.add(property4);
            });
          }
        }
        if (propertiesForTypeId.size > 0) {
          properties[typeId] = propertiesForTypeId;
        }
        properties[typeId] = propertiesForTypeId.size > 0 ? propertiesForTypeId : void 0;
      }
      for (const [endpointId, requestPropertiesNode] of Object.entries(this.requestProperties)) {
        if (!this.endpointsNeededForAudience.has(endpointId)) {
          continue;
        }
        const propertiesForEndpoint = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const propertiesForAudience = requestPropertiesNode.propertiesByAudience[audience];
          if (propertiesForAudience != null) {
            propertiesForAudience.forEach((property4) => {
              propertiesForEndpoint.add(property4);
            });
          }
        }
        requestProperties[endpointId] = propertiesForEndpoint.size > 0 ? propertiesForEndpoint : void 0;
      }
      for (const [endpointId, queryParametersNode] of Object.entries(this.queryParameters)) {
        if (!this.endpointsNeededForAudience.has(endpointId)) {
          continue;
        }
        const parametersForEndpoint = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const parametersByAudience = queryParametersNode.parametersByAudience[audience];
          if (parametersByAudience != null) {
            parametersByAudience.forEach((parameter) => {
              parametersForEndpoint.add(parameter);
            });
          }
        }
        queryParameters[endpointId] = parametersForEndpoint.size > 0 ? parametersForEndpoint : void 0;
      }
      for (const [webhookId, webhookPaylodPropertiesNode] of Object.entries(this.webhookProperties)) {
        if (!this.webhooksNeededForAudience.has(webhookId)) {
          continue;
        }
        const propertiesForWebhook = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const propertiesForAudience = webhookPaylodPropertiesNode.propertiesByAudience[audience];
          if (propertiesForAudience != null) {
            propertiesForAudience.forEach((property4) => {
              propertiesForWebhook.add(property4);
            });
          }
        }
        webhookPayloadProperties[webhookId] = propertiesForWebhook.size > 0 ? propertiesForWebhook : void 0;
      }
    }
    return new FilteredIrImpl({
      types: typeIds,
      properties,
      errors: errorIds,
      requestProperties,
      queryParameters,
      environments: this.environmentsNeededForAudience,
      services: this.servicesNeededForAudience,
      endpoints: this.endpointsNeededForAudience,
      webhooks: this.webhooksNeededForAudience,
      webhookPayloadProperties,
      subpackages: this.subpackagesNeededForAudience
    });
  }
  markTypeForService(typeId, serviceId) {
    const types2 = this.typesReferencedByService[typeId] ??= /* @__PURE__ */ new Set();
    if (types2.has(serviceId)) {
      return;
    }
    types2.add(serviceId);
    const typeNode = this.getTypeNode(typeId);
    for (const descendantTypeId of typeNode.allDescendants) {
      this.markTypeForService(descendantTypeId, serviceId);
    }
  }
  addReferencedTypes(types2, typesToAdd) {
    for (const typeId of typesToAdd) {
      if (types2.has(typeId)) {
        continue;
      }
      types2.add(typeId);
      const typeNode = this.getTypeNode(typeId);
      if (this.audiences.type === "filtered") {
        for (const audienceId of this.audiences.audiences) {
          const descendantsForAudience = typeNode.descendantsByAudience[audienceId];
          if (descendantsForAudience != null) {
            descendantsForAudience.forEach((descendantTypeId) => {
              types2.add(descendantTypeId);
            });
          } else {
            typeNode.allDescendants.forEach((descendantTypeId) => {
              types2.add(descendantTypeId);
            });
            break;
          }
        }
      } else {
        typeNode.allDescendants.forEach((descendantTypeId) => {
          types2.add(descendantTypeId);
        });
      }
    }
  }
  getTypeNode(typeId) {
    const typeNode = this.types[typeId];
    if (typeNode == null) {
      throw new Error(`Failed to find type node with id ${typeId}`);
    }
    return typeNode;
  }
  getErrorNode(errorId) {
    const errorNode = this.errors[errorId];
    if (errorNode == null) {
      throw new Error(`Failed to find error node with id ${errorId}`);
    }
    return errorNode;
  }
  getEndpointNode(endpointId) {
    const endpointNode = this.endpoints[endpointId];
    if (endpointNode == null) {
      throw new Error(`Failed to find endpoint node with id ${endpointId}`);
    }
    return endpointNode;
  }
  getWebhookNode(webhookId) {
    const webhookNode = this.webhooks[webhookId];
    if (webhookNode == null) {
      throw new Error(`Failed to find webhook node with id ${webhookId}`);
    }
    return webhookNode;
  }
  hasNoAudiences() {
    return this.audiences.type === "none";
  }
  hasAudience(audiences) {
    const configuredAudiences = this.audiences;
    switch (configuredAudiences.type) {
      case "none":
        return true;
      case "filtered":
        return audiences.some((audienceId) => configuredAudiences.audiences.has(audienceId));
      default:
        assertNever(configuredAudiences);
    }
  }
  addSubpackages(fernFilePath) {
    for (let i = 1; i <= fernFilePath.allParts.length; ++i) {
      const packageFilePath = {
        ...fernFilePath,
        allParts: fernFilePath.allParts.slice(0, i)
      };
      this.subpackagesNeededForAudience.add(IdGenerator.generateSubpackageId(packageFilePath));
    }
  }
};
function audiencesFromConfig(configAudiences) {
  switch (configAudiences.type) {
    case "all":
      return { type: "none" };
    case "select":
      return { type: "filtered", audiences: new Set(configAudiences.audiences) };
    default:
      assertNever(configAudiences);
  }
}
function populateReferencesFromTypeReference(typeReference, referencedTypes, referencedSubpackages) {
  TypeReference2._visit(typeReference, {
    container: (containerType) => {
      populateReferencesFromContainer(containerType, referencedTypes, referencedSubpackages);
    },
    named: (declaredTypeName) => {
      populateReferencesFromTypeName(declaredTypeName, referencedTypes, referencedSubpackages);
    },
    primitive: noop,
    unknown: noop,
    _other: noop
  });
}
function populateReferencesFromTypeName(typeName, referencedTypes, referencedSubpackages) {
  referencedTypes.add(IdGenerator.generateTypeId(typeName));
  referencedSubpackages.add(typeName.fernFilepath);
}
function populateReferencesFromContainer(containerType, referencedTypes, referencedSubpackages) {
  ContainerType._visit(containerType, {
    list: (listType) => {
      populateReferencesFromTypeReference(listType, referencedTypes, referencedSubpackages);
    },
    map: (mapType2) => {
      populateReferencesFromTypeReference(mapType2.keyType, referencedTypes, referencedSubpackages);
      populateReferencesFromTypeReference(mapType2.valueType, referencedTypes, referencedSubpackages);
    },
    optional: (optionalType2) => {
      populateReferencesFromTypeReference(optionalType2, referencedTypes, referencedSubpackages);
    },
    set: (setType2) => {
      populateReferencesFromTypeReference(setType2, referencedTypes, referencedSubpackages);
    },
    literal: noop,
    _other: noop
  });
}

// ../../cli/generation/ir-generator/lib/filterExamples.js
function filterExampleSingleUnionTypeProperties({ filteredIr, singleUnionTypeProperties }) {
  return singleUnionTypeProperties._visit({
    samePropertiesAsObject: (s) => {
      const filteredObject = filteredIr.hasTypeId(s.typeId) ? {
        ...s,
        object: {
          properties: s.object.properties.filter((p) => filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue)).map((p) => ({
            ...p,
            value: filterExampleTypeReference({ filteredIr, exampleTypeReference: p.value })
          })).filter((p) => p.value !== void 0)
        }
      } : void 0;
      return filteredObject !== void 0 ? ExampleSingleUnionTypeProperties.samePropertiesAsObject(filteredObject) : void 0;
    },
    singleProperty: (s) => {
      const filteredProperty = filterExampleTypeReference({ filteredIr, exampleTypeReference: s });
      return filteredProperty !== void 0 ? ExampleSingleUnionTypeProperties.singleProperty(filteredProperty) : void 0;
    },
    noProperties: () => singleUnionTypeProperties,
    _other: () => {
      throw new Error("Received unknown type for example.");
    }
  });
}
function filterExampleTypeReference({ filteredIr, exampleTypeReference }) {
  return exampleTypeReference.shape._visit({
    primitive: () => exampleTypeReference,
    container: (c) => c._visit({
      list: (l) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.container(ExampleContainer.list({
          ...l,
          list: l.list.map((t) => filterExampleTypeReference({ filteredIr, exampleTypeReference: t })).filter((t) => t !== void 0)
        }))
      }),
      set: (s) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.container(ExampleContainer.set({
          ...s,
          set: s.set.map((t) => filterExampleTypeReference({ filteredIr, exampleTypeReference: t })).filter((t) => t !== void 0)
        }))
      }),
      optional: (o) => {
        const filteredOptionalTypReference = o.optional != null ? filterExampleTypeReference({ filteredIr, exampleTypeReference: o.optional }) : void 0;
        return filteredOptionalTypReference != null ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.container(ExampleContainer.optional({
            optional: filteredOptionalTypReference,
            valueType: o.valueType
          }))
        } : void 0;
      },
      map: (m) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.container(ExampleContainer.map({
          ...m,
          map: m.map.map((v) => {
            const filteredKey = filterExampleTypeReference({
              filteredIr,
              exampleTypeReference: v.key
            });
            const filteredValue = filterExampleTypeReference({
              filteredIr,
              exampleTypeReference: v.value
            });
            return filteredKey !== void 0 && filteredValue !== void 0 ? { key: filteredKey, value: filteredValue } : void 0;
          }).filter((t) => t !== void 0)
        }))
      }),
      // This is just a primitive, don't do anything
      literal: () => exampleTypeReference,
      _other: () => {
        throw new Error("Received unknown type for example.");
      }
    }),
    // If the type is allowed filter it's properties and return
    // Otherwise just return null
    named: (n) => filteredIr.hasTypeId(n.typeName.typeId) ? n.shape._visit({
      alias: (a) => {
        const filteredAlias = filterExampleTypeReference({
          filteredIr,
          exampleTypeReference: a.value
        });
        return filteredAlias !== void 0 ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.named({
            ...n,
            shape: ExampleTypeShape.alias({ ...a, value: filteredAlias })
          })
        } : void 0;
      },
      enum: (e) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.named({ ...n, shape: ExampleTypeShape.enum(e) })
      }),
      object: (o) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.named({
          ...n,
          shape: ExampleTypeShape.object({
            ...o,
            properties: o.properties.filter((p) => filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue)).map((p) => ({
              ...p,
              value: filterExampleTypeReference({
                filteredIr,
                exampleTypeReference: p.value
              })
            })).filter((p) => p.value !== void 0)
          })
        })
      }),
      union: (u) => {
        const filteredUnion = filterExampleSingleUnionTypeProperties({
          filteredIr,
          singleUnionTypeProperties: u.singleUnionType.shape
        });
        return filteredUnion !== void 0 ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.named({
            ...n,
            shape: ExampleTypeShape.union({
              ...u,
              singleUnionType: { ...u.singleUnionType, shape: filteredUnion }
            })
          })
        } : void 0;
      },
      undiscriminatedUnion: (u) => {
        const filteredUnion = filterExampleTypeReference({
          filteredIr,
          exampleTypeReference: u.singleUnionType
        });
        return filteredUnion !== void 0 ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.named({
            ...n,
            shape: ExampleTypeShape.undiscriminatedUnion({
              ...u,
              singleUnionType: filteredUnion
            })
          })
        } : void 0;
      },
      _other: () => {
        throw new Error("Received unknown type for example.");
      }
    }) : void 0,
    unknown: () => exampleTypeReference,
    _other: () => exampleTypeReference
  });
}
function filterExamplePathParameters({ filteredIr, pathParameters }) {
  return pathParameters.map((param) => {
    const filteredParam = filterExampleTypeReference({ filteredIr, exampleTypeReference: param.value });
    return filteredParam !== void 0 ? {
      ...param,
      value: filteredParam
    } : void 0;
  }).filter((param) => param !== void 0);
}
function filterExampleQueryParameters({ filteredIr, queryParameters }) {
  return queryParameters.map((queryParameter) => {
    const filteredQueryParameter = filterExampleTypeReference({
      filteredIr,
      exampleTypeReference: queryParameter.value
    });
    return filteredQueryParameter !== void 0 ? {
      ...queryParameter,
      value: filteredQueryParameter
    } : void 0;
  }).filter((queryParameter) => queryParameter !== void 0);
}
function filterExampleHeader({ filteredIr, headers }) {
  return headers.map((header) => {
    const filteredHeader = filterExampleTypeReference({ filteredIr, exampleTypeReference: header.value });
    return filteredHeader !== void 0 ? {
      ...header,
      value: filteredHeader
    } : void 0;
  }).filter((header) => header !== void 0);
}
function filterExampleRequestBody({ filteredIr, requestBody }) {
  return requestBody._visit({
    inlinedRequestBody: (inlined) => {
      return {
        ...requestBody,
        properties: inlined.properties.filter((p) => p.originalTypeDeclaration ? filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue) : true).map((property4) => {
          const filteredProperty = filterExampleTypeReference({
            filteredIr,
            exampleTypeReference: property4.value
          });
          return filteredProperty !== void 0 ? {
            ...property4,
            value: filteredProperty
          } : void 0;
        }).filter((property4) => property4 !== void 0)
      };
    },
    reference: (reference) => {
      const filteredReference = filterExampleTypeReference({ filteredIr, exampleTypeReference: reference });
      return filteredReference !== void 0 ? ExampleRequestBody.reference(filteredReference) : void 0;
    },
    _other: () => {
      throw new Error("Received unknown type for example.");
    }
  });
}
function filterExampleResponse({ filteredIr, response }) {
  return response._visit({
    ok: (ok) => ok._visit({
      body: (exampleTypeReference) => ExampleResponse.ok(ExampleEndpointSuccessResponse.body(exampleTypeReference != null ? filterExampleTypeReference({ filteredIr, exampleTypeReference }) : void 0)),
      stream: (stream) => ExampleResponse.ok(ExampleEndpointSuccessResponse.stream(stream.map((exampleTypeReference) => filterExampleTypeReference({ filteredIr, exampleTypeReference })).filter(isNonNullish))),
      sse: (events) => ExampleResponse.ok(ExampleEndpointSuccessResponse.sse(events.map(({ event, data }) => {
        const filteredData = filterExampleTypeReference({
          filteredIr,
          exampleTypeReference: data
        });
        return filteredData !== void 0 ? { event, data: filteredData } : void 0;
      }).filter(isNonNullish))),
      _other: ({ type: type2 }) => {
        throw new Error(`Received unknown type for OK example: ${type2}`);
      }
    }),
    error: ({ error, body }) => ExampleResponse.error({
      error,
      body: body != null ? filterExampleTypeReference({ filteredIr, exampleTypeReference: body }) : void 0
    }),
    _other: ({ type: type2 }) => {
      throw new Error(`Received unknown type for example: ${type2}`);
    }
  });
}
function filterEndpointExample({ filteredIr, example }) {
  return {
    ...example,
    rootPathParameters: filterExamplePathParameters({ filteredIr, pathParameters: example.rootPathParameters }),
    servicePathParameters: filterExamplePathParameters({
      filteredIr,
      pathParameters: example.servicePathParameters
    }),
    endpointPathParameters: filterExamplePathParameters({
      filteredIr,
      pathParameters: example.endpointPathParameters
    }),
    serviceHeaders: filterExampleHeader({ filteredIr, headers: example.serviceHeaders }),
    endpointHeaders: filterExampleHeader({ filteredIr, headers: example.endpointHeaders }),
    queryParameters: filterExampleQueryParameters({ filteredIr, queryParameters: example.queryParameters }),
    request: example.request !== void 0 ? filterExampleRequestBody({ filteredIr, requestBody: example.request }) : void 0,
    response: filterExampleResponse({ filteredIr, response: example.response })
  };
}
function filterExampleType({ filteredIr, exampleType }) {
  return exampleType.shape._visit({
    alias: (a) => {
      const filteredAlias = filterExampleTypeReference({ filteredIr, exampleTypeReference: a.value });
      return filteredAlias !== void 0 ? { ...exampleType, shape: ExampleTypeShape.alias({ ...a, value: filteredAlias }) } : void 0;
    },
    enum: () => exampleType,
    object: (o) => ({
      ...exampleType,
      shape: ExampleTypeShape.object({
        ...o,
        properties: o.properties.filter((p) => filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue)).map((p) => ({
          ...p,
          value: filterExampleTypeReference({ filteredIr, exampleTypeReference: p.value })
        })).filter((p) => p.value !== void 0)
      })
    }),
    union: (u) => {
      const filteredUnion = filterExampleSingleUnionTypeProperties({
        filteredIr,
        singleUnionTypeProperties: u.singleUnionType.shape
      });
      return filteredUnion !== void 0 ? {
        ...exampleType,
        shape: ExampleTypeShape.union({
          ...u,
          singleUnionType: { ...u.singleUnionType, shape: filteredUnion }
        })
      } : void 0;
    },
    undiscriminatedUnion: (u) => {
      const filteredUnion = filterExampleTypeReference({ filteredIr, exampleTypeReference: u.singleUnionType });
      return filteredUnion !== void 0 ? {
        ...exampleType,
        shape: ExampleTypeShape.undiscriminatedUnion({
          ...u,
          singleUnionType: filteredUnion
        })
      } : void 0;
    },
    _other: () => {
      throw new Error("Received unknown type for example.");
    }
  });
}

// ../../cli/generation/ir-generator/lib/PackageTreeGenerator.js
var PackageTreeGenerator = class {
  subpackages = {};
  rootPackage = {
    docs: void 0,
    fernFilepath: {
      allParts: [],
      packagePath: [],
      file: void 0
    },
    websocket: void 0,
    service: void 0,
    types: [],
    errors: [],
    subpackages: [],
    webhooks: void 0,
    navigationConfig: void 0
  };
  addPackageRedirection({ from, to }) {
    const package_ = this.getPackageForFernFilepath(from);
    if (package_.navigationConfig != null) {
      throw new Error("Found duplicate navigationConfig for package");
    }
    package_.navigationConfig = {
      pointsTo: IdGenerator.generateSubpackageId(to)
    };
  }
  addDocs(fernFilepath, docs) {
    const package_ = this.getPackageForFernFilepath(fernFilepath);
    if (package_.docs != null) {
      throw new Error("Found duplicate docs for package");
    }
    package_.docs = docs;
  }
  addSubpackage(fernFilepath) {
    this.getPackageForFernFilepath(fernFilepath);
  }
  addType(typeId, type2) {
    this.getPackageForFernFilepath(type2.name.fernFilepath).types.push(typeId);
  }
  addError(errorId, error) {
    this.getPackageForFernFilepath(error.name.fernFilepath).errors.push(errorId);
  }
  addService(serviceId, service) {
    const package_ = this.getPackageForFernFilepath(service.name.fernFilepath);
    if (package_.service != null) {
      throw new Error("Found duplicate service for " + serviceId);
    }
    package_.service = serviceId;
  }
  addWebhookGroup(webhookGroupId, fernFilepath) {
    const package_ = this.getPackageForFernFilepath(fernFilepath);
    if (package_.webhooks != null) {
      throw new Error("Found duplicate webhook group for " + webhookGroupId);
    }
    package_.webhooks = webhookGroupId;
  }
  addWebSocketChannel(websocketChannelId, fernFilepath) {
    const package_ = this.getPackageForFernFilepath(fernFilepath);
    if (package_.webhooks != null) {
      throw new Error("Found duplicate webhook group for " + websocketChannelId);
    }
    package_.websocket = websocketChannelId;
  }
  build(filteredIr) {
    if (filteredIr != null) {
      Object.entries(this.subpackages).forEach(([subpackageId, subpackage]) => {
        if (!filteredIr.hasSubpackageId(subpackageId)) {
          delete this.subpackages[subpackageId];
        } else {
          this.subpackages[subpackageId] = {
            ...subpackage,
            types: subpackage.types.filter((typeId) => filteredIr.hasTypeId(typeId)),
            errors: subpackage.errors.filter((errorId) => filteredIr.hasErrorId(errorId)),
            service: subpackage.service != null ? filteredIr.hasServiceId(subpackage.service) ? subpackage.service : void 0 : void 0,
            subpackages: subpackage.subpackages.filter((subpackageId2) => filteredIr.hasSubpackageId(subpackageId2))
          };
        }
      });
      this.rootPackage = {
        ...this.rootPackage,
        types: this.rootPackage.types.filter((typeId) => filteredIr.hasTypeId(typeId)),
        errors: this.rootPackage.errors.filter((errorId) => filteredIr.hasErrorId(errorId)),
        service: this.rootPackage.service != null ? filteredIr.hasServiceId(this.rootPackage.service) ? this.rootPackage.service : void 0 : void 0,
        subpackages: this.rootPackage.subpackages.filter((subpackageId) => filteredIr.hasSubpackageId(subpackageId)),
        webhooks: this.rootPackage.webhooks != null ? this.rootPackage.webhooks : void 0
      };
    }
    const allSubpackagesWithEndpoints = new Set(this.getAllChildrenWithEndpoints(this.rootPackage));
    return {
      subpackages: mapValues_default(this.subpackages, (subpackage, subpackageId) => ({
        ...subpackage,
        hasEndpointsInTree: allSubpackagesWithEndpoints.has(subpackageId)
      })),
      rootPackage: {
        ...this.rootPackage,
        hasEndpointsInTree: allSubpackagesWithEndpoints.size > 0 || this.rootPackage.service != null
      }
    };
  }
  sortRootPackage(subpackagesInOrder) {
    if (!isEqualIgnoreOrder(this.rootPackage.subpackages, subpackagesInOrder)) {
      throw new Error("Sorted subpackages differ from unsorted packages in root");
    }
    this.rootPackage.subpackages = subpackagesInOrder;
  }
  sortSubpackage(subpackageId, subpackagesInOrder) {
    const subpackage = this.subpackages[subpackageId];
    if (subpackage == null) {
      throw new Error("Subpackage does not exist: " + subpackageId);
    }
    if (!isEqualIgnoreOrder(subpackage.subpackages, subpackagesInOrder)) {
      throw new Error("Sorted subpackages differ from unsorted packages");
    }
    subpackage.subpackages = subpackagesInOrder;
  }
  getAllSubpackagesWithEndpoints(root2) {
    const subpackage = this.subpackages[root2];
    if (subpackage == null) {
      throw new Error("Subpackage does not exist: " + root2);
    }
    const subpackagesWithEndpoints = this.getAllChildrenWithEndpoints(subpackage);
    if (subpackagesWithEndpoints.length > 0 || subpackage.service != null) {
      subpackagesWithEndpoints.push(root2);
    }
    return subpackagesWithEndpoints;
  }
  getAllChildrenWithEndpoints(package_) {
    return package_.subpackages.flatMap((child) => {
      return [...this.getAllSubpackagesWithEndpoints(child)];
    });
  }
  getPackageForFernFilepath(fernFilepath, index = 0, parent = this.rootPackage) {
    const nextPart = fernFilepath.allParts[index];
    if (nextPart == null) {
      return parent;
    }
    const subpackagesInParent = parent.subpackages.map((subpackageId) => {
      const subpackage = this.subpackages[subpackageId];
      if (subpackage == null) {
        throw new Error("Subpackage ID is invalid: " + subpackageId);
      }
      return subpackage;
    });
    const nextIndex = index + 1;
    const fernFilepathForNextParent = {
      allParts: fernFilepath.allParts.slice(0, nextIndex),
      packagePath: fernFilepath.packagePath.slice(0, nextIndex),
      file: nextIndex === fernFilepath.allParts.length ? fernFilepath.file : void 0
    };
    let nextParent = subpackagesInParent.find((subpackage) => subpackage.name.originalName === nextPart.originalName);
    if (nextParent == null) {
      const newParentId = IdGenerator.generateSubpackageId(fernFilepathForNextParent);
      const newParent = {
        docs: void 0,
        fernFilepath: fernFilepathForNextParent,
        name: nextPart,
        service: void 0,
        types: [],
        errors: [],
        subpackages: [],
        navigationConfig: void 0,
        webhooks: void 0,
        websocket: void 0
      };
      this.subpackages[newParentId] = newParent;
      parent.subpackages.push(newParentId);
      nextParent = newParent;
    }
    return this.getPackageForFernFilepath(fernFilepath, nextIndex, nextParent);
  }
};
function isEqualIgnoreOrder(a, b) {
  if (a.length !== b.length) {
    return false;
  }
  const aSet = new Set(a);
  for (const bElement of b) {
    if (!aSet.has(bElement)) {
      return false;
    }
  }
  return true;
}

// ../../cli/generation/ir-generator/lib/utils/parseReferenceToEndpointName.js
function parseReferenceToEndpointName({ reference, referencedIn, imports }) {
  const [firstPart, secondPart, ...rest] = reference.split(".");
  if (firstPart == null || rest.length > 0) {
    return void 0;
  }
  if (secondPart == null) {
    return {
      endpointName: firstPart,
      relativeFilepath: referencedIn
    };
  }
  const importAlias = firstPart;
  const importPath = imports[importAlias];
  if (importPath == null) {
    return void 0;
  }
  return {
    endpointName: secondPart,
    relativeFilepath: getResolvedPathOfImportedFile({ referencedIn, importPath })
  };
}

// ../../cli/generation/ir-generator/lib/resolvers/EndpointResolver.js
var EndpointResolverImpl = class {
  workspace;
  constructor(workspace) {
    this.workspace = workspace;
  }
  async resolveEndpointOrThrow({ endpoint, file }) {
    const resolvedEndpoint = await this.resolveEndpoint({ endpoint, file });
    if (resolvedEndpoint == null) {
      throw new Error("Cannot resolve endpoint: " + endpoint + " in file " + file.relativeFilepath);
    }
    return resolvedEndpoint;
  }
  async resolveEndpointByMethodAndPath({ method, path: path5 }) {
    let result = void 0;
    await visitAllDefinitionFiles(this.workspace, async (relativeFilepath, file, metadata) => {
      const context = constructFernFileContext({
        relativeFilepath,
        definitionFile: file,
        casingsGenerator: CASINGS_GENERATOR,
        rootApiFile: this.workspace.definition.rootApiFile.contents,
        defaultUrl: metadata.defaultUrl
      });
      for (const [endpointId, endpointDeclaration] of Object.entries(file.service?.endpoints ?? {})) {
        if (endpointDeclaration.method === method && endpointDeclaration.path === path5) {
          result = {
            endpointId,
            endpoint: endpointDeclaration,
            file: context
          };
        }
      }
    });
    await visitAllPackageMarkers(this.workspace, async (relativeFilepath, packageMarker) => {
      const context = constructFernFileContext({
        relativeFilepath,
        definitionFile: packageMarker,
        casingsGenerator: CASINGS_GENERATOR,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      });
      for (const [endpointId, endpointDeclaration] of Object.entries(packageMarker.service?.endpoints ?? {})) {
        if (endpointDeclaration.method === method && endpointDeclaration.path === path5) {
          result = {
            endpointId,
            endpoint: endpointDeclaration,
            file: context
          };
        }
      }
    });
    return result;
  }
  async resolveEndpoint({ endpoint, file }) {
    const referenceParser = new HttpEndpointReferenceParser();
    const parsedEndpointReference = referenceParser.tryParse(endpoint);
    if (parsedEndpointReference != null) {
      return await this.resolveEndpointByMethodAndPath(parsedEndpointReference);
    }
    const maybeDeclaration = this.getDeclarationOfEndpoint({
      referenceToEndpoint: endpoint,
      file
    });
    if (maybeDeclaration == null) {
      return void 0;
    }
    const maybeEndpoint = maybeDeclaration.file.definitionFile.service?.endpoints?.[maybeDeclaration.endpointName];
    if (maybeEndpoint == null) {
      return void 0;
    }
    return {
      endpointId: maybeDeclaration.endpointName,
      endpoint: maybeEndpoint,
      file: maybeDeclaration.file
    };
  }
  getDeclarationOfEndpoint({ referenceToEndpoint, file }) {
    const parsedReference = parseReferenceToEndpointName({
      reference: referenceToEndpoint,
      referencedIn: file.relativeFilepath,
      imports: file.imports
    });
    if (parsedReference == null) {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, parsedReference.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    const declaration = definitionFile.service?.endpoints?.[parsedReference.endpointName];
    if (declaration == null) {
      return void 0;
    }
    return {
      endpointName: parsedReference.endpointName,
      file: constructFernFileContext({
        relativeFilepath: parsedReference.relativeFilepath,
        definitionFile,
        casingsGenerator: file.casingsGenerator,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      })
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/ErrorResolver.js
var ErrorResolverImpl = class {
  workspace;
  constructor(workspace) {
    this.workspace = workspace;
  }
  getDeclarationOrThrow(referenceToError, file) {
    const declaration = this.getDeclaration(referenceToError, file);
    if (declaration == null) {
      throw new Error("Error does not exist: " + referenceToError);
    }
    return declaration;
  }
  getDeclaration(referenceToError, file) {
    const parsedReference = parseReferenceToTypeName({
      reference: referenceToError,
      referencedIn: file.relativeFilepath,
      imports: file.imports
    });
    if (parsedReference == null) {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, parsedReference.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    const declaration = definitionFile.errors?.[parsedReference.typeName];
    if (declaration == null) {
      return void 0;
    }
    return {
      declaration,
      file: constructFernFileContext({
        definitionFile,
        relativeFilepath: parsedReference.relativeFilepath,
        casingsGenerator: file.casingsGenerator,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      })
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/ExampleResolver.js
var ExampleResolverImpl = class {
  typeResolver;
  constructor(typeResolver) {
    this.typeResolver = typeResolver;
  }
  resolveAllReferencesInExample({ example, file }) {
    if (typeof example === "string") {
      const resolvedExample = this.resolveExample({
        example,
        file
      });
      if (resolvedExample == null || typeof resolvedExample.resolvedExample === "string") {
        return resolvedExample;
      }
      return this.resolveAllReferencesInExample({
        example: resolvedExample.resolvedExample,
        file: resolvedExample.file
      });
    } else if (isPlainObject2(example)) {
      const newExample = {};
      for (const [exampleKey, exampleValue] of Object.entries(example)) {
        const resolvedExampleValue = this.resolveAllReferencesInExample({ example: exampleValue, file });
        if (resolvedExampleValue == null) {
          return void 0;
        }
        newExample[exampleKey] = resolvedExampleValue.resolvedExample;
      }
      return { resolvedExample: newExample };
    } else if (Array.isArray(example)) {
      const newExample = [];
      for (const exampleItem of example) {
        const resolvedExampleItem = this.resolveAllReferencesInExample({ example: exampleItem, file });
        if (resolvedExampleItem == null) {
          return void 0;
        }
        newExample.push(resolvedExampleItem.resolvedExample);
      }
      return { resolvedExample: newExample };
    }
    return { resolvedExample: example };
  }
  resolveAllReferencesInExampleOrThrow({ example, file }) {
    const resolvedExample = this.resolveAllReferencesInExample({ example, file });
    if (resolvedExample == null) {
      throw new Error("Failed to resolve examples");
    }
    return resolvedExample;
  }
  resolveExample({ example, file }) {
    if (typeof example !== "string") {
      return {
        resolvedExample: example,
        file
      };
    }
    if (example.startsWith(`\\${EXAMPLE_REFERENCE_PREFIX}`)) {
      return {
        // remove backslash
        resolvedExample: example.slice(1),
        file
      };
    }
    if (!example.startsWith(EXAMPLE_REFERENCE_PREFIX)) {
      return {
        resolvedExample: example,
        file
      };
    }
    const parsedExampleReference = this.parseExampleReference(example);
    if (parsedExampleReference == null) {
      return void 0;
    }
    const typeDeclaration = this.typeResolver.getDeclarationOfNamedType({
      referenceToNamedType: parsedExampleReference.rawTypeReference,
      file
    });
    if (typeDeclaration == null || typeof typeDeclaration.declaration === "string" || typeDeclaration.declaration.examples == null) {
      return void 0;
    }
    const resolvedExample = typeDeclaration.declaration.examples.find((otherExample) => otherExample.name === parsedExampleReference.exampleName);
    if (resolvedExample == null) {
      return void 0;
    }
    return this.resolveExample({ example: resolvedExample.value, file: typeDeclaration.file });
  }
  resolveExampleOrThrow({ example, file }) {
    const resolvedExample = this.resolveExample({ example, file });
    if (resolvedExample == null) {
      throw new Error("Cannot resolve example: " + example);
    }
    return resolvedExample;
  }
  parseExampleReference(exampleReference) {
    const [first, second, third, ...rest] = exampleReference.split(".");
    if (first == null || second == null || rest.length > 0) {
      return void 0;
    }
    if (third == null) {
      return {
        rawTypeReference: first.slice(EXAMPLE_REFERENCE_PREFIX.length),
        exampleName: second
      };
    }
    return {
      rawTypeReference: `${first}.${second}`.slice(EXAMPLE_REFERENCE_PREFIX.length),
      exampleName: third
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/PropertyResolver.js
var PropertyResolverImpl = class {
  typeResolver;
  endpointResolver;
  constructor(typeResolver, endpointResolver) {
    this.typeResolver = typeResolver;
    this.endpointResolver = endpointResolver;
    this.typeResolver = typeResolver;
    this.endpointResolver = endpointResolver;
  }
  async resolveRequestPropertyOrThrow({ file, endpoint, propertyComponents }) {
    const resolvedRequestProperty = await this.resolveRequestProperty({ file, endpoint, propertyComponents });
    if (resolvedRequestProperty == null) {
      throw new Error("Cannot resolve request property from endpoint: " + endpoint + " in file " + file.relativeFilepath);
    }
    return resolvedRequestProperty;
  }
  async resolveRequestProperty({ file, endpoint, propertyComponents }) {
    const resolvedEndpoint = await this.endpointResolver.resolveEndpointOrThrow({
      endpoint,
      file
    });
    if (resolvedEndpoint.endpoint.request == null) {
      return void 0;
    }
    if (typeof resolvedEndpoint.endpoint.request !== "string") {
      return this.resolveRequestPropertyFromInlinedRequest({
        typeResolver: this.typeResolver,
        file: resolvedEndpoint.file,
        requestType: resolvedEndpoint.endpoint.request,
        propertyComponents
      });
    }
    const objectProperty = await this.resolveObjectProperty({
      file: resolvedEndpoint.file,
      typeName: resolvedEndpoint.endpoint.request,
      propertyComponents
    });
    if (objectProperty == null) {
      return void 0;
    }
    return {
      propertyPath: await this.propertyPathFromPropertyComponents({
        propertyComponents,
        file
      }),
      property: RequestPropertyValue.body(objectProperty)
    };
  }
  async resolveResponsePropertyOrThrow({ file, endpoint, propertyComponents }) {
    const resolvedResponseProperty = await this.resolveResponseProperty({ file, endpoint, propertyComponents });
    if (resolvedResponseProperty == null) {
      throw new Error("Cannot resolve response property from endpoint: " + endpoint + " in file " + file.relativeFilepath);
    }
    return resolvedResponseProperty;
  }
  async resolveResponseProperty({ file, endpoint, propertyComponents }) {
    const resolvedEndpoint = await this.endpointResolver.resolveEndpointOrThrow({
      endpoint,
      file
    });
    const objectProperty = await this.resolveObjectProperty({
      file: resolvedEndpoint.file,
      typeName: (typeof resolvedEndpoint.endpoint.response !== "string" ? resolvedEndpoint.endpoint.response?.type : resolvedEndpoint.endpoint.response) ?? "",
      propertyComponents
    });
    if (objectProperty == null) {
      return void 0;
    }
    return {
      propertyPath: await this.propertyPathFromPropertyComponents({
        propertyComponents,
        file
      }),
      property: objectProperty
    };
  }
  async resolveRequestPropertyFromInlinedRequest({ typeResolver, file, requestType, propertyComponents }) {
    if (propertyComponents.length === 1) {
      const queryParameterKey = propertyComponents[0] ?? "";
      const queryParameter = typeof requestType["query-parameters"] != null ? requestType["query-parameters"]?.[queryParameterKey] : void 0;
      if (queryParameter != null) {
        return {
          property: RequestPropertyValue.query(await convertQueryParameter({
            file,
            queryParameterKey,
            queryParameter
          })),
          propertyPath: void 0
        };
      }
    }
    return this.resolveRequestPropertyFromInlinedRequestBody({
      typeResolver,
      file,
      requestType,
      propertyComponents
    });
  }
  async resolveRequestPropertyFromInlinedRequestBody({ typeResolver, file, requestType, propertyComponents }) {
    if (requestType.body == null) {
      return void 0;
    }
    if (typeof requestType.body === "string") {
      const objectProperty2 = await this.resolveObjectProperty({
        file,
        typeName: requestType.body,
        propertyComponents
      });
      if (objectProperty2 == null) {
        return void 0;
      }
      return {
        propertyPath: await this.propertyPathFromPropertyComponents({
          propertyComponents,
          file
        }),
        property: RequestPropertyValue.body(objectProperty2)
      };
    }
    if (isInlineRequestBody(requestType.body)) {
      const objectProperty2 = await getNestedObjectPropertyFromObjectSchema({
        typeResolver,
        file,
        objectSchema: requestType.body,
        propertyComponents
      });
      if (objectProperty2 == null) {
        return void 0;
      }
      return {
        propertyPath: await this.propertyPathFromPropertyComponents({
          propertyComponents,
          file
        }),
        property: RequestPropertyValue.body(objectProperty2)
      };
    }
    const objectProperty = await this.resolveObjectProperty({
      file,
      typeName: requestType.body.type,
      propertyComponents
    });
    if (objectProperty == null) {
      return void 0;
    }
    return {
      propertyPath: await this.propertyPathFromPropertyComponents({
        propertyComponents,
        file
      }),
      property: RequestPropertyValue.body(objectProperty)
    };
  }
  async resolveObjectProperty({ file, typeName, propertyComponents }) {
    const resolvedType = this.typeResolver.resolveTypeOrThrow({
      type: typeName,
      file
    });
    return await getNestedObjectPropertyFromResolvedType({
      typeResolver: this.typeResolver,
      file: maybeFileFromResolvedType(resolvedType) ?? file,
      resolvedType,
      propertyComponents
    });
  }
  async propertyPathFromPropertyComponents({ propertyComponents, file }) {
    if (propertyComponents.length <= 1) {
      return [];
    }
    return propertyComponents.slice(0, -1).map((property4) => file.casingsGenerator.generateName(property4));
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/TypeResolver.js
var TypeResolverImpl = class {
  workspace;
  constructor(workspace) {
    this.workspace = workspace;
  }
  resolveTypeOrThrow({ type: type2, file }) {
    const resolvedType = this.resolveType({ type: type2, file });
    if (resolvedType == null) {
      throw new Error("Cannot resolve type: " + type2 + " in file " + file.relativeFilepath);
    }
    return resolvedType;
  }
  getDeclarationOfNamedTypeOrThrow({ referenceToNamedType, file }) {
    const declaration = this.getDeclarationOfNamedType({ referenceToNamedType, file });
    if (declaration == null) {
      throw new Error("Cannot find declaration of type: " + referenceToNamedType + " in file " + file.relativeFilepath);
    }
    return declaration;
  }
  getDeclarationOfNamedType({ referenceToNamedType, file }) {
    const parsedReference = parseReferenceToTypeName({
      reference: referenceToNamedType,
      referencedIn: file.relativeFilepath,
      imports: file.imports
    });
    if (parsedReference == null) {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, parsedReference.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    const declaration = definitionFile.types?.[parsedReference.typeName];
    if (declaration == null) {
      const parsedGeneric = parseGeneric(parsedReference.typeName);
      if (parsedGeneric != null) {
        for (const type2 of Object.keys(definitionFile.types ?? {}) ?? []) {
          if (parsedGeneric.name && type2.startsWith(parsedGeneric.name) && type2.endsWith(">")) {
            const genericDeclaration = definitionFile.types?.[type2];
            return genericDeclaration != null ? {
              typeName: type2,
              declaration: genericDeclaration,
              file: constructFernFileContext({
                relativeFilepath: parsedReference.relativeFilepath,
                definitionFile,
                casingsGenerator: file.casingsGenerator,
                rootApiFile: this.workspace.definition.rootApiFile.contents
              })
            } : void 0;
          }
        }
      }
      return void 0;
    }
    return {
      typeName: parsedReference.typeName,
      declaration,
      file: constructFernFileContext({
        relativeFilepath: parsedReference.relativeFilepath,
        definitionFile,
        casingsGenerator: file.casingsGenerator,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      })
    };
  }
  resolveType({ type: type2, file, objectPath = [] }) {
    return recursivelyVisitRawTypeReference({
      type: type2,
      _default: void 0,
      validation: void 0,
      visitor: {
        primitive: (primitive) => ({
          _type: "primitive",
          primitive,
          originalTypeReference: TypeReference2.primitive(primitive)
        }),
        unknown: () => ({ _type: "unknown", originalTypeReference: TypeReference2.unknown() }),
        map: ({ keyType, valueType }) => keyType != null && valueType != null ? {
          _type: "container",
          container: {
            _type: "map",
            keyType,
            valueType
          },
          originalTypeReference: TypeReference2.container(ContainerType.map({
            keyType: keyType.originalTypeReference,
            valueType: valueType.originalTypeReference
          }))
        } : void 0,
        list: (itemType) => itemType != null ? {
          _type: "container",
          container: {
            _type: "list",
            itemType
          },
          originalTypeReference: TypeReference2.container(ContainerType.list(itemType.originalTypeReference))
        } : void 0,
        optional: (itemType) => itemType != null ? {
          _type: "container",
          container: {
            _type: "optional",
            itemType
          },
          originalTypeReference: TypeReference2.container(ContainerType.optional(itemType.originalTypeReference))
        } : void 0,
        set: (itemType) => itemType != null ? {
          _type: "container",
          container: {
            _type: "set",
            itemType
          },
          originalTypeReference: TypeReference2.container(ContainerType.set(itemType.originalTypeReference))
        } : void 0,
        literal: (literal) => ({
          _type: "container",
          container: {
            _type: "literal",
            literal
          },
          originalTypeReference: TypeReference2.container(ContainerType.literal(literal))
        }),
        named: (referenceToNamedType) => {
          const maybeDeclaration = this.getDeclarationOfNamedType({
            referenceToNamedType,
            file
          });
          if (maybeDeclaration == null) {
            return void 0;
          }
          const newObjectPathItem = {
            typeName: maybeDeclaration.typeName,
            file: maybeDeclaration.file.relativeFilepath,
            reference: referenceToNamedType
          };
          if (objectPath.some((pathItem) => pathItem.file === newObjectPathItem.file && pathItem.typeName === newObjectPathItem.typeName)) {
            return void 0;
          }
          return this.resolveNamedTypeFromDeclaration({
            referenceToNamedType,
            referencedIn: file,
            rawDeclaration: maybeDeclaration,
            objectPath: [...objectPath, newObjectPathItem]
          });
        }
      }
    });
  }
  resolveNamedTypeOrThrow({ referenceToNamedType, file }) {
    const resolvedType = this.resolveNamedType({ referenceToNamedType, file });
    if (resolvedType == null) {
      throw new Error("Cannot resolve type: " + referenceToNamedType);
    }
    return resolvedType;
  }
  resolveNamedType({ referenceToNamedType, file }) {
    const maybeDeclaration = this.getDeclarationOfNamedType({
      referenceToNamedType,
      file
    });
    if (maybeDeclaration == null) {
      return void 0;
    }
    return this.resolveNamedTypeFromDeclaration({
      referenceToNamedType,
      referencedIn: file,
      rawDeclaration: maybeDeclaration
    });
  }
  resolveNamedTypeFromDeclaration({ referenceToNamedType, referencedIn, rawDeclaration, objectPath = [] }) {
    const { declaration, file: fileOfResolvedDeclaration } = rawDeclaration;
    if (isRawAliasDefinition(declaration)) {
      return this.resolveType({
        type: typeof declaration === "string" ? declaration : declaration.type,
        file: fileOfResolvedDeclaration,
        objectPath
      });
    }
    const parsedTypeReference = parseInlineType({
      type: referenceToNamedType,
      _default: void 0,
      validation: void 0,
      file: referencedIn
    });
    if (parsedTypeReference.type !== "named") {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, fileOfResolvedDeclaration.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    return {
      _type: "named",
      rawName: rawDeclaration.typeName,
      name: parsedTypeReference,
      declaration,
      filepath: fileOfResolvedDeclaration.relativeFilepath,
      objectPath,
      originalTypeReference: parsedTypeReference,
      file: fileOfResolvedDeclaration
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/VariableResolver.js
var VariableResolverImpl = class _VariableResolverImpl {
  static VARIABLE_PREFIX = "$";
  getDeclarationOrThrow(referenceToVariable, file) {
    const declaration = this.getDeclaration(referenceToVariable, file);
    if (declaration == null) {
      throw new Error("Variable does not exist: " + referenceToVariable);
    }
    return declaration;
  }
  getDeclaration(referenceToVariable, file) {
    if (!referenceToVariable.startsWith(_VariableResolverImpl.VARIABLE_PREFIX)) {
      return void 0;
    }
    const declaration = file.rootApiFile.variables?.[referenceToVariable.substring(1)];
    if (declaration == null) {
      return void 0;
    }
    return {
      declaration,
      file: constructRootApiFileContext({
        casingsGenerator: file.casingsGenerator,
        rootApiFile: file.rootApiFile
      })
    };
  }
  getVariableIdOrThrow(referenceToVariable) {
    const variableId = this.getVariableId(referenceToVariable);
    if (variableId == null) {
      throw new Error("Variable reference does not start with " + _VariableResolverImpl.VARIABLE_PREFIX);
    }
    return variableId;
  }
  getVariableId(referenceToVariable) {
    if (!referenceToVariable.startsWith(_VariableResolverImpl.VARIABLE_PREFIX)) {
      return void 0;
    }
    return referenceToVariable.substring(_VariableResolverImpl.VARIABLE_PREFIX.length);
  }
};

// ../../cli/generation/ir-generator/lib/utils/getEnvironmentsByAudience.js
function getAudienceForEnvironment(environmentId, rawEnvironments) {
  if (rawEnvironments) {
    for (const [envId, environment] of Object.entries(rawEnvironments)) {
      if (typeof environment !== "string" && envId === environmentId) {
        return environment.audiences;
      }
    }
  }
  return void 0;
}

// ../../cli/generation/ir-generator/lib/examples/generator/generatePrimitiveExample.js
function generatePrimitiveExample({ fieldName, primitiveType }) {
  switch (primitiveType.v1) {
    case "STRING": {
      return generatePrimitiveStringExample({
        fieldName,
        validation: maybeStringValidation2(primitiveType.v2)
      });
    }
    case "BASE_64": {
      return { type: "success", example: ExamplePrimitive.base64(examples_exports.BASE64), jsonExample: examples_exports.BASE64 };
    }
    case "BOOLEAN": {
      return {
        type: "success",
        example: ExamplePrimitive.boolean(examples_exports.BOOLEAN),
        jsonExample: examples_exports.BOOLEAN
      };
    }
    case "DATE": {
      return { type: "success", example: ExamplePrimitive.date(examples_exports.DATE), jsonExample: examples_exports.DATE };
    }
    case "DATE_TIME": {
      return {
        type: "success",
        example: ExamplePrimitive.datetime({
          datetime: new Date(examples_exports.DATE_TIME),
          raw: examples_exports.DATE_TIME
        }),
        jsonExample: examples_exports.DATE_TIME
      };
    }
    case "DOUBLE": {
      return generatePrimitiveDoubleExample({
        fieldName,
        validation: maybeDoubleValidation(primitiveType.v2)
      });
    }
    case "FLOAT": {
      return { type: "success", example: ExamplePrimitive.float(examples_exports.FLOAT), jsonExample: examples_exports.FLOAT };
    }
    case "INTEGER": {
      return generatePrimitiveIntegerExample({
        fieldName,
        validation: maybeIntegerValidation(primitiveType.v2)
      });
    }
    case "UINT_64": {
      return { type: "success", example: ExamplePrimitive.uint64(examples_exports.INT64), jsonExample: examples_exports.INT64 };
    }
    case "UINT": {
      return { type: "success", example: ExamplePrimitive.uint(examples_exports.UINT), jsonExample: examples_exports.UINT };
    }
    case "BIG_INTEGER": {
      return {
        type: "success",
        example: ExamplePrimitive.bigInteger(examples_exports.INT64.toString()),
        jsonExample: `${examples_exports.INT64}`
      };
    }
    case "LONG": {
      return { type: "success", example: ExamplePrimitive.long(examples_exports.INT64), jsonExample: examples_exports.INT64 };
    }
    case "UUID": {
      return { type: "success", example: ExamplePrimitive.uuid(examples_exports.UUID), jsonExample: examples_exports.UUID };
    }
    default:
      assertNever(primitiveType.v1);
  }
}
function maybeStringValidation2(v2) {
  if (v2?.type === "string") {
    const stringType2 = v2;
    return stringType2.validation;
  }
  return void 0;
}
function maybeDoubleValidation(v2) {
  if (v2?.type === "double") {
    const doubleType = v2;
    return doubleType.validation;
  }
  return void 0;
}
function maybeIntegerValidation(v2) {
  if (v2?.type === "integer") {
    const integerType = v2;
    return integerType.validation;
  }
  return void 0;
}
function getStringExampleOfLength(length) {
  if (length <= examples_exports.SAMPLE_STRINGS.length) {
    const sampleString = examples_exports.SAMPLE_STRINGS[length - 1];
    if (sampleString) {
      return sampleString;
    } else {
      throw new Error(`Unexpected undefined value in SAMPLE_STRINGS at index ${length - 1}`);
    }
  }
  return examples_exports.SAMPLE_STRINGS[examples_exports.SAMPLE_STRINGS.length - 1] + ".".repeat(length - examples_exports.SAMPLE_STRINGS.length);
}
function generatePrimitiveStringExample({ fieldName, validation }) {
  if (validation) {
    const minLength = validation.minLength;
    const maxLength = validation.maxLength;
    if (minLength) {
      const minLengthExample = getStringExampleOfLength(minLength);
      return {
        type: "success",
        example: ExamplePrimitive.string({ original: minLengthExample }),
        jsonExample: minLengthExample
      };
    } else if (maxLength) {
      const maxLengthExample = getStringExampleOfLength(maxLength);
      return {
        type: "success",
        example: ExamplePrimitive.string({ original: maxLengthExample }),
        jsonExample: maxLengthExample
      };
    }
  }
  const jsonExample = fieldName ?? examples_exports.STRING;
  return { type: "success", example: ExamplePrimitive.string({ original: jsonExample }), jsonExample };
}
function generatePrimitiveDoubleExample({ fieldName, validation }) {
  if (validation) {
    const maximum = validation.max;
    const minimum = validation.min;
    if (maximum) {
      return { type: "success", example: ExamplePrimitive.double(maximum), jsonExample: maximum };
    } else if (minimum) {
      return { type: "success", example: ExamplePrimitive.double(minimum), jsonExample: minimum };
    }
  }
  return { type: "success", example: ExamplePrimitive.double(examples_exports.DOUBLE), jsonExample: examples_exports.DOUBLE };
}
function generatePrimitiveIntegerExample({ fieldName, validation }) {
  if (validation) {
    const maximum = validation.max;
    const minimum = validation.min;
    if (maximum) {
      return { type: "success", example: ExamplePrimitive.integer(maximum), jsonExample: maximum };
    } else if (minimum) {
      return { type: "success", example: ExamplePrimitive.integer(minimum), jsonExample: minimum };
    }
  }
  return { type: "success", example: ExamplePrimitive.integer(examples_exports.INT), jsonExample: examples_exports.INT };
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateContainerExample.js
function generateContainerExample({ fieldName, containerType, maxDepth, currentDepth, typeDeclarations, skipOptionalProperties }) {
  if (currentDepth >= maxDepth) {
    return generateEmptyContainerExample({ containerType });
  }
  switch (containerType.type) {
    case "list": {
      const example = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.list,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (example.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.list({
          list: [example.example, example.example],
          itemType: containerType.list
        }),
        jsonExample: [example.jsonExample, example.jsonExample]
      };
    }
    case "literal": {
      return {
        type: "success",
        example: ExampleContainer.literal({
          literal: containerType.literal._visit({
            boolean: (value) => ExamplePrimitive.boolean(value),
            string: (value) => ExamplePrimitive.string({ original: value }),
            _other: () => {
              throw new Error("Encountered unknown literal type");
            }
          })
        }),
        jsonExample: containerType.literal._visit({
          boolean: (value) => value,
          string: (value) => value,
          _other: () => {
            throw new Error("Encountered unknown literal type");
          }
        })
      };
    }
    case "optional": {
      if (skipOptionalProperties) {
        return generateEmptyContainerExample({ containerType });
      }
      const example = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.optional,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (example.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.optional({
          optional: example.example,
          valueType: containerType.optional
        }),
        jsonExample: example.jsonExample
      };
    }
    case "set": {
      const example = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.set,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (example.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.set({
          set: [example.example],
          itemType: containerType.set
        }),
        jsonExample: [example.jsonExample]
      };
    }
    case "map": {
      const keyExample = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.keyType,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      const valueExample = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.valueType,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (keyExample.type === "failure" || valueExample.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.map({
          map: [
            {
              key: keyExample.example,
              value: valueExample.example
            }
          ],
          keyType: containerType.keyType,
          valueType: containerType.valueType
        }),
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        jsonExample: { [keyExample.jsonExample]: valueExample.jsonExample }
      };
    }
    default:
      assertNever(containerType);
  }
}
function generateEmptyContainerExample({ containerType }) {
  switch (containerType.type) {
    case "list": {
      return {
        type: "success",
        example: ExampleContainer.list({
          list: [],
          itemType: containerType.list
        }),
        jsonExample: []
      };
    }
    case "literal": {
      return {
        type: "success",
        example: ExampleContainer.literal({
          literal: containerType.literal._visit({
            boolean: (value) => ExamplePrimitive.boolean(value),
            string: (value) => ExamplePrimitive.string({ original: value }),
            _other: () => {
              throw new Error("Encountered unknown literal type");
            }
          })
        }),
        jsonExample: containerType.literal._visit({
          boolean: (value) => value,
          string: (value) => value,
          _other: () => {
            throw new Error("Encountered unknown literal type");
          }
        })
      };
    }
    case "optional": {
      return {
        type: "success",
        example: ExampleContainer.optional({
          optional: void 0,
          valueType: containerType.optional
        }),
        jsonExample: void 0
      };
    }
    case "set": {
      return {
        type: "success",
        example: ExampleContainer.set({
          set: [],
          itemType: containerType.set
        }),
        jsonExample: []
      };
    }
    case "map": {
      return {
        type: "success",
        example: ExampleContainer.map({
          map: [],
          keyType: containerType.keyType,
          valueType: containerType.valueType
        }),
        jsonExample: {}
      };
    }
    default:
      assertNever(containerType);
  }
}

// ../../cli/generation/ir-generator/lib/examples/generator/isTypeReferenceOptional.js
function isOptional({ typeReference, typeDeclarations }) {
  if (typeReference.type === "container" && typeReference.container.type === "optional") {
    return true;
  }
  if (typeReference.type === "named") {
    const typeDeclaration = typeDeclarations[typeReference.typeId];
    if (typeDeclaration?.shape.type === "alias" && typeDeclaration?.shape.resolvedType.type === "container" && typeDeclaration?.shape.resolvedType.container.type === "optional") {
      return true;
    }
  }
  return false;
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateTypeDeclarationExample.js
function generateTypeDeclarationExample({ fieldName, typeDeclarations, typeDeclaration, maxDepth, currentDepth, skipOptionalProperties }) {
  switch (typeDeclaration.shape.type) {
    case "alias": {
      const generatedExample = generateTypeReferenceExample({
        fieldName,
        typeDeclarations,
        typeReference: typeDeclaration.shape.aliasOf,
        maxDepth,
        currentDepth,
        skipOptionalProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example, jsonExample } = generatedExample;
      return {
        type: "success",
        example: ExampleTypeShape.alias({
          value: example
        }),
        jsonExample
      };
    }
    case "enum": {
      const enumValue = typeDeclaration.shape.values[0];
      if (enumValue == null) {
        return { type: "failure", message: "No enum values present" };
      }
      return {
        type: "success",
        example: ExampleTypeShape.enum({
          value: enumValue.name
        }),
        jsonExample: enumValue.name.wireValue
      };
    }
    case "object": {
      const objectExample = generateObjectDeclarationExample({
        fieldName,
        typeDeclaration,
        objectTypeDeclaration: typeDeclaration.shape,
        typeDeclarations,
        currentDepth,
        maxDepth,
        skipOptionalProperties
      });
      if (objectExample.type === "failure") {
        return objectExample;
      }
      const { example, jsonExample } = objectExample;
      return {
        type: "success",
        example: ExampleTypeShape.object(example),
        jsonExample
      };
    }
    case "undiscriminatedUnion": {
      let i = 0;
      for (const variant of typeDeclaration.shape.members) {
        const variantExample = generateTypeReferenceExample({
          fieldName,
          typeReference: variant.type,
          typeDeclarations,
          currentDepth: currentDepth + 1,
          maxDepth,
          skipOptionalProperties
        });
        if (variantExample.type === "failure") {
          ++i;
          continue;
        }
        const { example, jsonExample } = variantExample;
        return {
          type: "success",
          example: ExampleTypeShape.undiscriminatedUnion({
            index: i,
            singleUnionType: example
          }),
          jsonExample
        };
      }
      break;
    }
    case "union": {
      const discriminant3 = typeDeclaration.shape.discriminant;
      for (const variant of typeDeclaration.shape.types) {
        const variantExample = variant.shape._visit({
          noProperties: () => {
            return {
              type: "success",
              example: ExampleTypeShape.union({
                discriminant: discriminant3,
                singleUnionType: {
                  wireDiscriminantValue: variant.discriminantValue,
                  shape: ExampleSingleUnionTypeProperties.noProperties()
                }
              }),
              jsonExample: {
                [discriminant3.wireValue]: variant.discriminantValue.wireValue
              }
            };
          },
          samePropertiesAsObject: (samePropertiesAsObject) => {
            const typeDeclaration2 = typeDeclarations[samePropertiesAsObject.typeId];
            if (typeDeclaration2 == null) {
              throw new Error(`Failed to find type declaration with id ${samePropertiesAsObject.typeId}`);
            }
            if (typeDeclaration2.shape.type !== "object") {
              throw new Error(`Same properties as object union is not an object ${typeDeclaration2.shape.type}`);
            }
            const objectExample = generateObjectDeclarationExample({
              currentDepth,
              maxDepth,
              fieldName,
              objectTypeDeclaration: typeDeclaration2.shape,
              typeDeclaration: typeDeclaration2,
              typeDeclarations,
              skipOptionalProperties
            });
            if (objectExample.type === "failure") {
              return objectExample;
            }
            const { example, jsonExample } = objectExample;
            return {
              type: "success",
              example: ExampleTypeShape.union({
                discriminant: discriminant3,
                singleUnionType: {
                  wireDiscriminantValue: variant.discriminantValue,
                  shape: ExampleSingleUnionTypeProperties.samePropertiesAsObject({
                    typeId: typeDeclaration2.name.typeId,
                    object: example
                  })
                }
              }),
              jsonExample: {
                [discriminant3.wireValue]: variant.discriminantValue.wireValue,
                ...typeof jsonExample === "object" ? jsonExample : {}
              }
            };
          },
          singleProperty: (value) => {
            const singlePropertyExample = generateTypeReferenceExample({
              currentDepth: currentDepth + 1,
              maxDepth,
              fieldName,
              typeReference: value.type,
              typeDeclarations,
              skipOptionalProperties
            });
            if (singlePropertyExample.type === "failure") {
              return singlePropertyExample;
            }
            const { example, jsonExample } = singlePropertyExample;
            return {
              type: "success",
              example: ExampleTypeShape.union({
                discriminant: discriminant3,
                singleUnionType: {
                  wireDiscriminantValue: variant.discriminantValue,
                  shape: ExampleSingleUnionTypeProperties.singleProperty(example)
                }
              }),
              jsonExample: {
                [discriminant3.wireValue]: variant.discriminantValue.wireValue,
                [value.name.wireValue]: jsonExample
              }
            };
          },
          _other: () => {
            throw new Error("Encountered unknown union type");
          }
        });
        if (variantExample.type === "failure") {
          continue;
        }
        return variantExample;
      }
    }
  }
  return { type: "failure", message: "Failed to generate example for type reference" };
}
function generateObjectDeclarationExample({ fieldName, typeDeclaration, objectTypeDeclaration, typeDeclarations, maxDepth, currentDepth, skipOptionalProperties }) {
  const jsonExample = {};
  const properties = [];
  for (const property4 of [
    ...objectTypeDeclaration.properties ?? [],
    ...objectTypeDeclaration.extendedProperties ?? []
  ]) {
    const propertyExample = generateTypeReferenceExample({
      fieldName: property4.name.wireValue,
      typeReference: property4.valueType,
      typeDeclarations,
      currentDepth: currentDepth + 1,
      maxDepth,
      skipOptionalProperties
    });
    if (propertyExample.type === "failure" && !isOptional({ typeDeclarations, typeReference: property4.valueType })) {
      return {
        type: "failure",
        message: `Failed to generate required property ${property4.name.wireValue} b/c ${propertyExample.message}`
      };
    } else if (propertyExample.type === "failure") {
      continue;
    }
    const { example, jsonExample: propertyJsonExample } = propertyExample;
    properties.push({
      name: property4.name,
      originalTypeDeclaration: typeDeclaration.name,
      value: example
    });
    jsonExample[property4.name.wireValue] = propertyJsonExample;
  }
  return {
    type: "success",
    example: ExampleTypeShape.object({
      properties
    }),
    jsonExample
  };
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateTypeReferenceExample.js
function generateTypeReferenceExample({ fieldName, typeReference, typeDeclarations, maxDepth, currentDepth, skipOptionalProperties }) {
  if (currentDepth > maxDepth) {
    return { type: "failure", message: "Exceeded max depth" };
  }
  switch (typeReference.type) {
    case "named": {
      const typeDeclaration = typeDeclarations[typeReference.typeId];
      if (typeDeclaration == null) {
        throw new Error(`Failed to find type declaration with id ${typeReference.typeId}`);
      }
      const generatedExample = generateTypeDeclarationExample({
        fieldName,
        typeDeclaration,
        typeDeclarations,
        maxDepth,
        currentDepth,
        skipOptionalProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example, jsonExample } = generatedExample;
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.named({
            shape: example,
            typeName: typeDeclaration.name
          })
        },
        jsonExample
      };
    }
    case "container": {
      const generatedExample = generateContainerExample({
        fieldName,
        containerType: typeReference.container,
        typeDeclarations,
        maxDepth,
        currentDepth,
        skipOptionalProperties
      });
      if (generatedExample.type === "failure") {
        const { example: example2, jsonExample: jsonExample2 } = generateEmptyContainerExample({
          containerType: typeReference.container
        });
        return {
          type: "success",
          example: {
            jsonExample: jsonExample2,
            shape: ExampleTypeReferenceShape.container(example2)
          },
          jsonExample: jsonExample2
        };
      }
      const { example, jsonExample } = generatedExample;
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.container(example)
        },
        jsonExample
      };
    }
    case "primitive": {
      const { jsonExample, example } = generatePrimitiveExample({
        fieldName,
        primitiveType: typeReference.primitive
      });
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.primitive(example)
        },
        jsonExample
      };
    }
    case "unknown": {
      const jsonExample = { key: "value" };
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.unknown(jsonExample)
        },
        jsonExample
      };
    }
  }
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateSuccessEndpointExample.js
var import_object_hash = __toESM(require_object_hash(), 1);
function generateEndpointExample({ ir, endpoint, service, typeDeclarations, skipOptionalRequestProperties, generationResponse }) {
  const result = {
    name: void 0,
    endpointHeaders: [],
    endpointPathParameters: [],
    queryParameters: [],
    servicePathParameters: [],
    serviceHeaders: [],
    rootPathParameters: [],
    request: void 0,
    response: ExampleResponse.ok(ExampleEndpointSuccessResponse.body(void 0)),
    docs: void 0
  };
  const pathParameterGroups = [
    {
      params: endpoint.pathParameters,
      add: (example) => result.endpointPathParameters.push(example)
    },
    {
      params: service.pathParameters,
      add: (example) => result.servicePathParameters.push(example)
    },
    {
      params: ir.pathParameters,
      add: (example) => result.rootPathParameters.push(example)
    }
  ];
  for (const group of pathParameterGroups) {
    for (const pathParameter of group.params) {
      const generatedExample = generateTypeReferenceExample({
        fieldName: pathParameter.name.originalName,
        currentDepth: 0,
        maxDepth: 1,
        typeDeclarations,
        typeReference: pathParameter.valueType,
        skipOptionalProperties: skipOptionalRequestProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example } = generatedExample;
      group.add({
        name: pathParameter.name,
        value: example
      });
    }
  }
  for (const queryParameter of endpoint.queryParameters) {
    if (skipOptionalRequestProperties && isOptional({ typeDeclarations, typeReference: queryParameter.valueType })) {
      continue;
    }
    const generatedExample = generateTypeReferenceExample({
      fieldName: queryParameter.name.name.originalName,
      currentDepth: 0,
      maxDepth: 1,
      typeDeclarations,
      typeReference: queryParameter.valueType,
      skipOptionalProperties: skipOptionalRequestProperties
    });
    if (generatedExample.type === "failure") {
      return generatedExample;
    }
    const { example } = generatedExample;
    result.queryParameters.push({
      name: queryParameter.name,
      shape: queryParameter.allowMultiple ? ExampleQueryParameterShape.exploded() : ExampleQueryParameterShape.single(),
      value: example
    });
  }
  const headerGroup = [
    {
      params: endpoint.headers,
      add: (example) => result.endpointHeaders.push(example)
    },
    {
      params: service.headers,
      add: (example) => result.serviceHeaders.push(example)
    }
  ];
  for (const group of headerGroup) {
    for (const header of group.params) {
      if (skipOptionalRequestProperties && isOptional({ typeDeclarations, typeReference: header.valueType })) {
        continue;
      }
      const generatedExample = generateTypeReferenceExample({
        fieldName: header.name.name.originalName,
        currentDepth: 0,
        maxDepth: 1,
        typeDeclarations,
        typeReference: header.valueType,
        skipOptionalProperties: skipOptionalRequestProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example } = generatedExample;
      group.add({
        name: header.name,
        value: example
      });
    }
  }
  if (endpoint.requestBody != null) {
    switch (endpoint.requestBody.type) {
      case "bytes":
        return { type: "failure", message: "Bytes request unsupported" };
      case "fileUpload":
        return { type: "failure", message: "File upload unsupported" };
      case "inlinedRequestBody": {
        const jsonExample = {};
        const properties = [];
        for (const property4 of [
          ...endpoint.requestBody.properties ?? [],
          ...endpoint.requestBody.extendedProperties ?? []
        ]) {
          const propertyExample = generateTypeReferenceExample({
            fieldName: property4.name.wireValue,
            typeReference: property4.valueType,
            typeDeclarations,
            currentDepth: 1,
            maxDepth: 10,
            skipOptionalProperties: skipOptionalRequestProperties
          });
          if (propertyExample.type === "failure" && !isOptional({ typeDeclarations, typeReference: property4.valueType })) {
            return {
              type: "failure",
              message: `Failed to generate required property ${property4.name.wireValue} b/c ${propertyExample.message}`
            };
          } else if (propertyExample.type === "failure") {
            continue;
          }
          const { example, jsonExample: propertyJsonExample } = propertyExample;
          properties.push({
            name: property4.name,
            originalTypeDeclaration: void 0,
            value: example
          });
          jsonExample[property4.name.wireValue] = propertyJsonExample;
        }
        result.request = ExampleRequestBody.inlinedRequestBody({
          jsonExample,
          properties
        });
        break;
      }
      case "reference": {
        const generatedExample = generateTypeReferenceExample({
          currentDepth: 0,
          maxDepth: 10,
          typeDeclarations,
          typeReference: endpoint.requestBody.requestBodyType,
          skipOptionalProperties: skipOptionalRequestProperties
        });
        if (generatedExample.type === "failure") {
          return generatedExample;
        }
        const { example } = generatedExample;
        result.request = ExampleRequestBody.reference(example);
        break;
      }
      default:
        assertNever(endpoint.requestBody);
    }
  }
  if (generationResponse.type === "success" && endpoint.response?.body != null) {
    switch (endpoint.response.body.type) {
      case "fileDownload":
        return { type: "failure", message: "File download unsupported" };
      case "json": {
        const generatedExample = generateTypeReferenceExample({
          currentDepth: 0,
          maxDepth: 10,
          typeDeclarations,
          typeReference: endpoint.response.body.value.responseBodyType,
          skipOptionalProperties: false
        });
        if (generatedExample.type === "failure") {
          return generatedExample;
        }
        const { example, jsonExample } = generatedExample;
        result.response = ExampleResponse.ok(ExampleEndpointSuccessResponse.body({ ...example, jsonExample }));
        break;
      }
      case "streamParameter":
        return { type: "failure", message: "Stream parameter unsupported" };
      case "streaming":
        return { type: "failure", message: "Streaming unsupported" };
      case "text":
        return { type: "failure", message: "Text unsupported" };
      default:
        assertNever(endpoint.response.body);
    }
  } else if (generationResponse.type === "error") {
    if (generationResponse.declaration.type == null) {
      result.response = ExampleResponse.error({
        body: void 0,
        error: generationResponse.declaration.name
      });
    } else {
      const generatedExample = generateTypeReferenceExample({
        currentDepth: 0,
        maxDepth: 10,
        typeDeclarations,
        typeReference: generationResponse.declaration.type,
        skipOptionalProperties: skipOptionalRequestProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example } = generatedExample;
      result.response = ExampleResponse.error({
        body: example,
        error: generationResponse.declaration.name
      });
    }
  }
  return {
    type: "success",
    example: {
      id: (0, import_object_hash.default)(result),
      url: getUrlForExample(endpoint, result),
      ...result
    },
    jsonExample: void 0
    // dummmy
  };
}
function getUrlForExample(endpoint, example) {
  const pathParameters = {};
  [...example.rootPathParameters, ...example.servicePathParameters, ...example.endpointPathParameters].forEach((examplePathParameter) => {
    const value = examplePathParameter.value.jsonExample;
    const stringValue = typeof value === "string" ? value : JSON.stringify(value);
    pathParameters[examplePathParameter.name.originalName] = stringValue;
  });
  const url = endpoint.fullPath.head + endpoint.fullPath.parts.map((pathPart) => pathParameters[pathPart.pathParameter] + pathPart.tail).join("");
  return url.startsWith("/") || url === "" ? url : `/${url}`;
}

// ../../cli/generation/ir-generator/lib/dynamic-snippets/version.js
var Version = "1.0.0";

// ../../cli/generation/ir-generator/lib/dynamic-snippets/DynamicSnippetsConverter.js
var DynamicSnippetsConverter = class {
  ir;
  auth;
  constructor(ir) {
    this.ir = ir;
    this.auth = this.convertAuth(ir.auth);
  }
  convert() {
    return {
      version: Version,
      types: this.convertNamedTypes(),
      headers: this.convertHeaders(),
      endpoints: this.convertEndpoints()
    };
  }
  convertNamedTypes() {
    return Object.fromEntries(Object.entries(this.ir.types).map(([typeId, typeDeclaration]) => [
      typeId,
      this.convertTypeDeclaration(typeDeclaration)
    ]));
  }
  convertHeaders() {
    return this.convertWireValueParameters({ wireValueParameters: this.ir.headers });
  }
  convertEndpoints() {
    const endpoints = this.getAllHttpEndpoints();
    return Object.fromEntries(endpoints.map((endpoint) => [endpoint.id, this.convertEndpoint(endpoint)]));
  }
  convertEndpoint(endpoint) {
    return {
      auth: this.auth,
      declaration: this.convertDeclaration({ name: endpoint.name, fernFilepath: endpoint.fernFilepath }),
      location: this.convertEndpointLocation({ endpoint }),
      request: this.convertRequest({ endpoint }),
      response: dynamic_exports.Response.json()
    };
  }
  convertRequest({ endpoint }) {
    const pathParameters = this.convertPathParameters({ pathParameters: endpoint.allPathParameters });
    if (endpoint.sdkRequest == null && endpoint.requestBody == null) {
      return dynamic_exports.Request.body({ pathParameters, body: void 0 });
    }
    if (endpoint.sdkRequest == null) {
      throw new Error(`Internal error; endpoint "${endpoint.id}" has a request body but no SDK request`);
    }
    switch (endpoint.sdkRequest.shape.type) {
      case "justRequestBody":
        return dynamic_exports.Request.body({
          pathParameters,
          body: this.convertReferencedRequestBodyType({ body: endpoint.sdkRequest.shape.value })
        });
      case "wrapper":
        return this.convertInlinedRequest({
          fernFilepath: endpoint.fernFilepath,
          wrapper: endpoint.sdkRequest.shape,
          pathParameters,
          queryParameters: this.convertQueryParameters({ queryParameters: endpoint.queryParameters }),
          headers: this.convertWireValueParameters({
            wireValueParameters: [...endpoint.serviceHeaders, ...endpoint.headers]
          }),
          body: endpoint.requestBody
        });
      default:
        assertNever(endpoint.sdkRequest.shape);
    }
  }
  convertReferencedRequestBodyType({ body }) {
    switch (body.type) {
      case "bytes":
        return dynamic_exports.ReferencedRequestBodyType.bytes();
      case "typeReference":
        return dynamic_exports.ReferencedRequestBodyType.typeReference(this.convertTypeReference(body.requestBodyType));
      default:
        assertNever(body);
    }
  }
  convertInlinedRequest({ fernFilepath, wrapper, pathParameters, queryParameters, headers, body }) {
    return dynamic_exports.Request.inlined({
      declaration: this.convertDeclaration({ name: wrapper.wrapperName, fernFilepath }),
      pathParameters,
      queryParameters,
      headers,
      body: body != null ? this.convertInlinedRequestBody({ wrapper, body }) : void 0,
      metadata: this.convertInlinedRequestMetadata({ wrapper })
    });
  }
  convertInlinedRequestMetadata({ wrapper }) {
    return {
      includePathParameters: wrapper.includePathParameters ?? false,
      onlyPathParameters: wrapper.onlyPathParameters ?? false
    };
  }
  convertInlinedRequestBody({ wrapper, body }) {
    switch (body.type) {
      case "inlinedRequestBody": {
        const properties = [...body.extendedProperties ?? [], ...body.properties];
        return dynamic_exports.InlinedRequestBody.properties(this.convertWireValueParameters({ wireValueParameters: properties }));
      }
      case "reference":
        return dynamic_exports.InlinedRequestBody.referenced({
          bodyKey: wrapper.bodyKey,
          bodyType: dynamic_exports.ReferencedRequestBodyType.typeReference(this.convertTypeReference(body.requestBodyType))
        });
      case "bytes":
        return dynamic_exports.InlinedRequestBody.referenced({
          bodyKey: wrapper.bodyKey,
          bodyType: dynamic_exports.ReferencedRequestBodyType.bytes()
        });
      case "fileUpload":
        return this.convertFileUploadRequestBody({ properties: body.properties });
      default:
        assertNever(body);
    }
  }
  convertFileUploadRequestBody({ properties }) {
    return dynamic_exports.InlinedRequestBody.fileUpload({
      properties: this.convertFileUploadRequestBodyProperties({ properties })
    });
  }
  convertFileUploadRequestBodyProperties({ properties }) {
    return properties.map((property4) => {
      switch (property4.type) {
        case "file":
          return this.convertFileUploadRequestBodyFileProperty({ fileProperty: property4.value });
        case "bodyProperty":
          return dynamic_exports.FileUploadRequestBodyProperty.bodyProperty({
            name: property4.name,
            typeReference: this.convertTypeReference(property4.valueType)
          });
        default:
          assertNever(property4);
      }
    });
  }
  convertFileUploadRequestBodyFileProperty({ fileProperty }) {
    switch (fileProperty.type) {
      case "file":
        return dynamic_exports.FileUploadRequestBodyProperty.file(fileProperty.key);
      case "fileArray":
        return dynamic_exports.FileUploadRequestBodyProperty.fileArray(fileProperty.key);
      default:
        assertNever(fileProperty);
    }
  }
  convertPathParameters({ pathParameters }) {
    return pathParameters.map((pathParameter) => ({
      name: {
        name: pathParameter.name,
        wireValue: pathParameter.name.originalName
      },
      typeReference: this.convertTypeReference(pathParameter.valueType)
    }));
  }
  convertWireValueParameters({ wireValueParameters }) {
    return wireValueParameters.map((parameter) => ({
      name: {
        name: parameter.name.name,
        wireValue: parameter.name.wireValue
      },
      typeReference: this.convertTypeReference(parameter.valueType)
    }));
  }
  convertQueryParameters({ queryParameters }) {
    const parameters = [];
    for (const queryParameter of queryParameters) {
      let typeReference = this.convertTypeReference(queryParameter.valueType);
      if (queryParameter.allowMultiple) {
        typeReference = dynamic_exports.TypeReference.list(typeReference);
      }
      parameters.push({
        name: {
          name: queryParameter.name.name,
          wireValue: queryParameter.name.wireValue
        },
        typeReference
      });
    }
    return parameters;
  }
  convertTypeReference(typeReference) {
    switch (typeReference.type) {
      case "container":
        return this.convertContainerType(typeReference.container);
      case "named":
        return this.convertNamedType(typeReference);
      case "primitive":
        return this.convertPrimitiveType(typeReference.primitive);
      case "unknown":
        return this.convertUnknownType();
      default:
        assertNever(typeReference);
    }
  }
  convertContainerType(container) {
    switch (container.type) {
      case "list":
        return dynamic_exports.TypeReference.list(this.convertTypeReference(container.list));
      case "map":
        return dynamic_exports.TypeReference.map({
          key: this.convertTypeReference(container.keyType),
          value: this.convertTypeReference(container.valueType)
        });
      case "optional":
        return dynamic_exports.TypeReference.optional(this.convertTypeReference(container.optional));
      case "set":
        return dynamic_exports.TypeReference.set(this.convertTypeReference(container.set));
      case "literal":
        return dynamic_exports.TypeReference.literal(this.convertLiteral(container.literal));
      default:
        assertNever(container);
    }
  }
  convertNamedType(named) {
    return dynamic_exports.TypeReference.named(named.typeId);
  }
  convertTypeDeclaration(typeDeclaration) {
    const declaration = this.convertDeclaration(typeDeclaration.name);
    switch (typeDeclaration.shape.type) {
      case "alias":
        return this.convertAlias({ declaration, alias: typeDeclaration.shape });
      case "enum":
        return this.convertEnum({ declaration, enum_: typeDeclaration.shape });
      case "object":
        return this.convertObject({ declaration, object: typeDeclaration.shape });
      case "union":
        return this.convertDiscriminatedUnion({ declaration, union: typeDeclaration.shape });
      case "undiscriminatedUnion":
        return this.convertUndiscriminatedUnion({ declaration, union: typeDeclaration.shape });
      default:
        assertNever(typeDeclaration.shape);
    }
  }
  convertAlias({ declaration, alias }) {
    return dynamic_exports.NamedType.alias({
      declaration,
      typeReference: this.convertTypeReference(alias.aliasOf)
    });
  }
  convertEnum({ declaration, enum_: enum_3 }) {
    return dynamic_exports.NamedType.enum({
      declaration,
      values: enum_3.values.map((value) => value.name)
    });
  }
  convertObject({ declaration, object: object3 }) {
    const properties = [...object3.extendedProperties ?? [], ...object3.properties];
    return this.convertObjectProperties({
      declaration,
      properties
    });
  }
  convertObjectProperties({ declaration, properties }) {
    return dynamic_exports.NamedType.object({
      declaration,
      properties: this.convertWireValueParameters({ wireValueParameters: properties })
    });
  }
  convertDiscriminatedUnion({ declaration, union: union3 }) {
    const inheritedProperties = [...this.resolveProperties(union3.extends), ...union3.baseProperties];
    return dynamic_exports.NamedType.discriminatedUnion({
      declaration,
      discriminant: union3.discriminant,
      types: Object.fromEntries(union3.types.map((unionType2) => [
        unionType2.discriminantValue.wireValue,
        this.convertDiscriminatedUnionType({
          inheritedProperties,
          discriminantValue: unionType2.discriminantValue,
          singleUnionTypeProperties: unionType2.shape
        })
      ]))
    });
  }
  convertDiscriminatedUnionType({ inheritedProperties, discriminantValue, singleUnionTypeProperties }) {
    switch (singleUnionTypeProperties.propertiesType) {
      case "samePropertiesAsObject":
        return this.convertDiscriminatedUnionTypeObject({
          inheritedProperties,
          discriminantValue,
          declaredTypeName: singleUnionTypeProperties
        });
      case "singleProperty":
        return this.convertDiscriminatedUnionTypeSingleProperty({
          inheritedProperties,
          discriminantValue,
          singleUnionTypeProperty: singleUnionTypeProperties
        });
      case "noProperties":
        return this.convertDiscriminatedUnionTypeNoProperties({
          inheritedProperties,
          discriminantValue
        });
      default:
        assertNever(singleUnionTypeProperties);
    }
  }
  convertDiscriminatedUnionTypeObject({ inheritedProperties, discriminantValue, declaredTypeName }) {
    return dynamic_exports.SingleDiscriminatedUnionType.samePropertiesAsObject({
      typeId: declaredTypeName.typeId,
      discriminantValue,
      properties: this.convertWireValueParameters({ wireValueParameters: inheritedProperties })
    });
  }
  convertDiscriminatedUnionTypeSingleProperty({ inheritedProperties, discriminantValue, singleUnionTypeProperty }) {
    return dynamic_exports.SingleDiscriminatedUnionType.singleProperty({
      typeReference: this.convertTypeReference(singleUnionTypeProperty.type),
      discriminantValue,
      properties: inheritedProperties.length > 0 ? this.convertWireValueParameters({ wireValueParameters: inheritedProperties }) : void 0
    });
  }
  convertDiscriminatedUnionTypeNoProperties({ inheritedProperties, discriminantValue }) {
    return dynamic_exports.SingleDiscriminatedUnionType.noProperties({
      discriminantValue,
      properties: inheritedProperties.length > 0 ? this.convertWireValueParameters({ wireValueParameters: inheritedProperties }) : void 0
    });
  }
  convertUndiscriminatedUnion({ declaration, union: union3 }) {
    return dynamic_exports.NamedType.undiscriminatedUnion({
      declaration,
      types: union3.members.map((member) => this.convertTypeReference(member.type))
    });
  }
  convertLiteral(literal) {
    switch (literal.type) {
      case "boolean":
        return dynamic_exports.LiteralType.boolean(literal.boolean);
      case "string":
        return dynamic_exports.LiteralType.string(literal.string);
      default:
        assertNever(literal);
    }
  }
  convertPrimitiveType(primitive) {
    return dynamic_exports.TypeReference.primitive(primitive.v1);
  }
  convertUnknownType() {
    return dynamic_exports.TypeReference.unknown();
  }
  convertAuth(auth) {
    if (auth.schemes[0] == null) {
      return void 0;
    }
    const scheme = auth.schemes[0];
    switch (scheme.type) {
      case "basic":
        return dynamic_exports.Auth.basic(scheme);
      case "bearer":
        return dynamic_exports.Auth.bearer(scheme);
      case "header":
        return dynamic_exports.Auth.header({
          header: {
            name: scheme.name,
            typeReference: this.convertTypeReference(scheme.valueType)
          }
        });
      case "oauth":
        return void 0;
      default:
        assertNever(scheme);
    }
  }
  convertDeclaration({ name, fernFilepath }) {
    return {
      name,
      fernFilepath
    };
  }
  convertEndpointLocation({ endpoint }) {
    return {
      method: endpoint.method,
      path: this.getFullPathForEndpoint(endpoint)
    };
  }
  getAllHttpEndpoints() {
    return Object.values(this.ir.services).flatMap((service) => service.endpoints.map((endpoint) => ({
      ...endpoint,
      serviceHeaders: service.headers,
      fernFilepath: service.name.fernFilepath
    })));
  }
  resolveProperties(declaredTypeNames) {
    const properties = [];
    for (const declaredTypeName of declaredTypeNames) {
      const typeDeclaration = this.resolveObjectTypeOrThrow(declaredTypeName.typeId);
      properties.push(...this.resolveProperties(typeDeclaration.extends));
      properties.push(...typeDeclaration.properties);
    }
    return Object.values(properties);
  }
  resolveObjectTypeOrThrow(typeId) {
    const typeDeclaration = this.ir.types[typeId];
    if (typeDeclaration == null) {
      throw new Error(`Internal error; type "${typeId}" not found`);
    }
    if (typeDeclaration.shape.type !== "object") {
      throw new Error(`Internal error; type "${typeId}" is not an object`);
    }
    return typeDeclaration.shape;
  }
  getFullPathForEndpoint(endpoint) {
    let url = "";
    if (endpoint.fullPath.head.length > 0) {
      url = urlJoin(url, endpoint.fullPath.head);
    }
    for (const part of endpoint.fullPath.parts) {
      url = urlJoin(url, "{" + part.pathParameter + "}");
      if (part.tail.length > 0) {
        url = urlJoin(url, part.tail);
      }
    }
    return url.startsWith("/") ? url : `/${url}`;
  }
};

// ../../cli/generation/ir-generator/lib/dynamic-snippets/convertIrToDynamicSnippetsIr.js
async function convertIrToDynamicSnippetsIr(ir) {
  const converter = new DynamicSnippetsConverter(ir);
  return converter.convert();
}

// ../../cli/generation/ir-generator/lib/generateIntermediateRepresentation.js
async function generateIntermediateRepresentation({ workspace, generationLanguage, keywords, smartCasing, disableExamples, audiences, readme, packageName, version, context, fdrApiDefinitionId, includeOptionalRequestPropertyExamples, sourceResolver }) {
  const casingsGenerator = constructCasingsGenerator({ generationLanguage, keywords, smartCasing });
  const irGraph = new IrGraph(audiences);
  const rootApiFileContext = constructRootApiFileContext({
    casingsGenerator,
    rootApiFile: workspace.definition.rootApiFile.contents
  });
  const globalErrors = (workspace.definition.rootApiFile.contents.errors ?? []).map((referenceToError) => {
    const errorName = parseErrorName({
      errorName: referenceToError,
      file: rootApiFileContext
    });
    return { error: errorName, docs: void 0 };
  });
  const typeResolver = new TypeResolverImpl(workspace);
  const endpointResolver = new EndpointResolverImpl(workspace);
  const propertyResolver = new PropertyResolverImpl(typeResolver, endpointResolver);
  const errorResolver = new ErrorResolverImpl(workspace);
  const exampleResolver = new ExampleResolverImpl(typeResolver);
  const variableResolver = new VariableResolverImpl();
  const intermediateRepresentation = {
    fdrApiDefinitionId,
    apiVersion: await convertApiVersionScheme({
      file: rootApiFileContext,
      rawApiFileSchema: workspace.definition.rootApiFile.contents
    }),
    apiName: casingsGenerator.generateName(workspace.definition.rootApiFile.contents.name),
    apiDisplayName: workspace.definition.rootApiFile.contents["display-name"],
    apiDocs: await formatDocs(workspace.definition.rootApiFile.contents.docs),
    auth: await convertApiAuth({
      rawApiFileSchema: workspace.definition.rootApiFile.contents,
      file: rootApiFileContext,
      propertyResolver,
      endpointResolver
    }),
    headers: workspace.definition.rootApiFile.contents.headers != null ? await Promise.all(Object.entries(workspace.definition.rootApiFile.contents.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file: rootApiFileContext }))) : [],
    idempotencyHeaders: workspace.definition.rootApiFile.contents["idempotency-headers"] != null ? await Promise.all(Object.entries(workspace.definition.rootApiFile.contents["idempotency-headers"]).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file: rootApiFileContext }))) : [],
    types: {},
    errors: {},
    services: {},
    constants: generateFernConstants(casingsGenerator),
    environments: convertEnvironments({
      casingsGenerator,
      rawApiFileSchema: workspace.definition.rootApiFile.contents
    }),
    errorDiscriminationStrategy: convertErrorDiscriminationStrategy(workspace.definition.rootApiFile.contents["error-discrimination"], rootApiFileContext),
    basePath: workspace.definition.rootApiFile.contents["base-path"] != null ? constructHttpPath(workspace.definition.rootApiFile.contents["base-path"]) : void 0,
    pathParameters: await convertPathParameters2({
      pathParameters: workspace.definition.rootApiFile.contents["path-parameters"],
      file: rootApiFileContext,
      location: PathParameterLocation.Root,
      variableResolver
    }),
    variables: workspace.definition.rootApiFile.contents.variables != null ? Object.entries(workspace.definition.rootApiFile.contents.variables).map(([key, variable]) => ({
      docs: typeof variable !== "string" ? variable.docs : void 0,
      id: key,
      name: rootApiFileContext.casingsGenerator.generateName(key),
      type: rootApiFileContext.parseTypeReference(variable)
    })) : [],
    serviceTypeReferenceInfo: {
      typesReferencedOnlyByService: {},
      sharedTypes: []
    },
    webhookGroups: {},
    websocketChannels: {},
    readmeConfig: void 0,
    sourceConfig: void 0,
    publishConfig: void 0,
    dynamic: void 0
  };
  const packageTreeGenerator = new PackageTreeGenerator();
  const visitDefinitionFile = async (file) => {
    packageTreeGenerator.addSubpackage(file.fernFilepath);
    await visitObject(file.definitionFile, {
      imports: noop,
      docs: (docs) => {
        if (docs != null) {
          packageTreeGenerator.addDocs(file.fernFilepath, docs);
        }
      },
      types: async (types3) => {
        if (types3 == null) {
          return;
        }
        for (const [typeName, typeDeclaration] of Object.entries(types3)) {
          if (isGeneric(typeName)) {
            continue;
          }
          const convertedTypeDeclarationWithFilepaths = await convertTypeDeclaration({
            typeName,
            typeDeclaration,
            file,
            typeResolver,
            exampleResolver,
            sourceResolver,
            workspace
          });
          const convertedTypeDeclaration = convertedTypeDeclarationWithFilepaths.typeDeclaration;
          if (disableExamples) {
            convertedTypeDeclaration.userProvidedExamples = [];
            convertedTypeDeclaration.autogeneratedExamples = [];
          }
          const subpackageFilepaths = convertedTypeDeclarationWithFilepaths.descendantFilepaths;
          const typeId = IdGenerator.generateTypeId(convertedTypeDeclaration.name);
          intermediateRepresentation.types[typeId] = convertedTypeDeclaration;
          packageTreeGenerator.addType(typeId, convertedTypeDeclaration);
          irGraph.addType({
            declaredTypeName: convertedTypeDeclaration.name,
            descendantTypeIds: convertedTypeDeclaration.referencedTypes,
            descendantTypeIdsByAudience: {},
            propertiesByAudience: convertedTypeDeclarationWithFilepaths.propertiesByAudience,
            descendantFilepaths: subpackageFilepaths
          });
          irGraph.markTypeForAudiences(convertedTypeDeclaration.name, getAudiences(typeDeclaration));
        }
      },
      errors: (errors) => {
        if (errors == null) {
          return;
        }
        const errorDiscriminationSchema = workspace.definition.rootApiFile.contents["error-discrimination"];
        if (errorDiscriminationSchema == null) {
          throw new Error("error-discrimination is missing in api.yml but there are declared errors.");
        }
        for (const [errorName, errorDeclaration] of Object.entries(errors)) {
          const convertedErrorDeclaration = convertErrorDeclaration({
            errorName,
            errorDeclaration,
            file,
            typeResolver,
            exampleResolver,
            workspace
          });
          const errorId = IdGenerator.generateErrorId(convertedErrorDeclaration.name);
          intermediateRepresentation.errors[errorId] = convertedErrorDeclaration;
          packageTreeGenerator.addError(errorId, convertedErrorDeclaration);
          irGraph.addError(convertedErrorDeclaration);
        }
      },
      service: async (service) => {
        if (service == null) {
          return;
        }
        const convertedHttpService = await convertHttpService({
          rootDefaultUrl: file.defaultUrl ?? workspace.definition.rootApiFile.contents["default-url"],
          rootPathParameters: intermediateRepresentation.pathParameters,
          serviceDefinition: service,
          file,
          errorResolver,
          typeResolver,
          propertyResolver,
          exampleResolver,
          sourceResolver,
          globalErrors,
          variableResolver,
          workspace
        });
        const serviceId = IdGenerator.generateServiceId(convertedHttpService.name);
        intermediateRepresentation.services[serviceId] = convertedHttpService;
        packageTreeGenerator.addService(serviceId, convertedHttpService);
        const convertedEndpoints = {};
        convertedHttpService.endpoints.forEach((httpEndpoint) => {
          if (disableExamples) {
            httpEndpoint.autogeneratedExamples = [];
            httpEndpoint.userSpecifiedExamples = [];
          }
          const rawEndpointSchema = service.endpoints[httpEndpoint.name.originalName];
          irGraph.addEndpoint(convertedHttpService, httpEndpoint, rawEndpointSchema);
          convertedEndpoints[httpEndpoint.name.originalName] = httpEndpoint;
        });
        if (service.audiences != null) {
          irGraph.markEndpointForAudience(convertedHttpService.name, convertedHttpService.endpoints, service.audiences);
        }
        Object.entries(service.endpoints).map(([endpointId, endpoint]) => {
          const convertedEndpoint = convertedEndpoints[endpointId];
          if (convertedEndpoint != null && endpoint.audiences != null) {
            irGraph.markEndpointForAudience(convertedHttpService.name, [convertedEndpoint], endpoint.audiences);
          }
        });
      },
      webhooks: async (webhooks) => {
        if (webhooks == null) {
          return;
        }
        const webhookGroupId = IdGenerator.generateWebhookGroupId(file.fernFilepath);
        const convertedWebhookGroup = await convertWebhookGroup({
          webhooks,
          file,
          typeResolver,
          exampleResolver,
          workspace
        });
        const webhooksByOriginalName = {};
        for (const convertedWebhook of convertedWebhookGroup) {
          webhooksByOriginalName[convertedWebhook.name.originalName] = convertedWebhook;
        }
        Object.entries(webhooks).forEach(([key, webhook]) => {
          const irWebhook = webhooksByOriginalName[key];
          if (irWebhook != null) {
            irGraph.addWebhook(file, irWebhook, webhook);
            if (webhook.audiences != null) {
              irGraph.markWebhookForAudiences(file, irWebhook, webhook.audiences);
            }
          }
        });
        intermediateRepresentation.webhookGroups[webhookGroupId] = convertedWebhookGroup;
        packageTreeGenerator.addWebhookGroup(webhookGroupId, file.fernFilepath);
      },
      channel: async (channel) => {
        if (channel == null) {
          return;
        }
        const websocketChannelId = IdGenerator.generateWebSocketChannelId(file.fernFilepath);
        const websocketChannel = await convertChannel({
          channel,
          file,
          variableResolver,
          typeResolver,
          exampleResolver,
          workspace
        });
        if (intermediateRepresentation.websocketChannels != null) {
          intermediateRepresentation.websocketChannels[websocketChannelId] = websocketChannel;
          packageTreeGenerator.addWebSocketChannel(websocketChannelId, file.fernFilepath);
        }
      }
    });
  };
  await visitAllDefinitionFiles(workspace, async (relativeFilepath, file, metadata) => {
    await visitDefinitionFile(constructFernFileContext({
      relativeFilepath,
      definitionFile: file,
      casingsGenerator,
      rootApiFile: workspace.definition.rootApiFile.contents,
      defaultUrl: metadata.defaultUrl
    }));
  });
  await visitAllPackageMarkers(workspace, async (relativeFilepath, packageMarker) => {
    if (packageMarker.navigation == null) {
      return;
    }
    if (typeof packageMarker.navigation === "string") {
      packageTreeGenerator.addPackageRedirection({
        from: convertToFernFilepath({ relativeFilepath, casingsGenerator }),
        to: convertToFernFilepath({
          relativeFilepath: join(dirname(relativeFilepath), RelativeFilePath.of(packageMarker.navigation)),
          casingsGenerator
        })
      });
    } else {
      const childrenInOrder = packageMarker.navigation.map((childFilepath) => {
        return IdGenerator.generateSubpackageId(convertToFernFilepath({
          relativeFilepath: join(dirname(relativeFilepath), RelativeFilePath.of(childFilepath)),
          casingsGenerator
        }));
      });
      if (relativeFilepath === FERN_PACKAGE_MARKER_FILENAME) {
        packageTreeGenerator.sortRootPackage(childrenInOrder);
      } else {
        packageTreeGenerator.sortSubpackage(IdGenerator.generateSubpackageId(convertToFernFilepath({
          relativeFilepath,
          casingsGenerator
        })), childrenInOrder);
      }
    }
  });
  intermediateRepresentation.serviceTypeReferenceInfo = computeServiceTypeReferenceInfo(irGraph);
  const intermediateRepresentationWithGeneratedExamples = disableExamples ? intermediateRepresentation : injectAutogeneratedExamples(intermediateRepresentation, context, !includeOptionalRequestPropertyExamples);
  const workspaceDefinitionRootApiFileContents = workspace.definition.rootApiFile.contents;
  const environments = convertEnvironments({
    casingsGenerator,
    rawApiFileSchema: workspaceDefinitionRootApiFileContents
  });
  const ignoreAudiences = environments?.environments._visit({
    singleBaseUrl: (value) => {
      return value.environments.filter((environment) => {
        return getAudienceForEnvironment(environment.id, workspaceDefinitionRootApiFileContents.environments) != null;
      }).length === 0;
    },
    multipleBaseUrls: (value) => {
      return value.environments.filter((environment) => {
        return getAudienceForEnvironment(environment.id, workspaceDefinitionRootApiFileContents.environments) != null;
      }).length === 0;
    },
    _other: () => false
  });
  environments?.environments.environments.forEach((environment) => {
    irGraph.markEnvironmentForAudiences(environment, getAudienceForEnvironment(environment.id, workspaceDefinitionRootApiFileContents.environments) ?? [], ignoreAudiences);
  });
  const filteredIr = !irGraph.hasNoAudiences() ? irGraph.build() : void 0;
  const intermediateRepresentationForAudiences = filterIntermediateRepresentationForAudiences(intermediateRepresentationWithGeneratedExamples, filteredIr);
  const isAuthMandatory = workspace.definition.rootApiFile.contents.auth != null && Object.values(intermediateRepresentationForAudiences.services).every((service) => {
    return service.endpoints.every((endpoint) => endpoint.auth);
  });
  const hasStreamingEndpoints = Object.values(intermediateRepresentationForAudiences.services).some((service) => {
    return service.endpoints.some((endpoint) => endpoint.response?.body?.type === "streaming");
  });
  const hasPaginatedEndpoints = Object.values(intermediateRepresentationForAudiences.services).some((service) => {
    return service.endpoints.some((endpoint) => endpoint.pagination != null);
  });
  const hasFileDownloadEndpoints = Object.values(intermediateRepresentationForAudiences.services).some((service) => {
    return service.endpoints.some((endpoint) => endpoint.response?.body?.type === "fileDownload");
  });
  const sdkConfig = {
    isAuthMandatory,
    hasStreamingEndpoints,
    hasPaginatedEndpoints,
    hasFileDownloadEndpoints,
    platformHeaders: {
      language: "X-Fern-Language",
      sdkName: "X-Fern-SDK-Name",
      sdkVersion: "X-Fern-SDK-Version",
      userAgent: version != null && packageName != null ? {
        header: "User-Agent",
        value: `${packageName}/${version}`
      } : void 0
    }
  };
  const readmeConfig = readme != null ? convertReadmeConfig({ readme, services: intermediateRepresentation.services }) : void 0;
  const { types: types2, services } = addExtendedPropertiesToIr(intermediateRepresentationForAudiences);
  const finalIR = {
    ...intermediateRepresentationForAudiences,
    ...packageTreeGenerator.build(filteredIr),
    types: types2,
    services,
    sdkConfig,
    readmeConfig
  };
  return {
    ...finalIR,
    dynamic: await convertIrToDynamicSnippetsIr(finalIR)
  };
}
function injectAutogeneratedExamples(ir, context, skipOptionalRequestProperties) {
  for (const [_, service] of Object.entries(ir.services)) {
    for (const endpoint of service.endpoints) {
      context.logger.debug(`Generating example for ${endpoint.id}`);
      const generatedExample = generateEndpointExample({
        ir,
        service,
        endpoint,
        typeDeclarations: ir.types,
        skipOptionalRequestProperties: skipOptionalRequestProperties ?? true,
        generationResponse: { type: "success" }
      });
      if (generatedExample.type === "failure") {
        context.logger.debug(`Failed to generate example for ${endpoint.id}. ${generatedExample.message}`);
        continue;
      }
      const { example } = generatedExample;
      endpoint.autogeneratedExamples = [{ example }];
    }
  }
  return ir;
}
function computeServiceTypeReferenceInfo(irGraph) {
  const typesReferencedOnlyByService = {};
  const sharedTypes = [];
  const typesReferencedByService = irGraph.getTypesReferencedByService();
  for (const [typeId, serviceIds] of Object.entries(typesReferencedByService)) {
    if (serviceIds.size === 1) {
      const serviceId = serviceIds.values().next().value;
      if (typesReferencedOnlyByService[serviceId] === void 0) {
        typesReferencedOnlyByService[serviceId] = [];
      }
      typesReferencedOnlyByService[serviceId]?.push(typeId);
      continue;
    }
    sharedTypes.push(typeId);
  }
  return {
    typesReferencedOnlyByService,
    sharedTypes
  };
}
function filterIntermediateRepresentationForAudiences(intermediateRepresentation, filteredIr) {
  if (filteredIr == null) {
    return intermediateRepresentation;
  }
  const filteredTypes = pickBy_default(intermediateRepresentation.types, (type2) => filteredIr.hasType(type2));
  const filteredTypesAndProperties = Object.fromEntries(Object.entries(filteredTypes).map(([typeId, typeDeclaration]) => {
    const filteredProperties = [];
    typeDeclaration.userProvidedExamples = typeDeclaration.userProvidedExamples.map((example) => filterExampleType({ filteredIr, exampleType: example })).filter((ex) => ex !== void 0);
    if (typeDeclaration.shape.type === "object") {
      for (const property4 of typeDeclaration.shape.properties) {
        const hasProperty = filteredIr.hasProperty(typeId, property4.name.wireValue);
        if (hasProperty) {
          filteredProperties.push(property4);
        }
      }
      return [
        typeId,
        {
          ...typeDeclaration,
          shape: Type.object({
            ...typeDeclaration.shape,
            properties: filteredProperties
          })
        }
      ];
    }
    return [typeId, typeDeclaration];
  }));
  const filteredWebhookGroups = Object.fromEntries(Object.entries(intermediateRepresentation.webhookGroups).map(([webhookGroupId, webhookGroup]) => {
    const filteredWebhooks = webhookGroup.filter((webhook) => filteredIr.hasWebhook(webhook)).map((webhook) => {
      const webhookId = webhook.id;
      if (webhook.payload.type === "inlinedPayload" && webhookId != null) {
        webhook.payload = {
          ...webhook.payload,
          properties: webhook.payload.properties.filter((property4) => {
            return filteredIr.hasWebhookPayloadProperty(webhookId, property4.name.wireValue);
          })
        };
      }
      return webhook;
    });
    return [webhookGroupId, filteredWebhooks];
  }));
  const filteredEnvironmentsConfig = intermediateRepresentation.environments;
  if (filteredEnvironmentsConfig) {
    switch (filteredEnvironmentsConfig.environments.type) {
      case "singleBaseUrl": {
        filteredEnvironmentsConfig.environments.environments = filteredEnvironmentsConfig.environments.environments.filter((environment) => filteredIr.hasEnvironmentId(environment.id));
        break;
      }
      case "multipleBaseUrls": {
        filteredEnvironmentsConfig.environments.environments = filteredEnvironmentsConfig.environments.environments.filter((environment) => filteredIr.hasEnvironmentId(environment.id));
        break;
      }
    }
    if (filteredEnvironmentsConfig.defaultEnvironment) {
      if (!filteredIr.hasEnvironmentId(filteredEnvironmentsConfig.defaultEnvironment)) {
        filteredEnvironmentsConfig.defaultEnvironment = void 0;
      }
    }
  }
  return {
    ...intermediateRepresentation,
    environments: filteredEnvironmentsConfig,
    types: filteredTypesAndProperties,
    errors: pickBy_default(intermediateRepresentation.errors, (error) => filteredIr.hasError(error)),
    services: mapValues_default(pickBy_default(intermediateRepresentation.services, (httpService) => filteredIr.hasService(httpService)), (httpService) => ({
      ...httpService,
      endpoints: httpService.endpoints.filter((httpEndpoint) => filteredIr.hasEndpoint(httpEndpoint)).map((httpEndpoint) => {
        httpEndpoint.autogeneratedExamples = httpEndpoint.autogeneratedExamples.map((autogenerated) => {
          return {
            ...autogenerated,
            example: filterEndpointExample({ filteredIr, example: autogenerated.example })
          };
        });
        httpEndpoint.userSpecifiedExamples = httpEndpoint.userSpecifiedExamples.map((userSpecified) => {
          return {
            ...userSpecified,
            example: userSpecified.example != null ? filterEndpointExample({ filteredIr, example: userSpecified.example }) : void 0
          };
        });
        if (httpEndpoint.queryParameters.length > 0) {
          httpEndpoint.queryParameters = httpEndpoint.queryParameters.filter((queryParameter) => {
            return filteredIr.hasQueryParameter(httpEndpoint.id, queryParameter.name.wireValue);
          });
        }
        if (httpEndpoint.requestBody?.type === "inlinedRequestBody") {
          return {
            ...httpEndpoint,
            requestBody: {
              ...httpEndpoint.requestBody,
              properties: httpEndpoint.requestBody.properties.filter((property4) => {
                return filteredIr.hasRequestProperty(httpEndpoint.id, property4.name.wireValue);
              })
            }
          };
        }
        return httpEndpoint;
      })
    })),
    webhookGroups: filteredWebhookGroups,
    serviceTypeReferenceInfo: filterServiceTypeReferenceInfoForAudiences(intermediateRepresentation.serviceTypeReferenceInfo, filteredIr)
  };
}
function filterServiceTypeReferenceInfoForAudiences(serviceTypeReferenceInfo, filteredIr) {
  if (filteredIr == null) {
    return serviceTypeReferenceInfo;
  }
  const filteredTypesReferencedOnlyByService = {};
  Object.entries(serviceTypeReferenceInfo.typesReferencedOnlyByService).forEach(([key, values]) => {
    if (filteredIr.hasServiceId(key)) {
      filteredTypesReferencedOnlyByService[key] = values.filter((value) => filteredIr.hasTypeId(value));
    }
  });
  return {
    sharedTypes: serviceTypeReferenceInfo.sharedTypes.filter((typeId) => filteredIr.hasTypeId(typeId)),
    typesReferencedOnlyByService: filteredTypesReferencedOnlyByService
  };
}

// ../../cli/generation/source-resolver/lib/NopSourceResolver.js
var NopSourceResolver = class {
  async resolveSource({ source }) {
    return void 0;
  }
  async resolveSourceOrThrow({ source }) {
    return void 0;
  }
};

// src/utils/NopLogger.ts
var NopLogger = class {
  disable() {
  }
  enable() {
  }
  debug(...args) {
  }
  info(...args) {
  }
  warn(...args) {
  }
  error(...args) {
  }
  log(level, ...args) {
  }
};

// src/utils/createTaskContext.ts
function createTaskContext() {
  const context = {
    logger: new NopLogger(),
    takeOverTerminal: async (run) => {
    },
    failAndThrow: (_message, _error) => {
      throw new Error("unimplemented");
    },
    failWithoutThrowing: (_message, _error) => {
    },
    getResult: () => 0 /* Success */,
    addInteractiveTask: () => {
      throw new Error("unimplemented");
    },
    runInteractiveTask: async (_params, _run) => {
      return false;
    },
    instrumentPostHogEvent: async (_event) => {
    }
  };
  return context;
}

// ../../cli/workspace/browser-compatible-fern-workspace/lib/InMemoryOpenAPILoader.js
var import_openapi_core2 = require("@redocly/openapi-core");
var InMemoryOpenAPILoader = class {
  async loadDocument(spec) {
    return {
      type: "openapi",
      value: await this.loadParsedOpenAPI({
        openapi: spec.parsed,
        overrides: spec.overrides
      }),
      settings: spec.settings
    };
  }
  async loadParsedOpenAPI({ openapi, overrides }) {
    const parsed = await this.parseOpenAPI({
      parsed: openapi
    });
    if (overrides != null) {
      const merged = await mergeWithOverrides({ data: parsed, overrides });
      return await this.parseOpenAPI({
        parsed: merged
      });
    }
    return parsed;
  }
  async parseOpenAPI({ parsed }) {
    const result = await (0, import_openapi_core2.bundle)({
      ...DEFAULT_OPENAPI_BUNDLE_OPTIONS,
      doc: {
        source: new import_openapi_core2.Source("<memory>", "<openapi>"),
        parsed
      }
    });
    return result.bundle.parsed;
  }
};

// ../../cli/workspace/browser-compatible-fern-workspace/lib/OpenAPIWorkspace.js
var IN_MEMORY_ABSOLUTE_FILEPATH = AbsoluteFilePath.of("/<memory>");
var DEFAULT_WORKSPACE_ARGS = {
  absoluteFilePath: IN_MEMORY_ABSOLUTE_FILEPATH,
  cliVersion: "<unknown>",
  workspaceName: "anonymous"
};
var OpenAPIWorkspace = class extends BaseOpenAPIWorkspace {
  spec;
  loader;
  constructor({ spec, generatorsConfiguration }) {
    super({
      ...DEFAULT_WORKSPACE_ARGS,
      generatorsConfiguration,
      respectReadonlySchemas: spec.settings?.respectReadonlySchemas ?? false,
      onlyIncludeReferencedSchemas: spec.settings?.onlyIncludeReferencedSchemas ?? false,
      inlinePathParameters: spec.settings?.inlinePathParameters ?? false,
      objectQueryParameters: spec.settings?.objectQueryParameters ?? false
    });
    this.spec = spec;
    this.loader = new InMemoryOpenAPILoader();
  }
  async getOpenAPIIr({ context }, settings) {
    const optionOverrides = getOptionsOverridesFromSettings(settings);
    const document = await this.loader.loadDocument(this.spec);
    return await parse({
      context,
      documents: [document],
      options: {
        ...optionOverrides,
        respectReadonlySchemas: this.respectReadonlySchemas,
        onlyIncludeReferencedSchemas: this.onlyIncludeReferencedSchemas
      }
    });
  }
  getAbsoluteFilePaths() {
    return [];
  }
};

// src/utils/convertAPIToWorkspace.ts
async function convertAPIToWorkspace({
  context,
  api,
  generatorsConfiguration,
  settings
}) {
  switch (api.type) {
    case "openapi": {
      const openapi = new OpenAPIWorkspace({
        spec: {
          parsed: api.openapi,
          overrides: api.overrides
        },
        generatorsConfiguration
      });
      return await openapi.toFernWorkspace({ context }, settings);
    }
  }
}

// src/generateDynamicIR.ts
async function generateDynamicIR({
  api,
  language,
  generatorsConfiguration,
  settings,
  audiences,
  keywords,
  smartCasing
}) {
  const context = createTaskContext();
  const workspace = await convertAPIToWorkspace({ context, api, generatorsConfiguration, settings });
  const ir = await generateIntermediateRepresentation({
    context,
    workspace,
    generationLanguage: language,
    audiences: audiences ?? { type: "all" },
    keywords,
    sourceResolver: new NopSourceResolver(),
    smartCasing: smartCasing ?? false,
    disableExamples: true,
    version: void 0,
    packageName: void 0,
    readme: void 0
  });
  if (ir.dynamic == null) {
    throw new Error("Internal error; failed to generate dynamic intermediate representation");
  }
  return ir.dynamic;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  generateDynamicIR
});
/*! Bundled license information:

lodash-es/lodash.js:
  (**
   * @license
   * Lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="es" -o ./`
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)

js-yaml/dist/js-yaml.mjs:
  (*! js-yaml 4.1.0 https://github.com/nodeca/js-yaml @license MIT *)
*/
